/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/collections","vs/base/common/decorators","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function($e){for(var e=[],C=0,F=$e.length;C<F;C++)e[C]=Se[$e[C]];return e};define(Se[156],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class C{static get(){const f=new Map,L=new Map,R=new Map,$=new Map;function E(k,D){k.has(D.detail)||k.set(D.detail,-D.timestamp)}function p(k,D){const v=k.get(D.detail);v&&(v>=0||k.set(D.detail,v+D.timestamp))}let A=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(A=$e.getStats().slice(0).sort((k,D)=>k.timestamp-D.timestamp));for(const k of A)switch(k.type){case 10:E(f,k);break;case 11:case 12:p(f,k);break;case 21:E(L,k);break;case 22:p(L,k);break;case 33:E(R,k);break;case 34:p(R,k);break;case 31:E($,k);break;case 32:p($,k);break}let I=0;R.forEach(k=>I+=k);function w(k){const D=[];return k.forEach((v,o)=>D.push([o,v])),D}return{amdLoad:w(f),amdInvoke:w(L),nodeRequire:w(R),nodeEval:w($),nodeRequireTotal:I}}static toMarkdownTable(f,L){let R="";const $=[];return f.forEach((E,p)=>{$[p]=E.length}),L.forEach(E=>{E.forEach((p,A)=>{typeof p>"u"&&(p=E[A]="-");const I=p.toString().length;$[A]=Math.max(I,$[A])})}),f.forEach((E,p)=>{R+=`| ${E+" ".repeat($[p]-E.toString().length)} `}),R+=`|
`,f.forEach((E,p)=>{R+=`| ${"-".repeat($[p])} `}),R+=`|
`,L.forEach(E=>{E.forEach((p,A)=>{typeof p<"u"&&(R+=`| ${p+" ".repeat($[A]-p.toString().length)} `)}),R+=`|
`}),R}}e.$S=C}),define(Se[118],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function C(v,o,s){const n=F(v,o);if(n!==-1)return v[n]}e.$db=C;function F(v,o,s=v.length-1){for(let n=s;n>=0;n--){const l=v[n];if(o(l))return n}return-1}e.$eb=F;function f(v,o){const s=L(v,o);return s===-1?void 0:v[s]}e.$fb=f;function L(v,o,s=0,n=v.length){let l=s,b=n;for(;l<b;){const h=Math.floor((l+b)/2);o(v[h])?l=h+1:b=h}return l-1}e.$gb=L;function R(v,o){const s=$(v,o);return s===v.length?void 0:v[s]}e.$hb=R;function $(v,o,s=0,n=v.length){let l=s,b=n;for(;l<b;){const h=Math.floor((l+b)/2);o(v[h])?b=h:l=h+1}return l}e.$ib=$;function E(v,o,s=0,n=v.length){const l=$(v,o,s,n);return l===v.length?-1:l}e.$jb=E;class p{static{this.assertInvariants=!1}constructor(o){this.e=o,this.c=0}findLastMonotonous(o){if(p.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!o(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=o}const s=L(this.e,o,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$kb=p;function A(v,o){if(v.length===0)return;let s=v[0];for(let n=1;n<v.length;n++){const l=v[n];o(l,s)>0&&(s=l)}return s}e.$lb=A;function I(v,o){if(v.length===0)return;let s=v[0];for(let n=1;n<v.length;n++){const l=v[n];o(l,s)>=0&&(s=l)}return s}e.$mb=I;function w(v,o){return A(v,(s,n)=>-o(s,n))}e.$nb=w;function k(v,o){if(v.length===0)return-1;let s=0;for(let n=1;n<v.length;n++){const l=v[n];o(l,v[s])>0&&(s=n)}return s}e.$ob=k;function D(v,o){for(const s of v){const n=o(s);if(n!==void 0)return n}}e.$pb=D}),define(Se[56],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function C(R,$){const E=Object.create(null);for(const p of R){const A=$(p);let I=E[A];I||(I=E[A]=[]),I.push(p)}return E}e.$I=C;function F(R,$){const E=[],p=[];for(const A of R)$.has(A)||E.push(A);for(const A of $)R.has(A)||p.push(A);return{removed:E,added:p}}e.$J=F;function f(R,$){const E=[],p=[];for(const[A,I]of R)$.has(A)||E.push(I);for(const[A,I]of $)R.has(A)||p.push(I);return{removed:E,added:p}}e.$K=f;class L{constructor(){this.a=new Map}add($,E){let p=this.a.get($);p||(p=new Set,this.a.set($,p)),p.add(E)}delete($,E){const p=this.a.get($);p&&(p.delete(E),p.size===0&&this.a.delete($))}forEach($,E){const p=this.a.get($);p&&p.forEach(E)}get($){const E=this.a.get($);return E||new Set}}e.$L=L}),define(Se[57],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=e.$7g=e.$6g=void 0;function C(R){return($,E,p)=>{let A=null,I=null;if(typeof p.value=="function"?(A="value",I=p.value):typeof p.get=="function"&&(A="get",I=p.get),!I)throw new Error("not supported");p[A]=R(I,E)}}function F(R,$,E){let p=null,A=null;if(typeof E.value=="function"?(p="value",A=E.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(p="get",A=E.get),!A)throw new Error("not supported");const I=`$memoize$${$}`;E[p]=function(...w){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,w)}),this[I]}}e.$6g=F;function f(R,$,E){return C((p,A)=>{const I=`$debounce$${A}`,w=`$debounce$result$${A}`;return function(...k){this[w]||(this[w]=E?E():void 0),clearTimeout(this[I]),$&&(this[w]=$(this[w],...k),k=[this[w]]),this[I]=setTimeout(()=>{p.apply(this,k),this[w]=E?E():void 0},R)}})}e.$7g=f;function L(R,$,E){return C((p,A)=>{const I=`$throttle$timer$${A}`,w=`$throttle$result$${A}`,k=`$throttle$lastRun$${A}`,D=`$throttle$pending$${A}`;return function(...v){if(this[w]||(this[w]=E?E():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),$&&(this[w]=$(this[w],...v)),this[D])return;const o=this[k]+R;o<=Date.now()?(this[k]=Date.now(),p.apply(this,[this[w]]),this[w]=E?E():void 0):(this[D]=!0,this[I]=setTimeout(()=>{this[D]=!1,this[k]=Date.now(),p.apply(this,[this[w]]),this[w]=E?E():void 0},o-Date.now()))}})}e.$8g=L}),define(Se[8],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?l.isErrorNoTelemetry(t)?new l(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=C,e.$V=new C;function F(h){e.$V.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=F;function f(h){if(!h||typeof h!="object")return!1;const t=h;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=f;function L(h){p(h)||e.$V.onUnexpectedError(h)}e.$Y=L;function R(h){p(h)||e.$V.onUnexpectedExternalError(h)}e.$Z=R;function $(h){if(h instanceof Error){const{name:t,message:r}=h,a=h.stacktrace||h.stack;return{$isError:!0,name:t,message:r,stack:a,noTelemetry:l.isErrorNoTelemetry(h)}}return h}e.$1=$;const E="Canceled";function p(h){return h instanceof A?!0:h instanceof Error&&h.name===E&&h.message===E}e.$2=p;class A extends Error{constructor(){super(E),this.name=this.message}}e.$3=A;function I(){const h=new Error(E);return h.name=h.message,h}e.$4=I;function w(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$5=w;function k(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$6=k;class D extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=D;function v(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$8=v;class o extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=o;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=s;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=n;class l extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof l)return t;const r=new l;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=l;class b extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}e.$ab=b}),define(Se[19],De([1,0,8,118]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function f(te,se=0){return te[te.length-(1+se)]}e.$qb=f;function L(te){if(te.length===0)throw new Error("Invalid tail call");return[te.slice(0,te.length-1),te[te.length-1]]}e.$rb=L;function R(te,se,ne=(Ee,oe)=>Ee===oe){if(te===se)return!0;if(!te||!se||te.length!==se.length)return!1;for(let Ee=0,oe=te.length;Ee<oe;Ee++)if(!ne(te[Ee],se[Ee]))return!1;return!0}e.$sb=R;function $(te,se){const ne=te.length-1;se<ne&&(te[se]=te[ne]),te.pop()}e.$tb=$;function E(te,se,ne){return p(te.length,Ee=>ne(te[Ee],se))}e.$ub=E;function p(te,se){let ne=0,Ee=te-1;for(;ne<=Ee;){const oe=(ne+Ee)/2|0,he=se(oe);if(he<0)ne=oe+1;else if(he>0)Ee=oe-1;else return oe}return-(ne+1)}e.$vb=p;function A(te,se,ne){if(te=te|0,te>=se.length)throw new TypeError("invalid index");const Ee=se[Math.floor(se.length*Math.random())],oe=[],he=[],ee=[];for(const le of se){const be=ne(le,Ee);be<0?oe.push(le):be>0?he.push(le):ee.push(le)}return te<oe.length?A(te,oe,ne):te<oe.length+ee.length?ee[0]:A(te-(oe.length+ee.length),he,ne)}e.$wb=A;function I(te,se){const ne=[];let Ee;for(const oe of te.slice(0).sort(se))!Ee||se(Ee[0],oe)!==0?(Ee=[oe],ne.push(Ee)):Ee.push(oe);return ne}e.$xb=I;function*w(te,se){let ne,Ee;for(const oe of te)Ee!==void 0&&se(Ee,oe)?ne.push(oe):(ne&&(yield ne),ne=[oe]),Ee=oe;ne&&(yield ne)}e.$yb=w;function k(te,se){for(let ne=0;ne<=te.length;ne++)se(ne===0?void 0:te[ne-1],ne===te.length?void 0:te[ne])}e.$zb=k;function D(te,se){for(let ne=0;ne<te.length;ne++)se(ne===0?void 0:te[ne-1],te[ne],ne+1===te.length?void 0:te[ne+1])}e.$Ab=D;function v(te,se,ne){const Ee=[];function oe(le,be,Ie){if(be===0&&Ie.length===0)return;const B=Ee[Ee.length-1];B&&B.start+B.deleteCount===le?(B.deleteCount+=be,B.toInsert.push(...Ie)):Ee.push({start:le,deleteCount:be,toInsert:Ie})}let he=0,ee=0;for(;;){if(he===te.length){oe(he,0,se.slice(ee));break}if(ee===se.length){oe(he,te.length-he,[]);break}const le=te[he],be=se[ee],Ie=ne(le,be);Ie===0?(he+=1,ee+=1):Ie<0?(oe(he,1,[]),he+=1):Ie>0&&(oe(he,0,[be]),ee+=1)}return Ee}e.$Bb=v;function o(te,se,ne){const Ee=v(te,se,ne),oe=[],he=[];for(const ee of Ee)oe.push(...te.slice(ee.start,ee.start+ee.deleteCount)),he.push(...ee.toInsert);return{removed:oe,added:he}}e.$Cb=o;function s(te,se,ne){if(ne===0)return[];const Ee=te.slice(0,ne).sort(se);return l(te,se,Ee,ne,te.length),Ee}e.top=s;function n(te,se,ne,Ee,oe){return ne===0?Promise.resolve([]):new Promise((he,ee)=>{(async()=>{const le=te.length,be=te.slice(0,ne).sort(se);for(let Ie=ne,B=Math.min(ne+Ee,le);Ie<le;Ie=B,B=Math.min(B+Ee,le)){if(Ie>ne&&await new Promise(Y=>setTimeout(Y)),oe&&oe.isCancellationRequested)throw new C.$3;l(te,se,be,Ie,B)}return be})().then(he,ee)})}e.$Eb=n;function l(te,se,ne,Ee,oe){for(const he=ne.length;Ee<oe;Ee++){const ee=te[Ee];if(se(ee,ne[he-1])<0){ne.pop();const le=(0,F.$ib)(ne,be=>se(ee,be)<0);ne.splice(le,0,ee)}}}function b(te){return te.filter(se=>!!se)}e.$Fb=b;function h(te){let se=0;for(let ne=0;ne<te.length;ne++)te[ne]&&(te[se]=te[ne],se+=1);te.length=se}e.$Gb=h;function t(te,se,ne){te.splice(ne,0,te.splice(se,1)[0])}e.$Hb=t;function r(te){return!Array.isArray(te)||te.length===0}e.$Ib=r;function a(te){return Array.isArray(te)&&te.length>0}e.$Jb=a;function i(te,se=ne=>ne){const ne=new Set;return te.filter(Ee=>{const oe=se(Ee);return ne.has(oe)?!1:(ne.add(oe),!0)})}e.$Kb=i;function c(te){const se=new Set;return ne=>{const Ee=te(ne);return se.has(Ee)?!1:(se.add(Ee),!0)}}e.$Lb=c;function d(te,se){return te.length>0?te[0]:se}e.$Mb=d;function y(te,se){return te.length>0?te[te.length-1]:se}e.$Nb=y;function S(te,se,ne=(Ee,oe)=>Ee===oe){let Ee=0;for(let oe=0,he=Math.min(te.length,se.length);oe<he&&ne(te[oe],se[oe]);oe++)Ee++;return Ee}e.$Ob=S;function g(te){return[].concat(...te)}e.$Pb=g;function u(te,se){let ne=typeof se=="number"?te:0;typeof se=="number"?ne=te:(ne=0,se=te);const Ee=[];if(ne<=se)for(let oe=ne;oe<se;oe++)Ee.push(oe);else for(let oe=ne;oe>se;oe--)Ee.push(oe);return Ee}e.$Qb=u;function m(te,se,ne){return te.reduce((Ee,oe)=>(Ee[se(oe)]=ne?ne(oe):oe,Ee),Object.create(null))}e.$Rb=m;function P(te,se){return te.push(se),()=>O(te,se)}e.$Sb=P;function O(te,se){const ne=te.indexOf(se);if(ne>-1)return te.splice(ne,1),se}e.$Tb=O;function N(te,se,ne){const Ee=te.slice(0,se),oe=te.slice(se);return Ee.concat(ne,oe)}e.$Ub=N;function M(te,se){let ne;if(typeof se=="number"){let Ee=se;ne=()=>{const oe=Math.sin(Ee++)*179426549;return oe-Math.floor(oe)}}else ne=Math.random;for(let Ee=te.length-1;Ee>0;Ee-=1){const oe=Math.floor(ne()*(Ee+1)),he=te[Ee];te[Ee]=te[oe],te[oe]=he}}e.$Vb=M;function j(te,se){const ne=te.indexOf(se);ne>-1&&(te.splice(ne,1),te.unshift(se))}e.$Wb=j;function z(te,se){const ne=te.indexOf(se);ne>-1&&(te.splice(ne,1),te.push(se))}e.$Xb=z;function T(te,se){for(const ne of se)te.push(ne)}e.$Yb=T;function H(te,se){return Array.isArray(te)?te.map(se):se(te)}e.$Zb=H;function q(te){return Array.isArray(te)?te:[te]}e.$1b=q;function me(te){return te[Math.floor(Math.random()*te.length)]}e.$2b=me;function Z(te,se,ne){const Ee=V(te,se),oe=te.length,he=ne.length;te.length=oe+he;for(let ee=oe-1;ee>=Ee;ee--)te[ee+he]=te[ee];for(let ee=0;ee<he;ee++)te[ee+Ee]=ne[ee]}e.$3b=Z;function X(te,se,ne,Ee){const oe=V(te,se);let he=te.splice(oe,ne);return he===void 0&&(he=[]),Z(te,oe,Ee),he}e.$4b=X;function V(te,se){return se<0?Math.max(se+te.length,0):Math.min(se,te.length)}var x;(function(te){function se(he){return he<0}te.isLessThan=se;function ne(he){return he<=0}te.isLessThanOrEqual=ne;function Ee(he){return he>0}te.isGreaterThan=Ee;function oe(he){return he===0}te.isNeitherLessOrGreaterThan=oe,te.greaterThan=1,te.lessThan=-1,te.neitherLessOrGreaterThan=0})(x||(e.CompareResult=x={}));function ge(te,se){return(ne,Ee)=>se(te(ne),te(Ee))}e.$5b=ge;function ue(...te){return(se,ne)=>{for(const Ee of te){const oe=Ee(se,ne);if(!x.isNeitherLessOrGreaterThan(oe))return oe}return x.neitherLessOrGreaterThan}}e.$6b=ue;const ve=(te,se)=>te-se;e.$7b=ve;const G=(te,se)=>(0,e.$7b)(te?1:0,se?1:0);e.$8b=G;function U(te){return(se,ne)=>-te(se,ne)}e.$9b=U;class K{constructor(se){this.g=se,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(se){let ne=this.c;for(;ne<this.g.length&&se(this.g[ne]);)ne++;const Ee=ne===this.c?null:this.g.slice(this.c,ne);return this.c=ne,Ee}takeFromEndWhile(se){let ne=this.d;for(;ne>=0&&se(this.g[ne]);)ne--;const Ee=ne===this.d?null:this.g.slice(ne+1,this.d+1);return this.d=ne,Ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const se=this.g[this.c];return this.c++,se}removeLast(){const se=this.g[this.d];return this.d--,se}takeCount(se){const ne=this.g.slice(this.c,this.c+se);return this.c+=se,ne}}e.$0b=K;class fe{static{this.empty=new fe(se=>{})}constructor(se){this.iterate=se}forEach(se){this.iterate(ne=>(se(ne),!0))}toArray(){const se=[];return this.iterate(ne=>(se.push(ne),!0)),se}filter(se){return new fe(ne=>this.iterate(Ee=>se(Ee)?ne(Ee):!0))}map(se){return new fe(ne=>this.iterate(Ee=>ne(se(Ee))))}some(se){let ne=!1;return this.iterate(Ee=>(ne=se(Ee),!ne)),ne}findFirst(se){let ne;return this.iterate(Ee=>se(Ee)?(ne=Ee,!1):!0),ne}findLast(se){let ne;return this.iterate(Ee=>(se(Ee)&&(ne=Ee),!0)),ne}findLastMaxBy(se){let ne,Ee=!0;return this.iterate(oe=>((Ee||x.isGreaterThan(se(oe,ne)))&&(Ee=!1,ne=oe),!0)),ne}}e.$$b=fe}),define(Se[58],De([1,0,8]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.$xc=e.$wc=e.$vc=e.ok=void 0;function F(E,p){if(!E)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}e.ok=F;function f(E,p="Unreachable"){throw new Error(p)}e.$vc=f;function L(E){if(!E)throw new C.$ab("Assertion Failed")}e.$wc=L;function R(E){if(!E()){debugger;E(),(0,C.$Y)(new C.$ab("Assertion Failed"))}}e.$xc=R;function $(E,p){let A=0;for(;A<E.length-1;){const I=E[A],w=E[A+1];if(!p(I,w))return!1;A++}return!0}e.$yc=$}),define(Se[75],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function C(F){const f=this;let L=!1,R;return function(){return L||(L=!0,R=F.apply(f,arguments)),R}}e.$bb=C}),define(Se[119],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$7L=void 0;class C{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$7L=C,e.$8L=new C("id#")}),define(Se[50],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(F){function f(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}F.is=f;const L=Object.freeze([]);function R(){return L}F.empty=R;function*$(h){yield h}F.single=$;function E(h){return f(h)?h:$(h)}F.wrap=E;function p(h){return h||L}F.from=p;function*A(h){for(let t=h.length-1;t>=0;t--)yield h[t]}F.reverse=A;function I(h){return!h||h[Symbol.iterator]().next().done===!0}F.isEmpty=I;function w(h){return h[Symbol.iterator]().next().value}F.first=w;function k(h,t){for(const r of h)if(t(r))return!0;return!1}F.some=k;function D(h,t){for(const r of h)if(t(r))return r}F.find=D;function*v(h,t){for(const r of h)t(r)&&(yield r)}F.filter=v;function*o(h,t){let r=0;for(const a of h)yield t(a,r++)}F.map=o;function*s(...h){for(const t of h)for(const r of t)yield r}F.concat=s;function n(h,t,r){let a=r;for(const i of h)a=t(a,i);return a}F.reduce=n;function*l(h,t,r=h.length){for(t<0&&(t+=h.length),r<0?r+=h.length:r>h.length&&(r=h.length);t<r;t++)yield h[t]}F.slice=l;function b(h,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,h];const a=h[Symbol.iterator]();for(let i=0;i<t;i++){const c=a.next();if(c.done)return[r,F.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return a}}]}F.consume=b})(C||(e.Iterable=C={}))}),define(Se[157],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,r=!1){let a=0;const i=t.length;let c="",d=0,y=16,S=0;function g(j){let z=0,T=0;for(;z<j;){const H=t.charCodeAt(a);if(H>=48&&H<=57)T=T*16+H-48;else if(H>=65&&H<=70)T=T*16+H-65+10;else if(H>=97&&H<=102)T=T*16+H-97+10;else break;a++,z++}return z<j&&(T=-1),T}function u(j){a=j,c="",d=0,y=16,S=0}function m(){const j=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&p(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&p(t.charCodeAt(a)))for(a++;a<t.length&&p(t.charCodeAt(a));)a++;else return S=3,t.substring(j,a);let z=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&p(t.charCodeAt(a))){for(a++;a<t.length&&p(t.charCodeAt(a));)a++;z=a}else S=3;return t.substring(j,z)}function P(){let j="",z=a;for(;;){if(a>=i){j+=t.substring(z,a),S=2;break}const T=t.charCodeAt(a);if(T===34){j+=t.substring(z,a),a++;break}if(T===92){if(j+=t.substring(z,a),a++,a>=i){S=2;break}switch(t.charCodeAt(a++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const q=g(4);q>=0?j+=String.fromCharCode(q):S=4;break}default:S=5}z=a;continue}if(T>=0&&T<=31)if(E(T)){j+=t.substring(z,a),S=2;break}else S=6;a++}return j}function O(){if(c="",S=0,d=a,a>=i)return d=i,y=17;let j=t.charCodeAt(a);if($(j)){do a++,c+=String.fromCharCode(j),j=t.charCodeAt(a);while($(j));return y=15}if(E(j))return a++,c+=String.fromCharCode(j),j===13&&t.charCodeAt(a)===10&&(a++,c+=`
`),y=14;switch(j){case 123:return a++,y=1;case 125:return a++,y=2;case 91:return a++,y=3;case 93:return a++,y=4;case 58:return a++,y=6;case 44:return a++,y=5;case 34:return a++,c=P(),y=10;case 47:{const z=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<i&&!E(t.charCodeAt(a));)a++;return c=t.substring(z,a),y=12}if(t.charCodeAt(a+1)===42){a+=2;const T=i-1;let H=!1;for(;a<T;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,H=!0;break}a++}return H||(a++,S=1),c=t.substring(z,a),y=13}return c+=String.fromCharCode(j),a++,y=16}case 45:if(c+=String.fromCharCode(j),a++,a===i||!p(t.charCodeAt(a)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=m(),y=11;default:for(;a<i&&N(j);)a++,j=t.charCodeAt(a);if(d!==a){switch(c=t.substring(d,a),c){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return c+=String.fromCharCode(j),a++,y=16}}function N(j){if($(j)||E(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let j;do j=O();while(j>=12&&j<=15);return j}return{setPosition:u,getPosition:()=>a,scan:r?M:O,getToken:()=>y,getTokenValue:()=>c,getTokenOffset:()=>d,getTokenLength:()=>a-d,getTokenError:()=>S}}e.$Jm=R;function $(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function I(t,r){const a=[],i=new Object;let c;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function S(g,u,m,P){d.value=g,d.offset=u,d.length=m,d.type=P,d.colonOffset=void 0,c=d}try{l(t,{onObjectBegin:(g,u)=>{if(r<=g)throw i;c=void 0,y=r>g,a.push("")},onObjectProperty:(g,u,m)=>{if(r<u||(S(g,u,m,"property"),a[a.length-1]=g,r<=u+m))throw i},onObjectEnd:(g,u)=>{if(r<=g)throw i;c=void 0,a.pop()},onArrayBegin:(g,u)=>{if(r<=g)throw i;c=void 0,a.push(0)},onArrayEnd:(g,u)=>{if(r<=g)throw i;c=void 0,a.pop()},onLiteralValue:(g,u,m)=>{if(r<u||(S(g,u,m,h(g)),r<=u+m))throw i},onSeparator:(g,u,m)=>{if(r<=u)throw i;if(g===":"&&c&&c.type==="property")c.colonOffset=u,y=!1,c=void 0;else if(g===","){const P=a[a.length-1];typeof P=="number"?a[a.length-1]=P+1:(y=!0,a[a.length-1]=""),c=void 0}}})}catch(g){if(g!==i)throw g}return{path:a,previousNode:c,isAtPropertyKey:y,matches:g=>{let u=0;for(let m=0;u<g.length&&m<a.length;m++)if(g[u]===a[m]||g[u]==="*")u++;else if(g[u]!=="**")return!1;return u===g.length}}}e.$Km=I;function w(t,r=[],a=L.DEFAULT){let i=null,c=[];const d=[];function y(g){Array.isArray(c)?c.push(g):i!==null&&(c[i]=g)}return l(t,{onObjectBegin:()=>{const g={};y(g),d.push(c),c=g,i=null},onObjectProperty:g=>{i=g},onObjectEnd:()=>{c=d.pop()},onArrayBegin:()=>{const g=[];y(g),d.push(c),c=g,i=null},onArrayEnd:()=>{c=d.pop()},onLiteralValue:y,onError:(g,u,m)=>{r.push({error:g,offset:u,length:m})}},a),c[0]}e.$Lm=w;function k(t,r=[],a=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(g){i.type==="property"&&(i.length=g-i.offset,i=i.parent)}function d(g){return i.children.push(g),g}l(t,{onObjectBegin:g=>{i=d({type:"object",offset:g,length:-1,parent:i,children:[]})},onObjectProperty:(g,u,m)=>{i=d({type:"property",offset:u,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:g,offset:u,length:m,parent:i})},onObjectEnd:(g,u)=>{i.length=g+u-i.offset,i=i.parent,c(g+u)},onArrayBegin:(g,u)=>{i=d({type:"array",offset:g,length:-1,parent:i,children:[]})},onArrayEnd:(g,u)=>{i.length=g+u-i.offset,i=i.parent,c(g+u)},onLiteralValue:(g,u,m)=>{d({type:h(g),offset:u,length:m,parent:i,value:g}),c(u+m)},onSeparator:(g,u,m)=>{i.type==="property"&&(g===":"?i.colonOffset=u:g===","&&c(u))},onError:(g,u,m)=>{r.push({error:g,offset:u,length:m})}},a);const S=i.children[0];return S&&delete S.parent,S}e.$Mm=k;function D(t,r){if(!t)return;let a=t;for(const i of r)if(typeof i=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const d of a.children)if(Array.isArray(d.children)&&d.children[0].value===i){a=d.children[1],c=!0;break}if(!c)return}else{const c=i;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.$Nm=D;function v(t){if(!t.parent||!t.parent.children)return[];const r=v(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;r.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&r.push(a)}return r}e.$Om=v;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const r=Object.create(null);for(const a of t.children){const i=a.children[1];i&&(r[a.children[0].value]=o(i))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Pm=o;function s(t,r,a=!1){return r>=t.offset&&r<t.offset+t.length||a&&r===t.offset+t.length}e.$Qm=s;function n(t,r,a=!1){if(s(t,r,a)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=r;c++){const d=n(i[c],r,a);if(d)return d}return t}}e.$Rm=n;function l(t,r,a=L.DEFAULT){const i=R(t,!1);function c(ge){return ge?()=>ge(i.getTokenOffset(),i.getTokenLength()):()=>!0}function d(ge){return ge?ue=>ge(ue,i.getTokenOffset(),i.getTokenLength()):()=>!0}const y=c(r.onObjectBegin),S=d(r.onObjectProperty),g=c(r.onObjectEnd),u=c(r.onArrayBegin),m=c(r.onArrayEnd),P=d(r.onLiteralValue),O=d(r.onSeparator),N=c(r.onComment),M=d(r.onError),j=a&&a.disallowComments,z=a&&a.allowTrailingComma;function T(){for(;;){const ge=i.scan();switch(i.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:j||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(ge){case 12:case 13:j?H(10):N();break;case 16:H(1);break;case 15:case 14:break;default:return ge}}}function H(ge,ue=[],ve=[]){if(M(ge),ue.length+ve.length>0){let G=i.getToken();for(;G!==17;){if(ue.indexOf(G)!==-1){T();break}else if(ve.indexOf(G)!==-1)break;G=T()}}}function q(ge){const ue=i.getTokenValue();return ge?P(ue):S(ue),T(),!0}function me(){switch(i.getToken()){case 11:{let ge=0;try{ge=JSON.parse(i.getTokenValue()),typeof ge!="number"&&(H(2),ge=0)}catch{H(2)}P(ge);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return T(),!0}function Z(){return i.getToken()!==10?(H(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(O(":"),T(),x()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function X(){y(),T();let ge=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ge||H(4,[],[]),O(","),T(),i.getToken()===2&&z)break}else ge&&H(6,[],[]);Z()||H(4,[],[2,5]),ge=!0}return g(),i.getToken()!==2?H(7,[2],[]):T(),!0}function V(){u(),T();let ge=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ge||H(4,[],[]),O(","),T(),i.getToken()===4&&z)break}else ge&&H(6,[],[]);x()||H(4,[],[4,5]),ge=!0}return m(),i.getToken()!==4?H(8,[4],[]):T(),!0}function x(){switch(i.getToken()){case 3:return V();case 1:return X();case 10:return q(!0);default:return me()}}return T(),i.getToken()===17?a.allowEmptyContent?!0:(H(4,[],[]),!1):x()?(i.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.$Sm=l;function b(t,r){const a=R(t),i=[];let c,d=0,y;do switch(y=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:d!==y&&i.push(t.substring(d,y)),r!==void 0&&i.push(a.getTokenValue().replace(/[^\r\n]/g,r)),d=a.getPosition();break}while(c!==17);return i.join("")}e.$Tm=b;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Um=h}),define(Se[59],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class C{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=C}),define(Se[3],De([1,0,19,56,75,50]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=void 0;const R=!1;let $=null;class E{constructor(){this.b=new Map}static{this.a=0}c(u){let m=this.b.get(u);return m||(m={parent:null,source:null,isSingleton:!1,value:u,idx:E.a++},this.b.set(u,m)),m}trackDisposable(u){const m=this.c(u);m.source||(m.source=new Error().stack)}setParent(u,m){const P=this.c(u);P.parent=m}markAsDisposed(u){this.b.delete(u)}markAsSingleton(u){this.c(u).isSingleton=!0}f(u,m){const P=m.get(u);if(P)return P;const O=u.parent?this.f(this.c(u.parent),m):u;return m.set(u,O),O}getTrackedDisposables(){const u=new Map;return[...this.b.entries()].filter(([,P])=>P.source!==null&&!this.f(P,u).isSingleton).map(([P])=>P).flat()}computeLeakingDisposables(u=10,m){let P;if(m)P=m;else{const z=new Map,T=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,z).isSingleton);if(T.length===0)return;const H=new Set(T.map(q=>q.value));if(P=T.filter(q=>!(q.parent&&H.has(q.parent))),P.length===0)throw new Error("There are cyclic diposable chains!")}if(!P)return;function O(z){function T(q,me){for(;q.length>0&&me.some(Z=>typeof Z=="string"?Z===q[0]:q[0].match(Z));)q.shift()}const H=z.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return T(H,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),H.reverse()}const N=new F.$L;for(const z of P){const T=O(z);for(let H=0;H<=T.length;H++)N.add(T.slice(0,H).join(`
`),z)}P.sort((0,C.$5b)(z=>z.idx,C.$7b));let M="",j=0;for(const z of P.slice(0,u)){j++;const T=O(z),H=[];for(let q=0;q<T.length;q++){let me=T[q];me=`(shared with ${N.get(T.slice(0,q+1).join(`
`)).size}/${P.length} leaks) at ${me}`;const X=N.get(T.slice(0,q).join(`
`)),V=(0,F.$I)([...X].map(x=>O(x)[q]),x=>x);delete V[T[q]];for(const[x,ge]of Object.entries(V))H.unshift(`    - stacktraces of ${ge.length} other leaks continue with ${x}`);H.unshift(me)}M+=`


==================== Leaking disposable ${j}/${P.length}: ${z.value.constructor.name} ====================
${H.join(`
`)}
============================================================

`}return P.length>u&&(M+=`


... and ${P.length-u} more leaking disposables

`),{leaks:P,details:M}}}e.$_b=E;function p(g){$=g}if(e.$ac=p,R){const g="__is_disposable_tracked__";p(new class{trackDisposable(u){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[g]||console.log(m)},3e3)}setParent(u,m){if(u&&u!==h.None)try{u[g]=!0}catch{}}markAsDisposed(u){if(u&&u!==h.None)try{u[g]=!0}catch{}}markAsSingleton(u){}})}function A(g){return $?.trackDisposable(g),g}e.$bc=A;function I(g){$?.markAsDisposed(g)}e.$cc=I;function w(g,u){$?.setParent(g,u)}function k(g,u){if($)for(const m of g)$.setParent(m,u)}function D(g){return $?.markAsSingleton(g),g}e.$dc=D;function v(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.$ec=v;function o(g){if(L.Iterable.is(g)){const u=[];for(const m of g)if(m)try{m.dispose()}catch(P){u.push(P)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}e.$fc=o;function s(g){for(const u of g)v(u)&&u.dispose();return[]}e.$gc=s;function n(...g){const u=l(()=>o(g));return k(g,u),u}e.$hc=n;function l(g){const u=A({dispose:(0,f.$bb)(()=>{I(u),g()})});return u}e.$ic=l;class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(I(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return w(u,this),this.g?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(u),u}}e.$jc=b;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new b,A(this),w(this.q,this)}dispose(){I(this),this.q.dispose()}B(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(u)}}e.$kc=h;class t{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(u){this.b||u===this.a||(this.a?.dispose(),u&&w(u,this),this.a=u)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const u=this.a;return this.a=void 0,u&&w(u,null),u}}e.$lc=t;class r{constructor(u){this.b=u,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$mc=r;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(u){let m=u;return this.unset=()=>m=void 0,this.isset=()=>m!==void 0,this.dispose=()=>{m&&(m(),m=void 0,I(this))},this}}e.$nc=a;class i{constructor(){this.a=new Map}acquire(u,...m){let P=this.a.get(u);P||(P={counter:0,object:this.b(u,...m)},this.a.set(u,P));const{object:O}=P,N=(0,f.$bb)(()=>{--P.counter===0&&(this.c(u,P.object),this.a.delete(u))});return P.counter++,{object:O,dispose:N}}}e.$oc=i;class c{constructor(u){this.a=u}async acquire(u,...m){const P=this.a.acquire(u,...m);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(O){throw P.dispose(),O}}}e.$pc=c;class d{constructor(u){this.object=u}dispose(){}}e.$qc=d;function y(g){const u=new b;try{g(u)}finally{u.dispose()}}e.$rc=y;class S{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(u){return this.a.has(u)}get size(){return this.a.size}get(u){return this.a.get(u)}set(u,m,P=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),P||this.a.get(u)?.dispose(),this.a.set(u,m)}deleteAndDispose(u){this.a.get(u)?.dispose(),this.a.delete(u)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$sc=S}),define(Se[76],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=void 0;class C{static{this.Undefined=new C(void 0)}constructor(L){this.element=L,this.next=C.Undefined,this.prev=C.Undefined}}class F{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let L=this.a;for(;L!==C.Undefined;){const R=L.next;L.prev=C.Undefined,L.next=C.Undefined,L=R}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,R){const $=new C(L);if(this.a===C.Undefined)this.a=$,this.b=$;else if(R){const p=this.b;this.b=$,$.prev=p,p.next=$}else{const p=this.a;this.a=$,$.next=p,p.prev=$}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e($))}}shift(){if(this.a!==C.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==C.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==C.Undefined&&L.next!==C.Undefined){const R=L.prev;R.next=L.next,L.next.prev=R}else L.prev===C.Undefined&&L.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):L.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):L.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==C.Undefined;)yield L.element,L=L.next}}e.$tc=F}),define(Se[28],De([1,0]),function($e,e){"use strict";var C,F,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.Touch=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=void 0;function L(s,n,l){let b=s.get(n);return b===void 0&&(b=l,s.set(n,b)),b}e.$wi=L;function R(s){const n=[];return s.forEach((l,b)=>{n.push(`${b} => ${l}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.$xi=R;function $(s){const n=[];return s.forEach(l=>{n.push(l)}),`Set(${s.size}) {${n.join(", ")}}`}e.$yi=$;class E{constructor(n,l){this.uri=n,this.value=l}}function p(s){return Array.isArray(s)}class A{static{this.a=n=>n.toString()}constructor(n,l){if(this[C]="ResourceMap",n instanceof A)this.b=new Map(n.b),this.c=l??A.a;else if(p(n)){this.b=new Map,this.c=l??A.a;for(const[b,h]of n)this.set(b,h)}else this.b=new Map,this.c=n??A.a}set(n,l){return this.b.set(this.c(n),new E(n,l)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,l){typeof l<"u"&&(n=n.bind(l));for(const[b,h]of this.b)n(h.value,h.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$zi=A;class I{constructor(n,l){this[F]="ResourceSet",!n||typeof n=="function"?this.a=new A(n):(this.a=new A(l),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,l){this.a.forEach((b,h)=>n.call(l,h,h,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ai=I;var w;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class k{constructor(){this[f]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,l=0){const b=this.a.get(n);if(b)return l!==0&&this.j(b,l),b.value}set(n,l,b=0){let h=this.a.get(n);if(h)h.value=l,b!==0&&this.j(h,b);else{switch(h={key:n,value:l,next:void 0,previous:void 0},b){case 0:this.h(h);break;case 1:this.g(h);break;case 2:this.h(h);break;default:this.h(h);break}this.a.set(n,h),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const l=this.a.get(n);if(l)return this.a.delete(n),this.i(l),this.d--,l.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,l){const b=this.e;let h=this.b;for(;h;){if(l?n.bind(l)(h.value,h.key,this):n(h.value,h.key,this),this.e!==b)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const n=this,l=this.e;let b=this.b;const h={[Symbol.iterator](){return h},next(){if(n.e!==l)throw new Error("LinkedMap got modified during iteration.");if(b){const t={value:b.key,done:!1};return b=b.next,t}else return{value:void 0,done:!0}}};return h}values(){const n=this,l=this.e;let b=this.b;const h={[Symbol.iterator](){return h},next(){if(n.e!==l)throw new Error("LinkedMap got modified during iteration.");if(b){const t={value:b.value,done:!1};return b=b.next,t}else return{value:void 0,done:!0}}};return h}entries(){const n=this,l=this.e;let b=this.b;const h={[Symbol.iterator](){return h},next(){if(n.e!==l)throw new Error("LinkedMap got modified during iteration.");if(b){const t={value:[b.key,b.value],done:!1};return b=b.next,t}else return{value:void 0,done:!0}}};return h}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let l=this.b,b=this.size;for(;l&&b>n;)this.a.delete(l.key),l=l.next,b--;this.b=l,this.d=b,l&&(l.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const l=n.next,b=n.previous;if(!l||!b)throw new Error("Invalid list");l.previous=b,b.next=l}n.next=void 0,n.previous=void 0,this.e++}j(n,l){if(!this.b||!this.c)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(n===this.b)return;const b=n.next,h=n.previous;n===this.c?(h.next=void 0,this.c=h):(b.previous=h,h.next=b),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(l===2){if(n===this.c)return;const b=n.next,h=n.previous;n===this.b?(b.previous=void 0,this.b=b):(b.previous=h,h.next=b),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((l,b)=>{n.push([b,l])}),n}fromJSON(n){this.clear();for(const[l,b]of n)this.set(l,b)}}e.$Bi=k;class D extends k{constructor(n,l=1){super(),this.k=n,this.l=Math.min(Math.max(0,l),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,l=2){return super.get(n,l)}peek(n){return super.get(n,0)}set(n,l){return super.set(n,l,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ci=D;class v{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let l=this.a.get(n)||0;return l===0?!1:(l--,l===0?this.a.delete(n):this.a.set(n,l),!0)}has(n){return this.a.has(n)}}e.$Di=v;class o{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[l,b]of n)this.set(l,b)}clear(){this.a.clear(),this.b.clear()}set(n,l){this.a.set(n,l),this.b.set(l,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const l=this.a.get(n);return l===void 0?!1:(this.a.delete(n),this.b.delete(l),!0)}forEach(n,l){this.a.forEach((b,h)=>{n.call(l,b,h,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ei=o}),function($e,e){typeof define=="function"&&define.amd?define(Se[158],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(se,ne){for(var Ee=0;Ee<ne.length;Ee++){var oe=ne[Ee];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(se,oe.key,oe)}}function C(se,ne,Ee){return ne&&e(se.prototype,ne),Ee&&e(se,Ee),Object.defineProperty(se,"prototype",{writable:!1}),se}function F(se,ne){if(se){if(typeof se=="string")return f(se,ne);var Ee=Object.prototype.toString.call(se).slice(8,-1);if(Ee==="Object"&&se.constructor&&(Ee=se.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(se);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return f(se,ne)}}function f(se,ne){(ne==null||ne>se.length)&&(ne=se.length);for(var Ee=0,oe=new Array(ne);Ee<ne;Ee++)oe[Ee]=se[Ee];return oe}function L(se,ne){var Ee=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(Ee)return(Ee=Ee.call(se)).next.bind(Ee);if(Array.isArray(se)||(Ee=F(se))||ne&&se&&typeof se.length=="number"){Ee&&(se=Ee);var oe=0;return function(){return oe>=se.length?{done:!0}:{done:!1,value:se[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=R();function $(se){$e.defaults=se}var E=/[&<>"']/,p=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(ne){return w[ne]};function D(se,ne){if(ne){if(E.test(se))return se.replace(p,k)}else if(A.test(se))return se.replace(I,k);return se}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(se){return se.replace(v,function(ne,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(se,ne){se=typeof se=="string"?se:se.source,ne=ne||"";var Ee={replace:function(he,ee){return ee=ee.source||ee,ee=ee.replace(s,"$1"),se=se.replace(he,ee),Ee},getRegex:function(){return new RegExp(se,ne)}};return Ee}var l=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(se,ne,Ee){if(se){var oe;try{oe=decodeURIComponent(o(Ee)).replace(l,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}ne&&!b.test(Ee)&&(Ee=c(ne,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var t={},r=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(se,ne){t[" "+se]||(r.test(se)?t[" "+se]=se+"/":t[" "+se]=g(se,"/",!0)),se=t[" "+se];var Ee=se.indexOf(":")===-1;return ne.substring(0,2)==="//"?Ee?ne:se.replace(a,"$1")+ne:ne.charAt(0)==="/"?Ee?ne:se.replace(i,"$1")+ne:se+ne}var d={exec:function(){}};function y(se){for(var ne=1,Ee,oe;ne<arguments.length;ne++){Ee=arguments[ne];for(oe in Ee)Object.prototype.hasOwnProperty.call(Ee,oe)&&(se[oe]=Ee[oe])}return se}function S(se,ne){var Ee=se.replace(/\|/g,function(ee,le,be){for(var Ie=!1,B=le;--B>=0&&be[B]==="\\";)Ie=!Ie;return Ie?"|":" |"}),oe=Ee.split(/ \|/),he=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>ne)oe.splice(ne);else for(;oe.length<ne;)oe.push("");for(;he<oe.length;he++)oe[he]=oe[he].trim().replace(/\\\|/g,"|");return oe}function g(se,ne,Ee){var oe=se.length;if(oe===0)return"";for(var he=0;he<oe;){var ee=se.charAt(oe-he-1);if(ee===ne&&!Ee)he++;else if(ee!==ne&&Ee)he++;else break}return se.slice(0,oe-he)}function u(se,ne){if(se.indexOf(ne[1])===-1)return-1;for(var Ee=se.length,oe=0,he=0;he<Ee;he++)if(se[he]==="\\")he++;else if(se[he]===ne[0])oe++;else if(se[he]===ne[1]&&(oe--,oe<0))return he;return-1}function m(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(se,ne){if(ne<1)return"";for(var Ee="";ne>1;)ne&1&&(Ee+=se),ne>>=1,se+=se;return Ee+se}function O(se,ne,Ee,oe){var he=ne.href,ee=ne.title?D(ne.title):null,le=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){oe.state.inLink=!0;var be={type:"link",raw:Ee,href:he,title:ee,text:le,tokens:oe.inlineTokens(le)};return oe.state.inLink=!1,be}return{type:"image",raw:Ee,href:he,title:ee,text:D(le)}}function N(se,ne){var Ee=se.match(/^(\s+)(?:```)/);if(Ee===null)return ne;var oe=Ee[1];return ne.split(`
`).map(function(he){var ee=he.match(/^\s+/);if(ee===null)return he;var le=ee[0];return le.length>=oe.length?he.slice(oe.length):he}).join(`
`)}var M=function(){function se(Ee){this.options=Ee||$e.defaults}var ne=se.prototype;return ne.space=function(oe){var he=this.rules.block.newline.exec(oe);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},ne.code=function(oe){var he=this.rules.block.code.exec(oe);if(he){var ee=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:g(ee,`
`)}}},ne.fences=function(oe){var he=this.rules.block.fences.exec(oe);if(he){var ee=he[0],le=N(ee,he[3]||"");return{type:"code",raw:ee,lang:he[2]?he[2].trim():he[2],text:le}}},ne.heading=function(oe){var he=this.rules.block.heading.exec(oe);if(he){var ee=he[2].trim();if(/#$/.test(ee)){var le=g(ee,"#");(this.options.pedantic||!le||/ $/.test(le))&&(ee=le.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:ee,tokens:this.lexer.inline(ee)}}},ne.hr=function(oe){var he=this.rules.block.hr.exec(oe);if(he)return{type:"hr",raw:he[0]}},ne.blockquote=function(oe){var he=this.rules.block.blockquote.exec(oe);if(he){var ee=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},ne.list=function(oe){var he=this.rules.block.list.exec(oe);if(he){var ee,le,be,Ie,B,Y,ie,re,Q,de,ye,je,We=he[1].trim(),_e=We.length>1,Qe={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(je=!1,!(!(he=it.exec(oe))||this.rules.block.hr.test(oe)));){if(ee=he[0],oe=oe.substring(ee.length),re=he[2].split(`
`,1)[0],Q=oe.split(`
`,1)[0],this.options.pedantic?(Ie=2,ye=re.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ye=re.slice(Ie),Ie+=he[1].length),Y=!1,!re&&/^ *$/.test(Q)&&(ee+=Q+`
`,oe=oe.substring(Q.length+1),je=!0),!je)for(var et=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");oe&&(de=oe.split(`
`,1)[0],re=de,this.options.pedantic&&(re=re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(re)||Ve.test(re)||et.test(re)||Ae.test(oe)));){if(re.search(/[^ ]/)>=Ie||!re.trim())ye+=`
`+re.slice(Ie);else if(!Y)ye+=`
`+re;else break;!Y&&!re.trim()&&(Y=!0),ee+=de+`
`,oe=oe.substring(de.length+1)}Qe.loose||(ie?Qe.loose=!0:/\n *\n *$/.test(ee)&&(ie=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(ye),le&&(be=le[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ee,task:!!le,checked:be,loose:!1,text:ye}),Qe.raw+=ee}Qe.items[Qe.items.length-1].raw=ee.trimRight(),Qe.items[Qe.items.length-1].text=ye.trimRight(),Qe.raw=Qe.raw.trimRight();var Le=Qe.items.length;for(B=0;B<Le;B++){this.lexer.state.top=!1,Qe.items[B].tokens=this.lexer.blockTokens(Qe.items[B].text,[]);var Xe=Qe.items[B].tokens.filter(function(ae){return ae.type==="space"}),ce=Xe.every(function(ae){for(var Ce=ae.raw.split(""),qe=0,Ue=L(Ce),Ze;!(Ze=Ue()).done;){var rt=Ze.value;if(rt===`
`&&(qe+=1),qe>1)return!0}return!1});!Qe.loose&&Xe.length&&ce&&(Qe.loose=!0,Qe.items[B].loose=!0)}return Qe}},ne.html=function(oe){var he=this.rules.block.html.exec(oe);if(he){var ee={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(he[0]):D(he[0]);ee.type="paragraph",ee.text=le,ee.tokens=this.lexer.inline(le)}return ee}},ne.def=function(oe){var he=this.rules.block.def.exec(oe);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var ee=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:he[0],href:he[2],title:he[3]}}},ne.table=function(oe){var he=this.rules.block.table.exec(oe);if(he){var ee={type:"table",header:S(he[1]).map(function(ie){return{text:ie}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=he[0];var le=ee.align.length,be,Ie,B,Y;for(be=0;be<le;be++)/^ *-+: *$/.test(ee.align[be])?ee.align[be]="right":/^ *:-+: *$/.test(ee.align[be])?ee.align[be]="center":/^ *:-+ *$/.test(ee.align[be])?ee.align[be]="left":ee.align[be]=null;for(le=ee.rows.length,be=0;be<le;be++)ee.rows[be]=S(ee.rows[be],ee.header.length).map(function(ie){return{text:ie}});for(le=ee.header.length,Ie=0;Ie<le;Ie++)ee.header[Ie].tokens=this.lexer.inline(ee.header[Ie].text);for(le=ee.rows.length,Ie=0;Ie<le;Ie++)for(Y=ee.rows[Ie],B=0;B<Y.length;B++)Y[B].tokens=this.lexer.inline(Y[B].text);return ee}}},ne.lheading=function(oe){var he=this.rules.block.lheading.exec(oe);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},ne.paragraph=function(oe){var he=this.rules.block.paragraph.exec(oe);if(he){var ee=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:ee,tokens:this.lexer.inline(ee)}}},ne.text=function(oe){var he=this.rules.block.text.exec(oe);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},ne.escape=function(oe){var he=this.rules.inline.escape.exec(oe);if(he)return{type:"escape",raw:he[0],text:D(he[1])}},ne.tag=function(oe){var he=this.rules.inline.tag.exec(oe);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):D(he[0]):he[0]}},ne.link=function(oe){var he=this.rules.inline.link.exec(oe);if(he){var ee=he[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var le=g(ee.slice(0,-1),"\\");if((ee.length-le.length)%2===0)return}else{var be=u(he[2],"()");if(be>-1){var Ie=he[0].indexOf("!")===0?5:4,B=Ie+he[1].length+be;he[2]=he[2].substring(0,be),he[0]=he[0].substring(0,B).trim(),he[3]=""}}var Y=he[2],ie="";if(this.options.pedantic){var re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Y);re&&(Y=re[1],ie=re[3])}else ie=he[3]?he[3].slice(1,-1):"";return Y=Y.trim(),/^</.test(Y)&&(this.options.pedantic&&!/>$/.test(ee)?Y=Y.slice(1):Y=Y.slice(1,-1)),O(he,{href:Y&&Y.replace(this.rules.inline._escapes,"$1"),title:ie&&ie.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},ne.reflink=function(oe,he){var ee;if((ee=this.rules.inline.reflink.exec(oe))||(ee=this.rules.inline.nolink.exec(oe))){var le=(ee[2]||ee[1]).replace(/\s+/g," ");if(le=he[le.toLowerCase()],!le||!le.href){var be=ee[0].charAt(0);return{type:"text",raw:be,text:be}}return O(ee,le,ee[0],this.lexer)}},ne.emStrong=function(oe,he,ee){ee===void 0&&(ee="");var le=this.rules.inline.emStrong.lDelim.exec(oe);if(le&&!(le[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=le[1]||le[2]||"";if(!be||be&&(ee===""||this.rules.inline.punctuation.exec(ee))){var Ie=le[0].length-1,B,Y,ie=Ie,re=0,Q=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Q.lastIndex=0,he=he.slice(-1*oe.length+Ie);(le=Q.exec(he))!=null;)if(B=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!B){if(Y=B.length,le[3]||le[4]){ie+=Y;continue}else if((le[5]||le[6])&&Ie%3&&!((Ie+Y)%3)){re+=Y;continue}if(ie-=Y,!(ie>0)){if(Y=Math.min(Y,Y+ie+re),Math.min(Ie,Y)%2){var de=oe.slice(1,Ie+le.index+Y);return{type:"em",raw:oe.slice(0,Ie+le.index+Y+1),text:de,tokens:this.lexer.inlineTokens(de)}}var ye=oe.slice(2,Ie+le.index+Y-1);return{type:"strong",raw:oe.slice(0,Ie+le.index+Y+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},ne.codespan=function(oe){var he=this.rules.inline.code.exec(oe);if(he){var ee=he[2].replace(/\n/g," "),le=/[^ ]/.test(ee),be=/^ /.test(ee)&&/ $/.test(ee);return le&&be&&(ee=ee.substring(1,ee.length-1)),ee=D(ee,!0),{type:"codespan",raw:he[0],text:ee}}},ne.br=function(oe){var he=this.rules.inline.br.exec(oe);if(he)return{type:"br",raw:he[0]}},ne.del=function(oe){var he=this.rules.inline.del.exec(oe);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},ne.autolink=function(oe,he){var ee=this.rules.inline.autolink.exec(oe);if(ee){var le,be;return ee[2]==="@"?(le=D(this.options.mangle?he(ee[1]):ee[1]),be="mailto:"+le):(le=D(ee[1]),be=le),{type:"link",raw:ee[0],text:le,href:be,tokens:[{type:"text",raw:le,text:le}]}}},ne.url=function(oe,he){var ee;if(ee=this.rules.inline.url.exec(oe)){var le,be;if(ee[2]==="@")le=D(this.options.mangle?he(ee[0]):ee[0]),be="mailto:"+le;else{var Ie;do Ie=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(Ie!==ee[0]);le=D(ee[0]),ee[1]==="www."?be="http://"+le:be=le}return{type:"link",raw:ee[0],text:le,href:be,tokens:[{type:"text",raw:le,text:le}]}}},ne.inlineText=function(oe,he){var ee=this.rules.inline.text.exec(oe);if(ee){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):D(ee[0]):ee[0]:le=D(this.options.smartypants?he(ee[0]):ee[0]),{type:"text",raw:ee[0],text:le}}},se}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=n(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=n(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=n(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=n(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=n(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=n(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=y({},j),j.gfm=y({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=n(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=n(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=y({},j.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:n(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=n(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=n(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=n(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=n(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=n(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=n(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=n(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=n(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=n(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=n(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=n(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=y({},z),z.pedantic=y({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=y({},z.normal,{escape:n(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=n(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=y({},z.gfm,{br:n(z.br).replace("{2,}","*").getRegex(),text:n(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(se){var ne="",Ee,oe,he=se.length;for(Ee=0;Ee<he;Ee++)oe=se.charCodeAt(Ee),Math.random()>.5&&(oe="x"+oe.toString(16)),ne+="&#"+oe+";";return ne}var q=function(){function se(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||$e.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:j.normal,inline:z.normal};this.options.pedantic?(oe.block=j.pedantic,oe.inline=z.pedantic):this.options.gfm&&(oe.block=j.gfm,this.options.breaks?oe.inline=z.breaks:oe.inline=z.gfm),this.tokenizer.rules=oe}se.lex=function(oe,he){var ee=new se(he);return ee.lex(oe)},se.lexInline=function(oe,he){var ee=new se(he);return ee.inlineTokens(oe)};var ne=se.prototype;return ne.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},ne.blockTokens=function(oe,he){var ee=this;he===void 0&&(he=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(ie,re,Q){return re+"    ".repeat(Q.length)});for(var le,be,Ie,B;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ie){return(le=ie.call({lexer:ee},oe,he))?(oe=oe.substring(le.raw.length),he.push(le),!0):!1}))){if(le=this.tokenizer.space(oe)){oe=oe.substring(le.raw.length),le.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(le);continue}if(le=this.tokenizer.code(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+le.raw,be.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):he.push(le);continue}if(le=this.tokenizer.fences(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.heading(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.hr(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.blockquote(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.list(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.html(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.def(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+le.raw,be.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.lheading(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(Ie=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var ie=1/0,re=oe.slice(1),Q=void 0;ee.options.extensions.startBlock.forEach(function(de){Q=de.call({lexer:this},re),typeof Q=="number"&&Q>=0&&(ie=Math.min(ie,Q))}),ie<1/0&&ie>=0&&(Ie=oe.substring(0,ie+1))}(),this.state.top&&(le=this.tokenizer.paragraph(Ie))){be=he[he.length-1],B&&be.type==="paragraph"?(be.raw+=`
`+le.raw,be.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):he.push(le),B=Ie.length!==oe.length,oe=oe.substring(le.raw.length);continue}if(le=this.tokenizer.text(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&be.type==="text"?(be.raw+=`
`+le.raw,be.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):he.push(le);continue}if(oe){var Y="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return this.state.top=!0,he},ne.inline=function(oe,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:oe,tokens:he}),he},ne.inlineTokens=function(oe,he){var ee=this;he===void 0&&(he=[]);var le,be,Ie,B=oe,Y,ie,re;if(this.tokens.links){var Q=Object.keys(this.tokens.links);if(Q.length>0)for(;(Y=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)Q.includes(Y[0].slice(Y[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,Y.index)+"["+P("a",Y[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Y=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,Y.index)+"["+P("a",Y[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Y=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,Y.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(ie||(re=""),ie=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(le=ye.call({lexer:ee},oe,he))?(oe=oe.substring(le.raw.length),he.push(le),!0):!1}))){if(le=this.tokenizer.escape(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.tag(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&le.type==="text"&&be.type==="text"?(be.raw+=le.raw,be.text+=le.text):he.push(le);continue}if(le=this.tokenizer.link(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&le.type==="text"&&be.type==="text"?(be.raw+=le.raw,be.text+=le.text):he.push(le);continue}if(le=this.tokenizer.emStrong(oe,B,re)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.codespan(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.br(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.del(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.autolink(oe,H)){oe=oe.substring(le.raw.length),he.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(oe,H))){oe=oe.substring(le.raw.length),he.push(le);continue}if(Ie=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=oe.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},je),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Ie=oe.substring(0,ye+1))}(),le=this.tokenizer.inlineText(Ie,T)){oe=oe.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(re=le.raw.slice(-1)),ie=!0,be=he[he.length-1],be&&be.type==="text"?(be.raw+=le.raw,be.text+=le.text):he.push(le);continue}if(oe){var de="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return he},C(se,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),se}(),me=function(){function se(Ee){this.options=Ee||$e.defaults}var ne=se.prototype;return ne.code=function(oe,he,ee){var le=(he||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(oe,le);be!=null&&be!==oe&&(ee=!0,oe=be)}return oe=oe.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+D(le,!0)+'">'+(ee?oe:D(oe,!0))+`</code></pre>
`:"<pre><code>"+(ee?oe:D(oe,!0))+`</code></pre>
`},ne.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},ne.html=function(oe){return oe},ne.heading=function(oe,he,ee,le){if(this.options.headerIds){var be=this.options.headerPrefix+le.slug(ee);return"<h"+he+' id="'+be+'">'+oe+"</h"+he+`>
`}return"<h"+he+">"+oe+"</h"+he+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(oe,he,ee){var le=he?"ol":"ul",be=he&&ee!==1?' start="'+ee+'"':"";return"<"+le+be+`>
`+oe+"</"+le+`>
`},ne.listitem=function(oe){return"<li>"+oe+`</li>
`},ne.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(oe){return"<p>"+oe+`</p>
`},ne.table=function(oe,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+he+`</table>
`},ne.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},ne.tablecell=function(oe,he){var ee=he.header?"th":"td",le=he.align?"<"+ee+' align="'+he.align+'">':"<"+ee+">";return le+oe+("</"+ee+`>
`)},ne.strong=function(oe){return"<strong>"+oe+"</strong>"},ne.em=function(oe){return"<em>"+oe+"</em>"},ne.codespan=function(oe){return"<code>"+oe+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(oe){return"<del>"+oe+"</del>"},ne.link=function(oe,he,ee){if(oe=h(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var le='<a href="'+D(oe)+'"';return he&&(le+=' title="'+he+'"'),le+=">"+ee+"</a>",le},ne.image=function(oe,he,ee){if(oe=h(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var le='<img src="'+oe+'" alt="'+ee+'"';return he&&(le+=' title="'+he+'"'),le+=this.options.xhtml?"/>":">",le},ne.text=function(oe){return oe},se}(),Z=function(){function se(){}var ne=se.prototype;return ne.strong=function(oe){return oe},ne.em=function(oe){return oe},ne.codespan=function(oe){return oe},ne.del=function(oe){return oe},ne.html=function(oe){return oe},ne.text=function(oe){return oe},ne.link=function(oe,he,ee){return""+ee},ne.image=function(oe,he,ee){return""+ee},ne.br=function(){return""},se}(),X=function(){function se(){this.seen={}}var ne=se.prototype;return ne.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(oe,he){var ee=oe,le=0;if(this.seen.hasOwnProperty(ee)){le=this.seen[oe];do le++,ee=oe+"-"+le;while(this.seen.hasOwnProperty(ee))}return he||(this.seen[oe]=le,this.seen[ee]=0),ee},ne.slug=function(oe,he){he===void 0&&(he={});var ee=this.serialize(oe);return this.getNextSafeSlug(ee,he.dryrun)},se}(),V=function(){function se(Ee){this.options=Ee||$e.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new X}se.parse=function(oe,he){var ee=new se(he);return ee.parse(oe)},se.parseInline=function(oe,he){var ee=new se(he);return ee.parseInline(oe)};var ne=se.prototype;return ne.parse=function(oe,he){he===void 0&&(he=!0);var ee="",le,be,Ie,B,Y,ie,re,Q,de,ye,je,We,_e,Qe,it,et,Ae,Oe,Ve,Le=oe.length;for(le=0;le<Le;le++){if(ye=oe[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ve=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ee+=Ve||"";continue}switch(ye.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,o(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(Q="",re="",B=ye.header.length,be=0;be<B;be++)re+=this.renderer.tablecell(this.parseInline(ye.header[be].tokens),{header:!0,align:ye.align[be]});for(Q+=this.renderer.tablerow(re),de="",B=ye.rows.length,be=0;be<B;be++){for(ie=ye.rows[be],re="",Y=ie.length,Ie=0;Ie<Y;Ie++)re+=this.renderer.tablecell(this.parseInline(ie[Ie].tokens),{header:!1,align:ye.align[Ie]});de+=this.renderer.tablerow(re)}ee+=this.renderer.table(Q,de);continue}case"blockquote":{de=this.parse(ye.tokens),ee+=this.renderer.blockquote(de);continue}case"list":{for(je=ye.ordered,We=ye.start,_e=ye.loose,B=ye.items.length,de="",be=0;be<B;be++)it=ye.items[be],et=it.checked,Ae=it.task,Qe="",it.task&&(Oe=this.renderer.checkbox(et),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Oe+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Oe+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Oe}):Qe+=Oe),Qe+=this.parse(it.tokens,_e),de+=this.renderer.listitem(Qe,Ae,et);ee+=this.renderer.list(de,je,We);continue}case"html":{ee+=this.renderer.html(ye.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(de=ye.tokens?this.parseInline(ye.tokens):ye.text;le+1<Le&&oe[le+1].type==="text";)ye=oe[++le],de+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ee+=he?this.renderer.paragraph(de):de;continue}default:{var Xe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return ee},ne.parseInline=function(oe,he){he=he||this.renderer;var ee="",le,be,Ie,B=oe.length;for(le=0;le<B;le++){if(be=oe[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Ie=this.options.extensions.renderers[be.type].call({parser:this},be),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){ee+=Ie||"";continue}switch(be.type){case"escape":{ee+=he.text(be.text);break}case"html":{ee+=he.html(be.text);break}case"link":{ee+=he.link(be.href,be.title,this.parseInline(be.tokens,he));break}case"image":{ee+=he.image(be.href,be.title,be.text);break}case"strong":{ee+=he.strong(this.parseInline(be.tokens,he));break}case"em":{ee+=he.em(this.parseInline(be.tokens,he));break}case"codespan":{ee+=he.codespan(be.text);break}case"br":{ee+=he.br();break}case"del":{ee+=he.del(this.parseInline(be.tokens,he));break}case"text":{ee+=he.text(be.text);break}default:{var Y='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Y);return}else throw new Error(Y)}}}return ee},se}();function x(se,ne,Ee){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof ne=="function"&&(Ee=ne,ne=null),ne=y({},x.defaults,ne||{}),m(ne),Ee){var oe=ne.highlight,he;try{he=q.lex(se,ne)}catch(B){return Ee(B)}var ee=function(Y){var ie;if(!Y)try{ne.walkTokens&&x.walkTokens(he,ne.walkTokens),ie=V.parse(he,ne)}catch(re){Y=re}return ne.highlight=oe,Y?Ee(Y):Ee(null,ie)};if(!oe||oe.length<3||(delete ne.highlight,!he.length))return ee();var le=0;x.walkTokens(he,function(B){B.type==="code"&&(le++,setTimeout(function(){oe(B.text,B.lang,function(Y,ie){if(Y)return ee(Y);ie!=null&&ie!==B.text&&(B.text=ie,B.escaped=!0),le--,le===0&&ee()})},0))}),le===0&&ee();return}function be(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+D(B.message+"",!0)+"</pre>";throw B}try{var Ie=q.lex(se,ne);if(ne.walkTokens){if(ne.async)return Promise.all(x.walkTokens(Ie,ne.walkTokens)).then(function(){return V.parse(Ie,ne)}).catch(be);x.walkTokens(Ie,ne.walkTokens)}return V.parse(Ie,ne)}catch(B){be(B)}}x.options=x.setOptions=function(se){return y(x.defaults,se),$(x.defaults),x},x.getDefaults=R,x.defaults=$e.defaults,x.use=function(){for(var se=arguments.length,ne=new Array(se),Ee=0;Ee<se;Ee++)ne[Ee]=arguments[Ee];var oe=y.apply(void 0,[{}].concat(ne)),he=x.defaults.extensions||{renderers:{},childTokens:{}},ee;ne.forEach(function(le){if(le.extensions&&(ee=!0,le.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var B=he.renderers?he.renderers[Ie.name]:null;B?he.renderers[Ie.name]=function(){for(var Y=arguments.length,ie=new Array(Y),re=0;re<Y;re++)ie[re]=arguments[re];var Q=Ie.renderer.apply(this,ie);return Q===!1&&(Q=B.apply(this,ie)),Q}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),le.renderer&&function(){var Ie=x.defaults.renderer||new me,B=function(re){var Q=Ie[re];Ie[re]=function(){for(var de=arguments.length,ye=new Array(de),je=0;je<de;je++)ye[je]=arguments[je];var We=le.renderer[re].apply(Ie,ye);return We===!1&&(We=Q.apply(Ie,ye)),We}};for(var Y in le.renderer)B(Y);oe.renderer=Ie}(),le.tokenizer&&function(){var Ie=x.defaults.tokenizer||new M,B=function(re){var Q=Ie[re];Ie[re]=function(){for(var de=arguments.length,ye=new Array(de),je=0;je<de;je++)ye[je]=arguments[je];var We=le.tokenizer[re].apply(Ie,ye);return We===!1&&(We=Q.apply(Ie,ye)),We}};for(var Y in le.tokenizer)B(Y);oe.tokenizer=Ie}(),le.walkTokens){var be=x.defaults.walkTokens;oe.walkTokens=function(Ie){var B=[];return B.push(le.walkTokens.call(this,Ie)),be&&(B=B.concat(be.call(this,Ie))),B}}ee&&(oe.extensions=he),x.setOptions(oe)})},x.walkTokens=function(se,ne){for(var Ee=[],oe=function(){var be=ee.value;switch(Ee=Ee.concat(ne.call(x,be)),be.type){case"table":{for(var Ie=L(be.header),B;!(B=Ie()).done;){var Y=B.value;Ee=Ee.concat(x.walkTokens(Y.tokens,ne))}for(var ie=L(be.rows),re;!(re=ie()).done;)for(var Q=re.value,de=L(Q),ye;!(ye=de()).done;){var je=ye.value;Ee=Ee.concat(x.walkTokens(je.tokens,ne))}break}case"list":{Ee=Ee.concat(x.walkTokens(be.items,ne));break}default:x.defaults.extensions&&x.defaults.extensions.childTokens&&x.defaults.extensions.childTokens[be.type]?x.defaults.extensions.childTokens[be.type].forEach(function(We){Ee=Ee.concat(x.walkTokens(be[We],ne))}):be.tokens&&(Ee=Ee.concat(x.walkTokens(be.tokens,ne)))}},he=L(se),ee;!(ee=he()).done;)oe();return Ee},x.parseInline=function(se,ne){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");ne=y({},x.defaults,ne||{}),m(ne);try{var Ee=q.lexInline(se,ne);return ne.walkTokens&&x.walkTokens(Ee,ne.walkTokens),V.parseInline(Ee,ne)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+D(oe.message+"",!0)+"</pre>";throw oe}},x.Parser=V,x.parser=V.parse,x.Renderer=me,x.TextRenderer=Z,x.Lexer=q,x.lexer=q.lex,x.Tokenizer=M,x.Slugger=X,x.parse=x;var ge=x.options,ue=x.setOptions,ve=x.use,G=x.walkTokens,U=x.parseInline,K=x,fe=V.parse,te=q.lex;$e.Lexer=q,$e.Parser=V,$e.Renderer=me,$e.Slugger=X,$e.TextRenderer=Z,$e.Tokenizer=M,$e.getDefaults=R,$e.lexer=te,$e.marked=x,$e.options=ge,$e.parse=K,$e.parseInline=U,$e.parser=fe,$e.setOptions=ue,$e.use=ve,$e.walkTokens=G,Object.defineProperty($e,"__esModule",{value:!0})}),define(Se[77],De([1,0,28]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=void 0;const F=new C.$Ci(1e4);function f(p){return E(p,"NFC",F)}e.$hl=f;const L=new C.$Ci(1e4);function R(p){return E(p,"NFD",L)}e.$il=R;const $=/[^\u0000-\u0080]/;function E(p,A,I){if(!p)return p;const w=I.get(p);if(w)return w;let k;return $.test(p)?k=p.normalize(A):k=p,I.set(p,k),k}e.$jl=function(){const p=/[\u0300-\u036f]/g;return function(A){return R(A).replace(p,"")}}()}),define(Se[120],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.rot=e.$Hl=void 0;function C($,E,p){return Math.min(Math.max($,E),p)}e.$Hl=C;function F($,E){return(E+$%E)%E}e.rot=F;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$Jl=f;class L{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Kl=L;class R{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const p=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ll=R}),function(){function $e(f){const L=[];typeof f=="number"&&L.push("code/timeOrigin",f);function R(E){L.push(E,Date.now())}function $(){const E=[];for(let p=0;p<L.length;p+=2)E.push({name:L[p],startTime:L[p+1]});return E}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(f+R.startTime)});return L}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function C(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=C(F))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var F in C)(typeof exports=="object"?exports:$e)[F]=C[F]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function C(F){if(e[F])return e[F].exports;var f=e[F]={i:F,l:!1,exports:{}};return $e[F].call(f.exports,f,f.exports,C),f.l=!0,f.exports}return C.m=$e,C.c=e,C.d=function(F,f,L){C.o(F,f)||Object.defineProperty(F,f,{enumerable:!0,get:L})},C.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},C.t=function(F,f){if(1&f&&(F=C(F)),8&f||4&f&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(C.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&f&&typeof F!="string")for(var R in F)C.d(L,R,function($){return F[$]}.bind(null,R));return L},C.n=function(F){var f=F&&F.__esModule?function(){return F.default}:function(){return F};return C.d(f,"a",f),f},C.o=function(F,f){return Object.prototype.hasOwnProperty.call(F,f)},C.p="",C(C.s=0)}([function($e,e,C){(function(F){var f;e=$e.exports=ve,f=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],E=e.src=[],p=0,A=p++;E[A]="0|[1-9]\\d*";var I=p++;E[I]="[0-9]+";var w=p++;E[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=p++;E[k]="("+E[A]+")\\.("+E[A]+")\\.("+E[A]+")";var D=p++;E[D]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var v=p++;E[v]="(?:"+E[A]+"|"+E[w]+")";var o=p++;E[o]="(?:"+E[I]+"|"+E[w]+")";var s=p++;E[s]="(?:-("+E[v]+"(?:\\."+E[v]+")*))";var n=p++;E[n]="(?:-?("+E[o]+"(?:\\."+E[o]+")*))";var l=p++;E[l]="[0-9A-Za-z-]+";var b=p++;E[b]="(?:\\+("+E[l]+"(?:\\."+E[l]+")*))";var h=p++,t="v?"+E[k]+E[s]+"?"+E[b]+"?";E[h]="^"+t+"$";var r="[v=\\s]*"+E[D]+E[n]+"?"+E[b]+"?",a=p++;E[a]="^"+r+"$";var i=p++;E[i]="((?:<|>)?=?)";var c=p++;E[c]=E[I]+"|x|X|\\*";var d=p++;E[d]=E[A]+"|x|X|\\*";var y=p++;E[y]="[v=\\s]*("+E[d]+")(?:\\.("+E[d]+")(?:\\.("+E[d]+")(?:"+E[s]+")?"+E[b]+"?)?)?";var S=p++;E[S]="[v=\\s]*("+E[c]+")(?:\\.("+E[c]+")(?:\\.("+E[c]+")(?:"+E[n]+")?"+E[b]+"?)?)?";var g=p++;E[g]="^"+E[i]+"\\s*"+E[y]+"$";var u=p++;E[u]="^"+E[i]+"\\s*"+E[S]+"$";var m=p++;E[m]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=p++;E[P]="(?:~>?)";var O=p++;E[O]="(\\s*)"+E[P]+"\\s+",$[O]=new RegExp(E[O],"g");var N=p++;E[N]="^"+E[P]+E[y]+"$";var M=p++;E[M]="^"+E[P]+E[S]+"$";var j=p++;E[j]="(?:\\^)";var z=p++;E[z]="(\\s*)"+E[j]+"\\s+",$[z]=new RegExp(E[z],"g");var T=p++;E[T]="^"+E[j]+E[y]+"$";var H=p++;E[H]="^"+E[j]+E[S]+"$";var q=p++;E[q]="^"+E[i]+"\\s*("+r+")$|^$";var me=p++;E[me]="^"+E[i]+"\\s*("+t+")$|^$";var Z=p++;E[Z]="(\\s*)"+E[i]+"\\s*("+r+"|"+E[y]+")",$[Z]=new RegExp(E[Z],"g");var X=p++;E[X]="^\\s*("+E[y]+")\\s+-\\s+("+E[y]+")\\s*$";var V=p++;E[V]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var x=p++;E[x]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)f(ge,E[ge]),$[ge]||($[ge]=new RegExp(E[ge]));function ue(Q,de){if(Q instanceof ve)return Q;if(typeof Q!="string"||Q.length>L||!(de?$[a]:$[h]).test(Q))return null;try{return new ve(Q,de)}catch{return null}}function ve(Q,de){if(Q instanceof ve){if(Q.loose===de)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof ve))return new ve(Q,de);f("SemVer",Q,de),this.loose=de;var ye=Q.trim().match(de?$[a]:$[h]);if(!ye)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<R)return We}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ue,e.valid=function(Q,de){var ye=ue(Q,de);return ye?ye.version:null},e.clean=function(Q,de){var ye=ue(Q.trim().replace(/^[=v]+/,""),de);return ye?ye.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(Q){return f("SemVer.compare",this.version,this.loose,Q),Q instanceof ve||(Q=new ve(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},ve.prototype.compareMain=function(Q){return Q instanceof ve||(Q=new ve(Q,this.loose)),U(this.major,Q.major)||U(this.minor,Q.minor)||U(this.patch,Q.patch)},ve.prototype.comparePre=function(Q){if(Q instanceof ve||(Q=new ve(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var de=0;do{var ye=this.prerelease[de],je=Q.prerelease[de];if(f("prerelease compare",de,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return U(ye,je)}while(++de)},ve.prototype.inc=function(Q,de){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,de,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new ve(Q,ye).inc(de,je).version}catch{return null}},e.diff=function(Q,de){if(se(Q,de))return null;var ye=ue(Q),je=ue(de);if(ye.prerelease.length||je.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return We},e.compareIdentifiers=U;var G=/^[0-9]+$/;function U(Q,de){var ye=G.test(Q),je=G.test(de);return ye&&je&&(Q=+Q,de=+de),ye&&!je?-1:je&&!ye?1:Q<de?-1:Q>de?1:0}function K(Q,de,ye){return new ve(Q,ye).compare(new ve(de,ye))}function fe(Q,de,ye){return K(Q,de,ye)>0}function te(Q,de,ye){return K(Q,de,ye)<0}function se(Q,de,ye){return K(Q,de,ye)===0}function ne(Q,de,ye){return K(Q,de,ye)!==0}function Ee(Q,de,ye){return K(Q,de,ye)>=0}function oe(Q,de,ye){return K(Q,de,ye)<=0}function he(Q,de,ye,je){var We;switch(de){case"===":typeof Q=="object"&&(Q=Q.version),typeof ye=="object"&&(ye=ye.version),We=Q===ye;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof ye=="object"&&(ye=ye.version),We=Q!==ye;break;case"":case"=":case"==":We=se(Q,ye,je);break;case"!=":We=ne(Q,ye,je);break;case">":We=fe(Q,ye,je);break;case">=":We=Ee(Q,ye,je);break;case"<":We=te(Q,ye,je);break;case"<=":We=oe(Q,ye,je);break;default:throw new TypeError("Invalid operator: "+de)}return We}function ee(Q,de){if(Q instanceof ee){if(Q.loose===de)return Q;Q=Q.value}if(!(this instanceof ee))return new ee(Q,de);f("comparator",Q,de),this.loose=de,this.parse(Q),this.semver===le?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(Q,de){return U(de,Q)},e.major=function(Q,de){return new ve(Q,de).major},e.minor=function(Q,de){return new ve(Q,de).minor},e.patch=function(Q,de){return new ve(Q,de).patch},e.compare=K,e.compareLoose=function(Q,de){return K(Q,de,!0)},e.rcompare=function(Q,de,ye){return K(de,Q,ye)},e.sort=function(Q,de){return Q.sort(function(ye,je){return e.compare(ye,je,de)})},e.rsort=function(Q,de){return Q.sort(function(ye,je){return e.rcompare(ye,je,de)})},e.gt=fe,e.lt=te,e.eq=se,e.neq=ne,e.gte=Ee,e.lte=oe,e.cmp=he,e.Comparator=ee;var le={};function be(Q,de){if(Q instanceof be)return Q.loose===de?Q:new be(Q.raw,de);if(Q instanceof ee)return new be(Q.value,de);if(!(this instanceof be))return new be(Q,de);if(this.loose=de,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function Ie(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function B(Q,de,ye,je,We,_e,Qe,it,et,Ae,Oe,Ve,Le){return((de=Ie(ye)?"":Ie(je)?">="+ye+".0.0":Ie(We)?">="+ye+"."+je+".0":">="+de)+" "+(it=Ie(et)?"":Ie(Ae)?"<"+(+et+1)+".0.0":Ie(Oe)?"<"+et+"."+(+Ae+1)+".0":Ve?"<="+et+"."+Ae+"."+Oe+"-"+Ve:"<="+it)).trim()}function Y(Q,de){for(var ye=0;ye<Q.length;ye++)if(!Q[ye].test(de))return!1;if(de.prerelease.length){for(ye=0;ye<Q.length;ye++)if(f(Q[ye].semver),Q[ye].semver!==le&&Q[ye].semver.prerelease.length>0){var je=Q[ye].semver;if(je.major===de.major&&je.minor===de.minor&&je.patch===de.patch)return!0}return!1}return!0}function ie(Q,de,ye){try{de=new be(de,ye)}catch{return!1}return de.test(Q)}function re(Q,de,ye,je){var We,_e,Qe,it,et;switch(Q=new ve(Q,je),de=new be(de,je),ye){case">":We=fe,_e=oe,Qe=te,it=">",et=">=";break;case"<":We=te,_e=Ee,Qe=fe,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ie(Q,de,je))return!1;for(var Ae=0;Ae<de.set.length;++Ae){var Oe=de.set[Ae],Ve=null,Le=null;if(Oe.forEach(function(Xe){Xe.semver===le&&(Xe=new ee(">=0.0.0")),Ve=Ve||Xe,Le=Le||Xe,We(Xe.semver,Ve.semver,je)?Ve=Xe:Qe(Xe.semver,Le.semver,je)&&(Le=Xe)}),Ve.operator===it||Ve.operator===et||(!Le.operator||Le.operator===it)&&_e(Q,Le.semver)||Le.operator===et&&Qe(Q,Le.semver))return!1}return!0}ee.prototype.parse=function(Q){var de=this.loose?$[q]:$[me],ye=Q.match(de);if(!ye)throw new TypeError("Invalid comparator: "+Q);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new ve(ye[2],this.loose):this.semver=le},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Q){return f("Comparator.test",Q,this.loose),this.semver===le||(typeof Q=="string"&&(Q=new ve(Q,this.loose)),he(Q,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Q,de){if(!(Q instanceof ee))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new be(Q.value,de),ie(this.value,ye,de);if(Q.operator==="")return ye=new be(this.value,de),ie(Q.semver,ye,de);var je=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),_e=this.semver.version===Q.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),it=he(this.semver,"<",Q.semver,de)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),et=he(this.semver,">",Q.semver,de)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return je||We||_e&&Qe||it||et},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Q){var de=this.loose;Q=Q.trim(),f("range",Q,de);var ye=de?$[V]:$[X];Q=Q.replace(ye,B),f("hyphen replace",Q),Q=Q.replace($[Z],"$1$2$3"),f("comparator trim",Q,$[Z]),Q=(Q=(Q=Q.replace($[O],"$1~")).replace($[z],"$1^")).split(/\s+/).join(" ");var je=de?$[q]:$[me],We=Q.split(" ").map(function(_e){return function(Qe,it){return f("comp",Qe),Qe=function(et,Ae){return et.trim().split(/\s+/).map(function(Oe){return function(Ve,Le){f("caret",Ve,Le);var Xe=Le?$[H]:$[T];return Ve.replace(Xe,function(ce,ae,Ce,qe,Ue){var Ze;return f("caret",Ve,ce,ae,Ce,qe,Ue),Ie(ae)?Ze="":Ie(Ce)?Ze=">="+ae+".0.0 <"+(+ae+1)+".0.0":Ie(qe)?Ze=ae==="0"?">="+ae+"."+Ce+".0 <"+ae+"."+(+Ce+1)+".0":">="+ae+"."+Ce+".0 <"+(+ae+1)+".0.0":Ue?(f("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ze=ae==="0"?Ce==="0"?">="+ae+"."+Ce+"."+qe+Ue+" <"+ae+"."+Ce+"."+(+qe+1):">="+ae+"."+Ce+"."+qe+Ue+" <"+ae+"."+(+Ce+1)+".0":">="+ae+"."+Ce+"."+qe+Ue+" <"+(+ae+1)+".0.0"):(f("no pr"),Ze=ae==="0"?Ce==="0"?">="+ae+"."+Ce+"."+qe+" <"+ae+"."+Ce+"."+(+qe+1):">="+ae+"."+Ce+"."+qe+" <"+ae+"."+(+Ce+1)+".0":">="+ae+"."+Ce+"."+qe+" <"+(+ae+1)+".0.0"),f("caret return",Ze),Ze})}(Oe,Ae)}).join(" ")}(Qe,it),f("caret",Qe),Qe=function(et,Ae){return et.trim().split(/\s+/).map(function(Oe){return function(Ve,Le){var Xe=Le?$[M]:$[N];return Ve.replace(Xe,function(ce,ae,Ce,qe,Ue){var Ze;return f("tilde",Ve,ce,ae,Ce,qe,Ue),Ie(ae)?Ze="":Ie(Ce)?Ze=">="+ae+".0.0 <"+(+ae+1)+".0.0":Ie(qe)?Ze=">="+ae+"."+Ce+".0 <"+ae+"."+(+Ce+1)+".0":Ue?(f("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ze=">="+ae+"."+Ce+"."+qe+Ue+" <"+ae+"."+(+Ce+1)+".0"):Ze=">="+ae+"."+Ce+"."+qe+" <"+ae+"."+(+Ce+1)+".0",f("tilde return",Ze),Ze})}(Oe,Ae)}).join(" ")}(Qe,it),f("tildes",Qe),Qe=function(et,Ae){return f("replaceXRanges",et,Ae),et.split(/\s+/).map(function(Oe){return function(Ve,Le){Ve=Ve.trim();var Xe=Le?$[u]:$[g];return Ve.replace(Xe,function(ce,ae,Ce,qe,Ue,Ze){f("xRange",Ve,ce,ae,Ce,qe,Ue,Ze);var rt=Ie(Ce),at=rt||Ie(qe),bt=at||Ie(Ue);return ae==="="&&bt&&(ae=""),rt?ce=ae===">"||ae==="<"?"<0.0.0":"*":ae&&bt?(at&&(qe=0),bt&&(Ue=0),ae===">"?(ae=">=",at?(Ce=+Ce+1,qe=0,Ue=0):bt&&(qe=+qe+1,Ue=0)):ae==="<="&&(ae="<",at?Ce=+Ce+1:qe=+qe+1),ce=ae+Ce+"."+qe+"."+Ue):at?ce=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":bt&&(ce=">="+Ce+"."+qe+".0 <"+Ce+"."+(+qe+1)+".0"),f("xRange return",ce),ce})}(Oe,Ae)}).join(" ")}(Qe,it),f("xrange",Qe),Qe=function(et,Ae){return f("replaceStars",et,Ae),et.trim().replace($[x],"")}(Qe,it),f("stars",Qe),Qe}(_e,de)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(je)})),We=We.map(function(_e){return new ee(_e,de)})},be.prototype.intersects=function(Q,de){if(!(Q instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return Q.set.some(function(We){return We.every(function(_e){return je.intersects(_e,de)})})})})},e.toComparators=function(Q,de){return new be(Q,de).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new ve(Q,this.loose));for(var de=0;de<this.set.length;de++)if(Y(this.set[de],Q))return!0;return!1},e.satisfies=ie,e.maxSatisfying=function(Q,de,ye){var je=null,We=null;try{var _e=new be(de,ye)}catch{return null}return Q.forEach(function(Qe){_e.test(Qe)&&(je&&We.compare(Qe)!==-1||(We=new ve(je=Qe,ye)))}),je},e.minSatisfying=function(Q,de,ye){var je=null,We=null;try{var _e=new be(de,ye)}catch{return null}return Q.forEach(function(Qe){_e.test(Qe)&&(je&&We.compare(Qe)!==1||(We=new ve(je=Qe,ye)))}),je},e.validRange=function(Q,de){try{return new be(Q,de).range||"*"}catch{return null}},e.ltr=function(Q,de,ye){return re(Q,de,"<",ye)},e.gtr=function(Q,de,ye){return re(Q,de,">",ye)},e.outside=re,e.prerelease=function(Q,de){var ye=ue(Q,de);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(Q,de,ye){return Q=new be(Q,ye),de=new be(de,ye),Q.intersects(de)},e.coerce=function(Q){if(Q instanceof ve)return Q;if(typeof Q!="string")return null;var de=Q.match($[m]);return de==null?null:ue((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,C(1))},function($e,e){var C,F,f=$e.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(o){if(C===setTimeout)return setTimeout(o,0);if((C===L||!C)&&setTimeout)return C=setTimeout,setTimeout(o,0);try{return C(o,0)}catch{try{return C.call(null,o,0)}catch{return C.call(this,o,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:L}catch{C=L}try{F=typeof clearTimeout=="function"?clearTimeout:R}catch{F=R}})();var E,p=[],A=!1,I=-1;function w(){A&&E&&(A=!1,E.length?p=E.concat(p):I=-1,p.length&&k())}function k(){if(!A){var o=$(w);A=!0;for(var s=p.length;s;){for(E=p,p=[];++I<s;)E&&E[I].run();I=-1,s=p.length}E=null,A=!1,function(n){if(F===clearTimeout)return clearTimeout(n);if((F===R||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(n);try{F(n)}catch{try{return F.call(null,n)}catch{return F.call(this,n)}}}(o)}}function D(o,s){this.fun=o,this.array=s}function v(){}f.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)s[n-1]=arguments[n];p.push(new D(o,s)),p.length!==1||A||$(k)},D.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=v,f.addListener=v,f.once=v,f.off=v,f.removeListener=v,f.removeAllListeners=v,f.emit=v,f.prependListener=v,f.prependOnceListener=v,f.listeners=function(o){return[]},f.binding=function(o){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(o){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(Se[37],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(L){return new F(L)}constructor(L){this.c=C&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$bd=F}),define(Se[4],De([1,0,8,75,3,76,37]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.Event=void 0;const $=!1,E=!1;var p;(function(g){g.None=()=>f.$kc.None;function u(he){if(E){const{onDidAddListener:ee}=he,le=D.create();let be=0;he.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),ee?.()}}}function m(he,ee){return me(he,()=>{},0,void 0,!0,void 0,ee)}g.defer=m;function P(he){return(ee,le=null,be)=>{let Ie=!1,B;return B=he(Y=>{if(!Ie)return B?B.dispose():Ie=!0,ee.call(le,Y)},null,be),Ie&&B.dispose(),B}}g.once=P;function O(he,ee,le){return H((be,Ie=null,B)=>he(Y=>be.call(Ie,ee(Y)),null,B),le)}g.map=O;function N(he,ee,le){return H((be,Ie=null,B)=>he(Y=>{ee(Y),be.call(Ie,Y)},null,B),le)}g.forEach=N;function M(he,ee,le){return H((be,Ie=null,B)=>he(Y=>ee(Y)&&be.call(Ie,Y),null,B),le)}g.filter=M;function j(he){return he}g.signal=j;function z(...he){return(ee,le=null,be)=>{const Ie=(0,f.$hc)(...he.map(B=>B(Y=>ee.call(le,Y))));return q(Ie,be)}}g.any=z;function T(he,ee,le,be){let Ie=le;return O(he,B=>(Ie=ee(Ie,B),Ie),be)}g.reduce=T;function H(he,ee){let le;const be={onWillAddFirstListener(){le=he(Ie.fire,Ie)},onDidRemoveLastListener(){le?.dispose()}};ee||u(be);const Ie=new l(be);return ee?.add(Ie),Ie.event}function q(he,ee){return ee instanceof Array?ee.push(he):ee&&ee.add(he),he}function me(he,ee,le=100,be=!1,Ie=!1,B,Y){let ie,re,Q,de=0,ye;const je={leakWarningThreshold:B,onWillAddFirstListener(){ie=he(_e=>{de++,re=ee(re,_e),be&&!Q&&(We.fire(re),re=void 0),ye=()=>{const Qe=re;re=void 0,Q=void 0,(!be||de>1)&&We.fire(Qe),de=0},typeof le=="number"?(clearTimeout(Q),Q=setTimeout(ye,le)):Q===void 0&&(Q=0,queueMicrotask(ye))})},onWillRemoveListener(){Ie&&de>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,ie.dispose()}};Y||u(je);const We=new l(je);return Y?.add(We),We.event}g.debounce=me;function Z(he,ee=0,le){return g.debounce(he,(be,Ie)=>be?(be.push(Ie),be):[Ie],ee,void 0,!0,void 0,le)}g.accumulate=Z;function X(he,ee=(be,Ie)=>be===Ie,le){let be=!0,Ie;return M(he,B=>{const Y=be||!ee(B,Ie);return be=!1,Ie=B,Y},le)}g.latch=X;function V(he,ee,le){return[g.filter(he,ee,le),g.filter(he,be=>!ee(be),le)]}g.split=V;function x(he,ee=!1,le=[],be){let Ie=le.slice(),B=he(re=>{Ie?Ie.push(re):ie.fire(re)});be&&be.add(B);const Y=()=>{Ie?.forEach(re=>ie.fire(re)),Ie=null},ie=new l({onWillAddFirstListener(){B||(B=he(re=>ie.fire(re)),be&&be.add(B))},onDidAddFirstListener(){Ie&&(ee?setTimeout(Y):Y())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return be&&be.add(ie),ie.event}g.buffer=x;function ge(he,ee){return(be,Ie,B)=>{const Y=ee(new ve);return he(function(ie){const re=Y.evaluate(ie);re!==ue&&be.call(Ie,re)},void 0,B)}}g.chain=ge;const ue=Symbol("HaltChainable");class ve{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(le=>(ee(le),le)),this}filter(ee){return this.f.push(le=>ee(le)?le:ue),this}reduce(ee,le){let be=le;return this.f.push(Ie=>(be=ee(be,Ie),be)),this}latch(ee=(le,be)=>le===be){let le=!0,be;return this.f.push(Ie=>{const B=le||!ee(Ie,be);return le=!1,be=Ie,B?Ie:ue}),this}evaluate(ee){for(const le of this.f)if(ee=le(ee),ee===ue)break;return ee}}function G(he,ee,le=be=>be){const be=(...ie)=>Y.fire(le(...ie)),Ie=()=>he.on(ee,be),B=()=>he.removeListener(ee,be),Y=new l({onWillAddFirstListener:Ie,onDidRemoveLastListener:B});return Y.event}g.fromNodeEventEmitter=G;function U(he,ee,le=be=>be){const be=(...ie)=>Y.fire(le(...ie)),Ie=()=>he.addEventListener(ee,be),B=()=>he.removeEventListener(ee,be),Y=new l({onWillAddFirstListener:Ie,onDidRemoveLastListener:B});return Y.event}g.fromDOMEventEmitter=U;function K(he){return new Promise(ee=>P(he)(ee))}g.toPromise=K;function fe(he){const ee=new l;return he.then(le=>{ee.fire(le)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}g.fromPromise=fe;function te(he,ee){return ee(void 0),he(le=>ee(le))}g.runAndSubscribe=te;function se(he,ee){let le=null;function be(B){le?.dispose(),le=new f.$jc,ee(B,le)}be(void 0);const Ie=he(B=>be(B));return(0,f.$ic)(()=>{Ie.dispose(),le?.dispose()})}g.runAndSubscribeWithStore=se;class ne{constructor(ee,le){this._observable=ee,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};le||u(be),this.emitter=new l(be),le&&le.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,le){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(he,ee){return new ne(he,ee).emitter.event}g.fromObservable=Ee;function oe(he){return ee=>{let le=0,be=!1;const Ie={beginUpdate(){le++},endUpdate(){le--,le===0&&(he.reportChanges(),be&&(be=!1,ee()))},handlePossibleChange(){},handleChange(){be=!0}};return he.addObserver(Ie),he.reportChanges(),{dispose(){he.removeObserver(Ie)}}}}g.fromObservableLight=oe})(p||(e.Event=p={}));class A{static{this.all=new Set}static{this.f=0}constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${A.f++}`,A.all.add(this)}start(u){this.g=new R.$bd,this.listenerCount=u}stop(){if(this.g){const u=this.g.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.g=void 0}}}e.$dd=A;let I=-1;function w(g){const u=I;return I=g,{dispose(){I=u}}}e.$ed=w;class k{constructor(u,m=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=m,this.g=0}dispose(){this.f?.clear()}check(u,m){const P=this.threshold;if(P<=0||m<P)return;this.f||(this.f=new Map);const O=this.f.get(u.value)||0;if(this.f.set(u.value,O+1),this.g-=1,this.g<=0){this.g=P*.5;let N,M=0;for(const[j,z]of this.f)(!N||M<z)&&(N=j,M=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${M}):`),console.warn(N)}return()=>{const N=this.f.get(u.value)||0;this.f.set(u.value,N-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class o{constructor(u){this.value=u,this.id=v++}}const s=2,n=(g,u)=>{if(g instanceof o)u(g);else for(let m=0;m<g.length;m++){const P=g[m];P&&u(P)}};class l{constructor(u){this.x=0,this.f=u,this.g=I>0||this.f?.leakWarningThreshold?new k(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const u=this.t;queueMicrotask(()=>{n(u,m=>m.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(u,m,P)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$kc.None;if(this.m)return f.$kc.None;m&&(u=u.bind(m));const O=new o(u);let N,M;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(O.stack=D.create(),N=this.g.check(O.stack,this.x+1)),$&&(O.stack=M??D.create()),this.t?this.t instanceof o?(this.u??=new h,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.x++;const j=(0,f.$ic)(()=>{N?.(),this.y(O)});return P instanceof f.$jc?P.add(j):Array.isArray(P)&&P.push(j),j},this.q}y(u){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const m=this.t,P=m.indexOf(u);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,m[P]=void 0;const O=this.u.current===this;if(this.x*s<=m.length){let N=0;for(let M=0;M<m.length;M++)m[M]?m[N++]=m[M]:O&&(this.u.end--,N<this.u.i&&this.u.i--);m.length=N}}z(u,m){if(!u)return;const P=this.f?.onListenerError||C.$Y;if(!P){u.value(m);return}try{u.value(m)}catch(O){P(O)}}A(u){const m=u.current.t;for(;u.i<u.end;)this.z(m[u.i++],u.value);u.reset()}fire(u){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof o)this.z(this.t,u);else{const m=this.u;m.enqueue(this,u,this.t.length),this.A(m)}this.j?.stop()}hasListeners(){return this.x>0}}e.$fd=l;const b=()=>new h;e.$gd=b;class h{constructor(){this.i=-1,this.end=0}enqueue(u,m,P){this.i=0,this.end=P,this.current=u,this.value=m}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends l{async fireAsync(u,m,P){if(this.t)for(this.h||(this.h=new L.$tc),n(this.t,O=>this.h.push([O.value,u]));this.h.size>0&&!m.isCancellationRequested;){const[O,N]=this.h.shift(),M=[],j={...N,token:m,waitUntil:z=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");P&&(z=P(z,O)),M.push(z)}};try{O(j)}catch(z){(0,C.$Y)(z);continue}Object.freeze(M),await Promise.allSettled(M).then(z=>{for(const T of z)T.status==="rejected"&&(0,C.$Y)(T.reason)})}}}e.$hd=t;class r extends l{get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new L.$tc,this.w=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.w(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.x&&(this.h!==0?this.s.push(u):super.fire(u))}}e.$id=r;class a extends r{constructor(u){super(u),this.k=u.delay??100}fire(u){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(u)}}e.$jd=a;class i extends l{constructor(u){super(u),this.h=[],this.k=u?.merge}fire(u){this.hasListeners()&&(this.h.push(u),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(m=>super.fire(m)),this.h=[]}))}}e.$kd=i;class c{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(u){const m={event:u,listener:null};this.h.push(m),this.g&&this.m(m);const P=()=>{this.g&&this.o(m);const O=this.h.indexOf(m);this.h.splice(O,1)};return(0,f.$ic)((0,F.$bb)(P))}j(){this.g=!0,this.h.forEach(u=>this.m(u))}k(){this.g=!1,this.h.forEach(u=>this.o(u))}m(u){u.listener=u.event(m=>this.f.fire(m))}o(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.f.dispose()}}e.$ld=c;class d{constructor(u,m,P,O){this.f=new f.$jc;const N=this.f.add(new c),M=this.f.add(new f.$sc);function j(z){M.set(z,N.add(O(z)))}for(const z of u)j(z);this.f.add(m(z=>{j(z)})),this.f.add(P(z=>{M.deleteAndDispose(z)})),this.event=N.event}dispose(){this.f.dispose()}}e.$md=d;class y{constructor(){this.f=[]}wrapEvent(u){return(m,P,O)=>u(N=>{const M=this.f[this.f.length-1];M?M.push(()=>m.call(P,N)):m.call(P,N)},void 0,O)}bufferEvents(u){const m=[];this.f.push(m);const P=u();return this.f.pop(),m.forEach(O=>O()),P}}e.$nd=y;class S{constructor(){this.f=!1,this.g=p.None,this.h=f.$kc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(u){this.g=u,this.f&&(this.h.dispose(),this.h=u(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$od=S}),define(Se[21],De([1,0,4]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pd=e.CancellationToken=void 0;const F=Object.freeze(function($,E){const p=setTimeout($.bind(E),0);return{dispose(){clearTimeout(p)}}});var f;(function($){function E(p){return p===$.None||p===$.Cancelled||p instanceof L?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}$.isCancellationToken=E,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(f||(e.CancellationToken=f={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new C.$fd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=f.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=f.None}}e.$pd=R}),define(Se[159],De([1,0,21]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=void 0;class F{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new C.$pd,E=this.b($.token);return this.a={promise:E,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$he=F;class f{constructor($){this.c=$,this.a=void 0,this.b=void 0}get($){const E=JSON.stringify($);return this.b!==E&&(this.b=E,this.a=this.c($)),this.a}}e.$ie=f;class L{get cachedValues(){return this.a}constructor($){this.b=$,this.a=new Map}get($){if(this.a.has($))return this.a.get($);const E=this.b($);return this.a.set($,E),E}}e.$je=L}),define(Se[97],De([1,0,8,3]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function f(b){const h=b;return h?typeof h.read=="function":!1}e.$qd=f;function L(b){const h=b;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$rd=L;function R(b){const h=b;return h?L(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$sd=R;function $(b,h){return new E(b,h)}e.$td=$;class E{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,C.$Y)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let r;switch(h){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const a=r.indexOf(t);a>=0&&r.splice(a,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function p(b,h){const t=[];let r;for(;(r=b.read())!==null;)t.push(r);return h(t)}e.$ud=p;function A(b,h,t){const r=[];let a;for(;(a=b.read())!==null&&r.length<t;)r.push(a);return a===null&&r.length>0?h(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a<"u"){const i=a;return a=void 0,i}return b.read()}}}e.$vd=A;function I(b,h){return new Promise((t,r)=>{const a=[];w(b,{onData:i=>{h&&a.push(i)},onError:i=>{h?r(i):t(void 0)},onEnd:()=>{t(h?h(a):void 0)}})})}e.$wd=I;function w(b,h,t){b.on("error",r=>{t?.isCancellationRequested||h.onError(r)}),b.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),b.on("data",r=>{t?.isCancellationRequested||h.onData(r)})}e.$xd=w;function k(b,h){return new Promise((t,r)=>{const a=new F.$jc,i=[],c=S=>{if(i.push(S),i.length>h)return a.dispose(),b.pause(),t({stream:b,buffer:i,ended:!1})},d=S=>(a.dispose(),r(S)),y=()=>(a.dispose(),t({stream:b,buffer:i,ended:!0}));a.add((0,F.$ic)(()=>b.removeListener("error",d))),b.on("error",d),a.add((0,F.$ic)(()=>b.removeListener("end",y))),b.on("end",y),a.add((0,F.$ic)(()=>b.removeListener("data",c))),b.on("data",c)})}e.$yd=k;function D(b,h){const t=$(h);return t.end(b),t}e.$zd=D;function v(){const b=$(()=>{throw new Error("not supported")});return b.end(),b}e.$Ad=v;function o(b){let h=!1;return{read:()=>h?null:(h=!0,b)}}e.$Bd=o;function s(b,h,t){const r=$(t);return w(b,{onData:a=>r.write(h.data(a)),onError:a=>r.error(h.error?h.error(a):a),onEnd:()=>r.end()}),r}e.$Cd=s;function n(b,h,t){let r=!1;return{read:()=>{const a=h.read();return r?a:(r=!0,a!==null?t([b,a]):b)}}}e.$Dd=n;function l(b,h,t){let r=!1;const a=$(t);return w(h,{onData:i=>r?a.write(i):(r=!0,a.write(t([b,i]))),onError:i=>a.error(i),onEnd:()=>{r||(r=!0,a.write(b)),a.end()}}),a}e.$Ed=l}),define(Se[22],De([1,0,59,97]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const f=typeof Buffer<"u",L=new C.$T(()=>new Uint8Array(256));let R,$;class E{static alloc(m){return f?new E(Buffer.allocUnsafe(m)):new E(new Uint8Array(m))}static wrap(m){return f&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new E(m)}static fromString(m,P){return!(P?.dontUseNodeBuffer||!1)&&f?new E(Buffer.from(m)):(R||(R=new TextEncoder),new E(R.encode(m)))}static fromByteArray(m){const P=E.alloc(m.length);for(let O=0,N=m.length;O<N;O++)P.buffer[O]=m[O];return P}static concat(m,P){if(typeof P>"u"){P=0;for(let M=0,j=m.length;M<j;M++)P+=m[M].byteLength}const O=E.alloc(P);let N=0;for(let M=0,j=m.length;M<j;M++){const z=m[M];O.set(z,N),N+=z.byteLength}return O}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=E.alloc(this.byteLength);return m.set(this),m}toString(){return f?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(m,P){return new E(this.buffer.subarray(m,P))}set(m,P){if(m instanceof E)this.buffer.set(m.buffer,P);else if(m instanceof Uint8Array)this.buffer.set(m,P);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),P);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return w(this.buffer,m)}writeUInt32BE(m,P){k(this.buffer,m,P)}readUInt32LE(m){return D(this.buffer,m)}writeUInt32LE(m,P){v(this.buffer,m,P)}readUInt8(m){return o(this.buffer,m)}writeUInt8(m,P){s(this.buffer,m,P)}indexOf(m,P=0){return p(this.buffer,m instanceof E?m.buffer:m,P)}}e.$Fd=E;function p(u,m,P=0){const O=m.byteLength,N=u.byteLength;if(O===0)return 0;if(O===1)return u.indexOf(m[0]);if(O>N-P)return-1;const M=L.value;M.fill(m.length);for(let H=0;H<m.length;H++)M[m[H]]=m.length-H-1;let j=P+m.length-1,z=j,T=-1;for(;j<N;)if(u[j]===m[z]){if(z===0){T=j;break}j--,z--}else j+=Math.max(m.length-z,M[u[j]]),z=m.length-1;return T}e.$Gd=p;function A(u,m){return u[m+0]<<0>>>0|u[m+1]<<8>>>0}e.$Hd=A;function I(u,m,P){u[P+0]=m&255,m=m>>>8,u[P+1]=m&255}e.$Id=I;function w(u,m){return u[m]*2**24+u[m+1]*2**16+u[m+2]*2**8+u[m+3]}e.$Jd=w;function k(u,m,P){u[P+3]=m,m=m>>>8,u[P+2]=m,m=m>>>8,u[P+1]=m,m=m>>>8,u[P]=m}e.$Kd=k;function D(u,m){return u[m+0]<<0>>>0|u[m+1]<<8>>>0|u[m+2]<<16>>>0|u[m+3]<<24>>>0}e.$Ld=D;function v(u,m,P){u[P+0]=m&255,m=m>>>8,u[P+1]=m&255,m=m>>>8,u[P+2]=m&255,m=m>>>8,u[P+3]=m&255}e.$Md=v;function o(u,m){return u[m]}e.$Nd=o;function s(u,m,P){u[P]=m}e.$Od=s;function n(u){return F.$ud(u,m=>E.concat(m))}e.$Pd=n;function l(u){return F.$Bd(u)}e.$Qd=l;function b(u){return F.$wd(u,m=>E.concat(m))}e.$Rd=b;async function h(u){return u.ended?E.concat(u.buffer):E.concat([...u.buffer,await b(u.stream)])}e.$Sd=h;function t(u){return F.$zd(u,m=>E.concat(m))}e.$Td=t;function r(u){return F.$Cd(u,{data:m=>typeof m=="string"?E.fromString(m):E.wrap(m)},m=>E.concat(m))}e.$Ud=r;function a(u){return F.$td(m=>E.concat(m),u)}e.$Vd=a;function i(u,m){return F.$Dd(u,m,P=>E.concat(P))}e.$Wd=i;function c(u,m){return F.$Ed(u,m,P=>E.concat(P))}e.$Xd=c;function d(u){let m=0,P=0,O=0;const N=new Uint8Array(Math.floor(u.length/4*3)),M=z=>{switch(P){case 3:N[O++]=m|z,P=0;break;case 2:N[O++]=m|z>>>2,m=z<<6,P=3;break;case 1:N[O++]=m|z>>>4,m=z<<4,P=2;break;default:m=z<<2,P=1}};for(let z=0;z<u.length;z++){const T=u.charCodeAt(z);if(T>=65&&T<=90)M(T-65);else if(T>=97&&T<=122)M(T-97+26);else if(T>=48&&T<=57)M(T-48+52);else if(T===43||T===45)M(62);else if(T===47||T===95)M(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${u[z]}`)}}const j=O;for(;P>0;)M(0);return E.wrap(N).slice(0,j)}e.$Yd=d;const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:u},m=!0,P=!1){const O=P?S:y;let N="";const M=u.byteLength%3;let j=0;for(;j<u.byteLength-M;j+=3){const z=u[j+0],T=u[j+1],H=u[j+2];N+=O[z>>>2],N+=O[(z<<4|T>>>4)&63],N+=O[(T<<2|H>>>6)&63],N+=O[H&63]}if(M===1){const z=u[j+0];N+=O[z>>>2],N+=O[z<<4&63],m&&(N+="==")}else if(M===2){const z=u[j+0],T=u[j+1];N+=O[z>>>2],N+=O[(z<<4|T>>>4)&63],N+=O[T<<2&63],m&&(N+="=")}return N}e.$Zd=g}),define(Se[15],De([1,0,159,59]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$if=e.$hf=e.$gf=e.$ff=e.GraphemeBreakType=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=void 0;function f(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$me=f;const L=/{(\d+)}/g;function R(Ae,...Oe){return Oe.length===0?Ae:Ae.replace(L,function(Ve,Le){const Xe=parseInt(Le,10);return isNaN(Xe)||Xe<0||Xe>=Oe.length?Ve:Oe[Xe]})}e.$ne=R;const $=/{([^}]+)}/g;function E(Ae,Oe){return Ae.replace($,(Ve,Le)=>Oe[Le]??Ve)}e.$oe=E;function p(Ae){return Ae.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.$pe=p;function A(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$qe=A;function I(Ae,Oe){let Ve=0;const Le=Oe.charCodeAt(0);for(let Xe=Ae.length-1;Xe>=0;Xe--)Ae.charCodeAt(Xe)===Le&&Ve++;return Ve}e.$re=I;function w(Ae,Oe,Ve="\u2026"){return Ae.length<=Oe?Ae:`${Ae.substr(0,Oe)}${Ve}`}e.$se=w;function k(Ae,Oe=" "){const Ve=D(Ae,Oe);return v(Ve,Oe)}e.$te=k;function D(Ae,Oe){if(!Ae||!Oe)return Ae;const Ve=Oe.length;if(Ve===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Oe,Le)===Le;)Le=Le+Ve;return Ae.substring(Le)}e.$ue=D;function v(Ae,Oe){if(!Ae||!Oe)return Ae;const Ve=Oe.length,Le=Ae.length;if(Ve===0||Le===0)return Ae;let Xe=Le,ce=-1;for(;ce=Ae.lastIndexOf(Oe,Xe-1),!(ce===-1||ce+Ve!==Xe);){if(ce===0)return"";Xe=ce}return Ae.substring(0,Xe)}e.$ve=v;function o(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$we=o;function s(Ae){return Ae.replace(/\*/g,"")}e.$xe=s;function n(Ae,Oe,Ve={}){if(!Ae)throw new Error("Cannot create regex from empty string");Oe||(Ae=A(Ae)),Ve.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return Ve.global&&(Le+="g"),Ve.matchCase||(Le+="i"),Ve.multiline&&(Le+="m"),Ve.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$ye=n;function l(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$ze=l;function b(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Ae=b;function h(Ae){for(let Oe=0,Ve=Ae.length;Oe<Ve;Oe++){const Le=Ae.charCodeAt(Oe);if(Le!==32&&Le!==9)return Oe}return-1}e.$Be=h;function t(Ae,Oe=0,Ve=Ae.length){for(let Le=Oe;Le<Ve;Le++){const Xe=Ae.charCodeAt(Le);if(Xe!==32&&Xe!==9)return Ae.substring(Oe,Le)}return Ae.substring(Oe,Ve)}e.$Ce=t;function r(Ae,Oe=Ae.length-1){for(let Ve=Oe;Ve>=0;Ve--){const Le=Ae.charCodeAt(Ve);if(Le!==32&&Le!==9)return Ve}return-1}e.$De=r;function a(Ae,Oe,Ve){const Le=[];let Xe=0;for(const ce of Ae.matchAll(Oe)){if(Le.push(Ae.slice(Xe,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");Xe=ce.index+ce[0].length,Le.push(Ve(ce[0],...ce.slice(1),ce.index,Ae,ce.groups))}return Le.push(Ae.slice(Xe)),Promise.all(Le).then(ce=>ce.join(""))}e.$Ee=a;function i(Ae,Oe){return Ae<Oe?-1:Ae>Oe?1:0}e.$Fe=i;function c(Ae,Oe,Ve=0,Le=Ae.length,Xe=0,ce=Oe.length){for(;Ve<Le&&Xe<ce;Ve++,Xe++){const qe=Ae.charCodeAt(Ve),Ue=Oe.charCodeAt(Xe);if(qe<Ue)return-1;if(qe>Ue)return 1}const ae=Le-Ve,Ce=ce-Xe;return ae<Ce?-1:ae>Ce?1:0}e.$Ge=c;function d(Ae,Oe){return y(Ae,Oe,0,Ae.length,0,Oe.length)}e.$He=d;function y(Ae,Oe,Ve=0,Le=Ae.length,Xe=0,ce=Oe.length){for(;Ve<Le&&Xe<ce;Ve++,Xe++){let qe=Ae.charCodeAt(Ve),Ue=Oe.charCodeAt(Xe);if(qe===Ue)continue;if(qe>=128||Ue>=128)return c(Ae.toLowerCase(),Oe.toLowerCase(),Ve,Le,Xe,ce);g(qe)&&(qe-=32),g(Ue)&&(Ue-=32);const Ze=qe-Ue;if(Ze!==0)return Ze}const ae=Le-Ve,Ce=ce-Xe;return ae<Ce?-1:ae>Ce?1:0}e.$Ie=y;function S(Ae){return Ae>=48&&Ae<=57}e.$Je=S;function g(Ae){return Ae>=97&&Ae<=122}e.$Ke=g;function u(Ae){return Ae>=65&&Ae<=90}e.$Le=u;function m(Ae,Oe){return Ae.length===Oe.length&&y(Ae,Oe)===0}e.$Me=m;function P(Ae,Oe){const Ve=Oe.length;return Oe.length>Ae.length?!1:y(Ae,Oe,0,Ve)===0}e.$Ne=P;function O(Ae,Oe){const Ve=Math.min(Ae.length,Oe.length);let Le;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Le)!==Oe.charCodeAt(Le))return Le;return Ve}e.$Oe=O;function N(Ae,Oe){const Ve=Math.min(Ae.length,Oe.length);let Le;const Xe=Ae.length-1,ce=Oe.length-1;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Xe-Le)!==Oe.charCodeAt(ce-Le))return Le;return Ve}e.$Pe=N;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$Qe=M;function j(Ae){return 56320<=Ae&&Ae<=57343}e.$Re=j;function z(Ae,Oe){return(Ae-55296<<10)+(Oe-56320)+65536}e.$Se=z;function T(Ae,Oe,Ve){const Le=Ae.charCodeAt(Ve);if(M(Le)&&Ve+1<Oe){const Xe=Ae.charCodeAt(Ve+1);if(j(Xe))return z(Le,Xe)}return Le}e.$Te=T;function H(Ae,Oe){const Ve=Ae.charCodeAt(Oe-1);if(j(Ve)&&Oe>1){const Le=Ae.charCodeAt(Oe-2);if(M(Le))return z(Le,Ve)}return Ve}class q{get offset(){return this.e}constructor(Oe,Ve=0){this.c=Oe,this.d=Oe.length,this.e=Ve}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=H(this.c,this.e);return this.e-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=T(this.c,this.d,this.e);return this.e+=Oe>=65536?2:1,Oe}eol(){return this.e>=this.d}}e.$Ue=q;class me{get offset(){return this.c.offset}constructor(Oe,Ve=0){this.c=new q(Oe,Ve)}nextGraphemeLength(){const Oe=de.getInstance(),Ve=this.c,Le=Ve.offset;let Xe=Oe.getGraphemeBreakType(Ve.nextCodePoint());for(;!Ve.eol();){const ce=Ve.offset,ae=Oe.getGraphemeBreakType(Ve.nextCodePoint());if(re(Xe,ae)){Ve.setOffset(ce);break}Xe=ae}return Ve.offset-Le}prevGraphemeLength(){const Oe=de.getInstance(),Ve=this.c,Le=Ve.offset;let Xe=Oe.getGraphemeBreakType(Ve.prevCodePoint());for(;Ve.offset>0;){const ce=Ve.offset,ae=Oe.getGraphemeBreakType(Ve.prevCodePoint());if(re(ae,Xe)){Ve.setOffset(ce);break}Xe=ae}return Le-Ve.offset}eol(){return this.c.eol()}}e.$Ve=me;function Z(Ae,Oe){return new me(Ae,Oe).nextGraphemeLength()}e.$We=Z;function X(Ae,Oe){return new me(Ae,Oe).prevGraphemeLength()}e.$Xe=X;function V(Ae,Oe){Oe>0&&j(Ae.charCodeAt(Oe))&&Oe--;const Ve=Oe+Z(Ae,Oe);return[Ve-X(Ae,Ve),Ve]}e.$Ye=V;function x(Ae){const Oe=new me(Ae);let Ve=0;for(;!Oe.eol();)Ve++,Oe.nextGraphemeLength();return Ve}e.$Ze=x;let ge;function ue(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(Ae){return ge||(ge=ue()),ge.test(Ae)}e.$1e=ve;const G=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return G.test(Ae)}e.$2e=U,e.$3e=/[\u2028\u2029]/;function K(Ae){return e.$3e.test(Ae)}e.$4e=K;function fe(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$5e=fe;function te(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$6e=te;function se(Ae,Oe){if(Ae.length<Oe)return Ae;const Ve=/\b/g;let Le=0;for(;Ve.test(Ae)&&!(Ae.length-Ve.lastIndex<Oe);)Le=Ve.lastIndex,Ve.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$7e=se;const ne=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Ee=/\x1b\].*?\x07/g;function oe(Ae){return Ae&&(Ae=Ae.replace(ne,"").replace(Ee,"")),Ae}e.$8e=oe,e.$9e=String.fromCharCode(65279);function he(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$0e=he;function ee(Ae){return he(Ae)?Ae.substr(1):Ae}e.$$e=ee;function le(Ae,Oe){if(!Ae||!Oe||Ae.length<Oe.length)return!1;const Ve=Oe.length,Le=Ae.toLowerCase();let Xe=0,ce=-1;for(;Xe<Ve;){const ae=Le.indexOf(Oe[Xe],ce+1);if(ae<0)return!1;ce=ae,Xe++}return!0}e.$_e=le;function be(Ae,Oe=!1){return Ae?(Oe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$af=be;function Ie(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$bf=Ie;function B(Ae,Oe=1){if(Oe===0)return"";let Ve=-1;do Ve=Ae.indexOf(`
`,Ve+1),Oe--;while(Oe>0&&Ve>=0);return Ve===-1?Ae:(Ae[Ve-1]==="\r"&&Ve--,Ae.substr(0,Ve))}e.$cf=B;function Y(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$df=Y;function ie(Ae){return de.getInstance().getGraphemeBreakType(Ae)}e.$ef=ie;function re(Ae,Oe){return Ae===0?Oe!==5&&Oe!==7:Ae===2&&Oe===3?!1:Ae===4||Ae===2||Ae===3||Oe===4||Oe===2||Oe===3?!0:!(Ae===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Ae===11||Ae===9)&&(Oe===9||Oe===10)||(Ae===12||Ae===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Ae===1||Ae===13&&Oe===14||Ae===6&&Oe===6)}var Q;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Q||(e.GraphemeBreakType=Q={}));class de{static{this.c=null}static getInstance(){return de.c||(de.c=new de),de.c}constructor(){this.d=ye()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const Ve=this.d,Le=Ve.length/3;let Xe=1;for(;Xe<=Le;)if(Oe<Ve[3*Xe])Xe=2*Xe;else if(Oe>Ve[3*Xe+1])Xe=2*Xe+1;else return Ve[3*Xe+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Oe){if(Ae===0)return 0;const Ve=We(Ae,Oe);if(Ve!==void 0)return Ve;const Le=new q(Oe,Ae);return Le.prevCodePoint(),Le.offset}e.$ff=je;function We(Ae,Oe){const Ve=new q(Oe,Ae);let Le=Ve.prevCodePoint();for(;_e(Le)||Le===65039||Le===8419;){if(Ve.offset===0)return;Le=Ve.prevCodePoint()}if(!te(Le))return;let Xe=Ve.offset;return Xe>0&&Ve.prevCodePoint()===8205&&(Xe=Ve.offset),Xe}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Qe;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.$gf="\xA0";class it{static{this.c=new F.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$ie(Oe=>{function Ve(Ze){const rt=new Map;for(let at=0;at<Ze.length;at+=2)rt.set(Ze[at],Ze[at+1]);return rt}function Le(Ze,rt){const at=new Map(Ze);for(const[bt,St]of rt)at.set(bt,St);return at}function Xe(Ze,rt){if(!Ze)return rt;const at=new Map;for(const[bt,St]of Ze)rt.has(bt)&&at.set(bt,St);return at}const ce=this.c.value;let ae=Oe.filter(Ze=>!Ze.startsWith("_")&&Ze in ce);ae.length===0&&(ae=["_default"]);let Ce;for(const Ze of ae){const rt=Ve(ce[Ze]);Ce=Xe(Ce,rt)}const qe=Ve(ce._common),Ue=Le(qe,Ce);return new it(Ue)})}static getInstance(Oe){return it.d.get(Array.from(Oe))}static{this.e=new F.$T(()=>Object.keys(it.c.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return it.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hf=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Oe){return et.e().has(Oe)}static get codePoints(){return et.e()}}e.$if=et}),define(Se[121],De([1,0,28,15]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.FuzzyScore=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.or=void 0;function f(...ee){return function(le,be){for(let Ie=0,B=ee.length;Ie<B;Ie++){const Y=ee[Ie](le,be);if(Y)return Y}return null}}e.or=f,e.$xj=L.bind(void 0,!1),e.$yj=L.bind(void 0,!0);function L(ee,le,be){if(!be||be.length<le.length)return null;let Ie;return ee?Ie=F.$Ne(be,le):Ie=be.indexOf(le)===0,Ie?le.length>0?[{start:0,end:le.length}]:[]:null}function R(ee,le){const be=le.toLowerCase().indexOf(ee.toLowerCase());return be===-1?null:[{start:be,end:be+ee.length}]}e.$zj=R;function $(ee,le){return E(ee.toLowerCase(),le.toLowerCase(),0,0)}e.$Aj=$;function E(ee,le,be,Ie){if(be===ee.length)return[];if(Ie===le.length)return null;if(ee[be]===le[Ie]){let B=null;return(B=E(ee,le,be+1,Ie+1))?s({start:Ie,end:Ie+1},B):null}return E(ee,le,be,Ie+1)}function p(ee){return 97<=ee&&ee<=122}function A(ee){return 65<=ee&&ee<=90}e.$Bj=A;function I(ee){return 48<=ee&&ee<=57}function w(ee){return ee===32||ee===9||ee===10||ee===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>k.add(ee.charCodeAt(0)));function D(ee){return w(ee)||k.has(ee)}function v(ee,le){return ee===le||D(ee)&&D(le)}function o(ee){return p(ee)||A(ee)||I(ee)}function s(ee,le){return le.length===0?le=[ee]:ee.end===le[0].start?le[0].start=ee.start:le.unshift(ee),le}function n(ee,le){for(let be=le;be<ee.length;be++){const Ie=ee.charCodeAt(be);if(A(Ie)||I(Ie)||be>0&&!o(ee.charCodeAt(be-1)))return be}return ee.length}function l(ee,le,be,Ie){if(be===ee.length)return[];if(Ie===le.length)return null;if(ee[be]!==le[Ie].toLowerCase())return null;{let B=null,Y=Ie+1;for(B=l(ee,le,be+1,Ie+1);!B&&(Y=n(le,Y))<le.length;)B=l(ee,le,be+1,Y),Y++;return B===null?null:s({start:Ie,end:Ie+1},B)}}function b(ee){let le=0,be=0,Ie=0,B=0,Y=0;for(let ye=0;ye<ee.length;ye++)Y=ee.charCodeAt(ye),A(Y)&&le++,p(Y)&&be++,o(Y)&&Ie++,I(Y)&&B++;const ie=le/ee.length,re=be/ee.length,Q=Ie/ee.length,de=B/ee.length;return{upperPercent:ie,lowerPercent:re,alphaPercent:Q,numericPercent:de}}function h(ee){const{upperPercent:le,lowerPercent:be}=ee;return be===0&&le>.6}function t(ee){const{upperPercent:le,lowerPercent:be,alphaPercent:Ie,numericPercent:B}=ee;return be>.2&&le<.8&&Ie>.6&&B<.2}function r(ee){let le=0,be=0,Ie=0,B=0;for(let Y=0;Y<ee.length;Y++)Ie=ee.charCodeAt(Y),A(Ie)&&le++,p(Ie)&&be++,w(Ie)&&B++;return(le===0||be===0)&&B===0?ee.length<=30:le<=5}function a(ee,le){if(!le||(le=le.trim(),le.length===0)||!r(ee)||le.length>60)return null;const be=b(le);if(!t(be)){if(!h(be))return null;le=le.toLowerCase()}let Ie=null,B=0;for(ee=ee.toLowerCase();B<le.length&&(Ie=l(ee,le,0,B))===null;)B=n(le,B+1);return Ie}e.$Cj=a;function i(ee,le,be=!1){if(!le||le.length===0)return null;let Ie=null,B=0;for(ee=ee.toLowerCase(),le=le.toLowerCase();B<le.length&&(Ie=c(ee,le,0,B,be))===null;)B=d(le,B+1);return Ie}e.$Dj=i;function c(ee,le,be,Ie,B){if(be===ee.length)return[];if(Ie===le.length)return null;if(v(ee.charCodeAt(be),le.charCodeAt(Ie))){let Y=null,ie=Ie+1;if(Y=c(ee,le,be+1,Ie+1,B),!B)for(;!Y&&(ie=d(le,ie))<le.length;)Y=c(ee,le,be+1,ie,B),ie++;return Y?ee.charCodeAt(be)!==le.charCodeAt(Ie)?Y:s({start:Ie,end:Ie+1},Y):null}else return null}function d(ee,le){for(let be=le;be<ee.length;be++)if(D(ee.charCodeAt(be))||be>0&&D(ee.charCodeAt(be-1)))return be;return ee.length}const y=f(e.$yj,a,R),S=f(e.$yj,a,$),g=new C.$Ci(1e4);function u(ee,le,be=!1){if(typeof ee!="string"||typeof le!="string")return null;let Ie=g.get(ee);Ie||(Ie=new RegExp(F.$we(ee),"i"),g.set(ee,Ie));const B=Ie.exec(le);return B?[{start:B.index,end:B.index+B[0].length}]:be?S(ee,le):y(ee,le)}e.$Ej=u;function m(ee,le){const be=fe(ee,ee.toLowerCase(),0,le,le.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?O(be):null}e.$Fj=m;function P(ee,le,be,Ie,B,Y){const ie=Math.min(13,ee.length);for(;be<ie;be++){const re=fe(ee,le,be,Ie,B,Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return re}return[0,Y]}e.$Gj=P;function O(ee){if(typeof ee>"u")return[];const le=[],be=ee[1];for(let Ie=ee.length-1;Ie>1;Ie--){const B=ee[Ie]+be,Y=le[le.length-1];Y&&Y.end===B?Y.end=B+1:le.push({start:B,end:B+1})}return le}e.$Hj=O;const N=128;function M(){const ee=[],le=[];for(let be=0;be<=N;be++)le[be]=0;for(let be=0;be<=N;be++)ee.push(le.slice(0));return ee}function j(ee){const le=[];for(let be=0;be<=ee;be++)le[be]=0;return le}const z=j(2*N),T=j(2*N),H=M(),q=M(),me=M(),Z=!1;function X(ee,le,be,Ie,B){function Y(re,Q,de=" "){for(;re.length<Q;)re=de+re;return re}let ie=` |   |${Ie.split("").map(re=>Y(re,3)).join("|")}
`;for(let re=0;re<=be;re++)re===0?ie+=" |":ie+=`${le[re-1]}|`,ie+=ee[re].slice(0,B+1).map(Q=>Y(Q.toString(),3)).join("|")+`
`;return ie}function V(ee,le,be,Ie){ee=ee.substr(le),be=be.substr(Ie),console.log(X(q,ee,ee.length,be,be.length)),console.log(X(me,ee,ee.length,be,be.length)),console.log(X(H,ee,ee.length,be,be.length))}function x(ee,le){if(le<0||le>=ee.length)return!1;const be=ee.codePointAt(le);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$6e(be)}}function ge(ee,le){if(le<0||le>=ee.length)return!1;switch(ee.charCodeAt(le)){case 32:case 9:return!0;default:return!1}}function ue(ee,le,be){return le[ee]!==be[ee]}function ve(ee,le,be,Ie,B,Y,ie=!1){for(;le<be&&B<Y;)ee[le]===Ie[B]&&(ie&&(z[le]=B),le+=1),B+=1;return le===be}e.$Ij=ve;var G;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(G||(G={}));var U;(function(ee){ee.Default=[-100,0];function le(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}ee.isDefault=le})(U||(e.FuzzyScore=U={}));class K{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(le,be){this.firstMatchCanBeWeak=le,this.boostFullMatch=be}}e.$Jj=K;function fe(ee,le,be,Ie,B,Y,ie=K.default){const re=ee.length>N?N:ee.length,Q=Ie.length>N?N:Ie.length;if(be>=re||Y>=Q||re-be>Q-Y||!ve(le,be,re,B,Y,Q,!0))return;te(re,Q,be,Y,le,B);let de=1,ye=1,je=be,We=Y;const _e=[!1];for(de=1,je=be;je<re;de++,je++){const Oe=z[je],Ve=T[je],Le=je+1<re?T[je+1]:Q;for(ye=Oe-Y+1,We=Oe;We<Le;ye++,We++){let Xe=Number.MIN_SAFE_INTEGER,ce=!1;We<=Ve&&(Xe=se(ee,le,je,be,Ie,B,We,Q,Y,H[de-1][ye-1]===0,_e));let ae=0;Xe!==Number.MAX_SAFE_INTEGER&&(ce=!0,ae=Xe+q[de-1][ye-1]);const Ce=We>Oe,qe=Ce?q[de][ye-1]+(H[de][ye-1]>0?-5:0):0,Ue=We>Oe+1&&H[de][ye-1]>0,Ze=Ue?q[de][ye-2]+(H[de][ye-2]>0?-5:0):0;if(Ue&&(!Ce||Ze>=qe)&&(!ce||Ze>=ae))q[de][ye]=Ze,me[de][ye]=3,H[de][ye]=0;else if(Ce&&(!ce||qe>=ae))q[de][ye]=qe,me[de][ye]=2,H[de][ye]=0;else if(ce)q[de][ye]=ae,me[de][ye]=1,H[de][ye]=H[de-1][ye-1]+1;else throw new Error("not possible")}}if(Z&&V(ee,be,Ie,Y),!_e[0]&&!ie.firstMatchCanBeWeak)return;de--,ye--;const Qe=[q[de][ye],Y];let it=0,et=0;for(;de>=1;){let Oe=ye;do{const Ve=me[de][Oe];if(Ve===3)Oe=Oe-2;else if(Ve===2)Oe=Oe-1;else break}while(Oe>=1);it>1&&le[be+de-1]===B[Y+ye-1]&&!ue(Oe+Y-1,Ie,B)&&it+1>H[de][Oe]&&(Oe=ye),Oe===ye?it++:it=1,et||(et=Oe),de--,ye=Oe-1,Qe.push(ye)}Q===re&&ie.boostFullMatch&&(Qe[0]+=2);const Ae=et-re;return Qe[0]-=Ae,Qe}e.$Kj=fe;function te(ee,le,be,Ie,B,Y){let ie=ee-1,re=le-1;for(;ie>=be&&re>=Ie;)B[ie]===Y[re]&&(T[ie]=re,ie--),re--}function se(ee,le,be,Ie,B,Y,ie,re,Q,de,ye){if(le[be]!==Y[ie])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return ie===be-Ie?je=ee[be]===B[ie]?7:5:ue(ie,B,Y)&&(ie===0||!ue(ie-1,B,Y))?(je=ee[be]===B[ie]?7:5,We=!0):x(Y,ie)&&(ie===0||!x(Y,ie-1))?je=5:(x(Y,ie-1)||ge(Y,ie-1))&&(je=5,We=!0),je>1&&be===Ie&&(ye[0]=!0),We||(We=ue(ie,B,Y)||x(Y,ie-1)||ge(Y,ie-1)),be===Ie?ie>Q&&(je-=We?3:5):de?je+=We?2:0:je+=We?0:1,ie+1===re&&(je-=We?3:5),je}function ne(ee,le,be,Ie,B,Y,ie){return oe(ee,le,be,Ie,B,Y,!0,ie)}e.$Lj=ne;function Ee(ee,le,be,Ie,B,Y,ie){return oe(ee,le,be,Ie,B,Y,!1,ie)}e.$Mj=Ee;function oe(ee,le,be,Ie,B,Y,ie,re){let Q=fe(ee,le,be,Ie,B,Y,re);if(Q&&!ie)return Q;if(ee.length>=3){const de=Math.min(7,ee.length-1);for(let ye=be+1;ye<de;ye++){const je=he(ee,ye);if(je){const We=fe(je,je.toLowerCase(),be,Ie,B,Y,re);We&&(We[0]-=3,(!Q||We[0]>Q[0])&&(Q=We))}}}return Q}function he(ee,le){if(le+1>=ee.length)return;const be=ee[le],Ie=ee[le+1];if(be!==Ie)return ee.slice(0,le)+Ie+be+ee.slice(le+2)}}),define(Se[51],De([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;function F(s){return f(s,0)}e.$pi=F;function f(s,n){switch(typeof s){case"object":return s===null?L(349,n):Array.isArray(s)?E(s,n):p(s,n);case"string":return $(s,n);case"boolean":return R(s,n);case"number":return L(s,n);case"undefined":return L(937,n);default:return L(617,n)}}e.$qi=f;function L(s,n){return(n<<5)-n+s|0}e.$ri=L;function R(s,n){return L(s?433:863,n)}function $(s,n){n=L(149417,n);for(let l=0,b=s.length;l<b;l++)n=L(s.charCodeAt(l),n);return n}e.$si=$;function E(s,n){return n=L(104579,n),s.reduce((l,b)=>f(b,l),n)}function p(s,n){return n=L(181387,n),Object.keys(s).sort().reduce((l,b)=>(l=$(b,l),f(s[b],l)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=f(n,this.g),this.g}}e.$ti=A;var I;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function w(s,n,l=32){const b=l-n,h=~((1<<b)-1);return(s<<n|(h&s)>>>b)>>>0}function k(s,n=0,l=s.byteLength,b=0){for(let h=0;h<l;h++)s[n+h]=b}function D(s,n,l="0"){for(;s.length<n;)s=l+s;return s}function v(s,n=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(l=>l.toString(16).padStart(2,"0")).join(""):D((s>>>0).toString(16),n/4)}e.$ui=v;class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const l=n.length;if(l===0)return;const b=this.p;let h=this.r,t=this.u,r,a;for(t!==0?(r=t,a=-1,t=0):(r=n.charCodeAt(0),a=0);;){let i=r;if(C.$Qe(r))if(a+1<l){const c=n.charCodeAt(a+1);C.$Re(c)?(a++,i=C.$Se(r,c)):i=65533}else{t=r;break}else C.$Re(r)&&(i=65533);if(h=this.w(b,h,i),a++,a<l)r=n.charCodeAt(a);else break}this.r=h,this.u=t}w(n,l,b){return b<128?n[l++]=b:b<2048?(n[l++]=192|(b&1984)>>>6,n[l++]=128|(b&63)>>>0):b<65536?(n[l++]=224|(b&61440)>>>12,n[l++]=128|(b&4032)>>>6,n[l++]=128|(b&63)>>>0):(n[l++]=240|(b&1835008)>>>18,n[l++]=128|(b&258048)>>>12,n[l++]=128|(b&4032)>>>6,n[l++]=128|(b&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=o.g,l=this.q;for(let y=0;y<64;y+=4)n.setUint32(y,l.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)n.setUint32(y,w(n.getUint32(y-12,!1)^n.getUint32(y-32,!1)^n.getUint32(y-56,!1)^n.getUint32(y-64,!1),1),!1);let b=this.h,h=this.l,t=this.m,r=this.n,a=this.o,i,c,d;for(let y=0;y<80;y++)y<20?(i=h&t|~h&r,c=1518500249):y<40?(i=h^t^r,c=1859775393):y<60?(i=h&t|h&r|t&r,c=2400959708):(i=h^t^r,c=3395469782),d=w(b,5)+i+a+c+n.getUint32(y*4,!1)&4294967295,a=r,r=t,t=w(h,30),h=b,b=d;this.h=this.h+b&4294967295,this.l=this.l+h&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+a&4294967295}}e.$vi=o}),define(Se[38],De([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(F||(F={})),function(f){const L="error",R="warning",$="warn",E="info",p="ignore";function A(w){return w?C.$Me(L,w)?f.Error:C.$Me(R,w)||C.$Me($,w)?f.Warning:C.$Me(E,w)?f.Info:f.Ignore:f.Ignore}f.fromValue=A;function I(w){switch(w){case f.Error:return L;case f.Warning:return R;case f.Info:return E;default:return p}}f.toString=I}(F||(F={})),e.default=F}),define(Se[160],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$cd=Symbol("MicrotaskDelay")}),define(Se[78],De([1,0,19,15]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;class f{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const D=k.charCodeAt(0),v=this.b.charCodeAt(this.c);return D-v}value(){return this.b[this.c]}}e.$Dh=f;class L{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,F.$Ge)(k,this.b,0,k.length,this.c,this.d):(0,F.$Ie)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Eh=L;class R{constructor(k=!0,D=!0){this.f=k,this.g=D}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let D=k.length-1;D>=0;D--,this.c--){const v=this.b.charCodeAt(D);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,F.$Ge)(k,this.b,0,k.length,this.d,this.e):(0,F.$Ie)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Fh=R;var $;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})($||($={}));class E{constructor(k,D){this.f=k,this.g=D,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,F.$He)(k,this.c.scheme);if(this.d[this.e]===2)return(0,F.$He)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,F.$Fe)(k,this.c.query);if(this.d[this.e]===5)return(0,F.$Fe)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Gh=E;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(A||(A={}));class I{static forUris(k=()=>!1,D=()=>!1){return new I(new E(k,D))}static forPaths(k=!1){return new I(new R(void 0,!k))}static forStrings(){return new I(new f)}static forConfigKeys(){return new I(new L)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,D){if(D){const v=D.slice(0);(0,C.$Vb)(v);for(const o of v)this.set(o,k)}else{const v=k.slice(0);(0,C.$Vb)(v);for(const o of v)this.set(o[0],o[1])}}set(k,D){const v=this.b.reset(k);let o;this.c||(this.c=new p,this.c.segment=v.value());const s=[];for(o=this.c;;){const l=v.cmp(o.segment);if(l>0)o.left||(o.left=new p,o.left.segment=v.value()),s.push([-1,o]),o=o.left;else if(l<0)o.right||(o.right=new p,o.right.segment=v.value()),s.push([1,o]),o=o.right;else if(v.hasNext())v.next(),o.mid||(o.mid=new p,o.mid.segment=v.value()),s.push([0,o]),o=o.mid;else break}const n=o.value;o.value=D,o.key=k;for(let l=s.length-1;l>=0;l--){const b=s[l][1];b.updateHeight();const h=b.balanceFactor();if(h<-1||h>1){const t=s[l][0],r=s[l+1][0];if(t===1&&r===1)s[l][1]=b.rotateLeft();else if(t===-1&&r===-1)s[l][1]=b.rotateRight();else if(t===1&&r===-1)b.right=s[l+1][1]=s[l+1][1].rotateRight(),s[l][1]=b.rotateLeft();else if(t===-1&&r===1)b.left=s[l+1][1]=s[l+1][1].rotateLeft(),s[l][1]=b.rotateRight();else throw new Error;if(l>0)switch(s[l-1][0]){case-1:s[l-1][1].left=s[l][1];break;case 1:s[l-1][1].right=s[l][1];break;case 0:s[l-1][1].mid=s[l][1];break}else this.c=s[0][1]}}return n}get(k){return this.d(k)?.value}d(k){const D=this.b.reset(k);let v=this.c;for(;v;){const o=D.cmp(v.segment);if(o>0)v=v.left;else if(o<0)v=v.right;else if(D.hasNext())D.next(),v=v.mid;else break}return v}has(k){const D=this.d(k);return!(D?.value===void 0&&D?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,D){const v=this.b.reset(k),o=[];let s=this.c;for(;s;){const n=v.cmp(s.segment);if(n>0)o.push([-1,s]),s=s.left;else if(n<0)o.push([1,s]),s=s.right;else if(v.hasNext())v.next(),o.push([0,s]),s=s.mid;else break}if(s){if(D?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:l,value:b,segment:h}=n;this.e(n.key,!1),s.key=l,s.value=b,s.segment=h}}else{const n=s.left??s.right;if(o.length>0){const[l,b]=o[o.length-1];switch(l){case-1:b.left=n;break;case 0:b.mid=n;break;case 1:b.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const l=o[n][1];l.updateHeight();const b=l.balanceFactor();if(b>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),o[n][1]=l.rotateLeft()):b<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),o[n][1]=l.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const D=this.b.reset(k);let v=this.c,o;for(;v;){const s=D.cmp(v.segment);if(s>0)v=v.left;else if(s<0)v=v.right;else if(D.hasNext())D.next(),o=v.value||o,v=v.mid;else break}return v&&v.value||o}findSuperstr(k){return this.g(k,!1)}g(k,D){const v=this.b.reset(k);let o=this.c;for(;o;){const s=v.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(v.hasNext())v.next(),o=o.mid;else return o.mid?this.h(o.mid):D?o.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[D,v]of this)k(v,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const D=[];return this.j(k,D),D[Symbol.iterator]()}j(k,D){k&&(k.left&&this.j(k.left,D),k.value&&D.push([k.key,k.value]),k.mid&&this.j(k.mid,D),k.right&&this.j(k.right,D))}_isBalanced(){const k=D=>{if(!D)return!0;const v=D.balanceFactor();return v<-1||v>1?!1:k(D.left)&&k(D.right)};return k(this.c)}}e.$Hh=I}),define(Se[18],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=void 0;function C(h){return typeof h=="string"}e.$jf=C;function F(h){return Array.isArray(h)&&h.every(t=>C(t))}e.$kf=F;function f(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$lf=f;function L(h){const t=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof t}e.$mf=L;function R(h){return typeof h=="number"&&!isNaN(h)}e.$nf=R;function $(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$of=$;function E(h){return h===!0||h===!1}e.$pf=E;function p(h){return typeof h>"u"}e.$qf=p;function A(h){return!I(h)}e.$rf=A;function I(h){return p(h)||h===null}e.$sf=I;function w(h,t){if(!h)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$tf=w;function k(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$uf=k;function D(...h){const t=[];for(let r=0;r<h.length;r++){const a=h[r];if(I(a))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(a)}return t}e.$vf=D;const v=Object.prototype.hasOwnProperty;function o(h){if(!f(h))return!1;for(const t in h)if(v.call(h,t))return!1;return!0}e.$wf=o;function s(h){return typeof h=="function"}e.$xf=s;function n(...h){return h.length>0&&h.every(s)}e.$yf=n;function l(h,t){const r=Math.min(h.length,t.length);for(let a=0;a<r;a++)b(h[a],t[a])}e.$zf=l;function b(h,t){if(C(t)){if(typeof h!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(h instanceof t)return}catch{}if(!I(h)&&h.constructor===t||t.length===1&&t.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Af=b}),define(Se[79],De([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=void 0;const F=Object.create(null);function f($,E){if((0,C.$jf)(E)){const p=F[E];if(p===void 0)throw new Error(`${$} references an unknown codicon: ${E}`);E=p}return F[$]=E,{id:$}}function L(){return F}e.$Nj=L;function R(){return Object.values(e.$Pj)}e.$Oj=R,e.$Pj={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(Se[23],De([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function F(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const n=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([l,b])=>{n[l]=b&&typeof b=="object"?F(b):b}),n}e.$Vm=F;function f(s){if(!s||typeof s!="object")return s;const n=[s];for(;n.length>0;){const l=n.shift();Object.freeze(l);for(const b in l)if(L.call(l,b)){const h=l[b];typeof h=="object"&&!Object.isFrozen(h)&&!(0,C.$mf)(h)&&n.push(h)}}return s}e.$Wm=f;const L=Object.prototype.hasOwnProperty;function R(s,n){return $(s,n,new Set)}e.$Xm=R;function $(s,n,l){if((0,C.$sf)(s))return s;const b=n(s);if(typeof b<"u")return b;if(Array.isArray(s)){const h=[];for(const t of s)h.push($(t,n,l));return h}if((0,C.$lf)(s)){if(l.has(s))throw new Error("Cannot clone recursive data-structure");l.add(s);const h={};for(const t in s)L.call(s,t)&&(h[t]=$(s[t],n,l));return l.delete(s),h}return s}function E(s,n,l=!0){return(0,C.$lf)(s)?((0,C.$lf)(n)&&Object.keys(n).forEach(b=>{b in s?l&&((0,C.$lf)(s[b])&&(0,C.$lf)(n[b])?E(s[b],n[b],l):s[b]=n[b]):s[b]=n[b]}),s):n}e.$Ym=E;function p(s,n){if(s===n)return!0;if(s==null||n===null||n===void 0||typeof s!=typeof n||typeof s!="object"||Array.isArray(s)!==Array.isArray(n))return!1;let l,b;if(Array.isArray(s)){if(s.length!==n.length)return!1;for(l=0;l<s.length;l++)if(!p(s[l],n[l]))return!1}else{const h=[];for(b in s)h.push(b);h.sort();const t=[];for(b in n)t.push(b);if(t.sort(),!p(h,t))return!1;for(l=0;l<h.length;l++)if(!p(s[h[l]],n[h[l]]))return!1}return!0}e.$Zm=p;function A(s){const n=new Set;return JSON.stringify(s,(l,b)=>{if((0,C.$lf)(b)||Array.isArray(b)){if(n.has(b))return"[Circular]";n.add(b)}return b})}e.$1m=A;function I(s,n){const l=Object.create(null);return!s||!n||Object.keys(n).forEach(h=>{const t=s[h],r=n[h];p(t,r)||(l[h]=r)}),l}e.$2m=I;function w(s,n){const l=n.toLowerCase(),b=Object.keys(s).find(h=>h.toLowerCase()===l);return b?s[b]:s[n]}e.$3m=w;function k(s,n){const l=Object.create(null);for(const[b,h]of Object.entries(s))n(b,h)&&(l[b]=h);return l}e.$4m=k;function D(s){let n=[];for(;Object.prototype!==s;)n=n.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return n}e.$5m=D;function v(s){const n=[];for(const l of D(s))typeof s[l]=="function"&&n.push(l);return n}e.$6m=v;function o(s,n){const l=h=>function(){const t=Array.prototype.slice.call(arguments,0);return n(h,t)},b={};for(const h of s)b[h]=l(h);return b}e.$7m=o}),define(Se[60],De([1,0,79]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Qj=e.ThemeColor=void 0;var F;(function(R){function $(E){return E&&typeof E=="object"&&typeof E.id=="string"}R.isThemeColor=$})(F||(e.ThemeColor=F={}));function f(R){return{id:R}}e.$Qj=f;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function E(n){const l=$.exec(n.id);if(!l)return E(C.$Pj.error);const[,b,h]=l,t=["codicon","codicon-"+b];return h&&t.push("codicon-modifier-"+h.substring(1)),t}R.asClassNameArray=E;function p(n){return E(n).join(" ")}R.asClassName=p;function A(n){return"."+E(n).join(".")}R.asCSSSelector=A;function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||F.isThemeColor(n.color))}R.isThemeIcon=I;const w=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function k(n){const l=w.exec(n);if(!l)return;const[,b]=l;return{id:b}}R.fromString=k;function D(n){return{id:n}}R.fromId=D;function v(n,l){let b=n.id;const h=b.lastIndexOf("~");return h!==-1&&(b=b.substring(0,h)),l&&(b=`${b}~${l}`),{id:b}}R.modify=v;function o(n){const l=n.id.lastIndexOf("~");if(l!==-1)return n.id.substring(l+1)}R.getModifier=o;function s(n,l){return n.id===l.id&&n.color?.id===l.color?.id}R.isEqual=s})(L||(e.ThemeIcon=L={}))}),define(Se[161],De([1,0,121,15,60]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=void 0;const L="$(",R=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function E(s){return s.replace($,(n,l)=>l?n:`\\${n}`)}e.$Rj=E;const p=new RegExp(`\\\\${R.source}`,"g");function A(s){return s.replace(p,n=>`\\${n}`)}e.$Sj=A;const I=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function w(s){return s.indexOf(L)===-1?s:s.replace(I,(n,l,b,h)=>b?n:l||h||"")}e.$Tj=w;function k(s){return s?s.replace(/\$\((.*?)\)/g,(n,l)=>` ${l} `).trim():""}e.$Uj=k;const D=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function v(s){D.lastIndex=0;let n="";const l=[];let b=0;for(;;){const h=D.lastIndex,t=D.exec(s),r=s.substring(h,t?.index);if(r.length>0){n+=r;for(let a=0;a<r.length;a++)l.push(b)}if(!t)break;b+=t[0].length}return{text:n,iconOffsets:l}}e.$Vj=v;function o(s,n,l=!1){const{text:b,iconOffsets:h}=n;if(!h||h.length===0)return(0,C.$Ej)(s,b,l);const t=(0,F.$ue)(b," "),r=b.length-t.length,a=(0,C.$Ej)(s,t,l);if(a)for(const i of a){const c=h[i.start+r]+r;i.start+=c,i.end+=c}return a}e.$Wj=o}),define(Se[122],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.Constants=void 0;var C;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function F(L){return L<0?0:L>255?255:L|0}e.$ke=F;function f(L){return L<0?0:L>4294967295?4294967295:L|0}e.$le=f}),define(Se[31],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(f){return C.test(f)}e.$3f=F,e.$4f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function($){for(let E=0;E<$.length;E++)$[E]=Math.floor(Math.random()*256);return $};const L=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){f(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,p="";return p+=R[L[E++]],p+=R[L[E++]],p+=R[L[E++]],p+=R[L[E++]],p+="-",p+=R[L[E++]],p+=R[L[E++]],p+="-",p+=R[L[E++]],p+=R[L[E++]],p+="-",p+=R[L[E++]],p+=R[L[E++]],p+="-",p+=R[L[E++]],p+=R[L[E++]],p+=R[L[E++]],p+=R[L[E++]],p+=R[L[E++]],p+=R[L[E++]],p}}()}),define(Se[162],De([1,0,19,50,31]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=e.$Qs=e.$Ps=void 0;function L(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$Ps=L;function R(I,w,k){const D={id:(0,f.$4f)(),name:I,uri:w,data:k};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.$Qs=R;class ${constructor(){this.a=new Map}get size(){let w=0;for(const k of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const k=[...this.a.keys()];return F.Iterable.some(this,([D,v])=>v.asFile())&&k.push("files"),A(E(w),k)}get(w){return this.a.get(this.b(w))?.[0]}append(w,k){const D=this.a.get(w);D?D.push(k):this.a.set(this.b(w),[k])}replace(w,k){this.a.set(this.b(w),[k])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,k]of this.a)for(const D of k)yield[w,D]}b(w){return E(w)}}e.$Rs=$;function E(I){return I.toLowerCase()}function p(I,w){return A(E(I),w.map(E))}e.$Ss=p;function A(I,w){if(I==="*/*")return w.length>0;if(w.includes(I))return!0;const k=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[D,v,o]=k;return o==="*"?w.some(s=>s.startsWith(v+"/")):!1}e.$Ts=Object.freeze({create:I=>(0,C.$Kb)(I.map(w=>w.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Ts.split(I).filter(w=>!w.startsWith("#"))})}),define(Se[163],De([1,0,61]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=void 0;function F($,E,p,A=1){let I=!1;return new Promise(w=>{const k=setTimeout(()=>{if(!I)return I=!0,w(0)},p);f($,E,A,D=>{if(!I)return I=!0,clearTimeout(k),w(D)})})}e.$6f=F;function f($,E,p,A){if(E===0)return A(0);const I=new C.Socket;I.once("connect",()=>(R(I),f($+p,E-1,p,A))),I.once("data",()=>{}),I.once("error",w=>(R(I),w.code!=="ECONNREFUSED"?f($+p,E-1,p,A):A($))),I.connect($,"127.0.0.1")}e.$7f={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L($,E,p,A="127.0.0.1"){let I=!1,w,k=1;const D=C.createServer({pauseOnConnect:!0});function v(o,s){I||(I=!0,D.removeAllListeners(),D.close(),w&&clearTimeout(w),s(o))}return new Promise(o=>{w=setTimeout(()=>{v(0,o)},p),D.on("listening",()=>{v($,o)}),D.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&k<E?($++,k++,D.listen($,A)):v(0,o)}),D.on("close",()=>{v(0,o)}),D.listen($,A)})}e.$8f=L;function R($){try{$.removeAllListeners("connect"),$.removeAllListeners("error"),$.end(),$.destroy(),$.unref()}catch(E){console.error(E)}}}),define(Se[123],De([1,0,122]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=e.$Hs=void 0;class F{constructor($){const E=(0,C.$ke)($);this.c=E,this.a=F.d(E),this.b=new Map}static d($){const E=new Uint8Array(256);return E.fill($),E}set($,E){const p=(0,C.$ke)(E);$>=0&&$<256?this.a[$]=p:this.b.set($,p)}get($){return $>=0&&$<256?this.a[$]:this.b.get($)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Hs=F;var f;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(f||(f={}));class L{constructor(){this.a=new F(0)}add($){this.a.set($,1)}has($){return this.a.get($)===1}clear(){return this.a.clear()}}e.$Is=L}),define(Se[62],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0;class C{constructor(f,L){this.lineNumber=f,this.column=L}with(f=this.lineNumber,L=this.column){return f===this.lineNumber&&L===this.column?this:new C(f,L)}delta(f=0,L=0){return this.with(this.lineNumber+f,this.column+L)}equals(f){return C.equals(this,f)}static equals(f,L){return!f&&!L?!0:!!f&&!!L&&f.lineNumber===L.lineNumber&&f.column===L.column}isBefore(f){return C.isBefore(this,f)}static isBefore(f,L){return f.lineNumber<L.lineNumber?!0:L.lineNumber<f.lineNumber?!1:f.column<L.column}isBeforeOrEqual(f){return C.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,L){return f.lineNumber<L.lineNumber?!0:L.lineNumber<f.lineNumber?!1:f.column<=L.column}static compare(f,L){const R=f.lineNumber|0,$=L.lineNumber|0;if(R===$){const E=f.column|0,p=L.column|0;return E-p}return R-$}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new C(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}}e.$js=C}),define(Se[34],De([1,0,62]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0;class F{constructor(L,R,$,E){L>$||L===$&&R>E?(this.startLineNumber=$,this.startColumn=E,this.endLineNumber=L,this.endColumn=R):(this.startLineNumber=L,this.startColumn=R,this.endLineNumber=$,this.endColumn=E)}isEmpty(){return F.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return F.containsPosition(this,L)}static containsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<L.startColumn||R.lineNumber===L.endLineNumber&&R.column>L.endColumn)}static strictContainsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<=L.startColumn||R.lineNumber===L.endLineNumber&&R.column>=L.endColumn)}containsRange(L){return F.containsRange(this,L)}static containsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>L.endColumn)}strictContainsRange(L){return F.strictContainsRange(this,L)}static strictContainsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<=L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>=L.endColumn)}plusRange(L){return F.plusRange(this,L)}static plusRange(L,R){let $,E,p,A;return R.startLineNumber<L.startLineNumber?($=R.startLineNumber,E=R.startColumn):R.startLineNumber===L.startLineNumber?($=R.startLineNumber,E=Math.min(R.startColumn,L.startColumn)):($=L.startLineNumber,E=L.startColumn),R.endLineNumber>L.endLineNumber?(p=R.endLineNumber,A=R.endColumn):R.endLineNumber===L.endLineNumber?(p=R.endLineNumber,A=Math.max(R.endColumn,L.endColumn)):(p=L.endLineNumber,A=L.endColumn),new F($,E,p,A)}intersectRanges(L){return F.intersectRanges(this,L)}static intersectRanges(L,R){let $=L.startLineNumber,E=L.startColumn,p=L.endLineNumber,A=L.endColumn;const I=R.startLineNumber,w=R.startColumn,k=R.endLineNumber,D=R.endColumn;return $<I?($=I,E=w):$===I&&(E=Math.max(E,w)),p>k?(p=k,A=D):p===k&&(A=Math.min(A,D)),$>p||$===p&&E>A?null:new F($,E,p,A)}equalsRange(L){return F.equalsRange(this,L)}static equalsRange(L,R){return!L&&!R?!0:!!L&&!!R&&L.startLineNumber===R.startLineNumber&&L.startColumn===R.startColumn&&L.endLineNumber===R.endLineNumber&&L.endColumn===R.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(L){return new C.$js(L.endLineNumber,L.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(L){return new C.$js(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,R){return new F(this.startLineNumber,this.startColumn,L,R)}setStartPosition(L,R){return new F(L,R,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(L){return new F(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(L){return new F(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new F(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,R=L){return new F(L.lineNumber,L.column,R.lineNumber,R.column)}static lift(L){return L?new F(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn)}static areIntersecting(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,R){if(L&&R){const p=L.startLineNumber|0,A=R.startLineNumber|0;if(p===A){const I=L.startColumn|0,w=R.startColumn|0;if(I===w){const k=L.endLineNumber|0,D=R.endLineNumber|0;if(k===D){const v=L.endColumn|0,o=R.endColumn|0;return v-o}return k-D}return I-w}return p-A}return(L?1:0)-(R?1:0)}static compareRangesUsingEnds(L,R){return L.endLineNumber===R.endLineNumber?L.endColumn===R.endColumn?L.startLineNumber===R.startLineNumber?L.startColumn-R.startColumn:L.startLineNumber-R.startLineNumber:L.endColumn-R.endColumn:L.endLineNumber-R.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$ks=F}),define(Se[164],De([1,0,34]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=void 0;class F{static insert(L,R){return{range:new C.$ks(L.lineNumber,L.column,L.lineNumber,L.column),text:R,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,R){return{range:L,text:R}}static replaceMove(L,R){return{range:L,text:R,forceMoveMarkers:!0}}}e.$ls=F}),define(Se[165],De([1,0,62,34]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=e.SelectionDirection=void 0;var f;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class L extends F.$ks{constructor($,E,p,A){super($,E,p,A),this.selectionStartLineNumber=$,this.selectionStartColumn=E,this.positionLineNumber=p,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection($){return L.selectionsEqual(this,$)}static selectionsEqual($,E){return $.selectionStartLineNumber===E.selectionStartLineNumber&&$.selectionStartColumn===E.selectionStartColumn&&$.positionLineNumber===E.positionLineNumber&&$.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition($,E){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,$,E):new L($,E,this.startLineNumber,this.startColumn)}getPosition(){return new C.$js(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$js(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition($,E){return this.getDirection()===0?new L($,E,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,$,E)}static fromPositions($,E=$){return new L($.lineNumber,$.column,E.lineNumber,E.column)}static fromRange($,E){return E===0?new L($.startLineNumber,$.startColumn,$.endLineNumber,$.endColumn):new L($.endLineNumber,$.endColumn,$.startLineNumber,$.startColumn)}static liftSelection($){return new L($.selectionStartLineNumber,$.selectionStartColumn,$.positionLineNumber,$.positionColumn)}static selectionsArrEqual($,E){if($&&!E||!$&&E)return!1;if(!$&&!E)return!0;if($.length!==E.length)return!1;for(let p=0,A=$.length;p<A;p++)if(!this.selectionsEqual($[p],E[p]))return!1;return!0}static isISelection($){return $&&typeof $.selectionStartLineNumber=="number"&&typeof $.selectionStartColumn=="number"&&typeof $.positionLineNumber=="number"&&typeof $.positionColumn=="number"}static createWithDirection($,E,p,A,I){return I===0?new L($,E,p,A):new L(p,A,$,E)}}e.$ms=L}),define(Se[166],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0,e.$Ur={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[167],De([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=e.$Js=e.WordCharacterClass=void 0;var F;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class f extends C.$Hs{constructor($){super(0);for(let E=0,p=$.length;E<p;E++)this.set($.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Js=f;function L(R){const $={};return E=>($.hasOwnProperty(E)||($[E]=R(E)),$[E])}e.$Ks=L(R=>new f(R))}),define(Se[124],De([1,0,50,3,76]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0,e.$Vr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(I=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$Vr)I.indexOf(k)>=0||(w+="\\"+k);return w+="\\s]+)",new RegExp(w,"g")}e.$Wr=L();function R(I){let w=e.$Wr;if(I&&I instanceof RegExp)if(I.global)w=I;else{let k="g";I.ignoreCase&&(k+="i"),I.multiline&&(k+="m"),I.unicode&&(k+="u"),w=new RegExp(I.source,k)}return w.lastIndex=0,w}e.$Xr=R;const $=new f.$tc;$.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(I){const w=$.unshift(I);return(0,F.$ic)(w)}e.$Yr=E;function p(I,w,k,D,v){if(v||(v=C.Iterable.first($)),k.length>v.maxLen){let b=I-v.maxLen/2;return b<0?b=0:D+=b,k=k.substring(b,I+v.maxLen/2),p(I,w,k,D,v)}const o=Date.now(),s=I-1-D;let n=-1,l=null;for(let b=1;!(Date.now()-o>=v.timeBudget);b++){const h=s-v.windowSize*b;w.lastIndex=Math.max(0,h);const t=A(w,k,s,n);if(!t&&l||(l=t,h<=0))break;n=h}if(l){const b={word:l[0],startColumn:D+1+l.index,endColumn:D+1+l.index+l[0].length};return w.lastIndex=0,b}return null}e.$Zr=p;function A(I,w,k,D){let v;for(;v=I.exec(w);){const o=v.index||0;if(o<=k&&I.lastIndex>=k)return v;if(D>0&&o>D)return null}return null}}),define(Se[168],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.$gt=e.IndentAction=void 0;var C;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class F{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let E=0,p=$.notIn.length;E<p;E++)switch($.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,E){if($.getTokenCount()===0)return!0;const p=$.findTokenIndexAtOffset(E-2),A=$.getStandardTokenType(p);return this.isOK(A)}g($,E){for(let p=$;p<=E;p++){const A=String.fromCharCode(p);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$gt=F;class f{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of $)L(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),L(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),L(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),L(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&L(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$ht=f;function L(R,$,E){R.has($)?R.get($).push(E):R.set($,[E])}}),define(Se[169],De([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AY=e.$zY=e.$yY=e.State=void 0;var F;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class f{constructor(D,v,o){const s=new Uint8Array(D*v);for(let n=0,l=D*v;n<l;n++)s[n]=o;this.a=s,this.rows=D,this.cols=v}get(D,v){return this.a[D*this.cols+v]}set(D,v,o){this.a[D*this.cols+v]=o}}class L{constructor(D){let v=0,o=0;for(let n=0,l=D.length;n<l;n++){const[b,h,t]=D[n];h>v&&(v=h),b>o&&(o=b),t>o&&(o=t)}v++,o++;const s=new f(o,v,0);for(let n=0,l=D.length;n<l;n++){const[b,h,t]=D[n];s.set(b,h,t)}this.a=s,this.b=v}nextState(D,v){return v<0||v>=this.b?0:this.a.get(D,v)}}e.$yY=L;let R=null;function $(){return R===null&&(R=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var E;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let p=null;function A(){if(p===null){p=new C.$Hs(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<k.length;v++)p.set(k.charCodeAt(v),1);const D=".,;:";for(let v=0;v<D.length;v++)p.set(D.charCodeAt(v),2)}return p}class I{static a(D,v,o,s,n){let l=n-1;do{const b=v.charCodeAt(l);if(D.get(b)!==2)break;l--}while(l>s);if(s>0){const b=v.charCodeAt(s-1),h=v.charCodeAt(l);(b===40&&h===41||b===91&&h===93||b===123&&h===125)&&l--}return{range:{startLineNumber:o,startColumn:s+1,endLineNumber:o,endColumn:l+2},url:v.substring(s,l+1)}}static computeLinks(D,v=$()){const o=A(),s=[];for(let n=1,l=D.getLineCount();n<=l;n++){const b=D.getLineContent(n),h=b.length;let t=0,r=0,a=0,i=1,c=!1,d=!1,y=!1,S=!1;for(;t<h;){let g=!1;const u=b.charCodeAt(t);if(i===13){let m;switch(u){case 40:c=!0,m=0;break;case 41:m=c?0:1;break;case 91:y=!0,d=!0,m=0;break;case 93:y=!1,m=d?0:1;break;case 123:S=!0,m=0;break;case 125:m=S?0:1;break;case 39:case 34:case 96:a===u?m=1:a===39||a===34||a===96?m=0:m=1;break;case 42:m=a===42?1:0;break;case 124:m=a===124?1:0;break;case 32:m=y?0:1;break;default:m=o.get(u)}m===1&&(s.push(I.a(o,b,n,r,t)),g=!0)}else if(i===12){let m;u===91?(d=!0,m=0):m=o.get(u),m===1?g=!0:i=13}else i=v.nextState(i,u),i===0&&(g=!0);g&&(i=1,c=!1,d=!1,S=!1,r=t+1,a=u),t++}i===13&&s.push(I.a(o,b,n,r,h))}return s}}e.$zY=I;function w(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:I.computeLinks(k)}e.$AY=w}),define(Se[125],De([1,0,23]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gu=e.$Fu=e.$Eu=e.$Du=e.ModelConstants=e.PositionAffinity=e.$Cu=e.TrackedRangeStickiness=e.$Bu=e.$Au=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var f;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(f||(e.GlyphMarginLane=f={}));var L;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var R;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var $;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var E;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var p;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(p||(e.EndOfLineSequence=p={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),h.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,h.indentSize|0),this.a=!1),this.insertSpaces=!!h.insertSpaces,this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=!!h.trimAutoWhitespace,this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.a===h.a&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,C.$Zm)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.$Au=A;class I{constructor(h,t){this._findMatchBrand=void 0,this.range=h,this.matches=t}}e.$Bu=I;var w;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function k(b){return b&&typeof b.read=="function"}e.$Cu=k;var D;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var v;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(e.ModelConstants=v={}));class o{constructor(h,t,r,a,i,c){this.identifier=h,this.range=t,this.text=r,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=i,this._isTracked=c}}e.$Du=o;class s{constructor(h,t,r){this.regex=h,this.wordSeparators=t,this.simpleSearch=r}}e.$Eu=s;class n{constructor(h,t,r){this.reverseEdits=h,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$Fu=n;function l(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.$Gu=l}),define(Se[170],De([1,0,19,122]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lu=e.$Ku=e.$Ju=void 0;class f{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,p){E=(0,F.$le)(E);const A=this.a,I=this.b,w=p.length;return w===0?!1:(this.a=new Uint32Array(A.length+w),this.a.set(A.subarray(0,E),0),this.a.set(A.subarray(E),E+w),this.a.set(p,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(E,p){return E=(0,F.$le)(E),p=(0,F.$le)(p),this.a[E]===p?!1:(this.a[E]=p,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,p){E=(0,F.$le)(E),p=(0,F.$le)(p);const A=this.a,I=this.b;if(E>=A.length)return!1;const w=A.length-E;return p>=w&&(p=w),p===0?!1:(this.a=new Uint32Array(A.length-p),this.a.set(A.subarray(0,E),0),this.a.set(A.subarray(E+p),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,F.$le)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let p=this.c[0]+1;p===0&&(this.b[0]=this.a[0],p++),E>=this.a.length&&(E=this.a.length-1);for(let A=p;A<=E;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let p=0,A=this.a.length-1,I=0,w=0,k=0;for(;p<=A;)if(I=p+(A-p)/2|0,w=this.b[I],k=w-this.a[I],E<k)A=I-1;else if(E>=w)p=I+1;else break;return new R(I,E-k)}}e.$Ju=f;class L{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const p=this.e[E],A=p>0?this.d[p-1]:0;return new R(p,E-A)}removeValues(E,p){this.a.splice(E,p),this.f(E)}insertValues(E,p){this.a=(0,C.$Ub)(this.a,E,p),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,p=this.a.length;E<p;E++){const A=this.a[E],I=E>0?this.d[E-1]:0;this.d[E]=I+A;for(let w=0;w<A;w++)this.e[I+w]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,p){this.a[E]!==p&&(this.a[E]=p,this.f(E))}}e.$Ku=L;class R{constructor(E,p){this.index=E,this.remainder=p,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=p}}e.$Lu=R}),define(Se[171],De([1,0,15,62,170]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mu=void 0;class L{constructor($,E,p,A){this.d=$,this.f=E,this.g=p,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents($){$.eol&&$.eol!==this.g&&(this.g=$.eol,this.j=null);const E=$.changes;for(const p of E)this.o(p.range),this.p(new F.$js(p.range.startLineNumber,p.range.startColumn),p.text);this.h=$.versionId,this.k=null}l(){if(!this.j){const $=this.g.length,E=this.f.length,p=new Uint32Array(E);for(let A=0;A<E;A++)p[A]=this.f[A].length+$;this.j=new f.$Ju(p)}}n($,E){this.f[$]=E,this.j&&this.j.setValue($,this.f[$].length+this.g.length)}o($){if($.startLineNumber===$.endLineNumber){if($.startColumn===$.endColumn)return;this.n($.startLineNumber-1,this.f[$.startLineNumber-1].substring(0,$.startColumn-1)+this.f[$.startLineNumber-1].substring($.endColumn-1));return}this.n($.startLineNumber-1,this.f[$.startLineNumber-1].substring(0,$.startColumn-1)+this.f[$.endLineNumber-1].substring($.endColumn-1)),this.f.splice($.startLineNumber,$.endLineNumber-$.startLineNumber),this.j&&this.j.removeValues($.startLineNumber,$.endLineNumber-$.startLineNumber)}p($,E){if(E.length===0)return;const p=(0,C.$Ae)(E);if(p.length===1){this.n($.lineNumber-1,this.f[$.lineNumber-1].substring(0,$.column-1)+p[0]+this.f[$.lineNumber-1].substring($.column-1));return}p[p.length-1]+=this.f[$.lineNumber-1].substring($.column-1),this.n($.lineNumber-1,this.f[$.lineNumber-1].substring(0,$.column-1)+p[0]);const A=new Uint32Array(p.length-1);for(let I=1;I<p.length;I++)this.f.splice($.lineNumber+I-1,0,p[I]),A[I-1]=p[I].length+this.g.length;this.j&&this.j.insertValues($.lineNumber,A)}}e.$Mu=L}),define(Se[172],De([1,0,15,167,62,34,125]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oB=e.$nB=e.$mB=e.$lB=e.$kB=e.$jB=void 0;const $=999;class E{constructor(n,l,b,h){this.searchString=n,this.isRegex=l,this.matchCase=b,this.wordSeparators=h}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=p(this.searchString):n=this.searchString.indexOf(`
`)>=0;let l=null;try{l=C.$ye(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!l)return null;let b=!this.isRegex&&!n;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new R.$Eu(l,this.wordSeparators?(0,F.$Ks)(this.wordSeparators):null,b?this.searchString:null)}}e.$jB=E;function p(s){if(!s||s.length===0)return!1;for(let n=0,l=s.length;n<l;n++){const b=s.charCodeAt(n);if(b===10)return!0;if(b===92){if(n++,n>=l)break;const h=s.charCodeAt(n);if(h===110||h===114||h===87)return!0}}return!1}e.$kB=p;function A(s,n,l){if(!l)return new R.$Bu(s,null);const b=[];for(let h=0,t=n.length;h<t;h++)b[h]=n[h];return new R.$Bu(s,b)}e.$lB=A;class I{constructor(n){const l=[];let b=0;for(let h=0,t=n.length;h<t;h++)n.charCodeAt(h)===10&&(l[b++]=h);this.a=l}findLineFeedCountBeforeOffset(n){const l=this.a;let b=0,h=l.length-1;if(h===-1||n<=l[0])return 0;for(;b<h;){const t=b+((h-b)/2>>0);l[t]>=n?h=t-1:l[t+1]>=n?(b=t,h=t):b=t+1}return b+1}}class w{static findMatches(n,l,b,h,t){const r=l.parseSearchRequest();return r?r.regex.multiline?this.b(n,b,new o(r.wordSeparators,r.regex),h,t):this.c(n,b,r,h,t):[]}static a(n,l,b,h,t,r){let a,i=0;h?(i=h.findLineFeedCountBeforeOffset(t),a=l+t+i):a=l+t;let c;if(h){const g=h.findLineFeedCountBeforeOffset(t+r.length)-i;c=a+r.length+g}else c=a+r.length;const d=n.getPositionAt(a),y=n.getPositionAt(c);return new L.$ks(d.lineNumber,d.column,y.lineNumber,y.column)}static b(n,l,b,h,t){const r=n.getOffsetAt(l.getStartPosition()),a=n.getValueInRange(l,1),i=n.getEOL()===`\r
`?new I(a):null,c=[];let d=0,y;for(b.reset(0);y=b.next(a);)if(c[d++]=A(this.a(n,r,a,i,y.index,y[0]),y,h),d>=t)return c;return c}static c(n,l,b,h,t){const r=[];let a=0;if(l.startLineNumber===l.endLineNumber){const c=n.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return a=this.d(b,c,l.startLineNumber,l.startColumn-1,a,r,h,t),r}const i=n.getLineContent(l.startLineNumber).substring(l.startColumn-1);a=this.d(b,i,l.startLineNumber,l.startColumn-1,a,r,h,t);for(let c=l.startLineNumber+1;c<l.endLineNumber&&a<t;c++)a=this.d(b,n.getLineContent(c),c,0,a,r,h,t);if(a<t){const c=n.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);a=this.d(b,c,l.endLineNumber,0,a,r,h,t)}return r}static d(n,l,b,h,t,r,a,i){const c=n.wordSeparators;if(!a&&n.simpleSearch){const S=n.simpleSearch,g=S.length,u=l.length;let m=-g;for(;(m=l.indexOf(S,m+g))!==-1;)if((!c||v(c,l,u,m,g))&&(r[t++]=new R.$Bu(new L.$ks(b,m+1+h,b,m+1+g+h),null),t>=i))return t;return t}const d=new o(n.wordSeparators,n.regex);let y;d.reset(0);do if(y=d.next(l),y&&(r[t++]=A(new L.$ks(b,y.index+1+h,b,y.index+1+y[0].length+h),y,a),t>=i))return t;while(y);return t}static findNextMatch(n,l,b,h){const t=l.parseSearchRequest();if(!t)return null;const r=new o(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,b,r,h):this.f(n,b,r,h)}static e(n,l,b,h){const t=new f.$js(l.lineNumber,1),r=n.getOffsetAt(t),a=n.getLineCount(),i=n.getValueInRange(new L.$ks(t.lineNumber,t.column,a,n.getLineMaxColumn(a)),1),c=n.getEOL()===`\r
`?new I(i):null;b.reset(l.column-1);const d=b.next(i);return d?A(this.a(n,r,i,c,d.index,d[0]),d,h):l.lineNumber!==1||l.column!==1?this.e(n,new f.$js(1,1),b,h):null}static f(n,l,b,h){const t=n.getLineCount(),r=l.lineNumber,a=n.getLineContent(r),i=this.g(b,a,r,l.column,h);if(i)return i;for(let c=1;c<=t;c++){const d=(r+c-1)%t,y=n.getLineContent(d+1),S=this.g(b,y,d+1,1,h);if(S)return S}return null}static g(n,l,b,h,t){n.reset(h-1);const r=n.next(l);return r?A(new L.$ks(b,r.index+1,b,r.index+1+r[0].length),r,t):null}static findPreviousMatch(n,l,b,h){const t=l.parseSearchRequest();if(!t)return null;const r=new o(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,b,r,h):this.j(n,b,r,h)}static h(n,l,b,h){const t=this.b(n,new L.$ks(1,1,l.lineNumber,l.column),b,h,10*$);if(t.length>0)return t[t.length-1];const r=n.getLineCount();return l.lineNumber!==r||l.column!==n.getLineMaxColumn(r)?this.h(n,new f.$js(r,n.getLineMaxColumn(r)),b,h):null}static j(n,l,b,h){const t=n.getLineCount(),r=l.lineNumber,a=n.getLineContent(r).substring(0,l.column-1),i=this.k(b,a,r,h);if(i)return i;for(let c=1;c<=t;c++){const d=(t+r-c-1)%t,y=n.getLineContent(d+1),S=this.k(b,y,d+1,h);if(S)return S}return null}static k(n,l,b,h){let t=null,r;for(n.reset(0);r=n.next(l);)t=A(new L.$ks(b,r.index+1,b,r.index+1+r[0].length),r,h);return t}}e.$mB=w;function k(s,n,l,b,h){if(b===0)return!0;const t=n.charCodeAt(b-1);if(s.get(t)!==0||t===13||t===10)return!0;if(h>0){const r=n.charCodeAt(b);if(s.get(r)!==0)return!0}return!1}function D(s,n,l,b,h){if(b+h===l)return!0;const t=n.charCodeAt(b+h);if(s.get(t)!==0||t===13||t===10)return!0;if(h>0){const r=n.charCodeAt(b+h-1);if(s.get(r)!==0)return!0}return!1}function v(s,n,l,b,h){return k(s,n,l,b,h)&&D(s,n,l,b,h)}e.$nB=v;class o{constructor(n,l){this._wordSeparators=n,this.a=l,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const l=n.length;let b;do{if(this.b+this.c===l||(b=this.a.exec(n),!b))return null;const h=b.index,t=b[0].length;if(h===this.b&&t===this.c){if(t===0){C.$Te(n,l,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=h,this.c=t,!this._wordSeparators||v(this._wordSeparators,n,l,h,t))return b}while(b);return null}}e.$oB=o}),define(Se[173],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m7=e.$l7=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$l7=C;class F{constructor(L){this.identifier=L}}e.$m7=F}),define(Se[174],De([1,0,4,3]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$fd,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,E){return this.a.set($,E),this.handleChange([$]),(0,F.$ic)(()=>{this.a.get($)===E&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,E){this.b.get($)?.dispose();const p=new L(this,$,E);return this.b.set($,p),(0,F.$ic)(()=>{const A=this.b.get($);!A||A!==p||(this.b.delete($),A.dispose())})}async getOrCreate($){const E=this.get($);if(E)return E;const p=this.b.get($);return!p||p.isResolved?null:(await p.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const p=this.b.get($);return!!(!p||p.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Vs=f;class L extends F.$kc{get isResolved(){return this.c}constructor($,E,p){super(),this.f=$,this.g=E,this.h=p,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(Se[175],De([10,11]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(Se[176],De([1,0,4,3,175]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;class L extends F.$kc{constructor(w,k="",D="",v=!0,o){super(),this.h=this.B(new C.$fd),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=k,this.u=D,this.w=v,this.C=o}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,k){this.C&&await this.C(w)}}e.$gi=L;class R extends F.$kc{constructor(){super(...arguments),this.f=this.B(new C.$fd),this.onWillRun=this.f.event,this.m=this.B(new C.$fd),this.onDidRun=this.m.event}async run(w,k){if(!w.enabled)return;this.f.fire({action:w});let D;try{await this.u(w,k)}catch(v){D=v}this.m.fire({action:w,error:D})}async u(w,k){await w.run(k)}}e.$hi=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let k=[];for(const D of w)D.length&&(k.length?k=[...k,new $,...D]:k=D);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$ii=$;class E{get actions(){return this.a}constructor(w,k,D,v){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=k,this.class=v,this.a=D}async run(){}}e.$ji=E;class p extends L{static{this.ID="vs.actions.empty"}constructor(){super(p.ID,f.localize(0,null),void 0,!1)}}e.$ki=p;function A(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...w)=>I.run(),tooltip:I.label}}e.$li=A}),define(Se[177],De([10,11]),function($e,e){return $e.create("vs/base/common/date",e)}),define(Se[178],De([1,0,177]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0;const F=60,f=F*60,L=f*24,R=L*7,$=L*30,E=L*365;function p(I,w,k,D){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,C.localize)(0,null,p(new Date().getTime()+v*1e3,!1));if(!D&&v<30)return(0,C.localize)(1,null);let o;return v<F?(o=v,w?o===1?k?(0,C.localize)(2,null,o):(0,C.localize)(3,null,o):k?(0,C.localize)(4,null,o):(0,C.localize)(5,null,o):o===1?k?(0,C.localize)(6,null,o):(0,C.localize)(7,null,o):k?(0,C.localize)(8,null,o):(0,C.localize)(9,null,o)):v<f?(o=Math.floor(v/F),w?o===1?k?(0,C.localize)(10,null,o):(0,C.localize)(11,null,o):k?(0,C.localize)(12,null,o):(0,C.localize)(13,null,o):o===1?k?(0,C.localize)(14,null,o):(0,C.localize)(15,null,o):k?(0,C.localize)(16,null,o):(0,C.localize)(17,null,o)):v<L?(o=Math.floor(v/f),w?o===1?k?(0,C.localize)(18,null,o):(0,C.localize)(19,null,o):k?(0,C.localize)(20,null,o):(0,C.localize)(21,null,o):o===1?k?(0,C.localize)(22,null,o):(0,C.localize)(23,null,o):k?(0,C.localize)(24,null,o):(0,C.localize)(25,null,o)):v<R?(o=Math.floor(v/L),w?o===1?(0,C.localize)(26,null,o):(0,C.localize)(27,null,o):o===1?(0,C.localize)(28,null,o):(0,C.localize)(29,null,o)):v<$?(o=Math.floor(v/R),w?o===1?k?(0,C.localize)(30,null,o):(0,C.localize)(31,null,o):k?(0,C.localize)(32,null,o):(0,C.localize)(33,null,o):o===1?k?(0,C.localize)(34,null,o):(0,C.localize)(35,null,o):k?(0,C.localize)(36,null,o):(0,C.localize)(37,null,o)):v<E?(o=Math.floor(v/$),w?o===1?k?(0,C.localize)(38,null,o):(0,C.localize)(39,null,o):k?(0,C.localize)(40,null,o):(0,C.localize)(41,null,o):o===1?k?(0,C.localize)(42,null,o):(0,C.localize)(43,null,o):k?(0,C.localize)(44,null,o):(0,C.localize)(45,null,o)):(o=Math.floor(v/E),w?o===1?k?(0,C.localize)(46,null,o):(0,C.localize)(47,null,o):k?(0,C.localize)(48,null,o):(0,C.localize)(49,null,o):o===1?k?(0,C.localize)(50,null,o):(0,C.localize)(51,null,o):k?(0,C.localize)(52,null,o):(0,C.localize)(53,null,o))}e.$6l=p;function A(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$7l=A}),define(Se[179],De([10,11]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(Se[46],De([1,0,19,18,179]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=void 0;function L(I,w){return w&&(I.stack||I.stacktrace)?f.localize(0,null,$(I),R(I.stack)||R(I.stacktrace)):$(I)}function R(I){return Array.isArray(I)?I.join(`
`):I}function $(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?f.localize(1,null,I.message):I.message||f.localize(2,null)}function E(I=null,w=!1){if(!I)return f.localize(3,null);if(Array.isArray(I)){const k=C.$Fb(I),D=E(k[0],w);return k.length>1?f.localize(4,null,D,k.length):D}if(F.$jf(I))return I;if(I.detail){const k=I.detail;if(k.error)return L(k.error,w);if(k.exception)return L(k.exception,w)}return I.stack?L(I,w):I.message?I.message:f.localize(5,null)}e.$mi=E;function p(I){const w=I;return w instanceof Error&&Array.isArray(w.actions)}e.$ni=p;function A(I,w){let k;return typeof I=="string"?k=new Error(I):k=I,k.actions=w,k}e.$oi=A}),define(Se[180],De([10,11]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(Se[12],De([1,0,180]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let F=!1,f=!1,L=!1,R=!1,$=!1,E=!1,p=!1,A=!1,I=!1,w=!1,k,D=e.$f,v=e.$f,o,s;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let n;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?n=e.$g.vscode.process:typeof process<"u"&&(n=process);const l=typeof n?.versions?.electron=="string",b=l&&n?.type==="renderer";if(typeof navigator=="object"&&!b)s=navigator.userAgent,F=s.indexOf("Windows")>=0,f=s.indexOf("Macintosh")>=0,A=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=s.indexOf("Linux")>=0,w=s?.indexOf("Mobi")>=0,E=!0,k=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$f,D=k,v=navigator.language;else if(typeof n=="object"){F=n.platform==="win32",f=n.platform==="darwin",L=n.platform==="linux",R=L&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,p=l,I=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$f,D=e.$f;const S=n.env.VSCODE_NLS_CONFIG;if(S)try{const g=JSON.parse(S),u=g.availableLanguages["*"];k=g.locale,v=g.osLocale,D=u||e.$f,o=g._translationsConfigFile}catch{}$=!0}else console.error("Unable to resolve platform.");var h;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(h||(e.Platform=h={}));function t(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let r=0;f?r=1:F?r=3:L&&(r=2),e.$i=F,e.$j=f,e.$k=L,e.$l=R,e.$m=$,e.$n=p,e.$o=E,e.$p=E&&typeof e.$g.importScripts=="function",e.$q=A,e.$r=w,e.$s=I,e.$t=r,e.$u=s,e.$v=D;var a;(function(S){function g(){return e.$v}S.value=g;function u(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}S.isDefaultVariant=u;function m(){return e.$v==="en"}S.isDefault=m})(a||(e.Language=a={})),e.$w=k,e.$x=v,e.$y=o,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const S=[];e.$g.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let m=0,P=S.length;m<P;m++){const O=S[m];if(O.id===u.data.vscodeScheduleAsyncWork){S.splice(m,1),O.callback();return}}});let g=0;return u=>{const m=++g;S.push({id:m,callback:u}),e.$g.postMessage({vscodeScheduleAsyncWork:m},"*")}}return S=>setTimeout(S)})();var i;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=f||A?2:F?1:3;let c=!0,d=!1;function y(){if(!d){d=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,c=new Uint16Array(S.buffer)[0]===(2<<8)+1}return c}e.$C=y,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(Se[47],De([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=e.$3d=e.env=e.cwd=void 0;let F;if(typeof C.$g.vscode<"u"&&typeof C.$g.vscode.process<"u"){const f=C.$g.vscode.process;F={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return C.$i?"win32":C.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$3d=F.platform,e.$4d=F.arch}),define(Se[16],De([1,0,47]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=e.sep=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=void 0;const F=65,f=97,L=90,R=122,$=46,E=47,p=92,A=58,I=63;class w extends Error{constructor(r,a,i){let c;typeof a=="string"&&a.indexOf("not ")===0?(c="must not be",a=a.replace(/^not /,"")):c="must be";const d=r.indexOf(".")!==-1?"property":"argument";let y=`The "${r}" ${d} ${c} of type ${a}`;y+=`. Received type ${typeof i}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,r){if(t===null||typeof t!="object")throw new w(r,"Object",t)}function D(t,r){if(typeof t!="string")throw new w(r,"string",t)}const v=C.$3d==="win32";function o(t){return t===E||t===p}function s(t){return t===E}function n(t){return t>=F&&t<=L||t>=f&&t<=R}function l(t,r,a,i){let c="",d=0,y=-1,S=0,g=0;for(let u=0;u<=t.length;++u){if(u<t.length)g=t.charCodeAt(u);else{if(i(g))break;g=E}if(i(g)){if(!(y===u-1||S===1))if(S===2){if(c.length<2||d!==2||c.charCodeAt(c.length-1)!==$||c.charCodeAt(c.length-2)!==$){if(c.length>2){const m=c.lastIndexOf(a);m===-1?(c="",d=0):(c=c.slice(0,m),d=c.length-1-c.lastIndexOf(a)),y=u,S=0;continue}else if(c.length!==0){c="",d=0,y=u,S=0;continue}}r&&(c+=c.length>0?`${a}..`:"..",d=2)}else c.length>0?c+=`${a}${t.slice(y+1,u)}`:c=t.slice(y+1,u),d=u-y-1;y=u,S=0}else g===$&&S!==-1?++S:S=-1}return c}function b(t,r){k(r,"pathObject");const a=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return a?a===r.root?`${a}${i}`:`${a}${t}${i}`:i}e.$5d={resolve(...t){let r="",a="",i=!1;for(let c=t.length-1;c>=-1;c--){let d;if(c>=0){if(d=t[c],D(d,"path"),d.length===0)continue}else r.length===0?d=C.cwd():(d=C.env[`=${r}`]||C.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==r.toLowerCase()&&d.charCodeAt(2)===p)&&(d=`${r}\\`));const y=d.length;let S=0,g="",u=!1;const m=d.charCodeAt(0);if(y===1)o(m)&&(S=1,u=!0);else if(o(m))if(u=!0,o(d.charCodeAt(1))){let P=2,O=P;for(;P<y&&!o(d.charCodeAt(P));)P++;if(P<y&&P!==O){const N=d.slice(O,P);for(O=P;P<y&&o(d.charCodeAt(P));)P++;if(P<y&&P!==O){for(O=P;P<y&&!o(d.charCodeAt(P));)P++;(P===y||P!==O)&&(g=`\\\\${N}\\${d.slice(O,P)}`,S=P)}}}else S=1;else n(m)&&d.charCodeAt(1)===A&&(g=d.slice(0,2),S=2,y>2&&o(d.charCodeAt(2))&&(u=!0,S=3));if(g.length>0)if(r.length>0){if(g.toLowerCase()!==r.toLowerCase())continue}else r=g;if(i){if(r.length>0)break}else if(a=`${d.slice(S)}\\${a}`,i=u,u&&r.length>0)break}return a=l(a,!i,"\\",o),i?`${r}\\${a}`:`${r}${a}`||"."},normalize(t){D(t,"path");const r=t.length;if(r===0)return".";let a=0,i,c=!1;const d=t.charCodeAt(0);if(r===1)return s(d)?"\\":t;if(o(d))if(c=!0,o(t.charCodeAt(1))){let S=2,g=S;for(;S<r&&!o(t.charCodeAt(S));)S++;if(S<r&&S!==g){const u=t.slice(g,S);for(g=S;S<r&&o(t.charCodeAt(S));)S++;if(S<r&&S!==g){for(g=S;S<r&&!o(t.charCodeAt(S));)S++;if(S===r)return`\\\\${u}\\${t.slice(g)}\\`;S!==g&&(i=`\\\\${u}\\${t.slice(g,S)}`,a=S)}}}else a=1;else n(d)&&t.charCodeAt(1)===A&&(i=t.slice(0,2),a=2,r>2&&o(t.charCodeAt(2))&&(c=!0,a=3));let y=a<r?l(t.slice(a),!c,"\\",o):"";return y.length===0&&!c&&(y="."),y.length>0&&o(t.charCodeAt(r-1))&&(y+="\\"),i===void 0?c?`\\${y}`:y:c?`${i}\\${y}`:`${i}${y}`},isAbsolute(t){D(t,"path");const r=t.length;if(r===0)return!1;const a=t.charCodeAt(0);return o(a)||r>2&&n(a)&&t.charCodeAt(1)===A&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,a;for(let d=0;d<t.length;++d){const y=t[d];D(y,"path"),y.length>0&&(r===void 0?r=a=y:r+=`\\${y}`)}if(r===void 0)return".";let i=!0,c=0;if(typeof a=="string"&&o(a.charCodeAt(0))){++c;const d=a.length;d>1&&o(a.charCodeAt(1))&&(++c,d>2&&(o(a.charCodeAt(2))?++c:i=!1))}if(i){for(;c<r.length&&o(r.charCodeAt(c));)c++;c>=2&&(r=`\\${r.slice(c)}`)}return e.$5d.normalize(r)},relative(t,r){if(D(t,"from"),D(r,"to"),t===r)return"";const a=e.$5d.resolve(t),i=e.$5d.resolve(r);if(a===i||(t=a.toLowerCase(),r=i.toLowerCase(),t===r))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===p;)c++;let d=t.length;for(;d-1>c&&t.charCodeAt(d-1)===p;)d--;const y=d-c;let S=0;for(;S<r.length&&r.charCodeAt(S)===p;)S++;let g=r.length;for(;g-1>S&&r.charCodeAt(g-1)===p;)g--;const u=g-S,m=y<u?y:u;let P=-1,O=0;for(;O<m;O++){const M=t.charCodeAt(c+O);if(M!==r.charCodeAt(S+O))break;M===p&&(P=O)}if(O!==m){if(P===-1)return i}else{if(u>m){if(r.charCodeAt(S+O)===p)return i.slice(S+O+1);if(O===2)return i.slice(S+O)}y>m&&(t.charCodeAt(c+O)===p?P=O:O===2&&(P=3)),P===-1&&(P=0)}let N="";for(O=c+P+1;O<=d;++O)(O===d||t.charCodeAt(O)===p)&&(N+=N.length===0?"..":"\\..");return S+=P,N.length>0?`${N}${i.slice(S,g)}`:(i.charCodeAt(S)===p&&++S,i.slice(S,g))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$5d.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===p){if(r.charCodeAt(1)===p){const a=r.charCodeAt(2);if(a!==I&&a!==$)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(n(r.charCodeAt(0))&&r.charCodeAt(1)===A&&r.charCodeAt(2)===p)return`\\\\?\\${r}`;return t},dirname(t){D(t,"path");const r=t.length;if(r===0)return".";let a=-1,i=0;const c=t.charCodeAt(0);if(r===1)return o(c)?t:".";if(o(c)){if(a=i=1,o(t.charCodeAt(1))){let S=2,g=S;for(;S<r&&!o(t.charCodeAt(S));)S++;if(S<r&&S!==g){for(g=S;S<r&&o(t.charCodeAt(S));)S++;if(S<r&&S!==g){for(g=S;S<r&&!o(t.charCodeAt(S));)S++;if(S===r)return t;S!==g&&(a=i=S+1)}}}}else n(c)&&t.charCodeAt(1)===A&&(a=r>2&&o(t.charCodeAt(2))?3:2,i=a);let d=-1,y=!0;for(let S=r-1;S>=i;--S)if(o(t.charCodeAt(S))){if(!y){d=S;break}}else y=!1;if(d===-1){if(a===-1)return".";d=a}return t.slice(0,d)},basename(t,r){r!==void 0&&D(r,"ext"),D(t,"path");let a=0,i=-1,c=!0,d;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(a=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let y=r.length-1,S=-1;for(d=t.length-1;d>=a;--d){const g=t.charCodeAt(d);if(o(g)){if(!c){a=d+1;break}}else S===-1&&(c=!1,S=d+1),y>=0&&(g===r.charCodeAt(y)?--y===-1&&(i=d):(y=-1,i=S))}return a===i?i=S:i===-1&&(i=t.length),t.slice(a,i)}for(d=t.length-1;d>=a;--d)if(o(t.charCodeAt(d))){if(!c){a=d+1;break}}else i===-1&&(c=!1,i=d+1);return i===-1?"":t.slice(a,i)},extname(t){D(t,"path");let r=0,a=-1,i=0,c=-1,d=!0,y=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(r=i=2);for(let S=t.length-1;S>=r;--S){const g=t.charCodeAt(S);if(o(g)){if(!d){i=S+1;break}continue}c===-1&&(d=!1,c=S+1),g===$?a===-1?a=S:y!==1&&(y=1):a!==-1&&(y=-1)}return a===-1||c===-1||y===0||y===1&&a===c-1&&a===i+1?"":t.slice(a,c)},format:b.bind(null,"\\"),parse(t){D(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const a=t.length;let i=0,c=t.charCodeAt(0);if(a===1)return o(c)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(o(c)){if(i=1,o(t.charCodeAt(1))){let P=2,O=P;for(;P<a&&!o(t.charCodeAt(P));)P++;if(P<a&&P!==O){for(O=P;P<a&&o(t.charCodeAt(P));)P++;if(P<a&&P!==O){for(O=P;P<a&&!o(t.charCodeAt(P));)P++;P===a?i=P:P!==O&&(i=P+1)}}}}else if(n(c)&&t.charCodeAt(1)===A){if(a<=2)return r.root=r.dir=t,r;if(i=2,o(t.charCodeAt(2))){if(a===3)return r.root=r.dir=t,r;i=3}}i>0&&(r.root=t.slice(0,i));let d=-1,y=i,S=-1,g=!0,u=t.length-1,m=0;for(;u>=i;--u){if(c=t.charCodeAt(u),o(c)){if(!g){y=u+1;break}continue}S===-1&&(g=!1,S=u+1),c===$?d===-1?d=u:m!==1&&(m=1):d!==-1&&(m=-1)}return S!==-1&&(d===-1||m===0||m===1&&d===S-1&&d===y+1?r.base=r.name=t.slice(y,S):(r.name=t.slice(y,d),r.base=t.slice(y,S),r.ext=t.slice(d,S))),y>0&&y!==i?r.dir=t.slice(0,y-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(v){const t=/\\/g;return()=>{const r=C.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>C.cwd()})();e.$6d={resolve(...t){let r="",a=!1;for(let i=t.length-1;i>=-1&&!a;i--){const c=i>=0?t[i]:h();D(c,"path"),c.length!==0&&(r=`${c}/${r}`,a=c.charCodeAt(0)===E)}return r=l(r,!a,"/",s),a?`/${r}`:r.length>0?r:"."},normalize(t){if(D(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===E,a=t.charCodeAt(t.length-1)===E;return t=l(t,!r,"/",s),t.length===0?r?"/":a?"./":".":(a&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return D(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let r;for(let a=0;a<t.length;++a){const i=t[a];D(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.$6d.normalize(r)},relative(t,r){if(D(t,"from"),D(r,"to"),t===r||(t=e.$6d.resolve(t),r=e.$6d.resolve(r),t===r))return"";const a=1,i=t.length,c=i-a,d=1,y=r.length-d,S=c<y?c:y;let g=-1,u=0;for(;u<S;u++){const P=t.charCodeAt(a+u);if(P!==r.charCodeAt(d+u))break;P===E&&(g=u)}if(u===S)if(y>S){if(r.charCodeAt(d+u)===E)return r.slice(d+u+1);if(u===0)return r.slice(d+u)}else c>S&&(t.charCodeAt(a+u)===E?g=u:u===0&&(g=0));let m="";for(u=a+g+1;u<=i;++u)(u===i||t.charCodeAt(u)===E)&&(m+=m.length===0?"..":"/..");return`${m}${r.slice(d+g)}`},toNamespacedPath(t){return t},dirname(t){if(D(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===E;let a=-1,i=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===E){if(!i){a=c;break}}else i=!1;return a===-1?r?"/":".":r&&a===1?"//":t.slice(0,a)},basename(t,r){r!==void 0&&D(r,"ext"),D(t,"path");let a=0,i=-1,c=!0,d;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let y=r.length-1,S=-1;for(d=t.length-1;d>=0;--d){const g=t.charCodeAt(d);if(g===E){if(!c){a=d+1;break}}else S===-1&&(c=!1,S=d+1),y>=0&&(g===r.charCodeAt(y)?--y===-1&&(i=d):(y=-1,i=S))}return a===i?i=S:i===-1&&(i=t.length),t.slice(a,i)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===E){if(!c){a=d+1;break}}else i===-1&&(c=!1,i=d+1);return i===-1?"":t.slice(a,i)},extname(t){D(t,"path");let r=-1,a=0,i=-1,c=!0,d=0;for(let y=t.length-1;y>=0;--y){const S=t.charCodeAt(y);if(S===E){if(!c){a=y+1;break}continue}i===-1&&(c=!1,i=y+1),S===$?r===-1?r=y:d!==1&&(d=1):r!==-1&&(d=-1)}return r===-1||i===-1||d===0||d===1&&r===i-1&&r===a+1?"":t.slice(r,i)},format:b.bind(null,"/"),parse(t){D(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const a=t.charCodeAt(0)===E;let i;a?(r.root="/",i=1):i=0;let c=-1,d=0,y=-1,S=!0,g=t.length-1,u=0;for(;g>=i;--g){const m=t.charCodeAt(g);if(m===E){if(!S){d=g+1;break}continue}y===-1&&(S=!1,y=g+1),m===$?c===-1?c=g:u!==1&&(u=1):c!==-1&&(u=-1)}if(y!==-1){const m=d===0&&a?1:d;c===-1||u===0||u===1&&c===y-1&&c===d+1?r.base=r.name=t.slice(m,y):(r.name=t.slice(m,c),r.base=t.slice(m,y),r.ext=t.slice(c,y))}return d>0?r.dir=t.slice(0,d-1):a&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$6d.win32=e.$5d.win32=e.$5d,e.$6d.posix=e.$5d.posix=e.$6d,e.$7d=v?e.$5d.normalize:e.$6d.normalize,e.$8d=v?e.$5d.isAbsolute:e.$6d.isAbsolute,e.$9d=v?e.$5d.join:e.$6d.join,e.$0d=v?e.$5d.resolve:e.$6d.resolve,e.$$d=v?e.$5d.relative:e.$6d.relative,e.$_d=v?e.$5d.dirname:e.$6d.dirname,e.$ae=v?e.$5d.basename:e.$6d.basename,e.$be=v?e.$5d.extname:e.$6d.extname,e.$ce=v?e.$5d.format:e.$6d.format,e.$de=v?e.$5d.parse:e.$6d.parse,e.$ee=v?e.$5d.toNamespacedPath:e.$6d.toNamespacedPath,e.sep=v?e.$5d.sep:e.$6d.sep,e.$ge=v?e.$5d.delimiter:e.$6d.delimiter}),define(Se[126],De([1,0,59,16]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=void 0;const f=new C.$T(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),L=new C.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new C.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(S,g,u=!1){const m=S||"",P=g||"",O=f.value.collator.compare(m,P);return f.value.collatorIsNumeric&&O===0&&m!==P?m<P?-1:1:O}e.$0p=$;function E(S,g){const u=L.value.collator;return S=S||"",g=g||"",b(u,S,g)}e.$$p=E;function p(S,g){const u=L.value.collator;return S=S||"",g=g||"",a(S,g)||b(u,S,g)}e.$_p=p;function A(S,g){const u=L.value.collator;return S=S||"",g=g||"",r(S,g)||b(u,S,g)}e.$aq=A;function I(S,g){return S=S||"",g=g||"",S===g?0:S<g?-1:1}e.$bq=I;function w(S,g){const[u,m]=n(S),[P,O]=n(g);let N=f.value.collator.compare(m,O);if(N===0){if(f.value.collatorIsNumeric&&m!==O)return m<O?-1:1;if(N=f.value.collator.compare(u,P),f.value.collatorIsNumeric&&N===0&&u!==P)return u<P?-1:1}return N}e.$cq=w;function k(S,g){S=S||"",g=g||"";const u=l(S),m=l(g),P=L.value.collator,O=R.value.collator;return b(O,u,m)||b(P,S,g)}e.$dq=k;function D(S,g){S=S||"",g=g||"";const u=l(S),m=l(g),P=L.value.collator,O=R.value.collator;return b(O,u,m)||a(S,g)||b(P,S,g)}e.$eq=D;function v(S,g){S=S||"",g=g||"";const u=l(S),m=l(g),P=L.value.collator,O=R.value.collator;return b(O,u,m)||r(S,g)||b(P,S,g)}e.$fq=v;function o(S,g){S=S||"",g=g||"";const u=l(S).toLowerCase(),m=l(g).toLowerCase();return u!==m?u<m?-1:1:S!==g?S<g?-1:1:0}e.$gq=o;const s=/^(.*?)(\.([^.]*))?$/;function n(S,g=!1){const u=S?s.exec(S):[];let m=[u&&u[1]||"",u&&u[3]||""];return g&&(!m[0]&&m[1]||m[0]&&m[0].charAt(0)===".")&&(m=[m[0]+"."+m[1],""]),m}function l(S){const g=S?s.exec(S):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function b(S,g,u){const m=S.compare(g,u);return m!==0?m:g.length!==u.length?g.length<u.length?-1:1:0}function h(S){const g=S.charAt(0);return g.toLocaleUpperCase()!==g}function t(S){const g=S.charAt(0);return g.toLocaleLowerCase()!==g}function r(S,g){return h(S)&&t(g)?-1:t(S)&&h(g)?1:0}function a(S,g){return t(S)&&h(g)?-1:h(S)&&t(g)?1:0}function i(S,g,u=!1){return u||(S=S&&S.toLowerCase(),g=g&&g.toLowerCase()),S===g?0:S<g?-1:1}function c(S,g,u=!1){const m=S.split(F.sep),P=g.split(F.sep),O=m.length-1,N=P.length-1;let M,j;for(let z=0;;z++){if(M=O===z,j=N===z,M&&j)return $(m[z],P[z],u);if(M)return-1;if(j)return 1;const T=i(m[z],P[z],u);if(T!==0)return T}}e.$hq=c;function d(S,g,u){const m=S.toLowerCase(),P=g.toLowerCase(),O=y(S,g,u);if(O)return O;const N=m.endsWith(u),M=P.endsWith(u);if(N!==M)return N?-1:1;const j=$(m,P);return j!==0?j:m.localeCompare(P)}e.$iq=d;function y(S,g,u){const m=S.toLowerCase(),P=g.toLowerCase(),O=m.startsWith(u),N=P.startsWith(u);if(O!==N)return O?-1:1;if(O&&N){if(m.length<P.length)return-1;if(m.length>P.length)return 1}return 0}e.$jq=y}),define(Se[32],De([1,0,16,12,15,18]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function R(d){return d===47||d===92}e.$Bf=R;function $(d){return d.replace(/[\\/]/g,C.$6d.sep)}e.$Cf=$;function E(d){return d.indexOf("/")===-1&&(d=$(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$Df=E;function p(d,y=C.$6d.sep){if(!d)return"";const S=d.length,g=d.charCodeAt(0);if(R(g)){if(R(d.charCodeAt(1))&&!R(d.charCodeAt(2))){let m=3;const P=m;for(;m<S&&!R(d.charCodeAt(m));m++);if(P!==m&&!R(d.charCodeAt(m+1))){for(m+=1;m<S;m++)if(R(d.charCodeAt(m)))return d.slice(0,m+1).replace(/[\\/]/g,y)}}return y}else if(s(g)&&d.charCodeAt(1)===58)return R(d.charCodeAt(2))?d.slice(0,2)+y:d.slice(0,2);let u=d.indexOf("://");if(u!==-1){for(u+=3;u<S;u++)if(R(d.charCodeAt(u)))return d.slice(0,u+1)}return""}e.$Ef=p;function A(d){if(!F.$i||!d||d.length<5)return!1;let y=d.charCodeAt(0);if(y!==92||(y=d.charCodeAt(1),y!==92))return!1;let S=2;const g=S;for(;S<d.length&&(y=d.charCodeAt(S),y!==92);S++);return!(g===S||(y=d.charCodeAt(S+1),isNaN(y)||y===92))}e.$Ff=A;const I=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(d,y=F.$i){const S=y?I:w;return!(!d||d.length===0||/^\s+$/.test(d)||(S.lastIndex=0,S.test(d))||y&&k.test(d)||d==="."||d===".."||y&&d[d.length-1]==="."||y&&d.length!==d.trim().length||d.length>255)}e.$Gf=D;function v(d,y,S){const g=d===y;return!S||g?g:!d||!y?!1:(0,f.$Me)(d,y)}e.$Hf=v;function o(d,y,S,g=C.sep){if(d===y)return!0;if(!d||!y||y.length>d.length)return!1;if(S){if(!(0,f.$Ne)(d,y))return!1;if(y.length===d.length)return!0;let m=y.length;return y.charAt(y.length-1)===g&&m--,d.charAt(m)===g}return y.charAt(y.length-1)!==g&&(y+=g),d.indexOf(y)===0}e.$If=o;function s(d){return d>=65&&d<=90||d>=97&&d<=122}e.$Jf=s;function n(d,y){return F.$i&&d.endsWith(":")&&(d+=C.sep),(0,C.$8d)(d)||(d=(0,C.$9d)(y,d)),d=(0,C.$7d)(d),F.$i?(d=(0,f.$ve)(d,C.sep),d.endsWith(":")&&(d+=C.sep)):(d=(0,f.$ve)(d,C.sep),d||(d=C.sep)),d}e.$Kf=n;function l(d){const y=(0,C.$7d)(d);return F.$i?d.length>3?!1:b(y)&&(d.length===2||y.charCodeAt(2)===92):y===C.$6d.sep}e.$Lf=l;function b(d,y=F.$i){return y?s(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$Mf=b;function h(d,y=F.$i){return b(d,y)?d[0]:void 0}e.$Nf=h;function t(d,y,S){return y.length>d.length?-1:d===y?0:(S&&(d=d.toLowerCase(),y=y.toLowerCase()),d.indexOf(y))}e.$Of=t;function r(d){const y=d.split(":");let S,g,u;for(const m of y){const P=Number(m);(0,L.$nf)(P)?g===void 0?g=P:u===void 0&&(u=P):S=S?[S,m].join(":"):m}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:g!==void 0?g:void 0,column:u!==void 0?u:g!==void 0?1:void 0}}e.$Pf=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(d,y,S=8){let g="";for(let m=0;m<S;m++){let P;m===0&&F.$i&&!y&&(S===3||S===4)?P=i:P=a,g+=P.charAt(Math.floor(Math.random()*P.length))}let u;return y?u=`${y}-${g}`:u=g,d?(0,C.$9d)(d,u):u}e.$Qf=c}),define(Se[127],De([1,0,126,121,51,16,12,15]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=void 0;const E=0,p=[E,[]];function A(H,q,me,Z){if(!H||!q)return p;const X=H.length,V=q.length;if(X<V)return p;const x=H.toLowerCase();return I(q,me,V,H,x,X,Z)}e.$kq=A;function I(H,q,me,Z,X,V,x){const ge=[],ue=[];for(let K=0;K<me;K++){const fe=K*V,te=fe-V,se=K>0,ne=H[K],Ee=q[K];for(let oe=0;oe<V;oe++){const he=oe>0,ee=fe+oe,le=ee-1,be=te+oe-1,Ie=he?ge[le]:0,B=se&&he?ge[be]:0,Y=se&&he?ue[be]:0;let ie;!B&&se?ie=0:ie=w(ne,Ee,Z,X,oe,Y),ie&&B+ie>=Ie&&(x||se||X.startsWith(q,oe))?(ue[ee]=Y+1,ge[ee]=B+ie):(ue[ee]=E,ge[ee]=Ie)}}const ve=[];let G=me-1,U=V-1;for(;G>=0&&U>=0;){const K=G*V+U;ue[K]===E||(ve.push(U),G--),U--}return[ge[me*V-1],ve.reverse()]}function w(H,q,me,Z,X,V){let x=0;if(!k(q,Z[X]))return x;if(x+=1,V>0&&(x+=V*5),H===me[X]&&(x+=1),X===0)x+=8;else{const ge=D(me.charCodeAt(X-1));ge?x+=ge:(0,F.$Bj)(me.charCodeAt(X))&&V===0&&(x+=2)}return x}function k(H,q){return H===q?!0:H==="/"||H==="\\"?q==="/"||q==="\\":!1}function D(H){switch(H){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function o(H,q,me=0,Z=0){const X=q;return X.values&&X.values.length>1?s(H,X.values,me,Z):n(H,q,me,Z)}e.$lq=o;function s(H,q,me,Z){let X=0;const V=[];for(const x of q){const[ge,ue]=n(H,x,me,Z);if(typeof ge!="number")return v;X+=ge,V.push(...ue)}return[X,S(V)]}function n(H,q,me,Z){const X=(0,F.$Kj)(q.original,q.originalLowercase,me,H,H.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,F.$Hj)(X)]:v}const l=Object.freeze({score:0}),b=1<<18,h=1<<17,t=1<<16;function r(H,q,me,Z){const X=Z.values?Z.values:[Z];return(0,f.$pi)({[Z.normalized]:{values:X.map(x=>({value:x.normalized,expectContiguousMatch:x.expectContiguousMatch})),label:H,description:q,allowNonContiguousMatches:me}})}function a(H,q,me,Z,X){if(!H||!q.normalized)return l;const V=Z.getItemLabel(H);if(!V)return l;const x=Z.getItemDescription(H),ge=r(V,x,me,q),ue=X[ge];if(ue)return ue;const ve=i(V,x,Z.getItemPath(H),q,me);return X[ge]=ve,ve}e.$mq=a;function i(H,q,me,Z,X){const V=!me||!Z.containsPathSeparator;return me&&(R.$k?Z.pathNormalized===me:(0,$.$Me)(Z.pathNormalized,me))?{score:b,labelMatch:[{start:0,end:H.length}],descriptionMatch:q?[{start:0,end:q.length}]:void 0}:Z.values&&Z.values.length>1?c(H,q,me,Z.values,V,X):d(H,q,me,Z,V,X)}function c(H,q,me,Z,X,V){let x=0;const ge=[],ue=[];for(const ve of Z){const{score:G,labelMatch:U,descriptionMatch:K}=d(H,q,me,ve,X,V);if(G===E)return l;x+=G,U&&ge.push(...U),K&&ue.push(...K)}return{score:x,labelMatch:S(ge),descriptionMatch:S(ue)}}function d(H,q,me,Z,X,V){if(X||!q){const[x,ge]=A(H,Z.normalized,Z.normalizedLowercase,V&&!Z.expectContiguousMatch);if(x){const ue=(0,F.$yj)(Z.normalized,H);let ve;if(ue){ve=h;const G=Math.round(Z.normalized.length/H.length*100);ve+=G}else ve=t;return{score:ve+x,labelMatch:ue||y(ge)}}}if(q){let x=q;me&&(x=`${q}${L.sep}`);const ge=x.length,ue=`${x}${H}`,[ve,G]=A(ue,Z.normalized,Z.normalizedLowercase,V&&!Z.expectContiguousMatch);if(ve){const U=y(G),K=[],fe=[];return U.forEach(te=>{te.start<ge&&te.end>ge?(K.push({start:0,end:te.end-ge}),fe.push({start:te.start,end:ge})):te.start>=ge?K.push({start:te.start-ge,end:te.end-ge}):fe.push(te)}),{score:ve,labelMatch:K,descriptionMatch:fe}}}return l}function y(H){const q=[];if(!H)return q;let me;for(const Z of H)me&&me.end===Z?me.end+=1:(me={start:Z,end:Z+1},q.push(me));return q}function S(H){const q=H.sort((X,V)=>X.start-V.start),me=[];let Z;for(const X of q)!Z||!g(Z,X)?(Z=X,me.push(X)):(Z.start=Math.min(Z.start,X.start),Z.end=Math.max(Z.end,X.end));return me}function g(H,q){return!(H.end<q.start||q.end<H.start)}function u(H,q,me,Z,X,V){const x=a(H,me,Z,X,V),ge=a(q,me,Z,X,V),ue=x.score,ve=ge.score;if((ue===b||ve===b)&&ue!==ve)return ue===b?-1:1;if(ue>t||ve>t){if(ue!==ve)return ue>ve?-1:1;if(ue<h&&ve<h){const ne=P(x.labelMatch,ge.labelMatch);if(ne!==0)return ne}const te=X.getItemLabel(H)||"",se=X.getItemLabel(q)||"";if(te.length!==se.length)return te.length-se.length}if(ue!==ve)return ue>ve?-1:1;const G=Array.isArray(x.labelMatch)&&x.labelMatch.length>0,U=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(G&&!U)return-1;if(U&&!G)return 1;const K=m(H,x,X),fe=m(q,ge,X);return K&&fe&&K!==fe?fe>K?-1:1:O(H,q,me,X)}e.$nq=u;function m(H,q,me){let Z=-1,X=-1;if(q.descriptionMatch&&q.descriptionMatch.length?Z=q.descriptionMatch[0].start:q.labelMatch&&q.labelMatch.length&&(Z=q.labelMatch[0].start),q.labelMatch&&q.labelMatch.length){if(X=q.labelMatch[q.labelMatch.length-1].end,q.descriptionMatch&&q.descriptionMatch.length){const V=me.getItemDescription(H);V&&(X+=V.length)}}else q.descriptionMatch&&q.descriptionMatch.length&&(X=q.descriptionMatch[q.descriptionMatch.length-1].end);return X-Z}function P(H,q){if(!H&&!q||(!H||!H.length)&&(!q||!q.length))return 0;if(!q||!q.length)return-1;if(!H||!H.length)return 1;const me=H[0].start,X=H[H.length-1].end-me,V=q[0].start,ge=q[q.length-1].end-V;return X===ge?0:ge<X?1:-1}function O(H,q,me,Z){const X=Z.getItemLabel(H)||"",V=Z.getItemLabel(q)||"",x=Z.getItemDescription(H),ge=Z.getItemDescription(q),ue=X.length+(x?x.length:0),ve=V.length+(ge?ge.length:0);if(ue!==ve)return ue-ve;const G=Z.getItemPath(H),U=Z.getItemPath(q);return G&&U&&G.length!==U.length?G.length-U.length:X!==V?(0,C.$iq)(X,V,me.normalized):x&&ge&&x!==ge?(0,C.$iq)(x,ge,me.normalized):G&&U&&G!==U?(0,C.$iq)(G,U,me.normalized):0}function N(H){return H.startsWith('"')&&H.endsWith('"')}const M=" ";function j(H){typeof H!="string"&&(H="");const q=H.toLowerCase(),{pathNormalized:me,normalized:Z,normalizedLowercase:X}=z(H),V=me.indexOf(L.sep)>=0,x=N(H);let ge;const ue=H.split(M);if(ue.length>1)for(const ve of ue){const G=N(ve),{pathNormalized:U,normalized:K,normalizedLowercase:fe}=z(ve);K&&(ge||(ge=[]),ge.push({original:ve,originalLowercase:ve.toLowerCase(),pathNormalized:U,normalized:K,normalizedLowercase:fe,expectContiguousMatch:G}))}return{original:H,originalLowercase:q,pathNormalized:me,normalized:Z,normalizedLowercase:X,values:ge,containsPathSeparator:V,expectContiguousMatch:x}}e.$oq=j;function z(H){let q;R.$i?q=H.replace(/\//g,L.sep):q=H.replace(/\\/g,L.sep);const me=(0,$.$xe)(q).replace(/\s|"/g,"");return{pathNormalized:q,normalized:me,normalizedLowercase:me.toLowerCase()}}function T(H){return Array.isArray(H)?j(H.map(q=>q.original).join(M)):j(H.original)}e.$pq=T}),define(Se[98],De([1,0,16]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.$Jr=e.$Ir=e.$Hr=void 0,e.$Hr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const I=(0,C.$be)(A),w=F[I.toLowerCase()];return w!==void 0?w:R(A)}e.$Ir=L;function R(A){const I=(0,C.$be)(A);return f[I.toLowerCase()]}e.$Jr=R;function $(A){for(const I in f)if(f[I]===A)return I}e.$Kr=$;const E=/^(.+)\/(.+?)(;.+)?$/;function p(A,I){const w=E.exec(A);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:I?void 0:A}e.$Lr=p}),define(Se[99],De([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0;var F;(function($){$[$.stdout=0]="stdout",$[$.stderr=1]="stderr"})(F||(e.Source=F={}));var f;(function($){$[$.Success=0]="Success",$[$.Unknown=1]="Unknown",$[$.AccessDenied=2]="AccessDenied",$[$.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function L($,...E){const p=E.reduce((w,k)=>(w[k]=!0,w),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys($).filter(w=>!p[w]).forEach(w=>{for(let k=0;k<A.length;k++)if(w.search(A[k])!==-1){delete $[w];break}})}e.$sl=L;function R($){$&&(delete $.DEBUG,C.$j&&delete $.DYLD_LIBRARY_PATH,C.$k&&delete $.LD_PRELOAD)}e.$tl=R}),define(Se[2],De([1,0,16,12]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,L=/^\//,R=/^\/\//;function $(i,c){if(!i.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!f.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(i,c){return!i&&!c?"file":i}function p(i,c){switch(i){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const A="",I="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(c){return c instanceof k?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,d,y,S,g,u=!1){typeof c=="object"?(this.scheme=c.scheme||A,this.authority=c.authority||A,this.path=c.path||A,this.query=c.query||A,this.fragment=c.fragment||A):(this.scheme=E(c,u),this.authority=d||A,this.path=p(this.scheme,y||A),this.query=S||A,this.fragment=g||A,$(this,u))}get fsPath(){return b(this,!1)}with(c){if(!c)return this;let{scheme:d,authority:y,path:S,query:g,fragment:u}=c;return d===void 0?d=this.scheme:d===null&&(d=A),y===void 0?y=this.authority:y===null&&(y=A),S===void 0?S=this.path:S===null&&(S=A),g===void 0?g=this.query:g===null&&(g=A),u===void 0?u=this.fragment:u===null&&(u=A),d===this.scheme&&y===this.authority&&S===this.path&&g===this.query&&u===this.fragment?this:new o(d,y,S,g,u)}static parse(c,d=!1){const y=w.exec(c);return y?new o(y[2]||A,a(y[4]||A),a(y[5]||A),a(y[7]||A),a(y[9]||A),d):new o(A,A,A,A,A)}static file(c){let d=A;if(F.$i&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const y=c.indexOf(I,2);y===-1?(d=c.substring(2),c=I):(d=c.substring(2,y),c=c.substring(y)||I)}return new o("file",d,c,A,A)}static from(c,d){return new o(c.scheme,c.authority,c.path,c.query,c.fragment,d)}static joinPath(c,...d){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return F.$i&&c.scheme==="file"?y=k.file(C.$5d.join(b(c,!0),...d)).path:y=C.$6d.join(c.path,...d),c.with({path:y})}toString(c=!1){return h(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof k)return c;{const d=new o(c);return d._formatted=c.external??null,d._fsPath=c._sep===v?c.fsPath??null:null,d}}else return c}}e.URI=k;function D(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$Sf=D;const v=F.$i?1:void 0;class o extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(c=!1){return c?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=v),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(i,c,d){let y,S=-1;for(let g=0;g<i.length;g++){const u=i.charCodeAt(g);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||c&&u===47||d&&u===91||d&&u===93||d&&u===58)S!==-1&&(y+=encodeURIComponent(i.substring(S,g)),S=-1),y!==void 0&&(y+=i.charAt(g));else{y===void 0&&(y=i.substr(0,g));const m=s[u];m!==void 0?(S!==-1&&(y+=encodeURIComponent(i.substring(S,g)),S=-1),y+=m):S===-1&&(S=g)}}return S!==-1&&(y+=encodeURIComponent(i.substring(S))),y!==void 0?y:i}function l(i){let c;for(let d=0;d<i.length;d++){const y=i.charCodeAt(d);y===35||y===63?(c===void 0&&(c=i.substr(0,d)),c+=s[y]):c!==void 0&&(c+=i[d])}return c!==void 0?c:i}function b(i,c){let d;return i.authority&&i.path.length>1&&i.scheme==="file"?d=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?c?d=i.path.substr(1):d=i.path[1].toLowerCase()+i.path.substr(2):d=i.path,F.$i&&(d=d.replace(/\//g,"\\")),d}e.$Tf=b;function h(i,c){const d=c?l:n;let y="",{scheme:S,authority:g,path:u,query:m,fragment:P}=i;if(S&&(y+=S,y+=":"),(g||S==="file")&&(y+=I,y+=I),g){let O=g.indexOf("@");if(O!==-1){const N=g.substr(0,O);g=g.substr(O+1),O=N.lastIndexOf(":"),O===-1?y+=d(N,!1,!1):(y+=d(N.substr(0,O),!1,!1),y+=":",y+=d(N.substr(O+1),!1,!0)),y+="@"}g=g.toLowerCase(),O=g.lastIndexOf(":"),O===-1?y+=d(g,!1,!0):(y+=d(g.substr(0,O),!1,!0),y+=g.substr(O))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const O=u.charCodeAt(1);O>=65&&O<=90&&(u=`/${String.fromCharCode(O+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const O=u.charCodeAt(0);O>=65&&O<=90&&(u=`${String.fromCharCode(O+32)}:${u.substr(2)}`)}y+=d(u,!0,!1)}return m&&(y+="?",y+=d(m,!1,!1)),P&&(y+="#",y+=c?P:n(P,!1,!1)),y}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(r)?i.replace(r,c=>t(c)):i}}),define(Se[181],De([1,0,2]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Pp=e.$Op=e.$Np=void 0;function F(p){const A=p;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$Np=F;function f(p){const A=[];let I;try{const w=JSON.parse(p.arguments),k=w[w.length-1];k&&k.__$stack&&(w.pop(),I=k.__$stack),A.push(...w)}catch{A.push("Unable to log remote console arguments",p.arguments)}return{args:A,stack:I}}e.$Op=f;function L(p){if(typeof p!="string")return L(f(p).stack);const A=p;if(A){const I=R(A),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(w&&w.length===4)return{uri:C.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$Pp=L;function R(p){if(!p)return p;const A=p.indexOf(`
`);return A===-1?p:p.substring(0,A)}function $(p,A){const{args:I,stack:w}=f(p),k=typeof I[0]=="string"&&I.length===1;let D=R(w);D&&(D=`(${D.trim()})`);let v=[];if(typeof I[0]=="string"?D&&k?v=[`%c[${A}] %c${I[0]} %c${D}`,E("blue"),E(""),E("grey")]:v=[`%c[${A}] %c${I[0]}`,E("blue"),E(""),...I.slice(1)]:v=[`%c[${A}]%`,E("blue"),...I],D&&!k&&v.push(D),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,v)}e.log=$;function E(p){return`color: ${p}`}}),define(Se[63],De([1,0,22,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.$0g=e.$9g=void 0;function f(E){return JSON.stringify(E,R)}e.$9g=f;function L(E){let p=JSON.parse(E);return p=$(p),p}e.$0g=L;function R(E,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:p.flags}:p}function $(E,p=0){if(!E||p>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return F.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof C.$Fd||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let A=0;A<E.length;++A)E[A]=$(E[A],p+1);else for(const A in E)Object.hasOwnProperty.call(E,A)&&(E[A]=$(E[A],p+1))}return E}e.$$g=$}),define(Se[17],De([1,0,8,12,2]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.Schemas=void 0;var L;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$Uf="vscode-tkn",e.$Vf="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${L.vscodeRemoteResource}`}set(A,I,w){this.a[A]=I,this.b[A]=w}setConnectionToken(A,I){this.c[A]=I}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(o){return C.$Y(o),A}const I=A.authority;let w=this.a[I];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const k=this.b[I],D=this.c[I];let v=`path=${encodeURIComponent(A.path)}`;return typeof D=="string"&&(v+=`&${e.$Vf}=${encodeURIComponent(D)}`),f.URI.from({scheme:F.$o?this.d:L.vscodeRemoteResource,authority:`${w}:${k}`,path:this.f,query:v})}}e.$Wf=new R,e.$Xf="vs/../../extensions",e.$Yf="vs/../../node_modules",e.$Zf="vs/../../node_modules.asar",e.$1f="vs/../../node_modules.asar.unpacked";class ${static{this.a="vscode-app"}asBrowserUri(A){const I=this.b(A,$e);return this.uriToBrowserUri(I)}uriToBrowserUri(A){return A.scheme===L.vscodeRemote?e.$Wf.rewrite(A):A.scheme===L.file&&(F.$m||F.$p&&F.$g.origin===`${L.vscodeFileResource}://${$.a}`)?A.with({scheme:L.vscodeFileResource,authority:A.authority||$.a,query:null,fragment:null}):A}asFileUri(A){const I=this.b(A,$e);return this.uriToFileUri(I)}uriToFileUri(A){return A.scheme===L.vscodeFileResource?A.with({scheme:L.file,authority:A.authority!==$.a?A.authority:null,query:null,fragment:null}):A}b(A,I){return f.URI.isUri(A)?A:f.URI.parse(I.toUrl(A))}}e.$2f=new $;var E;(function(p){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(A.get("3"));const I="vscode-coi";function w(D){let v;typeof D=="string"?v=new URL(D).searchParams:D instanceof URL?v=D.searchParams:f.URI.isUri(D)&&(v=new URL(D.toString(!0)).searchParams);const o=v?.get(I);if(o)return A.get(o)}p.getHeadersFromQuery=w;function k(D,v,o){if(!globalThis.crossOriginIsolated)return;const s=v&&o?"3":o?"2":"1";D instanceof URLSearchParams?D.set(I,s):D[I]=s}p.addSearchParam=k})(E||(e.COI=E={}))}),define(Se[182],De([1,0,156,17,12,2]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class R{constructor(w,k,D){this.id=w,this.dependencies=k,this.callback=D}}class ${static{this.INSTANCE=new $}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,k,D)=>{typeof w!="string"&&(D=k,k=w,w=null),(typeof k!="object"||!Array.isArray(k))&&(D=k,k=null),this.c.push(new R(w,k,D))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const k=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!k)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h(w){return new Promise((k,D)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const o=()=>{v.removeEventListener("load",s),v.removeEventListener("error",n)},s=l=>{o(),k(this.c.pop())},n=l=>{o(),D(l)};v.addEventListener("load",s),v.addEventListener("error",n),this.f&&(w=this.f.createScriptURL(w)),v.setAttribute("src",w),document.getElementsByTagName("head")[0].appendChild(v)})}i(w){return new Promise((k,D)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),k(this.c.pop())}catch(v){D(v)}})}async j(w){try{const k=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,o=L.URI.parse(w).fsPath,s=k.readFileSync(o).toString(),n=v.wrap(s.replace(/^#!.*/,""));return new D.Script(n).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const E=new Map;let p={};typeof globalThis.require=="object"&&(p=globalThis.require.paths??{});async function A(I,w,k){if(C.$R){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),p[I]&&(I=p[I]);const D=`${I}/${w}`;if(E.has(D))return E.get(D);let v;if(/^\w[\w\d+.-]*:\/\//.test(D))v=D;else{const l=`${k&&!f.$o?F.$Zf:F.$Yf}/${D}`;v=F.$2f.asBrowserUri(l).toString(!0)}const o=$.INSTANCE.load(v);return E.set(D,o),o}else return await new Promise((D,v)=>{$e([I],D,v)})}e.$cC=A}),define(Se[24],De([1,0,32,17,16,12,15,2]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.DataUri=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function E(k){return(0,$.$Tf)(k,!0)}e.$9f=E;class p{constructor(D){this.a=D}compare(D,v,o=!1){return D===v?0:(0,R.$Fe)(this.getComparisonKey(D,o),this.getComparisonKey(v,o))}isEqual(D,v,o=!1){return D===v?!0:!D||!v?!1:this.getComparisonKey(D,o)===this.getComparisonKey(v,o)}getComparisonKey(D,v=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,v,o=!1){if(D.scheme===v.scheme){if(D.scheme===F.Schemas.file)return C.$If(E(D),E(v),this.a(D))&&D.query===v.query&&(o||D.fragment===v.fragment);if((0,e.$ng)(D.authority,v.authority))return C.$If(D.path,v.path,this.a(D),"/")&&D.query===v.query&&(o||D.fragment===v.fragment)}return!1}joinPath(D,...v){return $.URI.joinPath(D,...v)}basenameOrAuthority(D){return(0,e.$fg)(D)||D.authority}basename(D){return f.$6d.basename(D.path)}extname(D){return f.$6d.extname(D.path)}dirname(D){if(D.path.length===0)return D;let v;return D.scheme===F.Schemas.file?v=$.URI.file(f.$_d(E(D))).path:(v=f.$6d.dirname(D.path),D.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),v="/")),D.with({path:v})}normalizePath(D){if(!D.path.length)return D;let v;return D.scheme===F.Schemas.file?v=$.URI.file(f.$7d(E(D))).path:v=f.$6d.normalize(D.path),D.with({path:v})}relativePath(D,v){if(D.scheme!==v.scheme||!(0,e.$ng)(D.authority,v.authority))return;if(D.scheme===F.Schemas.file){const n=f.$$d(E(D),E(v));return L.$i?C.$Cf(n):n}let o=D.path||"/";const s=v.path||"/";if(this.a(D)){let n=0;for(const l=Math.min(o.length,s.length);n<l&&!(o.charCodeAt(n)!==s.charCodeAt(n)&&o.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);o=s.substr(0,n)+o.substr(n)}return f.$6d.relative(o,s)}resolvePath(D,v){if(D.scheme===F.Schemas.file){const o=$.URI.file(f.$0d(E(D),v));return D.with({authority:o.authority,path:o.path})}return v=C.$Df(v),D.with({path:f.$6d.resolve(D.path,v)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,v){return D===v||D!==void 0&&v!==void 0&&(0,R.$Me)(D,v)}hasTrailingPathSeparator(D,v=f.sep){if(D.scheme===F.Schemas.file){const o=E(D);return o.length>C.$Ef(o).length&&o[o.length-1]===v}else{const o=D.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,v=f.sep){return(0,e.$og)(D,v)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,v=f.sep){let o=!1;if(D.scheme===F.Schemas.file){const s=E(D);o=s!==void 0&&s.length===C.$Ef(s).length&&s[s.length-1]===v}else{v="/";const s=D.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$og)(D,v)?D.with({path:D.path+"/"}):D}}e.$0f=p,e.$$f=new p(()=>!1),e.$_f=new p(k=>k.scheme===F.Schemas.file?!L.$k:!0),e.$ag=new p(k=>!0),e.$bg=e.$$f.isEqual.bind(e.$$f),e.$cg=e.$$f.isEqualOrParent.bind(e.$$f),e.$dg=e.$$f.getComparisonKey.bind(e.$$f),e.$eg=e.$$f.basenameOrAuthority.bind(e.$$f),e.$fg=e.$$f.basename.bind(e.$$f),e.$gg=e.$$f.extname.bind(e.$$f),e.$hg=e.$$f.dirname.bind(e.$$f),e.$ig=e.$$f.joinPath.bind(e.$$f),e.$jg=e.$$f.normalizePath.bind(e.$$f),e.$kg=e.$$f.relativePath.bind(e.$$f),e.$lg=e.$$f.resolvePath.bind(e.$$f),e.$mg=e.$$f.isAbsolutePath.bind(e.$$f),e.$ng=e.$$f.isEqualAuthority.bind(e.$$f),e.$og=e.$$f.hasTrailingPathSeparator.bind(e.$$f),e.$pg=e.$$f.removeTrailingPathSeparator.bind(e.$$f),e.$qg=e.$$f.addTrailingPathSeparator.bind(e.$$f);function A(k,D){const v=[];for(let o=0;o<k.length;o++){const s=D(k[o]);k.some((n,l)=>l===o?!1:(0,e.$cg)(s,D(n)))||v.push(k[o])}return v}e.$rg=A;var I;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function D(v){const o=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(l=>{const[b,h]=l.split(":");b&&h&&o.set(b,h)});const n=v.path.substring(0,v.path.indexOf(";"));return n&&o.set(k.META_DATA_MIME,n),o}k.parseMetaData=D})(I||(e.DataUri=I={}));function w(k,D,v){if(D){let o=k.path;return o&&o[0]!==f.$6d.sep&&(o=f.$6d.sep+o),k.with({scheme:v,authority:D,path:o})}return k.with({scheme:v})}e.$sg=w}),define(Se[9],De([1,0,21,8,4,3,24,12,160]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=e.$4g=e.$3g=e.Promises=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function p(U){return!!U&&typeof U.then=="function"}e.$tg=p;function A(U){const K=new C.$pd,fe=U(K.token),te=new Promise((se,ne)=>{const Ee=K.token.onCancellationRequested(()=>{Ee.dispose(),K.dispose(),ne(new F.$3)});Promise.resolve(fe).then(oe=>{Ee.dispose(),K.dispose(),se(oe)},oe=>{Ee.dispose(),K.dispose(),ne(oe)})});return new class{cancel(){K.cancel()}then(se,ne){return te.then(se,ne)}catch(se){return this.then(void 0,se)}finally(se){return te.finally(se)}}}e.$ug=A;function I(U,K,fe){return new Promise((te,se)=>{const ne=K.onCancellationRequested(()=>{ne.dispose(),te(fe)});U.then(te,se).finally(()=>ne.dispose())})}e.$vg=I;function w(U,K){return new Promise((fe,te)=>{const se=K.onCancellationRequested(()=>{se.dispose(),te(new F.$3)});U.then(fe,te).finally(()=>se.dispose())})}e.$wg=w;async function k(U){let K=-1;const fe=U.map((te,se)=>te.then(ne=>(K=se,ne)));try{return await Promise.race(fe)}finally{U.forEach((te,se)=>{se!==K&&te.cancel()})}}e.$xg=k;function D(U,K,fe){let te;const se=setTimeout(()=>{te?.(void 0),fe?.()},K);return Promise.race([U.finally(()=>clearTimeout(se)),new Promise(ne=>te=ne)])}e.$yg=D;function v(U){return new Promise((K,fe)=>{const te=U();p(te)?te.then(K,fe):K(te)})}e.$zg=v;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const fe=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(fe,fe).then(te)})}return new Promise((fe,te)=>{this.b.then(fe,te)})}return this.a=K(),new Promise((fe,te)=>{this.a.then(se=>{this.a=null,fe(se)},se=>{this.a=null,te(se)})})}dispose(){this.f=!0}}e.$Ag=o;class s{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$Bg=s;class n{constructor(){this.a=new Map}queue(K,fe){const se=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(fe).finally(()=>{this.a.get(K)===se&&this.a.delete(K)});return this.a.set(K,se),se}}e.$Cg=n;const l=(U,K)=>{let fe=!0;const te=setTimeout(()=>{fe=!1,K()},U);return{isTriggered:()=>fe,dispose:()=>{clearTimeout(te),fe=!1}}},b=U=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,U())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class h{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,fe=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((se,ne)=>{this.d=se,this.f=ne}).then(()=>{if(this.b=null,this.d=null,this.g){const se=this.g;return this.g=null,se()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=fe===E.$cd?b(te):l(fe,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dg=h;class t{constructor(K){this.a=new h(K),this.b=new o}trigger(K,fe){return this.a.trigger(()=>this.b.queue(K),fe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eg=t;class r{constructor(){this.a=!1,this.b=new Promise((K,fe)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fg=r;class a extends r{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$Gg=a;function i(U,K){return K?new Promise((fe,te)=>{const se=setTimeout(()=>{ne.dispose(),fe()},U),ne=K.onCancellationRequested(()=>{clearTimeout(se),ne.dispose(),te(new F.$3)})}):A(fe=>i(U,fe))}e.$Hg=i;function c(U,K=0){const fe=setTimeout(U,K);return(0,L.$ic)(()=>clearTimeout(fe))}e.$Ig=c;function d(U){const K=[];let fe=0;const te=U.length;function se(){return fe<te?U[fe++]():null}function ne(Ee){Ee!=null&&K.push(Ee);const oe=se();return oe?oe.then(ne):Promise.resolve(K)}return Promise.resolve(null).then(ne)}e.$Jg=d;function y(U,K=te=>!!te,fe=null){let te=0;const se=U.length,ne=()=>{if(te>=se)return Promise.resolve(fe);const Ee=U[te++];return Promise.resolve(Ee()).then(he=>K(he)?Promise.resolve(he):ne())};return ne()}e.$Kg=y;function S(U,K=te=>!!te,fe=null){if(U.length===0)return Promise.resolve(fe);let te=U.length;const se=()=>{te=-1;for(const ne of U)ne.cancel?.()};return new Promise((ne,Ee)=>{for(const oe of U)oe.then(he=>{--te>=0&&K(he)?(se(),ne(he)):te===0&&ne(fe)}).catch(he=>{--te>=0&&(se(),Ee(he))})})}e.$Lg=S;class g{constructor(K){this.a=0,this.d=K,this.f=[],this.b=0,this.g=new f.$fd}get onDrained(){return this.g.event}get size(){return this.a}queue(K){return this.a++,new Promise((fe,te)=>{this.f.push({factory:K,c:fe,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const K=this.f.shift();this.b++;const fe=K.factory();fe.then(K.c,K.e),fe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Mg=g;class u extends g{constructor(){super(1)}}e.$Ng=u;class m{constructor(){this.a=new me,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$Og=m;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new V;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueFor(K,fe=R.$$f){const te=fe.getComparisonKey(K);let se=this.a.get(te);if(!se){se=new u;const ne=this.f++,Ee=f.Event.once(se.onDrained)(()=>{se?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(ne),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$sc),this.d.set(ne,Ee),this.a.set(te,se)}return se}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Pg=P;class O{constructor(K,fe){this.a=-1,typeof K=="function"&&typeof fe=="number"&&this.setIfNotSet(K,fe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,fe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},fe)}setIfNotSet(K,fe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},fe))}}e.$Qg=O;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(K,fe){this.cancel(),this.a=setInterval(()=>{K()},fe)}}e.$Rg=N;class M{constructor(K,fe){this.b=-1,this.a=K,this.d=fe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sg=M;class j{constructor(K,fe){fe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${fe}ms is not a multiple of 1000ms.`),this.a=K,this.b=fe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Tg=j;class z extends M{constructor(K,fe){super(K,fe),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Ug=z;class T extends L.$kc{constructor(K,fe){super(),this.g=K,this.h=fe,this.a=[],this.b=this.B(new L.$lc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const fe of K)this.a.push(fe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vg=T,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Wg=U=>{(0,$.$A)(()=>{if(K)return;const fe=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,fe-Date.now())}}))});let K=!1;return{dispose(){K||(K=!0)}}}:e.$Wg=(U,K)=>{const fe=requestIdleCallback(U,typeof K=="number"?{timeout:K}:void 0);let te=!1;return{dispose(){te||(te=!0,cancelIdleCallback(fe))}}}}();class H{constructor(K){this.d=!1,this.a=()=>{try{this.f=K()}catch(fe){this.g=fe}finally{this.d=!0}},this.b=(0,e.$Wg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Xg=H;async function q(U,K,fe){let te;for(let se=0;se<fe;se++)try{return await U()}catch(ne){te=ne,await i(K)}throw te}e.$Yg=q;class me{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,fe,te){return this.a={taskId:K,cancel:()=>te?.(),promise:fe},fe.then(()=>this.d(K),()=>this.d(K)),fe}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{let fe,te;const se=new Promise((ne,Ee)=>{fe=ne,te=Ee});this.b={run:K,promise:se,promiseResolve:fe,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zg=me;class Z{constructor(K,fe=()=>Date.now()){this.d=K,this.f=fe,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$1g=Z;var X;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(X||(X={}));class V{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,fe)=>{this.a=K,this.b=fe})}complete(K){return new Promise(fe=>{this.a(K),this.d={outcome:0,value:K},fe()})}error(K){return new Promise(fe=>{this.b(K),this.d={outcome:1,value:K},fe()})}cancel(){return this.error(new F.$3)}}e.$2g=V;var x;(function(U){async function K(te){let se;const ne=await Promise.all(te.map(Ee=>Ee.then(oe=>oe,oe=>{se||(se=oe)})));if(typeof se<"u")throw se;return ne}U.settled=K;function fe(te){return new Promise(async(se,ne)=>{try{await te(se,ne)}catch(Ee){ne(Ee)}})}U.withAsyncBody=fe})(x||(e.Promises=x={}));var ge;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(ge||(ge={}));class ue{static fromArray(K){return new ue(fe=>{fe.emitMany(K)})}static fromPromise(K){return new ue(async fe=>{fe.emitMany(await K)})}static fromPromises(K){return new ue(async fe=>{await Promise.all(K.map(async te=>fe.emitOne(await te)))})}static merge(K){return new ue(async fe=>{await Promise.all(K.map(async te=>{for await(const se of te)fe.emitOne(se)}))})}static{this.EMPTY=ue.fromArray([])}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new f.$fd,queueMicrotask(async()=>{const fe={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(K(fe)),this.j()}catch(te){this.k(te)}finally{fe.emitOne=void 0,fe.emitMany=void 0,fe.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(K,fe){return new ue(async te=>{for await(const se of K)te.emitOne(fe(se))})}map(K){return ue.map(this,K)}static filter(K,fe){return new ue(async te=>{for await(const se of K)fe(se)&&te.emitOne(se)})}filter(K){return ue.filter(this,K)}static coalesce(K){return ue.filter(K,fe=>!!fe)}coalesce(){return ue.coalesce(this)}static async toPromise(K){const fe=[];for await(const te of K)fe.push(te);return fe}toPromise(){return ue.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$3g=ue;class ve extends ue{constructor(K,fe){super(fe),this.l=K}cancel(){this.l.cancel()}}e.$4g=ve;function G(U){const K=new C.$pd,fe=U(K.token);return new ve(K,async te=>{const se=K.token.onCancellationRequested(()=>{se.dispose(),K.dispose(),te.reject(new F.$3)});try{for await(const ne of fe){if(K.token.isCancellationRequested)return;te.emitOne(ne)}se.dispose(),K.dispose()}catch(ne){se.dispose(),K.dispose(),te.reject(ne)}})}e.$5g=G}),define(Se[35],De([1,0,19,9,32,28,16,12,15]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=void 0;function p(){return Object.create(null)}e.$mj=p,e.$nj="**",e.$oj="/";const A="[/\\\\]",I="[^/\\\\]",w=/\//g;function k(me,Z){switch(me){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}${Z?`|${A}${I}+`:""})*?`}}function D(me,Z){if(!me)return[];const X=[];let V=!1,x=!1,ge="";for(const ue of me){switch(ue){case Z:if(!V&&!x){X.push(ge),ge="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":x=!0;break;case"]":x=!1;break}ge+=ue}return ge&&X.push(ge),X}e.$pj=D;function v(me){if(!me)return"";let Z="";const X=D(me,e.$oj);if(X.every(V=>V===e.$nj))Z=".*";else{let V=!1;X.forEach((x,ge)=>{if(x===e.$nj){if(V)return;Z+=k(2,ge===X.length-1)}else{let ue=!1,ve="",G=!1,U="";for(const K of x){if(K!=="}"&&ue){ve+=K;continue}if(G&&(K!=="]"||!U)){let fe;K==="-"?fe=K:(K==="^"||K==="!")&&!U?fe="^":K===e.$oj?fe="":fe=(0,E.$qe)(K),U+=fe;continue}switch(K){case"{":ue=!0;continue;case"[":G=!0;continue;case"}":{const te=`(?:${D(ve,",").map(se=>v(se)).join("|")})`;Z+=te,ue=!1,ve="";break}case"]":{Z+="["+U+"]",G=!1,U="";break}case"?":Z+=I;continue;case"*":Z+=k(1);continue;default:Z+=(0,E.$qe)(K)}}ge<X.length-1&&(X[ge+1]!==e.$nj||ge+2<X.length)&&(Z+=A)}V=x===e.$nj})}return Z}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Ci(1e4),r=function(){return!1},a=function(){return null};function i(me,Z){if(!me)return a;let X;typeof me!="string"?X=me.pattern:X=me,X=X.trim();const V=`${X}_${!!Z.trimForExclusions}`;let x=t.get(V);if(x)return c(x,me);let ge;return o.test(X)?x=y(X.substr(4),X):(ge=s.exec(d(X,Z)))?x=S(ge[1],X):(Z.trimForExclusions?l:n).test(X)?x=g(X,Z):(ge=b.exec(d(X,Z)))?x=u(ge[1].substr(1),X,!0):(ge=h.exec(d(X,Z)))?x=u(ge[1],X,!1):x=m(X),t.set(V,x),c(x,me)}function c(me,Z){if(typeof Z=="string")return me;const X=function(V,x){return(0,f.$If)(V,Z.base,!$.$k)?me((0,E.$ue)(V.substr(Z.base.length),R.sep),x):null};return X.allBasenames=me.allBasenames,X.allPaths=me.allPaths,X.basenames=me.basenames,X.patterns=me.patterns,X}function d(me,Z){return Z.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function y(me,Z){return function(X,V){return typeof X=="string"&&X.endsWith(me)?Z:null}}function S(me,Z){const X=`/${me}`,V=`\\${me}`,x=function(ue,ve){return typeof ue!="string"?null:ve?ve===me?Z:null:ue===me||ue.endsWith(X)||ue.endsWith(V)?Z:null},ge=[me];return x.basenames=ge,x.patterns=[Z],x.allBasenames=ge,x}function g(me,Z){const X=H(me.slice(1,-1).split(",").map(ve=>i(ve,Z)).filter(ve=>ve!==a),me),V=X.length;if(!V)return a;if(V===1)return X[0];const x=function(ve,G){for(let U=0,K=X.length;U<K;U++)if(X[U](ve,G))return me;return null},ge=X.find(ve=>!!ve.allBasenames);ge&&(x.allBasenames=ge.allBasenames);const ue=X.reduce((ve,G)=>G.allPaths?ve.concat(G.allPaths):ve,[]);return ue.length&&(x.allPaths=ue),x}function u(me,Z,X){const V=R.sep===R.$6d.sep,x=V?me:me.replace(w,R.sep),ge=R.sep+x,ue=R.$6d.sep+me;let ve;return X?ve=function(G,U){return typeof G=="string"&&(G===x||G.endsWith(ge)||!V&&(G===me||G.endsWith(ue)))?Z:null}:ve=function(G,U){return typeof G=="string"&&(G===x||!V&&G===me)?Z:null},ve.allPaths=[(X?"*/":"./")+me],ve}function m(me){try{const Z=new RegExp(`^${v(me)}$`);return function(X){return Z.lastIndex=0,typeof X=="string"&&Z.test(X)?me:null}}catch{return a}}function P(me,Z,X){return!me||typeof Z!="string"?!1:O(me)(Z,void 0,X)}e.$qj=P;function O(me,Z={}){if(!me)return r;if(typeof me=="string"||N(me)){const X=i(me,Z);if(X===a)return r;const V=function(x,ge){return!!X(x,ge)};return X.allBasenames&&(V.allBasenames=X.allBasenames),X.allPaths&&(V.allPaths=X.allPaths),V}return z(me,Z)}e.$rj=O;function N(me){const Z=me;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}e.$sj=N;function M(me){return me.allBasenames||[]}e.$tj=M;function j(me){return me.allPaths||[]}e.$uj=j;function z(me,Z){const X=H(Object.getOwnPropertyNames(me).map(ve=>T(ve,me[ve],Z)).filter(ve=>ve!==a)),V=X.length;if(!V)return a;if(!X.some(ve=>!!ve.requiresSiblings)){if(V===1)return X[0];const ve=function(K,fe){let te;for(let se=0,ne=X.length;se<ne;se++){const Ee=X[se](K,fe);if(typeof Ee=="string")return Ee;(0,F.$tg)(Ee)&&(te||(te=[]),te.push(Ee))}return te?(async()=>{for(const se of te){const ne=await se;if(typeof ne=="string")return ne}return null})():null},G=X.find(K=>!!K.allBasenames);G&&(ve.allBasenames=G.allBasenames);const U=X.reduce((K,fe)=>fe.allPaths?K.concat(fe.allPaths):K,[]);return U.length&&(ve.allPaths=U),ve}const x=function(ve,G,U){let K,fe;for(let te=0,se=X.length;te<se;te++){const ne=X[te];ne.requiresSiblings&&U&&(G||(G=(0,R.$ae)(ve)),K||(K=G.substr(0,G.length-(0,R.$be)(ve).length)));const Ee=ne(ve,G,K,U);if(typeof Ee=="string")return Ee;(0,F.$tg)(Ee)&&(fe||(fe=[]),fe.push(Ee))}return fe?(async()=>{for(const te of fe){const se=await te;if(typeof se=="string")return se}return null})():null},ge=X.find(ve=>!!ve.allBasenames);ge&&(x.allBasenames=ge.allBasenames);const ue=X.reduce((ve,G)=>G.allPaths?ve.concat(G.allPaths):ve,[]);return ue.length&&(x.allPaths=ue),x}function T(me,Z,X){if(Z===!1)return a;const V=i(me,X);if(V===a)return a;if(typeof Z=="boolean")return V;if(Z){const x=Z.when;if(typeof x=="string"){const ge=(ue,ve,G,U)=>{if(!U||!V(ue,ve))return null;const K=x.replace("$(basename)",()=>G),fe=U(K);return(0,F.$tg)(fe)?fe.then(te=>te?me:null):fe?me:null};return ge.requiresSiblings=!0,ge}}return V}function H(me,Z){const X=me.filter(ve=>!!ve.basenames);if(X.length<2)return me;const V=X.reduce((ve,G)=>{const U=G.basenames;return U?ve.concat(U):ve},[]);let x;if(Z){x=[];for(let ve=0,G=V.length;ve<G;ve++)x.push(Z)}else x=X.reduce((ve,G)=>{const U=G.patterns;return U?ve.concat(U):ve},[]);const ge=function(ve,G){if(typeof ve!="string")return null;if(!G){let K;for(K=ve.length;K>0;K--){const fe=ve.charCodeAt(K-1);if(fe===47||fe===92)break}G=ve.substr(K)}const U=V.indexOf(G);return U!==-1?x[U]:null};ge.basenames=V,ge.patterns=x,ge.allBasenames=V;const ue=me.filter(ve=>!ve.basenames);return ue.push(ge),ue}function q(me,Z){return(0,C.$sb)(me,Z,(X,V)=>typeof X=="string"&&typeof V=="string"?X===V:typeof X!="string"&&typeof V!="string"?X.base===V.base&&X.pattern===V.pattern:!1)}e.$vj=q}),define(Se[80],De([1,0,8,161,24,15,2]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class E{constructor(s="",n=!1){if(this.value=s,typeof this.value!="string")throw(0,C.$5)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(s,n=0){return this.value+=w(this.supportThemeIcons?(0,F.$Rj)(s):s).replace(/([ \t]+)/g,(l,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,n){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(s,n,l){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(s),")"),l&&(this.value+=` "${this.c(this.c(l,'"'),")")}"`),this.value+=")",this}c(s,n){const l=new RegExp((0,L.$qe)(n),"g");return s.replace(l,(b,h)=>s.charAt(h-1)!=="\\"?`\\${b}`:b)}}e.$Xj=E;function p(o){return A(o)?!o.value:Array.isArray(o)?o.every(p):!0}e.$Yj=p;function A(o){return o instanceof E?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$Zj=A;function I(o,s){return o===s?!0:!o||!s?!1:o.value===s.value&&o.isTrusted===s.isTrusted&&o.supportThemeIcons===s.supportThemeIcons&&o.supportHtml===s.supportHtml&&(o.baseUri===s.baseUri||!!o.baseUri&&!!s.baseUri&&(0,f.$bg)(R.URI.from(o.baseUri),R.URI.from(s.baseUri)))}e.$1j=I;function w(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$2j=w;function k(o){return o.replace(/"/g,"&quot;")}e.$3j=k;function D(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$4j=D;function v(o){const s=[],n=o.split("|").map(b=>b.trim());o=n[0];const l=n[1];if(l){const b=/height=(\d+)/.exec(l),h=/width=(\d+)/.exec(l),t=b?b[1]:"",r=h?h[1]:"",a=isFinite(parseInt(r)),i=isFinite(parseInt(t));a&&s.push(`width="${r}"`),i&&s.push(`height="${t}"`)}return{href:o,dimensions:s}}e.$5j=v}),define(Se[100],De([1,0,19,32,16,12,24,15]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=void 0;function E(i,c){const{os:d,tildify:y,relative:S}=c;if(S){const m=p(i,S,d);if(typeof m=="string")return m}let g=i.fsPath;if(d===1&&!L.$i?g=g.replace(/\//g,"\\"):d!==1&&L.$i&&(g=g.replace(/\\/g,"/")),d!==1&&y?.userHome){const m=y.userHome.fsPath;let P;i.scheme!==y.userHome.scheme&&i.path.startsWith(f.$6d.sep)?P=y.userHome.with({path:i.path}).fsPath:P=i.fsPath,g=w(P,m,d)}return(d===1?f.$5d:f.$6d).normalize(A(g,d===1))}e.$hv=E;function p(i,c,d){const y=d===1?f.$5d:f.$6d,S=d===3?R.$$f:R.$ag,g=c.getWorkspace(),u=(0,C.$Mb)(g.folders);if(!u)return;i.scheme!==u.uri.scheme&&i.path.startsWith(f.$6d.sep)&&(i=u.uri.with({path:i.path}));const m=c.getWorkspaceFolder(i);if(!m)return;let P;if(S.isEqual(m.uri,i)?P="":P=S.relativePath(m.uri,i)??"",P&&(P=y.normalize(P)),g.folders.length>1&&!c.noPrefix){const O=m.name?m.name:S.basenameOrAuthority(m.uri);P=P?`${O} \u2022 ${P}`:O}return P}function A(i,c=L.$i){return(0,F.$Mf)(i,c)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$iv=A;let I=Object.create(null);function w(i,c,d=L.OS){if(d===1||!i||!c)return i;let y=I.original===c?I.normalized:void 0;y||(y=c,L.$i&&(y=(0,F.$Cf)(y)),y=`${(0,$.$ve)(y,f.$6d.sep)}${f.$6d.sep}`,I={original:c,normalized:y});let S=i;return L.$i&&(S=(0,F.$Cf)(S)),(d===3?S.startsWith(y):(0,$.$Ne)(S,y))?`~/${S.substr(y.length)}`:i}e.$jv=w;function k(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.$kv=k;const D="\u2026",v="\\\\",o="~";function s(i,c=f.sep){const d=new Array(i.length);let y=!1;for(let S=0;S<i.length;S++){const g=i[S];if(g===""){d[S]=`.${c}`;continue}if(!g){d[S]=g;continue}y=!0;let u="",m=g;m.indexOf(v)===0?(u=m.substr(0,m.indexOf(v)+v.length),m=m.substr(m.indexOf(v)+v.length)):m.indexOf(c)===0?(u=m.substr(0,m.indexOf(c)+c.length),m=m.substr(m.indexOf(c)+c.length)):m.indexOf(o)===0&&(u=m.substr(0,m.indexOf(o)+o.length),m=m.substr(m.indexOf(o)+o.length));const P=m.split(c);for(let O=1;y&&O<=P.length;O++)for(let N=P.length-O;y&&N>=0;N--){y=!1;let M=P.slice(N,N+O).join(c);for(let j=0;!y&&j<i.length;j++)if(j!==S&&i[j]&&i[j].indexOf(M)>-1){const z=N+O===P.length,T=N>0&&i[j].indexOf(c)>-1?c+M:M,H=i[j].endsWith(T);y=!z||H}if(!y){let j="";(P[0].endsWith(":")||u!=="")&&(N===1&&(N=0,O++,M=P[0]+c+M),N>0&&(j=P[0]+c),j=u+j),N>0&&(j=j+D+c),j=j+M,N+O<P.length&&(j=j+c+D),d[S]=j}}y&&(d[S]=g)}return d}e.$lv=s;var n;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function l(i,c=Object.create(null)){const d=[];let y=!1,S="";for(const g of i)if(g==="$"||y&&g==="{")S&&d.push({value:S,type:n.TEXT}),S="",y=!0;else if(g==="}"&&y){const u=c[S];if(typeof u=="string")u.length&&d.push({value:u,type:n.VARIABLE});else if(u){const m=d[d.length-1];(!m||m.type!==n.SEPARATOR)&&d.push({value:u.label,type:n.SEPARATOR})}S="",y=!1}else S+=g;return S&&!y&&d.push({value:S,type:n.TEXT}),d.filter((g,u)=>{if(g.type===n.SEPARATOR){const m=d[u-1],P=d[u+1];return[m,P].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map(g=>g.value).join("")}e.$mv=l;function b(i,c){return L.$j||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):i.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$nv=b;function h(i,c){return L.$j||c?i.replace(/\(&&\w\)|&&/g,""):L.$i?i.replace(/&&|&/g,d=>d==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$ov=h;function t(i){return i.replace(/&/g,"&&")}e.$pv=t;function r(i){if(i.endsWith("]")){const c=i.lastIndexOf(" [",i.length-2);if(c!==-1){const d=a(i.substring(0,c));return{name:d.name,parentPath:d.parentPath+i.substring(c)}}}return a(i)}e.$qv=r;function a(i){const c=i.indexOf("/")!==-1?f.$6d:f.$5d,d=c.basename(i),y=c.dirname(i);return d.length?{name:d,parentPath:y}:{name:y,parentPath:""}}}),define(Se[128],De([1,0,22,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=void 0;function f(I){return I.toJSON()}class L{constructor(w){this.a=w}transformIncoming(w){const k=this.a.transformIncoming(w);return k===w?w:f(F.URI.from(k))}transformOutgoing(w){const k=this.a.transformOutgoing(w);return k===w?w:f(F.URI.from(k))}transformOutgoingURI(w){const k=this.a.transformOutgoing(w);return k===w?w:F.URI.from(k)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Bm=L,e.$Cm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,w,k){if(!I||k>200)return null;if(typeof I=="object"){if(I instanceof F.URI)return w.transformOutgoing(I);for(const D in I)if(Object.hasOwnProperty.call(I,D)){const v=R(I[D],w,k+1);v!==null&&(I[D]=v)}}return null}function $(I,w){const k=R(I,w,0);return k===null?I:k}e.$Dm=$;function E(I,w,k,D){if(!I||D>200)return null;if(typeof I=="object"){if(I.$mid===1)return k?F.URI.revive(w.transformIncoming(I)):w.transformIncoming(I);if(I instanceof C.$Fd)return null;for(const v in I)if(Object.hasOwnProperty.call(I,v)){const o=E(I[v],w,k,D+1);o!==null&&(I[v]=o)}}return null}function p(I,w){const k=E(I,w,!1,0);return k===null?I:k}e.$Em=p;function A(I,w){const k=E(I,w,!0,0);return k===null?I:k}e.$Fm=A}),define(Se[29],De([1,0,52,64,371,9,32,77,16,12,24,2]),function($e,e,C,F,f,L,R,$,E,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function k(T,H=w.UNLINK,q){if((0,R.$Lf)(T))throw new Error("rimraf - will refuse to recursively delete root");return H===w.UNLINK?v(T):D(T,q)}async function D(T,H=(0,R.$Qf)((0,F.tmpdir)())){try{try{await C.promises.rename(T,H)}catch(q){return q.code==="ENOENT"?void 0:v(T)}v(H).catch(q=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function v(T){return(0,f.promisify)(C.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function o(T){if((0,R.$Lf)(T))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function s(T,H){return b(await(H?n(T):(0,f.promisify)(C.readdir)(T)))}async function n(T){try{return await(0,f.promisify)(C.readdir)(T,{withFileTypes:!0})}catch(me){console.warn("[node.js fs] readdir with filetypes failed with error: ",me)}const H=[],q=await s(T);for(const me of q){let Z=!1,X=!1,V=!1;try{const x=await e.Promises.lstat((0,E.$9d)(T,me));Z=x.isFile(),X=x.isDirectory(),V=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}H.push({name:me,isFile:()=>Z,isDirectory:()=>X,isSymbolicLink:()=>V})}return H}function l(T){return b(C.readdirSync(T))}e.readdirSync=l;function b(T){return T.map(H=>typeof H=="string"?p.$j?(0,$.$hl)(H):H:(H.name=p.$j?(0,$.$hl)(H.name):H.name,H))}async function h(T){const H=await s(T),q=[];for(const me of H)await r.existsDirectory((0,E.$9d)(T,me))&&q.push(me);return q}function t(T,H=1e3){return new Promise(q=>{let me=!1;const Z=setInterval(()=>{me||(me=!0,C.access(T,X=>{me=!1,X&&(clearInterval(Z),q(void 0))}))},H)})}e.whenDeleted=t;var r;(function(T){async function H(Z){let X;try{if(X=await e.Promises.lstat(Z),!X.isSymbolicLink())return{stat:X}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:X?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};if(p.$i&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};throw x}throw V}}T.stat=H;async function q(Z){try{const{stat:X,symbolicLink:V}=await T.stat(Z);return X.isFile()&&V?.dangling!==!0}catch{}return!1}T.existsFile=q;async function me(Z){try{const{stat:X,symbolicLink:V}=await T.stat(Z);return X.isDirectory()&&V?.dangling!==!0}catch{}return!1}T.existsDirectory=me})(r||(e.SymlinkSupport=r={}));const a=new L.$Pg;function i(T,H,q){return a.queueFor(I.URI.file(T),A.$_f).queue(()=>{const me=g(q);return new Promise((Z,X)=>y(T,H,me,V=>V?X(V):Z()))})}let c=!0;function d(T){c=T}e.configureFlushOnWrite=d;function y(T,H,q,me){if(!c)return C.writeFile(T,H,{mode:q.mode,flag:q.flag},me);C.open(T,q.flag,q.mode,(Z,X)=>{if(Z)return me(Z);C.writeFile(X,H,V=>{if(V)return C.close(X,()=>me(V));C.fdatasync(X,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),d(!1)),C.close(X,ge=>me(ge))))})})}function S(T,H,q){const me=g(q);if(!c)return C.writeFileSync(T,H,{mode:me.mode,flag:me.flag});const Z=C.openSync(T,me.flag,me.mode);try{C.writeFileSync(Z,H);try{C.fdatasyncSync(Z)}catch(X){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",X),d(!1)}}finally{C.closeSync(Z)}}e.writeFileSync=S;function g(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function u(T,H,q=6e4){if(T!==H)try{p.$i&&typeof q=="number"?await m(T,H,Date.now(),q):await(0,f.promisify)(C.rename)(T,H)}catch(me){if(T.toLowerCase()!==H.toLowerCase()&&me.code==="EXDEV"||T.endsWith("."))await P(T,H,{preserveSymlinks:!1}),await k(T,w.MOVE);else throw me}}async function m(T,H,q,me,Z=0){try{return await(0,f.promisify)(C.rename)(T,H)}catch(X){if(X.code!=="EACCES"&&X.code!=="EPERM"&&X.code!=="EBUSY")throw X;if(Date.now()-q>=me)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${X}`),X;if(Z===0){let V=!1;try{const{stat:x}=await r.stat(H);x.isFile()||(V=!0)}catch{}if(V)throw X}return await(0,L.$Hg)(Math.min(100,Z*10)),m(T,H,q,me,Z+1)}}async function P(T,H,q){return N(T,H,{root:{source:T,target:H},options:q,handledSourcePaths:new Set})}const O=511;async function N(T,H,q){if(q.handledSourcePaths.has(T))return;q.handledSourcePaths.add(T);const{stat:me,symbolicLink:Z}=await r.stat(T);if(Z){if(q.options.preserveSymlinks)try{return await z(T,H,q)}catch(X){console.warn("[node.js fs] copy of symlink failed: ",X)}if(Z.dangling)return}return me.isDirectory()?M(T,H,me.mode&O,q):j(T,H,me.mode&O)}async function M(T,H,q,me){await e.Promises.mkdir(H,{recursive:!0,mode:q});const Z=await s(T);for(const X of Z)await N((0,E.$9d)(T,X),(0,E.$9d)(H,X),me)}async function j(T,H,q){await e.Promises.copyFile(T,H),await e.Promises.chmod(H,q)}async function z(T,H,q){let me=await e.Promises.readlink(T);(0,R.$If)(me,q.root.source,!p.$k)&&(me=(0,E.$9d)(q.root.target,me.substr(q.root.source.length+1))),await e.Promises.symlink(me,H)}e.Promises=new class{get access(){return(0,f.promisify)(C.access)}get stat(){return(0,f.promisify)(C.stat)}get lstat(){return(0,f.promisify)(C.lstat)}get utimes(){return(0,f.promisify)(C.utimes)}get read(){return(T,H,q,me,Z)=>new Promise((X,V)=>{C.read(T,H,q,me,Z,(x,ge,ue)=>x?V(x):X({bytesRead:ge,buffer:ue}))})}get readFile(){return(0,f.promisify)(C.readFile)}get write(){return(T,H,q,me,Z)=>new Promise((X,V)=>{C.write(T,H,q,me,Z,(x,ge,ue)=>x?V(x):X({bytesWritten:ge,buffer:ue}))})}get appendFile(){return(0,f.promisify)(C.appendFile)}get fdatasync(){return(0,f.promisify)(C.fdatasync)}get truncate(){return(0,f.promisify)(C.truncate)}get copyFile(){return(0,f.promisify)(C.copyFile)}get open(){return(0,f.promisify)(C.open)}get close(){return(0,f.promisify)(C.close)}get symlink(){return(0,f.promisify)(C.symlink)}get readlink(){return(0,f.promisify)(C.readlink)}get chmod(){return(0,f.promisify)(C.chmod)}get mkdir(){return(0,f.promisify)(C.mkdir)}get unlink(){return(0,f.promisify)(C.unlink)}get rmdir(){return(0,f.promisify)(C.rmdir)}get realpath(){return(0,f.promisify)(C.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return h}get writeFile(){return i}get rm(){return k}get rename(){return u}get copy(){return P}}}),define(Se[101],De([1,0,52,16,12,15,29]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function $(w){if(f.$k)return w;const k=(0,F.$_d)(w);if(w===k)return w;const D=((0,F.$ae)(w)||w).toLowerCase();try{const o=(0,R.readdirSync)(k).filter(s=>s.toLowerCase()===D);if(o.length===1){const s=$(k);if(s)return(0,F.$9d)(s,o[0])}else if(o.length>1){const s=o.indexOf(D);if(s>=0){const n=$(k);if(n)return(0,F.$9d)(n,o[s])}}}catch{}return null}e.$Up=$;async function E(w){if(f.$k)return w;const k=(0,F.$_d)(w);if(w===k)return w;const D=((0,F.$ae)(w)||w).toLowerCase();try{const o=(await R.Promises.readdir(k)).filter(s=>s.toLowerCase()===D);if(o.length===1){const s=await E(k);if(s)return(0,F.$9d)(s,o[0])}else if(o.length>1){const s=o.indexOf(D);if(s>=0){const n=await E(k);if(n)return(0,F.$9d)(n,o[s])}}}catch{}return null}e.$Vp=E;async function p(w){try{return await R.Promises.realpath(w)}catch{const D=I(w);return await R.Promises.access(D,C.constants.R_OK),D}}e.$Wp=p;function A(w){try{return C.realpathSync(w)}catch{const D=I(w);return C.accessSync(D,C.constants.R_OK),D}}e.$Xp=A;function I(w){return(0,L.$ve)((0,F.$7d)(w),F.sep)}}),define(Se[102],De([1,0,16,12,47,99,18,29]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(I=f.env){return I.comspec||"cmd.exe"}e.$ul=E;function p(I){let w=[],k=!1;const D=function(v){if(k){w.push(v);return}(!I.send(v,s=>{if(s&&console.error(s),k=!1,w.length>0){const n=w.slice(0);w=[],n.forEach(l=>D(l))}})||F.$i)&&(k=!0)};return{send:D}}e.$vl=p;var A;(function(I){async function w(k,D,v){if(C.$8d(k))return k;if(D===void 0&&(D=f.cwd()),C.$_d(k)!=="."||(v===void 0&&R.$jf(f.env.PATH)&&(v=f.env.PATH.split(C.$ge)),v===void 0||v.length===0))return C.$9d(D,k);async function s(n){if(await $.Promises.exists(n)){let l;try{l=await $.Promises.stat(n)}catch(b){b.message.startsWith("EACCES")&&(l=await $.Promises.lstat(n))}return l?!l.isDirectory():!1}return!1}for(const n of v){let l;if(C.$8d(n)?l=C.$9d(n,k):l=C.$9d(D,n,k),await s(l))return l;let b=l+".com";if(await s(b)||(b=l+".exe",await s(b)))return b}return C.$9d(D,k)}I.findExecutable=w})(A||(e.win32=A={}))});var Ke=this&&this.__decorate||function($e,e,C,F){var f=arguments.length,L=f<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,C):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($e,e,C,F);else for(var $=$e.length-1;$>=0;$--)(R=$e[$])&&(L=(f<3?R(L):f>3?R(e,C,L):R(e,C))||L);return f>3&&L&&Object.defineProperty(e,C,L),L};define(Se[81],De([1,0,19,9,22,21,57,8,4,3,63,15,18]),function($e,e,C,F,f,L,R,$,E,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.ProxyChannel=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.RequestInitiator=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=void 0;var k;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(k||(k={}));function D(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(v||(v={}));function o(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(s||(s={}));function n(Z){let X=0;for(let V=0;;V+=7){const x=Z.read(1);if(X|=(x.buffer[0]&127)<<V,!(x.buffer[0]&128))return X}}const l=a(0);function b(Z,X){if(X===0){Z.write(l);return}let V=0;for(let ge=X;ge!==0;ge=ge>>>7)V++;const x=f.$Fd.alloc(V);for(let ge=0;X!==0;ge++)x.buffer[ge]=X&127,X=X>>>7,X>0&&(x.buffer[ge]|=128);Z.write(x)}class h{constructor(X){this.b=X,this.a=0}read(X){const V=this.b.slice(this.a,this.a+X);return this.a+=V.byteLength,V}}e.$_g=h;class t{constructor(){this.a=[]}get buffer(){return f.$Fd.concat(this.a)}write(X){this.a.push(X)}}e.$ah=t;var r;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(r||(r={}));function a(Z){const X=f.$Fd.alloc(1);return X.writeUInt8(Z,0),X}const i={Undefined:a(r.Undefined),String:a(r.String),Buffer:a(r.Buffer),VSBuffer:a(r.VSBuffer),Array:a(r.Array),Object:a(r.Object),Uint:a(r.Int)},c=typeof Buffer<"u";function d(Z,X){if(typeof X>"u")Z.write(i.Undefined);else if(typeof X=="string"){const V=f.$Fd.fromString(X);Z.write(i.String),b(Z,V.byteLength),Z.write(V)}else if(c&&Buffer.isBuffer(X)){const V=f.$Fd.wrap(X);Z.write(i.Buffer),b(Z,V.byteLength),Z.write(V)}else if(X instanceof f.$Fd)Z.write(i.VSBuffer),b(Z,X.byteLength),Z.write(X);else if(Array.isArray(X)){Z.write(i.Array),b(Z,X.length);for(const V of X)d(Z,V)}else if(typeof X=="number"&&(X|0)===X)Z.write(i.Uint),b(Z,X);else{const V=f.$Fd.fromString(JSON.stringify(X));Z.write(i.Object),b(Z,V.byteLength),Z.write(V)}}e.$bh=d;function y(Z){switch(Z.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return Z.read(n(Z)).toString();case r.Buffer:return Z.read(n(Z)).buffer;case r.VSBuffer:return Z.read(n(Z));case r.Array:{const V=n(Z),x=[];for(let ge=0;ge<V;ge++)x.push(y(Z));return x}case r.Object:return JSON.parse(Z.read(n(Z)).toString());case r.Int:return n(Z)}}e.$ch=y;class S{constructor(X,V,x=null,ge=1e3){this.h=X,this.j=V,this.k=x,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ue=>this.q(ue)),this.m({type:200})}registerChannel(X,V){this.b.set(X,V),setTimeout(()=>this.w(X),0)}m(X){switch(X.type){case 200:{const V=this.o([X.type]);this.k?.logOutgoing(V,0,1,o(X.type));return}case 201:case 202:case 204:case 203:{const V=this.o([X.type,X.id],X.data);this.k?.logOutgoing(V,X.id,1,o(X.type),X.data);return}}}o(X,V=void 0){const x=new t;return d(x,X),d(x,V),this.p(x.buffer)}p(X){try{return this.h.send(X),X.byteLength}catch{return 0}}q(X){const V=new h(X),x=y(V),ge=y(V),ue=x[0];switch(ue){case 100:return this.k?.logIncoming(X.byteLength,x[1],1,`${D(ue)}: ${x[2]}.${x[3]}`,ge),this.s({type:ue,id:x[1],channelName:x[2],name:x[3],arg:ge});case 102:return this.k?.logIncoming(X.byteLength,x[1],1,`${D(ue)}: ${x[2]}.${x[3]}`,ge),this.t({type:ue,id:x[1],channelName:x[2],name:x[3],arg:ge});case 101:return this.k?.logIncoming(X.byteLength,x[1],1,`${D(ue)}`),this.u({type:ue,id:x[1]});case 103:return this.k?.logIncoming(X.byteLength,x[1],1,`${D(ue)}`),this.u({type:ue,id:x[1]})}}s(X){const V=this.b.get(X.channelName);if(!V){this.v(X);return}const x=new L.$pd;let ge;try{ge=V.call(this.j,X.name,X.arg,x.token)}catch(G){ge=Promise.reject(G)}const ue=X.id;ge.then(G=>{this.m({id:ue,data:G,type:201})},G=>{G instanceof Error?this.m({id:ue,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:ue,data:G,type:203})}).finally(()=>{ve.dispose(),this.d.delete(X.id)});const ve=(0,p.$ic)(()=>x.cancel());this.d.set(X.id,ve)}t(X){const V=this.b.get(X.channelName);if(!V){this.v(X);return}const x=X.id,ue=V.listen(this.j,X.name,X.arg)(ve=>this.m({id:x,data:ve,type:204}));this.d.set(X.id,ue)}u(X){const V=this.d.get(X.id);V&&(V.dispose(),this.d.delete(X.id))}v(X){let V=this.g.get(X.channelName);V||(V=[],this.g.set(X.channelName,V));const x=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.m({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:X,timeoutTimer:x})}w(X){const V=this.g.get(X);if(V){for(const x of V)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.s(x.request);break;case 102:this.t(x.request);break}this.g.delete(X)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,p.$fc)(this.d.values()),this.d.clear()}}e.$dh=S;var g;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));class u{constructor(X,V=null){this.l=X,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$fd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(x=>this.s(x)),this.j=V}getChannel(X){const V=this;return{call(x,ge,ue){return V.a?Promise.reject(new $.$3):V.m(X,x,ge,ue)},listen(x,ge){return V.a?E.Event.None:V.o(X,x,ge)}}}m(X,V,x,ge=L.CancellationToken.None){const ue=this.g++,G={id:ue,type:100,channelName:X,name:V,arg:x};if(ge.isCancellationRequested)return Promise.reject(new $.$3);let U;return new Promise((fe,te)=>{if(ge.isCancellationRequested)return te(new $.$3);const se=()=>{const he=ee=>{switch(ee.type){case 201:this.f.delete(ue),fe(ee.data);break;case 202:{this.f.delete(ue);const le=new Error(ee.data.message);le.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,le.name=ee.data.name,te(le);break}case 203:this.f.delete(ue),te(ee.data);break}};this.f.set(ue,he),this.p(G)};let ne=null;this.b===s.Idle?se():(ne=(0,F.$ug)(he=>this.u()),ne.then(()=>{ne=null,se()}));const Ee=()=>{ne?(ne.cancel(),ne=null):this.p({id:ue,type:101}),te(new $.$3)},oe=ge.onCancellationRequested(Ee);U=(0,p.$hc)((0,p.$ic)(Ee),oe),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(X,V,x){const ge=this.g++,ve={id:ge,type:102,channelName:X,name:V,arg:x};let G=null;const U=new E.$fd({onWillAddFirstListener:()=>{G=(0,F.$ug)(fe=>this.u()),G.then(()=>{G=null,this.d.add(U),this.p(ve)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(U),this.p({id:ge,type:103}))}}),K=fe=>U.fire(fe.data);return this.f.set(ge,K),U.event}p(X){switch(X.type){case 100:case 102:{const V=this.q([X.type,X.id,X.channelName,X.name],X.arg);this.j?.logOutgoing(V,X.id,0,`${D(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const V=this.q([X.type,X.id]);this.j?.logOutgoing(V,X.id,0,D(X.type));return}}}q(X,V=void 0){const x=new t;return d(x,X),d(x,V),this.r(x.buffer)}r(X){try{return this.l.send(X),X.byteLength}catch{return 0}}s(X){const V=new h(X),x=y(V),ge=y(V),ue=x[0];switch(ue){case 200:return this.j?.logIncoming(X.byteLength,0,0,o(ue)),this.t({type:x[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(X.byteLength,x[1],0,o(ue),ge),this.t({type:x[0],id:x[1],data:ge})}}t(X){if(X.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(X.id)?.(X)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,p.$fc)(this.d.values()),this.d.clear()}}e.$eh=u,Ke([R.$6g],u.prototype,"onDidInitializePromise",null);class m{get connections(){const X=[];return this.f.forEach(V=>X.push(V)),X}constructor(X){this.a=new Map,this.f=new Set,this.g=new E.$fd,this.onDidAddConnection=this.g.event,this.h=new E.$fd,this.onDidRemoveConnection=this.h.event,this.j=new p.$jc,this.j.add(X(({protocol:V,onDidClientDisconnect:x})=>{const ge=E.Event.once(V.onMessage);this.j.add(ge(ue=>{const ve=new h(ue),G=y(ve),U=new S(V,G),K=new u(V);this.a.forEach((te,se)=>U.registerChannel(se,te));const fe={channelServer:U,channelClient:K,ctx:G};this.f.add(fe),this.g.fire(fe),this.j.add(x(()=>{U.dispose(),K.dispose(),this.f.delete(fe),this.h.fire(fe)}))}))}))}getChannel(X,V){const x=this;return{call(ge,ue,ve){let G;if((0,w.$xf)(V)){const K=(0,C.$2b)(x.connections.filter(V));G=K?Promise.resolve(K):E.Event.toPromise(E.Event.filter(x.onDidAddConnection,V))}else G=V.routeCall(x,ge,ue);const U=G.then(K=>K.channelClient.getChannel(X));return O(U).call(ge,ue,ve)},listen(ge,ue){if((0,w.$xf)(V))return x.k(X,V,ge,ue);const ve=V.routeEvent(x,ge,ue).then(G=>G.channelClient.getChannel(X));return O(ve).listen(ge,ue)}}}k(X,V,x,ge){const ue=this;let ve;const G=new E.$fd({onWillAddFirstListener:()=>{ve=new p.$jc;const U=new E.$ld,K=new Map,fe=se=>{const Ee=se.channelClient.getChannel(X).listen(x,ge),oe=U.add(Ee);K.set(se,oe)},te=se=>{const ne=K.get(se);ne&&(ne.dispose(),K.delete(se))};ue.connections.filter(V).forEach(fe),E.Event.filter(ue.onDidAddConnection,V)(fe,void 0,ve),ue.onDidRemoveConnection(te,void 0,ve),U.event(G.fire,G,ve),ve.add(U)},onDidRemoveLastListener:()=>{ve?.dispose(),ve=void 0}});return G.event}registerChannel(X,V){this.a.set(X,V);for(const x of this.f)x.channelServer.registerChannel(X,V)}dispose(){this.j.dispose();for(const X of this.f)X.channelClient.dispose(),X.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$fh=m;class P{constructor(X,V,x=null){const ge=new t;d(ge,V),X.send(ge.buffer),this.a=new u(X,x),this.d=new S(X,V,x)}getChannel(X){return this.a.getChannel(X)}registerChannel(X,V){this.d.registerChannel(X,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$gh=P;function O(Z){return{call(X,V,x){return Z.then(ge=>ge.call(X,V,x))},listen(X,V){const x=new E.$od;return Z.then(ge=>x.input=ge.listen(X,V)),x.event}}}e.$hh=O;function N(Z){let X=!1;return{call(V,x,ge){return X?Z.call(V,x,ge):(0,F.$Hg)(0).then(()=>X=!0).then(()=>Z.call(V,x,ge))},listen(V,x){if(X)return Z.listen(V,x);const ge=new E.$od;return(0,F.$Hg)(0).then(()=>X=!0).then(()=>ge.input=Z.listen(V,x)),ge.event}}}e.$ih=N;class M{constructor(X){this.a=X}routeCall(X){return this.b(X)}routeEvent(X){return this.b(X)}async b(X){for(const V of X.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await E.Event.toPromise(X.onDidAddConnection),await this.b(X)}}e.$jh=M;var j;(function(Z){function X(ue,ve,G){const U=ue,K=G&&G.disableMarshalling,fe=new Map;for(const te in U)x(te)&&fe.set(te,E.Event.buffer(U[te],!0,void 0,ve));return new class{listen(te,se,ne){const Ee=fe.get(se);if(Ee)return Ee;if(ge(se)){const oe=U[se];if(typeof oe=="function")return oe.call(U,ne)}throw new $.$_(`Event not found: ${se}`)}call(te,se,ne){const Ee=U[se];if(typeof Ee=="function"){if(!K&&Array.isArray(ne))for(let oe=0;oe<ne.length;oe++)ne[oe]=(0,A.$$g)(ne[oe]);return Ee.apply(U,ne)}throw new $.$_(`Method not found: ${se}`)}}}Z.fromService=X;function V(ue,ve){const G=ve&&ve.disableMarshalling;return new Proxy({},{get(U,K){if(typeof K=="string")return ve?.properties?.has(K)?ve.properties.get(K):ge(K)?function(fe){return ue.listen(K,fe)}:x(K)?ue.listen(K):async function(...fe){let te;ve&&!(0,w.$sf)(ve.context)?te=[ve.context,...fe]:te=fe;const se=await ue.call(K,te);return G?se:(0,A.$$g)(se)};throw new $.$_(`Property not found: ${String(K)}`)}})}Z.toService=V;function x(ue){return ue[0]==="o"&&ue[1]==="n"&&I.$Le(ue.charCodeAt(2))}function ge(ue){return/^onDynamic/.test(ue)&&I.$Le(ue.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const X=Z.toString();if(X!=="[object Object]")return X}return Z}function H(Z){return Array.isArray(Z)?Z.map(T):T(Z)}function q(Z,X,V,x,ge,ue,ve){ve=H(ve);const G=z[ge],U=G[x%G.length];let K=[`%c[${Z}]%c[${String(X).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ue)?(K=K.concat(ve),K.push(")")):K.push(ve),console.log.apply(console,K)}class me{constructor(X,V){this.d=X,this.f=V,this.a=0,this.b=0}logOutgoing(X,V,x,ge,ue){this.b+=X,q(this.d,this.b,X,V,x,ge,ue)}logIncoming(X,V,x,ge,ue){this.a+=X,q(this.f,this.a,X,V,x,ge,ue)}}e.$kh=me}),define(Se[82],De([1,0,22,4,3,81]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=e.$mh=e.ProtocolConstants=e.$lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var $;(function(i){i.enableDiagnostics=!1,i.records=[];const c=new WeakMap;let d=0;function y(g,u){if(!c.has(g)){const m=String(++d);c.set(g,m)}return c.get(g)}function S(g,u,m,P){if(!i.enableDiagnostics)return;const O=y(g,u);if(P instanceof C.$Fd||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const N=C.$Fd.alloc(P.byteLength);N.set(P),i.records.push({timestamp:Date.now(),id:O,label:u,type:m,buff:N})}else i.records.push({timestamp:Date.now(),id:O,label:u,type:m,data:P})}i.traceSocketEvent=S})($||(e.SocketDiagnostics=$={}));var E;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let p=null;function A(){return p||(p=C.$Fd.alloc(0)),p}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,d){if(c===0)return A();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const u=this.a[0];return d&&(this.a.shift(),this.b-=c),u}if(this.a[0].byteLength>c){const u=this.a[0].slice(0,c);return d&&(this.a[0]=this.a[0].slice(c),this.b-=c),u}const y=C.$Fd.alloc(c);let S=0,g=0;for(;c>0;){const u=this.a[g];if(u.byteLength>c){const m=u.slice(0,c);y.set(m,S),S+=c,d&&(this.a[g]=u.slice(c),this.b-=c),c-=c}else y.set(u,S),S+=u.byteLength,d?(this.a.shift(),this.b-=u.byteLength):g++,c-=u.byteLength}return y}}e.$lh=I;var w;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(w||(w={}));function k(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class v{constructor(c,d,y,S){this.type=c,this.id=d,this.ack=y,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class o extends f.$kc{constructor(c){super(),this.f=this.B(new F.$fd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new I,this.B(this.a.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const d=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=d.readUInt32BE(9),this.g.messageType=d.readUInt8(0),this.g.id=d.readUInt32BE(1),this.g.ack=d.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const y=this.g.messageType,S=this.g.id,g=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",d),this.f.fire(new v(y,S,g,d)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=C.$Fd.alloc(13);d.writeUInt8(c.type,0),d.writeUInt32BE(c.id,1),d.writeUInt32BE(c.ack,5),d.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:k(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(d,c.data)}g(c,d){const y=this.f===0;return this.d.push(c,d),this.f+=c.byteLength+d.byteLength,y}h(){const c=C.$Fd.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,d){this.g(c,d)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class n extends f.$kc{constructor(c){super(),this.f=new F.$fd,this.onMessage=this.f.event,this.g=new F.$fd,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new s(this.a)),this.c=this.B(new o(this.a)),this.B(this.c.onMessage(d=>{d.type===1&&this.f.fire(d.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new v(1,0,0,c))}}e.$mh=n;class l extends L.$gh{static fromSocket(c,d){return new l(new n(c),d)}get onDidDispose(){return this.b.onDidDispose}constructor(c,d,y=null){super(c,d,y),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$nh=l;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$fd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$oh=b;class h{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,d=this.a;for(;d;)d=d.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let d=0,y=this.a;for(;y;)c[d++]=y.data,y=y.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const d=new h(c);if(!this.a){this.a=d,this.b=d;return}this.b.next=d,this.b=d}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const c=Date.now();for(let d=0;d<r.a;d++)this.c[d]=c-1e3*d;setInterval(()=>{for(let d=r.a;d>=1;d--)this.c[d]=this.c[d-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),d=(1+r.a)*1e3;let y=0;for(let S=0;S<r.a;S++)c-this.c[S]<=d&&y++;return 1-y/r.a}hasHighLoad(){return this.d()>=.5}}class a{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new b,this.onControlMessage=this.u.event,this.v=new b,this.onMessage=this.v.event,this.w=new b,this.onDidDispose=this.w.event,this.x=new b,this.onSocketClose=this.x.event,this.y=new b,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??r.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$jc,this.o=c.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new o(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new v(5,0,0,A());this.p.write(c),this.p.flush()}sendPause(){const c=new v(7,0,0,A());this.p.write(c)}sendResume(){const c=new v(8,0,0,A());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,d){this.a=!0,this.r.dispose(),this.r=new f.$jc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new o(this.o)),this.r.add(this.q.onMessage(y=>this.z(y))),this.r.add(this.o.onClose(y=>this.x.fire(y))),this.q.acceptChunk(d)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new v(3,0,this.h,A());this.p.write(c);const d=this.b.toArray();for(let y=0,S=d.length;y<S;y++)this.p.write(d[y]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const d=this.b.peek();if(d&&d.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const d=Date.now();d-this.m>1e4&&(this.m=d,this.p.write(new v(6,0,0,A())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const d=this.b.toArray();for(let y=0,S=d.length;y<S;y++)this.p.write(d[y]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const d=++this.c;this.h=this.g;const y=new v(1,d,this.h,c);this.b.push(y),this.a||(this.p.write(y),this.B())}sendControl(c){const d=new v(2,0,0,c);this.p.write(d)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),d=Date.now()-c.writtenTime,y=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(d>=2e4&&y>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:y});return}const g=Math.max(2e4-d,2e4-y,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},g)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new v(3,0,this.h,A());this.p.write(c)}D(){this.h=this.g;const c=new v(9,0,this.h,A());this.p.write(c)}}e.$ph=a}),define(Se[183],De([1,0,48,9,22,21,181,8,4,3,23,102,99,81]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0;class D extends k.$dh{constructor(s){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",n=>f.$Fd.wrap(Buffer.from(n,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$Rp=D;class v{constructor(s,n){this.i=s,this.j=n,this.c=new Set,this.g=new Map,this.h=new E.$fd,this.onDidProcessExit=this.h.event;const l=n&&n.timeout?n.timeout:6e4;this.b=new F.$Dg(l),this.d=null,this.f=null}getChannel(s){const n=this;return{call(l,b,h){return n.k(s,l,b,h)},listen(l,b){return n.l(s,l,b)}}}k(s,n,l,b=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject($.$4());this.b.cancel();const h=this.n(s),t=(0,F.$ug)(i=>h.call(n,l,i)),r=b.onCancellationRequested(()=>t.cancel()),a=(0,p.$ic)(()=>t.cancel());return this.c.add(a),t.finally(()=>{r.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,n,l){if(!this.b)return E.Event.None;this.b.cancel();let b;const h=new E.$fd({onWillAddFirstListener:()=>{b=this.n(s).listen(n,l)(h.fire,h),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$Vm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,w.$tl)(n.env),this.d=(0,C.fork)(this.i,s,n);const l=new E.$fd;E.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,R.$Np)(c)){(0,R.log)(c,`IPC Library: ${this.j.serverName}`);return}l.fire(f.$Fd.wrap(Buffer.from(c,"base64")))});const h=this.j.useQueue?(0,I.$vl)(this.d):this.d,t=c=>this.d&&this.d.connected&&h.send(c.buffer.toString("base64")),r=l.event,a={send:t,onMessage:r};this.f=new k.$eh(a);const i=()=>this.o();process.once("exit",i),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,d)=>{process.removeListener("exit",i),this.c.forEach(y=>(0,p.$fc)(y)),this.c.clear(),c!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:d})})}return this.f}n(s){let n=this.g.get(s);return n||(n=this.m.getChannel(s),this.g.set(s,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sp=v}),define(Se[184],De([1,0,9,4,3,63,18]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.StorageState=e.$Qo=e.StorageHint=void 0;var $;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})($||(e.StorageHint=$={}));function E(w){const k=w;return k?.changed instanceof Map||k?.deleted instanceof Set}e.$Qo=E;var p;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(p||(e.StorageState=p={}));class A extends f.$kc{static{this.a=100}constructor(k,D=Object.create(null)){super(),this.r=k,this.s=D,this.b=this.B(new F.$id),this.onDidChangeStorage=this.b.event,this.c=p.None,this.f=new Map,this.g=this.B(new C.$Eg(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach((D,v)=>this.w(v,D)),k.deleted?.forEach(D=>this.w(D,void 0))}finally{this.b.resume()}}w(k,D){if(this.c===p.Closed)return;let v=!1;(0,R.$sf)(D)?v=this.f.delete(k):this.f.get(k)!==D&&(this.f.set(k,D),v=!0),v&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===p.None&&(this.c=p.Initialized,this.s.hint!==$.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,D){const v=this.f.get(k);return(0,R.$sf)(v)?D:v}getBoolean(k,D){const v=this.get(k);return(0,R.$sf)(v)?D:v==="true"}getNumber(k,D){const v=this.get(k);return(0,R.$sf)(v)?D:parseInt(v,10)}getObject(k,D){const v=this.get(k);return(0,R.$sf)(v)?D:(0,L.$0g)(v)}async set(k,D,v=!1){if(this.c===p.Closed)return;if((0,R.$sf)(D))return this.delete(k,v);const o=(0,R.$lf)(D)||Array.isArray(D)?(0,L.$9g)(D):String(D);if(this.f.get(k)!==o)return this.f.set(k,o),this.j.set(k,o),this.h.delete(k),this.b.fire({key:k,external:v}),this.D()}async delete(k,D=!1){if(!(this.c===p.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:D}),this.D()}async optimize(){if(this.c!==p.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=p.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(this.z)return this.D(k)}async D(k){return this.s.hint===$.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===$.STORAGE_IN_MEMORY}}e.$Ro=A;class I{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((D,v)=>this.a.set(v,D)),k.delete?.forEach(D=>this.a.delete(D))}async optimize(){}async close(){}}e.$So=I}),define(Se[185],De([1,0,35,16]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gE=void 0;function f(L,R,$,E,p,A){if(Array.isArray(L)){let I=0;for(const w of L){const k=f(w,R,$,E,p,A);if(k===10)return k;k>I&&(I=k)}return I}else{if(typeof L=="string")return E?L==="*"?5:L===$?10:0:0;if(L){const{language:I,pattern:w,scheme:k,hasAccessToAllModels:D,notebookType:v}=L;if(!E&&!D)return 0;v&&p&&(R=p);let o=0;if(k)if(k===R.scheme)o=10;else if(k==="*")o=5;else return 0;if(I)if(I===$)o=10;else if(I==="*")o=Math.max(o,5);else return 0;if(v)if(v===A)o=10;else if(v==="*"&&A!==void 0)o=Math.max(o,5);else return 0;if(w){let s;if(typeof w=="string"?s=w:s={...w,base:(0,F.$7d)(w.base)},s===R.fsPath||(0,C.$qj)(s,R.fsPath))o=10;else return 0}return o}else return 0}}e.$gE=f}),define(Se[129],De([1,0,22,12]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w0=e.$v0=void 0;var f;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(f||(f={}));function L(I){for(let w=0,k=I.length;w<k;w+=4){const D=I[w+0],v=I[w+1],o=I[w+2],s=I[w+3];I[w+0]=s,I[w+1]=o,I[w+2]=v,I[w+3]=D}}function R(I){const w=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.$C()||L(w),C.$Fd.wrap(w)}function $(I){const w=I.buffer;if(F.$C()||L(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const k=new Uint8Array(w.byteLength);return k.set(w),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function E(I){const w=new Uint32Array(p(I));let k=0;if(w[k++]=I.id,I.type==="full")w[k++]=1,w[k++]=I.data.length,w.set(I.data,k),k+=I.data.length;else{w[k++]=2,w[k++]=I.deltas.length;for(const D of I.deltas)w[k++]=D.start,w[k++]=D.deleteCount,D.data?(w[k++]=D.data.length,w.set(D.data,k),k+=D.data.length):w[k++]=0}return R(w)}e.$v0=E;function p(I){let w=0;if(w+=1+1,I.type==="full")w+=1+I.data.length;else{w+=1,w+=(1+1+1)*I.deltas.length;for(const k of I.deltas)k.data&&(w+=k.data.length)}return w}function A(I){const w=$(I);let k=0;const D=w[k++];if(w[k++]===1){const n=w[k++],l=w.subarray(k,k+n);return k+=n,{id:D,type:"full",data:l}}const o=w[k++],s=[];for(let n=0;n<o;n++){const l=w[k++],b=w[k++],h=w[k++];let t;h>0&&(t=w.subarray(k,k+h),k+=h),s[n]={start:l,deleteCount:b,data:t}}return{id:D,type:"delta",deltas:s}}e.$w0=A}),define(Se[186],De([10,11]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(Se[130],De([1,0,19,23,12,166,124,186]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class p{constructor(ae){this.c=ae}hasChanged(ae){return this.c[ae]}}e.ConfigurationChangedEvent=p;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class I{constructor(ae,Ce,qe,Ue){this.id=ae,this.name=Ce,this.defaultValue=qe,this.schema=Ue}applyUpdate(ae,Ce){return k(ae,Ce)}compute(ae,Ce,qe){return qe}}class w{constructor(ae,Ce){this.newValue=ae,this.didChange=Ce}}e.ApplyUpdateResult=w;function k(ce,ae){if(typeof ce!="object"||typeof ae!="object"||!ce||!ae)return new w(ae,ce!==ae);if(Array.isArray(ce)||Array.isArray(ae)){const qe=Array.isArray(ce)&&Array.isArray(ae)&&C.$sb(ce,ae);return new w(ae,!qe)}let Ce=!1;for(const qe in ae)if(ae.hasOwnProperty(qe)){const Ue=k(ce[qe],ae[qe]);Ue.didChange&&(ce[qe]=Ue.newValue,Ce=!0)}return new w(ce,Ce)}class D{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,Ce){return k(ae,Ce)}validate(ae){return this.defaultValue}}class v{constructor(ae,Ce,qe,Ue){this.id=ae,this.name=Ce,this.defaultValue=qe,this.schema=Ue}applyUpdate(ae,Ce){return k(ae,Ce)}validate(ae){return typeof ae>"u"?this.defaultValue:ae}compute(ae,Ce,qe){return qe}}function o(ce,ae){return typeof ce>"u"?ae:ce==="false"?!1:!!ce}e.boolean=o;class s extends v{constructor(ae,Ce,qe,Ue=void 0){typeof Ue<"u"&&(Ue.type="boolean",Ue.default=qe),super(ae,Ce,qe,Ue)}validate(ae){return o(ae,this.defaultValue)}}function n(ce,ae,Ce,qe){if(typeof ce>"u")return ae;let Ue=parseInt(ce,10);return isNaN(Ue)?ae:(Ue=Math.max(Ce,Ue),Ue=Math.min(qe,Ue),Ue|0)}e.clampedInt=n;class l extends v{static clampedInt(ae,Ce,qe,Ue){return n(ae,Ce,qe,Ue)}constructor(ae,Ce,qe,Ue,Ze,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=qe,rt.minimum=Ue,rt.maximum=Ze),super(ae,Ce,qe,rt),this.minimum=Ue,this.maximum=Ze}validate(ae){return l.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}function b(ce,ae,Ce,qe){if(typeof ce>"u")return ae;const Ue=h.float(ce,ae);return h.clamp(Ue,Ce,qe)}e.clampedFloat=b;class h extends v{static clamp(ae,Ce,qe){return ae<Ce?Ce:ae>qe?qe:ae}static float(ae,Ce){if(typeof ae=="number")return ae;if(typeof ae>"u")return Ce;const qe=parseFloat(ae);return isNaN(qe)?Ce:qe}constructor(ae,Ce,qe,Ue,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=qe),super(ae,Ce,qe,Ze),this.validationFn=Ue}validate(ae){return this.validationFn(h.float(ae,this.defaultValue))}}class t extends v{static string(ae,Ce){return typeof ae!="string"?Ce:ae}constructor(ae,Ce,qe,Ue=void 0){typeof Ue<"u"&&(Ue.type="string",Ue.default=qe),super(ae,Ce,qe,Ue)}validate(ae){return t.string(ae,this.defaultValue)}}function r(ce,ae,Ce,qe){return typeof ce!="string"?ae:qe&&ce in qe?qe[ce]:Ce.indexOf(ce)===-1?ae:ce}e.stringSet=r;class a extends v{constructor(ae,Ce,qe,Ue,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ue,Ze.default=qe),super(ae,Ce,qe,Ze),this.c=Ue}validate(ae){return r(ae,this.defaultValue,this.c)}}class i extends I{constructor(ae,Ce,qe,Ue,Ze,rt,at=void 0){typeof at<"u"&&(at.type="string",at.enum=Ze,at.default=Ue),super(ae,Ce,qe,at),this.c=Ze,this.d=rt}validate(ae){return typeof ae!="string"?this.defaultValue:this.c.indexOf(ae)===-1?this.defaultValue:this.d(ae)}}function c(ce){switch(ce){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,Ce,qe){return qe===0?ae.accessibilitySupport:qe}}class y extends I{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:$.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{insertSpace:o(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function g(ce){switch(ce){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(u||(e.TextEditorCursorStyle=u={}));function m(ce){switch(ce){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=m;function P(ce){switch(ce){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class O extends D{constructor(){super(140)}compute(ae,Ce,qe){const Ue=["monaco-editor"];return Ce.get(39)&&Ue.push(Ce.get(39)),ae.extraEditorClassName&&Ue.push(ae.extraEditorClassName),Ce.get(73)==="default"?Ue.push("mouse-default"):Ce.get(73)==="copy"&&Ue.push("mouse-copy"),Ce.get(110)&&Ue.push("showUnused"),Ce.get(138)&&Ue.push("showDeprecated"),Ue.join(" ")}}class N extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(ae,Ce,qe){return qe&&ae.emptySelectionClipboard}}class M extends I{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:$.localize(16,null),included:f.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:$.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{cursorMoveOnType:o(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":r(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":r(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(Ce.loop,this.defaultValue.loop)}}}class j extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?j.OFF:ae==="true"?j.ON:ae:ae?j.ON:j.OFF}}e.EditorFontLigatures=j;class z extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",z.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?z.OFF:ae==="true"?z.TRANSLATE:ae:ae?z.TRANSLATE:z.OFF}compute(ae,Ce,qe){return ae.fontInfo.fontVariationSettings}}e.EditorFontVariations=z;class T extends D{constructor(){super(50)}compute(ae,Ce,qe){return ae.fontInfo}}class H extends v{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(ae){const Ce=h.float(ae,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Ce,6,100)}compute(ae,Ce,qe){return ae.fontInfo.fontSize}}class q extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.d,maximum:q.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(l.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,q.d,q.e))}}class me extends I{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:qe,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:qe,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:qe,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:qe,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:qe,description:$.localize(41,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{multiple:r(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??r(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??r(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??r(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??r(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??r(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends I{constructor(){const ae={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ae.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:$.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),delay:l.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:o(Ce.sticky,this.defaultValue.sticky),hidingDelay:l.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(Ce.above,this.defaultValue.above)}}}var X;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(X||(e.RenderMinimap=X={}));class V extends D{constructor(){super(143)}compute(ae,Ce,qe){return V.computeLayout(Ce,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio,glyphMarginDecorationLaneCount:ae.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ae){const Ce=ae.height/ae.lineHeight,qe=Math.floor(ae.paddingTop/ae.lineHeight);let Ue=Math.floor(ae.paddingBottom/ae.lineHeight);ae.scrollBeyondLastLine&&(Ue=Math.max(Ue,Ce-1));const Ze=(qe+ae.viewLineCount+Ue)/(ae.pixelRatio*ae.height),rt=Math.floor(ae.viewLineCount/Ze);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Ue,desiredRatio:Ze,minimapLineCount:rt}}static c(ae,Ce){const qe=ae.outerWidth,Ue=ae.outerHeight,Ze=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const rt=Ce.stableMinimapLayoutInput,at=rt&&ae.outerHeight===rt.outerHeight&&ae.lineHeight===rt.lineHeight&&ae.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ae.pixelRatio===rt.pixelRatio&&ae.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ae.paddingTop===rt.paddingTop&&ae.paddingBottom===rt.paddingBottom&&ae.minimap.enabled===rt.minimap.enabled&&ae.minimap.side===rt.minimap.side&&ae.minimap.size===rt.minimap.size&&ae.minimap.showSlider===rt.minimap.showSlider&&ae.minimap.renderCharacters===rt.minimap.renderCharacters&&ae.minimap.maxColumn===rt.minimap.maxColumn&&ae.minimap.scale===rt.minimap.scale&&ae.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ae.isViewportWrapping===rt.isViewportWrapping,bt=ae.lineHeight,St=ae.typicalHalfwidthCharacterWidth,Xt=ae.scrollBeyondLastLine,Ht=ae.minimap.renderCharacters;let pt=Ze>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const Ut=ae.minimap.maxColumn,Nt=ae.minimap.size,Bt=ae.minimap.side,At=ae.verticalScrollbarWidth,Rt=ae.viewLineCount,jt=ae.remainingWidth,Wt=ae.isViewportWrapping,Kt=Ht?2:3;let Vt=Math.floor(Ze*Ue);const qt=Vt/Ze;let ot=!1,ft=!1,Lt=Kt*pt,Mt=pt/Ze,It=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Fe,extraLinesBeforeFirstLine:Pe,extraLinesBeyondLastLine:_,desiredRatio:Te,minimapLineCount:He}=V.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Xt,paddingTop:ae.paddingTop,paddingBottom:ae.paddingBottom,height:Ue,lineHeight:bt,pixelRatio:Ze});if(Rt/He>1)ot=!0,ft=!0,pt=1,Lt=1,Mt=pt/Ze;else{let Je=!1,nt=pt+1;if(Nt==="fit"){const $t=Math.ceil((Pe+Rt+_)*Lt);Wt&&at&&jt<=Ce.stableFitRemainingWidth?(Je=!0,nt=Ce.stableFitMaxMinimapScale):Je=$t>Vt}if(Nt==="fill"||Je){ot=!0;const $t=pt;Lt=Math.min(bt*Ze,Math.max(1,Math.floor(1/Te))),Wt&&at&&jt<=Ce.stableFitRemainingWidth&&(nt=Ce.stableFitMaxMinimapScale),pt=Math.min(nt,Math.max(1,Math.floor(Lt/Kt))),pt>$t&&(It=Math.min(2,pt/$t)),Mt=pt/Ze/It,Vt=Math.ceil(Math.max(Fe,Pe+Rt+_)*Lt),Wt?(Ce.stableMinimapLayoutInput=ae,Ce.stableFitRemainingWidth=jt,Ce.stableFitMaxMinimapScale=pt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const dt=Math.floor(Ut*Mt),kt=Math.min(dt,Math.max(0,Math.floor((jt-At-2)*Mt/(St+Mt)))+e.MINIMAP_GUTTER_WIDTH);let Dt=Math.floor(Ze*kt);const Ft=Dt/Ze;Dt=Math.floor(Dt*It);const Ge=Ht?1:2,Me=Bt==="left"?0:qe-kt-At;return{renderMinimap:Ge,minimapLeft:Me,minimapWidth:kt,minimapHeightIsEditorHeight:ot,minimapIsSampling:ft,minimapScale:pt,minimapLineHeight:Lt,minimapCanvasInnerWidth:Dt,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:qt}}static computeLayout(ae,Ce){const qe=Ce.outerWidth|0,Ue=Ce.outerHeight|0,Ze=Ce.lineHeight|0,rt=Ce.lineNumbersDigitCount|0,at=Ce.typicalHalfwidthCharacterWidth,bt=Ce.maxDigitWidth,St=Ce.pixelRatio,Xt=Ce.viewLineCount,Ht=ae.get(135),pt=Ht==="inherit"?ae.get(134):Ht,Ut=pt==="inherit"?ae.get(130):pt,Nt=ae.get(133),Bt=Ce.isDominatedByLongLines,At=ae.get(57),Rt=ae.get(67).renderType!==0,jt=ae.get(68),Wt=ae.get(104),Kt=ae.get(83),Vt=ae.get(72),qt=ae.get(102),ot=qt.verticalScrollbarSize,ft=qt.verticalHasArrows,Lt=qt.arrowSize,Mt=qt.horizontalScrollbarSize,It=ae.get(43),dt=ae.get(109)!=="never";let kt=ae.get(65);It&&dt&&(kt+=16);let Dt=0;if(Rt){const vt=Math.max(rt,jt);Dt=Math.round(vt*bt)}let Ft=0;At&&(Ft=Ze*Ce.glyphMarginDecorationLaneCount);let Ge=0,Me=Ge+Ft,Fe=Me+Dt,Pe=Fe+kt;const _=qe-Ft-Dt-kt;let Te=!1,He=!1,xe=-1;pt==="inherit"&&Bt?(Te=!0,He=!0):Ut==="on"||Ut==="bounded"?He=!0:Ut==="wordWrapColumn"&&(xe=Nt);const Je=V.c({outerWidth:qe,outerHeight:Ue,lineHeight:Ze,typicalHalfwidthCharacterWidth:at,pixelRatio:St,scrollBeyondLastLine:Wt,paddingTop:Kt.top,paddingBottom:Kt.bottom,minimap:Vt,verticalScrollbarWidth:ot,viewLineCount:Xt,remainingWidth:_,isViewportWrapping:He},Ce.memory||new A);Je.renderMinimap!==0&&Je.minimapLeft===0&&(Ge+=Je.minimapWidth,Me+=Je.minimapWidth,Fe+=Je.minimapWidth,Pe+=Je.minimapWidth);const nt=_-Je.minimapWidth,$t=Math.max(1,Math.floor((nt-ot-2)/at)),Pt=ft?Lt:0;return He&&(xe=Math.max(1,$t),Ut==="bounded"&&(xe=Math.min(xe,Nt))),{width:qe,height:Ue,glyphMarginLeft:Ge,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Me,lineNumbersWidth:Dt,decorationsLeft:Fe,decorationsWidth:kt,contentLeft:Pe,contentWidth:nt,minimap:Je,viewportColumn:$t,isWordWrapMinified:Te,isViewportWrapping:He,wrappingColumn:xe,verticalScrollbarWidth:ot,horizontalScrollbarHeight:Mt,overviewRuler:{top:Pt,width:ot,height:Ue-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=V;class x extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(ae){return r(ae,"simple",["simple","advanced"])}compute(ae,Ce,qe){return Ce.get(2)===2?"advanced":qe}}class ge extends I{constructor(){const ae={enabled:!0};super(64,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:$.localize(50,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:o(ae.enabled,this.defaultValue.enabled)}}}class ue extends I{constructor(){const ae={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ae,{"editor.stickyScroll.enabled":{type:"boolean",default:ae.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ae.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ae.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ae.scrollWithEditor,description:$.localize(54,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),maxLineCount:l.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ve extends I{constructor(){const ae={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"string",default:ae.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ae.padding,description:$.localize(62,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:r(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:l.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:o(Ce.padding,this.defaultValue.padding)}}}class G extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(ae){return typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)?-parseFloat(ae.substring(0,ae.length-2)):l.clampedInt(ae,this.defaultValue,0,1e3)}compute(ae,Ce,qe){return qe<0?l.clampedInt(-qe*ae.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class U extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>h.clamp(ae,0,150),{markdownDescription:$.localize(63,null)})}compute(ae,Ce,qe){return ae.fontInfo.lineHeight}}class K extends I{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ae.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:ae.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:$.localize(74,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),autohide:o(Ce.autohide,this.defaultValue.autohide),size:r(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ce.side,this.defaultValue.side,["right","left"]),showSlider:r(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(Ce.scale,1,1,3),maxColumn:l.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function fe(ce){return ce==="ctrlCmd"?f.$j?"metaKey":"ctrlKey":"altKey"}class te extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{top:l.clampedInt(Ce.top,0,0,1e3),bottom:l.clampedInt(Ce.bottom,0,0,1e3)}}}class se extends I{constructor(){const ae={enabled:!0,cycle:!0};super(85,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:$.localize(78,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),cycle:o(Ce.cycle,this.defaultValue.cycle)}}}class ne extends D{constructor(){super(141)}compute(ae,Ce,qe){return ae.pixelRatio}}class Ee extends I{constructor(){const ae={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(88,"quickSuggestions",ae,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:ae.strings,description:$.localize(82,null)},comments:{anyOf:Ce,default:ae.comments,description:$.localize(83,null)},other:{anyOf:Ce,default:ae.other,description:$.localize(84,null)}},default:ae,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ae}validate(ae){if(typeof ae=="boolean"){const St=ae?"on":"off";return{comments:St,strings:St,other:St}}if(!ae||typeof ae!="object")return this.defaultValue;const{other:Ce,comments:qe,strings:Ue}=ae,Ze=["on","inline","off"];let rt,at,bt;return typeof Ce=="boolean"?rt=Ce?"on":"off":rt=r(Ce,this.defaultValue.other,Ze),typeof qe=="boolean"?at=qe?"on":"off":at=r(qe,this.defaultValue.comments,Ze),typeof Ue=="boolean"?bt=Ue?"on":"off":bt=r(Ue,this.defaultValue.strings,Ze),{other:rt,comments:at,strings:bt}}}var oe;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class he extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(ae){let Ce=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof ae<"u"&&(typeof ae=="function"?(Ce=4,qe=ae):ae==="interval"?Ce=3:ae==="relative"?Ce=2:ae==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:qe}}}function ee(ce){const ae=ce.get(97);return ae==="editable"?ce.get(90):ae!=="on"}e.filterValidationDecorations=ee;class le extends I{constructor(){const ae=[],Ce={type:"number",description:$.localize(91,null)};super(101,"rulers",ae,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:ae,description:$.localize(93,null)})}validate(ae){if(Array.isArray(ae)){const Ce=[];for(const qe of ae)if(typeof qe=="number")Ce.push({column:l.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Ue=qe;Ce.push({column:l.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return Ce.sort((qe,Ue)=>qe.column-Ue.column),Ce}return this.defaultValue}}class be extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:ae}}function Ie(ce,ae){if(typeof ce!="string")return ae;switch(ce){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:$.localize(104,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae,qe=l.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=l.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ce.vertical,this.defaultValue.vertical),horizontal:Ie(Ce.horizontal,this.defaultValue.horizontal),useShadows:o(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:l.clampedInt(Ce.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:l.clampedInt(Ce.verticalSliderSize,Ue,0,1e3),scrollByPage:o(Ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Y extends I{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:$.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:$.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:$.localize(111,null)}})}applyUpdate(ae,Ce){let qe=!1;Ce.allowedCharacters&&ae&&(F.$Zm(ae.allowedCharacters,Ce.allowedCharacters)||(ae={...ae,allowedCharacters:Ce.allowedCharacters},qe=!0)),Ce.allowedLocales&&ae&&(F.$Zm(ae.allowedLocales,Ce.allowedLocales)||(ae={...ae,allowedLocales:Ce.allowedLocales},qe=!0));const Ue=super.applyUpdate(ae,Ce);return qe?new w(Ue.newValue,!0):Ue}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{nonBasicASCII:de(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ae.allowedLocales,this.defaultValue.allowedLocales)}}c(ae,Ce){if(typeof ae!="object"||!ae)return Ce;const qe={};for(const[Ue,Ze]of Object.entries(ae))Ze===!0&&(qe[Ue]=!0);return qe}}class ie extends I{constructor(){const ae={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:$.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ae.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(113,null),$.localize(114,null)],description:$.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ae.suppressSuggestions,description:$.localize(116,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),mode:r(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:o(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(Ce.keepOnBlur,this.defaultValue.keepOnBlur)}}}class re extends I{constructor(){const ae={enabled:L.$Ur.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Ur.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,markdownDescription:$.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ae.independentColorPoolPerBracketType,description:$.localize(118,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends I{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(119,null),$.localize(120,null),$.localize(121,null)],default:ae.bracketPairs,description:$.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(123,null),$.localize(124,null),$.localize(125,null)],default:ae.bracketPairsHorizontal,description:$.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:$.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:$.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(129,null),$.localize(130,null),$.localize(131,null)],default:ae.highlightActiveIndentation,description:$.localize(132,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{bracketPairs:de(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(ce,ae,Ce){const qe=Ce.indexOf(ce);return qe===-1?ae:Ce[qe]}class ye extends I{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(133,null),$.localize(134,null)],default:ae.insertMode,description:$.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:$.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:$.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:$.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(139,null),$.localize(140,null),$.localize(141,null),$.localize(142,null)],default:ae.selectionMode,markdownDescription:$.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:$.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:$.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:$.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:$.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:$.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{insertMode:r(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:o(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:o(Ce.preview,this.defaultValue.preview),previewMode:r(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(Ce.showMethods,this.defaultValue.showMethods),showFunctions:o(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:o(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(Ce.showFields,this.defaultValue.showFields),showVariables:o(Ce.showVariables,this.defaultValue.showVariables),showClasses:o(Ce.showClasses,this.defaultValue.showClasses),showStructs:o(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:o(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:o(Ce.showModules,this.defaultValue.showModules),showProperties:o(Ce.showProperties,this.defaultValue.showProperties),showEvents:o(Ce.showEvents,this.defaultValue.showEvents),showOperators:o(Ce.showOperators,this.defaultValue.showOperators),showUnits:o(Ce.showUnits,this.defaultValue.showUnits),showValues:o(Ce.showValues,this.defaultValue.showValues),showConstants:o(Ce.showConstants,this.defaultValue.showConstants),showEnums:o(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:o(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(Ce.showKeywords,this.defaultValue.showKeywords),showWords:o(Ce.showWords,this.defaultValue.showWords),showColors:o(Ce.showColors,this.defaultValue.showColors),showFiles:o(Ce.showFiles,this.defaultValue.showFiles),showReferences:o(Ce.showReferences,this.defaultValue.showReferences),showFolders:o(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:o(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:o(Ce.showUsers,this.defaultValue.showUsers),showIssues:o(Ce.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(182,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(ae.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(183,null),$.localize(184,null),$.localize(185,null),$.localize(186,null)],description:$.localize(187,null),default:"same"}})}validate(ae){switch(ae){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ae,Ce,qe){return Ce.get(2)===2?0:qe}}class Qe extends D{constructor(){super(144)}compute(ae,Ce,qe){const Ue=Ce.get(143);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}class it extends I{constructor(){const ae={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ae,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ae.enabled,markdownDescription:$.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(190,null),$.localize(191,null)],default:"afterDrop"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),showDropSelector:r(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const ae={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ae,{"editor.pasteAs.enabled":{type:"boolean",default:ae.enabled,markdownDescription:$.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(194,null),$.localize(195,null)],default:"afterPaste"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:o(Ce.enabled,this.defaultValue.enabled),showPasteSelector:r(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Oe="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$j?Oe:f.$k?Ve:Ae,fontWeight:"normal",fontSize:f.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var Xe;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.ariaRequired=5]="ariaRequired",ce[ce.autoClosingBrackets=6]="autoClosingBrackets",ce[ce.autoClosingComments=7]="autoClosingComments",ce[ce.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ce[ce.autoClosingDelete=9]="autoClosingDelete",ce[ce.autoClosingOvertype=10]="autoClosingOvertype",ce[ce.autoClosingQuotes=11]="autoClosingQuotes",ce[ce.autoIndent=12]="autoIndent",ce[ce.automaticLayout=13]="automaticLayout",ce[ce.autoSurround=14]="autoSurround",ce[ce.bracketPairColorization=15]="bracketPairColorization",ce[ce.guides=16]="guides",ce[ce.codeLens=17]="codeLens",ce[ce.codeLensFontFamily=18]="codeLensFontFamily",ce[ce.codeLensFontSize=19]="codeLensFontSize",ce[ce.colorDecorators=20]="colorDecorators",ce[ce.colorDecoratorsLimit=21]="colorDecoratorsLimit",ce[ce.columnSelection=22]="columnSelection",ce[ce.comments=23]="comments",ce[ce.contextmenu=24]="contextmenu",ce[ce.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=26]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=28]="cursorStyle",ce[ce.cursorSurroundingLines=29]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=31]="cursorWidth",ce[ce.disableLayerHinting=32]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ce[ce.domReadOnly=34]="domReadOnly",ce[ce.dragAndDrop=35]="dragAndDrop",ce[ce.dropIntoEditor=36]="dropIntoEditor",ce[ce.emptySelectionClipboard=37]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=39]="extraEditorClassName",ce[ce.fastScrollSensitivity=40]="fastScrollSensitivity",ce[ce.find=41]="find",ce[ce.fixedOverflowWidgets=42]="fixedOverflowWidgets",ce[ce.folding=43]="folding",ce[ce.foldingStrategy=44]="foldingStrategy",ce[ce.foldingHighlight=45]="foldingHighlight",ce[ce.foldingImportsByDefault=46]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=47]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=49]="fontFamily",ce[ce.fontInfo=50]="fontInfo",ce[ce.fontLigatures=51]="fontLigatures",ce[ce.fontSize=52]="fontSize",ce[ce.fontWeight=53]="fontWeight",ce[ce.fontVariations=54]="fontVariations",ce[ce.formatOnPaste=55]="formatOnPaste",ce[ce.formatOnType=56]="formatOnType",ce[ce.glyphMargin=57]="glyphMargin",ce[ce.gotoLocation=58]="gotoLocation",ce[ce.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ce[ce.hover=60]="hover",ce[ce.inDiffEditor=61]="inDiffEditor",ce[ce.inlineSuggest=62]="inlineSuggest",ce[ce.letterSpacing=63]="letterSpacing",ce[ce.lightbulb=64]="lightbulb",ce[ce.lineDecorationsWidth=65]="lineDecorationsWidth",ce[ce.lineHeight=66]="lineHeight",ce[ce.lineNumbers=67]="lineNumbers",ce[ce.lineNumbersMinChars=68]="lineNumbersMinChars",ce[ce.linkedEditing=69]="linkedEditing",ce[ce.links=70]="links",ce[ce.matchBrackets=71]="matchBrackets",ce[ce.minimap=72]="minimap",ce[ce.mouseStyle=73]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=75]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=77]="multiCursorModifier",ce[ce.multiCursorPaste=78]="multiCursorPaste",ce[ce.multiCursorLimit=79]="multiCursorLimit",ce[ce.occurrencesHighlight=80]="occurrencesHighlight",ce[ce.overviewRulerBorder=81]="overviewRulerBorder",ce[ce.overviewRulerLanes=82]="overviewRulerLanes",ce[ce.padding=83]="padding",ce[ce.pasteAs=84]="pasteAs",ce[ce.parameterHints=85]="parameterHints",ce[ce.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=88]="quickSuggestions",ce[ce.quickSuggestionsDelay=89]="quickSuggestionsDelay",ce[ce.readOnly=90]="readOnly",ce[ce.readOnlyMessage=91]="readOnlyMessage",ce[ce.renameOnType=92]="renameOnType",ce[ce.renderControlCharacters=93]="renderControlCharacters",ce[ce.renderFinalNewline=94]="renderFinalNewline",ce[ce.renderLineHighlight=95]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=97]="renderValidationDecorations",ce[ce.renderWhitespace=98]="renderWhitespace",ce[ce.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ce[ce.roundedSelection=100]="roundedSelection",ce[ce.rulers=101]="rulers",ce[ce.scrollbar=102]="scrollbar",ce[ce.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=104]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=105]="scrollPredominantAxis",ce[ce.selectionClipboard=106]="selectionClipboard",ce[ce.selectionHighlight=107]="selectionHighlight",ce[ce.selectOnLineNumbers=108]="selectOnLineNumbers",ce[ce.showFoldingControls=109]="showFoldingControls",ce[ce.showUnused=110]="showUnused",ce[ce.snippetSuggestions=111]="snippetSuggestions",ce[ce.smartSelect=112]="smartSelect",ce[ce.smoothScrolling=113]="smoothScrolling",ce[ce.stickyScroll=114]="stickyScroll",ce[ce.stickyTabStops=115]="stickyTabStops",ce[ce.stopRenderingLineAfter=116]="stopRenderingLineAfter",ce[ce.suggest=117]="suggest",ce[ce.suggestFontSize=118]="suggestFontSize",ce[ce.suggestLineHeight=119]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ce[ce.suggestSelection=121]="suggestSelection",ce[ce.tabCompletion=122]="tabCompletion",ce[ce.tabIndex=123]="tabIndex",ce[ce.unicodeHighlighting=124]="unicodeHighlighting",ce[ce.unusualLineTerminators=125]="unusualLineTerminators",ce[ce.useShadowDOM=126]="useShadowDOM",ce[ce.useTabStops=127]="useTabStops",ce[ce.wordBreak=128]="wordBreak",ce[ce.wordSeparators=129]="wordSeparators",ce[ce.wordWrap=130]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=133]="wordWrapColumn",ce[ce.wordWrapOverride1=134]="wordWrapOverride1",ce[ce.wordWrapOverride2=135]="wordWrapOverride2",ce[ce.wrappingIndent=136]="wrappingIndent",ce[ce.wrappingStrategy=137]="wrappingStrategy",ce[ce.showDeprecated=138]="showDeprecated",ce[ce.inlayHints=139]="inlayHints",ce[ce.editorClassName=140]="editorClassName",ce[ce.pixelRatio=141]="pixelRatio",ce[ce.tabFocusMode=142]="tabFocusMode",ce[ce.layoutInfo=143]="layoutInfo",ce[ce.wrappingInfo=144]="wrappingInfo",ce[ce.defaultColorDecorators=145]="defaultColorDecorators",ce[ce.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ce[ce.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(196,null)})),acceptSuggestionOnEnter:Le(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(197,null),""],markdownDescription:$.localize(198,null)})),accessibilitySupport:Le(new d),accessibilityPageSize:Le(new l(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(199,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",$.localize(200,null))),ariaRequired:Le(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Le(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(202,null),$.localize(203,null),""],description:$.localize(204,null)})),autoClosingComments:Le(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(205,null),$.localize(206,null),""],description:$.localize(207,null)})),autoClosingDelete:Le(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(208,null),""],description:$.localize(209,null)})),autoClosingOvertype:Le(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(210,null),""],description:$.localize(211,null)})),autoClosingQuotes:Le(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(212,null),$.localize(213,null),""],description:$.localize(214,null)})),autoIndent:Le(new i(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[$.localize(215,null),$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null)],description:$.localize(220,null)})),automaticLayout:Le(new s(13,"automaticLayout",!1)),autoSurround:Le(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(221,null),$.localize(222,null),$.localize(223,null),""],description:$.localize(224,null)})),bracketPairColorization:Le(new re),bracketPairGuides:Le(new Q),stickyTabStops:Le(new s(115,"stickyTabStops",!1,{description:$.localize(225,null)})),codeLens:Le(new s(17,"codeLens",!0,{description:$.localize(226,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:$.localize(227,null)})),codeLensFontSize:Le(new l(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(228,null)})),colorDecorators:Le(new s(20,"colorDecorators",!0,{description:$.localize(229,null)})),colorDecoratorActivatedOn:Le(new a(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(230,null),$.localize(231,null),$.localize(232,null)],description:$.localize(233,null)})),colorDecoratorsLimit:Le(new l(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(234,null)})),columnSelection:Le(new s(22,"columnSelection",!1,{description:$.localize(235,null)})),comments:Le(new y),contextmenu:Le(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new s(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(236,null)})),cursorBlinking:Le(new i(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:$.localize(237,null)})),cursorSmoothCaretAnimation:Le(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(238,null),$.localize(239,null),$.localize(240,null)],description:$.localize(241,null)})),cursorStyle:Le(new i(28,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:$.localize(242,null)})),cursorSurroundingLines:Le(new l(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(243,null)})),cursorSurroundingLinesStyle:Le(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(244,null),$.localize(245,null)],markdownDescription:$.localize(246,null)})),cursorWidth:Le(new l(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(247,null)})),disableLayerHinting:Le(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new s(34,"domReadOnly",!1)),dragAndDrop:Le(new s(35,"dragAndDrop",!0,{description:$.localize(248,null)})),emptySelectionClipboard:Le(new N),dropIntoEditor:Le(new it),stickyScroll:Le(new ue),experimentalWhitespaceRendering:Le(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(249,null),$.localize(250,null),$.localize(251,null)],description:$.localize(252,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new h(40,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:$.localize(253,null)})),find:Le(new M),fixedOverflowWidgets:Le(new s(42,"fixedOverflowWidgets",!1)),folding:Le(new s(43,"folding",!0,{description:$.localize(254,null)})),foldingStrategy:Le(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(255,null),$.localize(256,null)],description:$.localize(257,null)})),foldingHighlight:Le(new s(45,"foldingHighlight",!0,{description:$.localize(258,null)})),foldingImportsByDefault:Le(new s(46,"foldingImportsByDefault",!1,{description:$.localize(259,null)})),foldingMaximumRegions:Le(new l(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(260,null)})),unfoldOnClickAfterEndOfLine:Le(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(261,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(262,null)})),fontInfo:Le(new T),fontLigatures2:Le(new j),fontSize:Le(new H),fontWeight:Le(new q),fontVariations:Le(new z),formatOnPaste:Le(new s(55,"formatOnPaste",!1,{description:$.localize(263,null)})),formatOnType:Le(new s(56,"formatOnType",!1,{description:$.localize(264,null)})),glyphMargin:Le(new s(57,"glyphMargin",!0,{description:$.localize(265,null)})),gotoLocation:Le(new me),hideCursorInOverviewRuler:Le(new s(59,"hideCursorInOverviewRuler",!1,{description:$.localize(266,null)})),hover:Le(new Z),inDiffEditor:Le(new s(61,"inDiffEditor",!1)),letterSpacing:Le(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>h.clamp(ce,-5,20),{description:$.localize(267,null)})),lightbulb:Le(new ge),lineDecorationsWidth:Le(new G),lineHeight:Le(new U),lineNumbers:Le(new he),lineNumbersMinChars:Le(new l(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new s(69,"linkedEditing",!1,{description:$.localize(268,null)})),links:Le(new s(70,"links",!0,{description:$.localize(269,null)})),matchBrackets:Le(new a(71,"matchBrackets","always",["always","near","never"],{description:$.localize(270,null)})),minimap:Le(new K),mouseStyle:Le(new a(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new h(74,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:$.localize(271,null)})),mouseWheelZoom:Le(new s(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(272,null)})),multiCursorMergeOverlapping:Le(new s(76,"multiCursorMergeOverlapping",!0,{description:$.localize(273,null)})),multiCursorModifier:Le(new i(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],fe,{markdownEnumDescriptions:[$.localize(274,null),$.localize(275,null)],markdownDescription:$.localize(276,null)})),multiCursorPaste:Le(new a(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(277,null),$.localize(278,null)],markdownDescription:$.localize(279,null)})),multiCursorLimit:Le(new l(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(280,null)})),occurrencesHighlight:Le(new s(80,"occurrencesHighlight",!0,{description:$.localize(281,null)})),overviewRulerBorder:Le(new s(81,"overviewRulerBorder",!0,{description:$.localize(282,null)})),overviewRulerLanes:Le(new l(82,"overviewRulerLanes",3,0,3)),padding:Le(new te),pasteAs:Le(new et),parameterHints:Le(new se),peekWidgetDefaultFocus:Le(new a(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(283,null),$.localize(284,null)],description:$.localize(285,null)})),definitionLinkOpensInPeek:Le(new s(87,"definitionLinkOpensInPeek",!1,{description:$.localize(286,null)})),quickSuggestions:Le(new Ee),quickSuggestionsDelay:Le(new l(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(287,null)})),readOnly:Le(new s(90,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new s(92,"renameOnType",!1,{description:$.localize(288,null),markdownDeprecationMessage:$.localize(289,null)})),renderControlCharacters:Le(new s(93,"renderControlCharacters",!0,{description:$.localize(290,null),restricted:!0})),renderFinalNewline:Le(new a(94,"renderFinalNewline",f.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(291,null)})),renderLineHighlight:Le(new a(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(292,null)],description:$.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Le(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(294,null)})),renderValidationDecorations:Le(new a(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new a(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(295,null),$.localize(296,null),$.localize(297,null),""],description:$.localize(298,null)})),revealHorizontalRightPadding:Le(new l(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new s(100,"roundedSelection",!0,{description:$.localize(299,null)})),rulers:Le(new le),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new l(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(300,null)})),scrollBeyondLastLine:Le(new s(104,"scrollBeyondLastLine",!0,{description:$.localize(301,null)})),scrollPredominantAxis:Le(new s(105,"scrollPredominantAxis",!0,{description:$.localize(302,null)})),selectionClipboard:Le(new s(106,"selectionClipboard",!0,{description:$.localize(303,null),included:f.$k})),selectionHighlight:Le(new s(107,"selectionHighlight",!0,{description:$.localize(304,null)})),selectOnLineNumbers:Le(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new a(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(305,null),$.localize(306,null),$.localize(307,null)],description:$.localize(308,null)})),showUnused:Le(new s(110,"showUnused",!0,{description:$.localize(309,null)})),showDeprecated:Le(new s(138,"showDeprecated",!0,{description:$.localize(310,null)})),inlayHints:Le(new ve),snippetSuggestions:Le(new a(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(311,null),$.localize(312,null),$.localize(313,null),$.localize(314,null)],description:$.localize(315,null)})),smartSelect:Le(new je),smoothScrolling:Le(new s(113,"smoothScrolling",!1,{description:$.localize(316,null)})),stopRenderingLineAfter:Le(new l(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ye),inlineSuggest:Le(new ie),inlineCompletionsAccessibilityVerbose:Le(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(317,null)})),suggestFontSize:Le(new l(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new l(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new s(120,"suggestOnTriggerCharacters",!0,{description:$.localize(320,null)})),suggestSelection:Le(new a(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(321,null),$.localize(322,null),$.localize(323,null)],description:$.localize(324,null)})),tabCompletion:Le(new a(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(325,null),$.localize(326,null),$.localize(327,null)],description:$.localize(328,null)})),tabIndex:Le(new l(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Y),unusualLineTerminators:Le(new a(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(329,null),$.localize(330,null),$.localize(331,null)],description:$.localize(332,null)})),useShadowDOM:Le(new s(126,"useShadowDOM",!0)),useTabStops:Le(new s(127,"useTabStops",!0,{description:$.localize(333,null)})),wordBreak:Le(new a(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(334,null),$.localize(335,null)],description:$.localize(336,null)})),wordSeparators:Le(new t(129,"wordSeparators",R.$Vr,{description:$.localize(337,null)})),wordWrap:Le(new a(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(338,null),$.localize(339,null),$.localize(340,null),$.localize(341,null)],description:$.localize(342,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new l(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(343,null)})),wordWrapOverride1:Le(new a(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new a(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new O),defaultColorDecorators:Le(new s(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(344,null)})),pixelRatio:Le(new ne),tabFocusMode:Le(new s(142,"tabFocusMode",!1,{markdownDescription:$.localize(345,null)})),layoutInfo:Le(new V),wrappingInfo:Le(new Qe),wrappingIndent:Le(new _e),wrappingStrategy:Le(new x)}}),define(Se[187],De([10,11]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(Se[83],De([1,0,79,2,164,34,174,187]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$bt=e.$at=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$_s=e.$$s=e.SymbolKinds=e.SymbolTag=e.$0s=e.$9s=e.SymbolKind=e.$8s=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$7s=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$6s=e.$5s=e.$4s=void 0;class E{constructor(j,z,T){this.offset=j,this.type=z,this.language=T,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$4s=E;class p{constructor(j,z){this.tokens=j,this.endState=z,this._tokenizationResultBrand=void 0}}e.$5s=p;class A{constructor(j,z){this.tokens=j,this.endState=z,this._encodedTokenizationResultBrand=void 0}}e.$6s=A;var I;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var w;(function(M){const j=new Map;j.set(0,C.$Pj.symbolMethod),j.set(1,C.$Pj.symbolFunction),j.set(2,C.$Pj.symbolConstructor),j.set(3,C.$Pj.symbolField),j.set(4,C.$Pj.symbolVariable),j.set(5,C.$Pj.symbolClass),j.set(6,C.$Pj.symbolStruct),j.set(7,C.$Pj.symbolInterface),j.set(8,C.$Pj.symbolModule),j.set(9,C.$Pj.symbolProperty),j.set(10,C.$Pj.symbolEvent),j.set(11,C.$Pj.symbolOperator),j.set(12,C.$Pj.symbolUnit),j.set(13,C.$Pj.symbolValue),j.set(15,C.$Pj.symbolEnum),j.set(14,C.$Pj.symbolConstant),j.set(15,C.$Pj.symbolEnum),j.set(16,C.$Pj.symbolEnumMember),j.set(17,C.$Pj.symbolKeyword),j.set(27,C.$Pj.symbolSnippet),j.set(18,C.$Pj.symbolText),j.set(19,C.$Pj.symbolColor),j.set(20,C.$Pj.symbolFile),j.set(21,C.$Pj.symbolReference),j.set(22,C.$Pj.symbolCustomColor),j.set(23,C.$Pj.symbolFolder),j.set(24,C.$Pj.symbolTypeParameter),j.set(25,C.$Pj.account),j.set(26,C.$Pj.issues);function z(q){let me=j.get(q);return me||(console.info("No codicon found for CompletionItemKind "+q),me=C.$Pj.symbolProperty),me}M.toIcon=z;const T=new Map;T.set("method",0),T.set("function",1),T.set("constructor",2),T.set("field",3),T.set("variable",4),T.set("class",5),T.set("struct",6),T.set("interface",7),T.set("module",8),T.set("property",9),T.set("event",10),T.set("operator",11),T.set("unit",12),T.set("value",13),T.set("constant",14),T.set("enum",15),T.set("enum-member",16),T.set("enumMember",16),T.set("keyword",17),T.set("snippet",27),T.set("text",18),T.set("color",19),T.set("file",20),T.set("reference",21),T.set("customcolor",22),T.set("folder",23),T.set("type-parameter",24),T.set("typeParameter",24),T.set("account",25),T.set("issue",26);function H(q,me){let Z=T.get(q);return typeof Z>"u"&&!me&&(Z=9),Z}M.fromString=H})(w||(e.CompletionItemKinds=w={}));var k;(function(M){M[M.Deprecated=1]="Deprecated"})(k||(e.CompletionItemTag=k={}));var D;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var v;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(e.CompletionTriggerKind=v={}));var o;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(o||(e.InlineCompletionTriggerKind=o={}));class s{constructor(j,z,T,H){this.range=j,this.text=z,this.completionKind=T,this.isSnippetText=H}equals(j){return L.$ks.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$7s=s;var n;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(n||(e.CodeActionTriggerType=n={}));var l;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var b;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(b||(e.DocumentHighlightKind=b={}));function h(M){return M&&F.URI.isUri(M.uri)&&L.$ks.isIRange(M.range)&&(L.$ks.isIRange(M.originSelectionRange)||L.$ks.isIRange(M.targetSelectionRange))}e.$8s=h;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$9s={[17]:(0,$.localize)(0,null),[16]:(0,$.localize)(1,null),[4]:(0,$.localize)(2,null),[13]:(0,$.localize)(3,null),[8]:(0,$.localize)(4,null),[9]:(0,$.localize)(5,null),[21]:(0,$.localize)(6,null),[23]:(0,$.localize)(7,null),[7]:(0,$.localize)(8,null),[0]:(0,$.localize)(9,null),[11]:(0,$.localize)(10,null),[10]:(0,$.localize)(11,null),[19]:(0,$.localize)(12,null),[5]:(0,$.localize)(13,null),[1]:(0,$.localize)(14,null),[2]:(0,$.localize)(15,null),[20]:(0,$.localize)(16,null),[15]:(0,$.localize)(17,null),[18]:(0,$.localize)(18,null),[24]:(0,$.localize)(19,null),[3]:(0,$.localize)(20,null),[6]:(0,$.localize)(21,null),[14]:(0,$.localize)(22,null),[22]:(0,$.localize)(23,null),[25]:(0,$.localize)(24,null),[12]:(0,$.localize)(25,null)};function r(M,j){return(0,$.localize)(26,null,M,e.$9s[j])}e.$0s=r;var a;(function(M){M[M.Deprecated=1]="Deprecated"})(a||(e.SymbolTag=a={}));var i;(function(M){const j=new Map;j.set(0,C.$Pj.symbolFile),j.set(1,C.$Pj.symbolModule),j.set(2,C.$Pj.symbolNamespace),j.set(3,C.$Pj.symbolPackage),j.set(4,C.$Pj.symbolClass),j.set(5,C.$Pj.symbolMethod),j.set(6,C.$Pj.symbolProperty),j.set(7,C.$Pj.symbolField),j.set(8,C.$Pj.symbolConstructor),j.set(9,C.$Pj.symbolEnum),j.set(10,C.$Pj.symbolInterface),j.set(11,C.$Pj.symbolFunction),j.set(12,C.$Pj.symbolVariable),j.set(13,C.$Pj.symbolConstant),j.set(14,C.$Pj.symbolString),j.set(15,C.$Pj.symbolNumber),j.set(16,C.$Pj.symbolBoolean),j.set(17,C.$Pj.symbolArray),j.set(18,C.$Pj.symbolObject),j.set(19,C.$Pj.symbolKey),j.set(20,C.$Pj.symbolNull),j.set(21,C.$Pj.symbolEnumMember),j.set(22,C.$Pj.symbolStruct),j.set(23,C.$Pj.symbolEvent),j.set(24,C.$Pj.symbolOperator),j.set(25,C.$Pj.symbolTypeParameter);function z(T){let H=j.get(T);return H||(console.info("No codicon found for SymbolKind "+T),H=C.$Pj.symbolProperty),H}M.toIcon=z})(i||(e.SymbolKinds=i={}));class c{static asEditOperation(j){return f.$ls.replace(L.$ks.lift(j.range),j.text)}}e.$$s=c;class d{static{this.Comment=new d("comment")}static{this.Imports=new d("imports")}static{this.Region=new d("region")}static fromValue(j){switch(j){case"comment":return d.Comment;case"imports":return d.Imports;case"region":return d.Region}return new d(j)}constructor(j){this.value=j}}e.$_s=d;var y;(function(M){function j(z){return!z||typeof z!="object"?!1:typeof z.id=="string"&&typeof z.title=="string"}M.is=j})(y||(e.Command=y={}));var S;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(S||(e.CommentThreadCollapsibleState=S={}));var g;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(g||(e.CommentThreadState=g={}));var u;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(u||(e.CommentMode=u={}));var m;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(m||(e.CommentState=m={}));var P;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class O{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$at=O,e.$bt=new R.$Vs;var N;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}))}),define(Se[188],De([10,11]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[189],De([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[190],De([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(Se[191],De([10,11]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[192],De([10,11]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[193],De([10,11]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[194],De([10,11]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[195],De([10,11]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(Se[196],De([10,11]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(Se[197],De([10,11]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[198],De([10,11]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(Se[199],De([10,11]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[200],De([10,11]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[201],De([10,11]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(Se[202],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(Se[203],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[204],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[205],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[206],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[207],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[208],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[209],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[210],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[211],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[212],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[213],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[214],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[215],De([10,11]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[216],De([10,11]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(Se[217],De([10,11]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(Se[218],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[219],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[220],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[221],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[222],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[223],De([10,11]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[224],De([10,11]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[225],De([10,11]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[226],De([10,11]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[227],De([1,0,8,190]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.TokenType=void 0;var f;(function(p){p[p.LParen=0]="LParen",p[p.RParen=1]="RParen",p[p.Neg=2]="Neg",p[p.Eq=3]="Eq",p[p.NotEq=4]="NotEq",p[p.Lt=5]="Lt",p[p.LtEq=6]="LtEq",p[p.Gt=7]="Gt",p[p.GtEq=8]="GtEq",p[p.RegexOp=9]="RegexOp",p[p.RegexStr=10]="RegexStr",p[p.True=11]="True",p[p.False=12]="False",p[p.In=13]="In",p[p.Not=14]="Not",p[p.And=15]="And",p[p.Or=16]="Or",p[p.Str=17]="Str",p[p.QuotedStr=18]="QuotedStr",p[p.Error=19]="Error",p[p.EOF=20]="EOF"})(f||(e.TokenType=f={}));function L(...p){switch(p.length){case 1:return(0,F.localize)(0,null,p[0]);case 2:return(0,F.localize)(1,null,p[0],p[1]);case 3:return(0,F.localize)(2,null,p[0],p[1],p[2]);default:return}}const R=(0,F.localize)(3,null),$=(0,F.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,C.$6)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const I=this.d,w=this.c.substring(this.d,this.e),k={type:19,offset:this.d,lexeme:w};this.g.push({offset:I,lexeme:w,additionalInfo:A}),this.f.push(k)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const I=this.c.substring(this.d,this.e),w=E.b.get(I);w?this.k(w):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,I=!1,w=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const D=this.c.charCodeAt(A);if(I)I=!1;else if(D===47&&!w){A++;break}else D===91?w=!0:D===92?I=!0:D===93&&(w=!1);A++}for(;A<this.c.length&&E.a.has(this.c.charCodeAt(A));)A++;this.e=A;const k=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:k,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fi=E}),define(Se[228],De([1,0,24,38,193,372]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function E(s){return s=s.trim(),s==="*"||R.test(s)}e.$Bo=E;function p(s){if(!E(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=s.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$Co=p;function A(s){if(!s)return null;const n=s.majorBase,l=s.majorMustEqual,b=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(n===0||(h=!1),r=!1);let a=0;if(s.preRelease){const i=$.exec(s.preRelease);if(i){const[,c,d,y]=i;a=Date.UTC(Number(c),Number(d)-1,Number(y))}}return{majorBase:n,majorMustEqual:l,minorBase:b,minorMustEqual:h,patchBase:t,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:a}}e.$Do=A;function I(s,n,l){let b;typeof s=="string"?b=A(p(s)):b=s;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let t;if(typeof l=="string"?t=A(p(l)):t=l,!b||!t)return!1;const r=b.majorBase,a=b.minorBase,i=b.patchBase;let c=t.majorBase,d=t.minorBase,y=t.patchBase;const S=t.notBefore;let g=t.majorMustEqual,u=t.minorMustEqual,m=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:a>d?!0:a<d||h&&h<S?!1:i>=y:(r===1&&c===0&&(!g||!u||!m)&&(c=1,d=0,y=0,g=!0,u=!1,m=!1),r<c?!1:r>c?!g:a<d?!1:a>d?!u:i<y?!1:i>y?!m:!(h&&h<S))}e.$Eo=I;function w(s,n,l,b,h){const t=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return t.push([F.default.Error,f.localize(0,null)]),t;if(typeof b.name!="string")return t.push([F.default.Error,f.localize(1,null,"name")]),t;if(typeof b.version!="string")return t.push([F.default.Error,f.localize(2,null,"version")]),t;if(!b.engines)return t.push([F.default.Error,f.localize(3,null,"engines")]),t;if(typeof b.engines.vscode!="string")return t.push([F.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof b.extensionDependencies<"u"&&!o(b.extensionDependencies))return t.push([F.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof b.activationEvents<"u"){if(!o(b.activationEvents))return t.push([F.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof b.main>"u"&&typeof b.browser>"u")return t.push([F.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&t.push([F.default.Warning,f.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return t.push([F.default.Error,f.localize(9,null,"main")]),t;{const i=(0,C.$ig)(l,b.main);(0,C.$cg)(i,l)||t.push([F.default.Warning,f.localize(10,null,i.path,l.path)])}}if(typeof b.browser<"u"){if(typeof b.browser!="string")return t.push([F.default.Error,f.localize(11,null,"browser")]),t;{const i=(0,C.$ig)(l,b.browser);(0,C.$cg)(i,l)||t.push([F.default.Warning,f.localize(12,null,i.path,l.path)])}}if(!L.valid(b.version))return t.push([F.default.Error,f.localize(13,null)]),t;const r=[];if(!k(s,n,b,h,r))for(const i of r)t.push([F.default.Error,i]);return t}e.$Fo=w;function k(s,n,l,b,h){return b||typeof l.main>"u"&&typeof l.browser>"u"?!0:v(s,n,l.engines.vscode,h)}e.$Go=k;function D(s,n,l){return s==="*"||v(n,l,s)}e.$Ho=D;function v(s,n,l,b=[]){const h=A(p(l));if(!h)return b.push(f.localize(14,null,l)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return b.push(f.localize(15,null,l)),!1}else if(!h.majorMustEqual)return b.push(f.localize(16,null,l)),!1;return I(s,n,h)?!0:(b.push(f.localize(17,null,s,l)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let n=0,l=s.length;n<l;n++)if(typeof s[n]!="string")return!1;return!0}}),define(Se[103],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class C{constructor(f,L=[],R=!1){this.ctor=f,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$yh=C}),define(Se[104],De([1,0,103]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.InstantiationType=void 0;const F=[];var f;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function L($,E,p){E instanceof C.$yh||(E=new C.$yh(E,[],!!p)),F.push([$,E])}e.$mr=L;function R(){return F}e.$nr=R}),define(Se[229],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;class C{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$4p=C;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const $=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(R);$.outgoing.set(E.key,E),E.incoming.set($.key,$)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let $=this.a.get(R);return $||($=new C(R,L),this.a.set(R,$)),$}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,$]of this.a)L.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const $=new Set([L]),E=this.c(R,$);if(E)return E}}c(L,R){for(const[$,E]of L.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const p=this.c(E,R);if(p)return p;R.delete($)}}}e.$5p=F}),define(Se[5],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=e._util=void 0;var C;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(E){return E[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(C||(e._util=C={})),e.$Ah=f("instantiationService");function F(R,$,E){$[C.DI_TARGET]===$?$[C.DI_DEPENDENCIES].push({id:R,index:E}):($[C.DI_DEPENDENCIES]=[{id:R,index:E}],$[C.DI_TARGET]=$)}function f(R){if(C.serviceIds.has(R))return C.serviceIds.get(R);const $=function(E,p,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F($,E,A)};return $.toString=()=>R,C.serviceIds.set(R,$),$}e.$Bh=f;function L(R){return R}e.$Ch=L}),define(Se[49],De([1,0,18,2,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.ConfigurationTarget=e.$0h=e.$9h=e.$8h=void 0,e.$8h=(0,f.$Bh)("configurationService");function L(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof F.URI)}e.$9h=L;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof F.URI)}e.$0h=R;var $;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function E(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$$h=E;function p(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$_h=p;function A(s,n){const l=Object.create(null);for(const b in s)I(l,b,s[b],n);return l}e.$ai=A;function I(s,n,l,b){const h=n.split("."),t=h.pop();let r=s;for(let a=0;a<h.length;a++){const i=h[a];let c=r[i];switch(typeof c){case"undefined":c=r[i]=Object.create(null);break;case"object":break;default:b(`Ignoring ${n} as ${h.slice(0,a+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=l}catch{b(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(r)}`)}else b(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(r)}`)}e.$bi=I;function w(s,n){const l=n.split(".");k(s,l)}e.$ci=w;function k(s,n){const l=n.shift();if(n.length===0){delete s[l];return}if(Object.keys(s).indexOf(l)!==-1){const b=s[l];typeof b=="object"&&!Array.isArray(b)&&(k(b,n),Object.keys(b).length===0&&delete s[l])}}function D(s,n,l){function b(r,a){let i=r;for(const c of a){if(typeof i!="object"||i===null)return;i=i[c]}return i}const h=n.split("."),t=b(s,h);return typeof t>"u"?l:t}e.$di=D;function v(s,n,l){Object.keys(n).forEach(b=>{b!=="__proto__"&&(b in s?C.$lf(s[b])&&C.$lf(n[b])?v(s[b],n[b],l):l&&(s[b]=n[b]):s[b]=n[b])})}e.$ei=v;function o(s){return s.replace(/[\[\]]/g,"")}e.$fi=o}),define(Se[41],De([1,0,12,15,227,5,189,8]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ContextKeyExprType=e.$Gi=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",C.$j),E.set("isLinux",C.$k),E.set("isWindows",C.$i),E.set("isWeb",C.$o),E.set("isMacNative",C.$j&&!C.$o),E.set("isEdge",C.$G),E.set("isFirefox",C.$E),E.set("isChrome",C.$D),E.set("isSafari",C.$F);function p(G,U){if(E.get(G)!==void 0)throw(0,$.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(G,U)}e.$Gi=p;const A=Object.prototype.hasOwnProperty;var I;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const w={regexParsingWithErrorRecovery:!0},k=(0,R.localize)(0,null),D=(0,R.localize)(1,null),v=(0,R.localize)(2,null),o=(0,R.localize)(3,null),s=(0,R.localize)(4,null),n=(0,R.localize)(5,null),l=(0,R.localize)(6,null),b=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=w){this.k=U,this.d=new f.$Fi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:k,offset:0,lexeme:"",additionalInfo:D});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const K=this.l();if(!this.E()){const fe=this.D(),te=fe.type===17?n:void 0;throw this.h.push({message:s,offset:fe.offset,lexeme:f.$Fi.getLexeme(fe),additionalInfo:te}),h.c}return K}catch(K){if(K!==h.c)throw K;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const K=this.o();U.push(K)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const K=this.s();U.push(K)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const K=this.l();return this.A(1,o),K?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const K=this.l();return this.A(1,o),K}case 17:{const K=U.lexeme;if(this.z(),this.y(9)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==10)throw this.B("REGEX",te);const se=te.lexeme,ne=se.lastIndexOf("/"),Ee=ne===se.length-1?void 0:this.w(se.substring(ne+1));let oe;try{oe=new RegExp(se.substring(1,ne),Ee)}catch{throw this.B("REGEX",te)}return T.create(K,oe)}switch(te.type){case 10:case 19:{const se=[te.lexeme];this.z();let ne=this.D(),Ee=0;for(let be=0;be<te.lexeme.length;be++)te.lexeme.charCodeAt(be)===40?Ee++:te.lexeme.charCodeAt(be)===41&&Ee--;for(;!this.E()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let be=0;be<ne.lexeme.length;be++)ne.lexeme.charCodeAt(be)===40?Ee++:te.lexeme.charCodeAt(be)===41&&Ee--}if(Ee<0)break;se.push(f.$Fi.getLexeme(ne)),this.z(),ne=this.D()}const oe=se.join(""),he=oe.lastIndexOf("/"),ee=he===oe.length-1?void 0:this.w(oe.substring(he+1));let le;try{le=new RegExp(oe.substring(1,he),ee)}catch{throw this.B("REGEX",te)}return t.regex(K,le)}case 18:{const se=te.lexeme;this.z();let ne=null;if(!(0,F.$me)(se)){const Ee=se.indexOf("/"),oe=se.lastIndexOf("/");if(Ee!==oe&&Ee>=0){const he=se.slice(Ee+1,oe),ee=se[oe+1]==="i"?"i":"";try{ne=new RegExp(he,ee)}catch{throw this.B("REGEX",te)}}}if(ne===null)throw this.B("REGEX",te);return T.create(K,ne)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const te=this.u();return t.notIn(K,te)}switch(this.D().type){case 3:{this.z();const te=this.u();if(this.x().type===18)return t.equals(K,te);switch(te){case"true":return t.has(K);case"false":return t.not(K);default:return t.equals(K,te)}}case 4:{this.z();const te=this.u();if(this.x().type===18)return t.notEquals(K,te);switch(te){case"true":return t.not(K);case"false":return t.has(K);default:return t.notEquals(K,te)}}case 5:return this.z(),j.create(K,this.u());case 6:return this.z(),z.create(K,this.u());case 7:return this.z(),N.create(K,this.u());case 8:return this.z(),M.create(K,this.u());case 13:return this.z(),t.in(K,this.u());default:return t.has(K)}}case 20:throw this.h.push({message:l,offset:U.offset,lexeme:"",additionalInfo:b}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,K){if(this.C(U))return this.z();throw this.B(K,this.D())}B(U,K,fe){const te=(0,R.localize)(8,null,U,f.$Fi.getLexeme(K)),se=K.offset,ne=f.$Fi.getLexeme(K);return this.h.push({message:te,offset:se,lexeme:ne,additionalInfo:fe}),h.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Hi=h;class t{static false(){return c.INSTANCE}static true(){return d.INSTANCE}static has(U){return y.create(U)}static equals(U,K){return S.create(U,K)}static notEquals(U,K){return m.create(U,K)}static regex(U,K){return T.create(U,K)}static in(U,K){return g.create(U,K)}static notIn(U,K){return u.create(U,K)}static not(U){return P.create(U)}static and(...U){return me.create(U,null,!0)}static or(...U){return Z.create(U,null,!0)}static greater(U,K){return N.create(U,K)}static greaterEquals(U,K){return M.create(U,K)}static smaller(U,K){return j.create(U,K)}static smallerEquals(U,K){return z.create(U,K)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Ii=t;function r(G){const U=new h({regexParsingWithErrorRecovery:!1});return G.map(K=>(U.parse(K),U.lexingErrors.length>0?U.lexingErrors.map(fe=>({errorMessage:fe.additionalInfo?(0,R.localize)(9,null,fe.additionalInfo):(0,R.localize)(10,null),offset:fe.offset,length:fe.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(fe=>({errorMessage:fe.additionalInfo?`${fe.message}. ${fe.additionalInfo}`:fe.message,offset:fe.offset,length:fe.lexeme.length})):[]))}e.$Ji=r;function a(G,U){const K=G?G.substituteConstants():void 0,fe=U?U.substituteConstants():void 0;return!K&&!fe?!0:!K||!fe?!1:K.equals(fe)}e.$Ki=a;function i(G,U){return G.cmp(U)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return d.INSTANCE}}e.$Li=c;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$Mi=d;class y{static create(U,K=null){const fe=E.get(U);return typeof fe=="boolean"?fe?d.INSTANCE:c.INSTANCE:new y(U,K)}constructor(U,K){this.key=U,this.c=K,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:V(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=E.get(this.key);return typeof U=="boolean"?U?d.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Ni=y;class S{static create(U,K,fe=null){if(typeof K=="boolean")return K?y.create(U,fe):P.create(U,fe);const te=E.get(U);return typeof te=="boolean"?K===(te?"true":"false")?d.INSTANCE:c.INSTANCE:new S(U,K,fe)}constructor(U,K,fe){this.c=U,this.d=K,this.f=fe,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const K=U?"true":"false";return this.d===K?d.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.$Oi=S;class g{static create(U,K){return new g(U,K)}constructor(U,K){this.d=U,this.f=K,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:x(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const K=U.getValue(this.f),fe=U.getValue(this.d);return Array.isArray(K)?K.includes(fe):typeof fe=="string"&&typeof K=="object"&&K!==null?A.call(K,fe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$Pi=g;class u{static create(U,K){return new u(U,K)}constructor(U,K){this.d=U,this.f=K,this.type=11,this.c=g.create(U,K)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qi=u;class m{static create(U,K,fe=null){if(typeof K=="boolean")return K?P.create(U,fe):y.create(U,fe);const te=E.get(U);return typeof te=="boolean"?K===(te?"true":"false")?c.INSTANCE:d.INSTANCE:new m(U,K,fe)}constructor(U,K,fe){this.c=U,this.d=K,this.f=fe,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const K=U?"true":"false";return this.d===K?c.INSTANCE:d.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Ri=m;class P{static create(U,K=null){const fe=E.get(U);return typeof fe=="boolean"?fe?c.INSTANCE:d.INSTANCE:new P(U,K)}constructor(U,K){this.c=U,this.d=K,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:V(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=E.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:d.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Si=P;function O(G,U){if(typeof G=="string"){const K=parseFloat(G);isNaN(K)||(G=K)}return typeof G=="string"||typeof G=="number"?U(G):c.INSTANCE}class N{static create(U,K,fe=null){return O(K,te=>new N(U,te,fe))}constructor(U,K,fe){this.c=U,this.d=K,this.f=fe,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Ti=N;class M{static create(U,K,fe=null){return O(K,te=>new M(U,te,fe))}constructor(U,K,fe){this.c=U,this.d=K,this.f=fe,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ui=M;class j{static create(U,K,fe=null){return O(K,te=>new j(U,te,fe))}constructor(U,K,fe){this.c=U,this.d=K,this.f=fe,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Vi=j;class z{static create(U,K,fe=null){return O(K,te=>new z(U,te,fe))}constructor(U,K,fe){this.c=U,this.d=K,this.f=fe,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Wi=z;class T{static create(U,K){return new T(U,K)}constructor(U,K){this.d=U,this.f=K,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const K=this.f?this.f.source:"",fe=U.f?U.f.source:"";return K<fe?-1:K>fe?1:0}equals(U){if(U.type===this.type){const K=this.f?this.f.source:"",fe=U.f?U.f.source:"";return this.d===U.d&&K===fe}return!1}substituteConstants(){return this}evaluate(U){const K=U.getValue(this.d);return this.f?this.f.test(K):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Xi=T;class H{static create(U){return new H(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new H(this.c.map(U))}negate(){return this.c}}e.$Yi=H;function q(G){let U=null;for(let K=0,fe=G.length;K<fe;K++){const te=G[K].substituteConstants();if(G[K]!==te&&U===null){U=[];for(let se=0;se<K;se++)U[se]=G[se]}U!==null&&(U[K]=te)}return U===null?G:U}class me{static create(U,K,fe){return me.d(U,K,fe)}constructor(U,K){this.expr=U,this.c=K,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let K=0,fe=this.expr.length;K<fe;K++){const te=i(this.expr[K],U.expr[K]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let K=0,fe=this.expr.length;K<fe;K++)if(!this.expr[K].equals(U.expr[K]))return!1;return!0}return!1}substituteConstants(){const U=q(this.expr);return U===this.expr?this:me.create(U,this.c,!1)}evaluate(U){for(let K=0,fe=this.expr.length;K<fe;K++)if(!this.expr[K].evaluate(U))return!1;return!0}static d(U,K,fe){const te=[];let se=!1;for(const ne of U)if(ne){if(ne.type===1){se=!0;continue}if(ne.type===0)return c.INSTANCE;if(ne.type===6){te.push(...ne.expr);continue}te.push(ne)}if(te.length===0&&se)return d.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(i);for(let ne=1;ne<te.length;ne++)te[ne-1].equals(te[ne])&&(te.splice(ne,1),ne--);if(te.length===1)return te[0];for(;te.length>1;){const ne=te[te.length-1];if(ne.type!==9)break;te.pop();const Ee=te.pop(),oe=te.length===0,he=Z.create(ne.expr.map(ee=>me.create([ee,Ee],null,fe)),null,oe);he&&(te.push(he),te.sort(i))}if(te.length===1)return te[0];if(fe){for(let ne=0;ne<te.length;ne++)for(let Ee=ne+1;Ee<te.length;Ee++)if(te[ne].negate().equals(te[Ee]))return c.INSTANCE;if(te.length===1)return te[0]}return new me(te,K)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const K of this.expr)U.push(...K.keys());return U}map(U){return new me(this.expr.map(K=>K.map(U)),null)}negate(){if(!this.c){const U=[];for(const K of this.expr)U.push(K.negate());this.c=Z.create(U,this,!0)}return this.c}}e.$Zi=me;class Z{static create(U,K,fe){return Z.d(U,K,fe)}constructor(U,K){this.expr=U,this.c=K,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let K=0,fe=this.expr.length;K<fe;K++){const te=i(this.expr[K],U.expr[K]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let K=0,fe=this.expr.length;K<fe;K++)if(!this.expr[K].equals(U.expr[K]))return!1;return!0}return!1}substituteConstants(){const U=q(this.expr);return U===this.expr?this:Z.create(U,this.c,!1)}evaluate(U){for(let K=0,fe=this.expr.length;K<fe;K++)if(this.expr[K].evaluate(U))return!0;return!1}static d(U,K,fe){let te=[],se=!1;if(U){for(let ne=0,Ee=U.length;ne<Ee;ne++){const oe=U[ne];if(oe){if(oe.type===0){se=!0;continue}if(oe.type===1)return d.INSTANCE;if(oe.type===9){te=te.concat(oe.expr);continue}te.push(oe)}}if(te.length===0&&se)return c.INSTANCE;te.sort(i)}if(te.length!==0){if(te.length===1)return te[0];for(let ne=1;ne<te.length;ne++)te[ne-1].equals(te[ne])&&(te.splice(ne,1),ne--);if(te.length===1)return te[0];if(fe){for(let ne=0;ne<te.length;ne++)for(let Ee=ne+1;Ee<te.length;Ee++)if(te[ne].negate().equals(te[Ee]))return d.INSTANCE;if(te.length===1)return te[0]}return new Z(te,K)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const K of this.expr)U.push(...K.keys());return U}map(U){return new Z(this.expr.map(K=>K.map(U)),null)}negate(){if(!this.c){const U=[];for(const K of this.expr)U.push(K.negate());for(;U.length>1;){const K=U.shift(),fe=U.shift(),te=[];for(const se of ve(K))for(const ne of ve(fe))te.push(me.create([se,ne],null,!1));U.unshift(Z.create(te,null,!1))}this.c=Z.create(U,this,!0)}return this.c}}e.$1i=Z;class X extends y{static{this.d=[]}static all(){return X.d.values()}constructor(U,K,fe){super(U,null),this.f=K,typeof fe=="object"?X.d.push({...fe,key:U}):fe!==!0&&X.d.push({key:U,description:fe,type:K!=null?typeof K:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return S.create(this.key,U)}notEqualsTo(U){return m.create(this.key,U)}}e.$2i=X,e.$3i=(0,L.$Bh)("contextKeyService");function V(G,U){return G<U?-1:G>U?1:0}function x(G,U,K,fe){return G<K?-1:G>K?1:U<fe?-1:U>fe?1:0}function ge(G,U){if(G.type===0||U.type===1)return!0;if(G.type===9)return U.type===9?ue(G.expr,U.expr):!1;if(U.type===9){for(const K of U.expr)if(ge(G,K))return!0;return!1}if(G.type===6){if(U.type===6)return ue(U.expr,G.expr);for(const K of G.expr)if(ge(K,U))return!0;return!1}return G.equals(U)}e.$4i=ge;function ue(G,U){let K=0,fe=0;for(;K<G.length&&fe<U.length;){const te=G[K].cmp(U[fe]);if(te<0)return!1;te===0&&K++,fe++}return K===G.length}function ve(G){return G.type===9?G.expr:[G]}}),define(Se[230],De([1,0,24,38,191,5,100,12,23]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.ConfirmResult=e.$tv=e.$sv=e.$rv=void 0,e.$rv=(0,L.$Bh)("dialogService");var p;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(p||(p={}));class A{a(o){return this.d(o,p.Confirmation)}b(o){return this.d(o,p.Prompt)}c(o){return this.d(o,p.Input)}d(o,s){const n=[];switch(s){case p.Confirmation:{const l=o;l.primaryButton?n.push(l.primaryButton):n.push((0,f.localize)(0,null)),l.cancelButton?n.push(l.cancelButton):n.push((0,f.localize)(1,null));break}case p.Prompt:{const l=o;Array.isArray(l.buttons)&&l.buttons.length>0&&n.push(...l.buttons.map(b=>b.label)),l.cancelButton&&(l.cancelButton===!0?n.push((0,f.localize)(2,null)):typeof l.cancelButton=="string"?n.push(l.cancelButton):l.cancelButton.label?n.push(l.cancelButton.label):n.push((0,f.localize)(3,null))),n.length===0&&n.push((0,f.localize)(4,null));break}case p.Input:{const l=o;l.primaryButton?n.push(l.primaryButton):n.push((0,f.localize)(5,null)),l.cancelButton?n.push(l.cancelButton):n.push((0,f.localize)(6,null));break}}return n}e(o){if(typeof o=="string")return o;if(typeof o=="number")return o===F.default.Info?"info":o===F.default.Error?"error":o===F.default.Warning?"warning":"none"}async f(o,s,n){const l=[...o.buttons??[]];return o.cancelButton&&typeof o.cancelButton!="string"&&typeof o.cancelButton!="boolean"&&l.push(o.cancelButton),{result:await l[s]?.run({checkboxChecked:n}),checkboxChecked:n}}}e.$sv=A,e.$tv=(0,L.$Bh)("fileDialogService");var I;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const w=10;function k(v){const o=[];return o.push(...v.slice(0,w).map(s=>typeof s=="string"?s:(0,C.$fg)(s))),v.length>w&&(v.length-w===1?o.push((0,f.localize)(7,null)):o.push((0,f.localize)(8,null,v.length-w))),o.push(""),o.join(`
`)}e.$uv=k;function D(v,o){const s=(0,E.$Vm)(v);let n=(s.buttons??[]).map(t=>(0,R.$ov)(t)),l=(v.buttons||[]).map((t,r)=>r),b=0,h=s.cancelId??n.length-1;if(n.length>1){const t=typeof h=="number"?n[h]:void 0;if($.$k||$.$j){if(typeof t=="string"&&n.length>1&&h!==1){n.splice(h,1),n.splice(1,0,t);const r=l[h];l.splice(h,1),l.splice(1,0,r),h=1}$.$k&&n.length>1&&(n=n.reverse(),l=l.reverse(),b=n.length-1,typeof t=="string"&&(h=b-1))}else if($.$i&&typeof t=="string"&&n.length>1&&h!==n.length-1){n.splice(h,1),n.push(t);const r=l[h];l.splice(h,1),l.push(r),h=n.length-1}}return s.buttons=n,s.defaultId=b,s.cancelId=h,s.noLink=!0,s.title=s.title||o.nameLong,{options:s,buttonIndeces:l}}e.$vv=D}),define(Se[131],De([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=void 0,e.$Ih=(0,C.$Bh)("environmentService"),e.$Jh=(0,C.$Ch)(e.$Ih)}),define(Se[132],De([1,0,192,5]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0,e.$Mn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Nn=new RegExp(e.$Mn),e.$On="__web_extension",e.$Pn="skipWalkthrough",e.$Qn="extensionsSync",e.$Rn="dependecyOrPackExtensionInstall";function f(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Sn=f;function L(n){switch(n){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Tn=L;function R(n,l){switch(n){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Un=R;function $(n,l){return l==="web"&&!n.includes("web")}e.$Vn=$;function E(n,l,b){return $(l,b)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===b?!0:p(b).includes(n)}e.$Wn=E;function p(n){switch(n){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Xn=p;function A(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.$Yn=A;var I;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var w;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var k;(function(n){n.Install="install",n.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var D;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(D||(e.InstallOperation=D={})),e.$Zn=(0,F.$Bh)("extensionGalleryService");var v;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.Extract="Extract",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var o;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(o||(e.ExtensionSignaturetErrorCode=o={}));class s extends Error{constructor(l,b){super(l),this.code=b,this.name=b}}e.$1n=s,e.$2n=(0,F.$Bh)("extensionManagementService"),e.$3n="extensionsIdentifiers/disabled",e.$4n="extensionsIdentifiers/enabled",e.$5n=(0,F.$Bh)("IGlobalExtensionEnablementService"),e.$6n=(0,F.$Bh)("IExtensionTipsService"),e.$7n=(0,C.localize)(0,null),e.$8n={value:e.$7n,original:"Extensions"},e.$9n={value:(0,C.localize)(1,null),original:"Preferences"}}),define(Se[231],De([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mXb=e.$lXb=void 0,e.$lXb=(0,C.$Bh)("externalTerminal"),e.$mXb="Terminal.app"}),define(Se[232],De([1,0,48,17,16,12,99,29,102,194,231]),function($e,e,C,F,f,L,R,$,E,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=e.$95b=e.$85b=void 0;const I=p.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends w{static{this.b="cmd.exe"}openTerminal(b,h){return this.spawnTerminal(C,b,E.$ul(),h)}spawnTerminal(b,h,t,r){const a=h.windowsExec||k.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const i=f.$ae(a,".exe").toLowerCase();if(i==="cmder")return b.spawn(a,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return a.indexOf(" ")>=0&&c.push('""'),c.push(a),i==="wt"&&c.push("-d ."),new Promise((d,y)=>{const S=o(process),g=b.spawn(t,c,{cwd:r,env:S});g.on("error",y),g.on("exit",()=>d())})}runInTerminal(b,h,t,r,a){const i="windowsExec"in a&&a.windowsExec?a.windowsExec:k.getDefaultTerminalWindows();return new Promise((c,d)=>{const y=`"${h} - ${I}"`,S=`""${t.join('" "')}" & pause"`,g=Object.assign({},o(process),r);Object.keys(g).filter(N=>g[N]===null).forEach(N=>delete g[N]);const u={cwd:h,env:g,windowsVerbatimArguments:!0};let m,P;f.$ae(i,".exe")==="wt"?(m=i,P=["-d",".",k.b,"/c",S]):(m=k.b,P=["/c","start",y,"/wait",i,"/c",S]),C.spawn(m,P,u).on("error",N=>{d(s(N))}),c(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const b=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${b?"Sysnative":"System32"}\\cmd.exe`}return k.d}}e.$85b=k;class D extends w{static{this.b="/usr/bin/osascript"}openTerminal(b,h){return this.spawnTerminal(C,b,h)}runInTerminal(b,h,t,r,a){const i=a.osxExec||A.$mXb;return new Promise((c,d)=>{if(i===A.$mXb||i==="iTerm.app"){const y=i===A.$mXb?"TerminalHelper":"iTermHelper",g=[F.$2f.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",b||I,"-w",h];for(const P of t)g.push("-a"),g.push(P);if(r){const P=Object.assign({},o(process),r);for(const O in P){const N=P[O];N===null?(g.push("-u"),g.push(O)):(g.push("-e"),g.push(`${O}=${N}`))}}let u="";const m=C.spawn(D.b,g);m.on("error",P=>{d(s(P))}),m.stderr.on("data",P=>{u+=P.toString()}),m.on("exit",P=>{if(P===0)c(void 0);else if(u){const O=u.split(`
`,1);d(new Error(O[0]))}else d(new Error(p.localize(1,null,y,P)))})}else d(new Error(p.localize(2,null,i)))})}spawnTerminal(b,h,t){const r=h.osxExec||A.$mXb;return new Promise((a,i)=>{const c=["-a",r];t&&c.push(t);const d=o(process),y=b.spawn("/usr/bin/open",c,{cwd:t,env:d});y.on("error",i),y.on("exit",()=>a())})}}e.$95b=D;class v extends w{static{this.b=p.localize(3,null)}openTerminal(b,h){return this.spawnTerminal(C,b,h)}runInTerminal(b,h,t,r,a){const i=a.linuxExec?Promise.resolve(a.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((c,d)=>{const y=[];i.then(S=>{S.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const g=`${n(t)}; echo; read -p "${v.b}" -n1;`;y.push(`''${g}''`);const u=Object.assign({},o(process),r);Object.keys(u).filter(N=>u[N]===null).forEach(N=>delete u[N]);const m={cwd:h,env:u};let P="";const O=C.spawn(S,y,m);O.on("error",N=>{d(s(N))}),O.stderr.on("data",N=>{P+=N.toString()}),O.on("exit",N=>{if(N===0)c(void 0);else if(P){const M=P.split(`
`,1);d(new Error(M[0]))}else d(new Error(p.localize(4,null,S,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!L.$k)v.d=Promise.resolve("xterm");else{const b=await $.Promises.exists("/etc/debian_version");v.d=new Promise(h=>{b?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return v.d}spawnTerminal(b,h,t){const r=h.linuxExec?Promise.resolve(h.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,i)=>{r.then(c=>{const d=o(process),y=b.spawn(c,[],{cwd:t,env:d});y.on("error",i),y.on("exit",()=>a())})})}}e.$05b=v;function o(l){const b={...l.env};return(0,R.$sl)(b),b}function s(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(p.localize(5,null,l.path)):l}function n(l){let b="";for(const h of l)h.indexOf(" ")>=0?b+='"'+h+'"':b+=h,b+=" ";return b}}),define(Se[30],De([1,0,78,16,15,18,2,195,5,12,17]),function($e,e,C,F,f,L,R,$,E,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileKind=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileOperationResult=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileChangeType=e.$kk=e.FileOperation=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.FileSystemProviderErrorCode=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$7j=e.$6j=void 0,e.$6j=(0,E.$Bh)("fileService");function I(V){return V.create===!0}e.$7j=I;var w;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var k;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(k||(e.FilePermission=k={}));var D;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(D||(e.FileSystemProviderCapabilities=D={}));function v(V){return!!(V.capabilities&2)}e.$8j=v;function o(V){return!!(V.capabilities&8)}e.$9j=o;function s(V){return!!(V.capabilities&131072)}e.$0j=s;function n(V){return!!(V.capabilities&4)}e.$$j=n;function l(V){return!!(V.capabilities&16)}e.$_j=l;function b(V){return v(V)?!!(V.capabilities&16384):!1}e.$ak=b;function h(V){return v(V)?!!(V.capabilities&32768):!1}e.$bk=h;function t(V){return!!(V.capabilities&65536)}e.$ck=t;function r(V){return!!(V.capabilities&2048)}e.$dk=r;var a;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class i extends Error{static create(x,ge){const ue=new i(x.toString(),ge);return y(ue,ge),ue}constructor(x,ge){super(x),this.code=ge}}e.$ek=i;function c(V,x){return i.create(V,x)}e.$fk=c;function d(V){return V||c((0,$.localize)(0,null),a.Unknown)}e.$gk=d;function y(V,x){return V.name=x?`${x} (FileSystemError)`:"FileSystemError",V}e.$hk=y;function S(V){if(!V)return a.Unknown;if(V instanceof i)return V.code;const x=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!x)return a.Unknown;switch(x[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$ik=S;function g(V){if(V instanceof M)return V.fileOperationResult;switch(S(V)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$jk=g;var u;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(u||(e.FileOperation=u={}));class m{constructor(x,ge,ue){this.resource=x,this.operation=ge,this.target=ue}isOperation(x){return this.operation===x}}e.$kk=m;var P;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class O{constructor(x,ge){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ue=new Map;for(const ve of x){const G=ue.get(ve.type);switch(G?G.push([ve.resource,ve]):ue.set(ve.type,[[ve.resource,ve]]),ve.type){case 1:this.rawAdded.push(ve.resource);break;case 0:this.rawUpdated.push(ve.resource);break;case 2:this.rawDeleted.push(ve.resource);break}}for(const[ve,G]of ue)switch(ve){case 1:this.a=C.$Hh.forUris(()=>ge),this.a.fill(G);break;case 0:this.b=C.$Hh.forUris(()=>ge),this.b.fill(G);break;case 2:this.c=C.$Hh.forUris(()=>ge),this.c.fill(G);break}}contains(x,...ge){return this.d(x,{includeChildren:!1},...ge)}affects(x,...ge){return this.d(x,{includeChildren:!0},...ge)}d(x,ge,...ue){if(!x)return!1;const ve=ue.length>0;return!!((!ve||ue.includes(1))&&(this.a?.get(x)||ge.includeChildren&&this.a?.findSuperstr(x))||(!ve||ue.includes(0))&&(this.b?.get(x)||ge.includeChildren&&this.b?.findSuperstr(x))||(!ve||ue.includes(2))&&(this.c?.findSubstr(x)||ge.includeChildren&&this.c?.findSuperstr(x)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$lk=O;function N(V,x,ge){return!V||!x||V===x||x.length>V.length?!1:(x.charAt(x.length-1)!==F.sep&&(x+=F.sep),ge?(0,f.$Ne)(V,x):V.indexOf(x)===0)}e.$mk=N;class M extends Error{constructor(x,ge,ue){super(x),this.fileOperationResult=ge,this.options=ue}}e.$nk=M;class j extends M{constructor(x,ge,ue,ve){super(x,ge,ve),this.fileOperationResult=ge,this.size=ue}}e.$ok=j;class z extends M{constructor(x,ge,ue){super(x,2,ue),this.stat=ge}}e.$pk=z;var T;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(T||(e.FileOperationResult=T={})),e.$qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sk="files.associations",e.$tk="files.exclude",e.$uk="files.readonlyInclude",e.$vk="files.readonlyExclude",e.$wk="files.readonlyFromPermissions";var H;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$xk="";function q(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.$yk=q;async function me(V,x){if(!x.hasProvider(R.URI.from({scheme:V.scheme})))return new Promise(ge=>{const ue=x.onDidChangeFileSystemProviderRegistrations(ve=>{ve.scheme===V.scheme&&ve.added&&(ue.dispose(),ge())})})}e.$zk=me;class Z{static{this.KB=1024}static{this.MB=Z.KB*Z.KB}static{this.GB=Z.MB*Z.KB}static{this.TB=Z.GB*Z.KB}static formatSize(x){return(0,L.$nf)(x)||(x=0),x<Z.KB?(0,$.localize)(1,null,x.toFixed(0)):x<Z.MB?(0,$.localize)(2,null,(x/Z.KB).toFixed(2)):x<Z.GB?(0,$.localize)(3,null,(x/Z.MB).toFixed(2)):x<Z.TB?(0,$.localize)(4,null,(x/Z.GB).toFixed(2)):(0,$.localize)(5,null,(x/Z.TB).toFixed(2))}}e.$Ak=Z;function X(V){const x=typeof V=="string"||V?.scheme===A.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===A.Schemas.file?1024*Z.MB:x?10*Z.MB:p.$o?50*Z.MB:1024*Z.MB}e.$Bk=X}),define(Se[233],De([1,0,22,8,196,30]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function R(A,I,w,k,D,v){let o;try{await $(A,I,w,k,D,v)}catch(s){o=s}finally{o&&D.errorTransformer&&(o=D.errorTransformer(o)),typeof o<"u"&&w.error(o),w.end()}}e.$Cp=R;async function $(A,I,w,k,D,v){E(v);const o=await A.open(I,{create:!1});try{E(v);let s=0,n=0,l=D&&typeof D.length=="number"?D.length:void 0,b=C.$Fd.alloc(Math.min(D.bufferSize,typeof l=="number"?l:D.bufferSize)),h=D&&typeof D.position=="number"?D.position:0,t=0;do n=await A.read(o,h,b.buffer,t,b.byteLength-t),h+=n,t+=n,s+=n,typeof l=="number"&&(l-=n),t===b.byteLength&&(await w.write(k(b)),b=C.$Fd.alloc(Math.min(D.bufferSize,typeof l=="number"?l:D.bufferSize)),t=0);while(n>0&&(typeof l!="number"||l>0)&&E(v)&&p(s,D));if(t>0){let r=t;typeof l=="number"&&(r=Math.min(t,l)),w.write(k(b.slice(0,r)))}}catch(s){throw(0,L.$gk)(s)}finally{await A.close(o)}}function E(A){if(A.isCancellationRequested)throw(0,F.$4)();return!0}function p(A,I){if(typeof I?.limits?.size=="number"&&A>I.limits.size)throw(0,L.$fk)((0,f.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[84],De([1,0,35,3,16,12,2,30]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=void 0;function E(s){return s.recursive===!0}e.$Ep=E;class p extends F.$kc{static{this.a=5}constructor(n,l,b,h){super(),this.h=n,this.j=l,this.m=b,this.n=h,this.c=this.B(new F.$lc),this.f=void 0,this.g=0}s(){const n=new F.$jc;this.c.value=n,this.b=this.r(n),this.b.setVerboseLogging(this.m),n.add(this.b.onDidChangeFile(l=>this.h(l))),n.add(this.b.onDidLogMessage(l=>this.j(l))),n.add(this.b.onDidError(l=>this.t(l)))}t(n){this.n.restartOnError?this.g<p.a&&this.f?(this.w(`restarting watcher after error: ${n}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${n}`):this.w(n)}u(n){this.g++,this.s(),this.watch(n)}async watch(n){this.f=n,await this.b?.watch(n)}async setVerboseLogging(n){this.m=n,await this.b?.setVerboseLogging(n)}w(n){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${n}`})}y(n){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${n}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fp=p;class A extends p{constructor(n,l,b){super(n,l,b,{type:"node.js",restartOnError:!1})}}e.$Gp=A;class I extends p{constructor(n,l,b){super(n,l,b,{type:"universal",restartOnError:!0})}}e.$Hp=I;function w(s){return s.map(n=>({type:n.type,resource:R.URI.file(n.path)}))}e.$Ip=w;function k(s){const n=new o;for(const l of s)n.processEvent(l);return n.coalesce()}e.$Jp=k;function D(s,n){return typeof n=="string"&&!n.startsWith(C.$nj)&&!(0,f.$8d)(n)?{base:s,pattern:n}:n}e.$Kp=D;function v(s,n){const l=[];for(const b of n)l.push((0,C.$rj)(D(s,b)));return l}e.$Lp=v;class o{constructor(){this.a=new Set,this.b=new Map}c(n){return L.$k?n.path:n.path.toLowerCase()}processEvent(n){const l=this.b.get(this.c(n));let b=!1;if(l){const h=l.type,t=n.type;l.path!==n.path&&(n.type===2||n.type===1)?b=!0:h===1&&t===2?(this.b.delete(this.c(n)),this.a.delete(l)):h===2&&t===1?l.type=0:h===1&&t===0||(l.type=t)}else b=!0;b&&(this.a.add(n),this.b.set(this.c(n),n))}coalesce(){const n=[],l=[];return Array.from(this.a).filter(b=>b.type!==2?(n.push(b),!1):!0).sort((b,h)=>b.path.length-h.path.length).filter(b=>l.some(h=>(0,$.$mk)(b.path,h,!L.$k))?!1:(l.push(b.path),!0)).concat(n)}}}),define(Se[234],De([1,0,52,9,21,32,3,77,16,12,101,29,84]),function($e,e,C,F,f,L,R,$,E,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0;class k extends R.$kc{static{this.a=100}static{this.b=75}constructor(o,s,n,l){super(),this.m=o,this.n=s,this.r=n,this.s=l,this.c=this.B(new F.$Vg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},b=>this.n(b))),this.f=this.B(new F.$Ug(b=>this.z(b),k.b)),this.g=(0,w.$Lp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,w.$Lp)(this.m.path,this.m.includes):void 0,this.j=new f.$pd,this.ready=this.t()}async t(){try{const o=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const s=await I.Promises.stat(o);this.B(await this.w(o,s.isDirectory()))}catch(o){o.code!=="ENOENT"?this.D(o):this.G(o)}}async u(o){let s=o.path;try{s=await I.Promises.realpath(o.path),o.path===s&&(s=await(0,A.$Vp)(o.path)??o.path),o.path!==s&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${s})`)}catch{}return s}async w(o,s){if(p.$j&&(0,L.$If)(o,"/Volumes/",!0))return this.D(`Refusing to watch ${o} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$kc.None;const n=new f.$pd(this.j.token),l=new R.$jc;try{const b=(0,E.$ae)(o),h=(0,C.watch)(o);l.add((0,R.$ic)(()=>{h.removeAllListeners(),h.close()})),this.G(`Started watching: '${o}'`);const t=new Set;if(s)try{for(const a of await I.Promises.readdir(o))t.add(a)}catch(a){this.D(a)}const r=new Map;l.add((0,R.$ic)(()=>{for(const[,a]of r)a.dispose();r.clear()})),h.on("error",(a,i)=>{this.D(`Failed to watch ${o} for changes using fs.watch() (${a}, ${i})`),this.dispose()}),h.on("change",(a,i)=>{if(n.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${i}`);let c="";if(i&&(c=i.toString(),p.$j&&(c=(0,$.$hl)(c))),!(!c||a!=="change"&&a!=="rename"))if(s)if(a==="rename"){r.get(c)?.dispose();const d=setTimeout(async()=>{if(r.delete(c),c===b&&!await I.Promises.exists(o)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const y=await this.C((0,E.$9d)(o,c));if(n.token.isCancellationRequested)return;let S;y?t.has(c)?S=0:(S=1,t.add(c)):(t.delete(c),S=2),this.y({path:(0,E.$9d)(this.m.path,c),type:S})},k.a);r.set(c,(0,R.$ic)(()=>clearTimeout(d)))}else{let d;t.has(c)?d=0:(d=1,t.add(c)),this.y({path:(0,E.$9d)(this.m.path,c),type:d})}else if(a==="rename"||c!==b){const d=setTimeout(async()=>{const y=await I.Promises.exists(o);n.token.isCancellationRequested||(y?(this.y({path:this.m.path,type:0},!0),l.add(await this.w(o,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},k.a);l.clear(),l.add((0,R.$ic)(()=>clearTimeout(d)))}else this.y({path:this.m.path,type:0},!0)})}catch(b){await I.Promises.exists(o)&&!n.token.isCancellationRequested&&this.D(`Failed to watch ${o} for changes using fs.watch() (${b.toString()})`)}return(0,R.$ic)(()=>{n.dispose(!0),l.dispose()})}y(o,s=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`),!s&&this.g.some(n=>n(o.path))?this.s&&this.G(` >> ignored (excluded) ${o.path}`):!s&&this.h&&this.h.length>0&&!this.h.some(n=>n(o.path))?this.s&&this.G(` >> ignored (not included) ${o.path}`):this.f.work(o))}z(o){const s=(0,w.$Jp)(o);if(s.length>0){if(this.s)for(const l of s)this.G(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.c.work(s)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(o){if(p.$k)return I.Promises.exists(o);try{const s=(0,E.$ae)(o);return(await I.Promises.readdir((0,E.$_d)(o))).some(l=>l===s)}catch(s){return this.G(s),!1}}setVerboseLogging(o){this.s=o}D(o){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${o}`})}F(o){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${o}`})}G(o){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${o}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Yp=k;async function D(v,o,s,n,l=512){const b=await I.Promises.open(v,"r"),h=Buffer.allocUnsafe(l),t=new f.$pd(n);let r,a=!1;const i={path:v,excludes:[],recursive:!1},c=new k(i,d=>{(async()=>{for(const{type:y}of d)if(y===0){if(a)return;a=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:S}=await I.Promises.read(b,h,0,l,null);if(!S||t.token.isCancellationRequested)break;o(h.slice(0,S))}}catch(S){r=new Error(S),t.dispose(!0)}finally{a=!1}}})()});return await c.ready,s(),new Promise((d,y)=>{t.token.onCancellationRequested(async()=>{c.dispose();try{await I.Promises.close(b)}catch(S){r=new Error(S)}r?y(r):d()})})}e.$Zp=D}),define(Se[235],De([1,0,4,35,3,12,234]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class $ extends f.$kc{constructor(){super(...arguments),this.a=this.B(new C.$fd),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$fd),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch(p){const A=this.j(p),I=A.filter(k=>{const D=this.c.get(k.path);return D?!(0,F.$vj)(D.request.excludes,k.excludes)||!(0,F.$vj)(D.request.includes,k.includes):!0}),w=Array.from(this.c.values()).filter(({request:k})=>!A.find(D=>D.path===k.path&&(0,F.$vj)(D.excludes,k.excludes)&&(0,F.$vj)(D.includes,k.includes))).map(({request:k})=>k.path);I.length&&this.m(`Request to start watching: ${I.map(k=>`${k.path} (excludes: ${k.excludes.length>0?k.excludes:"<none>"}, includes: ${k.includes&&k.includes.length>0?JSON.stringify(k.includes):"<all>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const k of w)this.h(k);for(const k of I)this.g(k)}g(p){const A=new R.$Yp(p,w=>this.a.fire(w),w=>this.b.fire(w),this.f),I={request:p,instance:A};this.c.set(p.path,I)}async stop(){for(const[p]of this.c)this.h(p);this.c.clear()}h(p){const A=this.c.get(p);A&&(this.c.delete(p),A.instance.dispose())}j(p){const A=new Map;for(const I of p){const w=L.$k?I.path:I.path.toLowerCase();A.set(w,I)}return Array.from(A.values())}async setVerboseLogging(p){this.f=p;for(const[,A]of this.c)A.instance.setVerboseLogging(p)}m(p){this.f&&this.b.fire({type:"trace",message:this.n(p)})}n(p,A){return A?`[File Watcher (node.js)] ${p} (path: ${A.request.path})`:`[File Watcher (node.js)] ${p}`}}e.$1p=$}),define(Se[236],De([1,0,84,235]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class f extends C.$Gp{constructor(R,$,E){super(R,$,E),this.s()}r(R){return R.add(new F.$1p)}}e.$2p=f}),define(Se[237],De([1,0,17,81,183,84]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class R extends L.$Hp{constructor(E,p,A){super(E,p,A),this.s()}r(E){const p=E.add(new f.$Sp(C.$2f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(p.onDidProcessExit(({code:A,signal:I})=>this.t(`terminated by itself with code ${A}, signal: ${I}`))),F.ProxyChannel.toService((0,F.$ih)(p.getChannel("watcher")))}}e.$Tp=R}),define(Se[105],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=void 0;class C{constructor(...f){this.a=new Map;for(const[L,R]of f)this.set(L,R)}set(f,L){const R=this.a.get(f);return this.a.set(f,L),R}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$zh=C}),define(Se[238],De([1,0,9,8,3,103,229,5,105,76]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;const A=!1;class I extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class w{constructor(o=new E.$zh,s=!1,n,l=A){this.f=o,this.g=s,this.h=n,this.i=l,this.o=new Set,this.f.set($.$Ah,this),this._globalGraph=l?n?._globalGraph??new R.$5p(b=>b):void 0}createChild(o){return new w(o,this.g,this,this.i)}invokeFunction(o,...s){const n=D.traceInvocation(this.i,o);let l=!1;try{return o({get:h=>{if(l)throw(0,F.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(h,n);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{l=!0,n.stop()}}createInstance(o,...s){let n,l;return o instanceof L.$yh?(n=D.traceCreation(this.i,o.ctor),l=this.j(o.ctor,o.staticArguments.concat(s),n)):(n=D.traceCreation(this.i,o),l=this.j(o,s,n)),n.stop(),l}j(o,s=[],n){const l=$._util.getServiceDependencies(o).sort((t,r)=>t.index-r.index),b=[];for(const t of l){const r=this.m(t.id,n);r||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),b.push(r)}const h=l.length>0?l[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(o,s.concat(b))}k(o,s){if(this.f.get(o)instanceof L.$yh)this.f.set(o,s);else if(this.h)this.h.k(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const s=this.f.get(o);return!s&&this.h?this.h.l(o):s}m(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof L.$yh?this.q(o,n,s.branch(o,!0)):(s.branch(o,!1),n)}q(o,s,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,s,n)}finally{this.o.delete(o)}}r(o,s,n){const l=new R.$5p(t=>t.id.toString());let b=0;const h=[{id:o,desc:s,_trace:n}];for(;h.length;){const t=h.pop();if(l.lookupOrInsertNode(t),b++>1e3)throw new I(l);for(const r of $._util.getServiceDependencies(t.desc.ctor)){const a=this.l(r.id);if(a||this.u(`[createInstance] ${o} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),a instanceof L.$yh){const i={id:r.id,desc:a,_trace:t._trace.branch(r.id,!0)};l.insertEdge(t,i),h.push(i)}}}for(;;){const t=l.roots();if(t.length===0){if(!l.isEmpty())throw new I(l);break}for(const{data:r}of t){if(this.l(r.id)instanceof L.$yh){const i=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,i)}l.removeNode(r)}}return this.l(o)}s(o,s,n=[],l,b){if(this.f.get(o)instanceof L.$yh)return this.t(o,s,n,l,b);if(this.h)return this.h.s(o,s,n,l,b);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(o,s,n=[],l,b){if(l){const h=new w(void 0,this.g,this,this.i);h.c=String(o);const t=new Map,r=new C.$Xg(()=>{const a=h.j(s,n,b);for(const[i,c]of t){const d=a[i];if(typeof d=="function")for(const y of c)d.apply(a,y)}return t.clear(),a});return new Proxy(Object.create(null),{get(a,i){if(!r.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let y=t.get(i);return y||(y=new p.$tc,t.set(i,y)),(g,u,m)=>{const P=y.push([g,u,m]);return(0,f.$ic)(P)}}if(i in a)return a[i];const c=r.value;let d=c[i];return typeof d!="function"||(d=d.bind(c),a[i]=d),d},set(a,i,c){return r.value[i]=c,!0},getPrototypeOf(a){return s.prototype}})}else return this.j(s,n,b)}u(o,s){if(s&&console.warn(o),this.g)throw new Error(o)}}e.$6p=w;var k;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(k||(k={}));class D{static{this.all=new Set}static{this.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new D(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(o,s){return o?new D(1,s.name):D.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const n=new D(3,o.toString());return this.h.push([o,s,n]),n}stop(){const o=Date.now()-this.g;D.f+=o;let s=!1;function n(b,h){const t=[],r=new Array(b+1).join("	");for(const[a,i,c]of h.h)if(i&&c){s=!0,t.push(`${r}CREATES -> ${a}`);const d=n(b+1,c);d&&t.push(d)}else t.push(`${r}uses -> ${a}`);return t.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(o>2||s)&&D.all.add(l.join(`
`))}}e.$7p=D}),define(Se[14],De([1,0,46,4,51,3,28,12,24,18,2,41,5]),function($e,e,C,F,f,L,R,$,E,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.log=e.$8i=e.LogLevel=e.$7i=e.$6i=e.$5i=void 0,e.$5i=(0,w.$Bh)("logService"),e.$6i=(0,w.$Bh)("loggerService");function k(){return new Date().toISOString()}function D(g){return(0,p.$nf)(g)}e.$7i=D;var v;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$8i=v.Info;function o(g,u,m){switch(u){case v.Trace:g.trace(m);break;case v.Debug:g.debug(m);break;case v.Info:g.info(m);break;case v.Warning:g.warn(m);break;case v.Error:g.error(m);break;case v.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=o;function s(g,u=!1){let m="";for(let P=0;P<g.length;P++){let O=g[P];if(O instanceof Error&&(O=(0,C.$mi)(O,u)),typeof O=="object")try{O=JSON.stringify(O)}catch{}m+=(P>0?" ":"")+O}return m}class n extends L.$kc{constructor(){super(...arguments),this.b=e.$8i,this.c=this.B(new F.$fd),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==v.Off&&this.b<=u}}e.$0i=n;class l extends n{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...m){this.f(v.Trace)&&this.g(v.Trace,s([u,...m],!0))}debug(u,...m){this.f(v.Debug)&&this.g(v.Debug,s([u,...m]))}info(u,...m){this.f(v.Info)&&this.g(v.Info,s([u,...m]))}warn(u,...m){this.f(v.Warning)&&this.g(v.Warning,s([u,...m]))}error(u,...m){if(this.f(v.Error))if(u instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=u.stack,this.g(v.Error,s(P))}else this.g(v.Error,s([u,...m]))}flush(){}}e.$$i=l;class b extends n{constructor(u=e.$8i){super(),this.setLevel(u),this.g=!$.$i}trace(u,...m){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,u,...m):console.log(`[main ${k()}]`,u,...m))}debug(u,...m){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,u,...m):console.log(`[main ${k()}]`,u,...m))}info(u,...m){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,u,...m):console.log(`[main ${k()}]`,u,...m))}warn(u,...m){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,u,...m):console.warn(`[main ${k()}]`,u,...m))}error(u,...m){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,u,...m):console.error(`[main ${k()}]`,u,...m))}dispose(){}flush(){}}e.$_i=b;class h extends n{constructor(u=e.$8i,m=!0){super(),this.g=m,this.setLevel(u)}trace(u,...m){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...m):console.log(u,...m))}debug(u,...m){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...m):console.log(u,...m))}info(u,...m){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...m):console.log(u,...m))}warn(u,...m){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...m):console.log(u,...m))}error(u,...m){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...m):console.error(u,...m))}dispose(){}flush(){}}e.$aj=h;class t extends n{constructor(u,m=e.$8i){super(),this.g=u,this.setLevel(m)}trace(u,...m){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(u),...m])}debug(u,...m){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(u),...m])}info(u,...m){this.f(v.Info)&&this.g.log(v.Info,[this.h(u),...m])}warn(u,...m){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(u),...m])}error(u,...m){this.f(v.Error)&&this.g.log(v.Error,[this.h(u),...m])}h(u){return typeof u=="string"?u:(0,C.$mi)(u,this.f(v.Trace))}dispose(){}flush(){}}e.$bj=t;class r extends n{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const m of this.g)m.setLevel(u);super.setLevel(u)}trace(u,...m){for(const P of this.g)P.trace(u,...m)}debug(u,...m){for(const P of this.g)P.debug(u,...m)}info(u,...m){for(const P of this.g)P.info(u,...m)}warn(u,...m){for(const P of this.g)P.warn(u,...m)}error(u,...m){for(const P of this.g)P.error(u,...m)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose()}}e.$cj=r;class a extends L.$kc{constructor(u,m,P){if(super(),this.h=u,this.j=m,this.b=new R.$zi,this.c=this.B(new F.$fd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$fd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$fd),this.onDidChangeVisibility=this.g.event,P)for(const O of P)this.b.set(O.resource,{logger:void 0,info:O})}m(u){return(0,p.$jf)(u)?[...this.b.values()].find(m=>m.info.id===u):this.b.get(u)}getLogger(u){return this.m(u)?.logger}createLogger(u,m){const P=this.n(u),O=(0,p.$jf)(u)?u:m?.id??(0,f.$pi)(P.toString()).toString(16);let N=this.b.get(P)?.logger;const M=m?.logLevel==="always"?v.Trace:m?.logLevel;N||(N=this.s(P,M??this.getLogLevel(P)??this.h,{...m,id:O}));const j={logger:N,info:{resource:P,id:O,logLevel:M,name:m?.name,hidden:m?.hidden,extensionId:m?.extensionId,when:m?.when}};return this.registerLogger(j.info),this.b.set(P,j),N}n(u){return(0,p.$jf)(u)?(0,E.$ig)(this.j,`${u}.log`):u}setLogLevel(u,m){if(A.URI.isUri(u)){const P=u,O=m,N=this.b.get(P);N&&O!==N.info.logLevel&&(N.info.logLevel=O===this.h?void 0:O,N.logger?.setLevel(O),this.b.set(N.info.resource,N),this.f.fire([P,O]))}else{this.h=u;for(const[P,O]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,m){const P=this.m(u);P&&m!==!P.info.hidden&&(P.info.hidden=!m,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,m]))}getLogLevel(u){let m;return u&&(m=this.b.get(u)?.info.logLevel),m??this.h}registerLogger(u){const m=this.b.get(u.resource);m?m.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const m=this.b.get(u);m&&(m.logger&&m.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[m.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dj=a;class i{constructor(){this.onDidChangeLogLevel=new F.$fd().event}setLevel(u){}getLevel(){return v.Info}trace(u,...m){}debug(u,...m){}info(u,...m){}warn(u,...m){}error(u,...m){}critical(u,...m){}dispose(){}flush(){}}e.$ej=i;class c extends i{}e.$fj=c;function d(g){if(g.verbose)return v.Trace;if(typeof g.logLevel=="string"){const u=S(g.logLevel.toLowerCase());if(u!==void 0)return u}return e.$8i}e.$gj=d;function y(g){switch(g){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$hj=y;function S(g){switch(g){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$ij=S,e.$jj=new I.$2i("logLevel",y(v.Info))}),define(Se[239],De([1,0,19,9,8,4,3,16,84,14]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class A extends R.$kc{constructor(w,k){super(),this.a=w,this.b=k,this.c=this.B(new L.$fd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$fd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$Eg(0)),this.w=[],this.y=this.B(new F.$Eg(0))}watch(w,k){return k.recursive||this.b?.watcher?.forceUniversal?this.n(w,k):this.z(w,k)}n(w,k){const D={path:this.H(w),excludes:k.excludes,includes:k.includes,recursive:k.recursive},v=(0,C.$Sb)(this.j,D);return this.r(),(0,R.$ic)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,f.$Y)(w))}s(){this.h||(this.h=this.B(this.t(k=>this.c.fire((0,E.$Ip)(k)),k=>this.G(k),this.a.getLevel()===p.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===p.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const k of this.j)(0,E.$Ep)(k)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const k of this.j)(0,E.$Ep)(k)&&w.includes(k.path)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,k){const D={path:this.H(w),excludes:k.excludes,includes:k.includes,recursive:!1},v=(0,C.$Sb)(this.w,D);return this.C(),(0,R.$ic)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,f.$Y)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,E.$Ip)(w)),w=>this.G(w),this.a.getLevel()===p.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===p.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,$.$7d)(w.fsPath)}}e.$Mp=A}),define(Se[240],De([1,0,52,373,9,28,22,4,32,3,16,12,24,97,29,197,30,233,239,46,237,236]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0,(()=>{try{(0,F.gracefulify)(C)}catch(r){console.error(`Error enabling graceful-fs: ${(0,l.$mi)(r)}`)}})();class t extends n.$Mp{static{this.I=!1}constructor(a,i){super(a,i),this.onDidChangeCapabilities=$.Event.None,this.N=new L.$zi(c=>w.$_f.getComparisonKey(c)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(a){try{const{stat:i,symbolicLink:c}=await D.SymlinkSupport.stat(this.H(a));return{type:this.M(i,c),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:o.FilePermission.Locked}}catch(i){throw this.eb(i)}}async L(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const i=await D.Promises.readdir(this.H(a),{withFileTypes:!0}),c=[];return await Promise.all(i.map(async d=>{try{let y;d.isSymbolicLink()?y=(await this.stat((0,w.$ig)(a,d.name))).type:y=this.M(d),c.push([d.name,y])}catch(y){this.a.trace(y)}})),c}catch(i){throw this.eb(i)}}M(a,i){let c;return i?.dangling?c=o.FileType.Unknown:a.isFile()?c=o.FileType.File:a.isDirectory()?c=o.FileType.Directory:c=o.FileType.Unknown,i&&(c|=o.FileType.SymbolicLink),c}async O(a){const i=this.H(a);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let c;for(;c=this.N.get(a);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await c.wait();const d=new f.$Fg;return this.N.set(a,d),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,p.$ic)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(a)===d&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(a)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),d.open()})}async readFile(a,i){let c;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(a)})`),c=await this.O(a));const d=this.H(a);return await D.Promises.readFile(d)}catch(d){throw this.eb(d)}finally{c?.dispose()}}P(a){t.I&&this.a.trace(a)}readFileStream(a,i,c){const d=(0,k.$td)(y=>R.$Fd.concat(y.map(S=>R.$Fd.wrap(S))).buffer);return(0,s.$Cp)(this,a,d,y=>y.buffer,{...i,bufferSize:256*1024},c),d}async writeFile(a,i,c){return c?.atomic!==!1&&c?.atomic?.postfix?this.Q(a,(0,w.$ig)((0,w.$hg)(a),`${(0,w.$fg)(a)}${c.atomic.postfix}`),i,c):this.R(a,i,c)}async Q(a,i,c,d){await this.R(i,c,d);try{await this.rename(i,a,{overwrite:!0})}catch(y){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw y}}async R(a,i,c){let d;try{const y=this.H(a);if(!c.create||!c.overwrite){if(await D.Promises.exists(y)){if(!c.overwrite)throw(0,o.$fk)((0,v.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,o.$fk)((0,v.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(a,{create:!0,unlock:c.unlock}),await this.write(d,0,i,0,i.byteLength)}catch(y){throw await this.fb(a,y)}finally{typeof d=="number"&&await this.close(d)}}static{this.X=!0}static configureFlushOnWrite(a){t.X=a}async open(a,i){const c=this.H(a);let d;(0,o.$7j)(i)&&(d=await this.O(a));let y;try{if((0,o.$7j)(i)&&i.unlock)try{const{stat:g}=await D.SymlinkSupport.stat(c);g.mode&128||await D.Promises.chmod(c,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let S;if((0,o.$7j)(i)){if(I.$i)try{await D.Promises.truncate(c,0),S="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}S||(S="w")}else S="r";y=await D.Promises.open(c,S)}catch(S){throw d?.dispose(),(0,o.$7j)(i)?await this.fb(a,S):this.eb(S)}if(this.S.set(y,0),(0,o.$7j)(i)&&this.W.set(y,a),d){const S=this.U.get(y);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${c})`),this.U.set(y,d),S&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${c})`),S.dispose())}return y}async close(a){const i=this.U.get(a);try{if(this.S.delete(a),this.W.delete(a)&&t.X)try{await D.Promises.fdatasync(a)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await D.Promises.close(a)}catch(c){throw this.eb(c)}finally{i&&(this.U.get(a)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.U.delete(a)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),i.dispose())}}async read(a,i,c,d,y){const S=this.Y(a,i);let g=null;try{g=(await D.Promises.read(a,c,d,y,S)).bytesRead}catch(u){throw this.eb(u)}finally{this.Z(a,S,g)}return g}Y(a,i){return i===this.S.get(a)?null:i}Z(a,i,c){const d=this.S.get(a);typeof d=="number"&&(typeof i=="number"||(typeof c=="number"?this.S.set(a,d+c):this.S.delete(a)))}async write(a,i,c,d,y){return(0,f.$Yg)(()=>this.$(a,i,c,d,y),100,3)}async $(a,i,c,d,y){const S=this.Y(a,i);let g=null;try{g=(await D.Promises.write(a,c,d,y,S)).bytesWritten}catch(u){throw await this.fb(this.W.get(a),u)}finally{this.Z(a,S,g)}return g}async mkdir(a){try{await D.Promises.mkdir(this.H(a))}catch(i){throw this.eb(i)}}async delete(a,i){try{const c=this.H(a);if(i.recursive){let d;i?.atomic!==!1&&i.atomic.postfix&&(d=(0,A.$9d)((0,A.$_d)(c),`${(0,A.$ae)(c)}${i.atomic.postfix}`)),await D.Promises.rm(c,D.RimRafMode.MOVE,d)}else try{await D.Promises.unlink(c)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let y=!1;try{const{stat:S,symbolicLink:g}=await D.SymlinkSupport.stat(c);y=S.isDirectory()&&!g}catch{}if(y)await D.Promises.rmdir(c);else throw d}else throw d}}catch(c){throw this.eb(c)}}async rename(a,i,c){const d=this.H(a),y=this.H(i);if(d!==y)try{await this.ab(a,i,"move",c.overwrite),await D.Promises.rename(d,y)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,v.localize)(2,null,(0,A.$ae)(d),(0,A.$ae)((0,A.$_d)(y)),S.toString()))),this.eb(S)}}async copy(a,i,c){const d=this.H(a),y=this.H(i);if(d!==y)try{await this.ab(a,i,"copy",c.overwrite),await D.Promises.copy(d,y,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,v.localize)(3,null,(0,A.$ae)(d),(0,A.$ae)((0,A.$_d)(y)),S.toString()))),this.eb(S)}}async ab(a,i,c,d){const y=this.H(a),S=this.H(i);let g=!1;if(!!(this.capabilities&1024)||(g=(0,E.$Hf)(y,S,!0)),g){if(c==="copy")throw(0,o.$fk)((0,v.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const m=await this.L(a);if(!m)throw(0,o.$fk)((0,v.localize)(5,null),o.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(i);if(P){if(!d)throw(0,o.$fk)((0,v.localize)(6,null),o.FileSystemProviderErrorCode.FileExists);m.type&o.FileType.File&&P.type&o.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,i){return this.bb(a,i,!1)}async bb(a,i,c){const d=this.H(a),y=this.H(i),S=!!(this.capabilities&1024);if((0,E.$Hf)(d,y,!S))return;const g=new p.$jc;try{const[u,m]=await Promise.all([this.O(a),this.O(i)]);g.add(u),g.add(m),c&&await D.Promises.mkdir((0,A.$_d)(y),{recursive:!0}),await D.Promises.copyFile(d,y)}catch(u){if(u.code==="ENOENT"&&!c)return this.bb(a,i,!0);throw this.eb(u)}finally{g.dispose()}}t(a,i,c){return new b.$Tp(d=>a(d),d=>i(d),c)}F(a,i,c){return new h.$2p(d=>a(d),d=>i(d),c)}eb(a){if(a instanceof o.$ek)return a;let i=a,c;switch(a.code){case"ENOENT":c=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=o.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=o.FileSystemProviderErrorCode.Unknown;break;default:c=o.FileSystemProviderErrorCode.Unknown}return(0,o.$fk)(i,c)}async fb(a,i){let c=this.eb(i);if(a&&c.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await D.SymlinkSupport.stat(this.H(a));d.mode&128||(c=(0,o.$fk)(i,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return c}}e.$3p=t}),define(Se[241],De([1,0,3,14]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0;class f extends C.$kc{constructor(R,$=[]){super(),this.a=new F.$cj([R,...$]),this.B(R.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$mN=f}),define(Se[242],De([1,0,30,14]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=void 0;var f;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(f||(f={}));async function L(p,A,I,w,k){try{const D=await new Promise((o,s)=>{$e(["@vscode/spdlog"],o,s)});D.setFlushOn(f.Trace);const v=await D.createAsyncRotatingLogger(p,A,I,w);return k?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(D){console.error(D)}return null}function R(p,A,I){switch(A){case F.LogLevel.Trace:p.trace(I);break;case F.LogLevel.Debug:p.debug(I);break;case F.LogLevel.Info:p.info(I);break;case F.LogLevel.Warning:p.warn(I);break;case F.LogLevel.Error:p.error(I);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function $(p,A){switch(A){case F.LogLevel.Trace:p.setLevel(f.Trace);break;case F.LogLevel.Debug:p.setLevel(f.Debug);break;case F.LogLevel.Info:p.setLevel(f.Info);break;case F.LogLevel.Warning:p.setLevel(f.Warning);break;case F.LogLevel.Error:p.setLevel(f.Error);break;case F.LogLevel.Off:p.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class E extends F.$$i{constructor(A,I,w,k,D){super(),this.m=[],this.setLevel(D),this.n=this.s(A,I,w,k),this.B(this.onDidChangeLogLevel(v=>{this.r&&$(this.r,v)}))}async s(A,I,w,k){const D=w?6:1,v=30/D*C.$Ak.MB,o=await L(A,I,v,D,k);if(o){this.r=o,$(this.r,this.getLevel());for(const{level:s,message:n}of this.m)R(this.r,s,n);this.m=[]}}g(A,I){this.r?R(this.r,A,I):this.getLevel()<=A&&this.m.push({level:A,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$bN=E}),define(Se[133],De([1,0,38,198,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(E){function p(D,v){return v-D}E.compare=p;const A=Object.create(null);A[E.Error]=(0,F.localize)(0,null),A[E.Warning]=(0,F.localize)(1,null),A[E.Info]=(0,F.localize)(2,null);function I(D){return A[D]||""}E.toString=I;function w(D){switch(D){case C.default.Error:return E.Error;case C.default.Warning:return E.Warning;case C.default.Info:return E.Info;case C.default.Ignore:return E.Hint}}E.fromSeverity=w;function k(D){switch(D){case E.Error:return C.default.Error;case E.Warning:return C.default.Warning;case E.Info:return C.default.Info;case E.Hint:return C.default.Ignore}}E.toSeverity=k}(R||(e.MarkerSeverity=R={}));var $;(function(E){const p="";function A(w){return I(w,!0)}E.makeKey=A;function I(w,k){const D=[p];return w.source?D.push(w.source.replace("\xA6","\\\xA6")):D.push(p),w.code?typeof w.code=="string"?D.push(w.code.replace("\xA6","\\\xA6")):D.push(w.code.value.replace("\xA6","\\\xA6")):D.push(p),w.severity!==void 0&&w.severity!==null?D.push(R.toString(w.severity)):D.push(p),w.message&&k?D.push(w.message.replace("\xA6","\\\xA6")):D.push(p),w.startLineNumber!==void 0&&w.startLineNumber!==null?D.push(w.startLineNumber.toString()):D.push(p),w.startColumn!==void 0&&w.startColumn!==null?D.push(w.startColumn.toString()):D.push(p),w.endLineNumber!==void 0&&w.endLineNumber!==null?D.push(w.endLineNumber.toString()):D.push(p),w.endColumn!==void 0&&w.endColumn!==null?D.push(w.endColumn.toString()):D.push(p),D.push(p),D.join("\xA6")}E.makeKeyOptionalMessage=I})($||(e.IMarkerData=$={})),e.$3s=(0,f.$Bh)("markerService")}),define(Se[243],De([1,0,4,38,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Su=e.$Ru=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Qu=e.Severity=void 0,e.Severity=F.default,e.$Qu=(0,f.$Bh)("notificationService");var L;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var $;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new p,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Ru=E;class p{infinite(){}done(){}total(I){}worked(I){}}e.$Su=p}),define(Se[134],De([1,0,15,2,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RT=e.$QT=e.$PT=e.$OT=e.$NT=void 0,e.$NT=(0,f.$Bh)("openerService");function L(p,A){return F.URI.isUri(p)?(0,C.$Me)(p.scheme,A):(0,C.$Ne)(p,A+":")}e.$OT=L;function R(p,...A){return A.some(I=>L(p,I))}e.$PT=R;function $(p,A){return p.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$QT=$;function E(p){let A;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(p.fragment);return I&&(A={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},p=p.with({fragment:""})),{selection:A,uri:p}}e.$RT=E}),define(Se[244],De([1,0,12,47]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let f;if(typeof C.$g.vscode<"u"&&typeof C.$g.vscode.context<"u"){const L=C.$g.vscode.context.configuration();if(L)f=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(f=globalThis._VSCODE_PRODUCT_JSON,F.env.VSCODE_DEV&&Object.assign(f,{nameShort:`${f.nameShort} Dev`,nameLong:`${f.nameLong} Dev`,dataFolderName:`${f.dataFolderName}-dev`,serverDataFolderName:f.serverDataFolderName?`${f.serverDataFolderName}-dev`:void 0}),!f.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(f,{version:L.version})}}else f={},Object.keys(f).length===0&&Object.assign(f,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=f}),define(Se[135],De([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=void 0,e.$kj=(0,C.$Bh)("productService"),e.$lj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(C,F){e(C,F,$e)}};define(Se[65],De([1,0,9,21,3,5]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=e.$Xu=e.$Wu=e.$Vu=e.$Uu=e.ProgressLocation=e.$Tu=void 0,e.$Tu=(0,L.$Bh)("progressService");var R;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Uu=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,w){this.c=I,this.report=w?.async?this.e.bind(this):this.d.bind(this)}d(I){this.a=I,this.c(this.a)}e(I){Promise.resolve(this.b).finally(()=>{this.a=I;const w=this.c(this.a);this.b=Promise.resolve(w).finally(()=>this.b=void 0)})}}e.$Vu=$;let E=class extends f.$kc{constructor(I,w){super(),this.a=new C.$2g,w.withProgress(I,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,f.$ic)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$Wu=E,e.$Wu=E=Ke([Be(1,e.$Tu)],E);class p extends f.$kc{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new f.$jc)}start(I){this.stop();const w=++this.a,k=new F.$pd;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,f.$ic)(()=>clearTimeout(this.f))),this.b.add((0,f.$ic)(()=>k.cancel())),this.b.add((0,f.$ic)(()=>this.c?this.c.done():void 0)),{id:w,token:k.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$Xu=p,e.$Yu=(0,L.$Bh)("editorProgressService")}),define(Se[42],De([1,0,58,18]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;class f{constructor(){this.a=new Map}add(R,$){C.ok(F.$jf(R)),C.ok(F.$lf($)),C.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$8m=new f}),define(Se[106],De([1,0,4,42]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$9m={JSONContribution:"base.contributions.json"};function f($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class L{constructor(){this.b=new C.$fd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,p){this.a[f(E)]=p,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;F.$8m.add(e.$9m.JSONContribution,R)}),define(Se[136],De([1,0,19,4,18,188,49,106,42]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ConfigurationScope=e.$an=e.EditPresentationTypes=void 0;var p;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(p||(e.EditPresentationTypes=p={})),e.$an={Configuration:"base.contributions.configuration"};var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn="vscode://schemas/settings/resourceLanguage",e.$in="vscode://schemas/settings/configurationDefaults";const I=E.$8m.as($.$9m.JSONContribution);class w{constructor(){this.h=new Set,this.i=new F.$fd,this.onDidSchemaChange=this.i.event,this.j=new F.$fd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$hn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const a=new Set;this.n(t,r,a),I.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const r=new Set;this.o(t,r),I.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const a=new Set;this.o(r,a),this.n(t,!1,a),I.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const a=[];for(const{overrides:i,source:c}of t)for(const d in i)if(r.add(d),e.$kn.test(d)){const y=this.a.get(d),S=y?.valuesSources??new Map;if(c)for(const P of Object.keys(i[d]))S.set(P,c);const g={...y?.value||{},...i[d]};this.a.set(d,{source:c,value:g,valuesSources:S});const u=(0,R.$fi)(d),m={type:"object",default:g,description:L.localize(1,null,u),$ref:e.$hn,defaultDefaultValue:g,source:f.$jf(c)?void 0:c,defaultValueSource:c};a.push(...v(d)),this.d[d]=m,this.b.properties[d]=m}else{this.a.set(d,{value:i[d],source:c});const y=this.d[d];y&&(this.w(d,y),this.r(d,y))}this.m(a)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:a,source:i}of t)for(const c in a){const d=this.a.get(c),y=f.$jf(i)?i:i?.id,S=f.$jf(d?.source)?d?.source:d?.source?.id;if(y===S)if(r.add(c),this.a.delete(c),e.$kn.test(c))delete this.d[c],delete this.b.properties[c];else{const g=this.d[c];g&&(this.w(c,g),this.r(c,g))}}this.u()}deltaConfiguration(t){let r=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,a){t.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,a),this.c.push(i),this.q(i)})}o(t,r){const a=i=>{if(i.properties)for(const c in i.properties){r.add(c);const d=this.d[c];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[c],this.s(c,i.properties[c])}i.allOf?.forEach(c=>a(c))};for(const i of t){a(i);const c=this.c.indexOf(i);c!==-1&&this.c.splice(c,1)}}p(t,r=!0,a,i,c=3,d){c=f.$sf(t.scope)?c:t.scope;const y=t.properties;if(y)for(const g in y){const u=y[g];if(r&&l(g,u)){delete y[g];continue}if(u.source=a,u.defaultDefaultValue=y[g].default,this.w(g,u),e.$kn.test(g)?u.scope=void 0:(u.scope=f.$sf(u.scope)?c:u.scope,u.restricted=f.$sf(u.restricted)?!!i?.includes(g):u.restricted),y[g].hasOwnProperty("included")&&!y[g].included){this.f[g]=y[g],delete y[g];continue}else this.d[g]=y[g],y[g].policy?.name&&this.e.set(y[g].policy.name,g);!y[g].deprecationMessage&&y[g].markdownDeprecationMessage&&(y[g].deprecationMessage=y[g].markdownDeprecationMessage),d.add(g)}const S=t.allOf;if(S)for(const g of S)this.p(g,r,a,i,c,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=a=>{const i=a.properties;if(i)for(const d in i)this.r(d,i[d]);a.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$bn.properties[t]=r,r.scope){case 1:e.$cn.properties[t]=r;break;case 2:e.$dn.properties[t]=r;break;case 6:e.$en.properties[t]=r;break;case 3:e.$fn.properties[t]=r;break;case 4:e.$gn.properties[t]=r;break;case 5:e.$gn.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$bn.properties[t],r.scope){case 1:delete e.$cn.properties[t];break;case 2:delete e.$dn.properties[t];break;case 6:delete e.$en.properties[t];break;case 3:delete e.$fn.properties[t];break;case 4:case 5:delete e.$gn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$hn};this.w(r,a),e.$bn.properties[r]=a,e.$cn.properties[r]=a,e.$dn.properties[r]=a,e.$en.properties[r]=a,e.$fn.properties[r]=a,e.$gn.properties[r]=a}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$hn};e.$bn.patternProperties[e.$jn]=t,e.$cn.patternProperties[e.$jn]=t,e.$dn.patternProperties[e.$jn]=t,e.$en.patternProperties[e.$jn]=t,e.$fn.patternProperties[e.$jn]=t,e.$gn.patternProperties[e.$jn]=t,this.i.fire()}w(t,r){const a=this.a.get(t);let i=a?.value,c=a?.source;f.$qf(i)&&(i=r.defaultDefaultValue,c=void 0),f.$qf(i)&&(i=s(r.type)),r.default=i,r.defaultValueSource=c}}const k="\\[([^\\]]+)\\]",D=new RegExp(k,"g");e.$jn=`^(${k})+$`,e.$kn=new RegExp(e.$jn);function v(h){const t=[];if(e.$kn.test(h)){let r=D.exec(h);for(;r?.length;){const a=r[1].trim();a&&t.push(a),r=D.exec(h)}}return(0,C.$Kb)(t)}e.$ln=v;function o(h){return h.reduce((t,r)=>`${t}[${r}]`,"")}e.$mn=o;function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$nn=s;const n=new w;E.$8m.add(e.$an.Configuration,n);function l(h,t){return h.trim()?e.$kn.test(h)?L.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?L.localize(8,null,h):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,h,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$on=l;function b(){const h=[],t=n.getConfigurationProperties();for(const r of Object.keys(t))h.push([r,t[r].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$pn=b}),define(Se[245],De([1,0,19,4,157,3,28,23,18,2,49,136,42]),function($e,e,C,F,f,L,R,$,E,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function k(r){return Object.isFrozen(r)?r:$.$Wm(r)}class D{constructor(a={},i=[],c=[],d){this.b=a,this.c=i,this.d=c,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(i=>{if(i instanceof D)return i;const c=new v("");return c.parseRaw(i),c.configurationModel});this.f=a.reduce((i,c)=>c===i?c:i.merge(c),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,A.$di)(this.contents,a):this.contents}inspect(a,i){const c=this.rawConfiguration.getValue(a),d=i?this.rawConfiguration.getOverrideValue(a,i):void 0,y=i?this.rawConfiguration.override(i).getValue(a):c;return{value:c,override:d,merged:y}}getOverrideValue(a,i){const c=this.i(i);return c?a?(0,A.$di)(c,a):c:void 0}getKeysForOverrideIdentifier(a){const i=[];for(const c of this.overrides)c.identifiers.includes(a)&&i.push(...c.keys);return C.$Kb(i)}getAllOverrideIdentifiers(){const a=[];for(const i of this.overrides)a.push(...i.identifiers);return C.$Kb(a)}override(a){let i=this.a.get(a);return i||(i=this.g(a),this.a.set(a,i)),i}merge(...a){const i=$.$Vm(this.contents),c=$.$Vm(this.overrides),d=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const S of a)if(y.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(i,S.contents);for(const g of S.overrides){const[u]=c.filter(m=>C.$sb(m.identifiers,g.identifiers));u?(this.h(u.contents,g.contents),u.keys.push(...g.keys),u.keys=C.$Kb(u.keys)):c.push($.$Vm(g))}for(const g of S.keys)d.indexOf(g)===-1&&d.push(g)}return new D(i,d,c,y.every(S=>S instanceof D)?void 0:y)}g(a){const i=this.i(a);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const c={};for(const d of C.$Kb([...Object.keys(this.contents),...Object.keys(i)])){let y=this.contents[d];const S=i[d];S&&(typeof y=="object"&&typeof S=="object"?(y=$.$Vm(y),this.h(y,S)):y=S),c[d]=y}return new D(c,this.keys,this.overrides)}h(a,i){for(const c of Object.keys(i)){if(c in a&&E.$lf(a[c])&&E.$lf(i[c])){this.h(a[c],i[c]);continue}a[c]=$.$Vm(i[c])}}i(a){let i=null,c=null;const d=y=>{y&&(c?this.h(c,y):c=$.$Vm(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===a?i=y.contents:y.identifiers.includes(a)&&d(y.contents);return d(i),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,i){this.j(a,i,!0)}setValue(a,i){this.j(a,i,!1)}removeValue(a){const i=this.keys.indexOf(a);i!==-1&&(this.keys.splice(i,1),(0,A.$ci)(this.contents,a),I.$kn.test(a)&&this.overrides.splice(this.overrides.findIndex(c=>C.$sb(c.identifiers,(0,I.$ln)(a))),1))}j(a,i,c){(0,A.$bi)(this.contents,a,i,d=>console.error(d)),c=c||this.keys.indexOf(a)===-1,c&&this.keys.push(a),I.$kn.test(a)&&this.overrides.push({identifiers:(0,I.$ln)(a),keys:Object.keys(this.contents[a]),contents:(0,A.$ai)(this.contents[a],d=>console.error(d))})}}e.$qn=D;class v{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,i){if(!E.$sf(a)){const c=this.g(a);this.parseRaw(c,i)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,i){this.a=a;const{contents:c,keys:d,overrides:y,restricted:S,hasExcludedProperties:g}=this.h(a,i);this.b=new D(c,d,y,g?[a]:void 0),this.c=S||[]}g(a){let i={},c=null,d=[];const y=[],S=[];function g(m){Array.isArray(d)?d.push(m):c!==null&&(d[c]=m)}const u={onObjectBegin:()=>{const m={};g(m),y.push(d),d=m,c=null},onObjectProperty:m=>{c=m},onObjectEnd:()=>{d=y.pop()},onArrayBegin:()=>{const m=[];g(m),y.push(d),d=m,c=null},onArrayEnd:()=>{d=y.pop()},onLiteralValue:g,onError:(m,P,O)=>{S.push({error:m,offset:P,length:O})}};if(a)try{f.$Sm(a,u),i=d[0]||{}}catch(m){console.error(`Error while parsing settings file ${this.f}: ${m}`),this.d=[m]}return i}h(a,i){const c=w.$8m.as(I.$an.Configuration).getConfigurationProperties(),d=this.i(a,c,!0,i);a=d.raw;const y=(0,A.$ai)(a,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),S=Object.keys(a),g=this.j(a,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:y,keys:S,overrides:g,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(a,i,c,d){let y=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:y};const S={},g=[];for(const u in a)if(I.$kn.test(u)&&c){const m=this.i(a[u],i,!1,d);S[u]=m.raw,y=y||m.hasExcludedProperties,g.push(...m.restricted)}else{const m=i[u],P=m?typeof m.scope<"u"?m.scope:3:void 0;m?.restricted&&g.push(u),!d.exclude?.includes(u)&&(d.include?.includes(u)||(P===void 0||d.scopes===void 0||d.scopes.includes(P))&&!(d.skipRestricted&&m?.restricted))?S[u]=a[u]:y=!0}return{raw:S,restricted:g,hasExcludedProperties:y}}j(a,i){const c=[];for(const d of Object.keys(a))if(I.$kn.test(d)){const y={};for(const S in a[d])y[S]=a[d][S];c.push({identifiers:(0,I.$ln)(d),keys:Object.keys(y),contents:(0,A.$ai)(y,i)})}return c}}e.$rn=v;class o extends L.$kc{constructor(a,i,c,d){super(),this.c=a,this.f=i,this.g=d,this.b=this.B(new F.$fd),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&c.isEqual(y.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new D}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$sn=o;class s{constructor(a,i,c,d,y,S,g,u,m,P,O,N,M){this.a=a,this.b=i,this.c=c,this.overrideIdentifiers=d,this.d=y,this.f=S,this.g=g,this.h=u,this.i=m,this.j=P,this.k=O,this.l=N,this.m=M}get value(){return k(this.c)}n(a,i,c){const d=a.inspect(i,c);return{get value(){return k(d.value)},get override(){return k(d.override)},get merged(){return k(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(a,i,c,d,y=new D,S=new D,g=new R.$zi,u=new D,m=new R.$zi){this.c=a,this.d=i,this.f=c,this.g=d,this.h=y,this.i=S,this.j=g,this.l=u,this.m=m,this.a=null,this.b=new R.$zi,this.n=null}getValue(a,i,c){return this.q(a,i,c).getValue(a)}updateValue(a,i,c={}){let d;c.resource?(d=this.m.get(c.resource),d||(d=new D,this.m.set(c.resource,d))):d=this.l,i===void 0?d.removeValue(a):d.setValue(a,i),c.resource||(this.a=null)}inspect(a,i,c){const d=this.q(a,i,c),y=this.u(i.resource,c),S=i.resource?this.m.get(i.resource)||this.l:this.l,g=new Set;for(const u of d.overrides)for(const m of u.identifiers)d.getOverrideValue(a,m)!==void 0&&g.add(m);return new s(a,i,d.getValue(a),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,y||void 0,S)}keys(a){const i=this.u(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,i){this.j.set(a,i),this.b.delete(a)}deleteFolderConfiguration(a){this.p.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,i){const c=[];if(!i){const{added:d,updated:y,removed:S}=h(this.c,a);i=[...d,...y,...S]}for(const d of i)for(const y of(0,I.$ln)(d)){const S=this.c.getKeysForOverrideIdentifier(y),g=a.getKeysForOverrideIdentifier(y),u=[...g.filter(m=>S.indexOf(m)===-1),...S.filter(m=>g.indexOf(m)===-1),...S.filter(m=>!$.$Zm(this.c.override(y).getValue(m),a.override(y).getValue(m)))];c.push([y,u])}return this.updateDefaultConfiguration(a),{keys:i,overrides:c}}compareAndUpdatePolicyConfiguration(a){const{added:i,updated:c,removed:d}=h(this.d,a),y=[...i,...c,...d];return y.length&&this.updatePolicyConfiguration(a),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:i,updated:c,removed:d,overrides:y}=h(this.applicationConfiguration,a),S=[...i,...c,...d];return S.length&&this.updateApplicationConfiguration(a),{keys:S,overrides:y}}compareAndUpdateLocalUserConfiguration(a){const{added:i,updated:c,removed:d,overrides:y}=h(this.localUserConfiguration,a),S=[...i,...c,...d];return S.length&&this.updateLocalUserConfiguration(a),{keys:S,overrides:y}}compareAndUpdateRemoteUserConfiguration(a){const{added:i,updated:c,removed:d,overrides:y}=h(this.remoteUserConfiguration,a),S=[...i,...c,...d];return S.length&&this.updateRemoteUserConfiguration(a),{keys:S,overrides:y}}compareAndUpdateWorkspaceConfiguration(a){const{added:i,updated:c,removed:d,overrides:y}=h(this.workspaceConfiguration,a),S=[...i,...c,...d];return S.length&&this.updateWorkspaceConfiguration(a),{keys:S,overrides:y}}compareAndUpdateFolderConfiguration(a,i){const c=this.p.get(a),{added:d,updated:y,removed:S,overrides:g}=h(c,i),u=[...d,...y,...S];return(u.length||!c)&&this.updateFolderConfiguration(a,i),{keys:u,overrides:g}}compareAndDeleteFolderConfiguration(a){const i=this.p.get(a);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:c,updated:d,removed:y,overrides:S}=h(i,void 0);return{keys:[...c,...d,...y],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(a,i,c){let d=this.r(i,c);return i.overrideIdentifier&&(d=d.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(d=d.merge(this.d)),d}r({resource:a},i){let c=this.s();if(i&&a){const d=i.getFolder(a);d&&(c=this.t(d.uri)||c);const y=this.m.get(a);y&&(c=c.merge(y))}return c}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(a){let i=this.b.get(a);if(!i){const c=this.s(),d=this.j.get(a);d?(i=c.merge(d),this.b.set(a,i)):i=c}return i}u(a,i){if(i&&a){const c=i.getFolder(a);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,i)=>{const{contents:c,overrides:d,keys:y}=this.j.get(i);return a.push([i,{contents:c,overrides:d,keys:y}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(i=>a.add(i)),this.userConfiguration.keys.forEach(i=>a.add(i)),this.i.keys.forEach(i=>a.add(i)),this.j.forEach(i=>i.keys.forEach(c=>a.add(c))),[...a.values()]}v(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(c=>a.add(c))),[...a.values()]}w(a){const i=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(c=>i.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(c=>i.add(c)),this.i.getKeysForOverrideIdentifier(a).forEach(c=>i.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(a).forEach(d=>i.add(d))),[...i.values()]}static parse(a){const i=this.x(a.defaults),c=this.x(a.policy),d=this.x(a.application),y=this.x(a.user),S=this.x(a.workspace),g=a.folders.reduce((u,m)=>(u.set(p.URI.revive(m[0]),this.x(m[1])),u),new R.$zi);return new n(i,c,d,y,new D,S,g,new D,new R.$zi)}static x(a){return new D(a.contents,a.keys,a.overrides)}}e.$tn=n;function l(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const a=new Set,i=new Map;for(const d of r)d.keys.forEach(y=>a.add(y)),d.overrides.forEach(([y,S])=>{const g=(0,R.$wi)(i,y,new Set);S.forEach(u=>g.add(u))});const c=[];return i.forEach((d,y)=>c.push([y,[...d.values()]])),{keys:[...a.values()],overrides:c}}e.$un=l;class b{constructor(a,i,c,d){this.change=a,this.f=i,this.g=c,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const y of a.keys)this.affectedKeys.add(y);for(const[,y]of a.overrides)for(const S of y)this.affectedKeys.add(S);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(a,i){const c=this.a+a,d=this.d.indexOf(c);if(d<0)return!1;const y=d+c.length;if(y>=this.d.length)return!1;const S=this.d.charCodeAt(y);if(S!==this.b&&S!==this.c)return!1;if(i){const g=this.previousConfiguration?this.previousConfiguration.getValue(a,i,this.f?.workspace):void 0,u=this.g.getValue(a,i,this.h);return!$.$Zm(g,u)}return!0}}e.$vn=b;function h(r,a){const{added:i,removed:c,updated:d}=t(a?.rawConfiguration,r?.rawConfiguration),y=[],S=r?.getAllOverrideIdentifiers()||[],g=a?.getAllOverrideIdentifiers()||[];if(a){const u=g.filter(m=>!S.includes(m));for(const m of u)y.push([m,a.getKeysForOverrideIdentifier(m)])}if(r){const u=S.filter(m=>!g.includes(m));for(const m of u)y.push([m,r.getKeysForOverrideIdentifier(m)])}if(a&&r){for(const u of S)if(g.includes(u)){const m=t({contents:r.getOverrideValue(void 0,u)||{},keys:r.getKeysForOverrideIdentifier(u)},{contents:a.getOverrideValue(void 0,u)||{},keys:a.getKeysForOverrideIdentifier(u)});y.push([u,[...m.added,...m.removed,...m.updated]])}}return{added:i,removed:c,updated:d,overrides:y}}function t(r,a){const i=r?a?r.keys.filter(y=>a.keys.indexOf(y)===-1):[...r.keys]:[],c=a?r?a.keys.filter(y=>r.keys.indexOf(y)===-1):[...a.keys]:[],d=[];if(r&&a){for(const y of a.keys)if(r.keys.indexOf(y)!==-1){const S=(0,A.$di)(a.contents,y),g=(0,A.$di)(r.contents,y);$.$Zm(S,g)||d.push(y)}}return{added:i,removed:c,updated:d}}}),define(Se[246],De([1,0,22,4,3,82]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckb=e.$Bkb=e.$Akb=e.$zkb=void 0;const R=(p,A,I)=>{const w=new Uint8Array(16);for(let v=0;v<16;v++)w[v]=Math.round(Math.random()*256);const k=(0,C.$Zd)(C.$Fd.wrap(w));return[`GET ws://localhost${p}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$zkb=R,e.$Akb=C.$Fd.fromString(`\r
\r
`);async function $(p,A,I,w,k){p.write(C.$Fd.fromString((0,e.$zkb)(A,I,w)));const D=new f.$jc;try{return await new Promise((v,o)=>{let s;D.add(p.onData(n=>{s?s=C.$Fd.concat([s,n],s.byteLength+n.byteLength):s=n;const l=s.indexOf(e.$Akb);if(l===-1)return;v(p),p.pauseData();const b=s.slice(l+e.$Akb.byteLength);b.byteLength&&k.onData.fire(b)})),D.add(p.onClose(n=>o(n??new Error("socket closed")))),D.add(p.onEnd(()=>o(new Error("socket ended"))))})}catch(v){throw p.dispose(),v}finally{D.dispose()}}e.$Bkb=$;class E extends f.$kc{constructor(A,I){super(),this.g=A,this.a=this.B(new F.$id),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new F.$fd),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(w=>this.a.fire(w))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,I){L.SocketDiagnostics.traceSocketEvent(this,this.g,A,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Ckb=E}),define(Se[66],De([1,0,8,5]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.RemoteAuthorityResolverErrorCode=e.$Lk=e.$Kk=e.RemoteConnectionType=e.$Jk=void 0,e.$Jk=(0,F.$Bh)("remoteAuthorityResolverService");var f;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class L{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kk=L;class R{constructor(I,w){this.host=I,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Lk=R;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class E extends C.$_{static isNotAvailable(I){return I instanceof E&&I._code===$.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof E&&I._code===$.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof E&&I._code===$.NoResolverFound}static isInvalidAuthority(I){return I instanceof E&&I._code===$.InvalidAuthority}static isHandled(I){return I instanceof E&&I.isHandled}constructor(I,w=$.Unknown,k){super(I),this._message=I,this._code=w,this._detail=k,this.isHandled=w===$.NotAvailable&&k===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Mk=E;function p(A){const I=A.indexOf("+");return I===-1?A:A.substring(0,I)}e.$Nk=p}),define(Se[67],De([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=void 0;function F(p){return p.scheme===C.Schemas.vscodeRemote?p.authority:void 0}e.$Ok=F;function f(p){if(!p)return;const A=p.indexOf("+");return A<0?p:p.substr(0,A)}e.$Pk=f;function L(p){return`/${p.quality??"oss"}-${p.commit??"dev"}`}e.$Qk=L;function R(p){const{host:A,port:I}=E(p);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:I}}e.$Rk=R;function $(p,A){let{host:I,port:w}=E(p);return typeof w>"u"&&(w=A),{host:I,port:w}}e.$Sk=$;function E(p){const A=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const w=p.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:p,port:void 0}}}),define(Se[25],De([1,0,15,5,67]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.TargetPlatform=e.ExtensionType=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl="extensions.user.cache",e.$Ql="extensions.builtin.cache",e.$Rl="undefined_publisher",e.$Sl=["ui","workspace","web"];function L(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Tl=L,e.$Ul=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class E{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const n=typeof o=="string"?o:o.value,l=typeof s=="string"?s:s.value;return C.$Me(n,l)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Vl=E;class p{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(E.toKey(o))}delete(o){return this.c.delete(E.toKey(o))}has(o){return this.c.has(E.toKey(o))}}e.$Wl=p;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(E.toKey(o))}get(o){return this.c.get(E.toKey(o))}has(o){return this.c.has(E.toKey(o))}set(o,s){this.c.set(E.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xl=A;function I(v){return w(v)}e.$Yl=I;function w(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$Zl=w;function k(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$1l=k;function D(v,o){if(o){const s=`onResolveRemoteAuthority:${(0,f.$Pk)(o)}`;return!!v.activationEvents?.includes(s)}return!1}e.$2l=D,e.$3l=(0,F.$Bh)("IBuiltinExtensionsScannerService")}),define(Se[137],De([1,0,8,25]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DE=e.$CE=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const E of R){const p=this.readActivationEvents(E);p.length>0&&($[F.$Vl.toKey(E.identifier)]=p)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return $;for(const E in R.contributes){const p=this.a.get(E);if(!p)continue;const A=R.contributes[E],I=Array.isArray(A)?A:[A];try{p(I,$)}catch(w){(0,C.$Y)(w)}}return $}}e.$CE=f,e.$DE=new f}),define(Se[247],De([1,0,9,22,21,8,4,3,53,37,31,82,66,67]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.PersistentConnectionEventType=e.$Zk=e.$Yk=e.$Xk=e.ConnectionType=void 0;const D=30*1e3;var v;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function o(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(G){const U=new f.$pd;return setTimeout(()=>U.cancel(),G),U.token}function n(G,U){if(G.isCancellationRequested||U.isCancellationRequested)return f.CancellationToken.Cancelled;const K=new f.$pd;return G.onCancellationRequested(()=>K.cancel()),U.onCancellationRequested(()=>K.cancel()),K.token}class l{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new $.$jc,this.promise=new Promise((K,fe)=>{this.f=K,this.g=fe}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function b(G,U){const K=new l(U);return K.registerDisposable(G.onControlMessage(fe=>{const te=JSON.parse(fe.toString()),se=X(te);se?K.reject(se):K.resolve(te)})),K.promise}function h(G,U,K,fe,te,se,ne,Ee){const oe=new l(Ee),he=p.$bd.create(!1);return G.info(`Creating a socket (${ne})...`),E.mark(`code/willCreateSocket/${se}`),U.connect(K,fe,te,ne).then(ee=>{oe.didTimeout?(E.mark(`code/didCreateSocketError/${se}`),G.info(`Creating a socket (${ne}) finished after ${he.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(E.mark(`code/didCreateSocketOK/${se}`),G.info(`Creating a socket (${ne}) was successful after ${he.elapsed()} ms.`),oe.resolve(ee))},ee=>{E.mark(`code/didCreateSocketError/${se}`),G.info(`Creating a socket (${ne}) returned an error after ${he.elapsed()} ms.`),G.error(ee),oe.reject(ee)}),oe.promise}function t(G,U){const K=new l(U);return G.then(fe=>{K.didTimeout||K.resolve(fe)},fe=>{K.didTimeout||K.reject(fe)}),K.promise}async function r(G,U,K,fe){const te=ue(G,U);G.logService.trace(`${te} 1/6. invoking socketFactory.connect().`);let se;try{se=await h(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,k.$Qk)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,o(U),`renderer-${o(U)}-${G.reconnectionToken}`,fe)}catch(ee){throw G.logService.error(`${te} socketFactory.connect() failed or timed out. Error:`),G.logService.error(ee),ee}G.logService.trace(`${te} 2/6. socketFactory.connect() was successful.`);let ne,Ee;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(se,null),ne=G.reconnectionProtocol,Ee=!1):(ne=new I.$ph({socket:se}),Ee=!0),G.logService.trace(`${te} 3/6. sending AuthRequest control message.`);const oe=await t(G.signService.createNewMessage((0,A.$4f)()),fe),he={type:"auth",auth:G.connectionToken||"00000000000000000000",data:oe.data};ne.sendControl(F.$Fd.fromString(JSON.stringify(he)));try{const ee=await b(ne,n(fe,s(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(G.logService.trace(`${te} 4/6. received SignRequest control message.`),!await t(G.signService.validate(oe,ee.signedData),fe)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const be=await t(G.signService.sign(ee.data),fe),Ie={type:"connectionType",commit:G.commit,signedData:be,desiredConnectionType:U};return K&&(Ie.args=K),G.logService.trace(`${te} 5/6. sending ConnectionTypeRequest control message.`),ne.sendControl(F.$Fd.fromString(JSON.stringify(Ie))),{protocol:ne,ownsProtocol:Ee}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(G.logService.error(`${te} the handshake timed out. Error:`),G.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${te} received error control message when negotiating connection. Error:`),G.logService.error(ee)),Ee&&Z(ne),ee}}async function a(G,U,K,fe){const te=Date.now(),se=ue(G,U),{protocol:ne,ownsProtocol:Ee}=await r(G,U,K,fe),oe=new l(fe);return oe.registerDisposable(ne.onControlMessage(he=>{const ee=JSON.parse(he.toString()),le=X(ee);le?(G.logService.error(`${se} received error control message when negotiating connection. Error:`),G.logService.error(le),Ee&&Z(ne),oe.reject(le)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${se} 6/6. handshake finished, connection is up and running after ${ve(te)}!`),oe.resolve({protocol:ne,firstMessage:ee}))})),oe.promise}async function i(G,U){const{protocol:K}=await a(G,1,void 0,U);return{protocol:K}}async function c(G,U,K){const{protocol:fe,firstMessage:te}=await a(G,2,U,K),se=te&&te.debugPort;return{protocol:fe,debugPort:se}}async function d(G,U,K){const fe=Date.now(),te=ue(G,3),{protocol:se}=await r(G,3,U,K);return G.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${ve(fe)}!`),se}async function y(G,U,K){const{connectTo:fe,connectionToken:te}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:fe,connectionToken:te,reconnectionToken:U,reconnectionProtocol:K,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function S(G,U,K){return u(G,async fe=>{const{protocol:te}=await i(fe,f.CancellationToken.None);return new q(G,U,K,fe.reconnectionToken,te)})}e.$Xk=S;async function g(G,U){return u(G,async K=>{const{protocol:fe,debugPort:te}=await c(K,U,f.CancellationToken.None);return new me(G,U,K.reconnectionToken,fe,te)})}e.$Yk=g;async function u(G,U){for(let fe=1;;fe++)try{const te=(0,A.$4f)(),se=await y(G,te,null);return await U(se)}catch(te){if(fe<5)G.logService.error(`[remote-connection][attempt ${fe}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(te);else throw G.logService.error(`[remote-connection][attempt ${fe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(te),H.triggerPermanentFailure(0,0,w.$Mk.isHandled(te)),te}}async function m(G,U,K){const fe=await y(G,(0,A.$4f)(),null);return await d(fe,{host:U,port:K},f.CancellationToken.None)}e.$Zk=m;function P(G){return(0,C.$ug)(U=>new Promise((K,fe)=>{const te=setTimeout(K,G*1e3);U.onCancellationRequested(()=>{clearTimeout(te),K()})}))}var O;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class N{constructor(U,K){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.type=0}}e.$1k=N;class M{constructor(U,K,fe,te){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.durationSeconds=fe,this.c=te,this.type=1}skipWait(){this.c.cancel()}}e.$2k=M;class j{constructor(U,K,fe){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.attempt=fe,this.type=2}}e.$3k=j;class z{constructor(U,K,fe){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.attempt=fe,this.type=4}}e.$4k=z;class T{constructor(U,K,fe,te){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.attempt=fe,this.handled=te,this.type=3}}e.$5k=T;class H extends $.$kc{static triggerPermanentFailure(U,K,fe){this._permanentFailure=!0,this.f=U,this.g=K,this.h=fe,this.j.forEach(te=>te.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||H._permanentFailure}constructor(U,K,fe,te,se){super(),this.t=U,this.u=K,this.reconnectionToken=fe,this.protocol=te,this.w=se,this.m=this.B(new R.$fd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(te.onSocketClose(ne=>{const Ee=ge(this.t,this.reconnectionToken,!0);ne?ne.type===0?(this.u.logService.info(`${Ee} received socket close event (hadError: ${ne.hadError}).`),ne.error&&this.u.logService.error(ne.error)):(this.u.logService.info(`${Ee} received socket close event (wasClean: ${ne.wasClean}, code: ${ne.code}, reason: ${ne.reason}).`),ne.event&&this.u.logService.error(ne.event)):this.u.logService.info(`${Ee} received socket close event.`),this.y()})),this.B(te.onSocketTimeout(ne=>{const Ee=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Ee} received socket timeout event (unacknowledgedMsgCount: ${ne.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ne.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ne.timeSinceLastReceivedSomeData}).`),this.y()})),H.j.push(this),this.B((0,$.$ic)(()=>{const ne=H.j.indexOf(this);ne>=0&&H.j.splice(ne,1)})),this.n&&this.D(H.f,H.g,H.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const K=[0,5,5,10,10,10,10,10,30];let fe=-1;do{fe++;const te=fe<K.length?K[fe]:K[K.length-1];try{if(te>0){const ne=P(te);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),te,ne)),this.u.logService.info(`${U} waiting for ${te} seconds before reconnecting...`);try{await ne}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),fe+1)),this.u.logService.info(`${U} resolving connection...`);const se=await y(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${se.connectTo}...`),await this.G(se,s(D)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),fe+1));break}catch(se){if(se.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),fe+1,!1);break}if(fe>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),fe+1,!1);break}if(w.$Mk.isTemporarilyNotAvailable(se)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if((se.code==="ETIMEDOUT"||se.code==="ENETUNREACH"||se.code==="ECONNREFUSED"||se.code==="ECONNRESET")&&se.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if((0,L.$2)(se)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if(se instanceof w.$Mk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),fe+1,w.$Mk.isHandled(se));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),fe+1,!1);break}}while(!this.n&&!this.s)}C(U,K,fe){this.w?H.triggerPermanentFailure(U,K,fe):this.D(U,K,fe)}D(U,K,fe){this.m.fire(new T(this.reconnectionToken,U,K,fe)),Z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$6k=H;class q extends H{constructor(U,K,fe,te,se){super(1,U,te,se,!0),this.client=this.B(new I.$nh(se,{remoteAuthority:K,clientId:fe},U.ipcLogger))}async G(U,K){await i(U,K)}}e.$7k=q;class me extends H{constructor(U,K,fe,te,se){super(2,U,fe,te,!1),this.H=K,this.debugPort=se}async G(U,K){await c(U,this.H,K)}}e.$8k=me;function Z(G){try{G.acceptDisconnect();const U=G.getSocket();G.dispose(),U.dispose()}catch(U){(0,L.$Y)(U)}}function X(G){if(G&&G.type==="error"){const U=new Error(`Connection error: ${G.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function V(G,U){for(;G.length<U;)G+=" ";return G}function x(G,U){return`[remote-connection][${V(o(G),13)}][${U.substr(0,5)}\u2026]`}function ge(G,U,K){return`${x(G,U)}[${K?"reconnect":"initial"}]`}function ue(G,U){return`${ge(U,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function ve(G){return`${Date.now()-G} ms`}}),define(Se[248],De([1,0,3,5]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=void 0,e.$Tk=(0,F.$Bh)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(R,$){return this.a[R]??=[],this.a[R].push($),(0,C.$ic)(()=>{const E=this.a[R]?.indexOf($);typeof E=="number"&&E>=0&&this.a[R]?.splice(E,1)})}b(R){return(this.a[R.type]||[]).find(E=>E.supports(R))}connect(R,$,E,p){const A=this.b(R);if(!A)throw new Error(`No socket factory found for ${R}`);return A.connect(R,$,E,p)}}e.$Uk=f}),define(Se[249],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z2b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const L=await this.c();if(L){const R=String(C.a++);return this.b.set(R,L),{id:R,data:L.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,L){if(!f.id)return!0;const R=this.b.get(f.id);if(!R)return!1;this.b.delete(f.id);try{return R.validate(L)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$z2b=C}),define(Se[107],De([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=void 0,e.$Vk="signService",e.$Wk=(0,C.$Bh)(e.$Vk)}),define(Se[138],De([1,0,249]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m7b=void 0;class F extends C.$z2b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(R=>new R.signer().sign(L))}h(){return new Promise((L,R)=>$e(["vsda"],L,R))}}e.$m7b=F}),define(Se[250],De([1,0,12,47,31]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=void 0;function L(E){if(C.$t===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function R(E,p,A,I,w,k,D,v){const o=Object.create(null);o["common.machineId"]=k,o.sessionID=(0,f.$4f)()+Date.now(),o.commitHash=I,o.version=w,o["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,C.$h)(C.$t),o["common.nodePlatform"]=F.$3d,o["common.nodeArch"]=A,o["common.product"]=v||"desktop",D&&(o["common.msftInternal"]=D);let s=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),C.$l&&(o["common.snap"]="true");const l=L(p);return l&&(o["common.platformDetail"]=l),o}e.$0n=R;function $(E){const p=F.env.USERDNSDOMAIN;if(!p)return!1;const A=p.toLowerCase();return E.some(I=>A===I)}e.$$n=$}),define(Se[251],De([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0,e.$9k=(0,C.$Bh)("telemetryService"),e.$0k=(0,C.$Bh)("customEndpointTelemetryService"),e.$$k="telemetry.currentSessionDate",e.$_k="telemetry.firstSessionDate",e.$al="telemetry.lastSessionDate",e.$bl="telemetry.machineId",e.$cl="telemetry",e.$dl="telemetry.telemetryLevel",e.$el="telemetry.enableCrashReporter",e.$fl="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var f;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(Se[85],De([1,0,23,18,4,49,67,250,251]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0;class p{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$_n=p;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ao=A,e.$bo=new A;class I{async publicLog(c,d,y){}async publicLogError(c,d,y){}}e.$co=I,e.$do="telemetry",e.$eo="extensionTelemetryLog",e.$fo={log:()=>null,flush:()=>Promise.resolve(null)};function w(i,c){return f.Event.debounce(c.onDidChangeConfiguration,(y,S)=>{const g=y?new Set([...y.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:g}},1e3,!0)(y=>{y.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,L.$$h)(y.source),configurationKeys:Array.from(y.affectedKeys)})})}e.$go=w;function k(i,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!i.enableTelemetry||c.extensionTestsLocationURI)}e.$ho=k;function D(i,c){return!(c.isBuilt||c.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$io=D;function v(i){const c=i.getValue(E.$dl),d=i.getValue(E.$el);if(i.getValue(E.$fl)===!1||d===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$jo=v;function o(i){const c={},d={},y={};l(i,y);for(let S in y){S=S.length>150?S.substr(S.length-149):S;const g=y[S];typeof g=="number"?d[S]=g:typeof g=="boolean"?d[S]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${g.length}`),c[S]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(c[S]=g)}return{properties:c,measurements:d}}e.$ko=o;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(i){if(!i)return"none";const c=(0,R.$Pk)(i);return s.has(c)?c:"other"}e.$lo=n;function l(i,c,d=0,y){if(i)for(const S of Object.getOwnPropertyNames(i)){const g=i[S],u=y?y+S:S;Array.isArray(g)?c[u]=(0,C.$1m)(g):g instanceof Date?c[u]=g.toISOString():(0,F.$lf)(g)?d<2?l(g,c,d+1,u+"."):c[u]=(0,C.$1m)(g):c[u]=g}}function b(i,c){const d=i.msftInternalDomains||[],y=c.getValue("telemetry.internalTesting");return(0,$.$$n)(d)||y}e.$mo=b;function h(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$no=h;function t(i,c){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let d=i;const y=[];for(const m of c)for(;;){const P=m.exec(i);if(!P)break;y.push([P.index,m.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(d="";;){const m=g.exec(i);if(!m)break;const P=y.some(([O,N])=>m.index<N&&O<g.lastIndex);!S.test(m[0])&&!P&&(d+=i.substring(u,m.index)+"<REDACTED: user-file-path>",u=g.lastIndex)}return u<i.length&&(d+=i.substr(u)),d}function r(i){if(!i)return i;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of c)if(d.regex.test(i))return`<REDACTED: ${d.label}>`;return i}function a(i,c){return(0,C.$Xm)(i,d=>{if(d instanceof p||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let y=d.replaceAll("%20"," ");y=t(y,c);for(const S of c)y=y.replace(S,"");return y=r(y),y}})}e.$oo=a}),define(Se[252],De([1,0,15,132,25,12,2,8,47,85]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;function A(a,i){return a.uuid&&i.uuid?a.uuid===i.uuid:a.id===i.id?!0:(0,C.$He)(a.id,i.id)===0}e.$po=A;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(i){const c=i.manifest?i.manifest.version:i.version,d=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new w(i.identifier,c,d)}static parse(i){const c=I.exec(i);return c&&c[1]&&c[2]?new w({id:c[1]},c[2],c[4]||void 0):null}constructor(i,c,d="undefined"){this.version=c,this.targetPlatform=d,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof w?A(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$qo=w;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(a){const i=k.exec(a);return i&&i[1]?[o(i[1]),i[2]]:[o(a),void 0]}e.$ro=D;function v(a,i){return`${a}.${i}`}e.$so=v;function o(a){return a.toLowerCase()}e.$to=o;function s(a,i){return o(v(a??f.$Rl,i))}e.$uo=s;function n(a,i){const c=[],d=y=>{for(const S of c)if(S.some(g=>A(i(g),i(y))))return S;return null};for(const y of a){const S=d(y);S?S.push(y):c.push([y])}return c}e.$vo=n;function l(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$wo=l;function b(a){return{id:new p.$_n(a.identifier.id),name:new p.$_n(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$xo=b,e.$yo=new f.$Vl("pprice.better-merge");function h(a,i){const c=[],d=i.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const y=d.shift();if(y&&c.every(S=>!A(S.identifier,{id:y}))){const S=a.filter(g=>A(g.identifier,{id:y}));S.length===1&&(c.push(S[0]),d.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$zo=h;async function t(a,i){if(!L.$k)return!1;let c;try{c=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(y){i.debug("Error while getting the os-release file.",(0,$.$8)(y))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(a,i){const c=await t(a,i),d=(0,F.$Un)(c?"alpine":L.$t,E.$4d);return i.debug("ComputeTargetPlatform:",d),d}e.$Ao=r}),define(Se[253],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=e.$cr=e.$br=e.$ar=void 0;function C(E){return[...E.entries()]}e.$ar=C;function F(E){return E?[...E.entries()]:[]}e.$br=F;function f(E){return new Map(E)}e.$cr=f;function L(E){return new Map(E??[])}e.$dr=L;function R(E){return Array.from(E.entries()).map(p=>[p[0],C(p[1].map),F(p[1].descriptionMap)])}e.$er=R;function $(E){return new Map(E.map(p=>[p[0],{map:f(p[1]),descriptionMap:L(p[2])}]))}e.$fr=$}),define(Se[254],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skb=void 0;class C{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,L,R=5){const $=L(E=>{const p=typeof E=="string"?E:E.data;let A=this.a.get(f);if(A){A.data.push(p);return}const I=setTimeout(()=>this.flushBuffer(f),R);A={data:[p],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(f),$.dispose()}},this.a.set(f,A)});return $}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const L=this.a.get(f);L&&(this.a.delete(f),this.b(f,L.data.join("")))}}e.$Skb=C}),define(Se[255],De([1,0,9,79,60,4,18,2,199,106,42]),function($e,e,C,F,f,L,R,$,E,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.IconFontDefinition=e.IconContribution=e.$Uv=void 0,e.$Uv={IconContribution:"base.contributions.icons"};var I;(function(b){function h(t,r){let a=t.defaults;for(;f.ThemeIcon.isThemeIcon(a);){const i=D.getIcon(a.id);if(!i)return;a=i.defaults}return a}b.getDefinition=h})(I||(e.IconContribution=I={}));var w;(function(b){function h(r){return{weight:r.weight,style:r.style,src:r.src.map(a=>({format:a.format,location:a.location.toString()}))}}b.toJSONObject=h;function t(r){const a=i=>(0,R.$jf)(i)?i:void 0;if(r&&Array.isArray(r.src)&&r.src.every(i=>(0,R.$jf)(i.format)&&(0,R.$jf)(i.location)))return{weight:a(r.weight),style:a(r.style),src:r.src.map(i=>({format:i.format,location:$.URI.parse(i.location)}))}}b.fromJSONObject=t})(w||(e.IconFontDefinition=w={}));class k{constructor(){this.a=new L.$fd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,t,r,a){const i=this.b[h];if(i){if(r&&!i.description){i.description=r,this.d.properties[h].markdownDescription=`${r} $(${h})`;const y=this.e.enum.indexOf(h);y!==-1&&(this.e.enumDescriptions[y]=r),this.a.fire()}return i}const c={id:h,description:r,defaults:t,deprecationMessage:a};this.b[h]=c;const d={$ref:"#/definitions/icons"};return a&&(d.deprecationMessage=a),r&&(d.markdownDescription=`${r}: $(${h})`),this.d.properties[h]=d,this.e.enum.push(h),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const t=this.e.enum.indexOf(h);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,t){const r=this.f[h];return r||(this.f[h]=t,this.a.fire(),t)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(i,c)=>i.id.localeCompare(c.id),t=i=>{for(;f.ThemeIcon.isThemeIcon(i.defaults);)i=this.b[i.defaults.id];return`codicon codicon-${i?i.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(i=>this.b[i]);for(const i of a.filter(c=>!!c.description).sort(h))r.push(`|<i class="${t(i)}"></i>|${i.id}|${f.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const i of a.filter(c=>!f.ThemeIcon.isThemeIcon(c.defaults)).sort(h))r.push(`|<i class="${t(i)}"></i>|${i.id}|`);return r.join(`
`)}}const D=new k;A.$8m.add(e.$Uv.IconContribution,D);function v(b,h,t,r){return D.registerIcon(b,h,t,r)}e.$Vv=v;function o(){return D}e.$Wv=o;function s(){const b=(0,F.$Nj)();for(const h in b){const t="\\"+b[h].toString(16);D.registerIcon(h,{fontCharacter:t})}}s(),e.$Xv="vscode://schemas/icons";const n=A.$8m.as(p.$9m.JSONContribution);n.registerSchema(e.$Xv,D.getIconSchema());const l=new C.$Sg(()=>n.notifySchemaChanged(e.$Xv),200);D.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.$Yv=v("widget-close",F.$Pj.close,(0,E.localize)(2,null)),e.$Zv=v("goto-previous-location",F.$Pj.arrowUp,(0,E.localize)(3,null)),e.$1v=v("goto-next-location",F.$Pj.arrowDown,(0,E.localize)(4,null)),e.$2v=f.ThemeIcon.modify(F.$Pj.sync,"spin"),e.$3v=f.ThemeIcon.modify(F.$Pj.loading,"spin")}),define(Se[86],De([1,0,4,49,5,14]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.$3u=e.ProvidedOnAutoForward=e.$2u=e.TunnelPrivacyId=e.TunnelProtocol=e.$1u=e.$Zu=void 0,e.$Zu=(0,f.$Bh)("tunnelService"),e.$1u=(0,f.$Bh)("sharedTunnelsService");var R;(function(o){o.Http="http",o.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})($||(e.TunnelPrivacyId=$={}));function E(o){return!!o.forwardPort}e.$2u=E;var p;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(p||(e.ProvidedOnAutoForward=p={}));function A(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(s)return{address:s[1],port:+s[2]}}e.$3u=A,e.$4u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(o){return e.$4u.indexOf(o)>=0}e.$5u=I,e.$6u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(o){return e.$6u.indexOf(o)>=0}e.$7u=w;function k(o,s,n,l){if(n===1)return!1;if(n===2&&w(s)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(b?.length===4&&parseInt(b[1])>=18)return!1}return o<1024}e.$8u=k;class D{constructor(s,n,l){this.remoteAddress=s,this.localAddress=n,this.b=l,this.a=new C.$fd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$9u=D;let v=class{constructor(s,n){this.j=s,this.k=n,this.a=new C.$fd,this.onTunnelOpened=this.a.event,this.b=new C.$fd,this.onTunnelClosed=this.b.event,this.c=new C.$fd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],n=Array.from(this.e.values());for(const l of n){const b=Array.from(l.values());for(const h of b){const t=await h.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:n}of s.values())await n.then(l=>typeof l!="string"?l?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,n,l,b,h){this.p(s,n,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:n,localAddress:l,privacy:b,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,n){(w(s)||I(s))&&(s=e.$4u[0]);const l=this.r(s,n);if(l)return++l.refcount,l.value}openTunnel(s,n,l,b,h,t=!1,r,a){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${l} on local port ${h}.`);const i=this.f??s;if(!i)return;if(n||(n="localhost"),b||(b=this.l),this.f&&this.i.has(l)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.s(i,n,l,b,h,t,r,a);return c?c.then(d=>{if(d){if(typeof d=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,l),d}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,l);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const y=this.n(d);return(d.tunnelRemoteHost!==n||d.tunnelRemotePort!==l)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&d.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(y),y}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const n=this.e.get(s.tunnelRemoteHost);if(n){const l=n.get(s.tunnelRemotePort);l&&(l.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,l))}}}}async o(s,n,l){if(l.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${n}.`);const b=l.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(n),b}}async closeTunnel(s,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${n} `);const l=this.e.get(s);if(l&&l.has(n)){const b=l.get(n);b.refcount=0,await this.o(s,n,b)}}p(s,n,l){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(n,{refcount:1,value:l})}async q(s,n){const l=this.e.get(s);if(l){const b=l.get(n),h=b?await b.value:void 0;(!h||typeof h=="string")&&l.delete(n),l.size===0&&this.e.delete(s)}}r(s,n){const l=[s];I(s)?(l.push(...e.$4u),l.push(...e.$6u)):w(s)&&l.push(...e.$6u);const b=l.map(h=>this.e.get(h));for(const h of b){const t=h?.get(n);if(t)return t}}canTunnel(s){return!!A(s)}t(s,n,l,b,h,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${l} on local port ${b}.`);const a=l;this.i.add(a);const i=b===void 0?l:b,c={elevationRequired:h?this.isPortPrivileged(i):!1},d={remoteAddress:{host:n,port:l},localAddressPort:b,privacy:t,public:t?t!==$.Private:void 0,protocol:r},y=s.forwardPort(d,c);return y?(this.p(n,l,y),y.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(a)})):this.i.delete(a),y}};e.$0u=v,e.$0u=v=Ke([Be(0,L.$5i),Be(1,F.$8h)],v)}),define(Se[256],De([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=void 0,e.$Ck=(0,C.$Bh)("IUriIdentityService")}),define(Se[257],De([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$$u=void 0,e.$$u=(0,C.$Bh)("editSessionIdentityService");var F;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Se[258],De([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=void 0;function F(E){return E.scheme!==C.Schemas.file&&E.scheme!==C.Schemas.vscodeRemote}e.$xJ=F;function f(E){if(E.folders.length)return E.folders.every(p=>F(p.uri))?E.folders[0].uri:void 0;if(E.configuration&&F(E.configuration))return E.configuration}e.$yJ=f;function L(E){return f(E)?.scheme}e.$zJ=L;function R(E){return f(E)?.authority}e.$AJ=R;function $(E){return f(E)!==void 0}e.$BJ=$}),define(Se[43],De([1,0,201,16,78,24,2,5,17]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.WorkbenchState=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0,e.$Kh=(0,$.$Bh)("contextService");function p(i){const c=i;return typeof c?.id=="string"&&R.URI.isUri(c.uri)}e.$Lh=p;function A(i){return typeof i?.id=="string"&&!p(i)&&!w(i)}e.$Mh=A,e.$Nh={id:"ext-dev"},e.$Oh={id:"empty-window"};function I(i,c){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,F.$ae)(i)}:c?e.$Nh:e.$Oh;const d=i;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$Ph=I;function w(i){const c=i;return typeof c?.id=="string"&&R.URI.isUri(c.configPath)}e.$Qh=w;function k(i){const c=i;if(c?.uri)return{id:c.id,uri:R.URI.revive(c.uri)};const d=i;if(d?.configPath)return{id:d.id,configPath:R.URI.revive(d.configPath)};if(i?.id)return{id:i.id}}e.$Rh=k;var D;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function v(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$Sh=v;function o(i){const c=i;return!!(c&&typeof c=="object"&&R.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$Th=o;class s{constructor(c,d,y,S,g){this.h=c,this.j=y,this.k=S,this.l=g,this.c=f.$Hh.forUris(this.l,()=>!0),this.folders=d}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=f.$Hh.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Uh=s;class n{constructor(c,d){this.raw=d,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,L.$ig)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Vh=n;function l(i){return new n({uri:i,index:0,name:(0,L.$eg)(i)},{uri:i.toString()})}e.$Wh=l,e.$Xh="code-workspace",e.$Yh=`.${e.$Xh}`,e.$Zh=[{name:(0,C.localize)(0,null),extensions:[e.$Xh]}],e.$1h="workspace.json";function b(i,c){return L.$_f.isEqualOrParent(i,c.untitledWorkspacesHome)}e.$2h=b;function h(i){let c;return R.URI.isUri(i)?c=i:c=i.configuration,c?.scheme===E.Schemas.tmp}e.$3h=h,e.$4h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$4h}e.$5h=t;function r(i,c){return!b(i,c)&&!h(i)}e.$6h=r;function a(i){return(typeof i=="string"?(0,F.$be)(i):(0,L.$gg)(i))===e.$Yh}e.$7h=a}),define(Se[259],De([1,0,51,4,3,24,2,200,131,30,5,14,43,28,256,9,31,15,18]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.ProfileResourceType=void 0;var l;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function b(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&R.URI.isUri(c.location)&&R.URI.isUri(c.globalStorageHome)&&R.URI.isUri(c.settingsResource)&&R.URI.isUri(c.keybindingsResource)&&R.URI.isUri(c.tasksResource)&&R.URI.isUri(c.snippetsHome)&&R.URI.isUri(c.extensionsResource))}e.$Dk=b,e.$Ek=(0,A.$Bh)("IUserDataProfilesService");function h(i,c){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:R.URI.revive(i.location).with({scheme:c}),globalStorageHome:R.URI.revive(i.globalStorageHome).with({scheme:c}),settingsResource:R.URI.revive(i.settingsResource).with({scheme:c}),keybindingsResource:R.URI.revive(i.keybindingsResource).with({scheme:c}),tasksResource:R.URI.revive(i.tasksResource).with({scheme:c}),snippetsHome:R.URI.revive(i.snippetsHome).with({scheme:c}),extensionsResource:R.URI.revive(i.extensionsResource).with({scheme:c}),cacheHome:R.URI.revive(i.cacheHome).with({scheme:c}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Fk=h;function t(i,c,d,y,S,g){return{id:i,name:c,location:d,isDefault:!1,shortName:S?.shortName,globalStorageHome:g&&S?.useDefaultFlags?.globalState?g.globalStorageHome:(0,L.$ig)(d,"globalStorage"),settingsResource:g&&S?.useDefaultFlags?.settings?g.settingsResource:(0,L.$ig)(d,"settings.json"),keybindingsResource:g&&S?.useDefaultFlags?.keybindings?g.keybindingsResource:(0,L.$ig)(d,"keybindings.json"),tasksResource:g&&S?.useDefaultFlags?.tasks?g.tasksResource:(0,L.$ig)(d,"tasks.json"),snippetsHome:g&&S?.useDefaultFlags?.snippets?g.snippetsHome:(0,L.$ig)(d,"snippets"),extensionsResource:g&&S?.useDefaultFlags?.extensions?g.extensionsResource:(0,L.$ig)(d,"extensions.json"),cacheHome:(0,L.$ig)(y,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}e.$Gk=t;let r=class extends f.$kc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,d,y,S){super(),this.t=c,this.u=d,this.w=y,this.y=S,this.f=!0,this.h=this.B(new F.$fd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$fd),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$fd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$fd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new k.$zi,emptyWindows:new Map},this.profilesHome=(0,L.$ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),d=[c];if(this.f)try{for(const g of this.O()){if(!g.name||!(0,n.$jf)(g.name)||!g.location){this.y.warn("Skipping the invalid stored profile",g.location||g.name);continue}d.push(t((0,L.$fg)(g.location),g.name,g.location,this.g,{shortName:g.shortName,useDefaultFlags:g.useDefaultFlags},c))}}catch(g){this.y.error(g)}const y=new k.$zi,S=new Map;if(d.length)try{const g=this.Q();if(g.workspaces)for(const[u,m]of Object.entries(g.workspaces)){const P=R.URI.parse(u),O=d.find(N=>N.id===m);O&&y.set(P,O)}if(g.emptyWindows)for(const[u,m]of Object.entries(g.emptyWindows)){const P=d.find(O=>O.id===m);P&&S.set(u,P)}}catch(g){this.y.error(g)}this.z={profiles:d,workspaces:y,emptyWindows:S}}return this.z}D(){const c=t("__default__profile__",(0,$.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const d="Temp",y=new RegExp(`${(0,s.$qe)(d)}\\s(\\d+)`);let S=0;for(const u of this.profiles){const m=y.exec(u.name),P=m?parseInt(m[1]):0;S=P>S?P:S}const g=`${d} ${S+1}`;return this.createProfile((0,C.$pi)((0,o.$4f)()).toString(16),g,{transient:!0},c)}async createNamedProfile(c,d,y){return this.createProfile((0,C.$pi)((0,o.$4f)()).toString(16),c,d,y)}async createProfile(c,d,y,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=await this.F(c,d,y);return S&&await this.setProfileForWorkspace(S,g),g}async F(c,d,y){if(!(0,n.$jf)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(d);return S||(S=(async()=>{try{const g=this.profiles.find(P=>P.name===d||P.id===c);if(g)return g;const u=t(c,d,(0,L.$ig)(this.profilesHome,c),this.g,y,this.defaultProfile);await this.u.createFolder(u.location);const m=[];return this.j.fire({profile:u,join(P){m.push(P)}}),await v.Promises.settled(m),this.I([u],[],[]),u}finally{this.r.delete(d)}})(),this.r.set(d,S)),S}async updateProfile(c,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let y=this.profiles.find(S=>S.id===c.id);if(!y)throw new Error(`Profile '${c.name}' does not exist`);return y=t(y.id,d.name??y.name,y.location,this.g,{shortName:d.shortName??y.shortName,transient:d.transient??y.isTransient,useDefaultFlags:d.useDefaultFlags??y.useDefaultFlags},this.defaultProfile),this.I([],[],[y]),y}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(S=>S.id===c.id);if(!d)throw new Error(`Profile '${c.name}' does not exist`);const y=[];this.m.fire({profile:d,join(S){y.push(S)}});try{await Promise.allSettled(y)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])d.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])d.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[d],[]);try{await this.u.del(d.cacheHome,{recursive:!0})}catch(S){(0,p.$jk)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(c,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=this.profiles.find(S=>S.id===d.id);if(!y)throw new Error(`Profile '${d.name}' does not exist`);this.L(c,y)}unsetWorkspace(c,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,d)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(d=>d.isDirectory&&this.profiles.every(y=>!this.w.extUri.isEqual(y.location,d.resource))).map(d=>this.u.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(d=>!this.H(d));await Promise.allSettled(c.map(d=>this.removeProfile(d)))}getProfileForWorkspace(c){const d=this.G(c);return R.URI.isUri(d)?this.s.workspaces.get(d)??this.C.workspaces.get(d):this.s.emptyWindows.get(d)??this.C.emptyWindows.get(d)}G(c){return(0,w.$Lh)(c)?c.uri:(0,w.$Qh)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,c.location))||[...this.s.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,c.location))||[...this.C.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,c.location))||[...this.C.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,c.location)))}I(c,d,y){const S=[...this.profiles,...c],g=[];this.s.profiles=[];for(let u of S)u.isDefault||d.some(m=>u.id===m.id)||(u=y.find(m=>u.id===m.id)??u,u.isTransient?this.s.profiles.push(u):g.push({location:u.location,name:u.name,shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}));this.P(g),this.z=void 0,this.J(c,d,y)}J(c,d,y){this.h.fire({added:c,removed:d,updated:y,all:this.profiles})}L(c,d,y){y=d?.isTransient?!0:y,y||this.L(c,void 0,!0);const S=this.G(c),g=y?this.s:this.C;R.URI.isUri(S)?(g.workspaces.delete(S),d&&g.workspaces.set(S,d)):(g.emptyWindows.delete(S),d&&g.emptyWindows.set(S,d)),y||this.M()}M(){const c={};for(const[y,S]of this.C.workspaces.entries())c[y.toString()]=S.id;const d={};for(const[y,S]of this.C.emptyWindows.entries())d[y.toString()]=S.id;this.R({workspaces:c,emptyWindows:d}),this.z=void 0}N(c){const d={},y=this.D();if(c.workspaces)for(const[g,u]of Object.entries(c.workspaces)){const m=R.URI.parse(u);d[g]=this.w.extUri.isEqual(m,y.location)?y.id:this.w.extUri.basename(m)}const S={};if(c.emptyWindows)for(const[g,u]of Object.entries(c.emptyWindows)){const m=R.URI.parse(u);S[g]=this.w.extUri.isEqual(m,y.location)?y.id:this.w.extUri.basename(m)}return{workspaces:d,emptyWindows:S}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Hk=r,e.$Hk=r=Ke([Be(0,E.$Ih),Be(1,p.$6j),Be(2,D.$Ck),Be(3,I.$5i)],r);class a extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Ik=a}),define(Se[260],De([1,0,9,4,3,53,18,184,5,259]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Vo=e.$Uo=e.$To=void 0,e.$To="__$__isNewStorageMarker",e.$Uo="__$__targetStorageMarker",e.$Vo=(0,E.$Bh)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var I;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var w;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function k(n){const l=n.get(e.$Uo);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}e.$Wo=k;class D extends f.$kc{static{this.a=60*1e3}constructor(l={flushInterval:D.a}){super(),this.m=l,this.b=this.B(new F.$id),this.c=this.B(new F.$id),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$fd),this.onWillSaveState=this.f.event,this.h=this.B(new C.$Sg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$lc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,b,h){return F.Event.filter(this.b.event,t=>t.scope===l&&(b===void 0||t.key===b),h)}n(){this.j.value=(0,C.$Wg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$fc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,b){const{key:h,external:t}=b;if(h===e.$Uo){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:h,target:this.J(l)[h],external:t})}w(l){this.f.fire({reason:l})}get(l,b,h){return this.P(b)?.get(l,h)}getBoolean(l,b,h){return this.P(b)?.getBoolean(l,h)}getNumber(l,b,h){return this.P(b)?.getNumber(l,h)}getObject(l,b,h){return this.P(b)?.getObject(l,h)}storeAll(l,b){this.y(()=>{for(const h of l)this.store(h.key,h.value,h.scope,h.target,b)})}store(l,b,h,t,r=!1){if((0,R.$sf)(b)){this.remove(l,h,r);return}this.y(()=>{this.z(l,h,t),this.P(h)?.set(l,b,r)})}remove(l,b,h=!1){this.y(()=>{this.z(l,b,void 0),this.P(b)?.delete(l,h)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,b){const h=[],t=this.J(l);for(const r of Object.keys(t))t[r]===b&&h.push(r);return h}z(l,b,h,t=!1){const r=this.J(b);typeof h=="number"?r[l]!==h&&(r[l]=h,this.P(b)?.set(e.$Uo,JSON.stringify(r),t)):typeof r[l]=="number"&&(delete r[l],this.P(b)?.set(e.$Uo,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const b=this.P(l);return b?k(b):Object.create(null)}isNew(l){return this.getBoolean(e.$To,l)===!0}async flush(l=A.NONE){this.f.fire({reason:l});const b=this.P(-1),h=this.P(0),t=this.P(1);switch(l){case A.NONE:await C.Promises.settled([b?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await C.Promises.settled([b?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,b=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return s(l,b,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,b){return this.w(A.NONE),(0,p.$Dk)(l)?this.R(l,b):this.S(l,b)}M(l,b){return!(l.id===b.id||v(b)&&v(l))}N(l,b,h){this.y(()=>{const t=new Set;for(const[r,a]of l)t.add(r),b.get(r)!==a&&this.u(h,{key:r,external:!0});for(const[r]of b.items)t.has(r)||this.u(h,{key:r,external:!0})})}}e.$Xo=D;function v(n){return n.isDefault||!!n.useDefaultFlags?.globalState}e.$Yo=v;class o extends D{constructor(){super(),this.U=this.B(new $.$Ro(new $.$So,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new $.$Ro(new $.$So,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new $.$Ro(new $.$So,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$Zo=o;async function s(n,l,b,h,t,r){const a=P=>{try{return JSON.parse(P)}catch{return P}},i=new Map,c=new Map;n.forEach((P,O)=>{i.set(O,P),c.set(O,a(P))});const d=new Map,y=new Map;l.forEach((P,O)=>{d.set(O,P),y.set(O,a(P))});const S=new Map,g=new Map;b.forEach((P,O)=>{S.set(O,P),g.set(O,a(P))}),console.group(h!==t?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const u=[];if(i.forEach((P,O)=>{u.push({key:O,value:P})}),console.table(u),console.groupEnd(),console.log(c),h!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];d.forEach((O,N)=>{P.push({key:N,value:O})}),console.table(P),console.groupEnd(),console.log(y)}console.group(`Storage: Workspace (path: ${r})`);const m=[];S.forEach((P,O)=>{m.push({key:O,value:P})}),console.table(m),console.groupEnd(),console.log(g)}e.$1o=s}),define(Se[87],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=void 0;class C{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const L=this.c++;return this.b.set(L,f),this.e(),L}get(f,L){return this.b.has(f)?this.b.get(f)[L]:void 0}delete(f){this.b.delete(f),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$8ac=C}),define(Se[54],De([1,0,17,24,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=e.$0ac=void 0;class L{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new F.$0f($=>{const E=this.b.get($.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos($,E){E===null?this.b.delete($.scheme):this.b.set($.scheme,E)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$0ac=L,e.$$ac=(0,f.$Bh)("IExtHostFileSystemInfo")}),define(Se[26],De([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=void 0,e.$fM=(0,C.$Bh)("IExtHostInitDataService")}),define(Se[261],De([1,0,206,14,241,26]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=void 0;let R=class extends f.$mN{constructor(E,p,A){const I=A.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",w=A.remote.isRemote?(0,C.localize)(0,null):E?(0,C.localize)(1,null):(0,C.localize)(2,null);super(p.createLogger(I,{name:w}))}};e.$fdc=R,e.$fdc=R=Ke([Be(1,F.$6i),Be(2,L.$fM)],R)}),define(Se[262],De([1,0,9]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=e.$Abc=void 0;class F{constructor(R,$,E){this.h=new Map,this.a=R,this.b=$,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(p=>(this.f=p,this)),this.g=this.c.onDidChangeStorage(p=>{p.shared===this.b&&p.key===this.a&&(this.f=p.value)}),this.i=new C.$Sg(()=>{const p=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of p.values())A.complete()}catch(A){for(const I of p.values())I.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let E=this.f[R];return typeof E>"u"&&(E=$),E}update(R,$){this.f[R]=$;const E=this.h.get(R);if(E!==void 0)return E.p;const p=new C.$2g;return this.h.set(R,p),this.i.isScheduled()||this.i.schedule(),p.p}dispose(){this.g.dispose()}}e.$Abc=F;class f extends F{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$Bbc=f}),define(Se[263],De([1,0,4,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class f{constructor(R){this.c=R,this.a=new C.$fd,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$fd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,E,p){const I=this.c.getNotebookDocument(F.URI.revive(R)).acceptModelChanged($.value,E,p);this.b.fire(I)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(F.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(F.URI.revive(R));this.a.fire($.apiNotebook)}}e.$Zcc=f}),define(Se[20],De([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=void 0,e.$2L=(0,C.$Bh)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$3L=F}),define(Se[264],De([1,0,25,4]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=void 0;class f{#e;constructor(R,$){this.b=new F.$fd,this.onDidChange=this.b.event,this.a=C.$Vl.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$Mbc=f}),define(Se[68],De([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=e.$ibc=void 0,e.$ibc=(0,C.$Bh)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$jbc=F}),define(Se[265],De([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bb=e.$$bb=void 0;class F{constructor(){this.buffers=[]}add(E){let p=this.buffers.indexOf(E);return p<0&&(p=this.buffers.length,this.buffers.push(E)),p}}function f($,E){if(E.serializeBuffersForPostMessage){const p=new F,I=JSON.stringify($,(k,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:p.add(D)};if(ArrayBuffer.isView(D)){const v=L(D);if(v)return{$$vscode_array_buffer_reference$$:!0,index:p.add(D.buffer),view:{type:v,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),w=p.buffers.map(k=>{const D=new Uint8Array(k);return C.$Fd.wrap(D)});return{message:I,buffers:w}}else return{message:JSON.stringify($),buffers:[]}}e.$$bb=f;function L($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,E){const p=E.map(w=>{const k=new ArrayBuffer(w.byteLength);return new Uint8Array(k).set(w.buffer),k}),A=E.length?(w,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const D=k,{index:v}=D,o=p[v];if(D.view)switch(D.view.type){case 1:return new Int8Array(o,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return k}:void 0;return{message:JSON.parse($,A),arrayBuffers:p}}e.$_bb=R}),define(Se[266],De([1,0,267,374,375,61,2,14,376]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;const p=!0;function A(l,b,h,t,r,a){const i=a.environment.useHostProxy,c=typeof i=="boolean"?i:!a.remote.isRemote,d={resolveProxy:g=>l.resolveProxy(g),lookupProxyAuthorization:o.bind(void 0,t,r,b,{},a.remote.isRemote),getProxyURL:()=>b.getConfiguration("http").get("proxy"),getProxySupport:()=>b.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>w(b),getSystemCertificatesV2:()=>k(b),log:(g,u,...m)=>{switch(g){case E.LogLevel.Trace:t.trace(u,...m);break;case E.LogLevel.Debug:t.debug(u,...m);break;case E.LogLevel.Info:t.info(u,...m);break;case E.LogLevel.Warning:t.warn(u,...m);break;case E.LogLevel.Error:t.error(u,...m);break;case E.LogLevel.Critical:t.error(u,...m);break;case E.LogLevel.Off:break;default:P(g,u,m);break}function P(O,N,...M){t.error("Unknown log level",O),t.error(N,...M)}},getLogLevel:()=>{const g=t.getLevel();switch(g){case $.LogLevel.Trace:return E.LogLevel.Trace;case $.LogLevel.Debug:return E.LogLevel.Debug;case $.LogLevel.Info:return E.LogLevel.Info;case $.LogLevel.Warning:return E.LogLevel.Warning;case $.LogLevel.Error:return E.LogLevel.Error;case $.LogLevel.Off:return E.LogLevel.Off;default:return u(g)}function u(m){return t.error("Unknown log level",m),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,addCertificates:[],env:process.env},y=(0,E.createProxyResolver)(d),S=I(d,y);return v(h,S)}e.$Ndc=A;function I(l,b){return{http:Object.assign(C,(0,E.createHttpPatch)(l,C,b)),https:Object.assign(F,(0,E.createHttpPatch)(l,F,b)),net:Object.assign(L,(0,E.createNetPatch)(l,L)),tls:Object.assign(f,(0,E.createTlsPatch)(l,f))}}function w(l){const b=l.getConfiguration("http");return!b.get("experimental.systemCertificatesV2",p)&&!!b.get("systemCertificates")}function k(l){const b=l.getConfiguration("http");return!!b.get("experimental.systemCertificatesV2",p)&&!!b.get("systemCertificates")}const D=new Map;function v(l,b){return l.getExtensionPathIndex().then(h=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(i,c,d){if(i==="net")return b.net;if(i==="tls")return b.tls;if(i!=="http"&&i!=="https")return r.apply(this,arguments);const y=h.findSubstr(R.URI.file(c.filename));let S=D.get(y);if(S||D.set(y,S={}),!S[i]){const g=b[i];S[i]={...g}}return S[i]}})}async function o(l,b,h,t,r,a,i,c){const d=t[a];i&&(t[a]=i),l.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${a}`,`proxyAuthenticate:${i}`,`proxyAuthenticateCache:${d}`);const y=i||d,S=Array.isArray(y)?y:typeof y=="string"?[y]:[];if(n(b,S,r),S.some(g=>/^(Negotiate|Kerberos)( |$)/i.test(g))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const g=await new Promise((N,M)=>{$e(["kerberos"],N,M)}),u=new URL(a),m=h.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${u.hostname}`:`HTTP@${u.hostname}`);return l.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${a}`,`spn:${m}`),"Negotiate "+await(await g.initializeClient(m)).step("")}catch(g){l.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",g)}}let s=!1;function n(l,b,h){s||!b.length||(s=!0,l.$publicLog2("proxyAuthenticationRequest",{authenticationType:b.map(t=>t.split(" ")[0]).join(","),extensionHostType:h?"remote":"local"}))}}),define(Se[268],De([1,0,128]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;function F(L){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:L,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function f(L){return new C.$Bm(F(L))}e.$qr=f}),define(Se[139],De([1,0,216,18,2,3,5,42,30,17,46,176,38]),function($e,e,C,F,f,L,R,$,E,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9D=e.$8D=e.$7D=e.EditorsOrder=e.$6D=e.CloseDirection=e.$5D=e.$4D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.$WD=e.$VD=e.EditorInputCapabilities=e.$UD=e.SaveReason=e.Verbosity=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.$OD=e.$ND=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$MD=e.$LD=e.$KD=e.$JD=e.$ID=void 0,e.$ID={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$JD={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$KD="workbench.editor.sidebysideEditor",e.$LD="workbench.editors.textDiffEditor",e.$MD="workbench.editors.binaryResourceDiffEditor";var k;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var D;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function v(ue){const ve=ue;return!!ve&&typeof ve.getSelection=="function"&&!!ve.onDidChangeSelection}e.$ND=v;function o(ue,ve,G){for(const U of G.visibleEditorPanes)if(U.group.id===ve&&ue.matches(U.input))return U.getViewState()}e.$OD=o;function s(ue){if(d(ue))return!1;const ve=ue;return f.URI.isUri(ve?.resource)}e.$PD=s;function n(ue){if(d(ue))return!1;const ve=ue;return ve?.original!==void 0&&ve.modified!==void 0}e.$QD=n;function l(ue){if(d(ue)||n(ue))return!1;const ve=ue;return ve?.primary!==void 0&&ve.secondary!==void 0}e.$RD=l;function b(ue){if(d(ue))return!1;const ve=ue;return ve?ve.resource===void 0||ve.resource.scheme===p.Schemas.untitled||ve.forceUntitled===!0:!1}e.$SD=b;function h(ue){if(d(ue))return!1;const ve=ue;return f.URI.isUri(ve?.base?.resource)&&f.URI.isUri(ve?.input1?.resource)&&f.URI.isUri(ve?.input2?.resource)&&f.URI.isUri(ve?.result?.resource)}e.$TD=h;var t;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var r;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class a{constructor(){this.a=new Map}registerSource(ve,G){let U=this.a.get(ve);return U||(U={source:ve,label:G},this.a.set(ve,U)),U.source}getSourceLabel(ve){return this.a.get(ve)?.label??ve}}e.$UD=new a;var i;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors",ue[ue.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class c extends L.$kc{}e.$VD=c;function d(ue){return ue instanceof c}e.$WD=d;function y(ue){const ve=ue;return f.URI.isUri(ve?.preferredResource)}function S(ue){const ve=ue;return d(ve?.primary)&&d(ve?.secondary)}e.$XD=S;function g(ue){const ve=ue;return d(ve?.modified)&&d(ve?.original)}e.$YD=g;function u(ue,ve,G,U,K){return ge(U,[(0,I.$li)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const fe={...G,limits:{size:Number.MAX_VALUE}};ue.openEditor(ve,fe)}}),(0,I.$li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>K.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.$ZD=u;function m(ue){return d(ue?.editor)}e.$1D=m;function P(ue){const ve=ue;return m(ue)&&ve?.group!==void 0}e.$2D=P;function O(ue){const ve=ue;return typeof ve?.groupId=="number"&&d(ve.editor)}e.$3D=O;var N;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var M;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LOCKED=2]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=3]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=4]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=5]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=7]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=9]="EDITOR_PIN",ue[ue.EDITOR_STICKY=10]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=11]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var j;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class z{getOriginalUri(ve,G){if(!ve)return;if(h(ve))return e.$5D.getOriginalUri(ve.result,G);if(G?.supportSideBySide){const{primary:K,secondary:fe}=this.a(ve);if(K&&fe){if(G?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(fe,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getOriginalUri(K,{filterByScheme:G.filterByScheme})??this.getOriginalUri(fe,{filterByScheme:G.filterByScheme});ve=G.supportSideBySide===j.PRIMARY?K:fe}}if(n(ve)||l(ve)||h(ve))return;const U=y(ve)?ve.preferredResource:ve.resource;return!U||!G||!G.filterByScheme?U:this.b(U,G.filterByScheme)}a(ve){return S(ve)||l(ve)?{primary:ve.primary,secondary:ve.secondary}:g(ve)||n(ve)?{primary:ve.modified,secondary:ve.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ve,G){if(!ve)return;if(h(ve))return e.$5D.getCanonicalUri(ve.result,G);if(G?.supportSideBySide){const{primary:K,secondary:fe}=this.a(ve);if(K&&fe){if(G?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(fe,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getCanonicalUri(K,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(fe,{filterByScheme:G.filterByScheme});ve=G.supportSideBySide===j.PRIMARY?K:fe}}if(n(ve)||l(ve)||h(ve))return;const U=ve.resource;return!U||!G||!G.filterByScheme?U:this.b(U,G.filterByScheme)}b(ve,G){if(Array.isArray(G)){if(G.some(U=>ve.scheme===U))return ve}else if(G===ve.scheme)return ve}}var T;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.KEYBOARD=1]="KEYBOARD",ue[ue.MOUSE=2]="MOUSE"})(T||(e.EditorCloseMethod=T={}));function H(ue,ve,G,U){if(!ue.isSticky(ve))return!1;switch(U.preventPinnedEditorClose){case"keyboardAndMouse":return G===T.MOUSE||G===T.KEYBOARD;case"mouse":return G===T.MOUSE;case"keyboard":return G===T.KEYBOARD}return!1}e.$4D=H,e.$5D=new z;var q;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class me{constructor(){this.c=new Map,this.d=new Map}start(ve){const G=this.a=ve.get(R.$Ah);for(const[U,K]of this.c)this.e(U,K,G);this.c.clear()}e(ve,G,U){const K=U.createInstance(G);this.d.set(ve,K)}registerFileEditorFactory(ve){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ve}getFileEditorFactory(){return(0,F.$uf)(this.b)}registerEditorSerializer(ve,G){if(this.c.has(ve)||this.d.has(ve))throw new Error(`A editor serializer with type ID '${ve}' was already registered.`);return this.a?this.e(ve,G,this.a):this.c.set(ve,G),(0,L.$ic)(()=>{this.c.delete(ve),this.d.delete(ve)})}getEditorSerializer(ve){return this.d.get(typeof ve=="string"?ve:ve.typeId)}}$.$8m.add(e.$ID.EditorFactory,new me);async function Z(ue,ve,G){return!ue||!ue.length?[]:await Promise.all(ue.map(async U=>{const K=f.URI.revive(U.fileUri);if(!K){G.info("Cannot resolve the path because it is not valid.",U);return}if(!await ve.canHandleResource(K)){G.info("Cannot resolve the path because it cannot be handled",U);return}let te=U.exists,se=U.type;if(typeof te!="boolean"||typeof se!="number")try{se=(await ve.stat(K)).isDirectory?E.FileType.Directory:E.FileType.Unknown,te=!0}catch(Ee){G.error(Ee),te=!1}if(!te&&U.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",U);return}if(se===E.FileType.Directory){G.info("Cannot resolve the path because it is a directory",U);return}const ne={...U.options,pinned:!0};return te?{resource:K,options:ne}:{resource:K,options:ne,forceUntitled:!0}}))}e.$6D=Z;var X;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function V(ue){const ve=ue;if(!ve)return!1;const G=ve;if(G.modified)return V(G.modified);const U=ve;return!!(U.contributionsState&&U.viewState&&Array.isArray(U.cursorState))}e.$7D=V;function x(ue){return(0,A.$ni)(ue)}e.$8D=x;function ge(ue,ve,G){const U=(0,A.$oi)(ue,ve);return U.forceMessage=G?.forceMessage,U.forceSeverity=G?.forceSeverity,U.allowDialog=G?.allowDialog,U}e.$9D=ge}),define(Se[269],De([1,0,4,217,5,3,28,42,19,56,23,79,255]),function($e,e,C,F,f,L,R,$,E,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fE=e.$eE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$dE=e.$cE=e.ViewContentGroups=e.$bE=e.$aE=e.ViewContainerLocation=e.Extensions=e.$_D=void 0,e.$_D=(0,w.$Vv)("default-view-icon",I.$Pj.window,(0,F.localize)(0,null));var k;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(k||(e.Extensions=k={}));var D;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel",a[a.AuxiliaryBar=2]="AuxiliaryBar"})(D||(e.ViewContainerLocation=D={})),e.$aE=[0,1,2];function v(a){switch(a){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$bE=v;class o extends L.$kc{constructor(){super(...arguments),this.c=this.B(new C.$fd),this.onDidRegister=this.c.event,this.f=this.B(new C.$fd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Pb)([...this.g.values()])}registerViewContainer(i,c,d){const y=this.get(i.id);if(y)return y;const S=i;return S.openCommandActionDescriptor=d?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$wi)(this.g,c,[]).push(S),d?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:c}),S}deregisterViewContainer(i){for(const c of this.g.keys()){const d=this.g.get(c),y=d?.indexOf(i);if(y!==-1){d?.splice(y,1),d.length===0&&this.g.delete(c),this.f.fire({viewContainer:i,viewContainerLocation:c});return}}}get(i){return this.all.filter(c=>c.id===i)[0]}getViewContainers(i){return[...this.g.get(i)||[]]}getViewContainerLocation(i){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(d=>d?.id===i.id).length>0)[0]}getDefaultViewContainer(i){return this.h.find(c=>this.getViewContainerLocation(c)===i)}}$.$8m.add(k.ViewContainersRegistry,new o);var s;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(s||(e.ViewContentGroups=s={}));function n(a,i){const c=a.group??s.More,d=i.group??s.More;return c!==d?c.localeCompare(d):(a.order??5)-(i.order??5)}class l extends L.$kc{constructor(){super(...arguments),this.c=this.B(new C.$fd),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$fd),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$fd),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$fd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new p.$L}registerViews(i,c){this.registerViews2([{views:i,viewContainer:c}])}registerViews2(i){i.forEach(({views:c,viewContainer:d})=>this.r(c,d)),this.c.fire(i)}deregisterViews(i,c){const d=this.s(i,c);d.length&&this.f.fire({views:d,viewContainer:c})}moveViews(i,c){for(const d of this.m.keys())if(d!==c){const y=this.s(i,d);y.length&&(this.r(y,c),this.g.fire({views:y,from:d,to:c}))}}getViews(i){return this.m.get(i)||[]}getView(i){for(const c of this.j){const d=(this.m.get(c)||[]).filter(y=>y.id===i)[0];if(d)return d}return null}getViewContainer(i){for(const c of this.j)if((this.m.get(c)||[]).filter(y=>y.id===i)[0])return c;return null}registerViewWelcomeContent(i,c){return this.n.add(i,c),this.h.fire(i),(0,L.$ic)(()=>{this.n.delete(i,c),this.h.fire(i)})}registerViewWelcomeContent2(i,c){const d=new Map;for(const[y,S]of c)this.n.add(i,S),d.set(y,(0,L.$ic)(()=>{this.n.delete(i,S),this.h.fire(i)}));return this.h.fire(i),d}getViewWelcomeContent(i){const c=[];return this.n.forEach(i,d=>c.push(d)),c.sort(n)}r(i,c){let d=this.m.get(c);d||(d=[],this.m.set(c,d),this.j.push(c));for(const y of i){if(this.getView(y.id)!==null)throw new Error((0,F.localize)(1,null,y.id));d.push(y)}}s(i,c){const d=this.m.get(c);if(!d)return[];const y=[],S=[];for(const g of d)i.includes(g)?y.push(g):S.push(g);return y.length&&(S.length?this.m.set(c,S):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),y}}$.$8m.add(k.ViewsRegistry,new l),e.$cE=(0,f.$Bh)("viewsService"),e.$dE=(0,f.$Bh)("viewDescriptorService");var b;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(b||(e.ViewVisibilityState=b={}));var h;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(h||(e.TreeItemCollapsibleState=h={}));class t{constructor(i,c){this.c=!1,this.d=!1,(0,A.$Ym)(this,i),this.d=!!c,this.resolve=async d=>{if(c&&!this.c){const y=await c(d);y&&(this.tooltip=this.tooltip??y.tooltip,this.command=this.command??y.command)}d.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$eE=t;class r extends Error{constructor(i){super((0,F.localize)(2,null,i)),this.name="NoTreeViewError"}static is(i){return i.name==="NoTreeViewError"}}e.$fE=r}),define(Se[140],De([1,0,4,9,218]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new C.$fd,this.n=new C.$fd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,E,p,A){const I={command:$};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.s("request",I),typeof A=="number"){const w=setTimeout(()=>{clearTimeout(w);const k=this.f.get(I.seq);if(k){this.f.delete(I.seq);const D={type:"response",seq:0,request_seq:I.seq,success:!1,command:$,message:(0,f.localize)(0,null,A,$)};k(D)}},A)}return p&&this.f.set(I.seq,p),I.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,E){return $.type!=="event"||E.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,F.$Hg)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const E=$,p=this.f.get(E.request_seq);p&&(this.f.delete(E.request_seq),p(E));break}}}}s($,E){E.type=$,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((E,p)=>$.set(p,E)),await(0,F.$Hg)(500),$.forEach((E,p)=>{E({type:"response",seq:0,request_seq:p,success:!1,command:"canceled",message:"canceled"}),this.f.delete(p)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Ecb=L}),define(Se[270],De([1,0,219,41,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$PG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$OG=e.MemoryRangeType=e.$NG=e.State=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=void 0,e.$LF="workbench.view.debug",e.$MF="workbench.debug.variablesView",e.$NF="workbench.debug.watchExpressionsView",e.$OF="workbench.debug.callStackView",e.$PF="workbench.debug.loadedScriptsView",e.$QF="workbench.debug.breakPointsView",e.$RF="workbench.debug.disassemblyView",e.$SF="workbench.panel.repl",e.$TF="workbench.panel.repl.view",e.$UF=new F.$2i("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$VF=new F.$2i("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$WF=new F.$2i("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$XF="debugUx",e.$YF=new F.$2i(e.$XF,"default",{type:"string",description:C.localize(3,null)}),e.$ZF=new F.$2i("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$1F=new F.$2i("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$2F=new F.$2i("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$3F=new F.$2i("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$4F=new F.$2i("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$5F=new F.$2i("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$6F=new F.$2i("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$7F=new F.$2i("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$8F=new F.$2i("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$9F=new F.$2i("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$0F=new F.$2i("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$$F=new F.$2i("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$_F=new F.$2i("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$aG=new F.$2i("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$bG=new F.$2i("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$cG=new F.$2i("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$dG=new F.$2i("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$eG=new F.$2i("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$fG=new F.$2i("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(22,null)}),e.$gG=new F.$2i("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(23,null)}),e.$hG=new F.$2i("loadedScriptsItemType",void 0,{type:"string",description:C.localize(24,null)}),e.$iG=new F.$2i("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(25,null)}),e.$jG=new F.$2i("stepBackSupported",!1,{type:"boolean",description:C.localize(26,null)}),e.$kG=new F.$2i("restartFrameSupported",!1,{type:"boolean",description:C.localize(27,null)}),e.$lG=new F.$2i("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(28,null)}),e.$mG=new F.$2i("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.$nG=new F.$2i("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$oG=new F.$2i("breakpointsExist",!1,{type:"boolean",description:C.localize(31,null)}),e.$pG=new F.$2i("debuggersAvailable",!1,{type:"boolean",description:C.localize(32,null)}),e.$qG=new F.$2i("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(33,null)}),e.$rG=new F.$2i("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(34,null)}),e.$sG=new F.$2i("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(35,null)}),e.$tG=new F.$2i("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(36,null)}),e.$uG=new F.$2i("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(37,null)}),e.$vG=new F.$2i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$wG=new F.$2i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$xG=new F.$2i("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$yG=new F.$2i("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$zG=new F.$2i("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(42,null)}),e.$AG=new F.$2i("variableIsReadonly",!1,{type:"boolean",description:C.localize(43,null)}),e.$BG=new F.$2i("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(44,null)}),e.$CG=new F.$2i("multiSessionRepl",!1,{type:"boolean",description:C.localize(45,null)}),e.$DG=new F.$2i("multiSessionDebug",!1,{type:"boolean",description:C.localize(46,null)}),e.$EG=new F.$2i("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(47,null)}),e.$FG=new F.$2i("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(48,null)}),e.$GG=new F.$2i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(49,null)}),e.$HG=new F.$2i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(50,null)});const L=w=>C.localize(51,null,w);e.$IG=L,e.$JG="editor.contrib.debug",e.$KG="editor.contrib.breakpoint",e.$LG="debug",e.$MG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(52,null)};var R;(function(w){w[w.Inactive=0]="Inactive",w[w.Initializing=1]="Initializing",w[w.Stopped=2]="Stopped",w[w.Running=3]="Running"})(R||(e.State=R={}));function $(w){switch(w){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$NG=$;var E;(function(w){w[w.Valid=0]="Valid",w[w.Unreadable=1]="Unreadable",w[w.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$OG="vscode-debug-memory";var p;(function(w){w[w.Initial=1]="Initial",w[w.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var A;(function(w){w.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$PG=(0,f.$Bh)("debugService");var I;(function(w){w[w.CONDITION=0]="CONDITION",w[w.HIT_COUNT=1]="HIT_COUNT",w[w.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(Se[271],De([1,0,15,2,16,23,17,34,21,19]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=void 0;const A=/{([^}]+)}/g;function I(S,g,u){return S.replace(A,function(m,P){return g&&P.length>0&&P[0]!=="_"?m:u&&u.hasOwnProperty(P)?u[P]:m})}e.$aF=I;function w(S){const g={};for(const u of Object.keys(S))u.startsWith("!")||(g[u]=S[u]);return g}e.$bF=w;function k(S){return S.configuration.request==="attach"&&!D(S)&&(!S.parentSession||k(S.parentSession))}e.$cF=k;function D(S){let g=S.configuration.type;if(g)return g==="vslsShare"&&(g=S.configuration.adapterProxy.configuration.type),(0,C.$Me)(g,"extensionhost")||(0,C.$Me)(g,"pwa-extensionhost")?S:S.parentSession?D(S.parentSession):void 0}e.$dF=D;function v(S){return S.type&&(S.label||S.program||S.runtime)}e.$eF=v;function o(S,g,u){let m,P=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=O.exec(S);){const M=N.index+1,j=M+N[0].length;if(M<=g&&j>=u){m=N[0],P=M;break}}if(m){const M=/\w+/g;let j=null;for(;(j=M.exec(m))&&!(j.index+1+P+j[0].length>=u););j&&(m=m.substring(0,M.lastIndex))}return m?{start:P,end:P+m.length-1}:{start:0,end:0}}e.$fF=o;async function s(S,g,u,m){if(S.evaluatableExpressionProvider.has(g)){const P=S.evaluatableExpressionProvider.ordered(g),O=(0,p.$Fb)(await Promise.all(P.map(async N=>{try{return await N.provideEvaluatableExpression(g,u,m??E.CancellationToken.None)}catch{return}})));if(O.length>0){let N=O[0].expression;const M=O[0].range;return N||(N=g.getLineContent(u.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:N}}}else{const P=g.getLineContent(u.lineNumber),{start:O,end:N}=o(P,u.column,u.column),M=P.substring(O-1,N);return{matchingExpression:M,range:new $.$ks(u.lineNumber,O,u.lineNumber,O+M.length)}}return null}e.$gF=s;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(S){return!!(S&&S.match(n))}e.$hF=l;function b(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(l(S.path))return F.URI.parse(S.path);if((0,f.$8d)(S.path))return F.URI.file(S.path)}return S.path}function h(S){if(typeof S.path=="object"){const g=F.URI.revive(S.path);if(g)return g.scheme===R.Schemas.file?g.fsPath:g.toString()}return S.path}function t(S,g){const u=g?b:h,m=(0,L.$Vm)(S);return a(m,(P,O)=>{P&&O&&(O.path=u(O))}),m}e.$iF=t;function r(S,g){const u=g?b:h,m=(0,L.$Vm)(S);return a(m,(P,O)=>{!P&&O&&(O.path=u(O))}),m}e.$jF=r;function a(S,g){switch(S.type){case"event":{const u=S;switch(u.event){case"output":g(!1,u.body.source);break;case"loadedSource":g(!1,u.body.source);break;case"breakpoint":g(!1,u.body.breakpoint.source);break;default:break}break}case"request":{const u=S;switch(u.command){case"setBreakpoints":g(!0,u.arguments.source);break;case"breakpointLocations":g(!0,u.arguments.source);break;case"source":g(!0,u.arguments.source);break;case"gotoTargets":g(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(m=>g(!1,m));break;default:break}break}case"response":{const u=S;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(m=>g(!1,m.source));break;case"loadedSources":u.body.sources.forEach(m=>g(!1,m));break;case"scopes":u.body.scopes.forEach(m=>g(!1,m.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(m=>g(!1,m.source));break;case"setBreakpoints":u.body.breakpoints.forEach(m=>g(!1,m.source));break;case"disassemble":u.body?.instructions.forEach(P=>g(!1,P.location));break;default:break}break}}}function i(S){return S.filter(g=>!g.presentation?.hidden).sort((g,u)=>g.presentation?u.presentation?g.presentation.group?u.presentation.group?g.presentation.group!==u.presentation.group?g.presentation.group.localeCompare(u.presentation.group):c(g.presentation.order,u.presentation.order):-1:u.presentation.group?1:c(g.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.$kF=i;function c(S,g){return typeof S!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:S-g}async function d(S,g){const u=S.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(u!=="none"&&(await g.saveAll(),u==="allEditorsInActiveGroup")){const m=g.activeEditorPane;m&&m.input.resource?.scheme===R.Schemas.untitled&&await g.save({editor:m.input,groupId:m.group.id})}await S.reloadConfiguration()}e.$lF=d;const y=(S,g)=>!S||!g?S===g:S.name===g.name&&S.path===g.path&&S.sourceReference===g.sourceReference;e.$mF=y}),define(Se[272],De([1,0,48,61,23,16,12,15,29,220,140]),function($e,e,C,F,f,L,R,$,E,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=e.$ndc=e.$mdc=e.$ldc=void 0;class I extends A.$Ecb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,n){this.p=n,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",l=>this.w(l))}sendMessage(s){if(this.p){const n=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${I.a}${n}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const n=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(l){this.m.fire(new Error((l.message||l)+`
`+n))}continue}}else{const n=this.r.indexOf(I.a);if(n!==-1){const b=this.r.toString("utf8",0,n).split(I.b);for(const h of b){const t=h.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(n+I.a.length);continue}}break}}}e.$ldc=I;class w extends I{startSession(){return new Promise((s,n)=>{let l=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),l=!0}),this.x.on("close",()=>{l?this.m.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",b=>{l?this.m.fire(b):n(b)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$mdc=w;class k extends w{constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$ndc=k;class D extends w{constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.path,s)}}e.$odc=D;class v extends I{constructor(s,n){super(),this.y=s,this.z=n}async startSession(){const s=this.y.command,n=this.y.args,l=this.y.options||{};try{if(s)if(L.$8d(s)){if(!await E.Promises.exists(s))throw new Error(p.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(p.localize(1,null,this.z));let b=process.env;if(l.env&&Object.keys(l.env).length>0&&(b=f.$Ym(f.$Vm(process.env),l.env)),s==="node")if(Array.isArray(n)&&n.length>0){const h=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:b,execArgv:h?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(t.cwd=l.cwd);const r=C.fork(n[0],n.slice(1),t);if(!r.pid)throw new Error(p.localize(2,null,n[0]));this.x=r}else throw new Error(p.localize(3,null));else{const h={env:b};l.cwd&&(h.cwd=l.cwd),this.x=C.spawn(s,n,h)}this.x.on("error",h=>{this.m.fire(h)}),this.x.on("exit",(h,t)=>{this.n.fire(h)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",h=>{this.m.fire(h)}),this.x.stdin.on("error",h=>{this.m.fire(h)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(b){this.m.fire(b)}}async stopSession(){return this.x?(await this.u(),R.$i?new Promise((s,n)=>{const l=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function(b,h,t){if(b)return n(b)});l.on("exit",s),l.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,n){if(!s)return;const l=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?l.runtime=L.$9d(n,s.runtime):l.runtime=s.runtime),s.runtimeArgs&&(l.runtimeArgs=s.runtimeArgs),s.program&&(L.$8d(s.program)?l.program=s.program:l.program=L.$9d(n,s.program)),s.args&&(l.args=s.args);const b=s;return b.win&&(l.win=v.A(b.win,n)),b.winx86&&(l.winx86=v.A(b.winx86,n)),b.windows&&(l.windows=v.A(b.windows,n)),b.osx&&(l.osx=v.A(b.osx,n)),b.linux&&(l.linux=v.A(b.linux,n)),l}static platformAdapterExecutable(s,n){let l=Object.create(null);n=n.toLowerCase();for(const i of s)if(i.contributes){const c=i.contributes.debuggers;c&&c.length>0&&c.filter(d=>typeof d.type=="string"&&$.$Me(d.type,n)).forEach(d=>{const y=v.A(d,i.extensionLocation.fsPath);l=f.$Ym(l,y,i.isBuiltin)})}let b;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?b=l.winx86||l.win||l.windows:R.$i?b=l.win||l.windows:R.$j?b=l.osx:R.$k&&(b=l.linux),b=b||l;const h=b.program||l.program,t=b.args||l.args,r=b.runtime||l.runtime,a=b.runtimeArgs||l.runtimeArgs;if(r)return{type:"executable",command:r,args:(a||[]).concat(typeof h=="string"?[h]:[]).concat(t||[])};if(h)return{type:"executable",command:h,args:t||[]}}}e.$pdc=v}),define(Se[273],De([1,0,48,32,12]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=e.$qdc=void 0;function L(p,A){return new Promise((I,w)=>{let k="";const D=C.spawn(p,A);D.pid&&D.stdout.on("data",v=>{k+=v.toString()}),D.on("error",v=>{w(v)}),D.on("close",v=>{I(k)})})}async function R(p){if(p)if(f.$i){const A=await new Promise((I,w)=>{$e(["@vscode/windows-process-tree"],I,w)});return new Promise(I=>{A.getProcessTree(p,w=>{I(!!w&&w.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(p)]).then(A=>{const I=A.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$qdc=R;var $;(function(p){p[p.cmd=0]="cmd",p[p.powershell=1]="powershell",p[p.bash=2]="bash"})($||($={}));function E(p,A,I,w,k){p=p.trim().toLowerCase();let D;p.indexOf("powershell")>=0||p.indexOf("pwsh")>=0?D=1:p.indexOf("cmd.exe")>=0?D=0:p.indexOf("bash")>=0?D=2:f.$i?D=0:D=2;let v,o=" ";switch(D){case 1:if(v=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),w){const s=(0,F.$Nf)(w);s&&(o+=`${s}:; `),o+=`cd ${v(w)}; `}if(k)for(const s in k){const n=k[s];n===null?o+=`Remove-Item env:${s}; `:o+=`\${env:${s}}='${n}'; `}if(A.length>0){const s=A.shift(),n=I?s:v(s);o+=n[0]==="'"?`& ${n} `:`${n} `;for(const l of A)o+=l==="<"||l===">"||I?l:v(l),o+=" "}break;case 0:if(v=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>s.includes(n))||s.length===0?`"${s}"`:s),w){const s=(0,F.$Nf)(w);s&&(o+=`${s}: && `),o+=`cd ${v(w)} && `}if(k){o+='cmd /C "';for(const s in k){let n=k[s];n===null?o+=`set "${s}=" && `:(n=n.replace(/[&^|<>]/g,l=>`^${l}`),o+=`set "${s}=${n}" && `)}}for(const s of A)o+=s==="<"||s===">"||I?s:v(s),o+=" ";k&&(o+='"');break;case 2:{v=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),n.length===0?'""':n);const s=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(w&&(o+=`cd ${v(w)} ; `),k){o+="/usr/bin/env";for(const n in k){const l=k[n];l===null?o+=` -u ${s(n)}`:o+=` ${s(`${n}=${l}`)}`}o+=" "}for(const n of A)o+=n==="<"||n===">"||I?n:v(n),o+=" ";break}}return o}e.$rdc=E}),define(Se[108],De([1,0,22,35,50,98,17,16,12,41]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bI=e.$aI=e.$_H=e.$$H=e.CellStatusbarAlignment=e.$0H=e.$9H=e.$8H=e.NotebookEditorPriority=e.$7H=e.$6H=e.$5H=e.$4H=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$3H=e.$2H=e.$1H=e.$ZH=e.CellKind=e.$YH=e.$XH=e.$WH=void 0,e.$WH="workbench.editor.notebook",e.$XH="workbench.editor.notebookTextDiffEditor",e.$YH="workbench.editor.interactive";var A;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(A||(e.CellKind=A={})),e.$ZH=["application/json","application/javascript","text/html","image/svg+xml",L.$Hr.latex,L.$Hr.markdown,"image/png","image/jpeg",L.$Hr.text],e.$1H=[L.$Hr.latex,L.$Hr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Hr.text],e.$2H=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$3H="_notAvailable";var I;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var w;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var k;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(k||(e.NotebookExecutionState=k={}));var D;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var v;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(v||(e.RendererMessagingSpec=v={}));var o;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var s;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var n;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var l;(function(T){T.scheme=R.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${H.join("")}]+`),me=7;function Z(ve,G){const U=G.toString(me),fe=`${U.length<H.length?H[U.length-1]:"z"}${U}s${(0,C.$Zd)(C.$Fd.fromString(ve.scheme),!0,!0)}`;return ve.with({scheme:T.scheme,fragment:fe})}T.generate=Z;function X(ve){if(ve.scheme!==T.scheme)return;const G=ve.fragment.indexOf("s");if(G<0)return;const U=parseInt(ve.fragment.substring(0,G).replace(q,""),me),K=(0,C.$Yd)(ve.fragment.substring(G+1)).toString();if(!isNaN(U))return{handle:U,notebook:ve.with({scheme:K,fragment:null})}}T.parse=X;function V(ve,G){return ve.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${ve.scheme!==R.Schemas.file?ve.scheme:""}`})}T.generateCellOutputUri=V;function x(ve){if(ve.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ve.fragment);if(!G)return;const U=G[1]&&G[1]!==""?G[1]:void 0,K=G[2];return{outputId:U,notebook:ve.with({scheme:K||R.Schemas.file,fragment:null})}}T.parseCellOutputUri=x;function ge(ve,G,U){return T.generate(ve,G).with({scheme:U})}T.generateCellPropertyUri=ge;function ue(ve,G){if(ve.scheme===G)return T.parse(ve.with({scheme:T.scheme}))}T.parseCellPropertyUri=ue})(l||(e.CellUri=l={}));const b=T=>E.$i?T.replace(/\//g,"\\"):T;class h{constructor(H=[],q=e.$ZH){this.e=q,this.d=[...new Set(H)].map(me=>({pattern:me,matches:F.$rj(b(me))}))}sort(H){const q=new Map(f.Iterable.map(H,Z=>[Z,b(Z)]));let me=[];for(const{matches:Z}of this.d)for(const[X,V]of q)if(Z(V)){me.push(X),q.delete(X);break}return q.size&&(me=me.concat([...q.keys()].sort((Z,X)=>this.e.indexOf(Z)-this.e.indexOf(X)))),me}prioritize(H,q){const me=this.f(H);if(me===-1){this.d.unshift({pattern:H,matches:F.$rj(b(H))});return}const Z=new Set(q.map(V=>this.f(V,me)));Z.delete(-1);const X=Array.from(Z).sort();this.d.splice(me+1,0,...X.map(V=>this.d[V]));for(let V=X.length-1;V>=0;V--)this.d.splice(X[V],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,q=this.d.length){const me=b(H);for(let Z=0;Z<q;Z++)if(this.d[Z].matches(me))return Z;return-1}}e.$4H=h;function t(T,H,q,me=(Z,X)=>Z===X){const Z=[];function X(ge,ue,ve){if(ue===0&&ve.length===0)return;const G=Z[Z.length-1];G&&G.start+G.deleteCount===ge?(G.deleteCount+=ue,G.toInsert.push(...ve)):Z.push({start:ge,deleteCount:ue,toInsert:ve})}let V=0,x=0;for(;;){if(V===T.length){X(V,0,H.slice(x));break}if(x===H.length){X(V,T.length-V,[]);break}const ge=T[V],ue=H[x];if(me(ge,ue)){V+=1,x+=1;continue}q(ue)?(X(V,1,[]),V+=1):(X(V,0,[ue]),x+=1)}return Z}e.$5H=t,e.$6H=new p.$2i("notebookEditorCursorAtBoundary","none"),e.$7H=new p.$2i("notebookEditorCursorAtLineBoundary","none");var r;(function(T){T.default="default",T.option="option"})(r||(e.NotebookEditorPriority=r={}));function a(T){const H=T;return!!((typeof H.include=="string"||F.$sj(H.include))&&(typeof H.exclude=="string"||F.$sj(H.exclude)))}e.$8H=a;function i(T,H,q){if(Array.isArray(T.viewType)&&T.viewType.indexOf(H)>=0||T.viewType===H)return!0;if(T.filenamePattern){const me=a(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,Z=a(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(F.$qj(me,(0,$.$ae)(q.fsPath).toLowerCase()))return!(Z&&F.$qj(Z,(0,$.$ae)(q.fsPath).toLowerCase()))}return!1}e.$9H=i,e.$0H={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",cellExecutionScroll:"notebook.revealNextOnExecuteBehavior"};var c;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class d{static{this.d="notebook/"}static create(H){return`${d.d}${H}`}static parse(H){if(H.startsWith(d.d))return H.substring(d.d.length)}}e.$$H=d;function y(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.$_H=y;const S=new TextDecoder;function g(T){const H=[];let q=!1;for(const V of T)(H.length===0||q)&&(H.push(V),q=!0);let me=P(H);const Z=C.$Fd.concat(H.map(V=>C.$Fd.wrap(V))),X=z(Z);return me=me||X.byteLength!==Z.byteLength,{data:X,didCompression:me}}e.$aI=g,e.$bI=`${String.fromCharCode(27)}[A`;const u=e.$bI.split("").map(T=>T.charCodeAt(0)),m=10;function P(T){let H=!1;return T.forEach((q,me)=>{if(me===0||q.length<e.$bI.length)return;const Z=T[me-1],X=q.subarray(0,e.$bI.length);if(X[0]===u[0]&&X[1]===u[1]&&X[2]===u[2]){const V=Z.lastIndexOf(m);if(V===-1)return;H=!0,T[me-1]=Z.subarray(0,V),T[me]=q.subarray(e.$bI.length)}}),H}function O(T){let H=T;do T=H,H=T.replace(/[^\n]\x08/gm,"");while(H.length<T.length);return T}function N(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const H=T.match(/^(.*)\r+/m)[1];let q=T.match(/\r+(.*)$/m)[1];q=q+H.slice(q.length,H.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return T}const M="\b".charCodeAt(0),j="\r".charCodeAt(0);function z(T){return!T.buffer.includes(M)&&!T.buffer.includes(j)?T:C.$Fd.fromString(N(O(S.decode(T.buffer))))}}),define(Se[7],De([1,0,19,8,80,28,98,15,18,2,31,25,30,66,108]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D){"use strict";var v,o,s,n,l,b,h,t,r,a,i,c,d,y,S,g,u,m;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$QL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.TestRunProfileKind=e.TestResultState=e.$xL=e.$wL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$vL=e.$uL=e.$tL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$sL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.ColorThemeKind=e.$mL=e.$lL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$kL=e.DebugConsoleMode=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$eL=e.$dL=e.FileChangeType=e.$cL=e.$bL=e.$aL=e.$_K=e.InlineCompletionTriggerKind=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.ConfigurationTarget=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$OK=e.ViewBadge=e.ProgressLocation=e.$NK=e.$MK=e.TaskScope=e.ShellQuoting=e.$LK=e.$KK=e.$JK=e.TaskPanelKind=e.TaskRevealKind=e.$IK=e.TerminalLocation=e.$HK=e.$GK=e.$FK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$EK=e.$DK=e.$CK=e.$BK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$AK=e.StatusBarAlignment=e.ViewColumn=e.$zK=e.$yK=e.$xK=e.$wK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$vK=e.$uK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.LanguageStatusSeverity=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.CodeActionTriggerKind=e.$iK=e.$hK=e.SymbolTag=e.SymbolKind=e.$gK=e.DocumentHighlightKind=e.$fK=e.$eK=e.$dK=e.$cK=e.DiagnosticSeverity=e.DiagnosticTag=e.$bK=e.$aK=e.FileEditType=e.$_J=e.$$J=e.$0J=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(J){return Object.assign(J,{apply:function(...we){if(we.length===0)return Reflect.construct(J,[]);{const Re=we.length===1?[]:we[1];return Reflect.construct(J,Re,we[0].constructor)}},call:function(...we){if(we.length===0)return Reflect.construct(J,[]);{const[Re,...Ye]=we;return Reflect.construct(J,Ye,Re.constructor)}}})}var O;(function(J){J[J.Top=0]="Top",J[J.Bottom=1]="Bottom"})(O||(e.TerminalOutputAnchor=O={}));var N;(function(J){J[J.TerminalCommand=0]="TerminalCommand",J[J.Opener=1]="Opener",J[J.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let M=v=class{static from(...W){let we=W;return new v(function(){if(we){for(const Re of we)Re&&typeof Re.dispose=="function"&&Re.dispose();we=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$3J=M,e.$3J=M=v=Ke([P],M);let j=o=class{static Min(...W){if(W.length===0)throw new TypeError;let we=W[0];for(let Re=1;Re<W.length;Re++){const Ye=W[Re];Ye.isBefore(we)&&(we=Ye)}return we}static Max(...W){if(W.length===0)throw new TypeError;let we=W[0];for(let Re=1;Re<W.length;Re++){const Ye=W[Re];Ye.isAfter(we)&&(we=Ye)}return we}static isPosition(W){if(!W)return!1;if(W instanceof o)return!0;const{line:we,character:Re}=W;return typeof we=="number"&&typeof Re=="number"}static of(W){if(W instanceof o)return W;if(this.isPosition(W))return new o(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,we){if(W<0)throw(0,F.$5)("line must be non-negative");if(we<0)throw(0,F.$5)("character must be non-negative");this.c=W,this.e=we}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,we=0){if(W===null||we===null)throw(0,F.$5)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,we=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&we===0?this:new o(this.line+Re,this.character+we)}with(W,we=this.character){if(W===null||we===null)throw(0,F.$5)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,we=typeof W.character=="number"?W.character:this.character),Re===this.line&&we===this.character?this:new o(Re,we)}toJSON(){return{line:this.line,character:this.character}}};e.$4J=j,e.$4J=j=o=Ke([P],j);let z=s=class{static isRange(W){return W instanceof s?!0:W?j.isPosition(W.start)&&j.isPosition(W.end):!1}static of(W){if(W instanceof s)return W;if(this.isRange(W))return new s(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,we,Re,Ye){let tt,ct;if(typeof W=="number"&&typeof we=="number"&&typeof Re=="number"&&typeof Ye=="number"?(tt=new j(W,we),ct=new j(Re,Ye)):j.isPosition(W)&&j.isPosition(we)&&(tt=j.of(W),ct=j.of(we)),!tt||!ct)throw new Error("Invalid arguments");tt.isBefore(ct)?(this.c=tt,this.e=ct):(this.c=ct,this.e=tt)}contains(W){return s.isRange(W)?this.contains(W.start)&&this.contains(W.end):j.isPosition(W)?!(j.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const we=j.Max(W.start,this.c),Re=j.Min(W.end,this.e);if(!we.isAfter(Re))return new s(we,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const we=j.Min(W.start,this.c),Re=j.Max(W.end,this.end);return new s(we,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,we=this.end){if(W===null||we===null)throw(0,F.$5)();let Re;return W?j.isPosition(W)?Re=W:(Re=W.start||this.start,we=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&we.isEqual(this.end)?this:new s(Re,we)}toJSON(){return[this.start,this.end]}};e.$5J=z,e.$5J=z=s=Ke([P],z);let T=n=class extends z{static isSelection(W){return W instanceof n?!0:W?z.isRange(W)&&j.isPosition(W.anchor)&&j.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,we,Re,Ye){let tt,ct;if(typeof W=="number"&&typeof we=="number"&&typeof Re=="number"&&typeof Ye=="number"?(tt=new j(W,we),ct=new j(Re,Ye)):j.isPosition(W)&&j.isPosition(we)&&(tt=j.of(W),ct=j.of(we)),!tt||!ct)throw new Error("Invalid arguments");super(tt,ct),this.f=tt,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$6J=T,e.$6J=T=n=Ke([P],T);const H=J=>{if(typeof J!="string"||J.length===0||!/^[0-9A-Za-z_\-]+$/.test(J))throw(0,F.$5)("connectionToken")};class q{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,we,Re){if(typeof W!="string"||W.length===0)throw(0,F.$5)("host");if(typeof we!="number"||we===0||Math.round(we)!==we)throw(0,F.$5)("port");typeof Re<"u"&&H(Re),this.host=W,this.port=Math.round(we),this.connectionToken=Re}}e.$7J=q;class me{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,we){this.makeConnection=W,this.connectionToken=we,typeof we<"u"&&H(we)}}e.$8J=me;class Z extends Error{static NotAvailable(W,we){return new Z(W,k.RemoteAuthorityResolverErrorCode.NotAvailable,we)}static TemporarilyNotAvailable(W){return new Z(W,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,we=k.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=we,this._detail=Re,Object.setPrototypeOf(this,Z.prototype)}}e.$9J=Z;var X;(function(J){J[J.LF=1]="LF",J[J.CRLF=2]="CRLF"})(X||(e.EndOfLine=X={}));var V;(function(J){J[J.Replace=1]="Replace",J[J.Append=2]="Append",J[J.Prepend=3]="Prepend"})(V||(e.EnvironmentVariableMutatorType=V={}));let x=l=class{static isTextEdit(W){return W instanceof l?!0:W?z.isRange(W)&&typeof W.newText=="string":!1}static replace(W,we){return new l(W,we)}static insert(W,we){return l.replace(new z(W,W),we)}static delete(W){return l.replace(W,"")}static setEndOfLine(W){const we=new l(new z(new j(0,0),new j(0,0)),"");return we.newEol=W,we}get range(){return this.c}set range(W){if(W&&!z.isRange(W))throw(0,F.$5)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,F.$5)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,F.$5)("newEol");this.f=W}constructor(W,we){this.c=W,this.e=we}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$0J=x,e.$0J=x=l=Ke([P],x);let ge=b=class{static isNotebookCellEdit(W){return W instanceof b?!0:W?_t.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,we){return new b(W,we)}static insertCells(W,we){return new b(new _t(W,W),we)}static deleteCells(W){return new b(W,[])}static updateCellMetadata(W,we){const Re=new b(new _t(W,W),[]);return Re.newCellMetadata=we,Re}static updateNotebookMetadata(W){const we=new b(new _t(0,0),[]);return we.newNotebookMetadata=W,we}constructor(W,we){this.range=W,this.newCells=we}};e.$$J=ge,e.$$J=ge=b=Ke([P],ge);class ue{static isSnippetTextEdit(W){return W instanceof ue?!0:W?z.isRange(W.range)&&U.isSnippetString(W.snippet):!1}static replace(W,we){return new ue(W,we)}static insert(W,we){return ue.replace(new z(W,W),we)}constructor(W,we){this.range=W,this.snippet=we}}e.$_J=ue;var ve;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.Cell=3]="Cell",J[J.CellReplace=5]="CellReplace",J[J.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let G=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,we,Re,Ye){this.c.push({_type:1,from:W,to:we,options:Re,metadata:Ye})}createFile(W,we,Re){this.c.push({_type:1,from:void 0,to:W,options:we,metadata:Re})}deleteFile(W,we,Re){this.c.push({_type:1,from:W,to:void 0,options:we,metadata:Re})}e(W,we,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:we},notebookMetadata:we})}f(W,we,Re,Ye){const tt=we.start,ct=we.end;(tt!==ct||Re.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:ct-tt,cells:Re,metadata:Ye})}g(W,we,Re,Ye){this.c.push({_type:3,metadata:Ye,uri:W,edit:{editType:3,index:we,metadata:Re}})}replace(W,we,Re,Ye){this.c.push({_type:2,uri:W,edit:new x(we,Re),metadata:Ye})}insert(W,we,Re,Ye){this.replace(W,new z(we,we),Re,Ye)}delete(W,we,Re){this.replace(W,we,"",Re)}has(W){return this.c.some(we=>we._type===2&&we.uri.toString()===W.toString())}set(W,we){if(we)for(const Re of we){if(!Re)continue;let Ye,tt;Array.isArray(Re)?(Ye=Re[0],tt=Re[1]):Ye=Re,ge.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(W,Ye.range.start,Ye.newCellMetadata,tt):Ye.newNotebookMetadata?this.e(W,Ye.newNotebookMetadata,tt):this.f(W,Ye.range,Ye.newCells,tt):ue.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:W,range:Ye.range,edit:Ye.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Ye,metadata:tt})}else{for(let Re=0;Re<this.c.length;Re++){const Ye=this.c[Re];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,C.$Gb)(this.c)}}get(W){const we=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&we.push(Re.edit);return we}entries(){const W=new L.$zi;for(const we of this.c)if(we._type===2){let Re=W.get(we.uri);Re||(Re=[we.uri,[]],W.set(we.uri,Re)),Re[1].push(we.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$aK=G,e.$aK=G=Ke([P],G);let U=h=class{static isSnippetString(W){return W instanceof h?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=h.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,we=this.e++){if(typeof W=="function"){const Re=new h;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=h.c(W);return this.value+="${",this.value+=we,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,we=this.e++){const Re=W.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=we,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,we){if(typeof we=="function"){const Re=new h;Re.e=this.e,we(Re),this.e=Re.e,we=Re.value}else typeof we=="string"&&(we=we.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,we&&(this.value+=":",this.value+=we),this.value+="}",this}};e.$bK=U,e.$bK=U=h=Ke([P],U);var K;(function(J){J[J.Unnecessary=1]="Unnecessary",J[J.Deprecated=2]="Deprecated"})(K||(e.DiagnosticTag=K={}));var fe;(function(J){J[J.Hint=3]="Hint",J[J.Information=2]="Information",J[J.Warning=1]="Warning",J[J.Error=0]="Error"})(fe||(e.DiagnosticSeverity=fe={}));let te=t=class{static isLocation(W){return W instanceof t?!0:W?z.isRange(W.range)&&p.URI.isUri(W.uri):!1}constructor(W,we){if(this.uri=W,we)if(z.isRange(we))this.range=z.of(we);else if(j.isPosition(we))this.range=new z(we,we);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$cK=te,e.$cK=te=t=Ke([P],te);let se=class{static is(W){return W?typeof W.message=="string"&&W.location&&z.isRange(W.location.range)&&p.URI.isUri(W.location.uri):!1}constructor(W,we){this.location=W,this.message=we}static isEqual(W,we){return W===we?!0:!W||!we?!1:W.message===we.message&&W.location.range.isEqual(we.location.range)&&W.location.uri.toString()===we.location.uri.toString()}};e.$dK=se,e.$dK=se=Ke([P],se);let ne=class{constructor(W,we,Re=fe.Error){if(!z.isRange(W))throw new TypeError("range must be set");if(!we)throw new TypeError("message must be set");this.range=W,this.message=we,this.severity=Re}toJSON(){return{severity:fe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,we){return W===we?!0:!W||!we?!1:W.message===we.message&&W.severity===we.severity&&W.code===we.code&&W.severity===we.severity&&W.source===we.source&&W.range.isEqual(we.range)&&(0,C.$sb)(W.tags,we.tags)&&(0,C.$sb)(W.relatedInformation,we.relatedInformation,se.isEqual)}};e.$eK=ne,e.$eK=ne=Ke([P],ne);let Ee=class{constructor(W,we){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=we}};e.$fK=Ee,e.$fK=Ee=Ke([P],Ee);var oe;(function(J){J[J.Text=0]="Text",J[J.Read=1]="Read",J[J.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let he=class{constructor(W,we=oe.Text){this.range=W,this.kind=we}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$gK=he,e.$gK=he=Ke([P],he);var ee;(function(J){J[J.File=0]="File",J[J.Module=1]="Module",J[J.Namespace=2]="Namespace",J[J.Package=3]="Package",J[J.Class=4]="Class",J[J.Method=5]="Method",J[J.Property=6]="Property",J[J.Field=7]="Field",J[J.Constructor=8]="Constructor",J[J.Enum=9]="Enum",J[J.Interface=10]="Interface",J[J.Function=11]="Function",J[J.Variable=12]="Variable",J[J.Constant=13]="Constant",J[J.String=14]="String",J[J.Number=15]="Number",J[J.Boolean=16]="Boolean",J[J.Array=17]="Array",J[J.Object=18]="Object",J[J.Key=19]="Key",J[J.Null=20]="Null",J[J.EnumMember=21]="EnumMember",J[J.Struct=22]="Struct",J[J.Event=23]="Event",J[J.Operator=24]="Operator",J[J.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var le;(function(J){J[J.Deprecated=1]="Deprecated"})(le||(e.SymbolTag=le={}));let be=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,we,Re,Ye,tt){this.name=W,this.kind=we,this.containerName=tt,typeof Re=="string"&&(this.containerName=Re),Ye instanceof te?this.location=Ye:Re instanceof z&&(this.location=new te(Ye,Re)),r.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$hK=be,e.$hK=be=r=Ke([P],be);let Ie=a=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(a.validate)}constructor(W,we,Re,Ye,tt){this.name=W,this.detail=we,this.kind=Re,this.range=Ye,this.selectionRange=tt,this.children=[],a.validate(this)}};e.$iK=Ie,e.$iK=Ie=a=Ke([P],Ie);var B;(function(J){J[J.Invoke=1]="Invoke",J[J.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let Y=class{constructor(W,we){this.title=W,this.kind=we}};e.$jK=Y,e.$jK=Y=Ke([P],Y);let ie=class{static{i=this}static{this.c="."}constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.c)}};e.$kK=ie,e.$kK=ie=i=Ke([P],ie),ie.Empty=new ie(""),ie.QuickFix=ie.Empty.append("quickfix"),ie.Refactor=ie.Empty.append("refactor"),ie.RefactorExtract=ie.Refactor.append("extract"),ie.RefactorInline=ie.Refactor.append("inline"),ie.RefactorMove=ie.Refactor.append("move"),ie.RefactorRewrite=ie.Refactor.append("rewrite"),ie.Source=ie.Empty.append("source"),ie.SourceOrganizeImports=ie.Source.append("organizeImports"),ie.SourceFixAll=ie.Source.append("fixAll"),ie.Notebook=ie.Empty.append("notebook");let re=class{constructor(W,we){if(this.range=W,this.parent=we,we&&!we.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$lK=re,e.$lK=re=Ke([P],re);class Q{constructor(W,we,Re,Ye,tt,ct){this.kind=W,this.name=we,this.detail=Re,this.uri=Ye,this.range=tt,this.selectionRange=ct}}e.$mK=Q;class de{constructor(W,we){this.fromRanges=we,this.from=W}}e.$nK=de;class ye{constructor(W,we){this.fromRanges=we,this.to=W}}e.$oK=ye;var je;(function(J){J[J.Information=0]="Information",J[J.Warning=1]="Warning",J[J.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(W,we){this.range=W,this.command=we}get isResolved(){return!!this.command}};e.$pK=We,e.$pK=We=Ke([P],We);let _e=c=class{#e;static isMarkdownString(W){return W instanceof c?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,we=!1){this.#e=new f.$Xj(W,{supportThemeIcons:we})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,we){return this.#e.appendCodeblock(we??"",W),this}};e.$qK=_e,e.$qK=_e=c=Ke([P],_e);let Qe=class{constructor(W,we){this.label=W,this.documentation=we}};e.$rK=Qe,e.$rK=Qe=Ke([P],Qe);let it=class{constructor(W,we){this.label=W,this.documentation=we,this.parameters=[]}};e.$sK=it,e.$sK=it=Ke([P],it);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$tK=et,e.$tK=et=Ke([P],et);var Ae;(function(J){J[J.Invoke=1]="Invoke",J[J.TriggerCharacter=2]="TriggerCharacter",J[J.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Oe;(function(J){J[J.Type=1]="Type",J[J.Parameter=2]="Parameter"})(Oe||(e.InlayHintKind=Oe={}));let Ve=class{constructor(W){this.value=W}};e.$uK=Ve,e.$uK=Ve=Ke([P],Ve);let Le=class{constructor(W,we,Re){this.position=W,this.label=we,this.kind=Re}};e.$vK=Le,e.$vK=Le=Ke([P],Le);var Xe;(function(J){J[J.Invoke=0]="Invoke",J[J.TriggerCharacter=1]="TriggerCharacter",J[J.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe||(e.CompletionTriggerKind=Xe={}));var ce;(function(J){J[J.Text=0]="Text",J[J.Method=1]="Method",J[J.Function=2]="Function",J[J.Constructor=3]="Constructor",J[J.Field=4]="Field",J[J.Variable=5]="Variable",J[J.Class=6]="Class",J[J.Interface=7]="Interface",J[J.Module=8]="Module",J[J.Property=9]="Property",J[J.Unit=10]="Unit",J[J.Value=11]="Value",J[J.Enum=12]="Enum",J[J.Keyword=13]="Keyword",J[J.Snippet=14]="Snippet",J[J.Color=15]="Color",J[J.File=16]="File",J[J.Reference=17]="Reference",J[J.Folder=18]="Folder",J[J.EnumMember=19]="EnumMember",J[J.Constant=20]="Constant",J[J.Struct=21]="Struct",J[J.Event=22]="Event",J[J.Operator=23]="Operator",J[J.TypeParameter=24]="TypeParameter",J[J.User=25]="User",J[J.Issue=26]="Issue"})(ce||(e.CompletionItemKind=ce={}));var ae;(function(J){J[J.Deprecated=1]="Deprecated"})(ae||(e.CompletionItemTag=ae={}));let Ce=class{constructor(W,we){this.label=W,this.kind=we}toJSON(){return{label:this.label,kind:this.kind&&ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$wK=Ce,e.$wK=Ce=Ke([P],Ce);let qe=class{constructor(W=[],we=!1){this.items=W,this.isIncomplete=we}};e.$xK=qe,e.$xK=qe=Ke([P],qe);let Ue=class{constructor(W,we,Re){this.insertText=W,this.range=we,this.command=Re}};e.$yK=Ue,e.$yK=Ue=Ke([P],Ue);let Ze=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$zK=Ze,e.$zK=Ze=Ke([P],Ze);var rt;(function(J){J[J.Active=-1]="Active",J[J.Beside=-2]="Beside",J[J.One=1]="One",J[J.Two=2]="Two",J[J.Three=3]="Three",J[J.Four=4]="Four",J[J.Five=5]="Five",J[J.Six=6]="Six",J[J.Seven=7]="Seven",J[J.Eight=8]="Eight",J[J.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var at;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(at||(e.StatusBarAlignment=at={}));function bt(J,W){return`${I.$Vl.toKey(J)}.${W}`}e.$AK=bt;var St;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative"})(St||(e.TextEditorLineNumbersStyle=St={}));var Xt;(function(J){J[J.Manual=1]="Manual",J[J.AfterDelay=2]="AfterDelay",J[J.FocusOut=3]="FocusOut"})(Xt||(e.TextDocumentSaveReason=Xt={}));var Ht;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var pt;(function(J){J[J.Keyboard=1]="Keyboard",J[J.Mouse=2]="Mouse",J[J.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var Ut;(function(J){J[J.Undo=1]="Undo",J[J.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Nt;(function(J){J[J.OpenOpen=0]="OpenOpen",J[J.ClosedClosed=1]="ClosedClosed",J[J.OpenClosed=2]="OpenClosed",J[J.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(J){function W(we){switch(we){case"keyboard":return J.Keyboard;case"mouse":return J.Mouse;case"api":return J.Command}}J.fromValue=W}(pt||(e.TextEditorSelectionChangeKind=pt={}));var Bt;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(J){function W(we){switch(we){case J.Other:return"other";case J.Comment:return"comment";case J.String:return"string";case J.RegEx:return"regex"}return"other"}J.toString=W}(Bt||(e.SyntaxTokenType=Bt={}));let At=class{constructor(W,we){if(we&&!p.URI.isUri(we))throw(0,F.$5)("target");if(!z.isRange(W)||W.isEmpty)throw(0,F.$5)("range");this.range=W,this.target=we}};e.$BK=At,e.$BK=At=Ke([P],At);let Rt=class{constructor(W,we,Re,Ye){this.red=W,this.green=we,this.blue=Re,this.alpha=Ye}};e.$CK=Rt,e.$CK=Rt=Ke([P],Rt);let jt=class{constructor(W,we){if(we&&!(we instanceof Rt))throw(0,F.$5)("color");if(!z.isRange(W)||W.isEmpty)throw(0,F.$5)("range");this.range=W,this.color=we}};e.$DK=jt,e.$DK=jt=Ke([P],jt);let Wt=class{constructor(W){if(!W||typeof W!="string")throw(0,F.$5)("label");this.label=W}};e.$EK=Wt,e.$EK=Wt=Ke([P],Wt);var Kt;(function(J){J[J.RGB=0]="RGB",J[J.HEX=1]="HEX",J[J.HSL=2]="HSL"})(Kt||(e.ColorFormat=Kt={}));var Vt;(function(J){J[J.Error=0]="Error",J[J.Warning=1]="Warning",J[J.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var qt;(function(J){J[J.Unknown=0]="Unknown",J[J.Shutdown=1]="Shutdown",J[J.Process=2]="Process",J[J.User=3]="User",J[J.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ot{constructor(W,we,Re){if(this.startIndex=W,this.length=we,this.tooltip=Re,typeof W!="number"||W<0)throw(0,F.$5)("startIndex");if(typeof we!="number"||we<1)throw(0,F.$5)("length");if(Re!==void 0&&typeof Re!="string")throw(0,F.$5)("tooltip")}}e.$FK=ot;class ft{constructor(W){this.uri=W}}e.$GK=ft;class Lt{constructor(W){this.terminalCommand=W}}e.$HK=Lt;var Mt;(function(J){J[J.Panel=1]="Panel",J[J.Editor=2]="Editor"})(Mt||(e.TerminalLocation=Mt={}));class It{constructor(W){if(this.options=W,typeof W!="object")throw(0,F.$5)("options")}}e.$IK=It;var dt;(function(J){J[J.Always=1]="Always",J[J.Silent=2]="Silent",J[J.Never=3]="Never"})(dt||(e.TaskRevealKind=dt={}));var kt;(function(J){J[J.Shared=1]="Shared",J[J.Dedicated=2]="Dedicated",J[J.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let Dt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(W){switch(W){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(W,we){if(this.label=we,typeof W!="string"||typeof we!="string")throw(0,F.$5)("name");this.c=W}get id(){return this.c}};e.$JK=Dt,e.$JK=Dt=d=Ke([P],Dt);function Ft(J){let W="";for(let we=0;we<J.length;we++)W+=J[we].replace(/,/g,",,")+",";return W}let Ge=class{constructor(W,we,Re){if(typeof W!="string")throw(0,F.$5)("process");this.e=[],this.c=W,we!==void 0&&(Array.isArray(we)?(this.e=we,this.f=Re):this.f=we)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,F.$5)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const we of this.e)W.push(we);return Ft(W)}};e.$KK=Ge,e.$KK=Ge=Ke([P],Ge);let Me=class{constructor(W,we,Re){if(this.f=[],Array.isArray(we)){if(!W)throw(0,F.$5)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$5)("command");this.e=W,this.f=we,this.g=Re}else{if(typeof W!="string")throw(0,F.$5)("commandLine");this.c=W,this.g=we}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,F.$5)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$5)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const we of this.f)W.push(typeof we=="string"?we:we.value);return Ft(W)}};e.$LK=Me,e.$LK=Me=Ke([P],Me);var Fe;(function(J){J[J.Escape=1]="Escape",J[J.Strong=2]="Strong",J[J.Weak=3]="Weak"})(Fe||(e.ShellQuoting=Fe={}));var Pe;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace"})(Pe||(e.TaskScope=Pe={}));class _{constructor(W){this.c=W}computeId(){return"customExecution"+(0,A.$4f)()}set callback(W){this.c=W}get callback(){return this.c}}e.$MK=_;let Te=class{static{y=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,we,Re,Ye,tt,ct){this.j=!1,this.k=this.definition=W;let ht;typeof we=="string"?(this.m=this.name=we,this.t=this.source=Re,this.execution=Ye,ht=tt,this.j=!0):we===Pe.Global||we===Pe.Workspace?(this.target=we,this.m=this.name=Re,this.t=this.source=Ye,this.execution=tt,ht=ct):(this.target=we,this.m=this.name=Re,this.t=this.source=Ye,this.execution=tt,ht=ct),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ge?this.k={type:y.e,id:this.n.computeId()}:this.n instanceof Me?this.k={type:y.f,id:this.n.computeId()}:this.n instanceof _?this.k={type:y.c,id:this.n.computeId()}:this.k={type:y.g,id:(0,A.$4f)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,F.$5)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,F.$5)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const we=this.k.type;(y.g===we||y.e===we||y.f===we||y.c===we)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.$5)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$NK=Te,e.$NK=Te=y=Ke([P],Te);var He;(function(J){J[J.SourceControl=1]="SourceControl",J[J.Window=10]="Window",J[J.Notification=15]="Notification"})(He||(e.ProgressLocation=He={}));var xe;(function(J){function W(we){const Re=we;return(0,E.$nf)(Re.value)?Re.tooltip&&!(0,E.$jf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}J.isViewBadge=W})(xe||(e.ViewBadge=xe={}));let Je=S=class{static isTreeItem(W,we){const Re=W;if(Re.checkboxState!==void 0){const Ye=(0,E.$nf)(Re.checkboxState)?Re.checkboxState:(0,E.$lf)(Re.checkboxState)&&(0,E.$nf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,tt=!(0,E.$nf)(Re.checkboxState)&&(0,E.$lf)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==$t.Checked&&Ye!==$t.Unchecked||tt!==void 0&&!(0,E.$jf)(tt))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof S)return!0;if(Re.label!==void 0&&!(0,E.$jf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,E.$jf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,E.$jf)(Re.iconPath)&&!p.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,E.$jf)(Re.iconPath.id))){const Ye=Re.iconPath;if(!Ye||!(0,E.$jf)(Ye.light)&&!p.URI.isUri(Ye.light)&&!(0,E.$jf)(Ye.dark)&&!p.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,E.$jf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!p.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,E.$jf)(Re.tooltip)&&!(Re.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<nt.None&&Re.collapsibleState>nt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,E.$jf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,we=nt.None){this.collapsibleState=we,p.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$OK=Je,e.$OK=Je=S=Ke([P],Je);var nt;(function(J){J[J.None=0]="None",J[J.Collapsed=1]="Collapsed",J[J.Expanded=2]="Expanded"})(nt||(e.TreeItemCollapsibleState=nt={}));var $t;(function(J){J[J.Unchecked=0]="Unchecked",J[J.Checked=1]="Checked"})($t||(e.TreeItemCheckboxState=$t={}));let Pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$PK=Pt,e.$PK=Pt=Ke([P],Pt);class vt extends Pt{}e.$QK=vt;class lt extends vt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$RK=lt;class mt{constructor(W,we,Re,Ye){this.name=W,this.uri=we,this._itemId=Re,this.c=Ye}data(){return this.c()}}e.$SK=mt;let yt=class{#e=new Map;constructor(W){for(const[we,Re]of W??[]){const Ye=this.#e.get(this.#t(we));Ye?Ye.push(Re):this.#e.set(this.#t(we),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,we){this.#e.set(this.#t(W),[we])}forEach(W,we){for(const[Re,Ye]of this.#e)for(const tt of Ye)W.call(we,tt,Re,this)}*[Symbol.iterator](){for(const[W,we]of this.#e)for(const Re of we)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$TK=yt,e.$TK=yt=Ke([P],yt);let gi=class{constructor(W){this.insertText=W}};e.$UK=gi,e.$UK=gi=Ke([P],gi);let Jt=class{constructor(W,we){this.label=we,this.insertText=W}};e.$VK=Jt,e.$VK=Jt=Ke([P],Jt);let Qt=class{constructor(W,we){this.id=W,this.color=we}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$WK=Qt,e.$WK=Qt=Ke([P],Qt),Qt.File=new Qt("file"),Qt.Folder=new Qt("folder");let si=class{constructor(W){this.id=W}};e.$XK=si,e.$XK=si=Ke([P],si);var ki;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace",J[J.WorkspaceFolder=3]="WorkspaceFolder"})(ki||(e.ConfigurationTarget=ki={}));let Ct=class{get base(){return this.c}set base(W){this.c=W,this.e=p.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,we){if(typeof W!="string"&&(!W||!p.URI.isUri(W)&&!p.URI.isUri(W.uri)))throw(0,F.$5)("base");if(typeof we!="string")throw(0,F.$5)("pattern");typeof W=="string"?this.baseUri=p.URI.file(W):p.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=we}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$YK=Ct,e.$YK=Ct=Ke([P],Ct);const Qi=new WeakMap;function un(J,W){Qi.set(J,W)}e.$ZK=un;let wt=class{constructor(W,we,Re,Ye){this.enabled=typeof W=="boolean"?W:!0,typeof we=="string"&&(this.condition=we),typeof Re=="string"&&(this.hitCondition=Re),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this.c||(this.c=Qi.get(this)??(0,A.$4f)()),this.c}};e.$1K=wt,e.$1K=wt=Ke([P],wt);let mi=class extends wt{constructor(W,we,Re,Ye,tt){if(super(we,Re,Ye,tt),W===null)throw(0,F.$5)("location");this.location=W}};e.$2K=mi,e.$2K=mi=Ke([P],mi);let $i=class extends wt{constructor(W,we,Re,Ye,tt){super(we,Re,Ye,tt),this.functionName=W}};e.$3K=$i,e.$3K=$i=Ke([P],$i);let oi=class extends wt{constructor(W,we,Re,Ye,tt,ct,ht){if(super(Ye,tt,ct,ht),!we)throw(0,F.$5)("dataId");this.label=W,this.dataId=we,this.canPersist=Re}};e.$4K=oi,e.$4K=oi=Ke([P],oi);let Si=class{constructor(W,we,Re){this.command=W,this.args=we||[],this.options=Re}};e.$5K=Si,e.$5K=Si=Ke([P],Si);let Di=class{constructor(W,we){this.port=W,this.host=we}};e.$6K=Di,e.$6K=Di=Ke([P],Di);let Tt=class{constructor(W){this.path=W}};e.$7K=Tt,e.$7K=Tt=Ke([P],Tt);let bi=class{constructor(W){this.implementation=W}};e.$8K=bi,e.$8K=bi=Ke([P],bi);let Ci=class{constructor(W,we,Re){this.session=W,this.threadId=we,this.frameId=Re}};e.$9K=Ci,e.$9K=Ci=Ke([P],Ci);let ai=class{constructor(W,we){this.session=W,this.threadId=we}};e.$0K=ai,e.$0K=ai=Ke([P],ai);let ci=class{constructor(W,we){this.range=W,this.expression=we}};e.$$K=ci,e.$$K=ci=Ke([P],ci);var ut;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(ut||(e.InlineCompletionTriggerKind=ut={}));let Ii=class{constructor(W,we){this.range=W,this.text=we}};e.$_K=Ii,e.$_K=Ii=Ke([P],Ii);let Zt=class{constructor(W,we,Re=!0){this.range=W,this.variableName=we,this.caseSensitiveLookup=Re}};e.$aL=Zt,e.$aL=Zt=Ke([P],Zt);let ii=class{constructor(W,we){this.range=W,this.expression=we}};e.$bL=ii,e.$bL=ii=Ke([P],ii);let pi=class{constructor(W,we){this.frameId=W,this.stoppedLocation=we}};e.$cL=pi,e.$cL=pi=Ke([P],pi);var Zi;(function(J){J[J.Changed=1]="Changed",J[J.Created=2]="Created",J[J.Deleted=3]="Deleted"})(Zi||(e.FileChangeType=Zi={}));let Pi=g=class extends Error{static FileExists(W){return new g(W,w.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(W){return new g(W,w.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(W){return new g(W,w.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(W){return new g(W,w.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(W){return new g(W,w.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(W){return new g(W,w.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(W,we=w.FileSystemProviderErrorCode.Unknown,Re){super(p.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,w.$hk)(this,we),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$dL=Pi,e.$dL=Pi=g=Ke([P],Pi);let Ai=class{constructor(W,we,Re){this.start=W,this.end=we,this.kind=Re}};e.$eL=Ai,e.$eL=Ai=Ke([P],Ai);var Ri;(function(J){J[J.Comment=1]="Comment",J[J.Imports=2]="Imports",J[J.Region=3]="Region"})(Ri||(e.FoldingRangeKind=Ri={}));var xi;(function(J){J[J.Collapsed=0]="Collapsed",J[J.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Li;(function(J){J[J.Editing=0]="Editing",J[J.Preview=1]="Preview"})(Li||(e.CommentMode=Li={}));var ui;(function(J){J[J.Published=0]="Published",J[J.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var _i;(function(J){J[J.Unresolved=0]="Unresolved",J[J.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Mi{constructor(W,we=[]){this.tokenTypes=W,this.tokenModifiers=we}}e.$fL=Mi;function Fi(J){return typeof J>"u"||(0,E.$kf)(J)}class Ti{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let we=0,Re=W.tokenTypes.length;we<Re;we++)this.j.set(W.tokenTypes[we],we);for(let we=0,Re=W.tokenModifiers.length;we<Re;we++)this.k.set(W.tokenModifiers[we],we)}}push(W,we,Re,Ye,tt){if(typeof W=="number"&&typeof we=="number"&&typeof Re=="number"&&typeof Ye=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,we,Re,Ye,tt);if(z.isRange(W)&&typeof we=="string"&&Fi(Re))return this.m(W,we,Re);throw(0,F.$5)()}m(W,we,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(we))throw new Error("`tokenType` is not in the provided legend");const Ye=W.start.line,tt=W.start.character,ct=W.end.character-W.start.character,ht=this.j.get(we);let zt=0;if(Re)for(const Yt of Re){if(!this.k.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Yt);zt|=1<<xt>>>0}this.n(Ye,tt,ct,ht,zt)}n(W,we,Re,Ye,tt){if(this.f&&(W<this.c||W===this.c&&we<this.e)){this.f=!1;const zt=this.g.length/5|0;let Yt=0,xt=0;for(let ti=0;ti<zt;ti++){let ri=this.g[5*ti],Yi=this.g[5*ti+1];ri===0?(ri=Yt,Yi+=xt):ri+=Yt,this.g[5*ti]=ri,this.g[5*ti+1]=Yi,Yt=ri,xt=Yi}}let ct=W,ht=we;this.f&&this.h>0&&(ct-=this.c,ct===0&&(ht-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=ht,this.g[this.h++]=Re,this.g[this.h++]=Ye,this.g[this.h++]=tt,this.c=W,this.e=we}static o(W){const we=[],Re=W.length/5|0;for(let ht=0;ht<Re;ht++)we[ht]=ht;we.sort((ht,zt)=>{const Yt=W[5*ht],xt=W[5*zt];if(Yt===xt){const ti=W[5*ht+1],ri=W[5*zt+1];return ti-ri}return Yt-xt});const Ye=new Uint32Array(W.length);let tt=0,ct=0;for(let ht=0;ht<Re;ht++){const zt=5*we[ht],Yt=W[zt+0],xt=W[zt+1],ti=W[zt+2],ri=W[zt+3],Yi=W[zt+4],En=Yt-tt,Ln=En===0?xt-ct:xt,Xi=5*ht;Ye[Xi+0]=En,Ye[Xi+1]=Ln,Ye[Xi+2]=ti,Ye[Xi+3]=ri,Ye[Xi+4]=Yi,tt=Yt,ct=xt}return Ye}build(W){return this.f?new Oi(new Uint32Array(this.g),W):new Oi(Ti.o(this.g),W)}}e.$gL=Ti;class Oi{constructor(W,we){this.resultId=we,this.data=W}}e.$hL=Oi;class hi{constructor(W,we,Re){this.start=W,this.deleteCount=we,this.data=Re}}e.$iL=hi;class ln{constructor(W,we){this.resultId=we,this.edits=W}}e.$jL=ln;var en;(function(J){J[J.Separate=0]="Separate",J[J.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let Ni=class{static{this.Back={iconPath:new Qt("arrow-left")}}constructor(){}};e.$kL=Ni,e.$kL=Ni=Ke([P],Ni);var di;(function(J){J[J.Separator=-1]="Separator",J[J.Default=0]="Default"})(di||(e.QuickPickItemKind=di={}));var tn;(function(J){J[J.Info=1]="Info",J[J.Warning=2]="Warning",J[J.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(J){J[J.UI=1]="UI",J[J.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class hn{static validate(W){if(typeof W.badge=="string"){let we=(0,$.$We)(W.badge,0);if(we<W.badge.length&&(we+=(0,$.$We)(W.badge,we)),W.badge.length>we)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Qt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,we,Re){this.badge=W,this.tooltip=we,this.color=Re}}e.$lL=hn;let ni=class{constructor(W){this.kind=W}};e.$mL=ni,e.$mL=ni=Ke([P],ni);var ji;(function(J){J[J.Light=1]="Light",J[J.Dark=2]="Dark",J[J.HighContrast=3]="HighContrast",J[J.HighContrastLight=4]="HighContrastLight"})(ji||(e.ColorThemeKind=ji={}));class _t{static isNotebookRange(W){return W instanceof _t?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,we){if(W<0)throw(0,F.$5)("start must be positive");if(we<0)throw(0,F.$5)("end must be positive");W<=we?(this.c=W,this.e=we):(this.c=we,this.e=W)}with(W){let we=this.c,Re=this.e;return W.start!==void 0&&(we=W.start),W.end!==void 0&&(Re=W.end),we===this.c&&Re===this.e?this:new _t(we,Re)}}e.$nL=_t;class wi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(we=>wi.isNotebookCellData(we))}static isNotebookCellData(W){return!0}constructor(W,we,Re,Ye,tt,ct,ht){this.kind=W,this.value=we,this.languageId=Re,this.mime=Ye,this.outputs=tt??[],this.metadata=ct,this.executionSummary=ht,wi.validate(this)}}e.$oL=wi;class rn{constructor(W){this.cells=W}}e.$pL=rn;class Gt{static isNotebookCellOutputItem(W){return W instanceof Gt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const we={name:W.name,message:W.message,stack:W.stack};return Gt.json(we,"application/vnd.code.notebook.error")}static stdout(W){return Gt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Gt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,we="application/octet-stream"){return new Gt(W,we)}static#e=new TextEncoder;static text(W,we=R.$Hr.text){const Re=Gt.#e.encode(String(W));return new Gt(Re,we)}static json(W,we="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Gt.text(Re,we)}constructor(W,we){this.data=W,this.mime=we;const Re=(0,R.$Lr)(we,!0);if(!Re)throw new Error(`INVALID mime type: ${we}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$qL=Gt;class vi{static isNotebookCellOutput(W){return W instanceof vi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,we=!1){const Re=new Set,Ye=new Set;for(let tt=0;tt<W.length;tt++){const ct=W[tt],ht=(0,R.$Lr)(ct.mime);if(!Re.has(ht)||(0,D.$_H)(ht)){Re.add(ht);continue}Ye.add(tt),we&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ye.size===0?W:W.filter((tt,ct)=>!Ye.has(ct))}constructor(W,we,Re){this.items=vi.ensureUniqueMimeTypes(W,!0),typeof we=="string"?(this.id=we,this.metadata=Re):(this.id=(0,A.$4f)(),this.metadata=we??Re)}}e.$rL=vi;var sn;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var yi;(function(J){J[J.Idle=1]="Idle",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(yi||(e.NotebookCellExecutionState=yi={}));var zi;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(zi||(e.NotebookCellStatusBarAlignment=zi={}));var ze;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(ze||(e.NotebookEditorRevealType=ze={}));class ei{constructor(W,we){this.text=W,this.alignment=we}}e.$sL=ei;var Ui;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred"})(Ui||(e.NotebookControllerAffinity=Ui={}));var gt;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred",J[J.Hidden=-1]="Hidden"})(gt||(e.NotebookControllerAffinity2=gt={}));class dn{constructor(W,we=[]){this.uri=W,this.provides=(0,C.$1b)(we)}}e.$tL=dn;class fn{constructor(W){this.label=W}}e.$uL=fn;let Ei=class{constructor(W,we){this.label=W,this.timestamp=we}};e.$vL=Ei,e.$vL=Ei=Ke([P],Ei);var on;(function(J){J[J.Production=1]="Production",J[J.Development=2]="Development",J[J.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var fi;(function(J){J[J.Node=1]="Node",J[J.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var an;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class gn{constructor(W,we){this.ranges=W,this.wordPattern=we}}e.$wL=gn;class mn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$xL=mn;var Bi;(function(J){J[J.Queued=1]="Queued",J[J.Running=2]="Running",J[J.Passed=3]="Passed",J[J.Failed=4]="Failed",J[J.Skipped=5]="Skipped",J[J.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(J){J[J.Run=1]="Run",J[J.Debug=2]="Debug",J[J.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Wi=class{constructor(W=void 0,we=void 0,Re=void 0,Ye=!1){this.include=W,this.exclude=we,this.profile=Re,this.continuous=Ye}};e.$yL=Wi,e.$yL=Wi=Ke([P],Wi);let Vi=u=class{static diff(W,we,Re){const Ye=new u(W);return Ye.expectedOutput=we,Ye.actualOutput=Re,Ye}constructor(W){this.message=W}};e.$zL=Vi,e.$zL=Vi=u=Ke([P],Vi);let qi=class{constructor(W){this.id=W}};e.$AL=qi,e.$AL=qi=Ke([P],qi);let li=class{constructor(W,we){this.covered=W,this.total=we}};e.$BL=li,e.$BL=li=Ke([P],li);let Hi=m=class{static fromDetails(W,we){const Re=new li(0,0),Ye=new li(0,0),tt=new li(0,0);for(const ht of we)if("branches"in ht){Re.total+=1,Re.covered+=ht.executionCount>0?1:0;for(const zt of ht.branches)Ye.total+=1,Ye.covered+=zt.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const ct=new m(W,Re,Ye.total>0?Ye:void 0,tt.total>0?tt:void 0);return ct.detailedCoverage=we,ct}constructor(W,we,Re,Ye){this.uri=W,this.statementCoverage=we,this.branchCoverage=Re,this.functionCoverage=Ye}};e.$CL=Hi,e.$CL=Hi=m=Ke([P],Hi);let Ki=class{constructor(W,we,Re=[]){this.executionCount=W,this.location=we,this.branches=Re}};e.$DL=Ki,e.$DL=Ki=Ke([P],Ki);let Ji=class{constructor(W,we){this.executionCount=W,this.location=we}};e.$EL=Ji,e.$EL=Ji=Ke([P],Ji);let Gi=class{constructor(W,we){this.executionCount=W,this.location=we}};e.$FL=Gi,e.$FL=Gi=Ke([P],Gi);var pe;(function(J){J[J.None=0]="None",J[J.Option=1]="Option",J[J.Default=2]="Default",J[J.Preferred=3]="Preferred"})(pe||(e.ExternalUriOpenerPriority=pe={}));var ke;(function(J){J[J.Untrusted=0]="Untrusted",J[J.Trusted=1]="Trusted",J[J.Unspecified=2]="Unspecified"})(ke||(e.WorkspaceTrustState=ke={}));var Ne;(function(J){J[J.Notify=1]="Notify",J[J.OpenBrowser=2]="OpenBrowser",J[J.OpenPreview=3]="OpenPreview",J[J.Silent=4]="Silent",J[J.Ignore=5]="Ignore",J[J.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ne||(e.PortAutoForwardAction=Ne={}));class st{constructor(W,we,Re,Ye,tt,ct){this.kind=W,this.name=we,this.detail=Re,this.uri=Ye,this.range=tt,this.selectionRange=ct}}e.$GL=st;class Et{constructor(W){this.uri=W}}e.$HL=Et;class Ot{constructor(W,we){this.original=W,this.modified=we}}e.$IL=Ot;class kn{constructor(W,we,Re,Ye){this.base=W,this.input1=we,this.input2=Re,this.result=Ye}}e.$JL=kn;class Sn{constructor(W,we){this.uri=W,this.viewType=we}}e.$KL=Sn;class Dn{constructor(W){this.viewType=W}}e.$LL=Dn;class Cn{constructor(W,we){this.uri=W,this.notebookType=we}}e.$ML=Cn;class In{constructor(W,we,Re){this.original=W,this.modified=we,this.notebookType=Re}}e.$NL=In;class Pn{constructor(){}}e.$OL=Pn;class An{constructor(W,we){this.uri=W,this.inputBoxUri=we}}e.$PL=An;var $n;(function(J){J[J.Up=1]="Up",J[J.Down=2]="Down"})($n||(e.InteractiveSessionVoteDirection=$n={}));var bn;(function(J){J[J.Action=1]="Action",J[J.Toolbar=2]="Toolbar"})(bn||(e.InteractiveSessionCopyKind=bn={}));var pn;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful",J[J.Undone=2]="Undone",J[J.Accepted=3]="Accepted"})(pn||(e.InteractiveEditorResponseFeedbackKind=pn={}));var wn;(function(J){J[J.System=0]="System",J[J.User=1]="User",J[J.Assistant=2]="Assistant",J[J.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));var vn;(function(J){J[J.Short=1]="Short",J[J.Medium=2]="Medium",J[J.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Rn{constructor(W,we){this.role=W,this.content=we}}e.$QL=Rn;var yn;(function(J){J[J.SymbolInformation=1]="SymbolInformation",J[J.CommandInformation=2]="CommandInformation",J[J.SearchInformation=3]="SearchInformation",J[J.SettingInformation=4]="SettingInformation"})(yn||(e.RelatedInformationType=yn={}))}),define(Se[141],De([1,0,58,17,15,171,124,7,19]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=e.$4L=void 0;const p=new Map;function A(D,v){v?p.set(D,v):p.delete(D)}e.$4L=A;function I(D){return p.get(D)}class w extends L.$Mu{constructor(v,o,s,n,l,b,h,t){super(o,s,n,l),this.c=v,this.m=b,this.q=h,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(v){return(0,E.$sb)(this.f,v)}get document(){if(!this.a){const v=this;this.a={get uri(){return v.d},get fileName(){return v.d.fsPath},get isUntitled(){return v.d.scheme===F.Schemas.untitled},get languageId(){return v.m},get version(){return v.h},get isClosed(){return v.b},get isDirty(){return v.q},save(){return v.r()},getText(o){return o?v.s(o):v.getText()},get eol(){return v.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return v.f.length},lineAt(o){return v.t(o)},offsetAt(o){return v.u(o)},positionAt(o){return v.v(o)},validateRange(o){return v.w(o)},validatePosition(o){return v.x(o)},getWordRangeAtPosition(o,s){return v.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(v){(0,C.ok)(!this.b),this.m=v}_acceptIsDirty(v){(0,C.ok)(!this.b),this.q=v}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(v){const o=this.w(v);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,n=o.start.line,l=o.end.line,b=[];b.push(this.f[n].substring(o.start.character));for(let h=n+1;h<l;h++)b.push(this.f[h]);return b.push(this.f[l].substring(0,o.end.character)),b.join(s)}t(v){let o;if(v instanceof $.$4J?o=v.line:typeof v=="number"&&(o=v),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new k(o,this.f[o],o===this.f.length-1)}u(v){return v=this.x(v),this.l(),this.j.getPrefixSum(v.line-1)+v.character}v(v){v=Math.floor(v),v=Math.max(0,v),this.l();const o=this.j.getIndexOf(v),s=this.f[o.index].length;return new $.$4J(o.index,Math.min(o.remainder,s))}w(v){if(!(v instanceof $.$5J))throw new Error("Invalid argument");const o=this.x(v.start),s=this.x(v.end);return o===v.start&&s===v.end?v:new $.$5J(o.line,o.character,s.line,s.character)}x(v){if(!(v instanceof $.$4J))throw new Error("Invalid argument");if(this.f.length===0)return v.with(0,0);let{line:o,character:s}=v,n=!1;if(o<0)o=0,s=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,n=!0;else{const l=this.f[o].length;s<0?(s=0,n=!0):s>l&&(s=l,n=!0)}return n?new $.$4J(o,s):v}y(v,o){const s=this.x(v);if(!o)o=I(this.m);else if((0,f.$ze)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,R.$Zr)(s.character+1,(0,R.$Xr)(o),this.f[s.line],0);if(n)return new $.$5J(s.line,n.startColumn-1,s.line,n.endColumn-1)}}e.$5L=w;class k{constructor(v,o,s){this.a=v,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$5J(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$5J(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$6L=k}),define(Se[274],De([1,0,7,20,4]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;let L=class{constructor($){this.a=new C.$mL(C.ColorThemeKind.Dark),this.b=new f.$fd}get activeColorTheme(){return this.a}$onColorThemeChange($){let E;switch($){case"light":E=C.ColorThemeKind.Light;break;case"hcDark":E=C.ColorThemeKind.HighContrast;break;case"hcLight":E=C.ColorThemeKind.HighContrastLight;break;default:E=C.ColorThemeKind.Dark}this.a=new C.$mL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Icc=L,e.$Icc=L=Ke([Be(0,F.$2L)],L)}),define(Se[275],De([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dI=e.CellExecutionUpdateType=void 0;var F;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$dI=(0,C.$Bh)("INotebookExecutionService")}),define(Se[69],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(L){L.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class f{static fromExtHostTestItem(R,$,E=R.parent){if(R._isRoot)return new f([$]);const p=[R.id];for(let A=E;A&&A.id!==$;A=A.parent)p.push(A.id);return p.push($),new f(p.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new f(R.split("\0"))}static join(R,$){return new f([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:f.isChild(R,$)?2:f.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new f(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new f(this.path,R)}compare(R){if(typeof R=="string")return f.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$SI=f}),define(Se[88],De([1,0,2,34,69]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$YI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$XI=e.$WI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$VI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$UI=e.$TI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var R;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var $;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$TI=[2,4,8,16,32,64];const E=S=>"runId"in S;e.$UI=E;var p;(function(S){S.serialize=g=>({range:g.range.toJSON(),uri:g.uri.toJSON()}),S.deserialize=g=>({range:F.$ks.lift(g.range),uri:C.URI.revive(g.uri)})})(p||(e.IRichLocation=p={}));var A;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(A||(e.TestMessageType=A={}));var I;(function(S){S.serialize=g=>({message:g.message,type:0,expected:g.expected,actual:g.actual,contextValue:g.contextValue,location:g.location&&p.serialize(g.location)}),S.deserialize=g=>({message:g.message,type:0,expected:g.expected,actual:g.actual,contextValue:g.contextValue,location:g.location&&p.deserialize(g.location)})})(I||(e.ITestErrorMessage=I={}));const w=(S,g)=>`${g?"s":"e"}${S}`;e.$VI=w;var k;(function(S){S.serialize=g=>({message:g.message,type:1,offset:g.offset,length:g.length,location:g.location&&p.serialize(g.location)}),S.deserialize=g=>({message:g.message,type:1,offset:g.offset,length:g.length,location:g.location&&p.deserialize(g.location)})})(k||(e.ITestOutputMessage=k={}));var D;(function(S){S.serialize=g=>g.type===0?I.serialize(g):k.serialize(g),S.deserialize=g=>g.type===0?I.deserialize(g):k.deserialize(g)})(D||(e.ITestMessage=D={}));var v;(function(S){S.serializeWithoutMessages=g=>({state:g.state,duration:g.duration,messages:[]}),S.serialize=g=>({state:g.state,duration:g.duration,messages:g.messages.map(D.serialize)}),S.deserialize=g=>({state:g.state,duration:g.duration,messages:g.messages.map(D.deserialize)})})(v||(e.ITestTaskState=v={}));const o="\0",s=(S,g)=>S+o+g;e.$WI=s;const n=S=>{const g=S.indexOf(o);return{ctrlId:S.slice(0,g),tagId:S.slice(g+1)}};e.$XI=n;var l;(function(S){S.serialize=g=>({extId:g.extId,label:g.label,tags:g.tags,busy:g.busy,children:void 0,uri:g.uri?.toJSON(),range:g.range?.toJSON()||null,description:g.description,error:g.error,sortText:g.sortText}),S.deserialize=g=>({extId:g.extId,label:g.label,tags:g.tags,busy:g.busy,children:void 0,uri:g.uri?C.URI.revive(g.uri):void 0,range:g.range?F.$ks.lift(g.range):null,description:g.description,error:g.error,sortText:g.sortText})})(l||(e.ITestItem=l={}));var b;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(b||(e.TestItemExpandState=b={}));var h;(function(S){S.serialize=g=>({expand:g.expand,item:l.serialize(g.item)}),S.deserialize=g=>({controllerId:f.$SI.root(g.item.extId),expand:g.expand,item:l.deserialize(g.item)})})(h||(e.InternalTestItem=h={}));var t;(function(S){S.serialize=g=>{let u;return g.item&&(u={},g.item.label!==void 0&&(u.label=g.item.label),g.item.tags!==void 0&&(u.tags=g.item.tags),g.item.busy!==void 0&&(u.busy=g.item.busy),g.item.uri!==void 0&&(u.uri=g.item.uri?.toJSON()),g.item.range!==void 0&&(u.range=g.item.range?.toJSON()),g.item.description!==void 0&&(u.description=g.item.description),g.item.error!==void 0&&(u.error=g.item.error),g.item.sortText!==void 0&&(u.sortText=g.item.sortText)),{extId:g.extId,expand:g.expand,item:u}},S.deserialize=g=>{let u;return g.item&&(u={},g.item.label!==void 0&&(u.label=g.item.label),g.item.tags!==void 0&&(u.tags=g.item.tags),g.item.busy!==void 0&&(u.busy=g.item.busy),g.item.range!==void 0&&(u.range=g.item.range?F.$ks.lift(g.item.range):null),g.item.description!==void 0&&(u.description=g.item.description),g.item.error!==void 0&&(u.error=g.item.error),g.item.sortText!==void 0&&(u.sortText=g.item.sortText)),{extId:g.extId,expand:g.expand,item:u}}})(t||(e.ITestItemUpdate=t={}));const r=(S,g)=>{g.expand!==void 0&&(S.expand=g.expand),g.item!==void 0&&(S.item=S.item?Object.assign(S.item,g.item):g.item)};e.$YI=r;var a;(function(S){S.serializeWithoutMessages=g=>({...h.serialize(g),ownComputedState:g.ownComputedState,computedState:g.computedState,tasks:g.tasks.map(v.serializeWithoutMessages)}),S.serialize=g=>({...h.serialize(g),ownComputedState:g.ownComputedState,computedState:g.computedState,tasks:g.tasks.map(v.serialize)}),S.deserialize=g=>({...h.deserialize(g),ownComputedState:g.ownComputedState,computedState:g.computedState,tasks:g.tasks.map(v.deserialize),retired:!0})})(a||(e.TestResultItem=a={}));var i;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(i||(e.DetailType=i={}));var c;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(c||(e.TestDiffOpType=c={}));var d;(function(S){S.deserialize=g=>g.op===0?{op:g.op,item:h.deserialize(g.item)}:g.op===1?{op:g.op,item:t.deserialize(g.item)}:g.op===2?{op:g.op,uri:C.URI.revive(g.uri),docv:g.docv}:g,S.serialize=g=>g.op===0?{op:g.op,item:h.serialize(g.item)}:g.op===1?{op:g.op,item:t.serialize(g.item)}:g})(d||(e.TestsDiffOp=d={}));class y{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(g){const u=this.p();for(const m of g)switch(m.op){case 0:this.k(h.deserialize(m.item),u);break;case 1:this.l(t.deserialize(m.item),u);break;case 3:this.m(m.itemId,u);break;case 5:this.o(m.itemId);break;case 4:this.updatePendingRoots(m.amount);break;case 6:this.d.set(m.tag.id,m.tag);break;case 7:this.d.delete(m.id);break}u.complete?.()}k(g,u){const m=f.$SI.parentId(g.item.extId)?.toString();let P;if(!m)P=this.q(g),this.g.add(P),this.f.set(g.item.extId,P);else if(this.f.has(m)){const O=this.f.get(m);O.children.add(g.item.extId),P=this.q(g,O),this.f.set(g.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(g)}`);return}return u.add?.(P),g.expand===2&&this.h++,P}l(g,u){const m=this.f.get(g.extId);if(m)return g.expand!==void 0&&(m.expand===2&&this.h--,g.expand===2&&this.h++),(0,e.$YI)(m,g),u.update?.(m),m}m(g,u){const m=this.f.get(g);if(!m)return;const P=f.$SI.parentId(m.item.extId)?.toString();P?this.f.get(P).children.delete(m.item.extId):this.g.delete(m);const O=[[g]];for(;O.length;)for(const N of O.pop()){const M=this.f.get(N);M&&(O.push(M.children),this.f.delete(N),u.remove?.(M,M!==m),M.expand===2&&this.h--)}}o(g){}updatePendingRoots(g){this.j+=g}p(){return{}}}e.$ZI=y}),define(Se[109],De([1,0,9,4,3,58,88,69]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.TestItemEventOp=void 0;var E;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const p=(n,l)=>n===l,I=Object.entries({range:(n,l)=>n===l?!0:!n||!l?!1:n.equalsRange(l),busy:p,label:p,description:p,error:p,sortText:p,tags:(n,l)=>!(n.length!==l.length||n.some(b=>!l.includes(b)))}),w=(n,l)=>{let b;for(const[h,t]of I)t(n[h],l[h])||(b?b[h]=l[h]:b={[h]:l[h]});return b};class k extends f.$kc{get root(){return this.s.root}constructor(l){super(),this.s=l,this.f=this.B(new C.$Sg(()=>this.flushDiff(),200)),this.g=this.B(new F.$fd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(l){this.h=l;for(const b of this.tree.values())this.I(b)}get resolveHandler(){return this.h}collectDiff(){const l=this.m;return this.m=[],l}pushDiff(l){switch(l.op){case 2:{for(const b of this.m)if(b.op===2&&b.uri===l.uri){b.docv=l.docv;return}break}case 1:{const b=this.m[this.m.length-1];if(b){if(b.op===1&&b.item.extId===l.item.extId){(0,R.$YI)(b.item,l.item);return}if(b.op===0&&b.item.item.extId===l.item.extId){(0,R.$YI)(b.item,l.item);return}}break}}this.m.push(l),this.f.isScheduled()||this.f.schedule()}expand(l,b){const h=this.tree.get(l);if(h){if((h.expandLevels===void 0||b>h.expandLevels)&&(h.expandLevels=b),h.expand===1){const t=this.L(h);return t.isOpen()?this.J(h,b-1):t.wait().then(()=>this.J(h,b-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,b-1)):this.J(h,b-1)}}dispose(){for(const l of this.tree.values())this.s.getApiFor(l.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(l,b){switch(b.op){case 3:this.N($.$SI.joinToString(l.fullId,b.id));break;case 0:this.y(b.item,l);break;case 5:for(const h of b.ops)this.u(l,h);break;case 1:this.z(b.new,b.old,l.fullId.toString());break;case 2:this.I(l);break;case 4:this.pushDiff({op:1,item:{extId:l.fullId.toString(),item:b.update}});break;case 6:this.w(l.actual.uri);break;default:(0,L.$vc)(b)}}w(l){l&&this.pushDiff({op:2,uri:l,docv:this.s.getDocumentVersion(l)})}y(l,b){const h=$.$SI.fromExtHostTestItem(l,this.root.id,b?.actual),t=this.s.getApiFor(l);t.parent&&t.parent!==b?.actual&&this.s.getChildren(t.parent).delete(l.id);let r=this.tree.get(h.toString());if(!r){r={fullId:h,actual:l,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},l.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(l,b),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(l)}}),this.H(l,r,b);return}if(r.actual===l){this.G(l,r,b);return}if(r.actual.uri?.toString()!==l.uri?.toString())return this.N(h.toString()),this.y(l,b);const a=this.s.getChildren(r.actual),i=r.actual,c=w(this.s.toITestItem(i),this.s.toITestItem(l));this.s.getApiFor(i).listener=void 0,r.actual=l,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.z(l.tags,i.tags,h.toString()),delete c.tags),this.u(r,{op:4,update:c})),this.H(l,r,b);for(const[d,y]of a)this.s.getChildren(l).get(y.id)||this.N($.$SI.joinToString(h,y.id));this.w(r.actual.uri)}z(l,b,h){const t=new Set(b.map(r=>r.id));for(const r of l)t.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:h,item:{tags:l.map(r=>(0,R.$WI)(this.s.controllerId,r.id))}}}),t.forEach(this.D,this)}C(l){const b=this.j.get(l.id);b?b.refCount++:(this.j.set(l.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$WI)(this.s.controllerId,l.id)}}))}D(l){const b=this.j.get(l);b&&!--b.refCount&&(this.j.delete(l),this.pushDiff({op:7,id:(0,R.$WI)(this.s.controllerId,l)}))}F(l,b){this.s.getApiFor(l).parent=b&&b.actual!==this.root?b.actual:void 0}G(l,b,h){this.F(l,h);const t=this.s.getApiFor(l);t.parent=h?.actual,t.listener=r=>this.u(b,r),this.I(b)}H(l,b,h){this.G(l,b,h);for(const[t,r]of this.s.getChildren(l))this.y(r,b)}I(l){let b;this.h?l.resolveBarrier?b=l.resolveBarrier.isOpen()?3:2:b=l.actual.canResolveChildren?1:0:b=0,b!==l.expand&&(l.expand=b,this.pushDiff({op:1,item:{extId:l.fullId.toString(),expand:b}}),b===1&&l.expandLevels!==void 0&&this.L(l))}J(l,b){if(b<0)return;const h=[];for(const[t,r]of this.s.getChildren(l.actual)){const a=this.expand($.$SI.joinToString(l.fullId,r.id),b);(0,C.$tg)(a)&&h.push(a)}if(h.length)return Promise.all(h).then(()=>{})}L(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this.h){const r=new C.$Fg;return r.open(),r}l.expand=2,this.M(l);const b=l.resolveBarrier=new C.$Fg,h=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(l.actual===this.root?void 0:l.actual)}catch(r){h(r)}return(0,C.$tg)(t)?t.catch(h).then(()=>{b.open(),this.I(l)}):(b.open(),this.I(l)),l.resolveBarrier}M(l){this.pushDiff({op:1,item:{extId:l.fullId.toString(),expand:l.expand}})}N(l){const b=this.tree.get(l);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:l});const h=[b];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.D(r.id);this.tree.delete(t.fullId.toString());for(const[r,a]of this.s.getChildren(t.actual))h.push(this.tree.get($.$SI.joinToString(t.fullId,a.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.g.fire(l)}}e.$RL=k;class D extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.$SL=D;class v extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$TL=v;class o extends Error{constructor(l,b,h){super(`TestItem with ID "${l}" is from controller "${b}" and cannot be added as a child of an item from controller "${h}".`)}}e.$UL=o;const s=(n,l,b)=>{let h=new Map;return{get size(){return h.size},forEach(t,r){for(const a of h.values())t.call(r,a,this)},[Symbol.iterator](){return h.entries()},replace(t){const r=new Map,a=new Set(h.keys()),i={op:5,ops:[]};for(const c of t){if(!(c instanceof b))throw new v(c.id);const d=l(c).controllerId;if(d!==n.controllerId)throw new o(c.id,d,n.controllerId);if(r.has(c.id))throw new D(c.id);r.set(c.id,c),a.delete(c.id),i.ops.push({op:0,item:c})}for(const c of a.keys())i.ops.push({op:3,id:c});n.listener?.(i),h=r},add(t){if(!(t instanceof b))throw new v(t.id);h.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){h.delete(t)&&n.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$VL=s}),define(Se[142],De([1,0,109]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=e.$WL=void 0;const F=new WeakMap,f=(R,$)=>{const E={controllerId:$};return F.set(R,E),E};e.$WL=f;const L=R=>{const $=F.get(R);if(!$)throw new C.$TL(R?.id||"<unknown>");return $};e.$XL=L}),define(Se[110],De([1,0,17,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zob=e.$Yob=e.$Xob=e.$Wob=e.$Vob=void 0,e.$Vob="vscode-cdn.net",e.$Wob=`vscode-resource.${e.$Vob}`,e.$Xob=`'self' https://*.${e.$Vob}`;function f($,E){return $.scheme===C.Schemas.http||$.scheme===C.Schemas.https?$:(E&&E.authority&&E.isRemote&&$.scheme===C.Schemas.file&&($=F.URI.from({scheme:C.Schemas.vscodeRemote,authority:E.authority,path:$.path})),F.URI.from({scheme:C.Schemas.https,authority:`${$.scheme}+${L($.authority)}.${e.$Wob}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$Yob=f;function L($){return $.replace(/./g,E=>{const p=E.charCodeAt(0);return p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57?E:"-"+p.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(E,p)=>String.fromCharCode(parseInt(p,16)))}e.$Zob=R}),define(Se[276],De([1,0,4,3,110]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;class L{constructor($,E,p){this.d=$,this.e=E,this.f=p,this.a=0,this.b=new F.$jc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const A=E.getVisibleTextEditors();for(const I of this.c.values())A.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,E,p,A,I){let w;for(const l of this.e.getVisibleTextEditors(!0))if(l.value===$){w=l;break}if(!w)throw new Error("not a visible editor");const k=this,D=this.a++,v=new C.$fd,o=new C.$fd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(l){return(0,f.$Yob)(l,k.f)}get cspSource(){return f.$Xob}set options(l){this.b=l,k.d.$setOptions(D,l)}get options(){return this.b}set html(l){this.a=l,k.d.$setHtml(D,l)}get html(){return this.a}get onDidReceiveMessage(){return v.event}postMessage(l){return k.d.$postMessage(D,l)}},n=new class{constructor(){this.editor=$,this.line=E,this.height=p,this.webview=s,this.onDidDispose=o.event}dispose(){k.c.has(D)&&(k.c.delete(D),k.d.$disposeEditorInset(D),o.fire(),o.dispose(),v.dispose())}};return this.d.$createEditorInset(D,w.id,w.value.document.uri,E+1,p,A||{},I.identifier,I.extensionLocation),this.c.set(D,{editor:$,inset:n,onDidReceiveMessage:v}),n}$onDidDispose($){const E=this.c.get($);E&&E.inset.dispose()}$onDidReceiveMessage($,E){this.c.get($)?.onDidReceiveMessage.fire(E)}}e.$gcc=L}),define(Se[277],De([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.VariableKind=e.$NM=void 0,e.$NM=(0,C.$Bh)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class f extends Error{constructor(R,$){super($),this.variable=R}}e.$OM=f}),define(Se[278],De([1,0,16,47,18,23,12,100,223,277,15]),function($e,e,C,F,f,L,R,$,E,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,D,v,o){this.h=new Map,this.a=k,this.b=D,this.g=v,o&&(this.c=o.then(s=>this.i(s)))}i(k){if(R.$i){const D=Object.create(null);return Object.keys(k).forEach(v=>{D[v.toLowerCase()]=k[v]}),D}return k}resolveWithEnvironment(k,D,v){return this.l({env:this.i(k),userHome:void 0},D?D.uri:void 0,v)}async resolveAsync(k,D){const v={env:await this.c,userHome:await this.g};return this.l(v,k?k.uri:void 0,D)}async j(k,D,v,o){const s=L.$Vm(D);R.$i&&s.windows?Object.keys(s.windows).forEach(l=>s[l]=s.windows[l]):R.$j&&s.osx?Object.keys(s.osx).forEach(l=>s[l]=s.osx[l]):R.$k&&s.linux&&Object.keys(s.linux).forEach(l=>s[l]=s.linux[l]),delete s.windows,delete s.osx,delete s.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,k?k.uri:void 0,s,v,o)}async resolveAnyAsync(k,D,v){return this.j(k,D,v)}async resolveAnyMap(k,D,v){const o=new Map;return{newConfig:await this.j(k,D,v,o),resolvedVariables:o}}resolveWithInteractionReplace(k,D,v,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,D,v,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,D){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,D)}async l(k,D,v,o,s){if(f.$jf(v))return this.m(k,D,v,o,s);if(Array.isArray(v))return Promise.all(v.map(n=>this.l(k,D,n,o,s)));if(f.$lf(v)){const n=Object.create(null),l=await Promise.all(Object.keys(v).map(async b=>[await this.m(k,D,b,o,s),await this.l(k,D,v[b],o,s)]));for(const[b,h]of l)n[b]=h;return n}return v}m(k,D,v,o,s){return(0,A.$Ee)(v,I.VARIABLE_REGEXP,async(n,l)=>{if(l.includes(I.VARIABLE_LHS))return n;let b=await this.o(k,n,l,D,o);return s?.set(l,b),b!==n&&f.$jf(b)&&b.match(I.VARIABLE_REGEXP)&&(b=await this.m(k,D,b,o,s)),b})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,D,v,o,s){let n;const l=v.split(":");l.length>1&&(v=l[0],n=l[1]);const b=r=>{const a=this.a.getFilePath();if(a)return(0,$.$iv)(a);throw new p.$OM(r,(0,E.localize)(0,null,D))},h=r=>{const a=b(r);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,$.$iv)(i)}throw new p.$OM(r,(0,E.localize)(1,null,D,C.$ae(a)))},t=r=>{if(n){const a=this.a.getFolderUri(n);if(a)return a;throw new p.$OM(r,(0,E.localize)(2,null,D,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new p.$OM(r,(0,E.localize)(3,null,D)):new p.$OM(r,(0,E.localize)(4,null,D))};switch(v){case"env":if(n){if(k.env){const r=k.env[R.$i?n.toLowerCase():n];if(f.$jf(r))return r}return""}throw new p.$OM(p.VariableKind.Env,(0,E.localize)(5,null,D));case"config":if(n){const r=this.a.getConfigurationValue(o,n);if(f.$sf(r))throw new p.$OM(p.VariableKind.Config,(0,E.localize)(6,null,D,n));if(f.$lf(r))throw new p.$OM(p.VariableKind.Config,(0,E.localize)(7,null,D,n));return r}throw new p.$OM(p.VariableKind.Config,(0,E.localize)(8,null,D));case"command":return this.p(p.VariableKind.Command,D,n,s,"command");case"input":return this.p(p.VariableKind.Input,D,n,s,"input");case"extensionInstallFolder":if(n){const r=await this.a.getExtension(n);if(!r)throw new p.$OM(p.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,D,n));return this.n(r.extensionLocation)}throw new p.$OM(p.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,D));default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,$.$iv)(this.n(t(p.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,$.$iv)(this.n(t(p.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$iv)(C.$ae(this.n(t(p.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new p.$OM(p.VariableKind.UserHome,(0,E.localize)(11,null,D))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new p.$OM(p.VariableKind.LineNumber,(0,E.localize)(12,null,D))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new p.$OM(p.VariableKind.SelectedText,(0,E.localize)(13,null,D))}case"file":return b(p.VariableKind.File);case"fileWorkspaceFolder":return h(p.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||n?C.$$d(this.n(t(p.VariableKind.RelativeFile)),b(p.VariableKind.RelativeFile)):b(p.VariableKind.RelativeFile);case"relativeFileDirname":{const r=C.$_d(b(p.VariableKind.RelativeFileDirname));if(o||n){const a=C.$$d(this.n(t(p.VariableKind.RelativeFileDirname)),r);return a.length===0?".":a}return r}case"fileDirname":return C.$_d(b(p.VariableKind.FileDirname));case"fileExtname":return C.$be(b(p.VariableKind.FileExtname));case"fileBasename":return C.$ae(b(p.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=C.$ae(b(p.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-C.$be(r).length)}case"fileDirnameBasename":return C.$ae(C.$_d(b(p.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||D}case"execInstallFolder":{const r=this.a.getAppRoot();return r||D}case"pathSeparator":return C.sep;default:try{const r=n?`${v}:${n}`:v;return this.p(p.VariableKind.Unknown,D,r,s,void 0)}catch{return D}}}}p(k,D,v,o,s){if(v&&o){const n=s===void 0?o[v]:o[s+":"+v];if(typeof n=="string")return n;throw new p.$OM(k,(0,E.localize)(14,null,D))}return D}}e.$3M=I}),define(Se[143],De([1,0,5,139]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0B=e.$9B=e.OpenEditorContext=e.GroupsOrder=e.$8B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$7B=void 0,e.$7B=(0,C.$Bh)("editorGroupsService");var f;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var L;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EVEN=1]="EVEN",D[D.TOGGLE=2]="TOGGLE"})($||(e.GroupsArrangement=$={}));var E;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function p(D){const v=D;return(0,F.$WD)(v?.editor)&&(0,F.$WD)(v?.replacement)}e.$8B=p;var A;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var I;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function w(D){const v=D;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.$9B=w;function k(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$0B=k}),define(Se[279],De([1,0,5,143]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=e.$aC=e.$_B=e.$$B=void 0,e.$$B=(0,C.$Bh)("editorService"),e.$_B=-1,e.$aC=-2;function f(L){const R=L;return typeof L=="number"||(0,F.$9B)(R)}e.$bC=f}),define(Se[13],De([1,0,19,22,162,75,80,28,158,63,98,23,18,2,34,83,133,142,139,108,69,88,279,7]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b,h,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$1L=e.$ZL=e.MarkdownString=e.$YL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Me){function Fe(_){const{selectionStartLineNumber:Te,selectionStartColumn:He,positionLineNumber:xe,positionColumn:Je}=_,nt=new r.$4J(Te-1,He-1),$t=new r.$4J(xe-1,Je-1);return new r.$6J(nt,$t)}Me.to=Fe;function Pe(_){const{anchor:Te,active:He}=_;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Me.from=Pe})(a||(e.Selection=a={}));var i;(function(Me){function Fe(_){if(!_)return;const{start:Te,end:He}=_;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Me.from=Fe;function Pe(_){if(!_)return;const{startLineNumber:Te,startColumn:He,endLineNumber:xe,endColumn:Je}=_;return new r.$5J(Te-1,He-1,xe-1,Je-1)}Me.to=Pe})(i||(e.Range=i={}));var c;(function(Me){function Fe(Pe){switch(Pe){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Me.to=Fe})(c||(e.TokenType=c={}));var d;(function(Me){function Fe(_){return new r.$4J(_.lineNumber-1,_.column-1)}Me.to=Fe;function Pe(_){return{lineNumber:_.line+1,column:_.character+1}}Me.from=Pe})(d||(e.Position=d={}));var y;(function(Me){function Fe(Te,He,xe){return(0,C.$Fb)((0,C.$1b)(Te).map(Je=>Pe(Je,He,xe)))}Me.from=Fe;function Pe(Te,He,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:_(Te.scheme,He),pattern:Xe.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function _(Te,He){return He&&typeof Te=="string"?He.transformOutgoingScheme(Te):Te}})(y||(e.DocumentSelector=y={}));var S;(function(Me){function Fe(_){switch(_){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Me.from=Fe;function Pe(_){switch(_){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Me.to=Pe})(S||(e.DiagnosticTag=S={}));var g;(function(Me){function Fe(_){let Te;return _.code&&((0,w.$jf)(_.code)||(0,w.$nf)(_.code)?Te=String(_.code):Te={value:String(_.code.value),target:_.code.target}),{...i.from(_.range),message:_.message,source:_.source,code:Te,severity:m.from(_.severity),relatedInformation:_.relatedInformation&&_.relatedInformation.map(u.from),tags:Array.isArray(_.tags)?(0,C.$Fb)(_.tags.map(S.from)):void 0}}Me.from=Fe;function Pe(_){const Te=new r.$eK(i.to(_),_.message,m.to(_.severity));return Te.source=_.source,Te.code=(0,w.$jf)(_.code)?_.code:_.code?.value,Te.relatedInformation=_.relatedInformation&&_.relatedInformation.map(u.to),Te.tags=_.tags&&(0,C.$Fb)(_.tags.map(S.to)),Te}Me.to=Pe})(g||(e.Diagnostic=g={}));var u;(function(Me){function Fe(_){return{...i.from(_.location.range),message:_.message,resource:_.location.uri}}Me.from=Fe;function Pe(_){return new r.$dK(new r.$cK(_.resource,i.to(_)),_.message)}Me.to=Pe})(u||(e.DiagnosticRelatedInformation=u={}));var m;(function(Me){function Fe(_){switch(_){case r.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Me.from=Fe;function Pe(_){switch(_){case o.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Me.to=Pe})(m||(e.DiagnosticSeverity=m={}));var P;(function(Me){function Fe(_){return typeof _=="number"&&_>=r.ViewColumn.One?_-1:_===r.ViewColumn.Beside?t.$aC:t.$_B}Me.from=Fe;function Pe(_){if(typeof _=="number"&&_>=0)return _+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Pe})(P||(e.ViewColumn=P={}));function O(Me){return typeof Me.range<"u"}function N(Me){return Me.length===0?!0:!!O(Me[0])}e.$YL=N;var M;(function(Me){function Fe(Je){return Je.map(Me.from)}Me.fromMany=Fe;function Pe(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function _(Je){let nt;if(Pe(Je)){const{language:lt,value:mt}=Je;nt={value:"```"+lt+`
`+mt+"\n```\n"}}else r.$qK.isMarkdownString(Je)?nt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?nt={value:Je}:nt={value:""};const $t=Object.create(null);nt.uris=$t;const Pt=lt=>{try{let mt=k.URI.parse(lt,!0);mt=mt.with({query:Te(mt.query,$t)}),$t[lt]=mt}catch{}return""},vt=new E.marked.Renderer;return vt.link=Pt,vt.image=lt=>typeof lt=="string"?Pt(R.$5j(lt).href):"",(0,E.marked)(nt.value,{renderer:vt}),nt}Me.from=_;function Te(Je,nt){if(!Je)return Je;let $t;try{$t=(0,p.$0g)(Je)}catch{}if(!$t)return Je;let Pt=!1;return $t=(0,I.$Xm)($t,vt=>{if(k.URI.isUri(vt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[lt]=vt,Pt=!0,lt}else return}),Pt?JSON.stringify($t):Je}function He(Je){const nt=new r.$qK(Je.value,Je.supportThemeIcons);return nt.isTrusted=Je.isTrusted,nt.supportHtml=Je.supportHtml,nt.baseUri=Je.baseUri?k.URI.from(Je.baseUri):void 0,nt}Me.to=He;function xe(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=xe})(M||(e.MarkdownString=M={}));function j(Me){return N(Me)?Me.map(Fe=>({range:i.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?M.fromMany(Fe.hoverMessage):Fe.hoverMessage?M.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Me.map(Fe=>({range:i.from(Fe)}))}e.$ZL=j;function z(Me){return typeof Me>"u"?Me:typeof Me=="string"?k.URI.file(Me):Me}e.$1L=z;var T;(function(Me){function Fe(Pe){return typeof Pe>"u"?Pe:{contentText:Pe.contentText,contentIconPath:Pe.contentIconPath?z(Pe.contentIconPath):void 0,border:Pe.border,borderColor:Pe.borderColor,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,color:Pe.color,backgroundColor:Pe.backgroundColor,margin:Pe.margin,width:Pe.width,height:Pe.height}}Me.from=Fe})(T||(e.ThemableDecorationAttachmentRenderOptions=T={}));var H;(function(Me){function Fe(Pe){return typeof Pe>"u"?Pe:{backgroundColor:Pe.backgroundColor,outline:Pe.outline,outlineColor:Pe.outlineColor,outlineStyle:Pe.outlineStyle,outlineWidth:Pe.outlineWidth,border:Pe.border,borderColor:Pe.borderColor,borderRadius:Pe.borderRadius,borderSpacing:Pe.borderSpacing,borderStyle:Pe.borderStyle,borderWidth:Pe.borderWidth,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,cursor:Pe.cursor,color:Pe.color,opacity:Pe.opacity,letterSpacing:Pe.letterSpacing,gutterIconPath:Pe.gutterIconPath?z(Pe.gutterIconPath):void 0,gutterIconSize:Pe.gutterIconSize,overviewRulerColor:Pe.overviewRulerColor,before:Pe.before?T.from(Pe.before):void 0,after:Pe.after?T.from(Pe.after):void 0}}Me.from=Fe})(H||(e.ThemableDecorationRenderOptions=H={}));var q;(function(Me){function Fe(Pe){if(typeof Pe>"u")return Pe;switch(Pe){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Fe})(q||(e.DecorationRangeBehavior=q={}));var me;(function(Me){function Fe(Pe){return{isWholeLine:Pe.isWholeLine,rangeBehavior:Pe.rangeBehavior?q.from(Pe.rangeBehavior):void 0,overviewRulerLane:Pe.overviewRulerLane,light:Pe.light?H.from(Pe.light):void 0,dark:Pe.dark?H.from(Pe.dark):void 0,backgroundColor:Pe.backgroundColor,outline:Pe.outline,outlineColor:Pe.outlineColor,outlineStyle:Pe.outlineStyle,outlineWidth:Pe.outlineWidth,border:Pe.border,borderColor:Pe.borderColor,borderRadius:Pe.borderRadius,borderSpacing:Pe.borderSpacing,borderStyle:Pe.borderStyle,borderWidth:Pe.borderWidth,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,cursor:Pe.cursor,color:Pe.color,opacity:Pe.opacity,letterSpacing:Pe.letterSpacing,gutterIconPath:Pe.gutterIconPath?z(Pe.gutterIconPath):void 0,gutterIconSize:Pe.gutterIconSize,overviewRulerColor:Pe.overviewRulerColor,before:Pe.before?T.from(Pe.before):void 0,after:Pe.after?T.from(Pe.after):void 0}}Me.from=Fe})(me||(e.DecorationRenderOptions=me={}));var Z;(function(Me){function Fe(_){return{text:_.newText,eol:_.newEol&&et.from(_.newEol),range:i.from(_.range)}}Me.from=Fe;function Pe(_){const Te=new r.$0J(i.to(_.range),_.text);return Te.newEol=typeof _.eol>"u"?void 0:et.to(_.eol),Te}Me.to=Pe})(Z||(e.TextEdit=Z={}));var X;(function(Me){function Fe(_,Te){const He={edits:[]};if(_ instanceof r.$aK){const xe=new $.$Ai;for(const Je of _._allEntries())Je._type===1&&k.URI.isUri(Je.to)&&Je.from===void 0&&xe.add(Je.to);for(const Je of _._allEntries())if(Je._type===1){let nt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?nt={type:"base64",value:(0,F.$Zd)(F.$Fd.wrap(Je.options.contents))}:nt={type:"dataTransferItem",id:Je.options.contents._itemId}),He.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:nt},metadata:Je.metadata})}else Je._type===2?He.edits.push({resource:Je.uri,textEdit:Z.from(Je.edit),versionId:xe.has(Je.uri)?void 0:Te?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?He.edits.push({resource:Je.uri,textEdit:{range:i.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:xe.has(Je.uri)?void 0:Te?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?He.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&He.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(at.from)}})}return He}Me.from=Fe;function Pe(_){const Te=new r.$aK,He=new $.$zi;for(const xe of _.edits)if(xe.textEdit){const Je=xe,nt=k.URI.revive(Je.resource),$t=i.to(Je.textEdit.range),Pt=Je.textEdit.text,vt=Je.textEdit.insertAsSnippet;let lt;vt?lt=r.$_J.replace($t,new r.$bK(Pt)):lt=r.$0J.replace($t,Pt);const mt=He.get(nt);mt?mt.push(lt):He.set(nt,[lt])}else Te.renameFile(k.URI.revive(xe.oldResource),k.URI.revive(xe.newResource),xe.options);for(const[xe,Je]of He)Te.set(xe,Je);return Te}Me.to=Pe})(X||(e.WorkspaceEdit=X={}));var V;(function(Me){const Fe=Object.create(null);Fe[r.SymbolKind.File]=0,Fe[r.SymbolKind.Module]=1,Fe[r.SymbolKind.Namespace]=2,Fe[r.SymbolKind.Package]=3,Fe[r.SymbolKind.Class]=4,Fe[r.SymbolKind.Method]=5,Fe[r.SymbolKind.Property]=6,Fe[r.SymbolKind.Field]=7,Fe[r.SymbolKind.Constructor]=8,Fe[r.SymbolKind.Enum]=9,Fe[r.SymbolKind.Interface]=10,Fe[r.SymbolKind.Function]=11,Fe[r.SymbolKind.Variable]=12,Fe[r.SymbolKind.Constant]=13,Fe[r.SymbolKind.String]=14,Fe[r.SymbolKind.Number]=15,Fe[r.SymbolKind.Boolean]=16,Fe[r.SymbolKind.Array]=17,Fe[r.SymbolKind.Object]=18,Fe[r.SymbolKind.Key]=19,Fe[r.SymbolKind.Null]=20,Fe[r.SymbolKind.EnumMember]=21,Fe[r.SymbolKind.Struct]=22,Fe[r.SymbolKind.Event]=23,Fe[r.SymbolKind.Operator]=24,Fe[r.SymbolKind.TypeParameter]=25;function Pe(Te){return typeof Fe[Te]=="number"?Fe[Te]:6}Me.from=Pe;function _(Te){for(const He in Fe)if(Fe[He]===Te)return Number(He);return r.SymbolKind.Property}Me.to=_})(V||(e.SymbolKind=V={}));var x;(function(Me){function Fe(_){switch(_){case r.SymbolTag.Deprecated:return 1}}Me.from=Fe;function Pe(_){switch(_){case 1:return r.SymbolTag.Deprecated}}Me.to=Pe})(x||(e.SymbolTag=x={}));var ge;(function(Me){function Fe(_){return{name:_.name,kind:V.from(_.kind),tags:_.tags&&_.tags.map(x.from),containerName:_.containerName,location:K.from(_.location)}}Me.from=Fe;function Pe(_){const Te=new r.$hK(_.name,V.to(_.kind),_.containerName,K.to(_.location));return Te.tags=_.tags&&_.tags.map(x.to),Te}Me.to=Pe})(ge||(e.WorkspaceSymbol=ge={}));var ue;(function(Me){function Fe(_){const Te={name:_.name||"!!MISSING: name!!",detail:_.detail,range:i.from(_.range),selectionRange:i.from(_.selectionRange),kind:V.from(_.kind),tags:_.tags?.map(x.from)??[]};return _.children&&(Te.children=_.children.map(Fe)),Te}Me.from=Fe;function Pe(_){const Te=new r.$iK(_.name,_.detail,V.to(_.kind),i.to(_.range),i.to(_.selectionRange));return(0,C.$Jb)(_.tags)&&(Te.tags=_.tags.map(x.to)),_.children&&(Te.children=_.children.map(Pe)),Te}Me.to=Pe})(ue||(e.DocumentSymbol=ue={}));var ve;(function(Me){function Fe(_){const Te=new r.$mK(V.to(_.kind),_.name,_.detail||"",k.URI.revive(_.uri),i.to(_.range),i.to(_.selectionRange));return Te._sessionId=_._sessionId,Te._itemId=_._itemId,Te}Me.to=Fe;function Pe(_,Te,He){if(Te=Te??_._sessionId,He=He??_._itemId,Te===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:He,name:_.name,detail:_.detail,kind:V.from(_.kind),uri:_.uri,range:i.from(_.range),selectionRange:i.from(_.selectionRange),tags:_.tags?.map(x.from)}}Me.from=Pe})(ve||(e.CallHierarchyItem=ve={}));var G;(function(Me){function Fe(Pe){return new r.$nK(ve.to(Pe.from),Pe.fromRanges.map(_=>i.to(_)))}Me.to=Fe})(G||(e.CallHierarchyIncomingCall=G={}));var U;(function(Me){function Fe(Pe){return new r.$oK(ve.to(Pe.to),Pe.fromRanges.map(_=>i.to(_)))}Me.to=Fe})(U||(e.CallHierarchyOutgoingCall=U={}));var K;(function(Me){function Fe(_){return{range:_.range&&i.from(_.range),uri:_.uri}}Me.from=Fe;function Pe(_){return new r.$cK(k.URI.revive(_.uri),i.to(_.range))}Me.to=Pe})(K||(e.location=K={}));var fe;(function(Me){function Fe(_){const Te=_,He=_;return{originSelectionRange:Te.originSelectionRange?i.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:He.uri,range:i.from(Te.targetRange?Te.targetRange:He.range),targetSelectionRange:Te.targetSelectionRange?i.from(Te.targetSelectionRange):void 0}}Me.from=Fe;function Pe(_){return{targetUri:k.URI.revive(_.uri),targetRange:i.to(_.range),targetSelectionRange:_.targetSelectionRange?i.to(_.targetSelectionRange):void 0,originSelectionRange:_.originSelectionRange?i.to(_.originSelectionRange):void 0}}Me.to=Pe})(fe||(e.DefinitionLink=fe={}));var te;(function(Me){function Fe(_){return{range:i.from(_.range),contents:M.fromMany(_.contents)}}Me.from=Fe;function Pe(_){return new r.$fK(_.contents.map(M.to),i.to(_.range))}Me.to=Pe})(te||(e.Hover=te={}));var se;(function(Me){function Fe(_){return{range:i.from(_.range),expression:_.expression}}Me.from=Fe;function Pe(_){return new r.$$K(i.to(_.range),_.expression)}Me.to=Pe})(se||(e.EvaluatableExpression=se={}));var ne;(function(Me){function Fe(_){if(_ instanceof r.$_K)return{type:"text",range:i.from(_.range),text:_.text};if(_ instanceof r.$aL)return{type:"variable",range:i.from(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};if(_ instanceof r.$bL)return{type:"expression",range:i.from(_.range),expression:_.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Fe;function Pe(_){switch(_.type){case"text":return{range:i.to(_.range),text:_.text};case"variable":return{range:i.to(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};case"expression":return{range:i.to(_.range),expression:_.expression}}}Me.to=Pe})(ne||(e.InlineValue=ne={}));var Ee;(function(Me){function Fe(_){return{frameId:_.frameId,stoppedLocation:i.from(_.stoppedLocation)}}Me.from=Fe;function Pe(_){return new r.$cL(_.frameId,i.to(_.stoppedLocation))}Me.to=Pe})(Ee||(e.InlineValueContext=Ee={}));var oe;(function(Me){function Fe(_){return{range:i.from(_.range),kind:_.kind}}Me.from=Fe;function Pe(_){return new r.$gK(i.to(_.range),_.kind)}Me.to=Pe})(oe||(e.DocumentHighlight=oe={}));var he;(function(Me){function Fe(Pe){switch(Pe){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Me.to=Fe})(he||(e.CompletionTriggerKind=he={}));var ee;(function(Me){function Fe(Pe){return{triggerKind:he.to(Pe.triggerKind),triggerCharacter:Pe.triggerCharacter}}Me.to=Fe})(ee||(e.CompletionContext=ee={}));var le;(function(Me){function Fe(_){switch(_){case r.CompletionItemTag.Deprecated:return 1}}Me.from=Fe;function Pe(_){switch(_){case 1:return r.CompletionItemTag.Deprecated}}Me.to=Pe})(le||(e.CompletionItemTag=le={}));var be;(function(Me){const Fe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Pe(He){return Fe.get(He)??9}Me.from=Pe;const _=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Te(He){return _.get(He)??r.CompletionItemKind.Property}Me.to=Te})(be||(e.CompletionItemKind=be={}));var Ie;(function(Me){function Fe(Pe,_){const Te=new r.$wK(Pe.label);return Te.insertText=Pe.insertText,Te.kind=be.to(Pe.kind),Te.tags=Pe.tags?.map(le.to),Te.detail=Pe.detail,Te.documentation=R.$Zj(Pe.documentation)?M.to(Pe.documentation):Pe.documentation,Te.sortText=Pe.sortText,Te.filterText=Pe.filterText,Te.preselect=Pe.preselect,Te.commitCharacters=Pe.commitCharacters,D.$ks.isIRange(Pe.range)?Te.range=i.to(Pe.range):typeof Pe.range=="object"&&(Te.range={inserting:i.to(Pe.range.insert),replacing:i.to(Pe.range.replace)}),Te.keepWhitespace=typeof Pe.insertTextRules>"u"?!1:!!(Pe.insertTextRules&1),typeof Pe.insertTextRules<"u"&&Pe.insertTextRules&4?Te.insertText=new r.$bK(Pe.insertText):(Te.insertText=Pe.insertText,Te.textEdit=Te.range instanceof r.$5J?new r.$0J(Te.range,Te.insertText):void 0),Pe.additionalTextEdits&&Pe.additionalTextEdits.length>0&&(Te.additionalTextEdits=Pe.additionalTextEdits.map(He=>Z.to(He))),Te.command=_&&Pe.command?_.fromInternal(Pe.command):void 0,Te}Me.to=Fe})(Ie||(e.CompletionItem=Ie={}));var B;(function(Me){function Fe(_){if(typeof _.label!="string"&&!Array.isArray(_.label))throw new TypeError("Invalid label");return{label:_.label,documentation:M.fromStrict(_.documentation)}}Me.from=Fe;function Pe(_){return{label:_.label,documentation:R.$Zj(_.documentation)?M.to(_.documentation):_.documentation}}Me.to=Pe})(B||(e.ParameterInformation=B={}));var Y;(function(Me){function Fe(_){return{label:_.label,documentation:M.fromStrict(_.documentation),parameters:Array.isArray(_.parameters)?_.parameters.map(B.from):[],activeParameter:_.activeParameter}}Me.from=Fe;function Pe(_){return{label:_.label,documentation:R.$Zj(_.documentation)?M.to(_.documentation):_.documentation,parameters:Array.isArray(_.parameters)?_.parameters.map(B.to):[],activeParameter:_.activeParameter}}Me.to=Pe})(Y||(e.SignatureInformation=Y={}));var ie;(function(Me){function Fe(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(Y.from):[]}}Me.from=Fe;function Pe(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(Y.to):[]}}Me.to=Pe})(ie||(e.SignatureHelp=ie={}));var re;(function(Me){function Fe(Pe,_){const Te=new r.$vK(d.to(_.position),typeof _.label=="string"?_.label:_.label.map(Q.to.bind(void 0,Pe)),_.kind&&de.to(_.kind));return Te.textEdits=_.textEdits&&_.textEdits.map(Z.to),Te.tooltip=R.$Zj(_.tooltip)?M.to(_.tooltip):_.tooltip,Te.paddingLeft=_.paddingLeft,Te.paddingRight=_.paddingRight,Te}Me.to=Fe})(re||(e.InlayHint=re={}));var Q;(function(Me){function Fe(Pe,_){const Te=new r.$uK(_.label);return Te.tooltip=R.$Zj(_.tooltip)?M.to(_.tooltip):_.tooltip,v.Command.is(_.command)&&(Te.command=Pe.fromInternal(_.command)),_.location&&(Te.location=K.to(_.location)),Te}Me.to=Fe})(Q||(e.InlayHintLabelPart=Q={}));var de;(function(Me){function Fe(_){return _}Me.from=Fe;function Pe(_){return _}Me.to=Pe})(de||(e.InlayHintKind=de={}));var ye;(function(Me){function Fe(_){return{range:i.from(_.range),url:_.target,tooltip:_.tooltip}}Me.from=Fe;function Pe(_){let Te;if(_.url)try{Te=typeof _.url=="string"?k.URI.parse(_.url,!0):k.URI.revive(_.url)}catch{}return new r.$BK(i.to(_.range),Te)}Me.to=Pe})(ye||(e.DocumentLink=ye={}));var je;(function(Me){function Fe(_){const Te=new r.$EK(_.label);return _.textEdit&&(Te.textEdit=Z.to(_.textEdit)),_.additionalTextEdits&&(Te.additionalTextEdits=_.additionalTextEdits.map(He=>Z.to(He))),Te}Me.to=Fe;function Pe(_){return{label:_.label,textEdit:_.textEdit?Z.from(_.textEdit):void 0,additionalTextEdits:_.additionalTextEdits?_.additionalTextEdits.map(Te=>Z.from(Te)):void 0}}Me.from=Pe})(je||(e.ColorPresentation=je={}));var We;(function(Me){function Fe(_){return new r.$CK(_[0],_[1],_[2],_[3])}Me.to=Fe;function Pe(_){return[_.red,_.green,_.blue,_.alpha]}Me.from=Pe})(We||(e.Color=We={}));var _e;(function(Me){function Fe(_){return{range:i.from(_.range)}}Me.from=Fe;function Pe(_){return new r.$lK(i.to(_.range))}Me.to=Pe})(_e||(e.SelectionRange=_e={}));var Qe;(function(Me){function Fe(Pe){switch(Pe){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Me.to=Fe})(Qe||(e.TextDocumentSaveReason=Qe={}));var it;(function(Me){function Fe(_){switch(_){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Fe;function Pe(_){switch(_){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Me.to=Pe})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Me){function Fe(_){if(_===r.EndOfLine.CRLF)return 1;if(_===r.EndOfLine.LF)return 0}Me.from=Fe;function Pe(_){if(_===1)return r.EndOfLine.CRLF;if(_===0)return r.EndOfLine.LF}Me.to=Pe})(et||(e.EndOfLine=et={}));var Ae;(function(Me){function Fe(Pe){if(typeof Pe=="object")return Pe.viewId;switch(Pe){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Fe})(Ae||(e.ProgressLocation=Ae={}));var Oe;(function(Me){function Fe(_){const Te={start:_.start+1,end:_.end+1};return _.kind&&(Te.kind=Ve.from(_.kind)),Te}Me.from=Fe;function Pe(_){const Te={start:_.start-1,end:_.end-1};return _.kind&&(Te.kind=Ve.to(_.kind)),Te}Me.to=Pe})(Oe||(e.FoldingRange=Oe={}));var Ve;(function(Me){function Fe(_){if(_)switch(_){case r.FoldingRangeKind.Comment:return v.$_s.Comment;case r.FoldingRangeKind.Imports:return v.$_s.Imports;case r.FoldingRangeKind.Region:return v.$_s.Region}}Me.from=Fe;function Pe(_){if(_)switch(_.value){case v.$_s.Comment.value:return r.FoldingRangeKind.Comment;case v.$_s.Imports.value:return r.FoldingRangeKind.Imports;case v.$_s.Region.value:return r.FoldingRangeKind.Region}}Me.to=Pe})(Ve||(e.FoldingRangeKind=Ve={}));var Le;(function(Me){function Fe(Pe){if(Pe)return{pinned:typeof Pe.preview=="boolean"?!Pe.preview:void 0,inactive:Pe.background,preserveFocus:Pe.preserveFocus,selection:typeof Pe.selection=="object"?i.from(Pe.selection):void 0,override:typeof Pe.override=="boolean"?n.$JD.id:void 0}}Me.from=Fe})(Le||(e.TextEditorOpenOptions=Le={}));var Xe;(function(Me){function Fe(He){return He instanceof r.$YK?He.toJSON():typeof He=="string"?He:Pe(He)||_(He)?new r.$YK(He.baseUri??He.base,He.pattern).toJSON():He}Me.from=Fe;function Pe(He){const xe=He;return xe?k.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function _(He){const xe=He;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(He){return typeof He=="string"?He:new r.$YK(k.URI.revive(He.baseUri),He.pattern)}Me.to=Te})(Xe||(e.GlobPattern=Xe={}));var ce;(function(Me){function Fe(Pe){if(Pe){if(Array.isArray(Pe))return Pe.map(Fe);if(typeof Pe=="string")return Pe;{const _=Pe;return{language:_.language,scheme:_.scheme,pattern:Xe.from(_.pattern),exclusive:_.exclusive,notebookType:_.notebookType}}}else return}Me.from=Fe})(ce||(e.LanguageSelector=ce={}));var ae;(function(Me){function Fe(_){return!!_&&typeof _=="object"&&"selections"in _&&Array.isArray(_.selections)&&_.selections.every(Te=>Te instanceof r.$6J)&&"related"in _&&Array.isArray(_.related)&&_.related.every(Te=>Te&&typeof Te=="object"&&k.URI.isUri(Te.uri)&&Te.range instanceof r.$5J)}Me.is=Fe;function Pe(_){return{selections:_.selections.map(Te=>a.from(Te)),related:_.related.map(Te=>({uri:k.URI.from(Te.uri),range:i.from(Te.range)}))}}Me.from=Pe})(ae||(e.MappedEditsContext=ae={}));var Ce;(function(Me){function Fe(_){return{start:_.start,end:_.end}}Me.from=Fe;function Pe(_){return new r.$nL(_.start,_.end)}Me.to=Pe})(Ce||(e.NotebookRange=Ce={}));var qe;(function(Me){function Fe(_){return{timing:typeof _.runStartTime=="number"&&typeof _.runEndTime=="number"?{startTime:_.runStartTime,endTime:_.runEndTime}:void 0,executionOrder:_.executionOrder,success:_.lastRunSuccess}}Me.to=Fe;function Pe(_){return{lastRunSuccess:_.success,runStartTime:_.timing?.startTime,runEndTime:_.timing?.endTime,executionOrder:_.executionOrder}}Me.from=Pe})(qe||(e.NotebookCellExecutionSummary=qe={}));var Ue;(function(Me){function Fe(Pe){if(Pe===l.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Pe===l.NotebookCellExecutionState.Pending)return;if(Pe===l.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Pe}`)}Me.to=Fe})(Ue||(e.NotebookCellExecutionState=Ue={}));var Ze;(function(Me){function Fe(_){switch(_){case r.NotebookCellKind.Markup:return l.CellKind.Markup;case r.NotebookCellKind.Code:default:return l.CellKind.Code}}Me.from=Fe;function Pe(_){switch(_){case l.CellKind.Markup:return r.NotebookCellKind.Markup;case l.CellKind.Code:default:return r.NotebookCellKind.Code}}Me.to=Pe})(Ze||(e.NotebookCellKind=Ze={}));var rt;(function(Me){function Fe(_){const Te={metadata:_.metadata??Object.create(null),cells:[]};for(const He of _.cells)r.$oL.validate(He),Te.cells.push(at.from(He));return Te}Me.from=Fe;function Pe(_){const Te=new r.$pL(_.cells.map(at.to));return(0,w.$wf)(_.metadata)||(Te.metadata=_.metadata),Te}Me.to=Pe})(rt||(e.NotebookData=rt={}));var at;(function(Me){function Fe(_){return{cellKind:Ze.from(_.kind),language:_.languageId,mime:_.mime,source:_.value,metadata:_.metadata,internalMetadata:qe.from(_.executionSummary??{}),outputs:_.outputs?_.outputs.map(St.from):[]}}Me.from=Fe;function Pe(_){return new r.$oL(Ze.to(_.cellKind),_.source,_.language,_.mime,_.outputs?_.outputs.map(St.to):void 0,_.metadata,_.internalMetadata?qe.to(_.internalMetadata):void 0)}Me.to=Pe})(at||(e.NotebookCellData=at={}));var bt;(function(Me){function Fe(_){return{mime:_.mime,valueBytes:F.$Fd.wrap(_.data)}}Me.from=Fe;function Pe(_){return new r.$qL(_.valueBytes.buffer,_.mime)}Me.to=Pe})(bt||(e.NotebookCellOutputItem=bt={}));var St;(function(Me){function Fe(_){return{outputId:_.id,items:_.items.map(bt.from),metadata:_.metadata}}Me.from=Fe;function Pe(_){const Te=_.items.map(bt.to);return new r.$rL(Te,_.outputId,_.metadata)}Me.to=Pe})(St||(e.NotebookCellOutput=St={}));var Xt;(function(Me){function Fe(Te){return _(Te)?{include:Xe.from(Te.include)??void 0,exclude:Xe.from(Te.exclude)??void 0}:Xe.from(Te)??void 0}Me.from=Fe;function Pe(Te){return _(Te)?{include:Xe.to(Te.include),exclude:Xe.to(Te.exclude)}:Xe.to(Te)}Me.to=Pe;function _(Te){const He=Te;return He?!(0,w.$sf)(He.include)&&!(0,w.$sf)(He.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Ht;(function(Me){function Fe(Pe,_,Te){const He=typeof Pe.command=="string"?{title:"",command:Pe.command}:Pe.command;return{alignment:Pe.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:_.toInternal(He,Te),text:Pe.text,tooltip:Pe.tooltip,accessibilityInformation:Pe.accessibilityInformation,priority:Pe.priority}}Me.from=Fe})(Ht||(e.NotebookStatusBarItem=Ht={}));var pt;(function(Me){function Fe(Pe,_,Te){const He=typeof Pe.command=="string"?{title:"",command:Pe.command}:Pe.command;return{command:_.toInternal(He,Te),label:Pe.label,description:Pe.description,detail:Pe.detail,documentation:Pe.documentation}}Me.from=Fe})(pt||(e.NotebookKernelSourceAction=pt={}));var Ut;(function(Me){function Fe(Pe){return{transientOutputs:Pe?.transientOutputs??!1,transientCellMetadata:Pe?.transientCellMetadata??{},transientDocumentMetadata:Pe?.transientDocumentMetadata??{},cellContentMetadata:Pe?.cellContentMetadata??{}}}Me.from=Fe})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var Nt;(function(Me){function Fe(_){return{uri:_.uri,provides:_.provides}}Me.from=Fe;function Pe(_){return new r.$tL(k.URI.revive(_.uri),_.provides)}Me.to=Pe})(Nt||(e.NotebookRendererScript=Nt={}));var Bt;(function(Me){function Fe(_){return{message:M.fromStrict(_.message)||"",type:0,expected:_.expectedOutput,actual:_.actualOutput,contextValue:_.contextValue,location:_.location&&{range:i.from(_.location.range),uri:_.location.uri}}}Me.from=Fe;function Pe(_){const Te=new r.$zL(typeof _.message=="string"?_.message:M.to(_.message));return Te.actualOutput=_.actual,Te.expectedOutput=_.expected,Te.contextValue=_.contextValue,Te.location=_.location?K.to(_.location):void 0,Te}Me.to=Pe})(Bt||(e.TestMessage=Bt={}));var At;(function(Me){Me.namespace=h.$WI,Me.denamespace=h.$XI})(At||(e.TestTag=At={}));var Rt;(function(Me){function Fe(_){const Te=(0,s.$XL)(_).controllerId;return{extId:b.$SI.fromExtHostTestItem(_,Te).toString(),label:_.label,uri:k.URI.revive(_.uri),busy:_.busy,tags:_.tags.map(He=>At.namespace(Te,He.id)),range:D.$ks.lift(i.from(_.range)),description:_.description||null,sortText:_.sortText||null,error:_.error&&M.fromStrict(_.error)||null}}Me.from=Fe;function Pe(_){return{parent:void 0,error:void 0,id:b.$SI.fromString(_.extId).localId,label:_.label,uri:k.URI.revive(_.uri),tags:(_.tags||[]).map(Te=>{const{tagId:He}=At.denamespace(Te);return new r.$AL(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(_.range||void 0),canResolveChildren:!1,busy:_.busy,description:_.description||void 0,sortText:_.sortText||void 0}}Me.toPlain=Pe})(Rt||(e.TestItem=Rt={})),function(Me){function Fe(_){return{id:_.id}}Me.from=Fe;function Pe(_){return new r.$AL(_.id)}Me.to=Pe}(At||(e.TestTag=At={}));var jt;(function(Me){const Fe=(_,Te)=>{const He=[];for(const[Je,nt]of Te)b.$SI.compare(nt.item.extId,Je)===2&&(Te.delete(Je),He.push(nt));const xe={...Rt.toPlain(_.item),parent:void 0,taskStates:_.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(nt=>nt.type===0).map(Bt.to)})),children:He.map(Je=>Fe(Je,Te))};for(const Je of xe.children)Je.parent=xe;return xe};function Pe(_){const Te=[],He=new Map;for(const xe of _.items){He.set(xe.item.extId,xe);const Je=b.$SI.root(xe.item.extId);_.request.targets.some(nt=>nt.controllerId===Je&&nt.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:_.completedAt,results:Te.map(xe=>Fe(xe,He))}}Me.to=Pe})(jt||(e.TestResults=jt={}));var Wt;(function(Me){function Fe(He){return{covered:He.covered,total:He.covered}}function Pe(He){return"line"in He?d.from(He):i.from(He)}function _(He){return"branches"in He?{count:He.executionCount,location:Pe(He.location),type:1,branches:He.branches.length?He.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Pe(xe.location)})):void 0}:{type:0,count:He.executionCount,location:Pe(He.location)}}Me.fromDetailed=_;function Te(He){return{uri:He.uri,statement:Fe(He.statementCoverage),branch:He.branchCoverage&&Fe(He.branchCoverage),function:He.functionCoverage&&Fe(He.functionCoverage),details:He.detailedCoverage?.map(_)}}Me.fromFile=Te})(Wt||(e.TestCoverage=Wt={}));var Kt;(function(Me){function Fe(Pe){switch(Pe){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Me.to=Fe})(Kt||(e.CodeActionTriggerKind=Kt={}));var Vt;(function(Me){function Fe(_){const Te=new r.$GL(V.to(_.kind),_.name,_.detail||"",k.URI.revive(_.uri),i.to(_.range),i.to(_.selectionRange));return Te._sessionId=_._sessionId,Te._itemId=_._itemId,Te}Me.to=Fe;function Pe(_,Te,He){if(Te=Te??_._sessionId,He=He??_._itemId,Te===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:He,kind:V.from(_.kind),name:_.name,detail:_.detail??"",uri:_.uri,range:i.from(_.range),selectionRange:i.from(_.selectionRange),tags:_.tags?.map(x.from)}}Me.from=Pe})(Vt||(e.TypeHierarchyItem=Vt={}));var qt;(function(Me){function Fe(Pe){if(Pe)return{value:Pe.value,tooltip:Pe.tooltip}}Me.from=Fe})(qt||(e.ViewBadge=qt={}));var ot;(function(Me){function Fe(He,xe,Je){const nt=xe.fileData;return nt?new r.$RK(new r.$SK(nt.name,k.URI.revive(nt.uri),nt.id,(0,L.$bb)(()=>Je(nt.id)))):He===A.$Hr.uriList&&xe.uriListData?new r.$QK(Te(xe.uriListData)):new r.$QK(xe.asString)}Me.to=Fe;async function Pe(He,xe){const Je=await xe.asString();if(He===A.$Hr.uriList)return{asString:Je,fileData:void 0,uriListData:_(Je)};const nt=xe.asFile();return{asString:Je,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Me.from=Pe;function _(He){return f.$Ts.split(He).map(xe=>{if(xe.startsWith("#"))return xe;try{return k.URI.parse(xe)}catch{}return xe})}function Te(He){return f.$Ts.create(He.map(xe=>typeof xe=="string"?xe:k.URI.revive(xe)))}})(ot||(e.DataTransferItem=ot={}));var ft;(function(Me){function Fe(_,Te){const He=_.items.map(([xe,Je])=>[xe,ot.to(xe,Je,Te)]);return new r.$TK(He)}Me.toDataTransfer=Fe;async function Pe(_){const Te={items:[]},He=[];for(const[xe,Je]of _)He.push((async()=>{Te.items.push([xe,await ot.from(xe,Je)])})());return await Promise.all(He),Te}Me.from=Pe})(ft||(e.DataTransfer=ft={}));var Lt;(function(Me){function Fe(_){return{message:_.message,metadata:_.metadata,title:_.title,tooltip:_.tooltip}}Me.to=Fe;function Pe(_){return{kind:"reply",message:_.message,metadata:_.metadata,title:_.title,tooltip:_.tooltip}}Me.from=Pe})(Lt||(e.ChatReplyFollowup=Lt={}));var Mt;(function(Me){function Fe(Pe){return typeof Pe=="string"?{title:Pe,message:Pe,kind:"reply"}:"commandId"in Pe?{kind:"command",title:Pe.title??"",commandId:Pe.commandId??"",when:Pe.when??"",args:Pe.args}:Lt.from(Pe)}Me.from=Fe})(Mt||(e.ChatFollowup=Mt={}));var It;(function(Me){function Fe(_){const Te=new r.$QL(dt.to(_.role),_.content);return Te.name=_.name,Te}Me.to=Fe;function Pe(_){return{role:dt.from(_.role),content:_.content,name:_.name}}Me.from=Pe})(It||(e.ChatMessage=It={}));var dt;(function(Me){function Fe(_){switch(_){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Me.to=Fe;function Pe(_){switch(_){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Me.from=Pe})(dt||(e.ChatMessageRole=dt={}));var kt;(function(Me){function Fe(_){return{level:Dt.to(_.level),value:_.value,description:_.description}}Me.to=Fe;function Pe(_){return{level:Dt.from(_.level),value:_.value,description:_.description}}Me.from=Pe})(kt||(e.ChatVariable=kt={}));var Dt;(function(Me){function Fe(_){switch(_){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Me.to=Fe;function Pe(_){switch(_){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Me.from=Pe})(Dt||(e.ChatVariableLevel=Dt={}));var Ft;(function(Me){function Fe(Pe){switch(Pe){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Fe})(Ft||(e.InteractiveEditorResponseFeedbackKind=Ft={}));var Ge;(function(Me){function Fe(Pe,_,Te){return"terminalCommand"in Pe?{terminalCommand:Pe.terminalCommand}:"uri"in Pe?{uri:Pe.uri}:_.toInternal(Pe,Te)}Me.from=Fe})(Ge||(e.TerminalQuickFix=Ge={}))}),define(Se[280],De([1,0,2,8,7,13,76]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=void 0;class ${constructor(p,A,I,w={timeout:1500,errors:3}){this.c=p,this.d=A,this.f=I,this.g=w,this.a=new R.$tc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(p){return(A,I,w)=>{const D={dispose:this.a.push([A,I,p])};return Array.isArray(w)&&w.push(D),D}}async $participateInSave(p,A){const I=C.URI.revive(p);let w=!1;const k=setTimeout(()=>w=!0,this.g.timeout),D=[];try{for(const v of[...this.a]){if(w)break;const o=this.d.getDocument(I),s=await this.h(v,{document:o,reason:L.TextDocumentSaveReason.to(A)});D.push(s)}}finally{clearTimeout(k)}return D}h([p,A,I],w){const k=this.b.get(p);return typeof k=="number"&&k>this.g.errors?Promise.resolve(!1):this.i(I,p,A,w).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const v=this.b.get(p);this.b.set(p,v?v+1:1),typeof v=="number"&&v>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(p,A,I,w){const k=[],D=Date.now(),{document:v,reason:o}=w,{version:s}=v,n=Object.freeze({document:v,reason:o,waitUntil(l){if(Object.isFrozen(k))throw(0,F.$6)("waitUntil can not be called async");k.push(Promise.resolve(l))}});try{A.apply(I,[n])}catch(l){return Promise.reject(l)}return Object.freeze(k),new Promise((l,b)=>{const h=setTimeout(()=>b(new Error("timeout")),this.g.timeout);return Promise.all(k).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(h),l(t)}).catch(t=>{clearTimeout(h),b(t)})}).then(l=>{const b={edits:[]};for(const h of l)if(Array.isArray(h)&&h.every(t=>t instanceof f.$0J))for(const{newText:t,newEol:r,range:a}of h)b.edits.push({resource:v.uri,versionId:void 0,textEdit:{range:a&&L.Range.from(a),text:t,eol:r&&L.EndOfLine.from(r)}});if(b.edits.length!==0)return s===v.version?this.f.$tryApplyWorkspaceEdit(b):Promise.reject(new Error("concurrent_edits"))})}}e.$rbc=$}),define(Se[281],De([1,0,17,2,13,7,108]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=void 0;class ${constructor(I,w,k,D){this.start=I,this.deletedCount=w,this.deletedItems=k,this.items=D}asApiEvent(){return{range:new L.$nL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(I,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,w,k){this.notebook=I,this.h=w,this.j=k,this.handle=k.handle,this.uri=F.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(f.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,w=this.h.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:w.document,get mime(){return I.g},set mime(D){I.g=D},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(k)}return this.f}setOutputs(I){this.a=I.map(f.NotebookCellOutput.to)}setOutputItems(I,w,k){const D=k.map(f.NotebookCellOutputItem.to),v=this.a.find(o=>o.id===I);if(v&&(w||(v.items.length=0),v.items.push(...D),v.items.length>1&&v.items.every(o=>R.$_H(o.mime)))){const o=new Map,s=[];v.items.forEach(n=>{let l;o.has(n.mime)?l=o.get(n.mime):(l=[],o.set(n.mime,l),s.push(n.mime)),l.push(n.data)}),v.items.length=0,s.forEach(n=>{const l=R.$aI(o.get(n));v.items.push({mime:n,data:l.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$Ecc=E;class p{static{this.a=0}constructor(I,w,k,D,v){this.k=I,this.l=w,this.m=k,this.uri=D,this.handle=p.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=v.viewType,this.f=Object.freeze(v.metadata??Object.create(null)),this.r([[0,0,v.cells]],!0,void 0),this.g=v.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,w={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===C.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(k){return k=I.n(k),I.b[k].apiCell},getCells(k){return(k?I.p(k):I.b).map(v=>v.apiCell)},save(){return I.q()}};this.e=Object.freeze(w)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,w,k){this.g=I.versionId,this.h=w,this.acceptDocumentPropertiesChanged({metadata:k});const D={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},v=[];for(const s of I.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,D.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,D.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),v.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),v.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),v.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?v.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),v.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),v.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<v.length;s++){const n=v[s],l=o.get(n.cell);if(l===void 0){const b=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,b-1)}else D.cellChanges[l]={...D.cellChanges[l],...n}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let w=I.start|0,k=I.end|0;return w<0&&(w=0),k>this.b.length&&(k=this.b.length),I.with({start:w,end:k})}p(I){I=this.o(I);const w=[];for(let k=I.start;k<I.end;k++)w.push(this.b[k]);return w}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,w,k){if(this.j)return;const D=[],v=[],o=[];if(I.reverse().forEach(s=>{const l=s[2].map(t=>{const r=new E(this,this.l,t);return w||v.push(E.asModelAddData(this.apiNotebook,t)),r}),b=new $(s[0],s[1],[],l),h=this.b.splice(s[0],s[1],...l);for(const t of h)o.push(t.uri),b.deletedItems.push(t.apiCell);D.push(b)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:o}),k)for(const s of D)k.push(s.asApiEvent())}s(I,w,k,D){const v=this.b.splice(I,w);this.b.splice(k,0,...v);const o=[new $(I,w,v.map(s=>s.apiCell),[]),new $(k,0,[],v)];for(const s of o)D.push(s.asApiEvent())}t(I,w){this.b[I].setOutputs(w)}u(I,w,k,D){this.b[I].setOutputItems(w,k,D)}v(I,w){const k=this.b[I];k.apiCell.document.languageId!==w&&this.m.$acceptModelLanguageChanged(k.uri,w)}w(I,w){const k=this.b[I];k.apiCell.mime=w}x(I,w){this.b[I].setMetadata(w)}y(I,w){this.b[I].setInternalMetadata(w)}getCellFromApiCell(I){return this.b.find(w=>w.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(w=>w.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$Fcc=p}),define(Se[282],De([1,0,4,2,13,7]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=void 0;class R{constructor(E,p,A,I={timeout:1500,errors:3}){this.b=E,this.c=p,this.d=A,this.f=I,this.a=new C.$hd}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(p,A,I)=>{const w=function(D){p.call(A,D)};return w.extension=E,this.a.event(w,void 0,I)}}async $participateInSave(E,p,A){const I=F.URI.revive(E),w=this.c.getNotebookDocument(I);if(!w)throw new Error("Unable to resolve notebook document");const k=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:f.TextDocumentSaveReason.to(p)},A,async(v,o)=>{const s=Date.now(),n=await await Promise.resolve(v);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof L.$aK?k.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(k.length===0)return!0;const D={edits:[]};for(const v of k){const{edits:o}=f.WorkspaceEdit.from(v);D.edits=D.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(D)}}e.$6cc=R}),define(Se[144],De([1,0,8,13,7]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor($,E,p,A,I,w){this.id=$,this.f=E,this.notebookData=p,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=A,this.c=w}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(E){this.selections=[E]},get selections(){return $.a},set selections(E){if(!Array.isArray(E)||!E.every(f.$nL.isNotebookRange))throw(0,C.$5)("selections");$.a=E,$.g(E)},get visibleRanges(){return $.b},revealRange(E,p){$.f.$tryRevealRange($.id,F.NotebookRange.from(E),p??f.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(F.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$Gcc=L}),define(Se[283],De([1,0,8,4,14,13]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;let R=class{constructor(E,p){this.c=E,this.d=p,this.a=new F.$fd({onListenerError:C.$Z}),this.b=new F.$fd({onListenerError:C.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,p);const A=this.d.getEditorById(E);p.visibleRanges&&A._acceptVisibleRanges(p.visibleRanges.ranges.map(L.NotebookRange.to)),p.selections&&A._acceptSelections(p.selections.selections.map(L.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const p in E)this.d.getEditorById(p)._acceptViewColumn(L.ViewColumn.to(E[p]))}};e.$Ycc=R,e.$Ycc=R=Ke([Be(0,f.$5i)],R)}),define(Se[284],De([1,0,13,65,208,21,57,8]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=void 0;class E{constructor(w){this.b=0,this.c=new Map,this.a=w}async withProgress(w,k,D){const v=this.b++,{title:o,location:s,cancellable:n}=k,l={label:(0,f.localize)(0,null,w.displayName||w.name),id:w.identifier.value};return this.a.$startProgress(v,{location:C.ProgressLocation.from(s),title:o,source:l,cancellable:n},w.isUnderDevelopment?void 0:w.identifier.value).catch($.$Z),this.d(v,D,!!n)}d(w,k,D){let v;D&&(v=new L.$pd,this.c.set(w,v));const o=n=>{this.a.$progressEnd(n),this.c.delete(n),v?.dispose()};let s;try{s=k(new A(this.a,w),D&&v?v.token:L.CancellationToken.None)}catch(n){throw o(w),n}return s.then(n=>o(w),n=>o(w)),s}$acceptProgressCanceled(w){const k=this.c.get(w);k&&(k.cancel(),this.c.delete(w))}}e.$3bc=E;function p(I,w){return I.message=w.message,typeof w.increment=="number"&&(typeof I.increment=="number"?I.increment+=w.increment:I.increment=w.increment),I}class A extends F.$Vu{constructor(w,k){super(D=>this.throttledReport(D)),this.f=w,this.g=k}throttledReport(w){this.f.$progressReport(this.g,w)}}Ke([(0,R.$8g)(100,(I,w)=>p(I,w),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Se[145],De([1,0,34,142,69,109,88,13,2]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=e.$cM=e.$bM=void 0;const p=(l,b,h,t)=>{let r=b;return{enumerable:!0,configurable:!1,get(){return r},set(a){if(!h(r,a)){const i=r;r=a,l.listener?.(t(a,i))}}}},A=(l,b)=>l===b,I={range:(l,b)=>l===b?!0:!l||!b?!1:l.isEqual(b),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(l,b)=>!(l.length!==b.length||l.some(h=>!b.find(t=>h.id===t.id)))},w=l=>b=>({op:4,update:l(b)}),k=(l,b)=>({range:(()=>{let h;const t=w(r=>({range:C.$ks.lift($.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return h},set(r){l.listener?.({op:6}),I.range(h,r)||(h=r,l.listener?.(t(r)))}}})(),label:p(l,b,I.label,w(h=>({label:h}))),description:p(l,void 0,I.description,w(h=>({description:h}))),sortText:p(l,void 0,I.sortText,w(h=>({sortText:h}))),canResolveChildren:p(l,!1,I.canResolveChildren,h=>({op:2,state:h})),busy:p(l,!1,I.busy,w(h=>({busy:h}))),error:p(l,void 0,I.error,w(h=>({error:$.MarkdownString.fromStrict(h)||null}))),tags:p(l,[],I.tags,(h,t)=>({op:1,new:h.map($.TestTag.from),old:t.map($.TestTag.from)}))}),D=l=>{const b=f.$SI.fromString(l.extId),h=new o(b.controllerId,b.localId,l.label,E.URI.revive(l.uri)||void 0);return h.range=$.Range.to(l.range||void 0),h.description=l.description||void 0,h.sortText=l.sortText||void 0,h.tags=l.tags.map(t=>$.TestTag.to({id:(0,R.$XI)(t).tagId})),h},v=l=>{let b;for(const h of l.tests){const t=D(h.item);(0,F.$XL)(t).parent=b,b=t}return b};e.$bM=v;class o{constructor(b,h,t,r){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const a=(0,F.$WL)(this,b);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof s?void 0:a.parent}},children:{value:(0,L.$VL)(a,F.$XL,o),enumerable:!0,writable:!1},...k(a,t)})}}e.$cM=o;class s extends o{constructor(b,h){super(b,b,h,void 0),this._isRoot=!0}}e.$dM=s;class n extends L.$RL{constructor(b,h,t){super({controllerId:b,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:F.$XL,getChildren:r=>r.children,root:new s(b,h),toITestItem:$.TestItem.from})}}e.$eM=n}),define(Se[146],De([1,0,58,8,119,13,7]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=e.$9L=void 0;class ${static{this.c=new f.$7L("TextEditorDecorationType")}constructor(w,k,D){const v=$.c.nextId();w.$registerTextEditorDecorationType(k.identifier,v,L.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:v,dispose(){w.$removeTextEditorDecorationType(v)}})}}e.$9L=$;class E{constructor(w,k){this.g=[],this.h=void 0,this.j=!1,this.c=w,this.d=w.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(w,k){this.k();let D=null;if(w instanceof R.$4J)D=new R.$5J(w,w);else if(w instanceof R.$5J)D=w;else throw new Error("Unrecognized location");this.l(D,k,!1)}insert(w,k){this.k(),this.l(new R.$5J(w,w),k,!0)}delete(w){this.k();let k=null;if(w instanceof R.$5J)k=w;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(w,k,D){const v=this.c.validateRange(w);this.g.push({range:v,text:k,forceMoveMarkers:D})}setEndOfLine(w){if(this.k(),w!==R.EndOfLine.LF&&w!==R.EndOfLine.CRLF)throw(0,F.$5)("endOfLine");this.h=w}}class p{constructor(w,k,D,v){this.c=w,this.d=k,this._accept(D),this.e=v;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.m(s)},get indentSize(){return o.g},set indentSize(s){o.o(s)},get insertSpaces(){return o.h},set insertSpaces(s){o.q(s)},get cursorStyle(){return o.j},set cursorStyle(s){o.s(s)},get lineNumbers(){return o.k},set lineNumbers(s){o.t(s)}}}_accept(w){this.f=w.tabSize,this.g=w.indentSize,this.h=w.insertSpaces,this.j=w.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(w.lineNumbers)}l(w){if(w==="auto")return"auto";if(typeof w=="number"){const k=Math.floor(w);return k>0?k:null}if(typeof w=="string"){const k=parseInt(w,10);return isNaN(k)?null:k>0?k:null}return null}m(w){const k=this.l(w);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}n(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const k=Math.floor(w);return k>0?k:null}if(typeof w=="string"){const k=parseInt(w,10);return isNaN(k)?null:k>0?k:null}return null}o(w){const k=this.n(w);if(k!==null){if(typeof k=="number"){if(this.g===k)return;this.g=k}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}p(w){return w==="auto"?"auto":w==="false"?!1:!!w}q(w){const k=this.p(w);if(typeof k=="boolean"){if(this.h===k)return;this.h=k}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}s(w){this.j!==w&&(this.j=w,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:w})))}t(w){this.k!==w&&(this.k=w,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(w)})))}assign(w){const k={};let D=!1;if(typeof w.tabSize<"u"){const v=this.l(w.tabSize);v==="auto"?(D=!0,k.tabSize=v):typeof v=="number"&&this.f!==v&&(this.f=v,D=!0,k.tabSize=v)}if(typeof w.indentSize<"u"){const v=this.n(w.indentSize);v==="tabSize"?(D=!0,k.indentSize=v):typeof v=="number"&&this.g!==v&&(this.g=v,D=!0,k.indentSize=v)}if(typeof w.insertSpaces<"u"){const v=this.p(w.insertSpaces);v==="auto"?(D=!0,k.insertSpaces=v):this.h!==v&&(this.h=v,D=!0,k.insertSpaces=v)}typeof w.cursorStyle<"u"&&this.j!==w.cursorStyle&&(this.j=w.cursorStyle,D=!0,k.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this.k!==w.lineNumbers&&(this.k=w.lineNumbers,D=!0,k.lineNumbers=L.TextEditorLineNumbersStyle.from(w.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,k))}u(w,k){k.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this.e.warn(D)})}}e.$0L=p;class A{constructor(w,k,D,v,o,s,n,l){this.id=w,this.j=k,this.k=D,this.g=!1,this.h=new Set,this.c=o,this.d=new p(this.j,this.id,s,D),this.e=n,this.f=l;const b=this;this.value=Object.freeze({get document(){return v.value},set document(h){throw new F.$7("document")},get selection(){return b.c&&b.c[0]},set selection(h){if(!(h instanceof R.$6J))throw(0,F.$5)("selection");b.c=[h],b.l()},get selections(){return b.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof R.$6J)))throw(0,F.$5)("selections");b.c=h,b.l()},get visibleRanges(){return b.e},set visibleRanges(h){throw new F.$7("visibleRanges")},get options(){return b.d.value},set options(h){b.g||b.d.assign(h)},get viewColumn(){return b.f},set viewColumn(h){throw new F.$7("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(b.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new E(v.value,t);return h(r),b.m(r)},insertSnippet(h,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(b.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=b.c.map(i=>L.Range.from(i));else if(t instanceof R.$4J){const{lineNumber:i,column:c}=L.Position.from(t);a=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof R.$5J)a=[L.Range.from(t)];else{a=[];for(const i of t)if(i instanceof R.$5J)a.push(L.Range.from(i));else{const{lineNumber:c,column:d}=L.Position.from(i);a.push({startLineNumber:c,startColumn:d,endLineNumber:c,endColumn:d})}}return k.$tryInsertSnippet(w,v.value.version,h.value,a,r)},setDecorations(h,t){const r=t.length===0;r&&!b.h.has(h.key)||(r?b.h.delete(h.key):b.h.add(h.key),b.n(()=>{if(L.$YL(t))return k.$trySetDecorations(w,h.key,L.$ZL(t));{const a=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const d=t[i];a[4*i]=d.start.line+1,a[4*i+1]=d.start.character+1,a[4*i+2]=d.end.line+1,a[4*i+3]=d.end.character+1}return k.$trySetDecorationsFast(w,h.key,a)}}))},revealRange(h,t){b.n(()=>k.$tryRevealRange(w,L.Range.from(h),t||R.TextEditorRevealType.Default))},show(h){k.$tryShowEditor(w,L.ViewColumn.from(h))},hide(){k.$tryHideEditor(w)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(w){(0,C.ok)(!this.g),this.d._accept(w)}_acceptVisibleRanges(w){(0,C.ok)(!this.g),this.e=w}_acceptViewColumn(w){(0,C.ok)(!this.g),this.f=w}_acceptSelections(w){(0,C.ok)(!this.g),this.c=w}async l(){const w=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,w)),this.value}m(w){const k=w.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const D=k.edits.map(o=>o.range);D.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=D.length-1;o<s;o++){const n=D[o].end;if(D[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=k.edits.map(o=>({range:L.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,v,{setEndOfLine:typeof k.setEndOfLine=="number"?L.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(w){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$$L=A}),define(Se[147],De([1,0,5,131]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=void 0,e.$lJ=(0,C.$Ch)(F.$Ih)}),define(Se[148],De([1,0,25,4,16,3]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E3b=e.$D3b=e.$C3b=e.$B3b=e.$A3b=e.$z3b=void 0;class R{constructor(s,n){this.versionId=s,this.removedDueToLooping=n}}e.$z3b=R;class ${static isHostExtension(s,n,l){if(n.getExtensionDescription(s))return!1;const b=l.getExtensionDescription(s);return b?!!((b.main||b.browser)&&b.api==="none"):!1}constructor(s,n){this.j=s,this.c=new F.$fd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(D),this.f=new C.$Xl,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const n=this.j.readActivationEvents(s);if(Array.isArray(n))for(let l of n)l==="onUri"&&(l=`onUri:${C.$Vl.toKey(s.identifier)}`),this.h.has(l)||this.h.set(l,[]),this.h.get(l).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,n){this.e=v(this.e,n),this.e=this.e.concat(s);const l=$.l(this.e);return this.e=v(this.e,l.map(b=>b.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,l)}static l(s){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,a){this.addNode(r),this.addNode(a),this.c.has(r)?this.c.get(r).push(a):this.c.set(r,[a])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,a){const i=n.getArcs(r);for(let c=0;c<i.length;c++)if(!a.has(i[c]))return!1;return!0}getNodes(){return this.e}},l=new C.$Xl;for(const r of s)if(l.set(r.identifier,r),r.extensionDependencies)for(const a of r.extensionDependencies)n.addArc(C.$Vl.toKey(r.identifier),C.$Vl.toKey(a));const b=new Set;n.getNodes().filter(r=>n.getArcs(r).length===0).forEach(r=>b.add(r));const h=n.getNodes().filter(r=>!b.has(r));let t;do{t=!1;for(let r=0;r<h.length;r++){const a=h[r];n.hasOnlyGoodArcs(a,b)&&(h.splice(r,1),r--,b.add(a),t=!0)}}while(t);return h.map(r=>l.get(r))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const n=this.h.get(s);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const n=this.f.get(s);return n||void 0}getExtensionDescriptionByUUID(s){for(const n of this.g)if(n.uuid===s)return n}getExtensionDescriptionByIdOrUUID(s,n){return this.getExtensionDescription(s)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$A3b=$;class E{constructor(s,n){this.versionId=s,this.extensions=n}}e.$B3b=E,e.$C3b={readActivationEvents:o=>o.activationEvents};class p{constructor(s){this.d=new w,this.c=new $(s,[])}async acquireLock(s){const n=await this.d.acquire(s);return new A(this,n)}deltaExtensions(s,n,l){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,l)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,n){return this.c.getExtensionDescriptionByIdOrUUID(s,n)}}e.$D3b=p;class A extends L.$kc{constructor(s,n){super(),this.f=s,this.c=!1,this.B(n)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$E3b=A;class I{constructor(s){this.name=s,this.promise=new Promise((n,l)=>{this.c=n})}resolve(s){this.c(s)}}class w{constructor(){this.c=[],this.d=!1}async acquire(s){const n=new I(s);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let n=!0;const l=setTimeout(()=>{n&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),b=()=>{n&&(clearTimeout(l),n=!1,this.d=!1,this.e())};s.resolve((0,L.$ic)(b))}}var k;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(k||(k={}));function D(o,s){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,l=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(n!==l)return n-l;const b=f.$6d.basename(o.extensionLocation.path),h=f.$6d.basename(s.extensionLocation.path);return b<h?-1:b>h?1:0}function v(o,s){const n=new C.$Wl(s);return o.filter(l=>!n.has(l.identifier))}}),define(Se[285],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.ExtHostConnectionType=void 0;var C;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[F.ENV_KEY]=this.pipeName}}e.$nm=F;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[f.ENV_KEY]="1"}}e.$om=f;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[L.ENV_KEY]="1"}}e.$pm=L;function R(A){delete A[F.ENV_KEY],delete A[f.ENV_KEY],delete A[L.ENV_KEY]}function $(A,I){R(I),A.serialize(I)}e.$qm=$;function E(A){if(A[F.ENV_KEY])return p(A,new F(A[F.ENV_KEY]));if(A[f.ENV_KEY])return p(A,new f);if(A[L.ENV_KEY])return p(A,new L);throw new Error("No connection information defined in environment!")}e.$rm=E;function p(A,I){return R(A),I}}),define(Se[111],De([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$5l=e.$4l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(p){p[p.Desktop=1]="Desktop",p[p.Web=2]="Web"})(F||(e.UIKind=F={}));var f;(function(p){p[p.VersionMismatch=55]="VersionMismatch",p[p.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var L;(function(p){p[p.Initialized=0]="Initialized",p[p.Ready=1]="Ready",p[p.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(p){const A=C.$Fd.alloc(1);switch(p){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$4l=R;function $(p,A){if(p.byteLength!==1)return!1;switch(p.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$5l=$;var E;(function(p){p.Start="START_NATIVE_LOG",p.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(Se[89],De([1,0,5,4,14,26,111,67,85,23,2,3,210]),function($e,e,C,F,f,L,R,$,E,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=e.$hM=e.$gM=void 0;let k=class extends I.$kc{constructor(s,n){super(),this.s=s,this.t=n,this.a=this.B(new F.$fd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$fd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:E.$eo,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(n.onDidChangeLogLevel(l=>{(0,f.$7i)(l)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,n,l){const b=this.getTelemetryDetails(),h=new D(n,l,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,n,l){this.f=s,this.g=n,this.c=l??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const n=Object.create(null);switch(n["common.extname"]=`${s.publisher}.${s.name}`,n["common.extversion"]=s.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=v(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$Pk)((0,E.$lo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const n=this.getTelemetryDetails();this.r.forEach((l,b)=>{const h=l.filter(t=>!t.isDisposed);h.length===0?this.r.delete(b):this.r.set(b,h)}),this.r.forEach(l=>{for(const b of l)b.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,n){const b=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!b)return this.r.delete(s.value),!1;let h=!1;for(const t of b)t.ignoreUnhandledExtHostErrors||(t.logError(n),h=!0);return h}};e.$gM=k,e.$gM=k=Ke([Be(0,L.$fM),Be(1,f.$6i)],k);class D{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,n,l,b,h,t,r){this.g=l,this.h=b,this.i=h,this.j=t,this.a=new F.$fd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,n){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let n="properties"in s?s.properties??{}:s;return n=(0,E.$oo)(n,[]),this.c&&(n=(0,p.$Ym)(n,this.c)),this.b||(n=(0,p.$Ym)(n,this.j)),"properties"in s?s.properties=n:s=n,s}k(s,n){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(s,n),this.h.trace(s,n))}logUsage(s,n){this.d.isUsageEnabled&&this.k(s,n)}logError(s,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,n);else{const l={name:s.name,message:s.message,stack:s.stack,cause:s.cause},b=(0,E.$oo)(l,[]),h=new Error(b.message,{cause:b.cause});h.stack=b.stack,h.name=b.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const s=this,n={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$hM=D;function v(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$iM=v,e.$jM=(0,C.$Bh)("IExtHostTelemetry")}),define(Se[27],De([1,0,4,2,252,137,25,5]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=e.$3E=e.$2E=e.ActivationKind=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.ExtensionHostStartup=e.$VE=e.$UE=e.$TE=e.$SE=void 0,e.$SE=Object.freeze({identifier:new R.$Vl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$TE="extensions.webWorker",e.$UE=(0,$.$Bh)("extensionService");class E{constructor(h){this.dependency=h}}e.$VE=E;var p;(function(b){b[b.EagerAutoStart=1]="EagerAutoStart",b[b.EagerManualStart=2]="EagerManualStart",b[b.Lazy=3]="Lazy"})(p||(e.ExtensionHostStartup=p={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,r){this.c=h,this.d=t.slice(0),this.e=r.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$DE.createActivationEventsMap(this.d)}}set(h,t,r){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const a=[],i=[],c=[],d=[],y=I(this.d),S=I(t),g=(N,M)=>N.extensionLocation.toString()===M.extensionLocation.toString()||N.isBuiltin===M.isBuiltin||N.isUserBuiltin===M.isUserBuiltin||N.isUnderDevelopment===M.isUnderDevelopment;for(const N of this.d){const M=S.get(N.identifier);if(!M){a.push(N.identifier),y.delete(N.identifier);continue}if(!g(N,M)){a.push(N.identifier),y.delete(N.identifier);continue}}for(const N of t){const M=y.get(N.identifier);if(!M){i.push(N);continue}if(!g(M,N)){a.push(M.identifier),y.delete(M.identifier);continue}}const u=new R.$Wl(this.e),m=new R.$Wl(r);for(const N of this.e)m.has(N)||c.push(N);for(const N of r)u.has(N)||d.push(N);const P=L.$DE.createActivationEventsMap(i),O={versionId:h,toRemove:a,toAdd:i,addActivationEvents:P,myToRemove:c,myToAdd:d};return this.delta(O),O}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:a,myToAdd:i}=h,c=new R.$Wl(t),d=new R.$Wl(a);for(let y=0;y<this.d.length;y++)c.has(this.d[y].identifier)&&(this.d.splice(y,1),y--);for(let y=0;y<this.e.length;y++)d.has(this.e[y])&&(this.e.splice(y,1),y--);for(const y of r)this.d.push(y);for(const y of i)this.e.push(y);return h}containsExtension(h){for(const t of this.e)if(R.$Vl.equals(t,h))return!0;return!1}}e.$WE=A;function I(b){const h=new R.$Xl;for(const t of b)h.set(t.identifier,t);return h}function w(b,h){return b.enabledApiProposals?b.enabledApiProposals.includes(h):!1}e.$XE=w;function k(b,h){if(!w(b,h))throw new Error(`Extension '${b.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${b.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.$YE=k;class D{constructor(h,t,r,a){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=a}}e.$ZE=D;class v{constructor(h,t){this.description=h,this.value=t}}e.$1E=v;var o;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,f.$uo)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation,targetPlatform:b.targetPlatform,validations:[],isValid:!0}}e.$2E=s;function n(b,h){return{identifier:new R.$Vl((0,f.$so)(b.manifest.publisher,b.manifest.name)),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!h,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid,targetPlatform:b.targetPlatform}}e.$3E=n;class l{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$4E=l}),define(Se[286],De([1,0,8,148,25,27,14,9]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=e.$wbc=e.$vbc=e.$ubc=e.$tbc=e.$sbc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(s,n,l,b){this.startup=s,this.codeLoadingTime=n,this.activateCallTime=l,this.activateResolvedTime=b}}e.$sbc=E;class p{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,n){return s===-1||n===-1?-1:n-s}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$tbc=p;class A{constructor(s,n,l,b,h,t){this.activationFailed=s,this.activationFailedError=n,this.activationTimes=l,this.module=b,this.exports=h,this.subscriptions=t}}e.$ubc=A;class I extends A{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$vbc=I;class w extends A{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$wbc=w;class k extends A{constructor(s){super(!0,s,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(s,n,l,b){this.g=b,this.a=s,this.b=n,this.c=l,this.d=new f.$Xl,this.f=Object.create(null)}dispose(){for(const[s,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const s=[];for(const[n,l]of this.d)s.push(l.wait());await Promise.all(s)}isActivated(s){const n=this.d.get(s);return!!(n&&n.value)}getActivatedExtension(s){const n=this.d.get(s);if(!n||!n.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return n.value}async activateByEvent(s,n){if(this.f[s])return;const l=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(l.map(b=>({id:b.identifier,reason:{startup:n,extensionId:b.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,n){const l=this.a.getExtensionDescription(s);if(!l)throw new Error(`Extension '${s}' is not known`);return this.h([{id:l.identifier,reason:n}])}async h(s){const n=s.filter(l=>!this.isActivated(l.id)).map(l=>this.j(l));await Promise.all(n.map(l=>l.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const n=this.a.getExtensionDescription(s.id);if(!n){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new k(h));return this.c.onExtensionActivationError(s.id,h,new L.$VE(s.id.value)),t}const l=[],b=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of b){if(this.m(h))continue;const t=this.d.get(h);if(t){l.push(t);continue}if(this.l(h)){l.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const r=this.a.getExtensionDescription(h);if(r){if(!r.main&&!r.browser)continue;l.push(this.j({id:r.identifier,reason:s.reason}));continue}const a=n.displayName||n.identifier.value,i=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${h}'`),c=this.k(s,n.displayName,[],new k(i));return this.c.onExtensionActivationError(n.identifier,i,new L.$VE(h)),c}return this.k(s,n.displayName,l,null)}k(s,n,l,b){const h=new v(s.id,n,s.reason,l,b,this.c,this.g);return this.d.set(s.id,h),h}l(s){return F.$A3b.isHostExtension(s,this.a,this.b)}m(s){const n=this.b.getExtensionDescription(s);return n?!n.main&&!n.browser:!1}};e.$xbc=D,e.$xbc=D=Ke([Be(3,R.$5i)],D);let v=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,n,l,b,h,t,r){this.c=s,this.d=n,this.f=l,this.g=b,this.h=h,this.j=t,this.k=r,this.a=new $.$Fg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const n=this.g[s];if(n.value&&!n.value.activationFailed){this.g.splice(s,1),s--;continue}if(n.value&&n.value.activationFailed){const l=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);l.detail=n.value.activationFailedError,this.h=new k(l),this.j.onExtensionActivationError(this.c,l,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const n=new Error;if(s&&s.name&&(n.name=s.name),s&&s.message?n.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(n.stack=s.stack),this.h=new k(n),this.b&&C.$2(s))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};v=Ke([Be(6,R.$5i)],v)}),define(Se[287],De([1,0,212,24,2,4,3,269,9,7,18,19,13,80,21,173,27]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=void 0;function s(b,h){if((0,A.$jf)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let t;return Array.isArray(b.highlights)&&(t=b.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:b.label,highlights:t}}}class n extends R.$kc{constructor(h,t,r){super(),this.f=h,this.g=t,this.h=r,this.a=new Map,this.b=new v.$l7;function a(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:i=>a(i)?this.r(i):Array.isArray(i)&&i.length>0?i.map(c=>a(c)?this.r(c):c):i})}registerTreeDataProvider(h,t,r){const a=this.createTreeView(h,{treeDataProvider:t},r);return{dispose:()=>a.dispose()}}createTreeView(h,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],i=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,y=this.m(h,t,r),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:i,hasHandleDrag:c,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(h,S),u={get onDidCollapseElement(){return y.onDidCollapseElement},get onDidExpandElement(){return y.onDidExpandElement},get selection(){return y.selectedElements},get onDidChangeSelection(){return y.onDidChangeSelection},get activeItem(){return(0,o.$YE)(r,"treeViewActiveItem"),y.focusedElement},get onDidChangeActiveItem(){return(0,o.$YE)(r,"treeViewActiveItem"),y.onDidChangeActiveItem},get visible(){return y.visible},get onDidChangeVisibility(){return y.onDidChangeVisibility},get onDidChangeCheckboxState(){return y.onDidChangeCheckboxState},get message(){return y.message},set message(m){(0,k.$Zj)(m)&&(0,o.$YE)(r,"treeViewMarkdownMessage"),y.message=m},get title(){return y.title},set title(m){y.title=m},get description(){return y.description},set description(m){y.description=m},get badge(){return y.badge},set badge(m){m!==void 0&&p.ViewBadge.isViewBadge(m)?y.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(y.badge=void 0)},reveal:(m,P)=>y.reveal(m,P),dispose:async()=>{await g,this.a.delete(h),y.dispose()}};return this.B(u),u}$getChildren(h,t){const r=this.a.get(h);return r?r.getChildren(t):Promise.reject(new $.$fE(h))}async $handleDrop(h,t,r,a,i,c,d,y){const S=this.a.get(h);if(!S)return Promise.reject(new $.$fE(h));const g=w.DataTransfer.toDataTransfer(r,async u=>(await this.f.$resolveDropFileData(h,t,u)).buffer);return d===h&&y&&await this.j(g,S,y,i,c),S.onDrop(g,a,i)}async j(h,t,r,a,i){const c=this.b.removeDragOperationTransfer(i);if(c)(await c)?.forEach((d,y)=>{d&&h.set(y,d)});else if(i&&t.handleDrag){const d=t.handleDrag(r,h,a);this.b.addDragOperationTransfer(i,d),await d}return h}async $handleDrag(h,t,r,a){const i=this.a.get(h);if(!i)return Promise.reject(new $.$fE(h));const c=await this.j(new p.$TK,i,t,a,r);if(!(!c||a.isCancellationRequested))return w.DataTransfer.from(c)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new $.$fE(h);return t.hasResolve}$resolve(h,t,r){const a=this.a.get(h);if(!a)throw new $.$fE(h);return a.resolveTreeItem(t,r)}$setExpanded(h,t,r){const a=this.a.get(h);if(!a)throw new $.$fE(h);a.setExpanded(t,r)}$setSelectionAndFocus(h,t,r){const a=this.a.get(h);if(!a)throw new $.$fE(h);a.setSelectionAndFocus(t,r)}$setVisible(h,t){const r=this.a.get(h);if(!r){if(!t)return;throw new $.$fE(h)}r.setVisible(t)}$changeCheckboxState(h,t){const r=this.a.get(h);if(!r)throw new $.$fE(h);r.setCheckboxState(t)}m(h,t,r){const a=this.B(new l(h,t,this.f,this.g.converter,this.h,r));return this.a.set(h,a),a}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$0bc=n;class l extends R.$kc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,A.$sf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,r,a,i,c){if(super(),this.I=h,this.J=r,this.L=a,this.M=i,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$fd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$fd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$fd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$fd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$fd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$fd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$fd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new D.$pd,c.contributes&&c.contributes.views)for(const g in c.contributes.views)for(const u of c.contributes.views[g])u.id===h&&(this.P=u.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let d,y;const S=L.Event.debounce(this.F.event,(g,u)=>(g||(g={message:!1,elements:[]}),u.element!==!1&&(d||(d=new Promise(m=>y=m),this.G=this.G.then(()=>d)),Array.isArray(u.element)?g.elements.push(...u.element):g.elements.push(u.element)),u.message&&(g.message=!0),g),200,!0);this.B(S(({message:g,elements:u})=>{u.length&&(this.H=this.H.then(()=>{const m=y;return d=null,this.$(u).then(()=>m())})),g&&this.J.$setMessage(this.I,w.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let r=this.X(h);return r||(r=await this.Y(t)),r?r.map(a=>a.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const r=(0,A.$sf)(t.select)?!0:t.select,a=(0,A.$sf)(t.focus)?!1:t.focus,i=(0,A.$sf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(c=>this.W(h,c[c.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:c.map(y=>y.item)},{select:r,focus:a,expand:i})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:r,focus:a,expand:i})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=w.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const r=this.getExtensionElement(h);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(h,t){const r=!(0,I.$sb)(this.s,h);this.s=h;const a=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async r=>{const a=this.getExtensionElement(r.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:r.newState?p.TreeItemCheckboxState.Checked:p.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?p.TreeItemCheckboxState.Checked:p.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(h,t,r){const a=[];for(const i of h){const c=this.getExtensionElement(i);c&&a.push(c)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,r){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,E.$zg)(()=>this.g?.handleDrop?this.g.handleDrop(a,h,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(h);if(r){const a=this.m.get(r);if(a){const i=await this.f.resolveTreeItem(a.extensionItem,r,t)??a.extensionItem;return this.hb(i),a.item.tooltip=this.eb(i.tooltip),a.item.command=this.fb(a.disposableStore,i.command),a.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(a=>(r.push(a),r))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$zg)(()=>this.f.getParent(h))}W(h,t){const r=this.m.get(h);return r?Promise.resolve(r):(0,E.$zg)(()=>this.f.getTreeItem(h)).then(a=>this.kb(h,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const i=this.getExtensionElement(a);if(i){const c=this.m.get(i);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const r=this.getExtensionElement(h);t=r?this.m.get(r):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new D.$pd(this.Z.token);try{const r=h?this.m.get(h):void 0,a=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const i=await Promise.all((0,I.$Fb)(a||[]).map(async c=>{const d=await this.f.getTreeItem(c);return d&&!t.token.isCancellationRequested?this.db(c,d,r):null}));return t.token.isCancellationRequested?void 0:(0,I.$Fb)(i)}finally{t.dispose()}}$(h){if(h.some(r=>!r))return this.Z.dispose(!0),this.Z=new D.$pd,this.tb(),this.J.$refresh(this.I);{const r=this.ab(h);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(h){const t=new Set,r=h.map(i=>this.m.get(i));for(const i of r)if(i&&!t.has(i.item.handle)){let c=i;for(;c&&c.parent&&r.findIndex(d=>c&&c.parent&&d&&d.item.handle===c.parent.item.handle)===-1;){const d=this.j.get(c.parent.item.handle);c=d?this.m.get(d):void 0}c&&!c.parent&&t.add(i.item.handle)}const a=[];return t.forEach(i=>{const c=this.j.get(i);if(c){const d=this.m.get(c);d&&(!d.parent||!t.has(d.parent.item.handle))&&a.push(i)}}),a}bb(h){const t={};return Promise.all(h.map(r=>this.cb(r).then(a=>{a&&(t[r]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,E.$zg)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const i=this.ib(t,a,r.parent);return this.pb(t,i,r,r.parent),r.dispose(),i}return null})}return Promise.resolve(null)}db(h,t,r){const a=this.ib(h,t,r);if(t.id&&this.j.has(a.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(h,a),this.qb(a,r),a}eb(h){return p.$qK.isMarkdownString(h)?w.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,r,a;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,r=h.checkboxState.tooltip,a=h.checkboxState.accessibilityInformation),{isChecked:t===p.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:a}}hb(h){if(!p.$OK.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,r){this.hb(t);const a=this.B(new R.$jc),i=this.kb(h,t,r),c=this.lb(t);return{item:{handle:i,parentHandle:r?r.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,A.$sf)(t.collapsibleState)?p.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(h){return h.iconPath instanceof p.$WK?h.iconPath:void 0}kb(h,{id:t,label:r,resourceUri:a},i,c){if(t)return`${l.b}/${t}`;const d=s(r,this.N),y=i?i.item.handle:l.a;let S=d?d.label:a?(0,F.$fg)(a):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const g=this.m.has(h)?this.m.get(h).item.handle:void 0,u=this.X(i)||[];let m,P=0;do{if(m=`${y}/${P}:${S}`,c||!this.j.has(m)||g===m)break;P++}while(P<=u.length);return m}lb(h){if(h.iconPath&&!(h.iconPath instanceof p.$WK))return typeof h.iconPath=="string"||f.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof p.$WK)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return f.URI.isUri(h)?h:f.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,r,a){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(h,t);const i=this.X(a)||[],c=i.filter(d=>d.item.handle===r.item.handle)[0];c&&i.splice(i.indexOf(c),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const r of t.children){const a=this.j.get(r.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const r of t.children){const a=this.j.get(r.item.handle);a&&this.sb(a)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[288],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[289],De([1,0,224,8,38,132,106,42,25,288,135,137]),function($e,e,C,F,f,L,R,$,E,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=void 0;const w=$.$8m.as(R.$9m.JSONContribution);class k{constructor(h,t,r){this.a=h,this.b=t,this.c=r}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(f.default.Error,h)}warn(h){this.d(f.default.Warning,h)}info(h){this.d(f.default.Info,h)}}e.$ME=k;class D{static a(h){const t=new E.$Wl;for(let r=0,a=h.length;r<a;r++)t.add(h[r].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new D(t,[]);if(!t||!t.length)return new D([],h);const r=this.a(h),a=this.a(t),i=t.filter(d=>!r.has(d.description.identifier)),c=h.filter(d=>!a.has(d.description.identifier));return new D(i,c)}constructor(h,t){this.added=h,this.removed=t}}e.$NE=D;class v{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=D.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,F.$Y)(h)}}}e.$OE=v;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$PE={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$Ul},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(p.allApiProposals),markdownEnumDescriptions:Object.values(p.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"*",description:C.localize(42,null),body:"*"}]}},badges:{type:"array",description:C.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(44,null)},href:{type:"string",description:C.localize(45,null)},description:{type:"string",description:C.localize(46,null)}}}},markdown:{type:"string",description:C.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Mn}},extensionPack:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Mn}},extensionKind:{description:C.localize(51,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(52,null)},{body:["workspace"],description:C.localize(53,null)},{body:["ui","workspace"],description:C.localize(54,null)},{body:["workspace","ui"],description:C.localize(55,null)},{body:[],description:C.localize(56,null)}]},capabilities:{description:C.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(60,null),C.localize(61,null),C.localize(62,null)]},description:{type:"string",markdownDescription:C.localize(63,null)}}},untrustedWorkspaces:{description:C.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(66,null),C.localize(67,null),C.localize(68,null)]},restrictedConfigurations:{description:C.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(70,null)}}}}},sponsor:{description:C.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(73,null),type:"string"},"vscode:uninstall":{description:C.localize(74,null),type:"string"}}},icon:{type:"string",description:C.localize(75,null)},l10n:{type:"string",description:C.localize(76,null)},pricing:{type:"string",markdownDescription:C.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new v(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&I.$DE.register(h.extensionPoint,h.activationEventsGenerator),e.$PE.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,w.registerSchema(s,e.$PE),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$QE=n;const l={ExtensionsRegistry:"ExtensionsRegistry"};$.$8m.add(l.ExtensionsRegistry,new n),e.$RE=$.$8m.as(l.ExtensionsRegistry),w.registerSchema(s,e.$PE),w.registerSchema(A.$lj,{properties:{extensionEnabledApiProposals:{description:C.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(p.allApiProposals),markdownEnumDescriptions:Object.values(p.allApiProposals)}}]}}}})}),define(Se[290],De([1,0,221,18,23,289,41,4]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var p;(function(w){function k(D,v,o){if(!D)return;const s=F.$jf(D.type)?D.type:void 0;if(!s||s.length===0){o.error(C.localize(3,null));return}const n=[];if(Array.isArray(D.required))for(const l of D.required)F.$jf(l)&&n.push(l);return{extensionId:v.value,taskType:s,required:n,properties:D.properties?f.$Vm(D.properties):{},when:D.when?R.$Ii.deserialize(D.when):void 0}}w.from=k})(p||(p={}));const A=L.$RE.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(w,k)=>{for(const D of w)D.type&&k.push(`onTaskType:${D.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:E}});class I{constructor(){this.d=new $.$fd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,D)=>{A.setHandler((v,o)=>{this.c=void 0;try{for(const s of o.removed){const n=s.value;for(const l of n)this.a&&l.type&&this.a[l.type]&&delete this.a[l.type]}for(const s of o.added){const n=s.value;for(const l of n){const b=p.from(l,s.description.identifier,s.collector);b&&(this.a[b.taskType]=b)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const D of this.all()){const v={type:"object",additionalProperties:!1};D.required.length>0&&(v.required=D.required.slice(0)),D.properties!==void 0?v.properties=f.$Vm(D.properties):v.properties=Object.create(null),v.properties.type={type:"string",enum:[D.taskType]},k.push(v)}this.c={oneOf:k}}return this.c}}e.$AF=new I}),define(Se[291],De([1,0,222,18,24,23,41,290]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$KF=e.JsonSchemaVersion=e.ExecutionEngine=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$EF=e.ShellQuoting=e.$DF=e.$CF=e.$BF=void 0,e.$BF="settings",e.$CF=new R.$2i("taskRunning",!1,C.localize(0,null)),e.$DF={value:C.localize(1,null),original:"Tasks"};var E;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$EF="$customized",function(z){function T(H){if(!H)return z.Strong;switch(H.toLowerCase()){case"escape":return z.Escape;case"strong":return z.Strong;case"weak":return z.Weak;default:return z.Strong}}z.from=T}(E||(e.ShellQuoting=E={}));var p;(function(z){z.defaults={cwd:"${workspaceFolder}"}})(p||(e.CommandOptions=p={}));var A;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(A||(e.RevealKind=A={})),function(z){function T(H){switch(H.toLowerCase()){case"always":return z.Always;case"silent":return z.Silent;case"never":return z.Never;default:return z.Always}}z.fromString=T}(A||(e.RevealKind=A={}));var I;(function(z){z[z.Never=1]="Never",z[z.OnProblem=2]="OnProblem",z[z.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(z){function T(H){switch(H.toLowerCase()){case"always":return z.Always;case"never":return z.Never;case"onproblem":return z.OnProblem;default:return z.OnProblem}}z.fromString=T}(I||(e.RevealProblemKind=I={}));var w;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(w||(e.PanelKind=w={})),function(z){function T(H){switch(H.toLowerCase()){case"shared":return z.Shared;case"dedicated":return z.Dedicated;case"new":return z.New;default:return z.Shared}}z.fromString=T}(w||(e.PanelKind=w={}));var k;(function(z){z.defaults={echo:!0,reveal:A.Always,revealProblems:I.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(k||(e.PresentationOptions=k={}));var D;(function(z){z[z.Shell=1]="Shell",z[z.Process=2]="Process",z[z.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function(z){function T(q){switch(q.toLowerCase()){case"shell":return z.Shell;case"process":return z.Process;case"customExecution":return z.CustomExecution;default:return z.Process}}z.fromString=T;function H(q){switch(q){case z.Shell:return"shell";case z.Process:return"process";case z.CustomExecution:return"customExecution";default:return"process"}}z.toString=H}(D||(e.RuntimeType=D={}));var v;(function(z){function T(H){return F.$jf(H)?H:H.value}z.value=T})(v||(e.CommandString=v={}));var o;(function(z){z.Clean={_id:"clean",isDefault:!1},z.Build={_id:"build",isDefault:!1},z.Rebuild={_id:"rebuild",isDefault:!1},z.Test={_id:"test",isDefault:!1};function T(q){return q===z.Clean._id||q===z.Build._id||q===z.Rebuild._id||q===z.Test._id}z.is=T;function H(q){if(q!==void 0)return F.$jf(q)?T(q)?{_id:q,isDefault:!1}:void 0:q}z.from=H})(o||(e.TaskGroup=o={}));var s;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var n;(function(z){z.Workspace="workspace",z.Extension="extension",z.InMemory="inMemory",z.WorkspaceFile="workspaceFile",z.User="user";function T(H){switch(H){case z.User:return 2;case z.WorkspaceFile:return 5;default:return 6}}z.toConfigurationTarget=T})(n||(e.TaskSourceKind=n={}));var l;(function(z){z.parallel="parallel",z.sequence="sequence"})(l||(e.DependsOrder=l={}));var b;(function(z){z[z.default=1]="default",z[z.folderOpen=2]="folderOpen"})(b||(e.RunOnOptions=b={}));var h;(function(z){z.defaults={reevaluateOnRerun:!0,runOn:b.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(T,H,q,me,Z,X){this._label="",this._id=T,H&&(this._label=H),q&&(this.type=q),this.runOptions=me,this.configurationProperties=Z,this._source=X}getDefinition(T){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,H=!1){if(T===void 0)return!1;if(F.$jf(T))return T===this._label||T===this.configurationProperties.identifier||H&&T===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$FF=t;class r extends t{constructor(T,H,q,me,Z,X,V,x){super(T,q,void 0,V,x,H),this.command={},this._source=H,this.hasDefinedMatchers=X,Z&&(this.command=Z)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case D.Shell:H="shell";break;case D.Process:H="process";break;case D.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(T){return T instanceof r}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$BF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const T=this.d();if(!T)return;let H=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(H+=this._source.kind);const q={type:e.$EF,folder:T,id:H};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new r(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$GF=r;class a extends t{constructor(T,H,q,me,Z,X,V){super(T,q,me,X,V,H),this._source=H,this.configures=Z}static is(T){return T instanceof a}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$BF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const T=this.d();if(!T)return;let H=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(H+=this._source.kind);const q={type:e.$EF,folder:T,id:H};return JSON.stringify(q)}}e.$HF=a;class i extends t{constructor(T,H,q,me,Z,X,V,x,ge){super(T,q,me,x,ge,H),this.defines=Z,this.hasDefinedMatchers=V,this.command=X,this.icon=ge.icon,this.hide=ge.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof i}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new i(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$IF=i;class c extends t{constructor(T,H,q,me,Z,X){super(T,q,me,Z,X,H),this._source=H}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new c(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$JF=c;var d;(function(z){z[z.Process=1]="Process",z[z.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(z){z._default=z.Terminal}(d||(e.ExecutionEngine=d={}));var y;(function(z){z[z.V0_1_0=1]="V0_1_0",z[z.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class S{constructor(T){this.c=new Map;for(let H=0;H<T.length;H++)this.c.set(T[H].uri.toString(),H)}compare(T,H){const q=T.getWorkspaceFolder(),me=H.getWorkspaceFolder();if(q&&me){let Z=this.c.get(q.uri.toString());Z=Z===void 0?0:Z+1;let X=this.c.get(me.uri.toString());return X=X===void 0?0:X+1,Z===X?T._label.localeCompare(H._label):Z-X}else return!q&&me?-1:q&&!me?1:0}}e.$KF=S;var g;(function(z){z.DependsOnStarted="dependsOnStarted",z.AcquiredInput="acquiredInput",z.Start="start",z.ProcessStarted="processStarted",z.Active="active",z.Inactive="inactive",z.Changed="changed",z.Terminated="terminated",z.ProcessEnded="processEnded",z.End="end"})(g||(e.TaskEventKind=g={}));var u;(function(z){z.SingleRun="singleRun",z.Background="background"})(u||(e.TaskRunType=u={}));var m;(function(z){z[z.System=0]="System",z[z.User=1]="User",z[z.FolderOpen=2]="FolderOpen",z[z.ConfigurationChange=3]="ConfigurationChange",z[z.Reconnect=4]="Reconnect"})(m||(e.TaskRunSource=m={}));var P;(function(z){function T(x){return{taskId:x._id,taskName:x.configurationProperties.name,runType:x.configurationProperties.isBackground?"background":"singleRun",group:x.configurationProperties.group,__task:x}}function H(x,ge,ue){return{...T(x),kind:"start",terminalId:ge,resolvedVariables:ue}}z.start=H;function q(x,ge,ue){return{...T(x),kind:"processStarted",terminalId:ge,processId:ue}}z.processStarted=q;function me(x,ge,ue){return{...T(x),kind:"processEnded",terminalId:ge,exitCode:ue}}z.processEnded=me;function Z(x,ge,ue){return{...T(x),kind:"terminated",exitReason:ue,terminalId:ge}}z.terminated=Z;function X(x,ge,ue){return{...T(ge),kind:x,terminalId:ue}}z.general=X;function V(){return{kind:"changed"}}z.changed=V})(P||(e.TaskEvent=P={}));var O;(function(z){function T(q){const me=Object.keys(q).sort();let Z="";for(const X of me){let V=q[X];V instanceof Object?V=T(V):typeof V=="string"&&(V=V.replace(/,/g,",,")),Z+=X+","+V+","}return Z}function H(q){const Z={_key:T(q),type:q.taskType};return Object.assign(Z,q),Z}z.create=H})(O||(e.KeyedTaskIdentifier=O={}));var N;(function(z){z.AutoDetect="task.autoDetect",z.SaveBeforeRun="task.saveBeforeRun",z.ShowDecorations="task.showDecorations",z.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",z.SlowProviderWarning="task.slowProviderWarning",z.QuickOpenHistory="task.quickOpen.history",z.QuickOpenDetail="task.quickOpen.detail",z.QuickOpenSkip="task.quickOpen.skip",z.QuickOpenShowAll="task.quickOpen.showAll",z.AllowAutomaticTasks="task.allowAutomaticTasks",z.Reconnection="task.reconnection"})(N||(e.TaskSettingId=N={}));var M;(function(z){z.Tasks="tasks",z.SuppressTaskName="tasks.suppressTaskName",z.Windows="tasks.windows",z.Osx="tasks.osx",z.Linux="tasks.linux",z.ShowOutput="tasks.showOutput",z.IsShellCommand="tasks.isShellCommand",z.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var j;(function(z){function T(H,q){const me=$.$AF.get(H.type);if(me===void 0){const x=L.$Vm(H);return delete x._key,O.create(x)}const Z=Object.create(null);Z.type=me.taskType;const X=new Set;me.required.forEach(x=>X.add(x));const V=me.properties;for(const x of Object.keys(V)){const ge=H[x];if(ge!=null)Z[x]=ge;else if(X.has(x)){const ue=V[x];if(ue.default!==void 0)Z[x]=L.$Vm(ue.default);else switch(ue.type){case"boolean":Z[x]=!1;break;case"number":case"integer":Z[x]=0;break;case"string":Z[x]="";break;default:q.error(C.localize(2,null,JSON.stringify(H,void 0,0),x));return}}}return O.create(Z)}z.createTaskIdentifier=T})(j||(e.TaskDefinition=j={}))}),define(Se[292],De([1,0,8]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G3b=e.$F3b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,C.$Y)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$F3b=F;class f extends F{constructor(){super(),this.h=!0,this.i=new C.$3}}e.$G3b=f}),define(Se[70],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gv=e.$fv=e.$ev=e.$dv=void 0;class C{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++C.count}}e.$dv=C;const F=[];function f($){const E=new C($);return F[E.nid]=E,E}e.$ev=f;function L($){return F[$].sid}e.$fv=L;class R{constructor(E){this.value=E}}e.$gv=R}),define(Se[6],De([1,0,70]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.$1J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$ZJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var f;(function(v){v[v.UnknownInput=0]="UnknownInput",v[v.TextInput=1]="TextInput",v[v.TextDiffInput=2]="TextDiffInput",v[v.TextMergeInput=3]="TextMergeInput",v[v.NotebookInput=4]="NotebookInput",v[v.NotebookDiffInput=5]="NotebookDiffInput",v[v.CustomEditorInput=6]="CustomEditorInput",v[v.WebviewEditorInput=7]="WebviewEditorInput",v[v.TerminalEditorInput=8]="TerminalEditorInput",v[v.InteractiveEditorInput=9]="InteractiveEditorInput"})(f||(e.TabInputKind=f={}));var L;(function(v){v[v.TAB_OPEN=0]="TAB_OPEN",v[v.TAB_CLOSE=1]="TAB_CLOSE",v[v.TAB_UPDATE=2]="TAB_UPDATE",v[v.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(v){v[v.Editable=0]="Editable",v[v.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(v){v[v.Int8Array=1]="Int8Array",v[v.Uint8Array=2]="Uint8Array",v[v.Uint8ClampedArray=3]="Uint8ClampedArray",v[v.Int16Array=4]="Int16Array",v[v.Uint16Array=5]="Uint16Array",v[v.Int32Array=6]="Int32Array",v[v.Uint32Array=7]="Uint32Array",v[v.Float32Array=8]="Float32Array",v[v.Float64Array=9]="Float64Array",v[v.BigInt64Array=10]="BigInt64Array",v[v.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var E;(function(v){v[v.Text=1]="Text",v[v.Error=2]="Error",v[v.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var p;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(p||(e.NotebookEditorRevealType=p={}));var A;(function(v){v[v.None=0]="None",v[v.Process=1]="Process",v[v.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class I{static{this.a=0}static mixin(o){return o._id=I.a++,o}}e.$ZJ=I;var w;(function(v){v.label="a",v.kind="b",v.detail="c",v.documentation="d",v.sortText="e",v.filterText="f",v.preselect="g",v.insertText="h",v.insertTextRules="i",v.range="j",v.commitCharacters="k",v.additionalTextEdits="l",v.kindModifier="m",v.commandIdent="n",v.commandId="o",v.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var k;(function(v){v.defaultRanges="a",v.completions="b",v.isIncomplete="c",v.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var D;(function(v){v[v.Workspace=0]="Workspace",v[v.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.$1J={MainThreadAuthentication:(0,C.$ev)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$ev)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$ev)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,C.$ev)("MainThreadChatSlashCommands"),MainThreadChatAgents:(0,C.$ev)("MainThreadChatAgents"),MainThreadChatVariables:(0,C.$ev)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$ev)("MainThreadClipboard"),MainThreadCommands:(0,C.$ev)("MainThreadCommands"),MainThreadComments:(0,C.$ev)("MainThreadComments"),MainThreadConfiguration:(0,C.$ev)("MainThreadConfiguration"),MainThreadConsole:(0,C.$ev)("MainThreadConsole"),MainThreadDebugService:(0,C.$ev)("MainThreadDebugService"),MainThreadDecorations:(0,C.$ev)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$ev)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$ev)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$ev)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$ev)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$ev)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$ev)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$ev)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$ev)("MainThreadErrors"),MainThreadTreeViews:(0,C.$ev)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$ev)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$ev)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$ev)("MainThreadLanguages"),MainThreadLogger:(0,C.$ev)("MainThreadLogger"),MainThreadMessageService:(0,C.$ev)("MainThreadMessageService"),MainThreadOutputService:(0,C.$ev)("MainThreadOutputService"),MainThreadProgress:(0,C.$ev)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$ev)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$ev)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$ev)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$ev)("MainThreadSecretState"),MainThreadStorage:(0,C.$ev)("MainThreadStorage"),MainThreadTelemetry:(0,C.$ev)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$ev)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$ev)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$ev)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$ev)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$ev)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$ev)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$ev)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$ev)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$ev)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$ev)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.$ev)("MainThreadExtensionService"),MainThreadSCM:(0,C.$ev)("MainThreadSCM"),MainThreadSearch:(0,C.$ev)("MainThreadSearch"),MainThreadShare:(0,C.$ev)("MainThreadShare"),MainThreadTask:(0,C.$ev)("MainThreadTask"),MainThreadWindow:(0,C.$ev)("MainThreadWindow"),MainThreadLabelService:(0,C.$ev)("MainThreadLabelService"),MainThreadNotebook:(0,C.$ev)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$ev)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$ev)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$ev)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$ev)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$ev)("MainThreadInteractive"),MainThreadChat:(0,C.$ev)("MainThreadChat"),MainThreadInlineChat:(0,C.$ev)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$ev)("MainThreadTheming"),MainThreadTunnelService:(0,C.$ev)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$ev)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$ev)("MainThreadTimeline"),MainThreadTesting:(0,C.$ev)("MainThreadTesting"),MainThreadLocalization:(0,C.$ev)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$ev)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$ev)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$ev)("MainThreadIssueReporter")},e.$2J={ExtHostCommands:(0,C.$ev)("ExtHostCommands"),ExtHostConfiguration:(0,C.$ev)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$ev)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$ev)("ExtHostDebugService"),ExtHostDecorations:(0,C.$ev)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$ev)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$ev)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$ev)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$ev)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$ev)("ExtHostEditors"),ExtHostTreeViews:(0,C.$ev)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$ev)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$ev)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$ev)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$ev)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$ev)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$ev)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$ev)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$ev)("ExtHostStatusBar"),ExtHostShare:(0,C.$ev)("ExtHostShare"),ExtHostExtensionService:(0,C.$ev)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$ev)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$ev)("ExtHostTerminalService"),ExtHostSCM:(0,C.$ev)("ExtHostSCM"),ExtHostSearch:(0,C.$ev)("ExtHostSearch"),ExtHostTask:(0,C.$ev)("ExtHostTask"),ExtHostWorkspace:(0,C.$ev)("ExtHostWorkspace"),ExtHostWindow:(0,C.$ev)("ExtHostWindow"),ExtHostWebviews:(0,C.$ev)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$ev)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$ev)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$ev)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$ev)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$ev)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$ev)("ExtHostProgress"),ExtHostComments:(0,C.$ev)("ExtHostComments"),ExtHostSecretState:(0,C.$ev)("ExtHostSecretState"),ExtHostStorage:(0,C.$ev)("ExtHostStorage"),ExtHostUrls:(0,C.$ev)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$ev)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$ev)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$ev)("ExtHostOutputService"),ExtHosLabelService:(0,C.$ev)("ExtHostLabelService"),ExtHostNotebook:(0,C.$ev)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$ev)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$ev)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$ev)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$ev)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$ev)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$ev)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$ev)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$ev)("ExtHostChat"),ExtHostChatSlashCommands:(0,C.$ev)("ExtHostChatSlashCommands"),ExtHostChatAgents:(0,C.$ev)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$ev)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$ev)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,C.$ev)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$ev)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$ev)("ExtHostTheming"),ExtHostTunnelService:(0,C.$ev)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$ev)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$ev)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$ev)("ExtHostTimeline"),ExtHostTesting:(0,C.$ev)("ExtHostTesting"),ExtHostTelemetry:(0,C.$ev)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$ev)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$ev)("ExtHostIssueReporter")}}),define(Se[293],De([1,0,6,7]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;class f{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(C.$1J.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,E){if(this.a.size===0)throw new Error("No related information providers registered");const p=this.a.get(R);if(!p)throw new Error("related information provider not found");return await p.provideRelatedInformation($,E)??[]}getRelatedInformation(R,$,E){return this.c.$getAiRelatedInformation($,E)}registerRelatedInformationProvider(R,$,E){const p=this.b;return this.b++,this.a.set(p,E),this.c.$registerAiRelatedInformationProvider(p,$),new F.$3J(()=>{this.c.$unregisterAiRelatedInformationProvider(p),this.a.delete(p)})}}e.$_cc=f}),define(Se[90],De([1,0,5,14,6,20]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=e.$cbc=e.$bbc=void 0,e.$bbc=(0,C.$Bh)("IExtHostApiDeprecationService");let R=class{constructor(E,p){this.c=p,this.a=new Set,this.b=E.getProxy(f.$1J.MainThreadTelemetry)}report(E,p,A){const I=this.d(E,p);this.a.has(I)||(this.a.add(I),p.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:p.identifier.value,apiId:E}))}d(E,p){return`${E}-${p.identifier.value}`}};e.$cbc=R,e.$cbc=R=Ke([Be(0,L.$2L),Be(1,F.$5i)],R),e.$dbc=Object.freeze(new class{report($,E,p){}})}),define(Se[294],De([1,0,4,6,7,25]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=void 0;class R{constructor(p){this.b=new Map,this.c=[],this.d=new C.$fd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=p.getProxy(F.$1J.MainThreadAuthentication)}$setProviders(p){return this.c=p,Promise.resolve()}async getSession(p,A,I,w={}){const k=L.$Vl.toKey(p.identifier),D=[...I].sort().join(" ");return await this.f.getOrCreate(`${k} ${A} ${D}`,async()=>{await this.a.$ensureProvider(A);const v=p.displayName||p.name;return this.a.$getSession(A,I,k,v,w)})}async getSessions(p,A,I){const w=L.$Vl.toKey(p.identifier),k=[...I].sort().join(" ");return await this.g.getOrCreate(`${w} ${k}`,async()=>{await this.a.$ensureProvider(A);const D=p.displayName||p.name;return this.a.$getSessions(A,I,w,D)})}async removeSession(p,A){const I=this.b.get(p);return I?I.provider.removeSession(A):this.a.$removeSession(p,A)}registerAuthenticationProvider(p,A,I,w){if(this.b.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this.b.set(p,{label:A,provider:I,options:w??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===p)||this.c.push({id:p,label:A});const k=I.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions(p,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider(p,A,w?.supportsMultipleAccounts??!1),new f.$3J(()=>{k.dispose(),this.b.delete(p);const D=this.c.findIndex(v=>v.id===p);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider(p)})}$createSession(p,A,I){const w=this.b.get(p);if(w)return Promise.resolve(w.provider.createSession(A,I));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$removeSession(p,A){const I=this.b.get(p);if(I)return Promise.resolve(I.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$getSessions(p,A){const I=this.b.get(p);if(I)return Promise.resolve(I.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,A){return this.d.fire({provider:{id:p,label:A}}),Promise.resolve()}}e.$Jcc=R;class ${constructor(){this.a=new Map}getOrCreate(p,A){const I=this.a.get(p);if(I)return I;const w=A().finally(()=>this.a.delete(p));return this.a.set(p,w),w}}}),define(Se[295],De([1,0,6,20,13]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;let L=class{constructor($,E){this.a=$.getProxy(C.$1J.MainThreadBulkEdits),this.b={getTextDocumentVersion:p=>E.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,E,p){const A=f.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,p?.isRefactoring??!1)}};e.$Pcc=L,e.$Pcc=L=Ke([Be(0,F.$2L)],L)}),define(Se[296],De([1,0,9,4,50,3,37,202,6,13]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class A{static{this.a=0}constructor(k,D){this.extension=k,this.provider=D,this.handle=A.a++}}class I{static{this.a=0}constructor(k,D){this.h=D,this.b=new Map,this.d=new Map,this.e=new F.$fd,this.onDidPerformUserAction=this.e.event,this.g=k.getProxy(E.$1J.MainThreadChat)}registerChatProvider(k,D,v){const o=new A(k,v);return this.b.set(o.handle,o),this.g.$registerChatProvider(o.handle,D),(0,L.$ic)(()=>{this.g.$unregisterChatProvider(o.handle),this.b.delete(o.handle)})}transferChatSession(k,D){const v=f.Iterable.find(this.d.keys(),o=>this.d.get(o)===k)??0;typeof v=="number"&&this.g.$transferChatSession(v,D)}addChatRequest(k){this.g.$addRequest(k)}sendInteractiveRequestToProvider(k,D){this.g.$sendRequestToProvider(k,D)}async $prepareChat(k,D,v){const o=this.b.get(k);if(!o)return;const s=await o.provider.prepareSession(D,v);if(!s)return;const n=I.a++;return this.d.set(n,s),{id:n,requesterUsername:s.requester?.name,requesterAvatarIconUri:s.requester?.icon,responderUsername:s.responder?.name,responderAvatarIconUri:s.responder?.icon,inputPlaceholder:s.inputPlaceholder}}async $resolveRequest(k,D,v,o){const s=this.b.get(k);if(!s)return;const n=this.d.get(D);if(!n||!s.provider.resolveRequest)return;const l=await s.provider.resolveRequest(n,v,o);if(l)return{message:typeof l.message=="string"?l.message:p.ChatReplyFollowup.from(l.message)}}async $provideWelcomeMessage(k,D){const v=this.b.get(k);if(!v||!v.provider.provideWelcomeMessage)return;const o=await v.provider.provideWelcomeMessage(D);if(o)return o.map(s=>typeof s=="string"?s:s.map(n=>p.ChatReplyFollowup.from(n)))}async $provideFollowups(k,D,v){const o=this.b.get(k);if(!o)return;const s=this.d.get(D);return!s||!o.provider.provideFollowups?void 0:(await o.provider.provideFollowups(s,v))?.map(l=>p.ChatFollowup.from(l))}$removeRequest(k,D,v){const o=this.b.get(k);if(!o)return;const s=this.d.get(D);s&&o.provider.removeRequest&&o.provider.removeRequest(s,v)}async $provideReply(k,D,v,o){const s=this.b.get(k);if(!s)return;const n=this.d.get(D);if(!n)return;const l={session:n,message:typeof v.message=="string"?v.message:p.ChatReplyFollowup.to(v.message),variables:{}};if(v.variables)for(const i of Object.keys(v.variables))l.variables[i]=v.variables[i].map(p.ChatVariable.to);const b=R.$bd.create(!1);let h;const t={report:i=>{if(!o.isCancellationRequested)if(typeof h>"u"&&(h=b.elapsed()),"responseId"in i)this.g.$acceptResponseProgress(k,D,{requestId:i.responseId});else if("placeholder"in i&&"resolvedContent"in i){const c=Promise.all([this.g.$acceptResponseProgress(k,D,{placeholder:i.placeholder}),i.resolvedContent]);(0,C.$vg)(c,o).then(d=>{if(!d)return;const[y,S]=d;this.g.$acceptResponseProgress(k,D,S,y??void 0)})}else"content"in i?this.g.$acceptResponseProgress(k,D,{content:typeof i.content=="string"?i.content:p.MarkdownString.from(i.content)}):this.g.$acceptResponseProgress(k,D,i)}};let r;try{r=await s.provider.provideResponseWithProgress(l,t,o),r||(r={errorDetails:{message:(0,$.localize)(0,null)}})}catch(i){r={errorDetails:{message:(0,$.localize)(1,null,i.message),responseIsIncomplete:!0}},this.h.error(i)}try{if(n.saveState&&this.d.has(D)){const i=n.saveState();this.g.$acceptChatState(D,i)}}catch(i){this.h.warn(i)}const a={firstProgress:h??0,totalElapsed:b.elapsed()};return{errorDetails:r.errorDetails,timings:a}}async $provideSlashCommands(k,D,v){const o=this.b.get(k);if(!o)return;const s=this.d.get(D);return!s||!o.provider.provideSlashCommands?void 0:(await o.provider.provideSlashCommands(s,v))?.map(l=>({...l,kind:p.CompletionItemKind.from(l.kind)}))}$releaseSession(k){this.d.delete(k)}async $onDidPerformUserAction(k){this.e.fire(k)}}e.$4cc=I}),define(Se[297],De([1,0,9,3,65,6,13,7]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;class E{static{this.a=0}constructor(I,w,k){this.d=w,this.e=k,this.b=new Map,this.c=I.getProxy(L.$1J.MainThreadChatAgents)}registerAgent(I,w,k,D){const v=E.a++;return this.b.set(v,{extension:I,agent:k}),this.c.$registerAgent(v,w,D),(0,F.$ic)(()=>{this.c.$unregisterAgent(v),this.b.delete(v)})}async $invokeAgent(I,w,k,D,v){const o=this.b.get(I);if(!o){this.e.warn(`[CHAT](${I}) CANNOT invoke agent because the agent is not registered`);return}let s=!1;function n(){if(s)throw new Error("Only valid while executing the command")}const l=new C.$2g;v.onCancellationRequested(()=>l.complete()),setTimeout(()=>l.complete(),3*1e3),this.d.allowListExtensionWhile(o.extension,l.p);const b=o.agent({role:$.ChatMessageRole.User,content:k},{history:D.history.map(R.ChatMessage.to)},new f.$Vu(h=>{n(),this.c.$handleProgressChunk(w,{content:p(h.message)?h.message:h.message.value})}),v);try{return await(0,C.$vg)(Promise.resolve(b).then(h=>{if(h&&"followUp"in h)return{followUp:h?.followUp?.map(r=>R.ChatFollowup.from(r))}}),v)}finally{s=!0,l.complete()}}}e.$bdc=E;function p(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Se[298],De([1,0,3,6,13,65,25]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;class ${static{this.a=1}constructor(p,A){this.d=A,this.c=new Map,this.e=new Map,this.f=new R.$Xl,this.b=p.getProxy(F.$1J.MainThreadChatProvider)}registerProvider(p,A,I,w){const k=$.a++;return this.c.set(k,{extension:p,provider:I}),this.b.$registerProvider(k,A,{extension:p,displayName:w.name??p.value}),(0,C.$ic)(()=>{this.b.$unregisterProvider(k),this.c.delete(k)})}async $provideChatResponse(p,A,I,w,k){const D=this.c.get(p);if(!D)return;const v=new L.$Vu(async o=>{if(k.isCancellationRequested){this.d.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(A,{index:o.index,part:o.part})},{async:!0});return D.provider.provideChatResponse(I.map(f.ChatMessage.to),w,v,k)}allowListExtensionWhile(p,A){this.f.set(p,A),A.finally(()=>this.f.delete(p))}async requestChatResponseProvider(p,A){if(!this.f.has(p))throw new Error("Extension is NOT allowed to make chat requests");const I=this;return{get isRevoked(){return!I.f.has(p)},async makeRequest(w,k,D,v){if(!I.f.has(p))throw new Error("Access to chat has been revoked");const o=Math.random()*1e6|0;I.e.set(o,D);try{await I.b.$fetchResponse(p,A,o,w.map(f.ChatMessage.from),k,v)}finally{I.e.delete(o)}}}}async $handleResponseFragment(p,A){this.e.get(p)?.report(A)}}e.$9cc=$}),define(Se[299],De([1,0,3,6,7,13,65,9]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class E{static{this.a=0}constructor(I,w,k){this.d=w,this.e=k,this.b=new Map,this.c=I.getProxy(F.$1J.MainThreadChatSlashCommands)}registerCommand(I,w,k,D){const v=E.a++;return this.b.set(v,{extension:I,command:k}),this.c.$registerCommand(v,w,D.description),(0,C.$ic)(()=>{this.c.$unregisterCommand(v),this.b.delete(v)})}async $executeCommand(I,w,k,D,v){const o=this.b.get(I);if(!o){this.e.warn(`[CHAT](${I}) CANNOT execute command because the command is not registered`);return}let s=!1;function n(){if(s)throw new Error("Only valid while executing the command")}const l=new $.$2g;v.onCancellationRequested(()=>l.complete()),setTimeout(()=>l.complete(),3*1e3),this.d.allowListExtensionWhile(o.extension,l.p);const b=o.command({role:f.ChatMessageRole.User,content:k},{history:D.history.map(L.ChatMessage.to)},new R.$Vu(h=>{n(),this.c.$handleProgressChunk(w,{content:p(h.message)?h.message:h.message.value})}),v);try{return await(0,$.$vg)(Promise.resolve(b).then(h=>{if(h&&"followUp"in h)return{followUp:h?.followUp?.map(r=>L.ChatFollowup.from(r))}}),v)}finally{s=!0,l.complete()}}}e.$0cc=E;function p(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Se[300],De([1,0,3,6,8,13]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class R{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(F.$1J.MainThreadChatVariables)}async $resolveVariable(E,p,A){const I=this.b.get(E);if(I)try{const w=await I.resolver.resolve(I.data.name,{message:p},A);if(w)return w.map(L.ChatVariable.from)}catch(w){(0,f.$Z)(w)}}registerVariableResolver(E,p,A,I){const w=R.a++;return this.b.set(w,{extension:E.identifier,data:{name:p,description:A},resolver:I}),this.c.$registerVariable(w,{name:p,description:A}),(0,C.$ic)(()=>{this.b.delete(w),this.c.$unregisterVariable(w)})}}e.$$cc=R}),define(Se[301],De([1,0,6]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=void 0;class F{constructor(L){const R=L.getProxy(C.$1J.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$gbc=F}),define(Se[33],De([1,0,18,7,13,23,6,19,14,63,34,62,2,3,5,20,145,22,70,46,37,85,89]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=void 0;let r=class{#e;#t;#i;constructor(S,g,u){this.b=new Map,this.c=new Map,this.#e=S.getProxy(R.$1J.MainThreadCommands),this.d=g,this.#i=u,this.#t=S.getProxy(R.$1J.MainThreadTelemetry),this.converter=new a(this,m=>{const P=this.c.get(m);return P?.result===c.Void?P:void 0},g),this.f=[{processArgument(m){return(0,p.$$g)(m)}},{processArgument(m){return(0,L.$Xm)(m,function(P){if(A.$ks.isIRange(P))return f.Range.to(P);if(I.$js.isIPosition(P))return f.Position.to(P);if(A.$ks.isIRange(P.range)&&w.URI.isUri(P.uri))return f.location.to(P);if(P instanceof s.$Fd)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const g=this.registerCommand(!1,S.id,async(...u)=>{const m=S.args.map((O,N)=>{if(!O.validate(u[N]))throw new Error(`Invalid argument '${O.name}' when running '${S.id}', received: ${u[N]}`);return O.convert(u[N])}),P=await this.executeCommand(S.internalId,...m);return S.result.convert(P,u,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new F.$3J(()=>{g.dispose(),this.c.delete(S.id)})}registerCommand(S,g,u,m,P,O){if(this.d.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this.b.has(g))throw new Error(`command '${g}' already exists`);return this.b.set(g,{callback:u,thisArg:m,description:P,extension:O}),S&&this.#e.$registerCommand(g),new F.$3J(()=>{this.b.delete(g)&&S&&this.#e.$unregisterCommand(g)})}executeCommand(S,...g){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,g,!0)}async g(S,g,u){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,g,!1);{let m=!1;const P=(0,L.$Xm)(g,function(O){if(O instanceof F.$4J)return f.Position.from(O);if(O instanceof F.$5J)return f.Range.from(O);if(O instanceof F.$cK)return f.location.from(O);if(F.$nL.isNotebookRange(O))return f.NotebookRange.from(O);if(O instanceof ArrayBuffer)return m=!0,s.$Fd.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return m=!0,s.$Fd.wrap(O);if(O instanceof s.$Fd)return m=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(S,m?new n.$gv(P):P,u);return(0,p.$$g)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(S,g,!1);throw O}}}async h(S,g,u){const m=this.b.get(S);if(!m)throw new Error("Unknown command");const{callback:P,thisArg:O,description:N}=m;if(N)for(let j=0;j<N.args.length;j++)try{(0,C.$Af)(g[j],N.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${N.args[j].name}' - ${N.args[j].description}`)}const M=b.$bd.create();try{return await P.apply(O,g)}catch(j){if(S===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...g);z&&(S=z.command)}if(this.d.error(j,S,m.extension?.identifier),!u)throw j;if(m.extension?.identifier){const z=this.#i.onExtensionError(m.extension.identifier,j);this.d.trace("forwarded error to extension?",z,m.extension?.identifier)}throw new class extends Error{constructor(){super((0,l.$mi)(j)),this.id=S,this.source=m.extension?.displayName??m.extension?.name}}}finally{this.j(m,S,M.elapsed())}}j(S,g,u){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new h.$_n(g),duration:u})}$executeContributedCommand(S,...g){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const u=this.b.get(S);return u?(g=g.map(m=>this.f.reduce((P,O)=>O.processArgument(P,u.extension?.identifier),m)),this.h(S,g,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(g=>(S&&(g=g.filter(u=>u[0]!=="_")),g))}$getContributedCommandHandlerDescriptions(){const S=Object.create(null);for(const[g,u]of this.b){const{description:m}=u;m&&(S[g]=m)}return Promise.resolve(S)}};e.$kM=r,e.$kM=r=Ke([Be(0,v.$2L),Be(1,E.$5i),Be(2,t.$jM)],r),e.$lM=(0,D.$Bh)("IExtHostCommands");class a{constructor(S,g,u){this.d=S,this.f=g,this.g=u,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,g){if(!S)return;const u={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return u;const m=this.f(S.command);if(m)u.id=m.internalId,u.arguments=m.args.map((P,O)=>P.convert(S.arguments&&S.arguments[O]));else if((0,$.$Jb)(S.arguments)){const P=`${S.command}/${++this.c}`;this.b.set(P,S),g.add((0,k.$ic)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),u.$ident=P,u.id=this.delegatingCommandId,u.arguments=[P],this.g.trace("CommandsConverter#CREATE",S.command,P)}return u}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const g=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],g?g.command:"MISSING"),g?this.d.executeCommand(g.command,...g.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$mM=a;class i{static{this.Uri=new i("uri","Uri of a text document",S=>w.URI.isUri(S),S=>S)}static{this.Position=new i("position","A position in a text document",S=>F.$4J.isPosition(S),f.Position.from)}static{this.Range=new i("range","A range in a text document",S=>F.$5J.isRange(S),f.Range.from)}static{this.Selection=new i("selection","A selection in a text document",S=>F.$6J.isSelection(S),f.Selection.from)}static{this.Number=new i("number","",S=>typeof S=="number",S=>S)}static{this.String=new i("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=i.Arr(i.String)}static Arr(S){return new i(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,g=>Array.isArray(g)&&g.every(u=>S.validate(u)),g=>g.map(u=>S.convert(u)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",S=>S instanceof F.$mK,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",S=>S instanceof F.$GL,f.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",S=>S instanceof o.$cM,f.TestItem.from)}constructor(S,g,u,m){this.name=S,this.description=g,this.validate=u,this.convert=m}optional(){return new i(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,g){return new i(S??this.name,g??this.description,this.validate,this.convert)}}e.$nM=i;class c{static{this.Void=new c("no result",S=>S)}constructor(S,g){this.description=S,this.convert=g}}e.$oM=c;class d{constructor(S,g,u,m,P){this.id=S,this.internalId=g,this.description=u,this.args=m,this.result=P}}e.$pM=d}),define(Se[302],De([1,0,19,17,2,83,129,41,134,33,13,7]),function($e,e,C,F,f,L,R,$,E,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=void 0;const w=[new p.$pM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$nM.Uri,p.$nM.Position],new p.$oM("A promise that resolves to an array of DocumentHighlight-instances.",D(A.DocumentHighlight.to))),new p.$pM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$nM.Uri],new p.$oM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,s)=>{if((0,C.$Ib)(o))return;class n extends I.$hK{static to(b){const h=new n(b.name,A.SymbolKind.to(b.kind),b.containerName||"",new I.$cK(s[0],A.Range.to(b.range)));return h.detail=b.detail,h.range=h.location.range,h.selectionRange=A.Range.to(b.selectionRange),h.children=b.children?b.children.map(n.to):[],h}}return o.map(n.to)})),new p.$pM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$nM.Uri,new p.$nM("options","Formatting options",o=>!0,o=>o)],new p.$oM("A promise that resolves to an array of TextEdits.",D(A.TextEdit.to))),new p.$pM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$nM.Uri,p.$nM.Range,new p.$nM("options","Formatting options",o=>!0,o=>o)],new p.$oM("A promise that resolves to an array of TextEdits.",D(A.TextEdit.to))),new p.$pM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$nM.Uri,p.$nM.Position,new p.$nM("ch","Trigger character",o=>typeof o=="string",o=>o),new p.$nM("options","Formatting options",o=>!0,o=>o)],new p.$oM("A promise that resolves to an array of TextEdits.",D(A.TextEdit.to))),new p.$pM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$nM.Uri,p.$nM.Position],new p.$oM("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$pM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$nM.Uri,p.$nM.Position],new p.$oM("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$pM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$nM.Uri,p.$nM.Position],new p.$oM("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$pM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$nM.Uri,p.$nM.Position],new p.$oM("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$pM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$nM.Uri,p.$nM.Position],new p.$oM("A promise that resolves to an array of Location-instances.",D(A.location.to))),new p.$pM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$nM.Uri,p.$nM.Position],new p.$oM("A promise that resolves to an array of Hover-instances.",D(A.Hover.to))),new p.$pM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$nM.Uri,new p.$nM("position","A position in a text document",o=>Array.isArray(o)&&o.every(s=>I.$4J.isPosition(s)),o=>o.map(A.Position.from))],new p.$oM("A promise that resolves to an array of ranges.",o=>o.map(s=>{let n;for(const l of s.reverse())n=new I.$lK(A.Range.to(l),n);return n}))),new p.$pM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$nM.String.with("query","Search string")],new p.$oM("A promise that resolves to an array of SymbolInformation-instances.",o=>o.map(A.WorkspaceSymbol.to))),new p.$pM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$nM.Uri,p.$nM.Position],new p.$oM("A promise that resolves to an array of CallHierarchyItem-instances",o=>o.map(A.CallHierarchyItem.to))),new p.$pM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$nM.CallHierarchyItem],new p.$oM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",o=>o.map(A.CallHierarchyIncomingCall.to))),new p.$pM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$nM.CallHierarchyItem],new p.$oM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",o=>o.map(A.CallHierarchyOutgoingCall.to))),new p.$pM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$nM.Uri,p.$nM.Position],new p.$oM("A promise that resolves to a range and placeholder text.",o=>{if(o)return{range:A.Range.to(o.range),placeholder:o.text}})),new p.$pM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$nM.Uri,p.$nM.Position,p.$nM.String.with("newName","The new symbol name")],new p.$oM("A promise that resolves to a WorkspaceEdit.",o=>{if(o){if(o.rejectReason)throw new Error(o.rejectReason);return A.WorkspaceEdit.to(o)}})),new p.$pM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$nM.Uri,p.$nM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$oM("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(A.DocumentLink.to))),new p.$pM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$nM.Uri],new p.$oM("A promise that resolves to SemanticTokensLegend.",o=>{if(o)return new I.$fL(o.tokenTypes,o.tokenModifiers)})),new p.$pM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$nM.Uri],new p.$oM("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const s=(0,R.$w0)(o);if(s.type==="full")return new I.$hL(s.data,void 0)})),new p.$pM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$nM.Uri,p.$nM.Range.optional()],new p.$oM("A promise that resolves to SemanticTokensLegend.",o=>{if(o)return new I.$fL(o.tokenTypes,o.tokenModifiers)})),new p.$pM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$nM.Uri,p.$nM.Range],new p.$oM("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const s=(0,R.$w0)(o);if(s.type==="full")return new I.$hL(s.data,void 0)})),new p.$pM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$nM.Uri,p.$nM.Position,p.$nM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$nM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$oM("A promise that resolves to a CompletionList-instance.",(o,s,n)=>{if(!o)return new I.$xK([]);const l=o.suggestions.map(b=>A.CompletionItem.to(b,n));return new I.$xK(l,o.incomplete)})),new p.$pM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$nM.Uri,p.$nM.Position,p.$nM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$oM("A promise that resolves to SignatureHelp.",o=>{if(o)return A.SignatureHelp.to(o)})),new p.$pM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$nM.Uri,p.$nM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$oM("A promise that resolves to an array of CodeLens-instances.",(o,s,n)=>D(l=>new I.$pK(A.Range.to(l.range),l.command&&n.fromInternal(l.command)))(o))),new p.$pM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$nM.Uri,new p.$nM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>I.$5J.isRange(o),o=>I.$6J.isSelection(o)?A.Selection.from(o):A.Range.from(o)),p.$nM.String.with("kind","Code action kind to return code actions for").optional(),p.$nM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$oM("A promise that resolves to an array of Command-instances.",(o,s,n)=>D(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return n.fromInternal(l.command)}else{const b=new I.$jK(l.title,l.kind?new I.$kK(l.kind):void 0);return l.edit&&(b.edit=A.WorkspaceEdit.to(l.edit)),l.command&&(b.command=n.fromInternal(l.command)),b.isPreferred=l.isPreferred,b}})(o))),new p.$pM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$nM.Uri],new p.$oM("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(s=>new I.$DK(A.Range.to(s.range),A.Color.to(s.color))):[])),new p.$pM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$nM("color","The color to show and insert",o=>o instanceof I.$CK,A.Color.from),new p.$nM("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:A.Range.from(o.range)}))],new p.$oM("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(A.ColorPresentation.to):[])),new p.$pM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$nM.Uri,p.$nM.Range],new p.$oM("A promise that resolves to an array of Inlay objects",(o,s,n)=>o.map(A.InlayHint.to.bind(void 0,n)))),new p.$pM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$nM.Uri],new p.$oM("A promise that resolves to an array of FoldingRange objects",(o,s)=>{if(o)return o.map(A.FoldingRange.to)})),new p.$pM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$oM("A promise that resolves to an array of NotebookContentProvider static info objects.",D(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(s=>A.NotebookExclusiveDocumentPattern.to(s))})))),new p.$pM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$nM.Uri,p.$nM.Range,new p.$nM("context","An InlineValueContext",o=>o&&typeof o.frameId=="number"&&o.stoppedLocation instanceof I.$5J,o=>A.InlineValueContext.from(o))],new p.$oM("A promise that resolves to an array of InlineValue objects",o=>o.map(A.InlineValue.to))),new p.$pM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$nM("uriOrString","Uri-instance or string (only http/https)",o=>f.URI.isUri(o)||typeof o=="string"&&(0,E.$PT)(o,F.Schemas.http,F.Schemas.https),o=>o),new p.$nM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[A.ViewColumn.from(o),void 0]:[A.ViewColumn.from(o.viewColumn),A.TextEditorOpenOptions.from(o)])).optional(),p.$nM.String.with("label","").optional()],p.$oM.Void),new p.$pM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$nM.Uri.with("resource","Resource to open"),p.$nM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new p.$nM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[A.ViewColumn.from(o),void 0]:[A.ViewColumn.from(o.viewColumn),A.TextEditorOpenOptions.from(o)])).optional()],p.$oM.Void),new p.$pM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$nM.Uri.with("left","Left-hand side resource of the diff editor"),p.$nM.Uri.with("right","Right-hand side resource of the diff editor"),p.$nM.String.with("title","Human readable title for the diff editor").optional(),new p.$nM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[A.ViewColumn.from(o.viewColumn),A.TextEditorOpenOptions.from(o)]).optional()],p.$oM.Void),new p.$pM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$nM.Uri,p.$nM.Position],new p.$oM("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(A.TypeHierarchyItem.to))),new p.$pM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$nM.TypeHierarchyItem],new p.$oM("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(A.TypeHierarchyItem.to))),new p.$pM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$nM.TypeHierarchyItem],new p.$oM("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(A.TypeHierarchyItem.to))),new p.$pM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$nM.TestItem],p.$oM.Void),new p.$pM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$nM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$oM.Void),new p.$pM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$nM.String.with("name","The context key name"),new p.$nM("value","The context key value",()=>!0,o=>o)],p.$oM.Void),new p.$pM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$nM.Uri,p.$nM.StringArray,new p.$nM("MappedEditsContext","Mapped Edits Context",o=>A.MappedEditsContext.is(o),o=>A.MappedEditsContext.from(o))],new p.$oM("A promise that resolves to a workspace edit or null",o=>o?A.WorkspaceEdit.to(o):null))];class k{static register(s){w.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",$.$Ji)}}e.$fbc=k;function D(o){return s=>{if(Array.isArray(s))return s.map(o)}}function v(o){if(!Array.isArray(o))return;const s=[];for(const n of o)L.$8s(n)?s.push(A.DefinitionLink.to(n)):s.push(A.location.to(n));return s}}),define(Se[303],De([1,0,9,57,4,3,2,83,25,13,7,6,27]),function($e,e,C,F,f,L,R,$,E,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=void 0;function k(D,v,o){const s=D.getProxy(I.$1J.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$Xl,v.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const y=this.b.get(d.handle);return y?y.value:d}else if(d&&d.$mid===7){const y=this.b.get(d.commentControlHandle);if(!y)return d;const S=y.getCommentThread(d.commentThreadHandle);return S?S.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const y=this.b.get(d.thread.commentControlHandle);if(!y)return d;const S=y.getCommentThread(d.thread.commentThreadHandle);return S?d.$mid===8?S.value:{thread:S.value,text:d.text}:d}else if(d&&d.$mid===10){const y=this.b.get(d.thread.commentControlHandle);if(!y)return d;const S=y.getCommentThread(d.thread.commentThreadHandle);if(!S)return d;const g=d.commentUniqueId,u=S.getCommentByUniqueId(g);return u||d}else if(d&&d.$mid===11){const y=this.b.get(d.thread.commentControlHandle);if(!y)return d;const S=y.getCommentThread(d.thread.commentThreadHandle);if(!S)return d;const g=d.text,u=d.commentUniqueId,m=S.getCommentByUniqueId(u);return m?(typeof m.body=="string"?m.body=g:m.body=new A.$qK(g),m):d}return d}})}createCommentController(d,y,S){const g=n.a++,u=new b(d,g,y,S);this.b.set(u.handle,u);const m=this.c.get(d.identifier)||[];return m.push(u),this.c.set(d.identifier,m),u.value}$createCommentThreadTemplate(d,y,S){const g=this.b.get(d);g&&g.$createCommentThreadTemplate(y,S)}async $updateCommentThreadTemplate(d,y,S){const g=this.b.get(d);g&&g.$updateCommentThreadTemplate(y,S)}$deleteCommentThread(d,y){this.b.get(d)?.$deleteCommentThread(y)}$provideCommentingRanges(d,y,S){const g=this.b.get(d);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const u=o.getDocument(R.URI.revive(y));return(0,C.$zg)(async()=>{const m=await g.commentingRangeProvider.provideCommentingRanges(u,S);let P;return Array.isArray(m)?P={ranges:m,fileComments:!1}:m?P={ranges:m.ranges||[],fileComments:m.fileComments||!1}:P=m??void 0,P}).then(m=>{let P;return m&&(P={ranges:m.ranges.map(O=>p.Range.from(O)),fileComments:m.fileComments}),P})}$toggleReaction(d,y,S,g,u){const m=this.b.get(d);return!m||!m.reactionHandler?Promise.resolve(void 0):(0,C.$zg)(()=>{const P=m.getCommentThread(y);if(P){const O=P.getCommentByUniqueId(g.uniqueIdInThread);if(m!==void 0&&O&&m.reactionHandler)return m.reactionHandler(O,r(u))}return Promise.resolve(void 0)})}}class l{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,y,S,g,u,m,P,O){this.m=y,this.n=S,this.o=g,this.p=u,this.q=m,this.extensionDescription=P,this.r=O,this.handle=l.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$fd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$lc,this.l.value=new L.$jc,this.n===void 0&&(this.n=`${d}.${this.handle}`),s.$createCommentThread(y,this.handle,this.n,this.o,p.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=m,this.i.push({dispose:()=>{s.$deleteCommentThread(y,this.handle)}});const N=this;this.value={get uri(){return N.uri},get range(){return N.range},set range(M){N.range=M},get comments(){return N.comments},set comments(M){N.comments=M},get collapsibleState(){return N.collapsibleState},set collapsibleState(M){N.collapsibleState=M},get canReply(){return N.canReply},set canReply(M){N.canReply=M},get contextValue(){return N.contextValue},set contextValue(M){N.contextValue=M},get label(){return N.label},set label(M){N.label=M},get state(){return N.state},set state(M){N.state=M},dispose:()=>{N.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$jc);const d=S=>Object.prototype.hasOwnProperty.call(this.b,S),y={};d("range")&&(y.range=p.Range.from(this.p)),d("label")&&(y.label=this.label),d("contextValue")&&(y.contextValue=this.contextValue??null),d("comments")&&(y.comments=this.q.map(S=>h(this,S,this.k,this.extensionDescription))),d("collapsibleState")&&(y.collapseState=a(this.g)),d("canReply")&&(y.canReply=this.canReply),d("state")&&(y.state=i(this.h)),d("isTemplate")&&(y.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(d){for(const y of this.k){const S=y[0],g=y[1];if(d===g)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Ke([(0,F.$7g)(100)],l.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,y,S,g){this.f=d,this.g=y,this.h=S,this.i=g,this.a=new Map,s.$registerCommentController(this.handle,S,g,this.f.identifier.value);const u=this;this.value=Object.freeze({id:u.id,label:u.label,get options(){return u.options},set options(m){u.options=m},get commentingRangeProvider(){return u.commentingRangeProvider},set commentingRangeProvider(m){u.commentingRangeProvider=m},get reactionHandler(){return u.reactionHandler},set reactionHandler(m){u.reactionHandler=m},createCommentThread(m,P,O){return u.createCommentThread(m,P,O).value},dispose:()=>{u.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(d,y,S){y===void 0&&(0,w.$YE)(this.f,"fileComments");const g=new l(this.id,this.handle,void 0,d,y,S,this.f,!1);return this.a.set(g.handle,g),g}$createCommentThreadTemplate(d,y){const S=new l(this.id,this.handle,void 0,R.URI.revive(d),p.Range.to(y),[],this.f,!0);return S.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(d,y){const S=this.a.get(d);S&&(S.range=p.Range.to(y))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function h(c,d,y,S){let g=y.get(d);return g||(g=++c.commentHandle,y.set(d,g)),d.state!==void 0&&(0,w.$YE)(S,"commentsDraftState"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:g,body:typeof d.body=="string"?d.body:p.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(u=>t(u)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?p.$1L(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?R.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function a(c){if(c!==void 0)switch(c){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function i(c){if(c!==void 0)switch(c){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$hbc=k}),define(Se[304],De([1,0,23,6,26,20]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;let R=class{constructor(A,I){this.a=A.getProxy(F.$1J.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,I){const w=this,k=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){w.e(A,I,k,arguments)}})}e(A,I,w,k){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:E(k,this.b)}),this.c&&this.f(A,w,k)}};e.$edc=R,e.$edc=R=Ke([Be(0,L.$2L),Be(1,f.$fM)],R);const $=1e5;function E(p,A){const I=[];if(p.length)for(let w=0;w<p.length;w++){let k=p[w];if(typeof k>"u")k="undefined";else if(k instanceof Error){const D=k;D.stack?k=D.stack:k=D.toString()}I.push(k)}if(A){const w=new Error().stack;w&&I.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,C.$1m)(I);return w.length>$?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(Se[149],De([1,0,2,6,7,5,20,14,19,15,16,27]),function($e,e,C,F,f,L,R,$,E,p,A,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=void 0;let k=class{static{w=this}static{this.c=0}static{this.d=250}constructor(v,o){this.h=o,this.f=new Map,this.g=v.getProxy(F.$1J.MainThreadDecorations)}registerFileDecorationProvider(v,o){const s=w.c++;this.f.set(s,{provider:v,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const n=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(l=>{if(!l){this.g.$onDidChange(s,null);return}const b=(0,E.$1b)(l);if(b.length<=w.d){this.g.$onDidChange(s,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,b.length);const h=b.map(a=>({uri:a,rank:(0,p.$re)(a.path,"/")})),t=(0,E.$xb)(h,(a,i)=>a.rank-i.rank||(0,p.$Fe)(a.uri.path,i.uri.path)),r=[];e:for(const a of t){let i;for(const c of a){const d=(0,A.$_d)(c.uri.path);if(i!==d&&(i=d,r.push(c.uri)>=w.d))break e}}this.g.$onDidChange(s,r)});return new f.$3J(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(v,o,s){if(!this.f.has(v))return Object.create(null);const n=Object.create(null),{provider:l,extensionDescription:b}=this.f.get(v);return await Promise.all(o.map(async h=>{try{const{uri:t,id:r}=h,a=await Promise.resolve(l.provideFileDecoration(C.URI.revive(t),s));if(!a)return;try{f.$lL.validate(a),a.badge&&typeof a.badge!="string"&&(0,I.$YE)(b,"codiconDecoration"),n[r]=[a.propagate,a.tooltip,a.badge,a.color]}catch(i){this.h.warn(`INVALID decoration from extension '${b.identifier.value}': ${i}`)}}catch(t){this.h.error(t)}})),n}};e.$icc=k,e.$icc=k=w=Ke([Be(0,R.$2L),Be(1,$.$5i)],k),e.$jcc=(0,L.$Bh)("IExtHostDecorations")}),define(Se[305],De([1,0,203,133,2,6,7,13,4,14,28,54]),function($e,e,C,F,f,L,R,$,E,p,A,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=e.$_ac=void 0;class k{#e;#t;#i;constructor(o,s,n,l,b,h,t,r){this.d=o,this.e=s,this.f=n,this.g=l,this.h=b,this.c=!1,this.f=Math.max(l,n),this.#i=new A.$zi(a=>h.getComparisonKey(a)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let n=[];if(f.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(k.k);for(const t of o){const[r,a]=t;if((!h||r.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=r,n.push(r),this.#i.set(r,[])),a)this.#i.get(r)?.push(...a);else{const i=this.#i.get(r);i&&(i.length=0)}}}if(this.#t.fire(n),!this.#e)return;const l=[];let b=0;for(const h of n){let t=[];const r=this.#i.get(h);if(r)if(r.length>this.g){t=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const c of r)if(c.severity===a[i]&&t.push({...$.Diagnostic.from(c),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,C.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(a=>({...$.Diagnostic.from(a),modelVersionId:this.h(h)}));if(l.push([h,t]),b+=t.length,b>this.f)break}this.#e.$changeMany(this.e,l)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[n,l]of this)o.call(s,n,l,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$_ac=k;let D=class{static{w=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*w.d}static _mapper(o){const s=new A.$zi;for(const n of o)s.set(n,n);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,n,l){this.j=s,this.k=n,this.l=l,this.g=new Map,this.h=new E.$jd({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,w._mapper),this.f=o.getProxy(L.$1J.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:n,f:l,h:b,j:h,k:t,l:r}=this,a=new class{$changeMany(d,y){l.$changeMany(d,y),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,d,y.length===0?"CLEARING":y)}$clear(d){l.$clear(d),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,d)}dispose(){l.dispose()}};let i;if(!s)s="_generated_diagnostic_collection_name_#"+w.c++,i=s;else if(!n.has(s))i=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do i=s+w.c++;while(n.has(i))}return new class extends k{constructor(){super(s,i,w.e,w.d,d=>r.getDocument(d)?.version,t.extUri,a,b),n.set(i,this)}dispose(){super.dispose(),n.delete(i)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,n=[];for(const l of this.g.values())l.forEach((b,h)=>{let t=s.get(b.toString());typeof t>"u"&&(t=n.length,s.set(b.toString(),t),n.push([b,[]])),n[t][1]=n[t][1].concat(...h)});return n}}m(o){let s=[];for(const n of this.g.values())n.has(o)&&(s=s.concat(n.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",n=new k(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,l=>{},this.k.extUri,void 0,this.h);this.g.set(s,n),this.n=n}for(const[s,n]of o)this.n.set(f.URI.revive(s),n.map($.Diagnostic.to))}};e.$abc=D,e.$abc=D=w=Ke([Be(1,p.$5i),Be(2,I.$$ac)],D)}),define(Se[306],De([1,0,2,6,27]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=void 0;class L{constructor($){this.a=$.getProxy(F.$1J.MainThreadDialogs)}showOpenDialog($,E){return E?.allowUIResources&&(0,f.$YE)($,"showLocal"),this.a.$showOpenDialog(E).then(p=>p?p.map(A=>C.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(E=>E?C.URI.revive(E):void 0)}}e.$pbc=L}),define(Se[307],De([1,0,8,2,7,6,17,21,15]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=void 0;class p{static{this.a=0}constructor(I,w,k){this.d=w,this.e=k,this.b=new Map,this.c=I.getProxy(L.$1J.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,w){if(Object.keys(R.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const k=p.a++;this.b.set(k,w),this.c.$registerTextContentProvider(k,I);let D;return typeof w.onDidChange=="function"&&(D=w.onDidChange(v=>{if(v.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this.d.getDocument(v)&&this.$provideTextDocumentContent(k,v).then(o=>{if(!o&&typeof o!="string")return;const s=this.d.getDocument(v);if(!s)return;const n=(0,E.$Ae)(o);if(!s.equalLines(n))return this.c.$onVirtualDocumentChange(v,o)},C.$Y)})),new f.$3J(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(I,w){const k=this.b.get(I);return k?Promise.resolve(k.provideTextDocumentContent(F.URI.revive(w),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.$qbc=p}),define(Se[308],De([1,0,4,3,2,6,141,13,18,23,7,8]),function($e,e,C,F,f,L,R,$,E,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=void 0;class w{constructor(D,v){this.a=new C.$fd({onListenerError:I.$Z}),this.b=new C.$fd({onListenerError:I.$Z}),this.c=new C.$fd({onListenerError:I.$Z}),this.d=new C.$fd({onListenerError:I.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$jc,this.h=new Map,this.f=D.getProxy(L.$1J.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(o=>{for(const s of o)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(o=>{for(const s of o)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const v=this.g.getDocument(D);if(v)return v}getDocument(D){const v=this.getDocumentData(D);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return v.document}ensureDocumentData(D){const v=this.g.getDocument(D);if(v)return Promise.resolve(v);let o=this.h.get(D.toString());return o||(o=this.f.$tryOpenDocument(D).then(s=>{this.h.delete(D.toString());const n=f.URI.revive(s);return(0,E.$uf)(this.g.getDocument(n))},s=>(this.h.delete(D.toString()),Promise.reject(s))),this.h.set(D.toString(),o)),o}createDocumentData(D){return this.f.$tryCreateDocument(D).then(v=>f.URI.revive(v))}$acceptModelLanguageChanged(D,v){const o=f.URI.revive(D),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(v),this.a.fire(s.document)}$acceptModelSaved(D){const v=f.URI.revive(D),o=this.g.getDocument(v);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(o.document)}$acceptDirtyStateChanged(D,v){const o=f.URI.revive(D),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(v),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,v,o){const s=f.URI.revive(D),n=this.g.getDocument(s);if(!n)throw new Error("unknown document");n._acceptIsDirty(o),n.onEvents(v);let l;v.isUndoing?l=A.TextDocumentChangeReason.Undo:v.isRedoing&&(l=A.TextDocumentChangeReason.Redo),this.c.fire((0,p.$Wm)({document:n.document,contentChanges:v.changes.map(b=>({range:$.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:l}))}setWordDefinitionFor(D,v){(0,R.$4L)(D,v)}}e.$9ac=w}),define(Se[71],De([1,0,58,4,3,2,5,6,141,20,146,13,14,28,17,50,59]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=void 0;class s{constructor(b){this.value=b,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(b,h){this.h=b,this.i=h,this.a=null,this.b=new Map,this.c=new k.$zi,this.d=new F.$fd,this.e=new F.$fd,this.f=new F.$fd,this.g=new F.$fd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(b){this.acceptDocumentsAndEditorsDelta(b)}acceptDocumentsAndEditorsDelta(b){const h=[],t=[],r=[];if(b.removedDocuments)for(const a of b.removedDocuments){const i=L.URI.revive(a),c=this.c.get(i);c?.unref()&&(this.c.delete(i),h.push(c.value))}if(b.addedDocuments)for(const a of b.addedDocuments){const i=L.URI.revive(a.uri);let c=this.c.get(i);if(c&&i.scheme!==D.Schemas.vscodeNotebookCell&&i.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new s(new E.$5L(this.h.getProxy($.$1J.MainThreadDocuments),i,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(i,c),t.push(c.value)),c.ref()}if(b.removedEditors)for(const a of b.removedEditors){const i=this.b.get(a);this.b.delete(a),i&&r.push(i)}if(b.addedEditors)for(const a of b.addedEditors){const i=L.URI.revive(a.documentUri);C.ok(this.c.has(i),`document '${i}' does not exist`),C.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const c=this.c.get(i).value,d=new A.$$L(a.id,this.h.getProxy($.$1J.MainThreadTextEditors),this.i,new o.$T(()=>c.document),a.selections.map(I.Selection.to),a.options,a.visibleRanges.map(y=>I.Range.to(y)),typeof a.editorPosition=="number"?I.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,d)}b.newActiveEditor!==void 0&&(C.ok(b.newActiveEditor===null||this.b.has(b.newActiveEditor),`active editor '${b.newActiveEditor}' does not exist`),this.a=b.newActiveEditor),(0,f.$fc)(h),(0,f.$fc)(r),b.removedDocuments&&this.e.fire(h),b.addedDocuments&&this.d.fire(t),(b.removedEditors||b.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),b.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(b){return this.c.get(b)?.value}allDocuments(){return v.Iterable.map(this.c.values(),b=>b.value)}getEditor(b){return this.b.get(b)}activeEditor(b){if(!this.a)return;const h=this.b.get(this.a);return b?h:h?.value}allEditors(){return[...this.b.values()]}};e.$_L=n,e.$_L=n=Ke([Be(0,p.$2L),Be(1,w.$5i)],n),e.$aM=(0,R.$Bh)("IExtHostDocumentsAndEditors")}),define(Se[72],De([1,0,13,6,2,4,5,7,20,18,56]),function($e,e,C,F,f,L,R,$,E,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=e.$ncc=void 0,e.$ncc=(0,R.$Bh)("IExtHostEditorTabs");class I{constructor(o,s,n){this.e=n,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new $.$HL(f.URI.revive(this.b.input.uri));case 2:return new $.$IL(f.URI.revive(this.b.input.original),f.URI.revive(this.b.input.modified));case 3:return new $.$JL(f.URI.revive(this.b.input.base),f.URI.revive(this.b.input.input1),f.URI.revive(this.b.input.input2),f.URI.revive(this.b.input.result));case 6:return new $.$KL(f.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new $.$LL(this.b.input.viewType);case 4:return new $.$ML(f.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new $.$NL(f.URI.revive(this.b.input.original),f.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new $.$OL;case 9:return new $.$PL(f.URI.revive(this.b.input.uri),f.URI.revive(this.b.input.inputBoxUri));default:return}}}class w{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new I(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return C.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new I(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const s=this.c.find(n=>n.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let k=class{constructor(o){this.b=new L.$fd,this.c=new L.$fd,this.e=[],this.a=o.getProxy(F.$1J.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,p.$uf)(o.e.find(b=>b.groupId===n)?.apiObject)},close:async(n,l)=>{const b=Array.isArray(n)?n:[n];return b.length?D(b[0])?this.j(b,l):this.i(b,l):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(a=>a.groupId)),n=new Set(o.map(a=>a.groupId)),l=(0,A.$J)(s,n),b=this.e.filter(a=>l.removed.includes(a.groupId)).map(a=>a.apiObject),h=[],t=[];this.e=o.map(a=>{const i=new w(a,()=>this.d);return l.added.includes(i.groupId)?h.push(i.apiObject):t.push(i.apiObject),i});const r=(0,p.$uf)(o.find(a=>a.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:h,closed:b,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(n=>n.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(l=>l.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const n=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const s of this.e)for(const n of s.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const n=[];for(const l of o){const b=this.g(l);if(!b)throw new Error("Tab close: Invalid tab not found!");n.push(b.tabId)}return this.a.$closeTab(n,s)}async j(o,s){const n=[];for(const l of o){const b=this.h(l);if(!b)throw new Error("Group close: Invalid group not found!");n.push(b.groupId)}return this.a.$closeGroup(n,s)}};e.$occ=k,e.$occ=k=Ke([Be(0,E.$2L)],k);function D(v){return v.tabs!==void 0}}),define(Se[309],De([1,0,6,7]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;class f{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(C.$1J.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const p=this.a.get(R);if(!p)throw new Error("Embedding vector provider not found");const A=await p.provideEmbeddingVector($,E);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,$,E){const p=this.b;return this.b++,this.a.set(p,E),this.c.$registerAiEmbeddingVectorProvider($,p),new F.$3J(()=>{this.c.$unregisterAiEmbeddingVectorProvider(p),this.a.delete(p)})}}e.$adc=f}),define(Se[310],De([1,0,2,6,3,7,13,169,15,22,27,80]),function($e,e,C,F,f,L,R,$,E,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=void 0;class w{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const o=this.a.indexOf(v);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),o=[];let s,n,l=14,b=14;for(const h of v){let t=s?(0,E.$Oe)(s,h):0;for(t===0?n=1:n=b;t<h.length;t++)t+1===h.length?(l=b,b=9):b+=1,o.push([n,h.toUpperCase().charCodeAt(t),b]),o.push([n,h.toLowerCase().charCodeAt(t),b]),n=b;s=h,b=l}o.push([9,58,10]),o.push([10,47,12]),this.b=new $.$yY(o)}}provideDocumentLinks(v){this.c();const o=[],s=$.$zY.computeLinks({getLineContent(n){return v.lineAt(n-1).text},getLineCount(){return v.lineCount}},this.b);for(const n of s){const l=R.DocumentLink.to(n);l.target&&o.push(l)}return o}}class k{constructor(v,o){this.i=o,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(F.$1J.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,o,s,n={}){if(k.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const l=this.h++;this.b.add(o),this.d.add(o),this.c.set(l,s);let b=2;n.isCaseSensitive&&(b+=1024),n.isReadonly&&(b+=2048),typeof s.copy=="function"&&(b+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,A.$YE)(v,"fsChunks"),b+=4);let h;n.isReadonly&&(0,I.$Zj)(n.isReadonly)&&((0,A.$YE)(v,"readonlyMessage"),h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(l,o,b,h).catch(r=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${o}`),console.error(r)});const t=s.onDidChangeFile(r=>{const a=[];for(const i of r){const{uri:c,type:d}=i;if(c.scheme!==o)continue;let y;switch(d){case L.FileChangeType.Changed:y=0;break;case L.FileChangeType.Created:y=1;break;case L.FileChangeType.Deleted:y=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:c,type:y})}this.a.$onFileSystemChange(l,a)});return(0,f.$ic)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(l),this.a.$unregisterProvider(l)})}static j(v){if(!v)throw new Error("MISSING provider");if(typeof v.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof v.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof v.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof v.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof v.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof v.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof v.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof v.rename!="function")throw new Error("Provider does NOT implement rename")}static k(v){const{type:o,ctime:s,mtime:n,size:l,permissions:b}=v;return{type:o,ctime:s,mtime:n,size:l,permissions:b}}$stat(v,o){return Promise.resolve(this.l(v).stat(C.URI.revive(o))).then(s=>k.k(s))}$readdir(v,o){return Promise.resolve(this.l(v).readDirectory(C.URI.revive(o)))}$readFile(v,o){return Promise.resolve(this.l(v).readFile(C.URI.revive(o))).then(s=>p.$Fd.wrap(s))}$writeFile(v,o,s,n){return Promise.resolve(this.l(v).writeFile(C.URI.revive(o),s.buffer,n))}$delete(v,o,s){return Promise.resolve(this.l(v).delete(C.URI.revive(o),s))}$rename(v,o,s,n){return Promise.resolve(this.l(v).rename(C.URI.revive(o),C.URI.revive(s),n))}$copy(v,o,s,n){const l=this.l(v);if(!l.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(l.copy(C.URI.revive(o),C.URI.revive(s),n))}$mkdir(v,o){return Promise.resolve(this.l(v).createDirectory(C.URI.revive(o)))}$watch(v,o,s,n){const l=this.l(v).watch(C.URI.revive(s),n);this.f.set(o,l)}$unwatch(v,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(v,o,s){const n=this.l(v);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(C.URI.revive(o),s))}$close(v,o){const s=this.l(v);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(v,o,s,n){const l=this.l(v);if(!l.read)throw new Error('FileSystemProvider does not implement "read"');const b=p.$Fd.alloc(n);return Promise.resolve(l.read(o,s,b.buffer,0,n)).then(h=>b.slice(0,h))}$write(v,o,s,n){const l=this.l(v);if(!l.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(l.write(o,s,n.buffer,0,n.byteLength))}l(v){const o=this.c.get(v);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$Wbc=k}),define(Se[73],De([1,0,6,30,7,22,5,20,54,3,9,24,17]),function($e,e,C,F,f,L,R,$,E,p,A,I,w){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=e.$Cbc=void 0;let D=k=class{constructor(o,s){this.b=new Map,this.c=new A.$Pg,this.a=o.getProxy(C.$1J.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(l){try{let b;const h=n.b.get(l.scheme);return h?(await n.a.$ensureActivation(l.scheme),b=await h.impl.stat(l)):b=await n.a.$stat(l),{type:b.type,ctime:b.ctime,mtime:b.mtime,size:b.size,permissions:b.permissions===F.FilePermission.Readonly?1:void 0}}catch(b){k.e(b)}},async readDirectory(l){try{const b=n.b.get(l.scheme);return b?(await n.a.$ensureActivation(l.scheme),(await b.impl.readDirectory(l)).slice()):await n.a.$readdir(l)}catch(b){return k.e(b)}},async createDirectory(l){try{const b=n.b.get(l.scheme);return b&&!b.isReadonly?(await n.a.$ensureActivation(l.scheme),await n.d(b.impl,b.extUri,l)):await n.a.$mkdir(l)}catch(b){return k.e(b)}},async readFile(l){try{const b=n.b.get(l.scheme);return b?(await n.a.$ensureActivation(l.scheme),(await b.impl.readFile(l)).slice()):(await n.a.$readFile(l)).buffer}catch(b){return k.e(b)}},async writeFile(l,b){try{const h=n.b.get(l.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(l.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(l)),await n.c.queueFor(l).queue(()=>Promise.resolve(h.impl.writeFile(l,b,{create:!0,overwrite:!0})))):await n.a.$writeFile(l,L.$Fd.wrap(b))}catch(h){return k.e(h)}},async delete(l,b){try{const h=n.b.get(l.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(l.scheme),await h.impl.delete(l,{recursive:!1,...b})):await n.a.$delete(l,{recursive:!1,useTrash:!1,atomic:!1,...b})}catch(h){return k.e(h)}},async rename(l,b,h){try{return await n.a.$rename(l,b,{overwrite:!1,...h})}catch(t){return k.e(t)}},async copy(l,b,h){try{return await n.a.$copy(l,b,{overwrite:!1,...h})}catch(t){return k.e(t)}},isWritableFileSystem(l){const b=s.getCapabilities(l);if(typeof b=="number")return!(b&2048)}})}async d(o,s,n){const l=[];for(;!s.isEqual(n,s.dirname(n));)try{if(!((await o.stat(n)).type&F.FileType.Directory))throw f.$dL.FileExists(`Unable to create folder '${n.scheme===w.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(b){if(F.$ik(b)!==F.FileSystemProviderErrorCode.FileNotFound)throw b;l.push(s.basename(n)),n=s.dirname(n)}for(let b=l.length-1;b>=0;b--){n=s.joinPath(n,l[b]);try{await o.createDirectory(n)}catch(h){if(F.$ik(h)!==F.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof f.$dL)throw o;if(o instanceof F.$ek)switch(o.code){case F.FileSystemProviderErrorCode.FileExists:throw f.$dL.FileExists(o.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$dL.FileNotFound(o.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$dL.FileNotADirectory(o.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$dL.FileIsADirectory(o.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$dL.NoPermissions(o.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$dL.Unavailable(o.message);default:throw new f.$dL(o.message,o.name)}if(!(o instanceof Error))throw new f.$dL(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw f.$dL.Unavailable(o.message);switch(o.name){case F.FileSystemProviderErrorCode.FileExists:throw f.$dL.FileExists(o.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$dL.FileNotFound(o.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$dL.FileNotADirectory(o.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$dL.FileIsADirectory(o.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$dL.NoPermissions(o.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$dL.Unavailable(o.message);default:throw new f.$dL(o.message,o.name)}}addFileSystemProvider(o,s,n){return this.b.set(o,{impl:s,extUri:n?.isCaseSensitive?I.$$f:I.$ag,isReadonly:!!n?.isReadonly}),(0,p.$ic)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??I.$$f}};e.$Cbc=D,e.$Cbc=D=k=Ke([Be(0,$.$2L),Be(1,E.$$ac)],D),e.$Dbc=(0,R.$Bh)("IExtHostConsumerFileSystem")}),define(Se[311],De([1,0,4,35,2,6,13,7]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=void 0;class E{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(I,w,k,D,v,o,s,n){this.a=new C.$fd,this.b=new C.$fd,this.c=new C.$fd;const l=this.h(I,k,v);this.g=0,o&&(this.g+=1),s&&(this.g+=2),n&&(this.g+=4);const b=(0,F.$rj)(v),h=typeof v=="string",t=D(r=>{if(!o)for(const a of r.created){const i=f.URI.revive(a);b(i.fsPath)&&(!h||w.getWorkspaceFolder(i))&&this.a.fire(i)}if(!s)for(const a of r.changed){const i=f.URI.revive(a);b(i.fsPath)&&(!h||w.getWorkspaceFolder(i))&&this.b.fire(i)}if(!n)for(const a of r.deleted){const i=f.URI.revive(a);b(i.fsPath)&&(!h||w.getWorkspaceFolder(i))&&this.c.fire(i)}});this.d=$.$3J.from(l,this.a,this.b,this.c,t)}h(I,w,k){const D=$.$3J.from();if(typeof k=="string")return D;const v=I.getProxy(L.$1J.MainThreadFileSystem);let o=!1;(k.pattern.includes(F.$nj)||k.pattern.includes(F.$oj))&&(o=!0);const s=Math.random();return v.$watch(w.identifier.value,s,k.baseUri,{recursive:o,excludes:[]}),$.$3J.from({dispose:()=>v.$unwatch(s)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class p{constructor(I,w,k){this.j=I,this.k=w,this.l=k,this.a=new C.$fd,this.b=new C.$fd,this.c=new C.$fd,this.d=new C.$fd,this.g=new C.$hd,this.h=new C.$hd,this.i=new C.$hd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,w,k,D,v,o){return new E(this.j,I,w,this.a.event,R.GlobPattern.from(k),D,v,o)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,w){switch(I){case 2:this.b.fire(Object.freeze({files:w.map(k=>({oldUri:f.URI.revive(k.source),newUri:f.URI.revive(k.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(k=>f.URI.revive(k.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(k=>f.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,w){return(k,D,v)=>{const o=function(n){k.call(D,n)};return o.extension=I,w.event(o,void 0,v)}}async $onWillRunFileOperation(I,w,k,D){switch(I){case 2:return await this.n(this.g,{files:w.map(v=>({oldUri:f.URI.revive(v.source),newUri:f.URI.revive(v.target)}))},k,D);case 1:return await this.n(this.i,{files:w.map(v=>f.URI.revive(v.target))},k,D);case 0:case 3:return await this.n(this.h,{files:w.map(v=>f.URI.revive(v.target))},k,D)}}async n(I,w,k,D){const v=new Set,o=[];if(await I.fireAsync(w,D,async(n,l)=>{const b=Date.now(),h=await Promise.resolve(n);h instanceof $.$aK&&(o.push([l.extension,h]),v.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-b>k&&this.k.warn("SLOW file-participant",l.extension.identifier)}),D.isCancellationRequested||o.length===0)return;const s={edits:[]};for(const[,n]of o){const{edits:l}=R.WorkspaceEdit.from(n,{getTextDocumentVersion:b=>this.l.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(l)}return{edit:s,extensionNames:Array.from(v)}}}e.$Xbc=p}),define(Se[312],De([1,0,3,2,6,13,7,33]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=void 0;class E{static{this.a=0}constructor(w,k){this.extension=w,this.provider=k,this.handle=E.a++}}class p{constructor(w){this.session=w,this.responses=[]}}class A{static{this.a=0}constructor(w,k,D,v){this.f=D,this.g=v,this.b=new Map,this.d=new Map,this.e=w.getProxy(f.$1J.MainThreadInlineChat),k.registerApiCommand(new $.$pM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$nM("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?L.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?L.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?L.Position.from(o.position):void 0}})],$.$oM.Void))}registerProvider(w,k,D){const v=new E(w,k);return this.b.set(v.handle,v),this.e.$registerInteractiveEditorProvider(v.handle,D.label,w.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function"),(0,C.$ic)(()=>{this.e.$unregisterInteractiveEditorProvider(v.handle),this.b.delete(v.handle)})}async $prepareSession(w,k,D,v){const o=this.b.get(w);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const s=this.f.getDocument(F.URI.revive(k)),n=L.Selection.to(D),l=await o.provider.prepareInteractiveEditorSession({document:s,selection:n},v);if(!l)return;if(l.wholeRange&&!l.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const b=A.a++;return this.d.set(b,new p(l)),{id:b,placeholder:l.placeholder,slashCommands:l.slashCommands?.map(h=>({command:h.command,detail:h.detail,refer:h.refer,executeImmediately:h.executeImmediately})),wholeRange:L.Range.from(l.wholeRange),message:l.message}}async $provideResponse(w,k,D,v){const o=this.b.get(w);if(!o)return;const s=this.d.get(k.id);if(!s)return;const n={prompt:D.prompt,selection:L.Selection.to(D.selection),wholeRange:L.Range.to(D.wholeRange),attempt:D.attempt,live:D.live};let l=!1;const b={report:r=>{if(!D.live)throw new Error("Progress reporting is only supported for live sessions");l||v.isCancellationRequested||!r.message&&!r.edits||this.e.$handleProgressChunk(D.requestId,{message:r.message,edits:r.edits?.map(L.TextEdit.from)})}},h=o.provider.provideInteractiveEditorResponse(s.session,n,b,v);Promise.resolve(h).finally(()=>l=!0);const t=await h;if(t){const r=s.responses.push(t)-1,a={wholeRange:L.Range.from(t.wholeRange),placeholder:t.placeholder};if(A.h(t))return{...a,id:r,type:"message",message:L.MarkdownString.from(t.contents)};const{edits:i}=t;if(i instanceof R.$aK)return{...a,id:r,type:"bulkEdit",edits:L.WorkspaceEdit.from(i)};if(Array.isArray(i))return{...a,id:r,type:"editorEdit",edits:i.map(L.TextEdit.from)}}}$handleFeedback(w,k,D,v){const o=this.b.get(w),s=this.d.get(k),n=s?.responses[D];if(o&&n){const l=L.InteractiveEditorResponseFeedbackKind.to(v);o.provider.handleInteractiveEditorResponseFeedback?.(s.session,n,l)}}$releaseSession(w,k){}static h(w){return typeof w=="object"&&typeof w.contents=="object"}}e.$5cc=A}),define(Se[313],De([1,0,2,33]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;class f{constructor(R,$,E,p,A){this.a=$,this.b=E,this.c=p;const I=new F.$pM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$nM("showOptions","Show Options",w=>!0,w=>w),new F.$nM("resource","Interactive resource Uri",w=>!0,w=>w),new F.$nM("controllerId","Notebook controller Id",w=>!0,w=>w),new F.$nM("title","Interactive editor title",w=>!0,w=>w)],new F.$oM("Notebook and input URI",w=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const k=this.a.getEditorById(w.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:C.URI.revive(w.notebookUri),inputUri:C.URI.revive(w.inputUri),notebookEditor:k.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:C.URI.revive(w.notebookUri),inputUri:C.URI.revive(w.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(R,$,E,p){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:E,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive(p))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$1cc=f}),define(Se[314],De([1,0,6,7]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=void 0;class f{constructor(R){this.a=new Map,this.b=R.getProxy(C.$1J.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(R);if(!E)throw new Error("Issue request handler not found");const p=await E.handleIssueUrlRequest();if(!p)throw new Error("Issue request handler returned no result");return p}registerIssueUriRequestHandler(R,$){const E=R.identifier.value;return this.a.set(E,$),this.b.$registerIssueUriRequestHandler(E),new F.$3J(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$7cc=f}),define(Se[315],De([1,0,3,6]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;class f{constructor(R){this.b=0,this.a=R.getProxy(F.$1J.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,C.$ic)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$hcc=f}),define(Se[316],De([1,0,2,23,13,7,83,6,15,34,19,18,165,21,25,3,129,119,87,37,8,9,27,205]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b,h,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=void 0;class a{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentSymbols(B,Y){const ie=this.d.getDocument(B),re=await this.e.provideDocumentSymbols(ie,Y);if(!(0,A.$Ib)(re))return re[0]instanceof L.$iK?re.map(f.DocumentSymbol.from):a.f(re)}static f(B){B=B.slice(0).sort((re,Q)=>{let de=re.location.range.start.compareTo(Q.location.range.start);return de===0&&(de=Q.location.range.end.compareTo(re.location.range.end)),de});const Y=[],ie=[];for(const re of B){const Q={name:re.name||"!!MISSING: name!!",kind:f.SymbolKind.from(re.kind),tags:re.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:re.containerName,range:f.Range.from(re.location.range),selectionRange:f.Range.from(re.location.range),children:[]};for(;;){if(ie.length===0){ie.push(Q),Y.push(Q);break}const de=ie[ie.length-1];if(p.$ks.containsRange(de.range,Q.range)&&!p.$ks.equalsRange(de.range,Q.range)){de.children?.push(Q),ie.push(Q);break}ie.pop()}}return Y}}class i{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,Y,ie){this.g=B,this.h=Y,this.j=ie,this.e=new n.$8ac("CodeLens"),this.f=new Map}async provideCodeLenses(B,Y){const ie=this.g.getDocument(B),re=await this.j.provideCodeLenses(ie,Y);if(!re||Y.isCancellationRequested)return;const Q=this.e.add(re),de=new v.$jc;this.f.set(Q,de);const ye={cacheId:Q,lenses:[]};for(let je=0;je<re.length;je++)ye.lenses.push({cacheId:[Q,je],range:f.Range.from(re[je].range),command:this.h.toInternal(re[je].command,de)});return ye}async resolveCodeLens(B,Y){const ie=B.cacheId&&this.e.get(...B.cacheId);if(!ie)return;let re;if(typeof this.j.resolveCodeLens!="function"||ie.isResolved?re=ie:re=await this.j.resolveCodeLens(ie,Y),re||(re=ie),Y.isCancellationRequested)return;const Q=B.cacheId&&this.f.get(B.cacheId[0]);if(Q)return B.command=this.h.toInternal(re.command??i.d,Q),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function c(Ie){return Array.isArray(Ie)?Ie.map(f.DefinitionLink.from):Ie?[f.DefinitionLink.from(Ie)]:[]}class d{constructor(B,Y){this.d=B,this.e=Y}async provideDefinition(B,Y,ie){const re=this.d.getDocument(B),Q=f.Position.to(Y),de=await this.e.provideDefinition(re,Q,ie);return c(de)}}class y{constructor(B,Y){this.d=B,this.e=Y}async provideDeclaration(B,Y,ie){const re=this.d.getDocument(B),Q=f.Position.to(Y),de=await this.e.provideDeclaration(re,Q,ie);return c(de)}}class S{constructor(B,Y){this.d=B,this.e=Y}async provideImplementation(B,Y,ie){const re=this.d.getDocument(B),Q=f.Position.to(Y),de=await this.e.provideImplementation(re,Q,ie);return c(de)}}class g{constructor(B,Y){this.d=B,this.e=Y}async provideTypeDefinition(B,Y,ie){const re=this.d.getDocument(B),Q=f.Position.to(Y),de=await this.e.provideTypeDefinition(re,Q,ie);return c(de)}}class u{constructor(B,Y){this.d=B,this.e=Y}async provideHover(B,Y,ie){const re=this.d.getDocument(B),Q=f.Position.to(Y),de=await this.e.provideHover(re,Q,ie);if(!(!de||(0,A.$Ib)(de.contents)))return de.range||(de.range=re.getWordRangeAtPosition(Q)),de.range||(de.range=new L.$5J(Q,Q)),f.Hover.from(de)}}class m{constructor(B,Y){this.d=B,this.e=Y}async provideEvaluatableExpression(B,Y,ie){const re=this.d.getDocument(B),Q=f.Position.to(Y),de=await this.e.provideEvaluatableExpression(re,Q,ie);if(de)return f.EvaluatableExpression.from(de)}}class P{constructor(B,Y){this.d=B,this.e=Y}async provideInlineValues(B,Y,ie,re){const Q=this.d.getDocument(B),de=await this.e.provideInlineValues(Q,f.Range.to(Y),f.InlineValueContext.to(ie),re);if(Array.isArray(de))return de.map(ye=>f.InlineValue.from(ye))}}class O{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentHighlights(B,Y,ie){const re=this.d.getDocument(B),Q=f.Position.to(Y),de=await this.e.provideDocumentHighlights(re,Q,ie);if(Array.isArray(de))return de.map(f.DocumentHighlight.from)}}class N{constructor(B,Y){this.d=B,this.e=Y}async provideLinkedEditingRanges(B,Y,ie){const re=this.d.getDocument(B),Q=f.Position.to(Y),de=await this.e.provideLinkedEditingRanges(re,Q,ie);if(de&&Array.isArray(de.ranges))return{ranges:(0,A.$Fb)(de.ranges.map(f.Range.from)),wordPattern:de.wordPattern}}}class M{constructor(B,Y){this.d=B,this.e=Y}async provideReferences(B,Y,ie,re){const Q=this.d.getDocument(B),de=f.Position.to(Y),ye=await this.e.provideReferences(Q,de,ie,re);if(Array.isArray(ye))return ye.map(f.location.from)}}class j{static{this.d=1e3}constructor(B,Y,ie,re,Q,de,ye){this.g=B,this.h=Y,this.j=ie,this.k=re,this.l=Q,this.m=de,this.n=ye,this.e=new n.$8ac("CodeAction"),this.f=new Map}async provideCodeActions(B,Y,ie,re){const Q=this.g.getDocument(B),de=w.$ms.isISelection(Y)?f.Selection.to(Y):f.Range.to(Y),ye=[];for(const et of this.j.getDiagnostics(B))if(de.intersection(et.range)&&ye.push(et)>j.d)break;const je={diagnostics:ye,only:ie.only?new L.$kK(ie.only):void 0,triggerKind:f.CodeActionTriggerKind.to(ie.trigger)},We=await this.k.provideCodeActions(Q,de,je,re);if(!(0,A.$Jb)(We)||re.isCancellationRequested)return;const _e=this.e.add(We),Qe=new v.$jc;this.f.set(_e,Qe);const it=[];for(let et=0;et<We.length;et++){const Ae=We[et];Ae&&(j.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Qe)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,et],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Qe),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(f.Diagnostic.from),edit:Ae.edit&&f.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(B,Y){const[ie,re]=B,Q=this.e.get(ie,re);if(!Q||j.o(Q))return{};if(!this.k.resolveCodeAction)return{};const de=await this.k.resolveCodeAction(Q,Y)??Q;let ye;de.edit&&(ye=f.WorkspaceEdit.from(de.edit,void 0));let je;if(de.command){const We=this.f.get(ie);We&&(je=this.h.toInternal(de.command,We))}return{edit:ye,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class z{static toInternalProviderId(B,Y){return B+"."+Y}constructor(B,Y,ie,re,Q){this.d=B,this.e=Y,this.f=ie,this.g=re,this.h=Q}async prepareDocumentPaste(B,Y,ie,re){if(!this.f.prepareDocumentPaste)return;const Q=this.e.getDocument(B),de=Y.map(We=>f.Range.to(We)),ye=f.DataTransfer.toDataTransfer(ie,()=>{throw new b.$9});if(await this.f.prepareDocumentPaste(Q,de,ye,re),re.isCancellationRequested)return;const je=Array.from(ye).filter(([,We])=>!(We instanceof L.$QK));return f.DataTransfer.from(je)}async providePasteEdits(B,Y,ie,re,Q){if(!this.f.provideDocumentPasteEdits)return;const de=this.e.getDocument(Y),ye=ie.map(_e=>f.Range.to(_e)),je=f.DataTransfer.toDataTransfer(re,async _e=>(await this.d.$resolvePasteFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentPasteEdits(de,ye,je,Q);if(We)return{label:We.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:z.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class T{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentFormattingEdits(B,Y,ie){const re=this.d.getDocument(B),Q=await this.e.provideDocumentFormattingEdits(re,Y,ie);if(Array.isArray(Q))return Q.map(f.TextEdit.from)}}class H{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentRangeFormattingEdits(B,Y,ie,re){const Q=this.d.getDocument(B),de=f.Range.to(Y),ye=await this.e.provideDocumentRangeFormattingEdits(Q,de,ie,re);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Y,ie,re){(0,I.$tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Q=this.d.getDocument(B),de=Y.map(f.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(Q,de,ie,re);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}}class q{constructor(B,Y){this.d=B,this.e=Y,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Y,ie,re,Q){const de=this.d.getDocument(B),ye=f.Position.to(Y),je=await this.e.provideOnTypeFormattingEdits(de,ye,ie,re,Q);if(Array.isArray(je))return je.map(f.TextEdit.from)}}class me{constructor(B,Y){this.e=B,this.f=Y,this.d=new n.$8ac("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Y){const ie=await this.e.provideWorkspaceSymbols(B,Y);if(!(0,A.$Jb)(ie))return{symbols:[]};const re=this.d.add(ie),Q={cacheId:re,symbols:[]};for(let de=0;de<ie.length;de++){const ye=ie[de];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Q.symbols.push({...f.WorkspaceSymbol.from(ye),cacheId:[re,de]})}return Q}async resolveWorkspaceSymbol(B,Y){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const ie=this.d.get(...B.cacheId);if(ie){const re=await this.e.resolveWorkspaceSymbol(ie,Y);return re&&(0,F.$Ym)(B,f.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class Z{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Y,ie){this.d=B,this.e=Y,this.f=ie}async provideRenameEdits(B,Y,ie,re){const Q=this.d.getDocument(B),de=f.Position.to(Y);try{const ye=await this.e.provideRenameEdits(Q,de,ie,re);return ye?f.WorkspaceEdit.from(ye):void 0}catch(ye){const je=Z.g(ye);return je?{rejectReason:je,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,Y,ie){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const re=this.d.getDocument(B),Q=f.Position.to(Y);try{const de=await this.e.prepareRename(re,Q,ie);let ye,je;if(L.$5J.isRange(de)?(ye=de,je=re.getText(de)):(0,I.$lf)(de)&&(ye=de.range,je=de.placeholder),!ye||!je)return;if(ye.start.line>Q.line||ye.end.line<Q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(ye),text:je}}catch(de){const ye=Z.g(de);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(de)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class X{constructor(B,Y){this.resultId=B,this.tokens=Y}}class V{constructor(B,Y){this.f=B,this.g=Y,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Y,ie){const re=this.f.getDocument(B),Q=Y!==0?this.d.get(Y):null;let de=typeof Q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(re,Q.resultId,ie):await this.g.provideDocumentSemanticTokens(re,ie);return Q&&this.d.delete(Y),de?(de=V.h(de),this.o(V.n(Q,de),de)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return V.j(B)?V.k(B)?B:new L.$hL(new Uint32Array(B.data),B.resultId):V.l(B)?V.m(B)?B:new L.$jL(B.edits.map(Y=>new L.$iL(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Y of B.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static n(B,Y){if(!V.j(Y)||!B||!B.tokens)return Y;const ie=B.tokens,re=ie.length,Q=Y.data,de=Q.length;let ye=0;const je=Math.min(re,de);for(;ye<je&&ie[ye]===Q[ye];)ye++;if(ye===re&&ye===de)return new L.$jL([],Y.resultId);let We=0;const _e=je-ye;for(;We<_e&&ie[re-We-1]===Q[de-We-1];)We++;return new L.$jL([{start:ye,deleteCount:re-ye-We,data:Q.subarray(ye,de-We)}],Y.resultId)}o(B,Y){if(V.j(B)){const ie=this.e++;return this.d.set(ie,new X(B.resultId,B.data)),(0,o.$v0)({id:ie,type:"full",data:B.data})}if(V.l(B)){const ie=this.e++;return V.j(Y)?this.d.set(ie,new X(Y.resultId,Y.data)):this.d.set(ie,new X(B.resultId)),(0,o.$v0)({id:ie,type:"delta",deltas:(B.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}class x{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentRangeSemanticTokens(B,Y,ie){const re=this.d.getDocument(B),Q=await this.e.provideDocumentRangeSemanticTokens(re,f.Range.to(Y),ie);return Q?this.f(Q):null}f(B){return(0,o.$v0)({id:0,type:"full",data:B.data})}}class ge{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Y,ie,re,Q){this.f=B,this.g=Y,this.h=ie,this.j=re,this.k=Q,this.d=new n.$8ac("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Y,ie,re){const Q=this.f.getDocument(B),de=f.Position.to(Y),ye=Q.getWordRangeAtPosition(de)||new L.$5J(de,de),je=ye.with({end:de}),We=new l.$bd,_e=await this.h.provideCompletionItems(Q,de,re,f.CompletionContext.to(ie));if(!_e||re.isCancellationRequested)return;const Qe=Array.isArray(_e)?new L.$xK(_e):_e,it=ge.supportsResolving(this.h)?this.d.add(Qe.items):this.d.add([]),et=new v.$jc;this.e.set(it,et);const Ae=[],Oe={x:it,b:Ae,a:{replace:f.Range.from(ye),insert:f.Range.from(je)},c:Qe.isIncomplete||void 0,d:We.elapsed()};for(let Ve=0;Ve<Qe.items.length;Ve++){const Le=Qe.items[Ve],Xe=this.l(Le,[it,Ve],je,ye);Ae.push(Xe)}return Oe}async resolveCompletionItem(B,Y){if(typeof this.h.resolveCompletionItem!="function")return;const ie=this.d.get(...B);if(!ie)return;const re=this.l(ie,B),Q=await this.h.resolveCompletionItem(ie,Y);if(!Q)return;const de=this.l(Q,B);return(re.h!==de.h||re.i!==de.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(re.n!==de.n||re.o!==de.o||!(0,F.$Zm)(re.p,de.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...re,d:de.d,c:de.c,l:de.l,h:de.h,i:de.i,n:de.n,o:de.o,p:de.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Y,ie,re){const Q=this.e.get(Y[0]);if(!Q)throw Error("DisposableStore is missing...");const de=this.g.toInternal(B.command,Q),ye={x:Y,a:B.label,b:B.kind!==void 0?f.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(f.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:f.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(f.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof L.$bK&&(ye.h=B.insertText.value,ye.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),L.$5J.isRange(je)?ye.j=f.Range.from(je):je&&(!ie?.isEqual(je.inserting)||!re?.isEqual(je.replacing))&&(ye.j={insert:f.Range.from(je.inserting),replace:f.Range.from(je.replacing)}),ye}}class ue{async provideInlineCompletions(B,Y,ie,re){}disposeCompletions(B){}handleDidShowCompletionItem(B,Y,ie){}handlePartialAccept(B,Y,ie){}}class ve extends ue{constructor(B,Y,ie,re){super(),this.f=B,this.g=Y,this.h=ie,this.j=re,this.d=new G,this.e=(0,t.$XE)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$XE)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Y,ie,re){const Q=this.g.getDocument(B),de=f.Position.to(Y),ye=await this.h.provideInlineCompletionItems(Q,de,{selectedCompletionInfo:ie.selectedSuggestionInfo?{range:f.Range.to(ie.selectedSuggestionInfo.range),text:ie.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ie.triggerKind]},re);if(!ye||re.isCancellationRequested)return;const je=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],_e=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Qe;return{pid:this.d.createReferenceId({dispose(){Qe?.dispose()},items:je}),items:je.map((et,Ae)=>{let Oe;et.command&&(Qe||(Qe=new v.$jc),Oe=this.j.toInternal(et.command,Qe));const Ve=et.insertText;return{insertText:typeof Ve=="string"?Ve:{snippet:Ve.value},filterText:et.filterText,range:et.range?f.Range.from(et.range):void 0,command:Oe,idx:Ae,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:We.map(et=>(Qe||(Qe=new v.$jc),this.j.toInternal(et,Qe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Y,ie){const re=this.d.get(B)?.items[Y];re&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(re,ie)}handlePartialAccept(B,Y,ie){const re=this.d.get(B)?.items[Y];re&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(re,ie)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Y=this.e++;return this.d.set(Y,B),Y}disposeReferenceId(B){const Y=this.d.get(B);return this.d.delete(B),Y}get(B){return this.d.get(B)}}class U{constructor(B,Y){this.e=B,this.f=Y,this.d=new n.$8ac("SignatureHelp")}async provideSignatureHelp(B,Y,ie,re){const Q=this.e.getDocument(B),de=f.Position.to(Y),ye=this.g(ie),je=await this.f.provideSignatureHelp(Q,de,re,ye);if(je){const We=this.d.add([je]);return{...f.SignatureHelp.from(je),id:We}}}g(B){let Y;if(B.activeSignatureHelp){const ie=f.SignatureHelp.to(B.activeSignatureHelp),re=this.d.get(B.activeSignatureHelp.id,0);re?(Y=re,Y.activeSignature=ie.activeSignature,Y.activeParameter=ie.activeParameter):Y=ie}return{...B,activeSignatureHelp:Y}}releaseSignatureHelp(B){this.d.delete(B)}}class K{constructor(B,Y,ie,re,Q){this.f=B,this.g=Y,this.h=ie,this.j=re,this.k=Q,this.d=new n.$8ac("InlayHints"),this.e=new Map}async provideInlayHints(B,Y,ie){const re=this.f.getDocument(B),Q=f.Range.to(Y),de=await this.h.provideInlayHints(re,Q,ie);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${Y}`);return}if(ie.isCancellationRequested)return;const ye=this.d.add(de);this.e.set(ye,new v.$jc);const je={hints:[],cacheId:ye};for(let We=0;We<de.length;We++)this.l(de[We],Q)&&je.hints.push(this.m(de[We],[ye,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${Y}`),je}async resolveInlayHint(B,Y){if(typeof this.h.resolveInlayHint!="function")return;const ie=this.d.get(...B);if(!ie)return;const re=await this.h.resolveInlayHint(ie,Y);if(re&&this.l(re))return this.m(re,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Y){return B.label.length===0||Array.isArray(B.label)&&B.label.every(ie=>ie.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Y&&!Y.contains(B.position))}m(B,Y){const ie=this.e.get(Y[0]);if(!ie)throw Error("DisposableStore is missing...");const re={label:"",cacheId:Y,tooltip:f.MarkdownString.fromStrict(B.tooltip),position:f.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(f.TextEdit.from),kind:B.kind&&f.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?re.label=B.label:re.label=B.label.map(Q=>{const de={label:Q.value};return de.tooltip=f.MarkdownString.fromStrict(Q.tooltip),L.$cK.isLocation(Q.location)&&(de.location=f.location.from(Q.location)),Q.command&&(de.command=this.g.toInternal(Q.command,ie)),de}),re}}class fe{constructor(B,Y){this.e=B,this.f=Y,this.d=new n.$8ac("DocumentLink")}async provideLinks(B,Y){const ie=this.e.getDocument(B),re=await this.f.provideDocumentLinks(ie,Y);if(!(!Array.isArray(re)||re.length===0)&&!Y.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:re.filter(fe.g).map(f.DocumentLink.from)};{const Q=this.d.add(re),de={links:[],cacheId:Q};for(let ye=0;ye<re.length;ye++){if(!fe.g(re[ye]))continue;const je=f.DocumentLink.from(re[ye]);je.cacheId=[Q,ye],de.links.push(je)}return de}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Y){if(typeof this.f.resolveDocumentLink!="function")return;const ie=this.d.get(...B);if(!ie)return;const re=await this.f.resolveDocumentLink(ie,Y);if(!(!re||!fe.g(re)))return f.DocumentLink.from(re)}releaseLinks(B){this.d.delete(B)}}class te{constructor(B,Y){this.d=B,this.e=Y}async provideColors(B,Y){const ie=this.d.getDocument(B),re=await this.e.provideDocumentColors(ie,Y);return Array.isArray(re)?re.map(de=>({color:f.Color.from(de.color),range:f.Range.from(de.range)})):[]}async provideColorPresentations(B,Y,ie){const re=this.d.getDocument(B),Q=f.Range.to(Y.range),de=f.Color.to(Y.color),ye=await this.e.provideColorPresentations(de,{document:re,range:Q},ie);if(Array.isArray(ye))return ye.map(f.ColorPresentation.from)}}class se{constructor(B,Y){this.d=B,this.e=Y}async provideFoldingRanges(B,Y,ie){const re=this.d.getDocument(B),Q=await this.e.provideFoldingRanges(re,Y,ie);if(Array.isArray(Q))return Q.map(f.FoldingRange.from)}}class ne{constructor(B,Y,ie){this.d=B,this.e=Y,this.f=ie}async provideSelectionRanges(B,Y,ie){const re=this.d.getDocument(B),Q=Y.map(f.Position.to),de=await this.e.provideSelectionRanges(re,Q,ie);if(!(0,A.$Jb)(de))return[];if(de.length!==Q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let je=0;je<Q.length;je++){const We=[];ye.push(We);let _e=Q[je],Qe=de[je];for(;;){if(!Qe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(f.SelectionRange.from(Qe)),!Qe.parent)break;_e=Qe.range,Qe=Qe.parent}}return ye}}class Ee{constructor(B,Y){this.f=B,this.g=Y,this.d=new s.$7L(""),this.e=new Map}async prepareSession(B,Y,ie){const re=this.f.getDocument(B),Q=f.Position.to(Y),de=await this.g.prepareCallHierarchy(re,Q,ie);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(je=>this.h(ye,je)):[this.h(ye,de)]}async provideCallsTo(B,Y,ie){const re=this.j(B,Y);if(!re)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyIncomingCalls(re,ie);if(Q)return Q.map(de=>({from:this.h(B,de.from),fromRanges:de.fromRanges.map(ye=>f.Range.from(ye))}))}async provideCallsFrom(B,Y,ie){const re=this.j(B,Y);if(!re)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyOutgoingCalls(re,ie);if(Q)return Q.map(de=>({to:this.h(B,de.to),fromRanges:de.fromRanges.map(ye=>f.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,Y){const ie=this.e.get(B),re=f.CallHierarchyItem.from(Y,B,ie.size.toString(36));return ie.set(re._itemId,Y),re}j(B,Y){return this.e.get(B)?.get(Y)}}class oe{constructor(B,Y){this.f=B,this.g=Y,this.d=new s.$7L(""),this.e=new Map}async prepareSession(B,Y,ie){const re=this.f.getDocument(B),Q=f.Position.to(Y),de=await this.g.prepareTypeHierarchy(re,Q,ie);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(je=>this.h(ye,je)):[this.h(ye,de)]}async provideSupertypes(B,Y,ie){const re=this.j(B,Y);if(!re)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySupertypes(re,ie);if(Q)return Q.map(de=>this.h(B,de))}async provideSubtypes(B,Y,ie){const re=this.j(B,Y);if(!re)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySubtypes(re,ie);if(Q)return Q.map(de=>this.h(B,de))}releaseSession(B){this.e.delete(B)}h(B,Y){const ie=this.e.get(B),re=f.TypeHierarchyItem.from(Y,B,ie.size.toString(36));return ie.set(re._itemId,Y),re}j(B,Y){return this.e.get(B)?.get(Y)}}class he{static toInternalProviderId(B,Y){return B+"."+Y}constructor(B,Y,ie,re,Q){this.d=B,this.e=Y,this.f=ie,this.g=re,this.h=Q}async provideDocumentOnDropEdits(B,Y,ie,re,Q){const de=this.e.getDocument(Y),ye=f.Position.to(ie),je=f.DataTransfer.toDataTransfer(re,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentDropEdits(de,ye,je,Q);if(We)return{label:We.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:he.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor(B,Y){this.d=B,this.e=Y}async provideMappedEdits(B,Y,ie,re){const Q=C.URI.revive(B),de=this.d.getDocument(Q),ye={selections:ie.selections.map(We=>f.Selection.to(We)),related:ie.related.map(We=>({uri:C.URI.revive(We.uri),range:f.Range.to(We.range)}))},je=await this.e.provideMappedEdits(de,Y,ye,re);return je?f.WorkspaceEdit.from(je):null}}class le{constructor(B,Y){this.adapter=B,this.extension=Y}}class be{static{this.d=0}constructor(B,Y,ie,re,Q,de,ye,je){this.g=Y,this.h=ie,this.j=re,this.k=Q,this.l=de,this.m=ye,this.n=je,this.f=new Map,this.e=B.getProxy($.$1J.MainThreadLanguageFeatures)}o(B,Y){return f.DocumentSelector.from(B,this.g,Y)}p(B){return new L.$3J(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return be.d++}async t(B,Y,ie,re,Q,de=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof Y))return re;const je=Date.now();de||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${ie.toString().replace(/[\r\n]/g,"")}'`);const We=ie(ye.adapter,ye.extension);return Promise.resolve(We).catch(_e=>{(0,b.$2)(_e)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(ye.extension.identifier,_e))}).finally(()=>{de||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),k.CancellationToken.isCancellationToken(Q)?(0,h.$wg)(We,Q):We}u(B,Y){const ie=this.q();return this.f.set(ie,new le(B,Y)),ie}static w(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Y,ie,re){const Q=this.u(new a(this.h,ie),B),de=re&&re.label||be.w(B);return this.e.$registerDocumentSymbolProvider(Q,this.o(Y,B),de),this.p(Q)}$provideDocumentSymbols(B,Y,ie){return this.t(B,a,re=>re.provideDocumentSymbols(C.URI.revive(Y),ie),void 0,ie)}registerCodeLensProvider(B,Y,ie){const re=this.q(),Q=typeof ie.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(re,new le(new i(this.h,this.j.converter,ie),B)),this.e.$registerCodeLensSupport(re,this.o(Y,B),Q);let de=this.p(re);if(Q!==void 0){const ye=ie.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(Q));de=L.$3J.from(de,ye)}return de}$provideCodeLenses(B,Y,ie){return this.t(B,i,re=>re.provideCodeLenses(C.URI.revive(Y),ie),void 0,ie)}$resolveCodeLens(B,Y,ie){return this.t(B,i,re=>re.resolveCodeLens(Y,ie),void 0,void 0)}$releaseCodeLenses(B,Y){this.t(B,i,ie=>Promise.resolve(ie.releaseCodeLenses(Y)),void 0,void 0)}registerDefinitionProvider(B,Y,ie){const re=this.u(new d(this.h,ie),B);return this.e.$registerDefinitionSupport(re,this.o(Y,B)),this.p(re)}$provideDefinition(B,Y,ie,re){return this.t(B,d,Q=>Q.provideDefinition(C.URI.revive(Y),ie,re),[],re)}registerDeclarationProvider(B,Y,ie){const re=this.u(new y(this.h,ie),B);return this.e.$registerDeclarationSupport(re,this.o(Y,B)),this.p(re)}$provideDeclaration(B,Y,ie,re){return this.t(B,y,Q=>Q.provideDeclaration(C.URI.revive(Y),ie,re),[],re)}registerImplementationProvider(B,Y,ie){const re=this.u(new S(this.h,ie),B);return this.e.$registerImplementationSupport(re,this.o(Y,B)),this.p(re)}$provideImplementation(B,Y,ie,re){return this.t(B,S,Q=>Q.provideImplementation(C.URI.revive(Y),ie,re),[],re)}registerTypeDefinitionProvider(B,Y,ie){const re=this.u(new g(this.h,ie),B);return this.e.$registerTypeDefinitionSupport(re,this.o(Y,B)),this.p(re)}$provideTypeDefinition(B,Y,ie,re){return this.t(B,g,Q=>Q.provideTypeDefinition(C.URI.revive(Y),ie,re),[],re)}registerHoverProvider(B,Y,ie,re){const Q=this.u(new u(this.h,ie),B);return this.e.$registerHoverProvider(Q,this.o(Y,B)),this.p(Q)}$provideHover(B,Y,ie,re){return this.t(B,u,Q=>Q.provideHover(C.URI.revive(Y),ie,re),void 0,re)}registerEvaluatableExpressionProvider(B,Y,ie,re){const Q=this.u(new m(this.h,ie),B);return this.e.$registerEvaluatableExpressionProvider(Q,this.o(Y,B)),this.p(Q)}$provideEvaluatableExpression(B,Y,ie,re){return this.t(B,m,Q=>Q.provideEvaluatableExpression(C.URI.revive(Y),ie,re),void 0,re)}registerInlineValuesProvider(B,Y,ie,re){const Q=typeof ie.onDidChangeInlineValues=="function"?this.q():void 0,de=this.u(new P(this.h,ie),B);this.e.$registerInlineValuesProvider(de,this.o(Y,B),Q);let ye=this.p(de);if(Q!==void 0){const je=ie.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Q));ye=L.$3J.from(ye,je)}return ye}$provideInlineValues(B,Y,ie,re,Q){return this.t(B,P,de=>de.provideInlineValues(C.URI.revive(Y),ie,re,Q),void 0,Q)}registerDocumentHighlightProvider(B,Y,ie){const re=this.u(new O(this.h,ie),B);return this.e.$registerDocumentHighlightProvider(re,this.o(Y,B)),this.p(re)}$provideDocumentHighlights(B,Y,ie,re){return this.t(B,O,Q=>Q.provideDocumentHighlights(C.URI.revive(Y),ie,re),void 0,re)}registerLinkedEditingRangeProvider(B,Y,ie){const re=this.u(new N(this.h,ie),B);return this.e.$registerLinkedEditingRangeProvider(re,this.o(Y,B)),this.p(re)}$provideLinkedEditingRanges(B,Y,ie,re){return this.t(B,N,async Q=>{const de=await Q.provideLinkedEditingRanges(C.URI.revive(Y),ie,re);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?be.y(de.wordPattern):void 0}},void 0,re)}registerReferenceProvider(B,Y,ie){const re=this.u(new M(this.h,ie),B);return this.e.$registerReferenceSupport(re,this.o(Y,B)),this.p(re)}$provideReferences(B,Y,ie,re,Q){return this.t(B,M,de=>de.provideReferences(C.URI.revive(Y),ie,re,Q),void 0,Q)}registerCodeActionProvider(B,Y,ie,re){const Q=new v.$jc,de=this.u(new j(this.h,this.j.converter,this.k,ie,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(de,this.o(Y,B),{providedKinds:re?.providedCodeActionKinds?.map(ye=>ye.value),documentation:re?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Q)}))},be.w(B),!!ie.resolveCodeAction),Q.add(this.p(de)),Q}$provideCodeActions(B,Y,ie,re,Q){return this.t(B,j,de=>de.provideCodeActions(C.URI.revive(Y),ie,re,Q),void 0,Q)}$resolveCodeAction(B,Y,ie){return this.t(B,j,re=>re.resolveCodeAction(Y,ie),{},void 0)}$releaseCodeActions(B,Y){this.t(B,j,ie=>Promise.resolve(ie.releaseCodeActions(Y)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Y,ie){const re=this.u(new T(this.h,ie),B);return this.e.$registerDocumentFormattingSupport(re,this.o(Y,B),B.identifier,B.displayName||B.name),this.p(re)}$provideDocumentFormattingEdits(B,Y,ie,re){return this.t(B,T,Q=>Q.provideDocumentFormattingEdits(C.URI.revive(Y),ie,re),void 0,re)}registerDocumentRangeFormattingEditProvider(B,Y,ie){const re=typeof ie.provideDocumentRangesFormattingEdits=="function",Q=this.u(new H(this.h,ie),B);return this.e.$registerRangeFormattingSupport(Q,this.o(Y,B),B.identifier,B.displayName||B.name,re),this.p(Q)}$provideDocumentRangeFormattingEdits(B,Y,ie,re,Q){return this.t(B,H,de=>de.provideDocumentRangeFormattingEdits(C.URI.revive(Y),ie,re,Q),void 0,Q)}$provideDocumentRangesFormattingEdits(B,Y,ie,re,Q){return this.t(B,H,de=>de.provideDocumentRangesFormattingEdits(C.URI.revive(Y),ie,re,Q),void 0,Q)}registerOnTypeFormattingEditProvider(B,Y,ie,re){const Q=this.u(new q(this.h,ie),B);return this.e.$registerOnTypeFormattingSupport(Q,this.o(Y,B),re,B.identifier),this.p(Q)}$provideOnTypeFormattingEdits(B,Y,ie,re,Q,de){return this.t(B,q,ye=>ye.provideOnTypeFormattingEdits(C.URI.revive(Y),ie,re,Q,de),void 0,de)}registerWorkspaceSymbolProvider(B,Y){const ie=this.u(new me(Y,this.l),B);return this.e.$registerNavigateTypeSupport(ie,typeof Y.resolveWorkspaceSymbol=="function"),this.p(ie)}$provideWorkspaceSymbols(B,Y,ie){return this.t(B,me,re=>re.provideWorkspaceSymbols(Y,ie),{symbols:[]},ie)}$resolveWorkspaceSymbol(B,Y,ie){return this.t(B,me,re=>re.resolveWorkspaceSymbol(Y,ie),void 0,void 0)}$releaseWorkspaceSymbols(B,Y){this.t(B,me,ie=>ie.releaseWorkspaceSymbols(Y),void 0,void 0)}registerRenameProvider(B,Y,ie){const re=this.u(new Z(this.h,ie,this.l),B);return this.e.$registerRenameSupport(re,this.o(Y,B),Z.supportsResolving(ie)),this.p(re)}$provideRenameEdits(B,Y,ie,re,Q){return this.t(B,Z,de=>de.provideRenameEdits(C.URI.revive(Y),ie,re,Q),void 0,Q)}$resolveRenameLocation(B,Y,ie,re){return this.t(B,Z,Q=>Q.resolveRenameLocation(C.URI.revive(Y),ie,re),void 0,re)}registerDocumentSemanticTokensProvider(B,Y,ie,re){const Q=this.u(new V(this.h,ie),B),de=typeof ie.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Q,this.o(Y,B),re,de);let ye=this.p(Q);if(de){const je=ie.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(de));ye=L.$3J.from(ye,je)}return ye}$provideDocumentSemanticTokens(B,Y,ie,re){return this.t(B,V,Q=>Q.provideDocumentSemanticTokens(C.URI.revive(Y),ie,re),null,re)}$releaseDocumentSemanticTokens(B,Y){this.t(B,V,ie=>ie.releaseDocumentSemanticColoring(Y),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Y,ie,re){const Q=this.u(new x(this.h,ie),B);return this.e.$registerDocumentRangeSemanticTokensProvider(Q,this.o(Y,B),re),this.p(Q)}$provideDocumentRangeSemanticTokens(B,Y,ie,re){return this.t(B,x,Q=>Q.provideDocumentRangeSemanticTokens(C.URI.revive(Y),ie,re),null,re)}registerCompletionItemProvider(B,Y,ie,re){const Q=this.u(new ge(this.h,this.j.converter,ie,this.m,B),B);return this.e.$registerCompletionsProvider(Q,this.o(Y,B),re,ge.supportsResolving(ie),B.identifier),this.p(Q)}$provideCompletionItems(B,Y,ie,re,Q){return this.t(B,ge,de=>de.provideCompletionItems(C.URI.revive(Y),ie,re,Q),void 0,Q)}$resolveCompletionItem(B,Y,ie){return this.t(B,ge,re=>re.resolveCompletionItem(Y,ie),void 0,ie)}$releaseCompletionItems(B,Y){this.t(B,ge,ie=>ie.releaseCompletionItems(Y),void 0,void 0)}registerInlineCompletionsProvider(B,Y,ie,re){const Q=new ve(B,this.h,ie,this.j.converter),de=this.u(Q,B);return this.e.$registerInlineCompletionsSupport(de,this.o(Y,B),Q.supportsHandleEvents,D.$Vl.toKey(B.identifier.value),re?.yieldTo?.map(ye=>D.$Vl.toKey(ye))||[]),this.p(de)}$provideInlineCompletions(B,Y,ie,re,Q){return this.t(B,ue,de=>de.provideInlineCompletions(C.URI.revive(Y),ie,re,Q),void 0,Q)}$handleInlineCompletionDidShow(B,Y,ie,re){this.t(B,ue,async Q=>{Q.handleDidShowCompletionItem(Y,ie,re)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Y,ie,re){this.t(B,ue,async Q=>{Q.handlePartialAccept(Y,ie,re)},void 0,void 0)}$freeInlineCompletionsList(B,Y){this.t(B,ue,async ie=>{ie.disposeCompletions(Y)},void 0,void 0)}registerSignatureHelpProvider(B,Y,ie,re){const Q=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,de=this.u(new U(this.h,ie),B);return this.e.$registerSignatureHelpProvider(de,this.o(Y,B),Q),this.p(de)}$provideSignatureHelp(B,Y,ie,re,Q){return this.t(B,U,de=>de.provideSignatureHelp(C.URI.revive(Y),ie,re,Q),void 0,Q)}$releaseSignatureHelp(B,Y){this.t(B,U,ie=>ie.releaseSignatureHelp(Y),void 0,void 0)}registerInlayHintsProvider(B,Y,ie){const re=typeof ie.onDidChangeInlayHints=="function"?this.q():void 0,Q=this.u(new K(this.h,this.j.converter,ie,this.l,B),B);this.e.$registerInlayHintsProvider(Q,this.o(Y,B),typeof ie.resolveInlayHint=="function",re,be.w(B));let de=this.p(Q);if(re!==void 0){const ye=ie.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(re));de=L.$3J.from(de,ye)}return de}$provideInlayHints(B,Y,ie,re){return this.t(B,K,Q=>Q.provideInlayHints(C.URI.revive(Y),ie,re),void 0,re)}$resolveInlayHint(B,Y,ie){return this.t(B,K,re=>re.resolveInlayHint(Y,ie),void 0,ie)}$releaseInlayHints(B,Y){this.t(B,K,ie=>ie.releaseHints(Y),void 0,void 0)}registerDocumentLinkProvider(B,Y,ie){const re=this.u(new fe(this.h,ie),B);return this.e.$registerDocumentLinkProvider(re,this.o(Y,B),typeof ie.resolveDocumentLink=="function"),this.p(re)}$provideDocumentLinks(B,Y,ie){return this.t(B,fe,re=>re.provideLinks(C.URI.revive(Y),ie),void 0,ie,Y.scheme==="output")}$resolveDocumentLink(B,Y,ie){return this.t(B,fe,re=>re.resolveLink(Y,ie),void 0,void 0,!0)}$releaseDocumentLinks(B,Y){this.t(B,fe,ie=>ie.releaseLinks(Y),void 0,void 0,!0)}registerColorProvider(B,Y,ie){const re=this.u(new te(this.h,ie),B);return this.e.$registerDocumentColorProvider(re,this.o(Y,B)),this.p(re)}$provideDocumentColors(B,Y,ie){return this.t(B,te,re=>re.provideColors(C.URI.revive(Y),ie),[],ie)}$provideColorPresentations(B,Y,ie,re){return this.t(B,te,Q=>Q.provideColorPresentations(C.URI.revive(Y),ie,re),void 0,re)}registerFoldingRangeProvider(B,Y,ie){const re=this.q(),Q=typeof ie.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(re,new le(new se(this.h,ie),B)),this.e.$registerFoldingRangeProvider(re,this.o(Y,B),B.identifier,Q);let de=this.p(re);if(Q!==void 0){const ye=ie.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Q));de=L.$3J.from(de,ye)}return de}$provideFoldingRanges(B,Y,ie,re){return this.t(B,se,Q=>Q.provideFoldingRanges(C.URI.revive(Y),ie,re),void 0,re)}registerSelectionRangeProvider(B,Y,ie){const re=this.u(new ne(this.h,ie,this.l),B);return this.e.$registerSelectionRangeProvider(re,this.o(Y,B)),this.p(re)}$provideSelectionRanges(B,Y,ie,re){return this.t(B,ne,Q=>Q.provideSelectionRanges(C.URI.revive(Y),ie,re),[],re)}registerCallHierarchyProvider(B,Y,ie){const re=this.u(new Ee(this.h,ie),B);return this.e.$registerCallHierarchyProvider(re,this.o(Y,B)),this.p(re)}$prepareCallHierarchy(B,Y,ie,re){return this.t(B,Ee,Q=>Promise.resolve(Q.prepareSession(C.URI.revive(Y),ie,re)),void 0,re)}$provideCallHierarchyIncomingCalls(B,Y,ie,re){return this.t(B,Ee,Q=>Q.provideCallsTo(Y,ie,re),void 0,re)}$provideCallHierarchyOutgoingCalls(B,Y,ie,re){return this.t(B,Ee,Q=>Q.provideCallsFrom(Y,ie,re),void 0,re)}$releaseCallHierarchy(B,Y){this.t(B,Ee,ie=>Promise.resolve(ie.releaseSession(Y)),void 0,void 0)}registerTypeHierarchyProvider(B,Y,ie){const re=this.u(new oe(this.h,ie),B);return this.e.$registerTypeHierarchyProvider(re,this.o(Y,B)),this.p(re)}$prepareTypeHierarchy(B,Y,ie,re){return this.t(B,oe,Q=>Promise.resolve(Q.prepareSession(C.URI.revive(Y),ie,re)),void 0,re)}$provideTypeHierarchySupertypes(B,Y,ie,re){return this.t(B,oe,Q=>Q.provideSupertypes(Y,ie,re),void 0,re)}$provideTypeHierarchySubtypes(B,Y,ie,re){return this.t(B,oe,Q=>Q.provideSubtypes(Y,ie,re),void 0,re)}$releaseTypeHierarchy(B,Y){this.t(B,oe,ie=>Promise.resolve(ie.releaseSession(Y)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Y,ie,re){const Q=this.q();this.f.set(Q,new le(new he(this.e,this.h,ie,Q,B),B));const de=(0,t.$XE)(B,"dropMetadata")&&re?he.toInternalProviderId(B.identifier.value,re.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Q,this.o(Y,B),de,(0,t.$XE)(B,"dropMetadata")?re:void 0),this.p(Q)}$provideDocumentOnDropEdits(B,Y,ie,re,Q,de){return this.t(B,he,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(Y,C.URI.revive(ie),re,Q,de)),void 0,void 0)}registerMappedEditsProvider(B,Y,ie){const re=this.u(new ee(this.h,ie),B);return this.e.$registerMappedEditsProvider(re,this.o(Y,B)),this.p(re)}$provideMappedEdits(B,Y,ie,re,Q){return this.t(B,ee,de=>Promise.resolve(de.provideMappedEdits(Y,ie,re,Q)),null,Q)}registerDocumentPasteEditProvider(B,Y,ie,re){const Q=this.q();this.f.set(Q,new le(new z(this.e,this.h,ie,Q,B),B));const de=z.toInternalProviderId(B.identifier.value,re.id);return this.e.$registerPasteEditProvider(Q,this.o(Y,B),de,{supportsCopy:!!ie.prepareDocumentPaste,supportsPaste:!!ie.provideDocumentPasteEdits,copyMimeTypes:re.copyMimeTypes,pasteMimeTypes:re.pasteMimeTypes}),this.p(Q)}$prepareDocumentPaste(B,Y,ie,re,Q){return this.t(B,z,de=>de.prepareDocumentPaste(C.URI.revive(Y),ie,re,Q),void 0,Q)}$providePasteEdits(B,Y,ie,re,Q,de){return this.t(B,z,ye=>ye.providePasteEdits(Y,C.URI.revive(ie),re,Q,de),void 0,de)}static y(B){return{pattern:B.source,flags:B.flags}}static z(B){return{decreaseIndentPattern:be.y(B.decreaseIndentPattern),increaseIndentPattern:be.y(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?be.y(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?be.y(B.unIndentedLinePattern):void 0}}static B(B){return{beforeText:be.y(B.beforeText),afterText:B.afterText?be.y(B.afterText):void 0,previousLineText:B.previousLineText?be.y(B.previousLineText):void 0,action:B.action}}static C(B){return B.map(be.B)}static D(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Y=>L.SyntaxTokenType.toString(Y)):void 0}}static E(B){return B.map(be.D)}setLanguageConfiguration(B,Y,ie){const{wordPattern:re}=ie;if(re&&(0,E.$ze)(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this.h.setWordDefinitionFor(Y,re):this.h.setWordDefinitionFor(Y,void 0),ie.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ie.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const Q=this.q(),de={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?be.y(ie.wordPattern):void 0,indentationRules:ie.indentationRules?be.z(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?be.C(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport,autoClosingPairs:ie.autoClosingPairs?be.E(ie.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Q,Y,de),this.p(Q)}$setWordDefinitions(B){for(const Y of B)this.h.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.$ebc=be}),define(Se[317],De([1,0,6,13,7,38,9,3]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=void 0;class E{constructor(A,I,w,k){this.c=I,this.d=w,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=A.getProxy(C.$1J.MainThreadLanguages)}$acceptLanguageIds(A){this.b=A}async getLanguages(){return this.b.slice(0)}async changeLanguage(A,I){await this.a.$changeLanguage(A,I);const w=this.c.getDocumentData(A);if(!w)throw new Error(`document '${A.toString()}' NOT found`);return w.document}async tokenAtPosition(A,I){const w=A.version,k=F.Position.from(I),D=await this.a.$tokensAtPosition(A.uri,k),v={type:f.StandardTokenType.Other,range:A.getWordRangeAtPosition(I)??new f.$5J(I.line,I.character,I.line,I.character)};if(!D)return v;const o={range:F.Range.to(D.range),type:F.TokenType.to(D.type)};return!o.range.contains(I)||w!==A.version?v:o}createLanguageStatusItem(A,I,w){const k=this.f++,D=this.a,v=this.g,o=`${A.identifier.value}/${I}`;if(v.has(o))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);v.add(o);const s={selector:w,id:I,name:A.displayName??A.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const l=new $.$jc,b=()=>{if(n?.dispose(),!v.has(o)){console.warn(`LanguageStatusItem (${I}) from ${A.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$Ig)(()=>{l.clear(),this.a.$setLanguageStatus(k,{id:o,name:s.name??A.displayName??A.name,source:A.displayName??A.name,selector:F.DocumentSelector.from(s.selector,this.e),label:s.text,detail:s.detail??"",severity:s.severity===f.LanguageStatusSeverity.Error?L.default.Error:s.severity===f.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:s.command&&this.d.toInternal(s.command,l),accessibilityInfo:s.accessibilityInformation,busy:s.busy})},0)},h={dispose(){l.dispose(),n?.dispose(),D.$removeLanguageStatus(k),v.delete(o)},get id(){return s.id},get name(){return s.name},set name(t){s.name=t,b()},get selector(){return s.selector},set selector(t){s.selector=t,b()},get text(){return s.text},set text(t){s.text=t,b()},get detail(){return s.detail},set detail(t){s.detail=t,b()},get severity(){return s.severity},set severity(t){s.severity=t,b()},get accessibilityInformation(){return s.accessibilityInformation},set accessibilityInformation(t){s.accessibilityInformation=t,b()},get command(){return s.command},set command(t){s.command=t,b()},get busy(){return s.busy},set busy(t){s.busy=t,b()}};return b(),h}}e.$Ybc=E}),define(Se[112],De([1,0,12,15,2,5,14,6,26,20]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=void 0;let A=class{constructor(w,k,D){this.f=D,this.d=new Map,this.a=k.getProxy($.$1J.MainThreadLocalization),this.b=w.environment.appLanguage,this.c=this.b===C.$f}getMessage(w,k){const{message:D,args:v,comment:o}=k;if(this.c)return(0,F.$oe)(D,v??{});let s=D;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(w)?.contents[s];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,F.$oe)(n??D,v??{})}getBundle(w){return this.d.get(w)?.contents}getBundleUri(w){return this.d.get(w)?.uri}async initializeLocalizedMessages(w){if(this.c||!w.l10n&&!w.isBuiltin||this.d.has(w.identifier.value))return;let k;const D=await this.g(w);if(!D){this.f.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const v=await this.a.$fetchBundleContents(D),o=JSON.parse(v);k=w.isBuiltin?o.contents?.bundle:o}catch(v){this.f.error(`Failed to load translations for ${w.identifier.value} from ${D}: ${v.message}`);return}k&&this.d.set(w.identifier.value,{contents:k,uri:D})}async g(w){if(w.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(w.identifier.value,this.b);return f.URI.revive(k)}return w.l10n?f.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Nbc=A,e.$Nbc=A=Ke([Be(0,E.$fM),Be(1,p.$2L),Be(2,R.$5i)],A),e.$Obc=(0,L.$Bh)("IExtHostLocalizationService")}),define(Se[150],De([1,0,14,6,26,20,2,63]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;let E=class extends C.$dj{constructor(I,w){super(w.logLevel,w.logsLocation,w.loggers.map(k=>(0,$.$$g)(k))),this.r=I.getProxy(F.$1J.MainThreadLogger)}$setLogLevel(I,w){w?this.setLogLevel(R.URI.revive(w),I):this.setLogLevel(I)}setVisibility(I,w){super.setVisibility(I,w),this.r.$setVisibility(I,w)}s(I,w,k){return new p(this.r,I,w,k)}};e.$ddc=E,e.$ddc=E=Ke([Be(0,L.$2L),Be(1,f.$fM)],E);class p extends C.$$i{constructor(I,w,k,D){super(D?.logLevel==="always"),this.r=I,this.s=w,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(w,D).then(()=>{this.u(this.n),this.m=!0})}g(I,w){const k=[[I,w]];this.m?this.u(k):this.n.push(...k)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(Se[113],De([1,0,6,5,3,20,22]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.$Pbc=void 0,e.$Pbc=(0,F.$Bh)("IExtHostManagedSockets");let $=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(C.$1J.MainThreadManagedSockets)}setFactory(I,w){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(I,w),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const w=++this.b,k=await this.c.makeConnection(),D=new f.$jc;return this.d.set(w,new p(w,k,D)),D.add((0,f.$ic)(()=>this.d.delete(w))),D.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(w),D.dispose()})),D.add(k.onDidClose(v=>{this.a.$onDidManagedSocketClose(w,v?.stack??v?.message),D.dispose()})),D.add(k.onDidReceiveMessage(v=>this.a.$onDidManagedSocketHaveData(w,R.$Fd.wrap(v)))),w}$remoteSocketWrite(I,w){this.d.get(I)?.actual.send(w.buffer)}$remoteSocketEnd(I){const w=this.d.get(I);w&&(w.actual.end(),w.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$Qbc=$,e.$Qbc=$=Ke([Be(0,L.$2L)],$);class E{constructor(I,w){this.socketFactoryId=I,this.makeConnection=w}}class p extends f.$kc{constructor(I,w,k){super(),this.socketId=I,this.actual=w,this.B(k)}}}),define(Se[318],De([1,0,6,14,27]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=void 0;function L($){return $&&$.title}let R=class{constructor(E,p){this.b=p,this.a=E.getProxy(C.$1J.MainThreadMessageService)}showMessage(E,p,A,I,w){const k={source:{identifier:E.identifier,label:E.displayName||E.name}};let D;typeof I=="string"||L(I)?D=[I,...w]:(k.modal=I?.modal,k.useCustom=I?.useCustom,k.detail=I?.detail,D=w),k.useCustom&&(0,f.$YE)(E,"resolvers");const v=[];for(let o=0;o<D.length;o++){const s=D[o];if(typeof s=="string")v.push({title:s,handle:o,isCloseAffordance:!1});else if(typeof s=="object"){const{title:n,isCloseAffordance:l}=s;v.push({title:n,isCloseAffordance:!!l,handle:o})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(p,A,k,v).then(o=>{if(typeof o=="number")return D[o]})}};e.$Zbc=R,e.$Zbc=R=Ke([Be(1,F.$5i)],R)}),define(Se[319],De([1,0,207,22,4,3,28,15,18,2,30,87,6,33,13,7,70,281,144,8,23,17]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,i,c,d,y){this.q=c,this.r=d,this.s=y,this.f=new Map,this.g=new R.$zi,this.h=new Map,this.j=new f.$fd({onListenerError:l.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$fd({onListenerError:l.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$fd({onListenerError:l.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$fd({onListenerError:l.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$8ac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=a.getProxy(w.$1J.MainThreadNotebook),this.c=a.getProxy(w.$1J.MainThreadNotebookDocuments),this.d=a.getProxy(w.$1J.MainThreadNotebookEditors),this.i=i.converter,i.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const g=S.notebookEditor?.notebookUri,u=S.cell.handle,P=this.g.get(g)?.getCell(u);if(P)return P.apiCell}if(S&&S.$mid===14){const g=S.uri,u=this.g.get(g);if(u)return u.apiNotebook}return S}}),t.A(i)}getEditorById(a){const i=this.h.get(a);if(!i)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return i}getIdByEditor(a){for(const[i,c]of this.h)if(c.apiEditor===a)return i}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,i){const c=this.g.get(a);if(!c&&!i)throw new Error(`NO notebook document for '${a}'`);return c}static t(a,i){if(!i)return;const c=i.filenamePattern.map(d=>D.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(i.filenamePattern&&!c){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:i.displayName,filenamePattern:c,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,i,c){const d=t.a++,y=typeof c.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(d,c),this.b.$registerNotebookCellStatusBarItemProvider(d,y,i);let S;return y!==void 0&&(S=c.onDidChangeCellStatusBarItems(g=>this.b.$emitCellStatusBarEvent(y))),new v.$3J(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,y),S?.dispose()})}async createNotebookDocument(a){const i=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&D.NotebookData.from(a.content)});return p.URI.revive(i)}async openNotebookDocument(a){const i=this.g.get(a);if(i)return i.apiNotebook;const c=await this.c.$tryOpenNotebook(a),d=this.g.get(p.URI.revive(c));return(0,E.$uf)(d?.apiNotebook)}async showNotebookDocument(a,i){p.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let c;typeof i=="object"?c={position:D.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(D.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:c={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,c),y=d&&this.h.get(d)?.apiEditor;if(y)return y;throw d?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,i,c,d){const y=this.f.get(a),S=p.URI.revive(i),g=this.g.get(S);if(!g||!y)return;const u=g.getCellFromIndex(c);if(!u)return;const m=await y.provideCellStatusBarItems(u.apiCell,d);if(!m)return;const P=new L.$jc,O=this.p.add([P]),M=(Array.isArray(m)?m:[m]).map(j=>D.NotebookStatusBarItem.from(j,this.i,P));return{cacheId:O,items:M}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,i,c,d,y){if((0,$.$me)(i))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:i,serializer:c,options:d}),this.b.$registerNotebookSerializer(S,{id:a.identifier,location:a.extensionLocation},i,D.NotebookDocumentContentOptions.from(d),t.t(a,y)),(0,L.$ic)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(a,i,c){const d=this.w.get(a);if(!d)throw new Error("NO serializer found");const y=await d.serializer.deserializeNotebook(i.buffer,c);return new o.$gv(D.NotebookData.from(y))}async $notebookToData(a,i,c){const d=this.w.get(a);if(!d)throw new Error("NO serializer found");const y=await d.serializer.serializeNotebook(D.NotebookData.to(i.value),c);return F.$Fd.wrap(y)}async $saveNotebook(a,i,c,d,y){const S=p.URI.revive(i),g=this.w.get(a);if(!g)throw new Error("NO serializer found");const u=this.g.get(S);if(!u)throw new Error("Document NOT found");if(u.versionId!==c)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new A.$nk((0,C.localize)(0,null,this.y(S)),6);await this.x(S,d);const m={metadata:(0,b.$4m)(u.apiNotebook.metadata,j=>!(g.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of u.apiNotebook.getCells()){const z=new v.$oL(j.kind,j.document.getText(),j.document.languageId,j.mime,g.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);z.metadata=(0,b.$4m)(j.metadata,T=>!(g.options?.transientCellMetadata??{})[T]),m.cells.push(z)}const P=await g.serializer.serializeNotebook(m,y);await this.s.value.writeFile(S,P);const O=this.s.getFileSystemProviderExtUri(S.scheme),N=await this.s.value.stat(S);return{name:O.basename(S),isFile:(N.type&A.FileType.File)!==0,isDirectory:(N.type&A.FileType.Directory)!==0,isSymbolicLink:(N.type&A.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((N.permissions??0)&A.FilePermission.Locked),etag:A.$yk({mtime:N.mtime,size:N.size}),children:void 0}}async x(a,i){const c=await this.s.value.stat(a);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==A.$xk&&typeof c.mtime=="number"&&typeof c.size=="number"&&i.mtime<c.mtime&&i.etag!==A.$yk({mtime:i.mtime,size:c.size}))throw new A.$nk((0,C.localize)(1,null),3,i)}y(a){return a.scheme===h.Schemas.file?a.fsPath:a.toString()}z(a,i,c){if(this.h.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const d=new n.$Gcc(i,this.d,a,c.visibleRanges.map(D.NotebookRange.to),c.selections.map(D.NotebookRange.to),typeof c.viewColumn=="number"?D.ViewColumn.to(c.viewColumn):void 0);this.h.set(i,d)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const c of a.value.removedDocuments){const d=p.URI.revive(c),y=this.g.get(d);y&&(y.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:y.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(y.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===d.toString()&&this.h.delete(S.id)}if(a.value.addedDocuments){const c=[];for(const d of a.value.addedDocuments){const y=p.URI.revive(d.uri);if(this.g.has(y))throw new Error(`adding EXISTING notebook ${y} `);const S=new s.$Fcc(this.c,this.q,this.r,y,d);c.push(...d.cells.map(g=>s.$Ecc.asModelAddData(S.apiNotebook,g))),this.g.get(y)?.dispose(),this.g.set(y,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:c}),this.m.fire(S.apiNotebook)}}if(a.value.addedEditors)for(const c of a.value.addedEditors){if(this.h.has(c.id))return;const d=p.URI.revive(c.documentUri),y=this.g.get(d);y&&this.z(y,c.id,c)}const i=[];if(a.value.removedEditors)for(const c of a.value.removedEditors){const d=this.h.get(c);d&&(this.h.delete(c),this.k?.id===d.id&&(this.k=void 0),i.push(d))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const c=new Set;this.l.forEach(d=>c.add(d.id));for(const d of this.h.values()){const y=c.has(d.id);d._acceptVisibility(y)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(a){const i=k.$nM.String.with("notebookType","A notebook type"),c=new k.$pM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new k.$nM("data","Bytes to convert to data",y=>y instanceof Uint8Array,y=>F.$Fd.wrap(y))],new k.$oM("Notebook Data",y=>D.NotebookData.to(y.value))),d=new k.$pM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new k.$nM("NotebookData","Notebook data to convert to bytes",y=>!0,y=>new o.$gv(D.NotebookData.from(y)))],new k.$oM("Bytes",y=>y.buffer));a.registerApiCommand(c),a.registerApiCommand(d)}}e.$Hcc=t}),define(Se[320],De([1,0,19,9,21,4,3,28,2,25,14,87,6,33,13,7,110,275,27,70]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=void 0;let b=class{constructor(y,S,g,u,m){this.m=S,this.n=g,this.o=u,this.q=m,this.b=new $.$zi,this.c=new $.$zi,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new I.$8ac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.$fd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=y.getProxy(w.$1J.MainThreadNotebookKernels);const P=new k.$pM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new k.$nM("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const N=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:N}}else if(O&&"notebookEditor"in O){const N=this.n.getIdByEditor(O.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return O})],k.$oM.Void);this.o.registerApiCommand(P)}createNotebookController(y,S,g,u,m,P){for(const ge of this.j.values())if(ge.controller.id===S&&p.$Vl.equals(y.identifier,ge.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const O=this.k++,N=this;this.q.trace(`NotebookController[${O}], CREATED by ${y.identifier.value}, ${S}`);const M=()=>console.warn(`NO execute handler from notebook controller '${H.id}' of extension: '${y.identifier}'`);let j=!1;const z=new L.$fd,T=new L.$fd,H={id:c(y.identifier,S),notebookType:g,extensionId:y.identifier,extensionLocation:y.extensionLocation,label:u||y.identifier.value,preloads:P?P.map(D.NotebookRendererScript.from):[]};let q=m??M,me;this.a.$addKernel(O,H).catch(ge=>{console.log(ge),j=!0});let Z=0;const X=()=>{if(j)return;const ge=++Z;Promise.resolve().then(()=>{ge===Z&&this.a.$updateKernel(O,H)})},V=new $.$zi,x={get id(){return S},get notebookType(){return H.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return H.label},set label(ge){H.label=ge??y.displayName??y.name,X()},get detail(){return H.detail??""},set detail(ge){H.detail=ge,X()},get description(){return H.description??""},set description(ge){H.description=ge,X()},get supportedLanguages(){return H.supportedLanguages},set supportedLanguages(ge){H.supportedLanguages=ge,X()},get supportsExecutionOrder(){return H.supportsExecutionOrder??!1},set supportsExecutionOrder(ge){H.supportsExecutionOrder=ge,X()},get rendererScripts(){return H.preloads?H.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(ge){q=ge??M},get interruptHandler(){return me},set interruptHandler(ge){me=ge,H.supportsInterrupt=!!ge,X()},createNotebookCellExecution(ge){if(j)throw new Error("notebook controller is DISPOSED");if(!V.has(ge.notebook.uri))throw N.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.notebook.uri.toString()}`);return N._createNotebookCellExecution(ge,c(y.identifier,this.id))},createNotebookExecution(ge){if((0,n.$YE)(y,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!V.has(ge.uri))throw N.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.uri.toString()}`);return N._createNotebookExecution(ge,c(y.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${O}], DISPOSED`),j=!0,this.j.delete(O),z.dispose(),T.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(ge,ue){ue===v.NotebookControllerAffinity2.Hidden&&(0,n.$YE)(y,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(O,ge.uri,ue)},onDidReceiveMessage:T.event,postMessage(ge,ue){return(0,n.$YE)(y,"notebookMessaging"),N.a.$postMessage(O,ue&&N.n.getIdByEditor(ue),ge)},asWebviewUri(ge){return(0,n.$YE)(y,"notebookMessaging"),(0,o.$Yob)(ge,N.m.remote)}};return this.j.set(O,{extensionId:y.identifier,controller:x,onDidReceiveMessage:T,onDidChangeSelection:z,associatedNotebooks:V}),x}getIdByController(y){for(const[S,g]of this.j)if(g.controller===y)return c(g.extensionId,y.id);return null}createNotebookControllerDetectionTask(y,S){const g=this.f++,u=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${y.identifier.value}`),this.a.$addKernelDetectionTask(g,S);const m={dispose:()=>{this.e.delete(g),u.a.$removeKernelDetectionTask(g)}};return this.e.set(g,m),m}registerKernelSourceActionProvider(y,S,g){const u=this.h++,m=typeof g.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,P=this;this.g.set(u,g),this.q.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${y.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,S);let O;return m!==void 0&&(O=g.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.g.delete(u),P.a.$removeKernelSourceActionProvider(u,u),O?.dispose()}}}async $provideKernelSourceActions(y,S){const g=this.g.get(y);if(g){const u=new R.$jc;return this.i.add([u]),(await g.provideNotebookKernelSourceActions(S)??[]).map(P=>D.NotebookKernelSourceAction.from(P,this.o.converter,u))}return[]}$acceptNotebookAssociation(y,S,g){const u=this.j.get(y);if(u){const m=this.n.getNotebookDocument(E.URI.revive(S));g?u.associatedNotebooks.set(m.uri,!0):u.associatedNotebooks.delete(m.uri),this.q.trace(`NotebookController[${y}] ASSOCIATE notebook`,m.uri.toString(),g),u.onDidChangeSelection.fire({selected:g,notebook:m.apiNotebook})}}async $executeCells(y,S,g){const u=this.j.get(y);if(!u)return;const m=this.n.getNotebookDocument(E.URI.revive(S)),P=[];for(const O of g){const N=m.getCell(O);N&&P.push(N.apiCell)}try{this.q.trace(`NotebookController[${y}] EXECUTE cells`,m.uri.toString(),P.length),await u.controller.executeHandler.call(u.controller,P,m.apiNotebook,u.controller)}catch(O){this.q.error(`NotebookController[${y}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(y,S,g){const u=this.j.get(y);if(!u)return;const m=this.n.getNotebookDocument(E.URI.revive(S));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,m.apiNotebook);else for(const P of g){const O=m.getCell(P);O&&this.b.get(O.uri)?.cancel()}if(u.controller.interruptHandler){const P=this.c.get(m.uri);g.length&&Array.isArray(P)&&P.length&&P.forEach(O=>O.dispose())}}$acceptKernelMessageFromRenderer(y,S,g){const u=this.j.get(y);if(!u)return;const m=this.n.getEditorById(S);u.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:g}))}$cellExecutionChanged(y,S,g){const m=this.n.getNotebookDocument(E.URI.revive(y)).getCell(S);if(m){const P=g?D.NotebookCellExecutionState.to(g):v.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:m.apiCell,state:P})}}_createNotebookCellExecution(y,S){if(y.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.n.getNotebookDocument(y.notebook.uri).getCellFromApiCell(y);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const m=new t(S,u,this.a);this.b.set(u.uri,m);const P=m.onDidChangeState(()=>{m.state===h.Resolved&&(m.dispose(),P.dispose(),this.b.delete(u.uri))});return m.asApiObject()}_createNotebookExecution(y,S){const g=this.n.getNotebookDocument(y.uri),u=y.getCells().find(O=>{const N=g.getCellFromApiCell(O);return N&&this.b.has(N.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const m=new a(S,g,this.a),P=m.onDidChangeState(()=>{m.state===r.Resolved&&(m.dispose(),P.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[m,P]),m.asApiObject()}};e.$Vcc=b,e.$Vcc=b=Ke([Be(4,A.$5i)],b);var h;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(h||(h={}));class t extends R.$kc{static{this.a=0}get state(){return this.f}constructor(y,S,g){super(),this.m=S,this.n=g,this.b=t.a++,this.c=new L.$fd,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new f.$pd),this.h=new i(10,u=>this.s(u)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,y,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(y){await this.h.addItem(y)}async s(y){const S=Array.isArray(y)?y:[y];return this.n.$updateExecution(this.b,new l.$gv(S))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(y){let S=this.m;if(y&&(S=this.m.notebook.getCellFromApiCell(y)),!S)throw new Error("INVALID cell");return S.handle}y(y){return y.map(S=>{const g=v.$rL.ensureUniqueMimeTypes(S.items,!0);return g===S.items?D.NotebookCellOutput.from(S):D.NotebookCellOutput.from({items:g,id:S.id,metadata:S.metadata})})}async z(y,S,g){const u=this.w(S),m=this.y((0,C.$1b)(y));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:u,append:g,outputs:m})}async C(y,S,g){return y=v.$rL.ensureUniqueMimeTypes((0,C.$1b)(y),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:y.map(D.NotebookCellOutputItem.from),outputId:S.id,append:g})}asApiObject(){const y=this;return Object.freeze({get token(){return y.g.token},get cell(){return y.m.apiCell},get executionOrder(){return y.j},set executionOrder(g){y.j=g,y.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:y.j}])},start(g){if(y.f===h.Resolved||y.f===h.Started)throw new Error("Cannot call start again");y.f=h.Started,y.c.fire(),y.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,u){if(y.f===h.Resolved)throw new Error("Cannot call resolve twice");y.f=h.Resolved,y.c.fire(),y.h.flush(),y.n.$completeExecution(y.b,new l.$gv({runEndTime:u,lastRunSuccess:g}))},clearOutput(g){return y.t(),y.z([],g,!1)},appendOutput(g,u){return y.t(),y.z(g,u,!0)},replaceOutput(g,u){return y.t(),y.z(g,u,!1)},appendOutputItems(g,u){return y.t(),y.C(g,u,!0)},replaceOutputItems(g,u){return y.t(),y.C(g,u,!1)}})}}var r;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(r||(r={}));class a extends R.$kc{static{this.a=0}get state(){return this.f}constructor(y,S,g){super(),this.h=S,this.j=g,this.b=a.a++,this.c=new L.$fd,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new f.$pd),this.j.$createNotebookExecution(this.b,y,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class i{constructor(y,S){this.e=y,this.f=S,this.a=[],this.b=Date.now()}addItem(y){return this.a.push(y),this.c||(this.c=new F.$2g,this.b=Date.now(),(0,F.$Hg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const y=this.c;this.c=void 0;const S=this.a;return this.a=[],this.f(S).finally(()=>y.complete())}}function c(d,y){return`${d.value}/${y}`}e.$Wcc=c}),define(Se[321],De([1,0,4,6,144]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class L{constructor($,E){this.c=E,this.a=new Map,this.b=$.getProxy(F.$1J.MainThreadNotebookRenderers)}$postRendererMessage($,E,p){const A=this.c.getEditorById($);this.a.get(E)?.fire({editor:A.apiEditor,message:p})}createRendererMessaging($,E){if(!$.contributes?.notebookRenderer?.some(A=>A.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(A,I,w)=>this.d(E).event(A,I,w),postMessage:(A,I)=>{f.$Gcc.apiEditorsToExtHost.has(A)&&([A,I]=[I,A]);const w=I&&f.$Gcc.apiEditorsToExtHost.get(I);return this.b.$postMessage(w?.id,E,A)}}}d($){let E=this.a.get($);return E||(E=new C.$fd({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete($)}}),this.a.set($,E),E)}}e.$Xcc=L}),define(Se[322],De([1,0,3,18,2,27,6]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;class ${constructor(p){this.b=new Map,this.a=p.getProxy(R.$1J.MainThreadProfileContentHandlers)}registrProfileContentHandler(p,A,I){if((0,L.$YE)(p,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,I),this.a.$registerProfileContentHandler(A,I.name,I.description,p.identifier.value),(0,C.$ic)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(p,A,I,w){const k=this.b.get(p);if(!k)throw new Error(`Unknown handler with id: ${p}`);return k.saveProfile(A,I,w)}async $readProfile(p,A,I){const w=this.b.get(p);if(!w)throw new Error(`Unknown handler with id: ${p}`);return w.readProfile((0,F.$jf)(A)?A:f.URI.revive(A),I)}}e.$2cc=$}),define(Se[323],De([1,0,2,6,9,13]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;class R{static{this.a=0}constructor(E,p){this.d=p,this.c=new Map,this.b=E.getProxy(F.$1J.MainThreadQuickDiff)}$provideOriginalResource(E,p,A){const I=C.URI.revive(p),w=this.c.get(E);return w?(0,f.$zg)(()=>w.provideOriginalResource(I,A)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(E,p,A,I){const w=R.a++;return this.c.set(w,p),this.b.$registerQuickDiffProvider(w,L.DocumentSelector.from(E,this.d),A,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(w),this.c.delete(w)}}}}e.$3cc=R}),define(Se[324],De([1,0,21,4,3,6,2,7,8,19,38,60,27,13]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;function D(v,o,s){const n=v.getProxy(L.$1J.MainThreadQuickOpen);class l{constructor(y,S){this.e=new Map,this.f=0,this.a=y,this.b=S}showQuickPick(y,S,g,u=C.CancellationToken.None){this.c=void 0;const m=Promise.resolve(S),P=++this.f,O=n.$show(P,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},u),N={},M=O.then(()=>N);return Promise.race([M,m]).then(j=>{if(j===N)return;const z=(0,w.$XE)(y,"quickPickItemTooltip");return m.then(T=>{const H=[];for(let q=0;q<T.length;q++){const me=T[q];if(typeof me=="string")H.push({label:me,handle:q});else if(me.kind===$.QuickPickItemKind.Separator)H.push({type:"separator",label:me.label});else{me.tooltip&&!z&&console.warn(`Extension '${y.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${y.identifier.value}`);const Z=me.iconPath?a(me.iconPath):void 0;H.push({label:me.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:z?k.MarkdownString.fromStrict(me.tooltip):void 0,handle:q})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=q=>{g.onDidSelectItem(T[q])}),n.$setItems(P,H),O.then(q=>{if(typeof q=="number")return T[q];if(Array.isArray(q))return q.map(me=>T[me])})})}).then(void 0,j=>{if(!(0,E.$2)(j))return n.$setError(P,j),Promise.reject(j)})}$onItemSelected(y){this.c?.(y)}showInput(y,S=C.CancellationToken.None){return this.d=y?.validateInput,n.$input(y,typeof this.d=="function",S).then(void 0,g=>{if(!(0,E.$2)(g))return Promise.reject(g)})}async $validateInput(y){if(!this.d)return;const S=await this.d(y);if(!S||typeof S=="string")return S;let g;switch(S.severity){case $.InputBoxValidationSeverity.Info:g=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:g=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:g=A.default.Error;break;default:g=S.message?A.default.Error:A.default.Ignore;break}return{content:S.message,severity:g}}async showWorkspaceFolderPick(y,S=C.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[y]);if(!g)return;const u=await this.a.getWorkspaceFolders2();if(u)return u.find(m=>m.uri.toString()===g.uri.toString())}createQuickPick(y){const S=new i(y,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(y){const S=new c(y,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(y,S){this.e.get(y)?._fireDidChangeValue(S)}$onDidAccept(y){this.e.get(y)?._fireDidAccept()}$onDidChangeActive(y,S){const g=this.e.get(y);g instanceof i&&g._fireDidChangeActive(S)}$onDidChangeSelection(y,S){const g=this.e.get(y);g instanceof i&&g._fireDidChangeSelection(S)}$onDidTriggerButton(y,S){this.e.get(y)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(y,S,g){const u=this.e.get(y);u instanceof i&&u._fireDidTriggerItemButton(S,g)}$onDidHide(y){this.e.get(y)?._fireDidHide()}}class b{static{this.a=1}constructor(y,S){this.x=y,this.y=S,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$fd,this.q=new F.$fd,this.r=new F.$fd,this.s=new F.$fd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(y){this.b=y,this.z({title:y})}get step(){return this.c}set step(y){this.c=y,this.z({step:y})}get totalSteps(){return this.d}set totalSteps(y){this.d=y,this.z({totalSteps:y})}get enabled(){return this.g}set enabled(y){this.g=y,this.z({enabled:y})}get busy(){return this.j}set busy(y){this.j=y,this.z({busy:y})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(y){this.k=y,this.z({ignoreFocusOut:y})}get value(){return this.l}set value(y){this.l=y,this.z({value:y})}get placeholder(){return this.m}set placeholder(y){this.m=y,this.z({placeholder:y})}get buttons(){return this.n}set buttons(y){this.n=y.slice(),this.o.clear(),y.forEach((S,g)=>{const u=S===$.$kL.Back?-1:g;this.o.set(u,S)}),this.z({buttons:y.map((S,g)=>({...a(S.iconPath),tooltip:S.tooltip,handle:S===$.$kL.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(y){this.l=y,this.q.fire(y)}_fireDidTriggerButton(y){const S=this.o.get(y);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$fc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(y){if(!this.v){for(const S of Object.keys(y)){const g=y[S];this.u[S]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(d){if(d instanceof $.$WK)return{id:d.id};const y=r(d),S=t(d);return{dark:typeof y=="string"?R.URI.file(y):y,light:typeof S=="string"?R.URI.file(S):S}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function r(d){return typeof d=="object"&&"dark"in d?d.dark:d}function a(d){const y=h(d);let S,g;return"id"in y?g=I.ThemeIcon.asClassName(y):S=y,{iconPath:S,iconClass:g}}class i extends b{constructor(y,S){super(y.identifier,S),this.O=y,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$fd,this.L=[],this.M=new F.$fd,this.N=new F.$fd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(y){this.B=y.slice(),this.C.clear(),this.D.clear(),y.forEach((u,m)=>{this.C.set(m,u),this.D.set(u,m)});const S=(0,w.$XE)(this.O,"quickPickItemTooltip"),g=[];for(let u=0;u<y.length;u++){const m=y[u];if(m.kind===$.QuickPickItemKind.Separator)g.push({type:"separator",label:m.label});else{m.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=m.iconPath?a(m.iconPath):void 0;g.push({handle:u,label:m.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,tooltip:S?k.MarkdownString.fromStrict(m.tooltip):void 0,buttons:m.buttons?.map((O,N)=>({...a(O.iconPath),tooltip:O.tooltip,handle:N}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(y){this.E=y,this.z({canSelectMany:y})}get matchOnDescription(){return this.F}set matchOnDescription(y){this.F=y,this.z({matchOnDescription:y})}get matchOnDetail(){return this.G}set matchOnDetail(y){this.G=y,this.z({matchOnDetail:y})}get sortByLabel(){return this.H}set sortByLabel(y){this.H=y,this.z({sortByLabel:y})}get keepScrollPosition(){return this.I}set keepScrollPosition(y){this.I=y,this.z({keepScrollPosition:y})}get activeItems(){return this.J}set activeItems(y){this.J=y.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(y){this.L=y.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(y){const S=(0,p.$Fb)(y.map(g=>this.C.get(g)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(y){const S=(0,p.$Fb)(y.map(g=>this.C.get(g)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(y,S){const g=this.C.get(y);if(!g||!g.buttons||!g.buttons.length)return;const u=g.buttons[S];u&&this.N.fire({button:u,item:g})}}class c extends b{constructor(y,S){super(y.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(y){this.B=y,this.z({password:y})}get prompt(){return this.C}set prompt(y){this.C=y,this.z({prompt:y})}get valueSelection(){return this.D}set valueSelection(y){this.D=y,this.z({valueSelection:y})}get validationMessage(){return this.E}set validationMessage(y){this.E=y,y?typeof y=="string"?this.z({validationMessage:y,severity:A.default.Error}):this.z({validationMessage:y.message,severity:y.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new l(o,s)}e.$4bc=D}),define(Se[325],De([1,0,2,4,57,3,9,6,19,126,14,25,60,13,27,17]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=e.$5bc=void 0;function s(u){if(u)return typeof u.iconPath=="string"?C.URI.file(u.iconPath):C.URI.isUri(u.iconPath)||w.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function n(u){if(u.icon){if(C.URI.isUri(u.icon))return u.icon;if(w.ThemeIcon.isThemeIcon(u.icon))return u.icon;{const m=u.icon;return{light:m.light,dark:m.dark}}}else return}function l(u,m){if(!u.iconPath&&!m.iconPath)return 0;if(u.iconPath){if(!m.iconPath)return 1}else return-1;const P=typeof u.iconPath=="string"?u.iconPath:C.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,O=typeof m.iconPath=="string"?m.iconPath:C.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,p.$hq)(P,O)}function b(u,m){let P=0;if(u.strikeThrough!==m.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==m.faded)return u.faded?1:-1;if(u.tooltip!==m.tooltip)return(u.tooltip||"").localeCompare(m.tooltip||"");if(P=l(u,m),P!==0)return P;if(u.light&&m.light)P=l(u.light,m.light);else{if(u.light)return 1;if(m.light)return-1}if(P!==0)return P;if(u.dark&&m.dark)P=l(u.dark,m.dark);else{if(u.dark)return 1;if(m.dark)return-1}return P}function h(u,m){if(u.command!==m.command)return u.command<m.command?-1:1;if(u.title!==m.title)return u.title<m.title?-1:1;if(u.tooltip!==m.tooltip){if(u.tooltip!==void 0&&m.tooltip!==void 0)return u.tooltip<m.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(u.arguments===m.arguments)return 0;if(u.arguments)if(m.arguments){if(u.arguments.length!==m.arguments.length)return u.arguments.length-m.arguments.length}else return 1;else return-1;for(let P=0;P<u.arguments.length;P++){const O=u.arguments[P],N=m.arguments[P];if(O!==N)return O<N?-1:1}return 0}function t(u,m){let P=(0,p.$hq)(u.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(P!==0)return P;if(u.command&&m.command)P=h(u.command,m.command);else{if(u.command)return 1;if(m.command)return-1}if(P!==0)return P;if(u.decorations&&m.decorations)P=b(u.decorations,m.decorations);else{if(u.decorations)return 1;if(m.decorations)return-1}return P}function r(u,m){for(let P=0;P<u.length;P++)if(u[P]!==m[P])return!1;return!0}function a(u,m){return u.command===m.command&&u.title===m.title&&u.tooltip===m.tooltip&&(u.arguments&&m.arguments?r(u.arguments,m.arguments):u.arguments===m.arguments)}function i(u,m){return(0,E.$sb)(u,m,a)}function c(u,m){return u===m?!0:!u||!m?!1:u.id===m.id&&u.label===m.label&&u.upstream?.id===m.upstream?.id&&u.upstream?.label===m.upstream?.label}class d{#e;#t;get value(){return this.d}set value(m){m=m??"",this.#e.$setInputBoxValue(this.l,m),this.n(m)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(m){this.#e.$setInputBoxPlaceholder(this.l,m),this.f=m}get validateInput(){return(0,D.$YE)(this.k,"scmValidation"),this.g}set validateInput(m){if((0,D.$YE)(this.k,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=m,this.#e.$setValidationProviderIsEnabled(this.l,!!m)}get enabled(){return this.h}set enabled(m){m=!!m,this.h!==m&&(this.h=m,this.#e.$setInputBoxEnablement(this.l,m))}get visible(){return this.j}set visible(m){m=!!m,this.j!==m&&(this.j=m,this.#e.$setInputBoxVisibility(this.l,m))}get document(){return(0,D.$YE)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(m,P,O,N,M){this.k=m,this.l=N,this.m=M,this.d="",this.e=new F.$fd,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=O}showValidationMessage(m,P){(0,D.$YE)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,m,P)}$onInputBoxValueChange(m){this.n(m)}n(m){this.d=m,this.e.fire(m)}}e.$5bc=d;class y{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(m){this.v=m,this.q.$updateGroupLabel(this.t,this.handle,m)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(m){this.p=m,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(m){this.f=[...m],this.k.fire()}constructor(m,P,O,N,M){this.q=m,this.s=P,this.t=O,this.u=N,this.v=M,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$fd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$fd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=y.d++}getResourceState(m){return this.g.get(m)}$executeResourceCommand(m,P){const O=this.h.get(m);return O?(0,R.$zg)(()=>this.s.executeCommand(O.command,...O.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this.f].sort(t),O=(0,E.$Bb)(this.o,m,t).map(j=>{const z=j.toInsert.map(T=>{const H=this.e++;this.g.set(H,T);const q=T.resourceUri;let me;if(T.command)if(T.command.command==="vscode.open"||T.command.command==="vscode.diff"){const K=new L.$jc;me=this.s.converter.toInternal(T.command,K),this.j.set(H,K)}else this.h.set(H,T.command);const Z=s(T.decorations),X=T.decorations&&s(T.decorations.light)||Z,V=T.decorations&&s(T.decorations.dark)||Z,x=[X,V],ge=T.decorations&&T.decorations.tooltip||"",ue=T.decorations&&!!T.decorations.strikeThrough,ve=T.decorations&&!!T.decorations.faded,G=T.contextValue||"";return{rawResource:[H,q,x,ge,ue,ve,G,me],handle:H}});return{start:j.start,deleteCount:j.deleteCount,toInsert:z}}),N=O.map(({start:j,deleteCount:z,toInsert:T})=>[j,z,T.map(H=>H.rawResource)]),M=O.reverse();for(const{start:j,deleteCount:z,toInsert:T}of M){const H=T.map(me=>me.handle),q=this.n.splice(j,z,...H);for(const me of q)this.g.delete(me),this.h.delete(me),this.j.get(me)?.dispose(),this.j.delete(me)}return this.o=m,N}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(m){this.g!==m&&(this.g=m,this.#e.$updateSourceControl(this.x,{count:m}))}get quickDiffProvider(){return this.h}set quickDiffProvider(m){this.h=m;let P;(0,D.$XE)(this.y,"quickDiffProvider")&&(P=m?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!m,quickDiffLabel:P})}get historyProvider(){return(0,D.$YE)(this.y,"scmHistoryProvider"),this.j}set historyProvider(m){(0,D.$YE)(this.y,"scmHistoryProvider"),this.j=m,this.k.value=new L.$jc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!m}),m&&(this.k.value.add(m.onDidChangeCurrentHistoryItemGroup(()=>{c(this.l,m?.currentHistoryItemGroup)||(this.l=m?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(m.onDidChangeActionButton(()=>{(0,D.$YE)(this.y,"scmActionButton"),this.m.value=new L.$jc;const P=m.actionButton!==void 0?{command:this.z.converter.toInternal(m.actionButton.command,this.m.value),description:m.actionButton.description,enabled:m.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(m){m!==this.n&&(this.n=m,this.#e.$updateSourceControl(this.x,{commitTemplate:m}))}get acceptInputCommand(){return this.p}set acceptInputCommand(m){this.o.value=new L.$jc,this.p=m;const P=this.z.converter.toInternal(m,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,D.$YE)(this.y,"scmActionButton"),this.s}set actionButton(m){(0,D.$YE)(this.y,"scmActionButton"),this.q.value=new L.$jc,this.s=m;const P=m!==void 0?{command:this.z.converter.toInternal(m.command,this.q.value),secondaryCommands:m.secondaryCommands?.map(O=>O.map(N=>this.z.converter.toInternal(N,this.q.value))),description:m.description,enabled:m.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(m){if(this.u&&m&&i(this.u,m))return;this.t.value=new L.$jc,this.u=m;const P=(m||[]).map(O=>this.z.converter.toInternal(O,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(m,P,O,N,M,j,z){this.y=m,this.z=N,this.A=M,this.B=j,this.C=z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$lc,this.m=new L.$lc,this.n=void 0,this.o=new L.$lc,this.p=void 0,this.q=new L.$lc,this.t=new L.$lc,this.u=void 0,this.v=!1,this.w=new F.$fd,this.onDidChangeSelection=this.w.event,this.x=S.d++,this.D=new Map,this.E=new Set,this.#e=O;const T=C.URI.from({scheme:v.Schemas.vscodeSourceControl,path:`${M}/scm${this.x}/input`,query:z?`rootUri=${encodeURIComponent(z.toString())}`:void 0});this.f=new d(m,P,this.#e,this.x,T),this.#e.$registerSourceControl(this.x,M,j,z,T)}createResourceGroup(m,P){const O=new y(this.#e,this.z,this.x,m,P),N=F.Event.once(O.onDidDispose)(()=>this.D.delete(O));return this.D.set(O,N),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const m=[],P=[];for(const[O,N]of this.D){N.dispose();const M=O.onDidUpdateResourceStates(()=>{this.E.add(O),this.eventuallyUpdateResourceStates()});F.Event.once(O.onDidDispose)(()=>{this.E.delete(O),M.dispose(),this.e.delete(O.handle),this.#e.$unregisterGroup(this.x,O.handle)}),m.push([O.handle,O.id,O.label,O.features]);const j=O._takeResourceStateSnapshot();j.length>0&&P.push([O.handle,j]),this.e.set(O.handle,O)}this.#e.$registerGroups(this.x,m,P),this.D.clear()}eventuallyUpdateResourceStates(){const m=[];this.E.forEach(P=>{const O=P._takeResourceStateSnapshot();O.length!==0&&m.push([P.handle,O])}),m.length>0&&this.#e.$spliceResourceStates(this.x,m),this.E.clear()}getResourceGroup(m){return this.e.get(m)}setSelectionState(m){this.v=m,this.w.fire(m)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(m=>m.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,f.$7g)(100)],S.prototype,"eventuallyAddResourceGroups",null),Ke([(0,f.$7g)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let g=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(m,P,O,N){this.l=P,this.m=O,this.n=N,this.g=new Map,this.h=new I.$Xl,this.j=new F.$fd,this.e=m.getProxy($.$1J.MainThreadSCM),this.f=m.getProxy($.$1J.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const j=this.g.get(M.sourceControlHandle);if(!j)return M;const z=j.getResourceGroup(M.groupHandle);return z?z.getResourceState(M.handle):M}else if(M&&M.$mid===4){const j=this.g.get(M.sourceControlHandle);return j?j.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const j=this.g.get(M.handle);return j||M}return M}})}createSourceControl(m,P,O,N){this.n.trace("ExtHostSCM#createSourceControl",m.identifier.value,P,O,N),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const M=o.d++,j=new S(m,this.m,this.e,this.l,P,O,N);this.g.set(M,j);const z=this.h.get(m.identifier)||[];return z.push(j),this.h.set(m.identifier,z),j}getLastInputBox(m){this.n.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const P=this.h.get(m.identifier),O=P&&P[P.length-1];return O&&O.inputBox}$provideOriginalResource(m,P,O){const N=C.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",m,N.toString());const M=this.g.get(m);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$zg)(()=>M.quickDiffProvider.provideOriginalResource(N,O)).then(j=>j||null)}$onInputBoxValueChange(m,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",m);const O=this.g.get(m);return O&&O.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(m,P,O,N){this.n.trace("ExtHostSCM#$executeResourceCommand",m,P,O);const M=this.g.get(m);if(!M)return Promise.resolve(void 0);const j=M.getResourceGroup(P);return j?j.$executeResourceCommand(O,N):Promise.resolve(void 0)}$validateInput(m,P,O){this.n.trace("ExtHostSCM#$validateInput",m);const N=this.g.get(m);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,R.$zg)(()=>N.inputBox.validateInput(P,O)).then(M=>{if(!M)return Promise.resolve(void 0);const j=k.MarkdownString.fromStrict(M.message);return j?Promise.resolve([j,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this.g.get(m)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=m,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(m,P,O){return await this.g.get(m)?.historyProvider?.resolveHistoryItemGroupBase(P,O)??void 0}async $resolveHistoryItemGroupCommonAncestor(m,P,O,N){return await this.g.get(m)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,O,N)??void 0}async $provideHistoryItems(m,P,O,N){return(await this.g.get(m)?.historyProvider?.provideHistoryItems(P,O,N))?.map(z=>({id:z.id,parentIds:z.parentIds,label:z.label,description:z.description,icon:n(z),timestamp:z.timestamp}))??void 0}async $provideHistoryItemChanges(m,P,O){return await this.g.get(m)?.historyProvider?.provideHistoryItemChanges(P,O)??void 0}};e.$6bc=g,e.$6bc=g=o=Ke([Be(3,A.$5i)],g)}),define(Se[114],De([1,0,6,4,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=e.$Kbc=void 0;class L{constructor($){this.b=new F.$fd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(C.$1J.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,E){return this.a.$getPassword($,E)}store($,E,p){return this.a.$setPassword($,E,p)}delete($,E){return this.a.$deletePassword($,E)}}e.$Kbc=L,e.$Lbc=(0,f.$Bh)("IExtHostSecretState")}),define(Se[326],De([1,0,6,13,2]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0;class L{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(C.$1J.MainThreadShare)}async $provideShare($,E,p){return await this.c.get($)?.provideShare({selection:F.Range.to(E.selection),resourceUri:f.URI.revive(E.resourceUri)},p)??void 0}registerShareProvider($,E){const p=L.a++;return this.c.set(p,E),this.b.$registerShareProvider(p,F.DocumentSelector.from($,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(p),this.c.delete(p)}}}}e.$8cc=L}),define(Se[327],De([1,0,7,6,209,3,13,18]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$XK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$XK("statusBarItem.warningForeground")]])}#e;#t;constructor(w,k,D,v,o,s=C.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new L.$jc,this.#e=w,this.#t=k,o&&v){this.c=(0,C.$AK)(v.identifier,o);const l=D.get(this.c);l&&(s=l.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,n=l.priority,this.j=!0,this.name=l.name,this.text=l.text,this.tooltip=l.tooltip,this.command=l.command,this.accessibilityInformation=l.accessibilityInformation)}else this.c=String(E.a++);this.e=v,this.f=o,this.g=s,this.h=this.u(n)}u(w){if((0,$.$nf)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(w){this.k=w,this.v()}set name(w){this.m=w,this.v()}set tooltip(w){this.l=w,this.v()}set color(w){this.n=w,this.v()}set backgroundColor(w){w&&!E.b.has(w.id)&&(w=void 0),this.o=w,this.v()}set command(w){this.r?.fromApi!==w&&(this.p&&this.q.add(this.p),this.p=new L.$jc,typeof w=="string"?this.r={fromApi:w,internal:this.#t.toInternal({title:"",command:w},this.p)}:w?this.r={fromApi:w,internal:this.#t.toInternal(w,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(w){this.t=w,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let w;this.e?this.f?w=`${this.e.identifier.value}.${this.f}`:w=this.e.identifier.value:w=this.f;let k;this.m?k=this.m:k=(0,f.localize)(0,null,this.e.displayName||this.e.name);let D=this.n;this.o&&(D=E.b.get(this.o.id));const v=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,w,this.e?.identifier.value,k,this.k,v,this.r?.internal,D,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$7bc=E;class p{constructor(w){this.b=[],this.a=w.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(w){const k={message:w};return this.b.unshift(k),this.c(),new C.$3J(()=>{const D=this.b.indexOf(k);D>=0&&(this.b.splice(D,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(w,k){this.e=new Map,this.a=w.getProxy(F.$1J.MainThreadStatusBar),this.b=k,this.c=new p(this)}$acceptStaticEntries(w){for(const k of w)this.e.set(k.entryId,k)}createStatusBarEntry(w,k,D,v){return new E(this.a,this.b,this.e,w,k,D,v)}setStatusBarMessage(w,k){const D=this.c.setMessage(w);let v;return typeof k=="number"?v=setTimeout(()=>D.dispose(),k):typeof k<"u"&&k.then(()=>D.dispose(),()=>D.dispose()),new C.$3J(()=>{D.dispose(),clearTimeout(v)})}}e.$8bc=A}),define(Se[115],De([1,0,6,4,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=e.$ybc=void 0;class L{constructor($,E){this.c=E,this.b=new F.$fd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(C.$1J.MainThreadStorage)}registerExtensionStorageKeysToSync($,E){this.a.$registerExtensionStorageKeysToSync($,E)}async initializeExtensionStorage($,E,p){const A=await this.a.$initializeExtensionStorage($,E);let I;return A&&(I=this.d($,E,A)),I||p}setValue($,E,p){return this.a.$setValue($,E,p)}$acceptValue($,E,p){const A=this.d($,E,p);A&&this.b.fire({shared:$,key:E,value:A})}d($,E,p){try{return JSON.parse(p)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${$}): ${A}`)}}}e.$ybc=L,e.$zbc=(0,f.$Bh)("IExtHostStorage")}),define(Se[91],De([1,0,5,26,14,73,2]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=e.$Ebc=void 0,e.$Ebc=(0,C.$Bh)("IExtensionStoragePaths");let $=class{constructor(p,A,I){this.d=A,this.f=I,this.a=p.workspace??void 0,this.b=p.environment,this.whenReady=this.h().then(w=>this.c=w)}async g(p){return R.URI.joinPath(this.b.workspaceStorageHome,p)}async h(){if(!this.a)return Promise.resolve(void 0);const p=this.a.id,A=await this.g(p);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(p){if(this.c)return R.URI.joinPath(this.c,p.identifier.value)}globalValue(p){return R.URI.joinPath(this.b.globalStorageHome,p.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Fbc=$,e.$Fbc=$=Ke([Be(0,F.$fM),Be(1,f.$5i),Be(2,L.$Dbc)],$)}),define(Se[44],De([1,0,4,6,5,2,20,3,7,211,8,253,21,31,254,60,9,13,33]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=e.$Ibc=e.$Hbc=e.$Gbc=void 0,e.$Gbc=(0,f.$Bh)("IExtHostTerminalService");class l{constructor(g,u,m,P){this.l=g,this._id=u,this.m=m,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(N=>this.f=N);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(N,M=!0){O.q(),O.l.$sendText(O._id,N,M)},show(N){O.q(),O.l.$show(O._id,N)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(g,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??void 0,env:g.env??void 0,icon:c(g.iconPath)??void 0,color:v.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,isFeatureTerminal:u?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:u?.useShellEnvironment??void 0,location:u?.location||this.o(g.location,u?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,u,m,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:m,color:v.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(g,u),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(g,u){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in g?{viewColumn:s.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.n=g}setExitStatus(g,u){this.h=Object.freeze({code:g,reason:u})}setDimensions(g,u){return g===this.d&&u===this.g||g===0||u===0?!1:(this.d=g,this.g=u,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(g){this.k=g}_setProcessId(g){this.f?(this.f(g),this.f=void 0):this.b.then(u=>{u!==g&&(this.b=Promise.resolve(g))})}}e.$Hbc=l;class b{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new C.$fd,this.onProcessData=this.a.event,this.b=new C.$fd,this.d=new C.$fd,this.onDidChangeProperty=this.d.event,this.f=new C.$fd,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,u){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${u}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,u){this.g.setDimensions?.({columns:g,rows:u})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(u=>this.a.fire(u)),this.g.onDidClose?.((u=void 0)=>{this.f.fire(u===void 0?void 0:u)}),this.g.onDidOverrideDimensions?.(u=>{u&&this.d.fire({type:"overrideDimensions",value:{cols:u.columns,rows:u.rows}})}),this.g.onDidChangeName?.(u=>{this.d.fire({type:"title",value:u})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends $.$kc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,u,m){super(),this.Q=u,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$lc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$fd,this.onDidCloseTerminal=this.H.event,this.I=new C.$fd,this.onDidOpenTerminal=this.I.event,this.J=new C.$fd,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$fd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$fd,this.onDidChangeTerminalState=this.M.event,this.N=new C.$fd,this.onDidChangeShell=this.N.event,this.O=new C.$fd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$fd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=m.getProxy(F.$1J.MainThreadTerminalService),this.y=new D.$Skb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:P=>{const O=N=>{const M=N;return this.W(M.instanceId)?.value};switch(P?.$mid){case 15:return O(P);default:{if(Array.isArray(P))for(let N=0;N<P.length&&P[N].$mid===15;N++)P[N]=O(P[N]);return P}}}}),this.B({dispose:()=>{for(const[P,O]of this.g)O.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,u){const m=new l(this.a,(0,k.$4f)(),g,g.name),P=new b(g.pty);return m.createExtensionTerminal(g.location,this.R(g,u).resolvedExtHostIdentifier,c(g.iconPath),d(g.color)).then(O=>{const N=this.S(O,P);this.h[O]=N}),this.f.push(m),m.value}R(g,u){if(u=u||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const m=g.location.parentTerminal;if(m){const P=this.f.find(O=>O.value===m);P&&(u.resolvedExtHostIdentifier=P._id)}}else g.location&&typeof g.location!="object"?u.location=g.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(g,u){if(!this.W(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const P=new b(u),O=this.S(g,P);this.h[g]=O}async $acceptActiveTerminalChanged(g){const u=this.b;if(g===null){this.b=void 0,u!==this.b&&this.J.fire(this.b);return}const m=this.W(g);m&&(this.b=m,u!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,u){const m=this.W(g);m&&this.O.fire({terminal:m.value,data:u})}async $acceptTerminalDimensions(g,u,m){const P=this.W(g);P&&P.setDimensions(u,m)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(g,u){const m=this.W(g);m&&this.P.fire({terminal:m.value,...u})}async $acceptTerminalMaximumDimensions(g,u,m){this.g.get(g)?.resize(u,m)}async $acceptTerminalTitleChange(g,u){const m=this.W(g);m&&(m.name=u)}async $acceptTerminalClosed(g,u,m){const P=this.Y(this.f,g);if(P!==null){const O=this.f.splice(P,1)[0];O.setExitStatus(u,m),this.H.fire(O.value)}}$acceptTerminalOpened(g,u,m,P){if(u){const M=this.Y(this.f,u);if(M!==null){this.f[M]._id=g,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const O={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},N=new l(this.a,g,O,m);this.f.push(N),this.I.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(g,u){this.W(g)?._setProcessId(u)}async $startExtensionTerminal(g,u){const m=this.W(g);if(!m)return{message:(0,p.localize)(0,null,g)};m.isOpen||await new Promise(O=>{const N=this.onDidOpenTerminal(async M=>{M===m.value&&(N.dispose(),O())})});const P=this.g.get(g);P?P.startSendingEvents(u):this.j[g]={initialDimensions:u}}S(g,u){const m=new $.$jc;m.add(u.onProcessReady(O=>this.a.$sendProcessReady(g,O.pid,O.cwd,O.windowsPty))),m.add(u.onDidChangeProperty(O=>this.a.$sendProcessProperty(g,O))),this.y.startBuffering(g,u.onProcessData),m.add(u.onProcessExit(O=>this.U(g,O))),this.g.set(g,u);const P=this.j[g];return P&&u instanceof b&&(u.startSendingEvents(P.initialDimensions),delete this.j[g]),m}$acceptProcessAckDataEvent(g,u){this.g.get(g)?.acknowledgeDataEvent(u)}$acceptProcessInput(g,u){this.g.get(g)?.input(u)}$acceptTerminalInteraction(g){const u=this.W(g);u?.setInteractedWith()&&this.M.fire(u.value)}$acceptTerminalSelection(g,u){this.W(g)?.setSelection(u)}$acceptProcessResize(g,u,m){try{this.g.get(g)?.resize(u,m)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(g,u){this.g.get(g)?.shutdown(u)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(u=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:u}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(u=>this.a.$sendProcessProperty(g,{type:"cwd",value:u}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new E.$3J(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,u,m){if(this.C.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this.C.set(u,m),this.a.$registerProfileProvider(u,g.identifier.value),new E.$3J(()=>{this.C.delete(u),this.a.$unregisterProfileProvider(u)})}registerTerminalQuickFixProvider(g,u,m){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,m),this.a.$registerQuickFixProvider(g,u),new E.$3J(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,u){const m=new w.$pd().token;if(m.isCancellationRequested)return;const P=this.D.get(g);if(!P)return;const O=await P.provideTerminalQuickFixes(u,m);if(O===null||Array.isArray(O)&&O.length===0)return;const N=new $.$jc;if(this.w.value=N,!Array.isArray(O))return O?s.TerminalQuickFix.from(O,this.Q.converter,N):void 0;const M=[];for(const j of O){const z=s.TerminalQuickFix.from(j,this.Q.converter,N);z&&M.push(z)}return M}async $createContributedProfileTerminal(g,u){const m=new w.$pd().token;let P=await this.C.get(g)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,u);return}this.createTerminalFromOptions(P.options,u)}}async $provideLinks(g,u){const m=this.W(g);if(!m)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const O=new w.$pd;this.G.set(g,O);const N=[],M={terminal:m.value,line:u},j=[];for(const H of this.z)j.push(o.Promises.withAsyncBody(async q=>{O.token.onCancellationRequested(()=>q({provider:H,links:[]}));const me=await H.provideTerminalLinks(M,O.token)||[];O.token.isCancellationRequested||q({provider:H,links:me})}));const z=await Promise.all(j);if(O.token.isCancellationRequested)return[];const T=new Map;for(const H of z)H&&H.links.length>0&&N.push(...H.links.map(q=>{const me={id:h++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return T.set(me.id,{provider:H.provider,link:q}),me}));return this.F.set(g,T),N}$activateLink(g,u){const m=this.F.get(g)?.get(u);m&&m.provider.handleTerminalLink(m.link)}U(g,u){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const m=this.h[g];m&&(m.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,u)}W(g){return this.X(this.f,g)}X(g,u){const m=this.Y(g,u);return m!==null?g[m]:null}Y(g,u){const m=g.findIndex(P=>P._id===u);return m===-1?null:m}getEnvironmentVariableCollection(g){let u=this.n.get(g.identifier.value);return u||(u=new r,this.$(g.identifier.value,u)),u.getScopedEnvironmentVariableCollection(void 0)}Z(g,u){const m=(0,I.$ar)(u.map),P=(0,I.$br)(u.descriptionMap);this.a.$setEnvironmentVariableCollection(g,u.persistent,m.length===0?void 0:m,P)}$initEnvironmentVariableCollections(g){g.forEach(u=>{const m=u[0],P=new r(u[1]);this.$(m,P)})}$acceptDefaultProfile(g,u){const m=this.s;this.s=g,this.u=u,m?.path!==g.path&&this.N.fire(g.path)}$(g,u){this.n.set(g,u),u.onDidChangeCollection(()=>{this.Z(g,u)})}};e.$Ibc=t,e.$Ibc=t=Ke([Be(1,n.$lM),Be(2,R.$2L)],t);class r{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$fd,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const u=this.h(g);let m=this.a.get(u);return m||(m=new a(this,g),this.a.set(u,m),m.onDidChangeCollection(()=>this.d.fire())),m}replace(g,u,m,P){this.f(g,{value:u,type:E.EnvironmentVariableMutatorType.Replace,options:m??{applyAtProcessCreation:!0},scope:P})}append(g,u,m,P){this.f(g,{value:u,type:E.EnvironmentVariableMutatorType.Append,options:m??{applyAtProcessCreation:!0},scope:P})}prepend(g,u,m,P){this.f(g,{value:u,type:E.EnvironmentVariableMutatorType.Prepend,options:m??{applyAtProcessCreation:!0},scope:P})}f(g,u){if(u.options&&u.options.applyAtProcessCreation===!1&&!u.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const m=this.g(g,u.scope),P=this.map.get(m),O=u.options?{applyAtProcessCreation:u.options.applyAtProcessCreation??!1,applyAtShellIntegration:u.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==u.value||P.type!==u.type||P.options?.applyAtProcessCreation!==O.applyAtProcessCreation||P.options?.applyAtShellIntegration!==O.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==u.scope?.workspaceFolder?.index){const N=this.g(g,u.scope),M={variable:g,...u,options:O};this.map.set(N,M),this.d.fire()}}get(g,u){const m=this.g(g,u),P=this.map.get(m);return P?y(P):void 0}g(g,u){const m=this.h(u);return m.length?`${g}:::${m}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const u=new Map;for(const[m,P]of this.map)this.h(P.scope)===this.h(g)&&u.set(P.variable,y(P));return u}delete(g,u){const m=this.g(g,u);this.map.delete(m),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[u,m]of this.map)m.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(u);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,u){const m=this.h(u),P=this.descriptionMap.get(m);if(!P||P.description!==g){let O;typeof g=="string"?O=g:O=g?.value.split(`

`)[0];const N={description:O,scope:u};this.descriptionMap.set(m,N),this.d.fire()}}getDescription(g){const u=this.h(g);return this.descriptionMap.get(u)?.description}k(g){const u=this.h(g);this.descriptionMap.delete(u)}}class a{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,u){this.b=g,this.d=u,this.a=new C.$fd}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,u,m){this.b.replace(g,u,m,this.d)}append(g,u,m){this.b.append(g,u,m,this.d)}prepend(g,u,m){this.b.prepend(g,u,m,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,u){this.b.getVariableMap(this.d).forEach((m,P)=>g.call(u,P,m,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let i=class extends t{constructor(g,u){super(!1,g,u)}createTerminal(g,u,m){throw new A.$0}createTerminalFromOptions(g,u){throw new A.$0}};e.$Jbc=i,e.$Jbc=i=Ke([Be(0,n.$lM),Be(1,R.$2L)],i);function c(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function d(S){return v.ThemeColor.isThemeColor(S)?S:void 0}function y(S){const g={...S};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Se[328],De([1,0,118,9,22,21,4,75,51,3,23,18,31,6,20,145,13,7,69,109,88,27]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=e.$Rcc=e.$Qcc=void 0;let t=class{constructor(M,j,z){this.k=z,this.d=new R.$fd,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=M.getProxy(k.$1J.MainThreadTesting),this.j=new m(this.g),this.h=new c(this.g),j.registerArgumentProcessor({processArgument:T=>{switch(T?.$mid){case 16:{const H=T,q=H.tests[H.tests.length-1].item.extId;return this.f.get(n.$SI.root(q))?.collection.tree.get(q)?.actual??(0,v.$bM)(T)}case 18:{const{extId:H,message:q}=T;return{test:this.f.get(n.$SI.root(H))?.collection.tree.get(H)?.actual,message:o.TestMessage.to(q)}}default:return T}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const T=await j.executeCommand("_testing.getExplorerSelection"),H=q=>{const me=this.f.get(n.$SI.root(q));if(me)return n.$SI.isRoot(q)?me.controller:me.collection.tree.get(q)?.actual};return{include:T?.include.map(H).filter(I.$rf)||[],exclude:T?.exclude.map(H).filter(I.$rf)||[]}})}createTestController(M,j,z,T){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const H=new p.$jc,q=H.add(new v.$eM(j,z,this.k));q.root.label=z;const me=new Map,Z=this.g,X={items:q.root.children,get label(){return z},set label(x){z=x,q.root.label=x,Z.$updateController(j,{label:z})},get refreshHandler(){return T},set refreshHandler(x){T=x,Z.$updateController(j,{canRefresh:!!x})},get id(){return j},createRunProfile:(x,ge,ue,ve,G,U)=>{let K=(0,E.$pi)(x);for(;me.has(K);)K++;return new P(this.g,me,j,K,x,ge,ue,ve,G,U)},createTestItem(x,ge,ue){return new v.$cM(j,x,ge,ue)},createTestRun:(x,ge,ue=!0)=>this.h.createTestRun(M,j,q,x,ge,ue),invalidateTestResults:x=>{if(x===void 0)this.g.$markTestRetired(void 0);else{const ge=x instanceof Array?x:[x];this.g.$markTestRetired(ge.map(ue=>n.$SI.fromExtHostTestItem(ue,j).toString()))}},set resolveHandler(x){q.resolveHandler=x},get resolveHandler(){return q.resolveHandler},dispose:()=>{H.dispose()}};Z.$registerTestController(j,z,!!T),H.add((0,p.$ic)(()=>Z.$unregisterTestController(j)));const V={controller:X,collection:q,profiles:me,extension:M};return this.f.set(j,V),H.add((0,p.$ic)(()=>this.f.delete(j))),H.add(q.onDidGenerateDiff(x=>Z.$publishDiff(j,x.map(b.TestsDiffOp.serialize)))),X}createTestObserver(){return this.j.checkout()}async runTests(M,j=L.CancellationToken.None){const z=d(M);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.f.get(z.controllerId);if(!T)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(H=>n.$SI.fromExtHostTestItem(H,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:O[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:M.exclude?.map(H=>H.id)},j)}$syncTests(){for(const{collection:M}of this.f.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,j,z){return(0,C.$pb)(this.h.trackers,H=>H.id===M?H.getCoverage(j):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(M,j,z,T){return(0,C.$pb)(this.h.trackers,q=>q.id===M?q.getCoverage(j):void 0)?.resolveFileCoverage(z,T)??Promise.resolve([])}$configureRunProfile(M,j){this.f.get(M)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(M,j){await this.f.get(M)?.controller.refreshHandler?.(j)}$publishTestResults(M){this.results=Object.freeze(M.map(j=>(0,A.$Wm)(o.TestResults.to(j))).concat(this.results).sort((j,z)=>z.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(M,j){const z=this.f.get(n.$SI.fromString(M).controllerId)?.collection;z&&(await z.expand(M,j<0?1/0:j),z.flushDiff())}$acceptDiff(M){this.j.applyDiff(M.map(b.TestsDiffOp.deserialize))}async $runControllerTests(M,j){return Promise.all(M.map(z=>this.l(z,!1,j)))}async $startContinuousRun(M,j){const z=new L.$pd(j),T=await Promise.all(M.map(H=>this.l(H,!0,z.token)));return!j.isCancellationRequested&&!T.some(H=>H.error)&&await new Promise(H=>j.onCancellationRequested(H)),z.dispose(!0),T}async l(M,j,z){const T=this.f.get(M.controllerId);if(!T)return{};const{collection:H,profiles:q,extension:me}=T,Z=q.get(M.profileId);if(!Z)return{};const X=M.testIds.map(ue=>H.tree.get(ue)).filter(I.$rf),V=M.excludeExtIds.map(ue=>T.collection.tree.get(ue)).filter(I.$rf).filter(ue=>X.some(ve=>ve.fullId.compare(ue.fullId)===2));if(!X.length)return{};const x=new s.$yL(X.some(ue=>ue.actual instanceof v.$dM)?void 0:X.map(ue=>ue.actual),V.map(ue=>ue.actual),Z,j),ge=(0,b.$UI)(M)&&this.h.prepareForMainThreadTestRun(x,y.fromInternal(M,T.collection),me,z);try{return await Z.runHandler(x,z),{}}catch(ue){return{error:String(ue)}}finally{ge&&(ge.hasRunningTasks&&!z.isCancellationRequested&&await R.Event.toPromise(ge.onEnd),ge.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.h.cancelAllRuns():this.h.cancelRunById(M)}};e.$Qcc=t,e.$Qcc=t=Ke([Be(0,D.$2L)],t);const r=1e4;var a;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(a||(a={}));class i extends p.$kc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(M,j,z,T){super(),this.s=M,this.u=j,this.w=z,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$fd),this.onEnd=this.m.event,this.j=this.B(new L.$pd(T));const H=this.B(new F.$Sg(()=>this.y(),r));this.B(this.j.token.onCancellationRequested(()=>H.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(M){return this.g.get(M)?.coverage}createRun(M){const j=this.s.id,z=this.s.controllerId,T=(0,w.$4f)(),H=new S(this.u,j,T),q=V=>(x,...ge)=>{if(Z){console.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}this.s.isIncluded(x)&&(this.C(x),V(x,...ge))},me=(V,x)=>{const ge=x instanceof Array?x.map(o.TestMessage.from):[o.TestMessage.from(x)];if(ge.some(ue=>ue.contextValue!==void 0)&&(0,h.$YE)(this.w,"testMessageContextValue"),V.uri&&V.range){const ue={range:o.Range.from(V.range),uri:V.uri};for(const ve of ge)ve.location=ve.location||ue}this.u.$appendTestMessagesInRun(j,T,n.$SI.fromExtHostTestItem(V,z).toString(),ge)};let Z=!1;const X={isPersisted:this.s.isPersisted,token:this.j.token,name:M,get coverageProvider(){return H.coverageProvider},set coverageProvider(V){H.coverageProvider=V},enqueued:q(V=>{this.u.$updateTestStateInRun(j,T,n.$SI.fromExtHostTestItem(V,z).toString(),1)}),skipped:q(V=>{this.u.$updateTestStateInRun(j,T,n.$SI.fromExtHostTestItem(V,z).toString(),5)}),started:q(V=>{this.u.$updateTestStateInRun(j,T,n.$SI.fromExtHostTestItem(V,z).toString(),2)}),errored:q((V,x,ge)=>{me(V,x),this.u.$updateTestStateInRun(j,T,n.$SI.fromExtHostTestItem(V,z).toString(),6,ge)}),failed:q((V,x,ge)=>{me(V,x),this.u.$updateTestStateInRun(j,T,n.$SI.fromExtHostTestItem(V,z).toString(),4,ge)}),passed:q((V,x)=>{this.u.$updateTestStateInRun(j,T,n.$SI.fromExtHostTestItem(V,this.s.controllerId).toString(),3,x)}),appendOutput:(V,x,ge)=>{Z||(ge&&(this.s.isIncluded(ge)?this.C(ge):ge=void 0),this.u.$appendOutputToRun(j,T,f.$Fd.fromString(V),x&&o.location.from(x),ge&&n.$SI.fromExtHostTestItem(ge,z).toString()))},end:()=>{Z||(Z=!0,this.u.$finishedTestRunTask(j,T),this.g.delete(T),this.g.size||this.z())}};return this.g.set(T,{run:X,coverage:H}),this.u.$startedTestRunTask(j,{id:T,name:M,running:!0}),X}y(){for(const{run:M}of this.g.values())M.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(M){if(!(M instanceof v.$cM))throw new l.$TL(M.id);if(this.h.has(n.$SI.fromExtHostTestItem(M,this.s.controllerId).toString()))return;const j=[],z=this.s.colllection.root;for(;;){const T=o.TestItem.from(M);if(j.unshift(T),this.h.has(T.extId)||(this.h.add(T.extId),M===z))break;M=M.parent||z}this.u.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.z(),super.dispose()}}class c{get trackers(){return this.d.values()}constructor(M){this.f=M,this.d=new Map}prepareForMainThreadTestRun(M,j,z,T){return this.g(M,j,z,T)}cancelRunById(M){for(const j of this.d.values())if(j.id===M){j.cancel();return}}cancelAllRuns(){for(const M of this.d.values())M.cancel()}createTestRun(M,j,z,T,H,q){const me=this.d.get(T);if(me)return me.createRun(H);const Z=y.fromPublic(j,z,T,q),X=d(T);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!T.continuous,profile:X&&{group:O[X.kind],id:X.profileId},exclude:T.exclude?.map(x=>n.$SI.fromExtHostTestItem(x,z.root.id).toString())??[],id:Z.id,include:T.include?.map(x=>n.$SI.fromExtHostTestItem(x,z.root.id).toString())??[z.root.id],persist:q});const V=this.g(T,Z,M);return R.Event.once(V.onEnd)(()=>{this.f.$finishedExtensionTestRun(Z.id),V.dispose()}),V.createRun(H)}g(M,j,z,T){const H=new i(j,this.f,z,T);return this.d.set(M,H),R.Event.once(H.onEnd)(()=>this.d.delete(M)),H}}e.$Rcc=c;const d=N=>{if(N.profile){if(!(N.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class y{static fromPublic(M,j,z,T){return new y(M,(0,w.$4f)(),z.include?.map(H=>n.$SI.fromExtHostTestItem(H,M).toString())??[M],z.exclude?.map(H=>n.$SI.fromExtHostTestItem(H,M).toString())??[],T,j)}static fromInternal(M,j){return new y(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,j)}constructor(M,j,z,T,H,q){this.controllerId=M,this.id=j,this.isPersisted=H,this.colllection=q,this.d=z.map(me=>me+"\0"),this.f=T.map(me=>me+"\0")}isIncluded(M){const j=n.$SI.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const z of this.f)if(j===z||j.startsWith(z))return!1;for(const z of this.d)if(j===z||j.startsWith(z))return!0;return!1}}e.$Scc=y;class S{set coverageProvider(M){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.d=M,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(M,j,z){this.g=M,this.h=j,this.j=z}async provideFileCoverage(M){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(M))());try{return(await this.f)?.map(o.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(M,j){const z=await this.f;let T=z?.[M];return!this.d||!z||!T?[]:(T.detailedCoverage||(T=z[M]=await this.d.resolveFileCoverage?.(T,j)??T),T.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class g{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(M){this.j=M,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(M){this.d.add(M)}update(M){Object.assign(M.revived,o.TestItem.toPlain(M.item)),this.d.has(M)||this.f.add(M)}remove(M){if(this.d.has(M)){this.d.delete(M);return}this.f.delete(M);const j=n.$SI.parentId(M.item.extId);if(j&&this.h.has(j.toString())){this.h.add(M.item.extId);return}this.g.add(M)}getChangeEvent(){const{d:M,f:j,g:z}=this;return{get added(){return[...M].map(T=>T.revived)},get updated(){return[...j].map(T=>T.revived)},get removed(){return[...z].map(T=>T.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class u extends b.$ZI{constructor(){super(...arguments),this.s=new R.$fd,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(M){return this.f.get(M)}getMirroredTestDataByReference(M){return this.f.get(M.id)}q(M,j){return{...M,revived:o.TestItem.toPlain(M.item),depth:j?j.depth+1:0,children:new Set}}p(){return new g(this.s)}}class m{constructor(M){this.f=M}checkout(){this.d||(this.d=this.g());const M=this.d;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(j=>j.revived)},dispose:(0,$.$bb)(()=>{--M.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(M){return this.d?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.d?.tests.apply(M)}g(){const M=new u;return this.f.$subscribeToDiffs(),{observers:0,tests:M}}}class P{#e;#t;get label(){return this.f}set label(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(M){M!==this.h&&(this.h=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.g}set isDefault(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?o.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.d}set configureHandler(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,j,z,T,H,q,me,Z=!1,X=void 0,V=!1){this.controllerId=z,this.profileId=T,this.f=H,this.kind=q,this.runHandler=me,this.g=Z,this._tag=X,this.h=V,this.#e=M,this.#t=j,j.set(T,this);const x=O[q];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);this.#e.$publishTestRunProfile({profileId:T,controllerId:z,tag:X?o.TestTag.namespace(this.controllerId,X.id):null,label:H,group:x,isDefault:Z,hasConfigurationHandler:!1,supportsContinuousRun:V})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Tcc=P;const O={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Se[329],De([1,0,19,8,4,6,146,13,7]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=void 0;class p{constructor(I,w){this.i=w,this.a=new f.$fd({onListenerError:F.$Z}),this.b=new f.$fd({onListenerError:F.$Z}),this.c=new f.$fd({onListenerError:F.$Z}),this.d=new f.$fd({onListenerError:F.$Z}),this.f=new f.$fd({onListenerError:F.$Z}),this.g=new f.$fd({onListenerError:F.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(L.$1J.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(k=>this.g.fire(k)),this.i.onDidChangeActiveTextEditor(k=>this.f.fire(k))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const w=this.i.allEditors();return I?w:w.map(k=>k.value)}async showTextDocument(I,w,k){let D;typeof w=="number"?D={position:$.ViewColumn.from(w),preserveFocus:k}:typeof w=="object"?D={position:$.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?$.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:D={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(I.uri,D),o=v&&this.i.getEditor(v);if(o)return o.value;throw v?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,w){return new R.$9L(this.h,I,w).value}$acceptEditorPropertiesChanged(I,w){const k=this.i.getEditor(I);if(!k)throw new Error("unknown text editor");if(w.options&&k._acceptOptions(w.options),w.selections){const D=w.selections.selections.map($.Selection.to);k._acceptSelections(D)}if(w.visibleRanges){const D=C.$Fb(w.visibleRanges.map($.Range.to));k._acceptVisibleRanges(D)}if(w.options&&this.b.fire({textEditor:k.value,options:{...w.options,lineNumbers:$.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const D=E.TextEditorSelectionChangeKind.fromValue(w.selections.source),v=w.selections.selections.map($.Selection.to);this.a.fire({textEditor:k.value,selections:v,kind:D})}if(w.visibleRanges){const D=C.$Fb(w.visibleRanges.map($.Range.to));this.c.fire({textEditor:k.value,visibleRanges:D})}}$acceptEditorPositionData(I){for(const w in I){const k=this.i.getEditor(w);if(!k)throw new Error("Unknown text editor");const D=$.ViewColumn.to(I[w]);k.value.viewColumn!==D&&(k._acceptViewColumn(D),this.d.fire({textEditor:k.value,viewColumn:D}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$9bc=p}),define(Se[330],De([1,0,2,5,6,3,7,13,25,18]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=void 0,e.$Kcc=(0,F.$Bh)("IExtHostTimeline");class A{constructor(k,D){this.b=new Map,this.c=new Map,this.a=k.getProxy(f.$1J.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(v,o)=>{if(v&&v.$mid===12)if(this.b.get(v.source)&&E.$Vl.equals(o,this.b.get(v.source)?.extension)){const s=v.uri===void 0?void 0:C.URI.revive(v.uri);return this.c.get(v.source)?.get(I(s))?.get(v.handle)}else return;return v}})}async $getTimeline(k,D,v,o){return this.b.get(k)?.provider.provideTimeline(C.URI.revive(D),v,o)}registerTimelineProvider(k,D,v,o){const s=new L.$jc,n=this.d(D.id,o,s).bind(this);let l;D.onDidChange&&(l=D.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:D.id}),this));const b=this.c;return this.f({...D,scheme:k,onDidChange:void 0,async provideTimeline(h,t,r){t?.resetCache&&(s.clear(),b.get(D.id)?.clear());const a=await D.provideTimeline(h,t,r);if(a==null)return;const i=n(h,t);return{...a,source:D.id,items:a.items.map(i)}},dispose(){for(const h of b.values())h.get(D.id)?.clear();l?.dispose(),s.dispose()}},v)}d(k,D,v){return(o,s)=>{let n;if(s?.cacheResults){let l=this.c.get(k);l===void 0&&(l=new Map,this.c.set(k,l));const b=I(o);n=l.get(b),n===void 0&&(n=new Map,l.set(b,n))}return l=>{const{iconPath:b,...h}=l,t=`${k}|${l.id??l.timestamp}`;n?.set(t,l);let r,a,i;l.iconPath&&(b instanceof R.$WK?i={id:b.id,color:b.color}:C.URI.isUri(b)?(r=b,a=b):{light:r,dark:a}=b);let c;return R.$qK.isMarkdownString(h.tooltip)?c=$.MarkdownString.from(h.tooltip):(0,p.$jf)(h.tooltip)?c=h.tooltip:R.$qK.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=$.MarkdownString.from(h.detail)):(0,p.$jf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=h.detail),{...h,id:h.id??void 0,handle:t,source:k,command:l.command?D.toInternal(l.command,v):void 0,icon:r,iconDark:a,themeIcon:i,tooltip:c,accessibilityInformation:l.accessibilityInformation}}}}f(k,D){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:D}),(0,L.$ic)(()=>{for(const o of this.c.values())o.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.$Lcc=A;function I(w){return w?.toString()}}),define(Se[74],De([1,0,21,4,3,213,5,14,86,6,26,20,7]),function($e,e,C,F,f,L,R,$,E,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ssb=e.$rsb=e.TunnelDtoConverter=void 0;class k extends E.$9u{}var D;(function(o){function s(l){return{remoteAddress:l.remoteAddress,localAddress:l.localAddress,public:!!l.public,privacy:l.privacy??(l.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:l.protocol}}o.fromApiTunnel=s;function n(l){return{remoteAddress:{host:l.tunnelRemoteHost,port:l.tunnelRemotePort},localAddress:l.localAddress,public:l.privacy!==E.TunnelPrivacyId.ConstantPrivate&&l.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:l.privacy,protocol:l.protocol}}o.fromServiceTunnel=n})(D||(e.TunnelDtoConverter=D={})),e.$rsb=(0,R.$Bh)("IExtHostTunnelService");let v=class extends f.$kc{constructor(s,n,l){super(),this.s=l,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$fd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(p.$1J.MainThreadTunnelService)}async openTunnel(s,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const l=await this.a.$openTunnel(n,s.displayName);if(l){const b=new k(l.remoteAddress,l.localAddress,()=>this.a.$closeTunnel(l.remoteAddress));return this.B(b),b}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,n){const l=this.u();return this.r.set(l,{selector:s,provider:n}),this.a.$registerPortsAttributesProvider(s,l),new w.$3J(()=>{this.r.delete(l),this.a.$unregisterPortsAttributesProvider(l)})}async $providePortAttributes(s,n,l,b,h){const t=[];for(const a of s){const i=this.r.get(a);if(!i)return[];t.push(...await Promise.all(n.map(async c=>{let d;try{d=await i.provider.providePortAttributes({port:c,pid:l,commandLine:b},h)}catch{d=await i.provider.providePortAttributes(c,l,b,h)}return{providedAttributes:d,port:c}})))}const r=t.filter(a=>!!a.providedAttributes);return r.length>0?r.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(b,h)=>await s.provideTunnel(b,h,new C.$pd().token)??void 0;const l=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(l),Promise.resolve((0,f.$ic)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,n){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const l=s.tunnelFactory??(n?this.w(n):void 0);if(l){this.b=l;let b=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&b.length===0&&(b=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:b}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,f.$ic)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,n){if(this.g.has(s.host)){const l=this.g.get(s.host);l.has(s.port)&&(n&&l.get(s.port).disposeListener.dispose(),await l.get(s.port).tunnel.dispose(),l.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const l=this.b(s,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),l!==void 0){const b=await l;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),b===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(b.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(b.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:b,disposeListener:h}),D.fromApiTunnel(b)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(l){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),l instanceof Error)return l.message}}async $applyCandidateFilter(s){const n=await Promise.all(s.map(b=>this.f(b.host,b.port,b.detail??""))),l=s.filter((b,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(b=>b.port).join(", ")} to ${l.map(b=>b.port).join(", ")}`),l}};e.$ssb=v,e.$ssb=v=Ke([Be(0,I.$2L),Be(1,A.$fM),Be(2,$.$5i)],v)}),define(Se[331],De([1,0,3,17,2,6]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;class R{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(L.$1J.MainThreadUriOpeners)}registerExternalUriOpener(E,p,A,I){if(this.c.has(p))throw new Error(`Opener with id '${p}' already registered`);const w=I.schemes.find(k=>!R.a.has(k));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this.c.set(p,A),this.b.$registerUriOpener(p,I.schemes,E,I.label),(0,C.$ic)(()=>{this.c.delete(p),this.b.$unregisterUriOpener(p)})}async $canOpenUri(E,p,A){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const w=f.URI.revive(p);return I.canOpenExternalUri(w,A)}async $openUri(E,p,A){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(f.URI.revive(p.resolvedUri),{sourceUri:f.URI.revive(p.sourceUri)},A)}}e.$Ucc=R}),define(Se[332],De([1,0,6,2,3,8,25]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=void 0;class ${static{this.a=0}constructor(p){this.c=new R.$Wl,this.d=new Map,this.b=p.getProxy(C.$1J.MainThreadUrls)}registerUriHandler(p,A){const I=p.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const w=$.a++;return this.c.add(I),this.d.set(w,A),this.b.$registerUriHandler(w,I,p.displayName||p.name),(0,f.$ic)(()=>{this.c.delete(I),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(p,A){const I=this.d.get(p);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(A))}catch(w){(0,L.$Y)(w)}return Promise.resolve(void 0)}async createAppUri(p){return F.URI.revive(await this.b.$createAppUri(p))}}e.$$bc=$}),define(Se[92],De([1,0,4,3,17,23,2,228,265,110,6]),function($e,e,C,F,f,L,R,$,E,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=e.$ccc=e.$bcc=e.$acc=e.$_bc=void 0;class I{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(b,h,t,r,a,i,c){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new C.$fd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$fd,this._onDidDispose=this.#h.event,this.#e=b,this.#t=h,this.#r=t,this.#l=r,this.#u=a,this.#n=i,this.#c=w(i),this.#d=k(i),this.#i=c}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return this.#a=!0,(0,p.$Yob)(b,this.#l)}get cspSource(){const b=this.#n.extensionLocation;if(b.scheme===f.Schemas.https||b.scheme===f.Schemas.http){let h=b.toString();return h.endsWith("/")||(h+="/"),h+" "+p.$Xob}return p.$Xob}get html(){return this.a(),this.#s}set html(b){this.a(),this.#s!==b&&(this.#s=b,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(b)))}get options(){return this.a(),this.#r}set options(b){this.a(),L.$Zm(this.#r,b)||this.#t.$setOptions(this.#e,o(this.#n,this.#u,b)),this.#r=b}async postMessage(b){if(this.#o)return!1;const h=(0,E.$$bb)(b,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(b){if(!this.#d)return b;const h=this.#n.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return b.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,a,i,c,d,y)=>{const S=R.URI.from({scheme:c||"file",path:decodeURIComponent(d)}),g=(0,p.$Yob)(S,{isRemote:h,authority:t}).toString();return`${a}${g}${y}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,a,i,c,d,y)=>{const S=R.URI.from({scheme:c||"file",path:decodeURIComponent(d)}),g=(0,p.$Yob)(S,{isRemote:h,authority:t}).toString();return`${a}${g}${y}`})}}e.$_bc=I;function w(l){try{const b=(0,$.$Do)((0,$.$Co)(l.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.$acc=w;function k(l){try{const b=(0,$.$Do)((0,$.$Co)(l.engines.vscode));return b?b.majorBase<1||b.majorBase===1&&b.minorBase<60:!1}catch{return!1}}class D extends F.$kc{constructor(b,h,t,r,a){super(),this.c=h,this.f=t,this.g=r,this.h=a,this.b=new Map,this.a=b.getProxy(A.$1J.MainThreadWebviews)}dispose(){super.dispose();for(const b of this.b.values())b.dispose();this.b.clear()}$onMessage(b,h,t){const r=this.j(b);if(r){const{message:a}=(0,E.$_bb)(h,t.value);r._onMessageEmitter.fire(a)}}$onMissingCsp(b,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,h,t){const r=new I(b,this.a,s(h),this.c,this.f,t,this.h);this.b.set(b,r);const a=r._onDidDispose(()=>{a.dispose(),this.deleteWebview(b)});return r}deleteWebview(b){this.b.delete(b)}j(b){return this.b.get(b)}}e.$bcc=D;function v(l){return{id:l.identifier,location:l.extensionLocation}}e.$ccc=v;function o(l,b,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(l,b)}}e.$dcc=o;function s(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(b=>R.URI.from(b))}}function n(l,b){return[...(b?.getWorkspaceFolders()||[]).map(h=>h.uri),l.extensionLocation]}}),define(Se[333],De([1,0,21,51,3,17,24,2,13,92,87,6,7]),function($e,e,C,F,f,L,R,$,E,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;class k{constructor(r,a){this.document=r,this.b=a,this.a=1,this.c=new A.$8ac("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,a){await this.f(r).undo(),a||this.disposeBackup()}async redo(r,a){await this.f(r).redo(),a||this.disposeBackup()}disposeEdits(r){for(const a of r)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=h(this.document.uri)+this.a++;return(0,R.$ig)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const a=this.c.get(r,0);if(!a)throw new Error("No edit found");return a}}class D{constructor(){this.a=new Map}get(r,a){return this.a.get(this.b(r,a))}add(r,a,i){const c=this.b(r,a.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${r} resource:${a.uri}`);const d=new k(a,i);return this.a.set(c,d),d}delete(r,a){const i=this.b(r,a.uri);this.a.delete(i)}b(r,a){return`${r}@@@${a}`}}var v;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(v||(v={}));class o{constructor(){this.a=new Map}addTextProvider(r,a,i){return this.b(0,r,a,i)}addCustomProvider(r,a,i){return this.b(1,r,a,i)}get(r){return this.a.get(r)}b(r,a,i,c){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:r,extension:i,provider:c}),new w.$3J(()=>this.a.delete(a))}}class s{constructor(r,a,i,c,d){this.d=a,this.f=i,this.g=c,this.h=d,this.b=new o,this.c=new D,this.a=r.getProxy(I.$1J.MainThreadCustomEditors)}registerCustomEditorProvider(r,a,i,c){const d=new f.$jc;return l(i)?(d.add(this.b.addTextProvider(a,r,i)),this.a.$registerTextEditorProvider((0,p.$ccc)(r),a,c.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,p.$acc)(r))):(d.add(this.b.addCustomProvider(a,r,i)),n(i)&&d.add(i.onDidChangeCustomDocument(y=>{const S=this.i(a,y.document.uri);if(b(y)){const g=S.addEdit(y);this.a.$onDidEdit(y.document.uri,a,g,y.label)}else this.a.$onContentChange(y.document.uri,a)})),this.a.$registerCustomEditorProvider((0,p.$ccc)(r),a,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,p.$acc)(r))),w.$3J.from(d,new w.$3J(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(r,a,i,c,d){const y=this.b.get(a);if(!y)throw new Error(`No provider found for '${a}'`);if(y.type!==1)throw new Error(`Invalid provide type for '${a}'`);const S=$.URI.revive(r),g=await y.provider.openCustomDocument(S,{backupId:i,untitledDocumentData:c?.buffer},d);let u;return n(y.provider)&&this.f&&(u=this.f.workspaceValue(y.extension)??this.f.globalValue(y.extension)),this.c.add(a,g,u),{editable:n(y.provider)}}async $disposeCustomDocument(r,a){const i=this.b.get(a);if(!i)throw new Error(`No provider found for '${a}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${a}'`);const c=$.URI.revive(r),{document:d}=this.i(a,c);this.c.delete(a,d),d.dispose()}async $resolveCustomEditor(r,a,i,c,d,y){const S=this.b.get(i);if(!S)throw new Error(`No provider found for '${i}'`);const g=E.ViewColumn.to(d),u=this.g.createNewWebview(a,c.contentOptions,S.extension),m=this.h.createNewWebviewPanel(a,i,c.title,g,c.options,u,c.active),P=$.URI.revive(r);switch(S.type){case 1:{const{document:O}=this.i(i,P);return S.provider.resolveCustomEditor(O,m,y)}case 0:{const O=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(O,m,y)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,a,i){this.i(a,r).disposeEdits(i)}async $onMoveCustomEditor(r,a,i){const c=this.b.get(i);if(!c)throw new Error(`No provider found for '${i}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const d=this.h.getWebviewPanel(r);if(!d)throw new Error("No webview found");const y=$.URI.revive(a),S=this.d.getDocument(y);await c.provider.moveCustomTextEditor(S,d,C.CancellationToken.None)}async $undo(r,a,i,c){return this.i(a,r).undo(i,c)}async $redo(r,a,i,c){return this.i(a,r).redo(i,c)}async $revert(r,a,i){const c=this.i(a,r);await this.j(a).revertCustomDocument(c.document,i),c.disposeBackup()}async $onSave(r,a,i){const c=this.i(a,r);await this.j(a).saveCustomDocument(c.document,i),c.disposeBackup()}async $onSaveAs(r,a,i,c){const d=this.i(a,r);return this.j(a).saveCustomDocumentAs(d.document,$.URI.revive(i),c)}async $backup(r,a,i){const c=this.i(a,r),y=await this.j(a).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},i);return c.updateBackup(y),y.id}i(r,a){const i=this.c.get(r,$.URI.revive(a));if(!i)throw new Error("No custom document found");return i}j(r){const i=this.b.get(r)?.provider;if(!i||!n(i))throw new Error("Custom document is not editable");return i}}e.$Occ=s;function n(t){return!!t.onDidChangeCustomDocument}function l(t){return typeof t.resolveCustomTextEditor=="function"}function b(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const r=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,F.$pi)(r)+""}}),define(Se[334],De([1,0,4,3,2,31,13,92,6,7]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;class A extends F.$kc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(D,v,o,s){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new C.$fd),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$fd),this.onDidChangeViewState=this.#h.event,this.#e=D,this.#t=v,this.#l=o,this.#i=s.viewType,this.#u=s.panelOptions,this.#r=s.viewColumn,this.#n=s.title,this.#a=s.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(D){this.c(),this.#n!==D&&(this.#n=D,this.#t.$setTitle(this.#e,D))}get iconPath(){return this.c(),this.#s}set iconPath(D){this.c(),this.#s!==D&&(this.#s=D,this.#t.$setIconPath(this.#e,f.URI.isUri(D)?{light:D,dark:D}:D))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(D){this.#c||(this.active!==D.active||this.visible!==D.visible||this.viewColumn!==D.viewColumn)&&(this.#a=D.active,this.#o=D.visible,this.#r=D.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(D,v){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof D>"u"?void 0:R.ViewColumn.from(D),preserveFocus:!!v})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I extends F.$kc{static c(){return(0,L.$4f)()}constructor(D,v,o){super(),this.j=v,this.m=o,this.g=new Map,this.h=new Map,this.f=D.getProxy(E.$1J.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(D=>D.dispose()),this.g.clear()}createWebviewPanel(D,v,o,s,n={}){const l=typeof s=="object"?s.viewColumn:s,b={viewColumn:R.ViewColumn.from(l),preserveFocus:typeof s=="object"&&!!s.preserveFocus},h=(0,$.$acc)(D),t=I.c();this.f.$createWebviewPanel((0,$.$ccc)(D),t,v,{title:o,panelOptions:w(n),webviewOptions:(0,$.$dcc)(D,this.m,n),serializeBuffersForPostMessage:h},b);const r=this.j.createNewWebview(t,n,D);return this.createNewWebviewPanel(t,v,o,l,n,r,!0)}$onDidChangeWebviewPanelViewStates(D){const v=Object.keys(D);v.sort((o,s)=>{const n=D[o],l=D[s];return n.active?1:l.active?-1:+n.visible-+l.visible});for(const o of v){const s=this.getWebviewPanel(o);if(!s)continue;const n=D[o];s._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(D){this.getWebviewPanel(D)?.dispose(),this.g.delete(D),this.j.deleteWebview(D)}registerWebviewPanelSerializer(D,v,o){if(this.h.has(v))throw new Error(`Serializer for '${v}' already registered`);return this.h.set(v,{serializer:o,extension:D}),this.f.$registerSerializer(v,{serializeBuffersForPostMessage:(0,$.$acc)(D)}),new p.$3J(()=>{this.h.delete(v),this.f.$unregisterSerializer(v)})}async $deserializeWebviewPanel(D,v,o,s){const n=this.h.get(v);if(!n)throw new Error(`No serializer found for '${v}'`);const{serializer:l,extension:b}=n,h=this.j.createNewWebview(D,o.webviewOptions,b),t=this.createNewWebviewPanel(D,v,o.title,s,o.panelOptions,h,o.active);await l.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(D,v,o,s,n,l,b){const h=new A(D,this.f,l,{viewType:v,title:o,viewColumn:s,panelOptions:n,active:b});return this.g.set(D,h),h}getWebviewPanel(D){return this.g.get(D)}}e.$Ncc=I;function w(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(Se[335],De([1,0,4,3,92,13,6,7]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class E extends F.$kc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,w,k,D,v,o){super(),this.#u=!1,this.#a=this.B(new C.$fd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new C.$fd),this.onDidDispose=this.#c.event,this.#i=k,this.#s=D,this.#e=I,this.#t=w,this.#l=v,this.#n=o}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class p{constructor(I,w){this.d=w,this.b=new Map,this.c=new Map,this.a=I.getProxy(R.$1J.MainThreadWebviewViews)}registerWebviewViewProvider(I,w,k,D){if(this.b.has(w))throw new Error(`View provider for '${w}' already registered`);return this.b.set(w,{provider:k,extension:I}),this.a.$registerWebviewViewProvider((0,f.$ccc)(I),w,{retainContextWhenHidden:D?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$acc)(I)}),new $.$3J(()=>{this.b.delete(w),this.a.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(I,w,k,D,v){const o=this.b.get(w);if(!o)throw new Error(`No view provider found for '${w}'`);const{provider:s,extension:n}=o,l=this.d.createNewWebview(I,{},n),b=new E(I,this.a,w,k,l,!0);this.c.set(I,b),await s.resolveWebviewView(b,{state:D},v)}async $onDidChangeWebviewViewVisibility(I,w){this.e(I)._setVisible(w)}async $disposeWebviewView(I){const w=this.e(I);this.c.delete(I),w.dispose(),this.d.deleteWebview(I)}e(I){const w=this.c.get(I);if(!w)throw new Error("No webview found");return w}}e.$Mcc=p}),define(Se[151],De([1,0,4,6,2,17,15,5,20,27]),function($e,e,C,F,f,L,R,$,E,p){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=e.$ecc=void 0;let I=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(k){const D=this.d;return{get focused(){return D.focused},get active(){return(0,p.$YE)(k,"windowActivity"),D.active}}}constructor(k){this.c=new C.$fd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=k.getProxy(F.$1J.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:v})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(k){this.onDidChangeWindowProperty("focused",k)}$onDidChangeWindowActive(k){this.onDidChangeWindowProperty("active",k)}onDidChangeWindowProperty(k,D){D!==this.d[k]&&(this.d={...this.d,[k]:D},this.c.fire(this.d))}openUri(k,D){let v;if(typeof k=="string"){v=k;try{k=f.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,R.$me)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,v,D)}async asExternalUri(k,D){if((0,R.$me)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(k,D);return f.URI.from(v)}};e.$ecc=I,e.$ecc=I=A=Ke([Be(0,E.$2L)],I),e.$fcc=(0,$.$Bh)("IExtHostWindow")}),define(Se[336],De([1,0,304,26,20]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;const L=1024*1024;let R=class extends C.$edc{constructor(E,p){super(E,p),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,p,A){const I=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),p.apply(console,A),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,p){const A=process[E],I=A.write;let w="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(k,D,v)=>{if(!this.g){w+=k.toString(D);const o=w.length>L?w.length:w.lastIndexOf(`
`);o!==-1&&(console[p](w.slice(0,o)),w=w.slice(o+1))}I.call(A,k,D,v)}})}};e.$Pdc=R,e.$Pdc=R=Ke([Be(0,f.$2L),Be(1,F.$fM)],R)}),define(Se[337],De([1,0,73,17,14,240,30,12]),function($e,e,C,F,f,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;let E=class{constructor(I,w){I.addFileSystemProvider(F.Schemas.file,new p(w),{isCaseSensitive:$.$k})}};e.$Qdc=E,e.$Qdc=E=Ke([Be(0,C.$Dbc),Be(1,f.$5i)],E);class p{constructor(I){this.b=I,this.a=new L.$3p(this.b)}async stat(I){const w=await this.a.stat(I);return{type:w.type,ctime:w.ctime,mtime:w.mtime,size:w.size,permissions:w.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,w,k){return this.a.writeFile(I,w,{...k,unlock:!1,atomic:!1})}delete(I,w){return this.a.delete(I,{...w,useTrash:!1,atomic:!1})}rename(I,w,k){return this.a.rename(I,w,k)}copy(I,w,k){return this.a.copy(I,w,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,w){throw new Error("Method not implemented.")}}}),define(Se[338],De([1,0,16,64,31,33,3,6,2,20]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;let A=class extends R.$kc{constructor(w,k){super();const D=w.getProxy($.$1J.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async v=>{const o=E.URI.file((0,C.$9d)((0,F.tmpdir)(),(0,f.$4f)()));return await D.$download(v,o),o})}};e.$Odc=A,e.$Odc=A=Ke([Be(0,p.$2L),Be(1,L.$lM)],A)}),define(Se[339],De([1,0,150,17,242,31]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class R extends C.$ddc{s(E,p,A){return E.scheme===F.Schemas.file?new f.$bN(A?.name||(0,L.$4f)(),E.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,p):super.s(E,p,A)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$2dc=R}),define(Se[340],De([1,0,52,16,2,91,3,17,9,29]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class A extends L.$Fbc{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==$.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const a=r.fsPath;let i=0;do{let c;i===0?c=a:c=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${i}`:`${a}-${i}`,await I(c);const d=F.$9d(c,"vscode.lock"),y=await v(this.d,d,!1);if(y)return this.i=y,process.on("exit",()=>{y.dispose()}),f.URI.file(c);i++}while(i<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$1dc=A;async function I(h){try{await p.Promises.stat(h);return}catch{}try{await p.Promises.mkdir(h,{recursive:!0})}catch{}}const w=1e3,k=10*60*1e3;class D extends R.$kc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new E.$Rg),this.a.cancelAndSet(async()=>{const a=await o(t,r);(!a||a.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await p.Promises.utimes(r,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${r}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await p.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function v(h,t,r){try{const i={pid:process.pid,willReleaseAt:0};await p.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){h.error(i)}const a=await o(h,t);return!a||a.pid!==process.pid?r?(h.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),l(h,t)):(h.info(`Lock '${t}': Lock acquired.`),new D(h,t))}async function o(h,t){let r;try{r=await p.Promises.readFile(t)}catch(a){return h.error(a),null}try{return JSON.parse(String(r))}catch(a){return h.error(a),null}}async function s(h,t){let r;try{r=await p.Promises.stat(t)}catch(a){return h.error(a),0}return r.mtime.getTime()}function n(h){try{return process.kill(h,0),!0}catch{return!1}}async function l(h,t){const r=await o(h,t);if(!r)return h.info(`Lock '${t}': Could not read pid of lock holder.`),b(h,t);if(r.willReleaseAt){let y=r.willReleaseAt-Date.now();if(y<5e3){for(y>0?h.info(`Lock '${t}': The lockfile is scheduled to be released in ${y} ms.`):h.info(`Lock '${t}': The lockfile is scheduled to have been released.`);y>0;){if(await(0,E.$Hg)(Math.min(100,y)),await s(h,t)===0)return b(h,t);y=r.willReleaseAt-Date.now()}return b(h,t)}}if(!n(r.pid))return h.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),b(h,t);const a=await s(h,t),i=Date.now()-a;if(i<=k)return h.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;h.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Hg)(2e3);const c=await s(h,t),d=Date.now()-c;return d<=k?(h.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(h.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),b(h,t))}async function b(h,t){h.info(`Lock '${t}': Deleting a stale lock.`);try{await p.Promises.unlink(t)}catch{}return v(h,t,!0)}}),define(Se[341],De([1,0,31,20,44,33]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;let R=class extends f.$Ibc{constructor(E,p){super(!0,E,p)}createTerminal(E,p,A){return this.createTerminalFromOptions({name:E,shellPath:p,shellArgs:A})}createTerminalFromOptions(E,p){const A=new f.$Hbc(this.a,(0,C.$4f)(),E,E.name);return this.f.push(A),A.create(E,this.R(E,p)),A.value}};e.$jdc=R,e.$jdc=R=Ke([Be(0,L.$lM),Be(1,F.$2L)],R)}),define(Se[342],De([1,0,9,22,21,8,4,3,128,292,70]),function($e,e,C,F,f,L,R,$,E,p,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$J3b=e.ResponsiveState=e.RequestInitiator=e.$I3b=e.$H3b=void 0;function w(m,P){try{return JSON.stringify(m,P)}catch{return"null"}}const k="$$ref$$",D={[k]:-1};class v{constructor(P,O){this.jsonString=P,this.referencedBuffers=O}}function o(m,P=null,O=!1){const N=[];return{jsonString:(O?w:JSON.stringify)(m,(j,z)=>{if(typeof z>"u")return D;if(typeof z=="object"){if(z instanceof F.$Fd){const T=N.push(z)-1;return{[k]:T}}if(P)return P(j,z)}return z}),referencedBuffers:N}}e.$H3b=o;function s(m,P,O){return JSON.parse(m,(N,M)=>{if(M){const j=M[k];if(typeof j=="number")return P[j];if(O&&M.$mid===1)return O.transformIncoming(M)}return M})}e.$I3b=s;function n(m,P){return JSON.stringify(m,P)}function l(m){return m?(P,O)=>O&&O.$mid===1?m.transformOutgoing(O):O:null}var b;(function(m){m[m.LocalSide=0]="LocalSide",m[m.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));var h;(function(m){m[m.Responsive=0]="Responsive",m[m.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},r=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class i extends $.$kc{static{I=r}static{this.a=3*1e3}constructor(P,O=null,N=null){super(),this[I]=!0,this.b=this.B(new R.$fd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=O,this.g=N,this.h=l(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,j=A.$dv.count;M<j;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$Sg(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const O=this.w[P];delete this.w[P],O.resolveErr(L.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+i.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+i.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,E.$Em)(P,this.g):P}getProxy(P){const{nid:O,sid:N}=P;return this.s[O]||(this.s[O]=this.J(O,N)),this.s[O]}J(P,O){const N={get:(M,j)=>(typeof j=="string"&&!M[j]&&j.charCodeAt(0)===36&&(M[j]=(...z)=>this.U(P,j,z)),j===a?O:M[j])};return new Proxy(Object.create(null),N)}set(P,O){return this.m[P.nid]=O,O}assertRegistered(P){for(let O=0,N=P.length;O<N;O++){const M=P[O];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(P){if(this.j)return;const O=P.byteLength,N=d.read(P,0),M=N.readUInt8(),j=N.readUInt32();switch(M){case 1:case 2:{let{rpcId:z,method:T,args:H}=S.deserializeRequestJSONArgs(N);this.g&&(H=(0,E.$Em)(H,this.g)),this.M(O,j,z,T,H,M===2);break}case 3:case 4:{let{rpcId:z,method:T,args:H}=S.deserializeRequestMixedArgs(N);this.g&&(H=(0,E.$Em)(H,this.g)),this.M(O,j,z,T,H,M===4);break}case 5:{this.f?.logIncoming(O,j,0,"ack"),this.G(j);break}case 6:{this.N(O,j);break}case 7:{this.O(O,j,void 0);break}case 9:{let z=S.deserializeReplyOKJSON(N);this.g&&(z=(0,E.$Em)(z,this.g)),this.O(O,j,z);break}case 10:{const z=S.deserializeReplyOKJSONWithBuffers(N,this.g);this.O(O,j,z);break}case 8:{const z=S.deserializeReplyOKVSBuffer(N);this.O(O,j,z);break}case 11:{let z=S.deserializeReplyErrError(N);this.g&&(z=(0,E.$Em)(z,this.g)),this.P(O,j,z);break}case 12:{this.P(O,j,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,O,N,M,j,z){this.f?.logIncoming(P,O,1,`receiveRequest ${(0,A.$fv)(N)}.${M}(`,j);const T=String(O);let H,q;if(z){const Z=new f.$pd;j.push(Z.token),H=this.Q(N,M,j),q=()=>Z.cancel()}else H=this.Q(N,M,j),q=t;this.u[T]=q;const me=S.serializeAcknowledged(O);this.f?.logOutgoing(me.byteLength,O,1,"ack"),this.c.send(me),H.then(Z=>{delete this.u[T];const X=S.serializeReplyOK(O,Z,this.h);this.f?.logOutgoing(X.byteLength,O,1,"reply:",Z),this.c.send(X)},Z=>{delete this.u[T];const X=S.serializeReplyErr(O,Z);this.f?.logOutgoing(X.byteLength,O,1,"replyErr:",Z),this.c.send(X)})}N(P,O){this.f?.logIncoming(P,O,1,"receiveCancel");const N=String(O);this.u[N]?.()}O(P,O,N){this.f?.logIncoming(P,O,0,"receiveReply:",N);const M=String(O);if(!this.w.hasOwnProperty(M))return;const j=this.w[M];delete this.w[M],j.resolveOk(N)}P(P,O,N){this.f?.logIncoming(P,O,0,"receiveReplyErr:",N);const M=String(O);if(!this.w.hasOwnProperty(M))return;const j=this.w[M];delete this.w[M];let z;N&&(N.$isError?(z=new Error,z.name=N.name,z.message=N.message,z.stack=N.stack):z=N),j.resolveErr(z)}Q(P,O,N){try{return Promise.resolve(this.S(P,O,N))}catch(M){return Promise.reject(M)}}S(P,O,N){const M=this.m[P];if(!M)throw new Error("Unknown actor "+(0,A.$fv)(P));const j=M[O];if(typeof j!="function")throw new Error("Unknown method "+O+" on actor "+(0,A.$fv)(P));return j.apply(M,N)}U(P,O,N){if(this.j)return new p.$G3b;let M=null;if(N.length>0&&f.CancellationToken.isCancellationToken(N[N.length-1])&&(M=N.pop()),M&&M.isCancellationRequested)return Promise.reject(L.$4());const j=S.serializeRequestArguments(N,this.h),z=++this.t,T=String(z),H=new p.$F3b,q=new $.$jc;M&&q.add(M.onCancellationRequested(()=>{const Z=S.serializeCancel(z);this.f?.logOutgoing(Z.byteLength,z,0,"cancel"),this.c.send(S.serializeCancel(z))})),this.w[T]=new c(H,q),this.F(z);const me=S.serializeRequest(z,P,O,j,!!M);return this.f?.logOutgoing(me.byteLength,z,0,`request: ${(0,A.$fv)(P)}.${O}(`,N),this.c.send(me),H}}e.$J3b=i;class c{constructor(P,O){this.a=P,this.b=O}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class d{static alloc(P,O,N){const M=new d(F.$Fd.alloc(N+1+4),0);return M.writeUInt8(P),M.writeUInt32(O),M}static read(P,O){return new d(P,O)}get buffer(){return this.a}constructor(P,O){this.a=P,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const N=this.a.slice(this.b,this.b+P).toString();return this.b+=P,N}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+P).toString();return this.b+=P,N}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+P);return this.b+=P,O}static sizeMixedArray(P){let O=0;O+=1;for(let N=0,M=P.length;N<M;N++){const j=P[N];switch(O+=1,j.type){case 1:O+=this.sizeLongString(j.value);break;case 2:O+=this.sizeVSBuffer(j.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(j.value);for(let z=0;z<j.buffers.length;++z)O+=this.sizeVSBuffer(j.buffers[z]);break;case 4:break}}return O}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let O=0,N=P.length;O<N;O++){const M=P[O];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let j=0;j<M.buffers.length;++j)this.writeBuffer(M.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const O=new Array(P);for(let N=0;N<P;N++)switch(this.readUInt8()){case 1:O[N]=this.readLongString();break;case 2:O[N]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),z=this.readLongString(),T=[];for(let H=0;H<j;++H)T.push(this.readVSBuffer());O[N]=new A.$gv(s(z,T,null));break}case 4:O[N]=void 0;break}return O}}var y;(function(m){m[m.Simple=0]="Simple",m[m.Mixed=1]="Mixed"})(y||(y={}));class S{static a(P){for(let O=0,N=P.length;O<N;O++)if(P[O]instanceof F.$Fd||P[O]instanceof A.$gv||typeof P[O]>"u")return!0;return!1}static serializeRequestArguments(P,O){if(this.a(P)){const N=[];for(let M=0,j=P.length;M<j;M++){const z=P[M];if(z instanceof F.$Fd)N[M]={type:2,value:z};else if(typeof z>"u")N[M]={type:4};else if(z instanceof A.$gv){const{jsonString:T,referencedBuffers:H}=o(z.value,O);N[M]={type:3,value:F.$Fd.fromString(T),buffers:H}}else N[M]={type:1,value:F.$Fd.fromString(n(z,O))}}return{type:1,args:N}}return{type:0,args:n(P,O)}}static serializeRequest(P,O,N,M,j){switch(M.type){case 0:return this.b(P,O,N,M.args,j);case 1:return this.c(P,O,N,M.args,j)}}static b(P,O,N,M,j){const z=F.$Fd.fromString(N),T=F.$Fd.fromString(M);let H=0;H+=d.sizeUInt8(),H+=d.sizeShortString(z),H+=d.sizeLongString(T);const q=d.alloc(j?2:1,P,H);return q.writeUInt8(O),q.writeShortString(z),q.writeLongString(T),q.buffer}static deserializeRequestJSONArgs(P){const O=P.readUInt8(),N=P.readShortString(),M=P.readLongString();return{rpcId:O,method:N,args:JSON.parse(M)}}static c(P,O,N,M,j){const z=F.$Fd.fromString(N);let T=0;T+=d.sizeUInt8(),T+=d.sizeShortString(z),T+=d.sizeMixedArray(M);const H=d.alloc(j?4:3,P,T);return H.writeUInt8(O),H.writeShortString(z),H.writeMixedArray(M),H.buffer}static deserializeRequestMixedArgs(P){const O=P.readUInt8(),N=P.readShortString(),M=P.readMixedArray(),j=new Array(M.length);for(let z=0,T=M.length;z<T;z++){const H=M[z];typeof H=="string"?j[z]=JSON.parse(H):j[z]=H}return{rpcId:O,method:N,args:j}}static serializeAcknowledged(P){return d.alloc(5,P,0).buffer}static serializeCancel(P){return d.alloc(6,P,0).buffer}static serializeReplyOK(P,O,N){if(typeof O>"u")return this.d(P);if(O instanceof F.$Fd)return this.e(P,O);if(O instanceof A.$gv){const{jsonString:M,referencedBuffers:j}=o(O.value,N,!0);return this.g(P,M,j)}else return this.f(P,w(O,N))}static d(P){return d.alloc(7,P,0).buffer}static e(P,O){let N=0;N+=d.sizeVSBuffer(O);const M=d.alloc(8,P,N);return M.writeVSBuffer(O),M.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,O){const N=F.$Fd.fromString(O);let M=0;M+=d.sizeLongString(N);const j=d.alloc(9,P,M);return j.writeLongString(N),j.buffer}static g(P,O,N){const M=F.$Fd.fromString(O);let j=0;j+=d.sizeUInt32,j+=d.sizeLongString(M);for(const T of N)j+=d.sizeVSBuffer(T);const z=d.alloc(10,P,j);z.writeUInt32(N.length),z.writeLongString(M);for(const T of N)z.writeBuffer(T);return z.buffer}static deserializeReplyOKJSON(P){const O=P.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(P,O){const N=P.readUInt32(),M=P.readLongString(),j=[];for(let z=0;z<N;++z)j.push(P.readVSBuffer());return new A.$gv(s(M,j,O))}static serializeReplyErr(P,O){const N=O?w(L.$1(O),null):void 0;if(typeof N!="string")return this.h(P);const M=F.$Fd.fromString(N);let j=0;j+=d.sizeLongString(M);const z=d.alloc(11,P,j);return z.writeLongString(M),z.buffer}static deserializeReplyErrError(P){const O=P.readLongString();return JSON.parse(O)}static h(P){return d.alloc(12,P,0).buffer}}var g;(function(m){m[m.RequestJSONArgs=1]="RequestJSONArgs",m[m.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",m[m.RequestMixedArgs=3]="RequestMixedArgs",m[m.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",m[m.Acknowledged=5]="Acknowledged",m[m.Cancel=6]="Cancel",m[m.ReplyOKEmpty=7]="ReplyOKEmpty",m[m.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",m[m.ReplyOKJSON=9]="ReplyOKJSON",m[m.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",m[m.ReplyErrError=11]="ReplyErrError",m[m.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var u;(function(m){m[m.String=1]="String",m[m.VSBuffer=2]="VSBuffer",m[m.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",m[m.Undefined=4]="Undefined"})(u||(u={}))}),define(Se[343],De([1,0,4,42,41,5]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kJ=e.$jJ=e.OutputChannelUpdateMode=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=void 0,e.$$I="text/x-code-output",e.$_I="output",e.$aJ="Log",e.$bJ="text/x-code-log-output",e.$cJ="log",e.$dJ="log",e.$eJ="workbench.panel.output",e.$fJ=new f.$2i("inOutput",!1),e.$gJ=new f.$2i("activeLogOutput",!1),e.$hJ=new f.$2i("outputView.scrollLock",!1),e.$iJ=(0,L.$Bh)("outputService");var R;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$jJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new C.$fd,this.onDidRegisterChannel=this.b.event,this.c=new C.$fd,this.onDidRemoveChannel=this.c.event}registerChannel(p){this.a.has(p.id)||(this.a.set(p.id,p),this.b.fire(p.id))}getChannels(){const p=[];return this.a.forEach(A=>p.push(A)),p}getChannel(p){return this.a.get(p)}removeChannel(p){this.a.delete(p),this.c.fire(p)}}F.$8m.add(e.$jJ.OutputChannels,new $),e.$kJ=new f.$2i("activeOutputChannel","")}),define(Se[152],De([1,0,6,5,20,25,14,343,73,26,54,178,22,18,30,4,3]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=e.$1bc=void 0;class s extends R.$$i{get disposed(){return this.n}constructor(h,t,r,a,i){super(),this.id=h,this.name=t,this.r=r,this.s=a,this.extension=i,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=w.$Fd.fromString(t).byteLength,(0,R.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends s{appendLine(h){this.append(h)}}let l=class{constructor(h,t,r,a,i,c){this.i=t,this.j=r,this.k=a,this.l=i,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(C.$1J.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$7l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(h,t,r){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,i=(0,k.$jf)(t)?t:void 0;if((0,k.$jf)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const d=this.i.environment.extensionLogLevel?.find(([S])=>L.$Vl.equals(r.identifier,S))?.[1];d&&(c=(0,R.$ij)(d));const y=a?this.o(h,c,r):this.n(h,i,r);return y.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),a?this.r(h,c??this.m.getLevel(),y):this.q(h,y)}async n(h,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,i=this.k.extUri.joinPath(a,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(h,i,t,r.identifier.value);return new s(d,h,c,this.a,r)}async o(h,t,r){const a=await this.p(r),i=h.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(a,`${i}.log`),d=`${r.identifier.value}.${i}`,y=this.l.createLogger(c,{id:d,name:h,logLevel:t,extensionId:r.identifier.value});return new n(d,h,y,this.a,r)}p(h){let t=this.d.get(h.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(a){if((0,D.$ik)(a)!==D.FileSystemProviderErrorCode.FileExists)throw a}return r})())}return t}q(h,t){let r=!1;const a=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return h},append(i){a(),t.then(c=>c.append(i))},appendLine(i){a(),t.then(c=>c.appendLine(i))},clear(){a(),t.then(i=>i.clear())},replace(i){a(),t.then(c=>c.replace(i))},show(i,c){a(),t.then(d=>d.show(i,c))},hide(){a(),t.then(i=>i.hide())},dispose(){r=!0,t.then(i=>i.dispose())}}}r(h,t,r){const a=new o.$jc,i=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},c=a.add(new v.$fd);function d(y){t=y,c.fire(y)}return r.then(y=>{a.add(y),y.logLevel!==t&&d(y.logLevel),a.add(y.onDidChangeLogLevel(S=>d(S)))}),{...this.q(h,r),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(y,...S){i(),r.then(g=>g.trace(y,...S))},debug(y,...S){i(),r.then(g=>g.debug(y,...S))},info(y,...S){i(),r.then(g=>g.info(y,...S))},warn(y,...S){i(),r.then(g=>g.warn(y,...S))},error(y,...S){i(),r.then(g=>g.error(y,...S))},dispose(){a.dispose()}}}};e.$1bc=l,e.$1bc=l=Ke([Be(0,f.$2L),Be(1,p.$fM),Be(2,E.$Dbc),Be(3,A.$$ac),Be(4,R.$6i),Be(5,R.$5i)],l),e.$2bc=(0,F.$Bh)("IExtHostOutputService")}),define(Se[344],De([1,0,5,9]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0,e.$jm=(0,C.$Bh)("remoteAgentService"),e.$km=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let L=1/0;for(let $=0;$<this.maxSampleCount;$++){const E=await f.getRoundTripTime();if(E===void 0)return;L=Math.min(L,E/2),await(0,F.$Hg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce(($,E)=>$+E,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce(($,E)=>$+E,0)/this.average.length,high:(()=>typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[345],De([1,0,32,17,16,12,24,2,5,258,43,147,344]),function($e,e,C,F,f,L,R,$,E,p,A,I,w){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$DJ=e.$CJ=void 0,e.$CJ=(0,E.$Bh)("pathService");let D=k=class{constructor(o,s,n,l){this.d=o,this.e=s,this.f=n,this.g=l,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??o})()}hasValidBasename(o,s,n){return typeof s=="string"||typeof s>"u"?this.a.then(l=>this.h(o,l,s)):this.h(o,s,n)}h(o,s,n){return o.scheme===F.Schemas.file||o.scheme===F.Schemas.vscodeRemote?(0,C.$Gf)(n??(0,R.$fg)(o),s===1):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return F.Schemas.vscodeRemote;const n=(0,p.$zJ)(s.getWorkspace());if(n)return n;const l=s.getWorkspace().folders[0];if(l)return l.uri.scheme;const b=s.getWorkspace().configuration;return b?b.scheme:F.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?f.$5d:f.$6d)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const l=o.indexOf("/",2);l===-1?(s=o.substring(2),o="/"):(s=o.substring(2,l),o=o.substring(l)||"/")}return $.URI.from({scheme:F.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$DJ=D,e.$DJ=D=k=Ke([Be(1,w.$jm),Be(2,I.$lJ),Be(3,A.$Kh)],D)}),define(Se[346],De([1,0,225,19,57,4,51,3,2,49,230,14,66,260,86,43,147,27,21,18,23,41]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.OnPortForward=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.TunnelSource=e.TunnelCloseReason=e.$oJ=e.$nJ=e.$mJ=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$mJ="onTunnel",e.$nJ=new h.$2i("forwardedPortsViewEnabled",!1,C.localize(0,null));function a(O){const N=O.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(N)return{host:N[1]?.substring(0,N[1].length-1)||"localhost",port:Number(N[2])}}e.$oJ=a;var i;(function(O){O.Other="Other",O.User="User",O.AutoForwardEnd="AutoForwardEnd"})(i||(e.TunnelCloseReason=i={}));var c;(function(O){O[O.User=0]="User",O[O.Auto=1]="Auto",O[O.Extension=2]="Extension"})(c||(e.TunnelSource=c={})),e.$pJ={source:c.User,description:C.localize(1,null)},e.$qJ={source:c.Auto,description:C.localize(2,null)};function d(O,N,M){const j=O.get(S(N,M));if(j)return j;if((0,D.$5u)(N))for(const z of D.$4u){const T=S(z,M);if(O.has(T))return O.get(T)}else if((0,D.$7u)(N))for(const z of D.$6u){const T=S(z,M);if(O.has(T))return O.get(T)}}e.$rJ=d;function y(O,N,M){const j=d(O,N,M);if(j)return j;const z=(0,D.$7u)(N)?"localhost":(0,D.$5u)(N)?"0.0.0.0":void 0;if(z)return d(O,z,M)}e.$sJ=y;function S(O,N){return O+":"+N}e.$tJ=S;var g;(function(O){O.Notify="notify",O.OpenBrowser="openBrowser",O.OpenBrowserOnce="openBrowserOnce",O.OpenPreview="openPreview",O.Silent="silent",O.Ignore="ignore"})(g||(e.OnPortForward=g={}));function u(O){return O&&"host"in O&&typeof O.host=="string"&&"port"in O&&typeof O.port=="number"&&(!("detail"in O)||typeof O.detail=="string")&&(!("pid"in O)||typeof O.pid=="string")}e.$uJ=u;class m extends $.$kc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(N){super(),this.r=N,this.j=[],this.n=new L.$fd,this.onDidChangeAttributes=this.n.event,this.B(N.onDidChangeConfiguration(M=>{(M.affectsConfiguration(m.c)||M.affectsConfiguration(m.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(N,M,j){let z=this.w(N,M,j,this.j,0);const T={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;z>=0;){const H=this.j[z];H.key===N?(T.onAutoForward=H.onAutoForward??T.onAutoForward,T.elevateIfNeeded=H.elevateIfNeeded!==void 0?H.elevateIfNeeded:T.elevateIfNeeded,T.label=H.label??T.label,T.requireLocalPort=H.requireLocalPort,T.protocol=H.protocol):(T.onAutoForward=T.onAutoForward??H.onAutoForward,T.elevateIfNeeded=T.elevateIfNeeded!==void 0?T.elevateIfNeeded:H.elevateIfNeeded,T.label=T.label??H.label,T.requireLocalPort=T.requireLocalPort!==void 0?T.requireLocalPort:void 0,T.protocol=T.protocol??H.protocol),z=this.w(N,M,j,this.j,z+1)}return T.onAutoForward!==void 0||T.elevateIfNeeded!==void 0||T.label!==void 0||T.requireLocalPort!==void 0||T.protocol!==void 0?T:this.C()}t(N){return N.start!==void 0&&N.end!==void 0}u(N){return N.host!==void 0&&N.port!==void 0&&(0,l.$jf)(N.host)&&(0,l.$nf)(N.port)}w(N,M,j,z,T){if(T>=z.length)return-1;const H=!(0,D.$5u)(M)&&!(0,D.$7u)(M),me=z.slice(T).findIndex(Z=>(0,l.$nf)(Z.key)?H?!1:Z.key===N:this.t(Z.key)?H?!1:N>=Z.key.start&&N<=Z.key.end:this.u(Z.key)?N===Z.key.port&&M===Z.key.host:j?Z.key.test(j):!1);return me>=0?me+T:-1}y(){const N=this.r.getValue(m.c);if(!N||!(0,l.$lf)(N))return[];const M=[];for(const z in N){if(z===void 0)continue;const T=N[z];let H;if(Number(z))H=Number(z);else if((0,l.$jf)(z))if(m.g.test(z)){const q=z.match(m.g);H={start:Number(q[1]),end:Number(q[2])}}else if(m.h.test(z)){const q=z.match(m.h);H={host:q[1],port:Number(q[2])}}else{let q;try{q=RegExp(z)}catch{}q&&(H=q)}H&&M.push({key:H,elevateIfNeeded:T.elevateIfNeeded,onAutoForward:T.onAutoForward,label:T.label,requireLocalPort:T.requireLocalPort,protocol:T.protocol})}const j=this.r.getValue(m.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(M)}z(N){function M(j,z){return(0,l.$nf)(j.key)?j.key:z.t(j.key)?j.key.start:z.u(j.key)?j.key.port:Number.MAX_VALUE}return N.sort((j,z)=>M(j,this)-M(z,this))}C(){return this.m}static providedActionToAction(N){switch(N){case D.ProvidedOnAutoForward.Notify:return g.Notify;case D.ProvidedOnAutoForward.OpenBrowser:return g.OpenBrowser;case D.ProvidedOnAutoForward.OpenBrowserOnce:return g.OpenBrowserOnce;case D.ProvidedOnAutoForward.OpenPreview:return g.OpenPreview;case D.ProvidedOnAutoForward.Silent:return g.Silent;case D.ProvidedOnAutoForward.Ignore:return g.Ignore;default:return}}async addAttributes(N,M,j){const T=this.r.inspect(m.c).userRemoteValue;let H;!T||!(0,l.$lf)(T)?H={}:H=(0,b.$Vm)(T),H[`${N}`]||(H[`${N}`]={});for(const q in M)H[`${N}`][q]=M[q];return this.r.updateValue(m.c,H,j)}}e.$vJ=m;let P=class extends $.$kc{constructor(N,M,j,z,T,H,q,me,Z,X){super(),this.H=N,this.I=M,this.J=j,this.L=z,this.M=T,this.N=H,this.O=q,this.P=me,this.Q=Z,this.R=X,this.c=new Map,this.g=new L.$fd,this.onForwardPort=this.g.event,this.h=new L.$fd,this.onClosePort=this.h.event,this.j=new L.$fd,this.onPortName=this.j.event,this.n=new L.$fd,this.onCandidatesChanged=this.n.event,this.t=new L.$fd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$fd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new m(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async V=>{const x=await this.getAttributes(V.map(ge=>({port:ge.tunnelRemotePort,host:ge.tunnelRemoteHost})));for(const ge of V)if(ge.localAddress){const ue=S(ge.tunnelRemoteHost,ge.tunnelRemotePort),ve=y(this.m??new Map,ge.tunnelRemoteHost,ge.tunnelRemotePort);this.forwarded.set(ue,{remotePort:ge.tunnelRemotePort,remoteHost:ge.tunnelRemoteHost,localAddress:ge.localAddress,protocol:x?.get(ge.tunnelRemotePort)?.protocol??D.TunnelProtocol.Http,localUri:await this.X(ge.localAddress,x?.get(ge.tunnelRemotePort)),localPort:ge.tunnelLocalPort,runningProcess:ve?.detail,hasRunningProcess:!!ve,pid:ve?.pid,privacy:ge.privacy,source:e.$pJ}),this.f.set(ue,ge)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async V=>{const x=S(V.tunnelRemoteHost,V.tunnelRemotePort);if(!y(this.forwarded,V.tunnelRemoteHost,V.tunnelRemotePort)&&!y(this.detected,V.tunnelRemoteHost,V.tunnelRemotePort)&&!y(this.c,V.tunnelRemoteHost,V.tunnelRemotePort)&&V.localAddress){const ge=y(this.m??new Map,V.tunnelRemoteHost,V.tunnelRemotePort),ue=(await this.getAttributes([{port:V.tunnelRemotePort,host:V.tunnelRemoteHost}]))?.get(V.tunnelRemotePort);this.forwarded.set(x,{remoteHost:V.tunnelRemoteHost,remotePort:V.tunnelRemotePort,localAddress:V.localAddress,protocol:ue?.protocol??D.TunnelProtocol.Http,localUri:await this.X(V.localAddress,ue),localPort:V.tunnelLocalPort,closeable:!0,runningProcess:ge?.detail,hasRunningProcess:!!ge,pid:ge?.pid,privacy:V.privacy,source:e.$pJ})}await this.$(),this.f.set(x,V),this.g.fire(this.forwarded.get(x))})),this.B(this.H.onTunnelClosed(V=>this.W(V,i.Other))),this.U()}S(){return this.Q.extensions.find(N=>N.activationEvents?.includes(e.$mJ))?(this.R.createKey(e.$nJ.key,!0),!0):!1}U(){if(this.S())return;const N=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&N.dispose()}))}async W(N,M){const j=S(N.host,N.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(N))}X(N,M){if(N.startsWith("http"))return E.URI.parse(N);const j=M?.protocol??"http";return E.URI.parse(`${j}://${N}`)}async Y(){const N=this.N.getWorkspace(),M=N.configuration?(0,R.$pi)(N.configuration.path):N.folders.length>0?(0,R.$pi)(N.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${M}`}async Z(){const N=this.I.get(r,1);if(N)return this.I.remove(r,1),await this.$(),N;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const N=await this.s;if(N&&N!==this.y){const M=JSON.parse(N)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(j=>j.remotePort).join(", ")}`);for(const j of M){const z=y(this.detected,j.remoteHost,j.remotePort);j.source.source!==c.Extension&&!z||j.source.source===c.Extension&&z?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===c.Extension&&!z&&this.D.set(S(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const N=await this.Y();this.w=this.B(new $.$jc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===N&&(this.s=Promise.resolve(this.I.get(N,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const N=JSON.stringify(Array.from(this.forwarded.values()));if(N!==this.y){this.y=N;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(N,M,j){if(!N.tunnelLocalPort||!j?.requireLocalPort||N.tunnelLocalPort===M)return;const z=new Date;if(this.ab.getTime()+t>z.getTime())return;this.ab=z;const T=C.localize(3,null,M,N.tunnelRemotePort,N.tunnelLocalPort);return this.P.info(T)}async forward(N,M){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(N,M)}async cb(N,M){await this.Q.activateByEvent(e.$mJ);const j=y(this.forwarded,N.remote.host,N.remote.port);M=M??(M!==null?(await this.getAttributes([N.remote]))?.get(N.remote.port):void 0);const z=N.local!==void 0?N.local:N.remote.port;let T;if(j)return this.eb(j,N,M);{const H=this.L.remoteAuthority,q=H?{getAddress:async()=>(await this.M.resolveAuthority(H)).authority}:void 0,me=S(N.remote.host,N.remote.port);this.c.set(me,!0),N=this.db(me,N);const Z=await this.H.openTunnel(q,N.remote.host,N.remote.port,void 0,z,N.elevateIfNeeded?N.elevateIfNeeded:M?.elevateIfNeeded,N.privacy,M?.protocol);if(typeof Z=="string")T=Z;else if(Z&&Z.localAddress){const X=y(this.m??new Map,N.remote.host,N.remote.port),V=Z.protocol?Z.protocol===D.TunnelProtocol.Https?D.TunnelProtocol.Https:D.TunnelProtocol.Http:M?.protocol??D.TunnelProtocol.Http,x={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:M?.label??N.name,closeable:!0,localAddress:Z.localAddress,protocol:V,localUri:await this.X(Z.localAddress,M),runningProcess:X?.detail,hasRunningProcess:!!X,pid:X?.pid,source:N.source??e.$pJ,privacy:Z.privacy};return this.forwarded.set(me,x),this.f.set(me,Z),this.c.delete(me),await this.$(),await this.bb(Z,z,M),this.g.fire(x),Z}this.c.delete(me)}return T}db(N,M){const j=this.D.has(N)?this.D:this.F.has(N)?this.F:void 0;if(j){const z=j.get(N);j.delete(N),z&&(M.name=z.name??M.name,M.local=("local"in z?z.local:"localPort"in z?z.localPort:void 0)??M.local,M.privacy=z.privacy??M.privacy)}return M}async eb(N,M,j){const z=j?.label??M.name;let T;(function(q){q[q.None=0]="None",q[q.Fire=1]="Fire",q[q.Reopen=2]="Reopen"})(T||(T={}));let H=T.None;switch(z!==N.name&&(N.name=z,H=T.Fire),(j?.protocol||N.protocol!==D.TunnelProtocol.Http)&&j?.protocol!==N.protocol&&(M.source=N.source,H=T.Reopen),M.privacy&&N.privacy!==M.privacy&&(H=T.Reopen),H){case T.Fire:{this.g.fire();break}case T.Reopen:await this.close(N.remoteHost,N.remotePort,i.User),await this.cb(M,j)}return y(this.f,M.remote.host,M.remote.port)}async name(N,M,j){const z=y(this.forwarded,N,M),T=S(N,M);if(z){z.name=j,await this.$(),this.j.fire({host:N,port:M});return}else this.detected.has(T)&&(this.detected.get(T).name=j,this.j.fire({host:N,port:M}))}async close(N,M,j){const z=S(N,M),T=this.forwarded.get(z);return j===i.AutoForwardEnd&&T&&T.source.source===c.Auto&&this.F.set(z,{local:T.localPort,name:T.name,privacy:T.privacy}),await this.H.closeTunnel(N,M),this.W({host:N,port:M},j)}address(N,M){const j=S(N,M);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(N){if(N)for(const M of N){const j=y(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),z=typeof M.localAddress=="string"?M.localAddress:S(M.localAddress.host,M.localAddress.port);this.detected.set(S(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:z,protocol:D.TunnelProtocol.Http,localUri:this.X(z),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:D.TunnelPrivacyId.ConstantPrivate,source:{source:c.Extension,description:C.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,z,D.TunnelPrivacyId.ConstantPrivate,D.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(N){this.r=N}async setCandidates(N){let M=N;this.r&&(M=await this.r(N));const j=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(z=>z.port).join(", ")}`),this.n.fire(j)}fb(N){const M=this.m??new Map,j=new Map;return this.m=j,N.forEach(z=>{const T=S(z.host,z.port);j.set(T,{host:z.host,port:z.port,detail:z.detail,pid:z.pid}),M.has(T)&&M.delete(T);const H=y(this.forwarded,z.host,z.port);H&&(H.runningProcess=z.detail,H.hasRunningProcess=!0,H.pid=z.pid)}),M.forEach((z,T)=>{const H=a(T);if(!H)return;const q=y(this.forwarded,H.host,H.port);q&&(q.runningProcess=void 0,q.hasRunningProcess=!1,q.pid=void 0);const me=y(this.detected,H.host,H.port);me&&(me.runningProcess=void 0,me.hasRunningProcess=!1,me.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const N=Array.from(this.forwarded.values()),M=await this.getAttributes(N.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(M)for(const j of N){const z=M.get(j.remotePort);(z?.protocol||j.protocol!==D.TunnelProtocol.Http)&&z?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},z),z&&z.label&&z.label!==j.name&&await this.name(j.remoteHost,j.remotePort,z.label)}}async getAttributes(N,M=!0){const j=new Map,z=new Map;N.forEach(Z=>{const X=y(this.m??new Map,D.$4u[0],Z.port)??Z;if(X){j.set(Z.port,X);const V=u(X)?X.pid:void 0;z.has(V)||z.set(V,[]),z.get(V)?.push(Z.port)}});const T=new Map;if(N.forEach(Z=>{const X=this.configPortsAttributes.getAttributes(Z.port,Z.host,j.get(Z.port)?.detail);X&&T.set(Z.port,X)}),this.G.length===0||!M)return T.size>0?T:void 0;const H=await Promise.all((0,F.$Pb)(this.G.map(Z=>Array.from(z.entries()).map(X=>{const V=X[1],x=j.get(V[0]);return Z.providePortAttributes(V,x?.pid,x?.detail,new n.$pd().token)})))),q=new Map;if(H.forEach(Z=>Z.forEach(X=>{X&&q.set(X.port,X)})),!T&&!q)return;const me=new Map;return N.forEach(Z=>{const X=T.get(Z.port),V=q.get(Z.port);me.set(Z.port,{elevateIfNeeded:X?.elevateIfNeeded,label:X?.label,onAutoForward:X?.onAutoForward??m.providedActionToAction(V?.autoForwardAction),requireLocalPort:X?.requireLocalPort,protocol:X?.protocol})}),me}addAttributesProvider(N){this.G.push(N)}};e.$wJ=P,Ke([(0,f.$7g)(1e3)],P.prototype,"$",null),e.$wJ=P=Ke([Be(0,D.$Zu),Be(1,k.$Vo),Be(2,p.$8h),Be(3,o.$lJ),Be(4,w.$Jk),Be(5,v.$Kh),Be(6,I.$5i),Be(7,A.$rv),Be(8,s.$UE),Be(9,h.$3i)],P)}),define(Se[93],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$lI=e.$kI=void 0;class C{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new C(0,0)}with(R){return new C(0,0)}}e.$kI=C;class F{constructor(R,$,E,p){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(R,$),this.end=new C(E,p)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.$lI=F;var f;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(Se[36],De([1,0,19,35,23,32,15,5,16,8,93,9]),function($e,e,C,F,f,L,R,$,E,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.SearchErrorCode=e.$AI=e.$zI=e.SearchSortOrder=e.ViewMode=e.$yI=e.$xI=e.$wI=e.$vI=e.SearchCompletionExitCode=e.$uI=e.$tI=e.$sI=e.QueryType=e.SearchProviderType=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$mI="workbench.view.search",e.$nI="workbench.panel.search",e.$oI="workbench.view.search",e.$pI="search-result",e.$qI="search.exclude";const w="\u27EA ",k=" characters skipped \u27EB",D=(w.length+k.length+5)*2;e.$rI=(0,$.$Bh)("searchService");var v;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(v||(e.SearchProviderType=v={}));var o;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(o||(e.QueryType=o={}));function s(V){return!!V.preview}e.$sI=s;function n(V){return!!V.resource}e.$tI=n;function l(V){return!!V.message}e.$uI=l;var b;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})(b||(e.SearchCompletionExitCode=b={}));class h{constructor(x){this.resource=x,this.results=[]}}e.$vI=h;class t{constructor(x,ge,ue,ve){this.ranges=ge,this.webviewIndex=ve;const G=Array.isArray(ge)?ge:[ge];if(ue&&ue.matchLines===1&&r(G)){x=(0,R.$cf)(x,ue.matchLines);let U="",K=0,fe=0;const te=Math.floor(ue.charsPerLine/5),se=[];for(const ne of G){const Ee=Math.max(ne.startColumn-te,0),oe=ne.startColumn+ue.charsPerLine;if(Ee>fe+te+D){const he=w+(Ee-fe)+k;U+=he+x.slice(Ee,oe),K+=Ee-(fe+he.length)}else U+=x.slice(fe,oe);se.push(new i(0,ne.startColumn-K,ne.endColumn-K)),fe=oe}this.preview={text:U,matches:Array.isArray(this.ranges)?se:se[0]}}else{const U=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:x,matches:(0,C.$Zb)(ge,K=>new a(K.startLineNumber-U,K.startColumn,K.endLineNumber-U,K.endColumn))}}}}e.$wI=t;function r(V){const x=V[0].startLineNumber;for(const ge of V)if(ge.startLineNumber!==x||ge.endLineNumber!==x)return!1;return!0}class a{constructor(x,ge,ue,ve){this.startLineNumber=x,this.startColumn=ge,this.endLineNumber=ue,this.endColumn=ve}}e.$xI=a;class i extends a{constructor(x,ge,ue){super(x,ge,x,ue)}}e.$yI=i;var c;(function(V){V.List="list",V.Tree="tree"})(c||(e.ViewMode=c={}));var d;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function y(V,x=!0){const ge=V&&V.files&&V.files.exclude,ue=x&&V&&V.search&&V.search.exclude;if(!ge&&!ue)return;if(!ge||!ue)return ge||ue;let ve=Object.create(null);return ve=f.$Ym(ve,f.$Vm(ge)),ve=f.$Ym(ve,f.$Vm(ue),!0),ve}e.$zI=y;function S(V,x){return V.excludePattern&&F.$qj(V.excludePattern,x)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&F.$qj(V.includePattern,x)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(ge=>{const ue=ge.folder.fsPath;if(L.$If(x,ue)){const ve=E.$$d(ue,x);return!ge.includePattern||!!F.$qj(ge.includePattern,ve)}else return!1}):!1:!0}e.$AI=S;var g;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class u extends Error{constructor(x,ge){super(x),this.code=ge}}e.$BI=u;function m(V){const x=V.message;if((0,p.$2)(V))return new u(x,g.canceled);try{const ge=JSON.parse(x);return new u(ge.message,ge.code)}catch{return new u(x,g.other)}}e.$CI=m;function P(V){const x={message:V.message,code:V.code};return new Error(JSON.stringify(x))}e.$DI=P;function O(V){return V.type==="error"?!0:V.type==="success"}e.$EI=O;function N(V){return V.type==="success"}e.$FI=N;function M(V){return!!V.path}e.$GI=M;function j(V,x){const ge=V.searchPath?V.searchPath:V.relativePath;return(0,R.$_e)(ge,x)}e.$HI=j;class z{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$II=z;function T(V,x){const ge={...V||{},...x||{}};return Object.keys(ge).filter(ue=>{const ve=ge[ue];return typeof ve=="boolean"&&ve})}e.$JI=T;class H{constructor(x,ge){this.c=null,this.a={...x.excludePattern||{},...ge.excludePattern||{}},this.b=F.$rj(this.a);let ue=x.includePattern;ge.includePattern&&(ue?ue={...ue,...ge.includePattern}:ue=ge.includePattern),ue&&(this.c=F.$rj(ue))}matchesExcludesSync(x,ge,ue){return!!(this.b&&this.b(x,ge,ue))}includedInQuerySync(x,ge,ue){return!(this.b&&this.b(x,ge,ue)||this.c&&!this.c(x,ge,ue))}includedInQuery(x,ge,ue){const ve=this.b(x,ge,ue),G=()=>this.c?!!this.c(x,ge,ue):!0;return(0,I.$tg)(ve)?ve.then(U=>U?!1:G()):G()}hasSiblingExcludeClauses(){return q(this.a)}}e.$KI=H;function q(V){for(const x in V)if(typeof V[x]!="boolean")return!0;return!1}function me(V){if(!V)return;let x;return ge=>(x||(x=(V()||Promise.resolve([])).then(ue=>ue?X(ue):{})),x.then(ue=>!!ue[ge]))}e.$LI=me;function Z(V){if(!V)return;let x;return ge=>{if(!x){const ue=V();x=ue?X(ue):{}}return!!x[ge]}}e.$MI=Z;function X(V){const x={};for(const ge of V)x[ge]=!0;return x}}),define(Se[39],De([1,0,19,9,21,4,3,78,17,120,24,15,2,214,5,14,243,43,54,26,20,13,7,68,36,6]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b,h,t,r,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=e.$kbc=void 0;function c(O,N,M){return new A.$0f(j=>g(j,M)).isEqual(O,N)}function d(O,N,M){return c(O.uri,N.uri,M)?0:(0,I.$Fe)(O.uri.toString(),N.uri.toString())}function y(O,N,M){return O.index!==N.index?O.index<N.index?-1:1:c(O.uri,N.uri,M)?(0,I.$Fe)(O.name,N.name):(0,I.$Fe)(O.uri.toString(),N.uri.toString())}function S(O,N,M,j){const z=O.slice(0).sort((H,q)=>M(H,q,j)),T=N.slice(0).sort((H,q)=>M(H,q,j));return(0,C.$Cb)(z,T,(H,q)=>M(H,q,j))}function g(O,N){const M=N.getCapabilities(O.scheme);return!(M&&M&1024)}class u extends s.$Uh{static toExtHostWorkspace(N,M,j,z){if(!N)return{workspace:null,added:[],removed:[]};const{id:T,name:H,folders:q,configuration:me,transient:Z,isUntitled:X}=N,V=[],x=M;M?q.forEach((G,U)=>{const K=w.URI.revive(G.uri),fe=u.o(j||M,K,z);fe?(fe.name=G.name,fe.index=G.index,V.push(fe)):V.push({uri:K,name:G.name,index:U})}):V.push(...q.map(({uri:G,name:U,index:K})=>({uri:w.URI.revive(G),name:U,index:K}))),V.sort((G,U)=>G.index<U.index?-1:1);const ge=new u(T,H,V,!!Z,me?w.URI.revive(me):null,!!X,G=>g(G,z)),{added:ue,removed:ve}=S(x?x.workspaceFolders:[],ge.workspaceFolders,d,z);return{workspace:ge,added:ue,removed:ve}}static o(N,M,j){for(let z=0;z<N.folders.length;z++){const T=N.workspaceFolders[z];if(c(T.uri,M,j))return T}}constructor(N,M,j,z,T,H,q){super(N,j.map(me=>new s.$Vh(me)),z,T,q),this.t=M,this.u=H,this.q=[],this.s=$.$Hh.forUris(q),j.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(N,M){return M&&this.s.get(N)&&(N=(0,A.$hg)(N)),this.s.findSubstr(N)}resolveWorkspaceFolder(N){return this.s.get(N)}}let m=class{constructor(N,M,j,z,T){this.c=new L.$fd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$fd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$hd,this.B=new Map,this.h=z,this.s=j,this.t=T,this.j=new p.$Jl,this.k=new F.$Fg,this.o=N.getProxy(i.$1J.MainThreadWorkspace),this.q=N.getProxy(i.$1J.MainThreadMessageService);const H=M.workspace;this.l=H?new u(H.id,H.name,[],!!H.transient,H.configuration?w.URI.revive(H.configuration):null,!!H.isUntitled,q=>g(q,j)):void 0}$initializeWorkspace(N,M){this.v=M,this.$acceptWorkspaceData(N),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?w.URI.from({scheme:E.Schemas.untitled,path:(0,A.$fg)((0,A.$hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(N,M,j,...z){const T=[];if(Array.isArray(z)&&z.forEach(X=>{w.URI.isUri(X.uri)&&!T.some(V=>c(V.uri,X.uri,this.s))&&T.push({uri:X.uri,name:X.name||(0,A.$eg)(X.uri)})}),this.n||[M,j].some(X=>typeof X!="number"||X<0)||j===0&&T.length===0)return!1;const H=this.x?this.x.workspaceFolders:[];if(M+j>H.length)return!1;const q=H.slice(0);q.splice(M,j,...T.map(X=>({uri:X.uri,name:X.name||(0,A.$eg)(X.uri),index:void 0})));for(let X=0;X<q.length;X++){const V=q[X];if(q.some((x,ge)=>ge!==X&&c(V.uri,x.uri,this.s)))return!1}q.forEach((X,V)=>X.index=V);const{added:me,removed:Z}=S(H,q,y,this.s);if(me.length===0&&Z.length===0)return!1;if(this.o){const X=N.displayName||N.name;this.o.$updateWorkspaceFolders(X,M,j,T).then(void 0,V=>{this.n=void 0;const x={source:{identifier:N.identifier,label:N.displayName||N.name}};this.q.$showMessage(o.Severity.Error,(0,k.localize)(0,null,X,V.toString()),x,[])})}return this.y(q),!0}getWorkspaceFolder(N,M){if(this.x)return this.x.getWorkspaceFolder(N,M)}async getWorkspaceFolder2(N,M){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(N,M)}async resolveWorkspaceFolder(N){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(N)}getPath(){if(!this.x)return;const{folders:N}=this.x;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,M){let j,z="";if(typeof N=="string"?(j=w.URI.file(N),z=N):typeof N<"u"&&(j=N,z=N.fsPath),!j)return z;const T=this.getWorkspaceFolder(j,!0);if(!T)return z;typeof M>"u"&&this.x&&(M=this.x.folders.length>1);let H=(0,A.$kg)(T.uri,j);return M&&T.name&&(H=`${T.name}/${H}`),H}y(N){this.x&&(this.n=u.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:N,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:M,added:j,removed:z}=u.toExtHostWorkspace(N,this.l,this.n,this.s);this.l=M||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:z}))}findFiles(N,M,j,z,T=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let H;if(M===null?H=!1:M&&(typeof M=="string"?H=M:H=M.pattern),T&&T.isCancellationRequested)return Promise.resolve([]);const{includePattern:q,folder:me}=P(h.GlobPattern.from(N));return this.o.$startFileSearch(q??null,me??null,H??null,j??null,T).then(Z=>Array.isArray(Z)?Z.map(X=>w.URI.revive(X)):[])}async findTextInFiles(N,M,j,z,T=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const H=this.j.getNext(),q=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:me,folder:Z}=P(h.GlobPattern.from(M.include)),X=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,V={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:q,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:me,excludePattern:X},x=!1;if(this.u[H]=ge=>{if(x)return;const ue=w.URI.revive(ge.resource);ge.results.forEach(ve=>{(0,a.$sI)(ve)?j({uri:ue,preview:{text:ve.preview.text,matches:(0,C.$Zb)(ve.preview.matches,G=>new t.$5J(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))},ranges:(0,C.$Zb)(ve.ranges,G=>new t.$5J(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))}):j({uri:ue,text:ve.text,lineNumber:ve.lineNumber})})},T.isCancellationRequested)return{};try{const ge=await this.o.$startTextSearch(N,Z??null,V,H,T);return delete this.u[H],ge||{}}catch(ge){throw delete this.u[H],ge}}$handleTextSearchResult(N,M){this.u[M]?.(N)}async save(N){const M=await this.o.$save(N,{saveAs:!1});return w.URI.revive(M)}async saveAs(N){const M=await this.o.$save(N,{saveAs:!0});return w.URI.revive(M)}saveAll(N){return this.o.$saveAll(N)}resolveProxy(N){return this.o.$resolveProxy(N)}get trusted(){return this.v}requestWorkspaceTrust(N){return this.o.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(N,M){if(this.w.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.w.set(N,M);const j=this.t.transformOutgoingScheme(N),z=this.z++;return this.o.$registerEditSessionIdentityProvider(z,j),(0,R.$ic)(()=>{this.w.delete(N),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(N,M){this.h.info("Getting edit session identifier for workspaceFolder",N);const j=await this.resolveWorkspaceFolder(w.URI.revive(N));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const z=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!z),!z)return;const T=await z.provideEditSessionIdentity(j,M);if(this.h.info("Provider returned edit session identifier: ",T),!!T)return T}async $provideEditSessionIdentityMatch(N,M,j,z){this.h.info("Getting edit session identifier for workspaceFolder",N);const T=await this.resolveWorkspaceFolder(w.URI.revive(N));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const H=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!H),!H)return;const q=await H.provideEditSessionIdentityMatch?.(M,j,z);if(this.h.info("Provider returned edit session identifier match result: ",q),!!q)return q}getOnWillCreateEditSessionIdentityEvent(N){return(M,j,z)=>{const T=function(q){M.call(j,q)};return T.extension=N,this.A.event(T,void 0,z)}}async $onWillCreateEditSessionIdentity(N,M,j){const z=await this.resolveWorkspaceFolder(w.URI.revive(N));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:z},M,async(T,H)=>{const q=Date.now();await Promise.resolve(T),Date.now()-q>j&&this.h.warn("SLOW edit session create-participant",H.extension.identifier)}),M.isCancellationRequested}registerCanonicalUriProvider(N,M){if(this.B.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.B.set(N,M);const j=this.t.transformOutgoingScheme(N),z=this.z++;return this.o.$registerCanonicalUriProvider(z,j),(0,R.$ic)(()=>{this.B.delete(N),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(N,M,j){const z=this.B.get(N.scheme);if(!z)return;const T=await z.provideCanonicalUri?.(w.URI.revive(N),M,j);if(T)return T}async $provideCanonicalUri(N,M,j){return this.provideCanonicalUri(w.URI.revive(N),{targetScheme:M},j)}};e.$kbc=m,e.$kbc=m=Ke([Be(0,b.$2L),Be(1,l.$fM),Be(2,n.$$ac),Be(3,v.$5i),Be(4,r.$ibc)],m),e.$lbc=(0,D.$Bh)("IExtHostWorkspace");function P(O){let N,M;return O&&(typeof O=="string"?N=O:(N=O.pattern,M=w.URI.revive(O.baseUri))),{includePattern:N,folder:M}}}),define(Se[40],De([1,0,23,4,39,6,7,245,136,18,9,5,20,14,2]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=e.$nbc=e.$mbc=void 0;function v(r,a){if(a){const i=a.split(".");let c=r;for(let d=0;c&&d<i.length;d++)c=c[i[d]];return c}}function o(r){return r instanceof D.URI}function s(r){return r&&r.uri instanceof D.URI&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function l(r){return r&&r.uri instanceof D.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function b(r){if(o(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(n(r))return{overrideIdentifier:r.languageId};if(l(r))return{resource:r.uri};if(r===null)return{resource:null}}let h=class{constructor(a,i,c){this.a=a.getProxy(L.$1J.MainThreadConfiguration),this.c=i,this.b=c,this.d=new A.$Fg,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,i))}};e.$mbc=h,e.$mbc=h=Ke([Be(0,w.$2L),Be(1,f.$lbc),Be(2,k.$5i)],h);class t{constructor(a,i,c,d){this.a=new F.$fd,this.b=a,this.f=d,this.c=i,this.e=$.$tn.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,i){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$tn.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(i,c))}getConfiguration(a,i,c){const d=b(i)||{},y=this.g(a?v(this.e.getValue(void 0,d,this.c.workspace),a):this.e.getValue(void 0,d,this.c.workspace));a&&this.h(a,d,c?.identifier);function S(u){if(u==null)return null;if(typeof u=="boolean")return u?2:5;switch(u){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(u){return typeof v(y,u)<"u"},get:(u,m)=>{this.h(a?`${a}.${u}`:u,d,c?.identifier);let P=v(y,u);if(typeof P>"u")P=m;else{let O;const N=(M,j)=>{if((0,p.$lf)(M)){let z;const T=()=>{O=O||(0,C.$Vm)(y),z=z||v(O,j)};return new Proxy(M,{get:(H,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return T(),()=>z;if(O)return z=z||v(O,j),z[q];const me=H[q];return typeof q=="string"?N(me,`${j}.${q}`):me},set:(H,q,me)=>(T(),z&&(z[q]=me),!0),deleteProperty:(H,q)=>(T(),z&&delete z[q],!0),defineProperty:(H,q,me)=>(T(),z&&Object.defineProperty(z,q,me),!0)})}return Array.isArray(M)?(0,C.$Vm)(M):M};P=N(P,u)}return P},update:(u,m,P,O)=>{u=a?`${a}.${u}`:u;const N=S(P);return m!==void 0?this.b.$updateConfigurationOption(N,u,m,d,O):this.b.$removeConfigurationOption(N,u,d,O)},inspect:u=>{u=a?`${a}.${u}`:u;const m=this.e.inspect(u,d,this.c.workspace);if(m)return{key:u,defaultValue:(0,C.$Vm)(m.policy?.value??m.default?.value),globalValue:(0,C.$Vm)(m.user?.value??m.application?.value),workspaceValue:(0,C.$Vm)(m.workspace?.value),workspaceFolderValue:(0,C.$Vm)(m.workspaceFolder?.value),defaultLanguageValue:(0,C.$Vm)(m.default?.override),globalLanguageValue:(0,C.$Vm)(m.user?.override??m.application?.override),workspaceLanguageValue:(0,C.$Vm)(m.workspace?.override),workspaceFolderLanguageValue:(0,C.$Vm)(m.workspaceFolder?.override),languageIds:(0,C.$Vm)(m.overrideIdentifiers)}}};return typeof y=="object"&&(0,C.$Ym)(g,y,!1),Object.freeze(g)}g(a){const i=c=>(0,p.$lf)(c)?new Proxy(c,{get:(d,y)=>i(d[y]),set:(d,y,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(d,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(d,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(a)}h(a,i,c){const d=E.$kn.test(a)?4:this.d.get(a),y=c?`[${c.value}] `:"";if(d===4){typeof i?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){i?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,i){const c=new $.$vn(a,i,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,y)=>c.affectsConfiguration(d,b(y))})}k(a){return a.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.$nbc=t,e.$obc=(0,I.$Bh)("IExtHostConfiguration")}),define(Se[94],De([1,0,2,9,4,6,7,39,71,40,21,44,20,26,5,17,12,14,90,291,8]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=e.$kcc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(N){function M(z){if(z!=null)return z}N.from=M;function j(z){if(z!=null)return z}N.to=j})(h||(h={}));var t;(function(N){function M(z){if(z!=null)return z}N.from=M;function j(z){if(z!=null)return z}N.to=j})(t||(t={}));var r;(function(N){function M(z){if(z!=null)return z}N.from=M;function j(z){if(z!=null)return z}N.to=j})(r||(r={}));var a;(function(N){function M(T){if(T){const H=T;return H&&!!H.process}else return!1}N.is=M;function j(T){if(T==null)return;const H={process:T.process,args:T.args};return T.options&&(H.options=r.from(T.options)),H}N.from=j;function z(T){if(T!=null)return new R.$KK(T.process,T.args,T.options)}N.to=z})(a||(a={}));var i;(function(N){function M(z){if(z!=null)return z}N.from=M;function j(z){if(z!=null)return z}N.to=j})(i||(i={}));var c;(function(N){function M(T){if(T){const H=T;return H&&(!!H.commandLine||!!H.command)}else return!1}N.is=M;function j(T){if(T==null)return;const H={};return T.commandLine!==void 0?H.commandLine=T.commandLine:(H.command=T.command,H.args=T.args),T.options&&(H.options=i.from(T.options)),H}N.from=j;function z(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new R.$LK(T.commandLine,T.options):new R.$LK(T.command,T.args?T.args:[],T.options)}N.to=z})(c||(c={}));var d;(function(N){function M(T){if(T){const H=T;return H&&H.customExecution==="customExecution"}else return!1}N.is=M;function j(T){return{customExecution:"customExecution"}}N.from=j;function z(T,H){return H.get(T)}N.to=z})(d||(e.CustomExecutionDTO=d={}));var y;(function(N){function M(j,z){let T;return j.scope!==void 0&&typeof j.scope!="number"?T=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===R.TaskScope.Workspace&&z&&z.workspaceFile?T=z.workspaceFile:T=l.$BF),{id:j._id,workspaceFolder:T}}N.from=M})(y||(e.TaskHandleDTO=y={}));var S;(function(N){function M(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}N.from=M})(S||(S={}));var g;(function(N){function M(T,H){if(T==null)return[];const q=[];for(const me of T){const Z=j(me,H);Z&&q.push(Z)}return q}N.fromMany=M;function j(T,H){if(T==null)return;let q;T.execution instanceof R.$KK?q=a.from(T.execution):T.execution instanceof R.$LK?q=c.from(T.execution):T.execution&&T.execution instanceof R.$MK&&(q=d.from(T.execution));const me=h.from(T.definition);let Z;return T.scope?typeof T.scope=="number"?Z=T.scope:Z=T.scope.uri:Z=R.TaskScope.Workspace,!me||!Z?void 0:{_id:T._id,definition:me,name:T.name,source:{extensionId:H.identifier.value,label:T.source,scope:Z},execution:q,isBackground:T.isBackground,group:S.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}N.from=j;async function z(T,H,q){if(T==null)return;let me;a.is(T.execution)?me=a.to(T.execution):c.is(T.execution)?me=c.to(T.execution):d.is(T.execution)&&(me=d.to(T._id,q));const Z=h.to(T.definition);let X;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?X=T.source.scope:X=await H.resolveWorkspaceFolder(C.URI.revive(T.source.scope)):X=R.TaskScope.Workspace),!Z||!X)return;const V=new R.$NK(Z,X,T.name,T.source.label,me,T.problemMatchers);return T.isBackground!==void 0&&(V.isBackground=T.isBackground),T.group!==void 0&&(V.group=R.$JK.from(T.group._id),V.group&&T.group.isDefault&&(V.group=new R.$JK(V.group.id,V.group.label),T.group.isDefault===!0&&(V.group.isDefault=T.group.isDefault))),T.presentationOptions&&(V.presentationOptions=t.to(T.presentationOptions)),T._id&&(V._id=T._id),T.detail&&(V.detail=T.detail),V}N.to=z})(g||(e.TaskDTO=g={}));var u;(function(N){function M(z){return z}N.from=M;function j(z){if(z)return Object.assign(Object.create(null),z)}N.to=j})(u||(u={}));class m{#e;constructor(M,j,z){this._id=j,this.a=z,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let P=class{constructor(M,j,z,T,H,q,me,Z){this.q=new f.$fd,this.r=new f.$fd,this.s=new f.$fd,this.t=new f.$fd,this.a=M.getProxy(L.$1J.MainThreadTask),this.b=z,this.c=T,this.d=H,this.e=q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=Z,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,j,z){if(!z)return new R.$3J(()=>{});const T=this.w();return this.j.set(T,{type:j,provider:z,extension:M}),this.a.$registerTaskProvider(T,j),new R.$3J(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(M,j){this.a.$registerTaskSystem(M,j)}fetchTasks(M){return this.a.$fetchTasks(u.from(M)).then(async j=>{const z=[];for(const T of j){const H=await g.to(T,this.b,this.m);H&&z.push(H)}return z})}get taskExecutions(){const M=[];return this.k.forEach(j=>M.push(j)),M}terminateTask(M){if(!(M instanceof m))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,j,z){const T=this.m.get(M.id);T&&(this.o.set(M.id,T),this.e.attachPtyToTerminal(j,await T.callback(z))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const j=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const j=await this.y(M.id);this.s.fire({execution:j,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const j=await this.y(M.id);this.t.fire({execution:j,exitCode:M.exitCode})}$provideTasks(M,j){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));const T=[],H=(0,F.$zg)(()=>z.provider.provideTasks(A.CancellationToken.None)).then(q=>this.u(j,T,z,q));return new Promise(q=>{H.then(me=>{Promise.all(T).then(()=>{q(me)})})})}async $resolveTask(M,j){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const T=await g.to(j,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const H=await z.provider.resolveTask(T,A.CancellationToken.None);if(!H)return;this.z(H,z);const q=g.from(H,z.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(q.execution)&&await this.x(q,H,!0),await this.v(q)}w(){return this.h++}async x(M,j,z){const T=await this.a.$createTaskId(M);!z&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,j.execution)),this.m.set(T,j.execution)}async y(M,j){if(typeof M=="string"){const H=this.l.get(M);if(!H)throw new b.$_("Unexpected: The specified task is missing an execution");return H}const z=this.l.get(M.id);if(z)return z;const T=new Promise((H,q)=>{function me(Z,X,V){V?H(new m(Z,X.id,V)):q("Unexpected: Task does not exist.")}j?me(this,M,j):g.to(M.task,this.b,this.m).then(Z=>me(this,M,Z))});return this.l.set(M.id,T),T.then(H=>(this.k.set(M.id,H),H),H=>Promise.reject(H))}z(M,j){M._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const z=this.n.values();let T=z.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=z.next()}};e.$kcc=P,e.$kcc=P=Ke([Be(0,w.$2L),Be(1,k.$fM),Be(2,$.$lbc),Be(3,E.$aM),Be(4,p.$obc),Be(5,I.$Gbc),Be(6,s.$5i),Be(7,n.$bbc)],P);let O=class extends P{constructor(M,j,z,T,H,q,me,Z){super(M,j,z,T,H,q,me,Z),this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(M,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=g.from(j,M);if(z===void 0)throw new Error("Task is not valid");if(d.is(z.execution))await this.x(z,j,!1);else throw new b.$0;const T=await this.y(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(H=>{throw new Error(H)}),T}u(M,j,z,T){const H=[];if(T)for(const q of T){this.z(q,z),(!q.definition||!M[q.definition.type])&&this.f.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const me=g.from(q,z.extension);me&&d.is(me.execution)?(H.push(me),j.push(this.x(me,q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:H,extension:z.extension}}async v(M){if(d.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,j,z){}};e.$lcc=O,e.$lcc=O=Ke([Be(0,w.$2L),Be(1,k.$fM),Be(2,$.$lbc),Be(3,E.$aM),Be(4,p.$obc),Be(5,I.$Gbc),Be(6,s.$5i),Be(7,n.$bbc)],O),e.$mcc=(0,D.$Bh)("IExtHostTask")}),define(Se[347],De([1,0,16,21,46,35,24,37,36]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;class p{constructor(w,k,D){this.k=w,this.l=k,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=w.filePattern,this.b=w.includePattern&&L.$rj(w.includePattern),this.c=w.maxResults||void 0,this.d=w.exists,this.h=new Set,this.j=w.excludePattern&&L.$rj(w.excludePattern)}cancel(){this.g=!0,this.h.forEach(w=>w.cancel()),this.h=new Set}search(w){const k=this.k.folderQueries||[];return new Promise((D,v)=>{const o=s=>{this.f++,w(s)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const n=s.toString(),l=C.$ae(n);this.j&&this.j(n,l)||this.v(o,{base:s,basename:l})}),Promise.all(k.map(s=>this.p(s,o))).then(s=>{D({limitHit:this.e,stats:s[0]||void 0})},s=>{v(new Error((0,f.$mi)(s)))})})}async p(w,k){const D=new F.$pd,v=this.q(w),o=this.r(),s=new E.$KI(this.k,w),n=!s.hasSiblingExcludeClauses();let l;try{this.h.add(D),l=$.$bd.create();const b=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},v,D.token),h=l.elapsed(),t=$.$bd.create();return this.g&&!this.e||(b&&b.forEach(r=>{const a=C.$6d.relative(w.folder.path,r.path);if(n){const i=C.$ae(r.path);this.v(k,{base:w.folder,relativePath:a,basename:i});return}this.s(o,w.folder,a,k)}),this.g&&!this.e)?null:(this.u(o,s,k),{providerTime:h,postProcessTime:t.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q(w){const k=(0,E.$JI)(this.k.includePattern,w.includePattern),D=(0,E.$JI)(this.k.excludePattern,w.excludePattern);return{folder:w.folder,excludes:D,includes:k,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}s({pathToEntries:w},k,D,v){if(D===this.a){const s=C.$ae(this.a);this.v(v,{base:k,relativePath:this.a,basename:s})}function o(s){const n=C.$ae(s),l=C.$_d(s);let b=w[l];b||(b=w[l]=[],o(l)),b.push({base:k,relativePath:s,basename:n})}o(D)}u({rootEntries:w,pathToEntries:k},D,v){const o=this,s=this.a;function n(l){const b=(0,E.$MI)(()=>l.map(h=>h.basename));for(let h=0,t=l.length;h<t;h++){const r=l[h],{relativePath:a,basename:i}=r;if(D.matchesExcludesSync(a,i,s!==i?b:void 0))continue;const c=k[a];if(c)n(c);else{if(a===s)continue;o.v(v,r)}if(o.e)break}}n(w)}v(w,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||w(k))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(w,k,D,v){const o=this.c(w.cacheKey),s=new p(w,k,o&&o.token);let n=0;const l=b=>{n+=b.length,D(b.map(h=>this.d(h)))};return this.e(s,A.a,l,v).then(b=>({limitHit:b.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:b.stats}}))}clearCache(w){this.c(w)?.cancel()}c(w){if(w)return this.b.has(w)||this.b.set(w,new F.$pd),this.b.get(w)}d(w){return w.relativePath?{resource:R.$ig(w.base,w.relativePath)}:{resource:w.base}}e(w,k,D,v){const o=v.onCancellationRequested(()=>{w.cancel()}),s=l=>{l&&(n.push(l),k>0&&n.length>=k&&(D(n),n=[]))};let n=[];return w.search(s).then(l=>(n.length&&D(n),o.dispose(),l),l=>(n.length&&D(n),o.dispose(),Promise.reject(l)))}}e.$wcc=A}),define(Se[348],De([1,0,19,56,35,100,28,17,16,24,15,18,2,172,226,49,14,43,143,345,36]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FJ=e.$EJ=void 0;let h=class{constructor(u,m,P,O,N){this.a=u,this.b=m,this.c=P,this.d=O,this.e=N}text(u,m,P={}){u=this.f(u,P);const O=this.a.getValue(),N=m&&m.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(m?.map(s.$Wh),P),type:2,contentPattern:u,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:O.search.usePCRE2||N||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(u,m){const P=this.a.getValue();u.isRegExp&&(u.pattern=u.pattern.replace(/\r?\n/g,"\\n"));const O={...u,wordSeparators:P.editor.wordSeparators};return this.j(u,m)&&(O.isCaseSensitive=!0),this.k(u)&&(O.isMultiline=!0),m.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=m.notebookSearchConfig.includeMarkupInput),m.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=m.notebookSearchConfig.includeMarkupPreview),m.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=m.notebookSearchConfig.includeCodeInput),m.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=m.notebookSearchConfig.includeOutput),O}file(u,m={}){return{...this.h(u,m),type:1,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey}}g(u,m){return u?(u=Array.isArray(u)?u.map(c):c(u),m?this.parseSearchPaths(u):{pattern:r(...Array.isArray(u)?u:[u])}):{}}h(u=[],m={}){const P=this.g(m.includePattern,m.expandPatterns),O=this.g(m.excludePattern,m.expandPatterns),N=u.length>1,M=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(T=>this.q(T,m,O)):u.map(T=>this.r(T,m,O,N))).filter(T=>!!T),j={_reason:m._reason,folderQueries:M,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:O.pattern,includePattern:P.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const T=C.$Fb(C.$Pb(this.c.groups.map(me=>me.editors.map(Z=>Z.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const H=T.filter(me=>(0,b.$AI)(j,me.fsPath)),q=this.i(H);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...j,...q}}const z=m.extraFileResources&&m.extraFileResources.filter(T=>(0,b.$AI)(j,T.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(u){const m=[],P=new R.$zi,O={};let N=!1;return u.forEach(M=>{if(M.scheme===$.Schemas.walkThrough)return;if((0,p.$mg)(M)){const z=this.b.getWorkspaceFolder(M)?.uri??M.with({path:E.$_d(M.fsPath)});let T=P.get(z);T||(N=!0,T={folder:z,includePattern:{}},m.push(T),P.set(z,T));const H=E.$$d(z.fsPath,M.fsPath);(0,I.$uf)(T.includePattern)[H.replace(/\\/g,"/")]=!0}else M.fsPath&&(N=!0,O[M.fsPath]=!0)}),{folderQueries:m,includePattern:O,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(u,m){if(m.isSmartCase){if(u.isRegExp){if(A.$af(u.pattern,!0))return!0}else if(A.$af(u.pattern))return!0}return!!u.isCaseSensitive}k(u){return u.isMultiline||u.isRegExp&&(0,k.$kB)(u.pattern)||u.pattern.indexOf(`
`)>=0?!0:!!u.isMultiline}parseSearchPaths(u){const m=q=>E.$8d(q)||/^\.\.?([\/\\]|$)/.test(q),O=(Array.isArray(u)?u:a(u)).map(q=>{const me=this.e.resolvedUserHome;return me?(0,L.$kv)(q,me.scheme===$.Schemas.file?me.fsPath:me.path):q}),N=F.$I(O,q=>m(q)?"searchPaths":"exprSegments"),M=(N.exprSegments||[]).map(q=>A.$ve(q,"/")).map(q=>A.$ve(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),i(q))),j={},z=this.m(N.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const T=C.$Pb(M),H=r(...T);return H&&(j.pattern=H),j}l(u,m){return m.disregardExcludeSettings?void 0:(0,b.$zI)(u,!m.disregardSearchExcludeSettings)}m(u){if(!u||!u.length)return[];const m=u.flatMap(O=>{let{pathPortion:N,globPortion:M}=t(O);return M&&(M=d(M)),this.n(N).flatMap(z=>this.o(z,M))}),P=new Map;return m.forEach(O=>{const N=O.searchPath.toString(),M=P.get(N);M?O.pattern&&(M.pattern=M.pattern||{},M.pattern[O.pattern]=!0):P.set(N,{searchPath:O.searchPath,pattern:O.pattern?r(O.pattern):void 0})}),Array.from(P.values())}n(u){if(E.$8d(u)){const m=this.b.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==$.Schemas.file?[{searchPath:m[0].uri.with({path:u})}]:[{searchPath:w.URI.file(E.$7d(u))}]}if(this.b.getWorkbenchState()===2){const m=this.b.getWorkspace().folders[0].uri;if(u=c(u),u.startsWith("../")||u===".."){const O=E.$6d.resolve(m.path,u);return[{searchPath:m.with({path:O})}]}const P=d(u);return[{searchPath:m,pattern:P}]}else{if(u==="./"||u===".\\")return[];{const m=u.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(N=>{const M=m.match(new RegExp(`^${A.$qe(N.name)}(?:/(.*)|$)`));return M?{match:M,folder:N}:null}).filter(I.$rf);if(O.length)return O.map(N=>{const M=N.match[1];return{searchPath:N.folder.uri,pattern:M&&d(M)}});{const N=u.match(/\.[\/\\](.+)[\/\\]?/),M=N?N[1]:u,j=D.localize(0,null,M);throw new Error(j)}}}}o(u,m){const P=u.pattern&&m?`${u.pattern}/${m}`:u.pattern||m,O=[{searchPath:u.searchPath,pattern:P}];return P&&!P.endsWith("**")&&O.push({searchPath:u.searchPath,pattern:P+"/**"}),O}q(u,m,P){const O=this.r((0,s.$Wh)(u.searchPath),m,P,!1);return O?{...O,includePattern:u.pattern}:null}r(u,m,P,O){let N;const M=w.URI.isUri(u)?u:u.uri;if(P.searchPaths){const q=P.searchPaths.filter(me=>(0,p.$bg)(me.searchPath,M))[0];if(q&&!q.pattern)return null;q&&(N=q.pattern)}const j=this.a.getValue({resource:M}),T={...this.l(j,m)||{},...N||{}},H=w.URI.isUri(u)?(0,p.$fg)(u):u.name;return{folder:M,folderName:O?H:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof m.disregardParentIgnoreFiles=="boolean"?m.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!j.search.followSymlinks}}};e.$EJ=h,e.$EJ=h=Ke([Be(0,v.$8h),Be(1,s.$Kh),Be(2,n.$7B),Be(3,o.$5i),Be(4,l.$CJ)],h);function t(g){const u=g.match(/[\*\{\}\(\)\[\]\?]/);if(u){const m=u.index,P=g.substr(0,m).match(/[/|\\][^/\\]*$/);if(P){let O=g.substr(0,P.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:g.substr((P.index||0)+1)}}}return{pathPortion:g}}function r(...g){return g.length?g.reduce((u,m)=>(u[m]=!0,u),Object.create(null)):void 0}function a(g){return f.$pj(g,",").map(u=>u.trim()).filter(u=>!!u.length)}function i(g){return[`**/${g}/**`,`**/${g}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function c(g){return g.replace(/\\/g,"/")}function d(g){return c(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function y(g){return g.replace(/([?*[\]])/g,"[$1]")}function S(g,u){g=C.$Kb(g,O=>O.toString());const m=[],P=u.getWorkspace();return g&&g.forEach(O=>{let N;if(u.getWorkbenchState()===2)N=(0,p.$kg)(P.folders[0].uri,O),N&&N!=="."&&(N="./"+N);else{const M=u.getWorkspaceFolder(O);if(M){const j=M.name;if(P.folders.filter(T=>T.name===j).length===1){const T=(0,p.$kg)(M.uri,O);T===""?N=`./${M.name}`:N=`./${M.name}/${T}`}else N=O.fsPath}}N&&m.push(y(N))}),m}e.$FJ=S}),define(Se[349],De([1,0,24,2,21,8,5,348,36,43]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alb=e.$zlb=void 0;const A=7e3;function I(v,o){const s=o.activationEvents;if(!s)return Promise.resolve(void 0);const n=[],l=[];for(const i of s)if(/^workspaceContains:/.test(i)){const c=i.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||v.forceUsingSearch?l.push(c):n.push(c)}if(n.length===0&&l.length===0)return Promise.resolve(void 0);let b;const h=new Promise((i,c)=>{b=i}),t=i=>b({activationEvent:i}),r=Promise.all(n.map(i=>w(v,i,t))).then(()=>{}),a=k(v,o.identifier,l,t);return Promise.all([r,a]).then(()=>{b(void 0)}),h}e.$zlb=I;async function w(v,o,s){for(const n of v.folders)if(await v.exists(C.$ig(F.URI.revive(n),o))){s(`workspaceContains:${o}`);return}}async function k(v,o,s,n){if(s.length===0)return Promise.resolve(void 0);const l=new f.$pd,b=v.checkExists(v.folders,s,l.token),h=setTimeout(async()=>{l.cancel(),v.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},A);let t=!1;try{t=await b}catch(r){L.$2(r)||L.$Y(r)}l.dispose(),clearTimeout(h),t&&n(`workspaceContains:${s.join(",")}`)}function D(v,o,s,n){const l=v.get(R.$Ah),b=v.get(E.$rI),t=l.createInstance($.$EJ).file(o.map(r=>(0,p.$Wh)(F.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return b.fileSearch(t,n).then(r=>!!r.limitHit,r=>L.$2(r)?!1:Promise.reject(r))}e.$Alb=D}),define(Se[45],De([1,0,204,16,53,24,9,3,78,2,14,6,40,286,115,39,27,148,8,25,22,262,7,66,5,26,91,20,105,74,44,4,349,114,264,17,112,37,12,113]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b,h,t,r,a,i,c,d,y,S,g,u,m,P,O,N,M,j,z,T){"use strict";var H;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=e.$Ubc=e.$Tbc=e.$Sbc=e.$Rbc=void 0,e.$Rbc=(0,a.$Bh)("IHostUtils");let q=H=class extends $.$kc{constructor(G,U,K,fe,te,se,ne,Ee,oe,he,ee,le){super(),this.X=le,this.a=this.B(new u.$fd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=K,this.f=ne,this.j=fe,this.m=te,this.s=se,this.t=oe,this.u=he,this.w=ee,this.y=this.g.getProxy(I.$1J.MainThreadWorkspace),this.z=this.g.getProxy(I.$1J.MainThreadTelemetry),this.C=this.g.getProxy(I.$1J.MainThreadExtensionService),this.D=new R.$Fg,this.F=new R.$Fg,this.G=new R.$Fg,this.H=new R.$Fg,this.I=new ue(this.f.extensions.activationEvents),this.L=new s.$A3b(this.I,this.f.extensions.allExtensions);const be=new l.$Wl(this.f.extensions.myExtensions);this.J=new s.$A3b(this.I,x(this.L,be)),z.$s&&(this.s.info(`Creating extension host with the following global extensions: ${X(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${X(this.J)}`)),this.M=new D.$ybc(this.g,this.s),this.N=new P.$Kbc(this.g),this.O=Ee,this.h=G.createChild(new y.$zh([D.$zbc,this.M],[P.$Lbc,this.N])),this.P=this.B(new k.$xbc(this.J,this.L,{onExtensionActivationError:(Ie,B,Y)=>{this.C.$onExtensionActivationError(Ie,n.$1(B),Y)},actualActivateExtension:async(Ie,B)=>{if(s.$A3b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,B),new k.$wbc;const Y=this.J.getExtensionDescription(Ie);return this.db(Y,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(G){n.$Y(G)}}async Y(){this.O.onWillDeactivateAll();let G=[];try{G=this.J.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this.cb(te))}catch{}await Promise.all(G)}terminate(G,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${G}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(fe=>{this.s.error(fe)}),this.g.dispose();const K=this.Y();Promise.race([(0,R.$Hg)(5e3),K]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(G){return this.G.isOpen()?this.P.isActivated(G):!1}async getExtension(G){const U=await this.C.$getExtension(G);return U&&{...U,identifier:new l.$Vl(U.identifier.value),extensionLocation:p.URI.revive(U.extensionLocation)}}Z(G,U){return this.P.activateByEvent(G,U)}$(G,U){return this.P.activateById(G,U)}activateByIdWithErrors(G,U){return this.$(G,U).then(()=>{const K=this.P.getActivatedExtension(G);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(G=>this.J)}getExtensionExports(G){if(this.G.isOpen())return this.P.getActivatedExtension(G).exports;try{return this.P.getActivatedExtension(G).exports}catch{return null}}async ab(G){if(G.scheme===N.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(G.fsPath);return p.URI.file(U)}return G}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(G=>new ge(G))),this.Q}async bb(G){const U=E.$Hh.forUris(K=>L.$_f.ignorePathCasing(K));return await Promise.all(G.map(async K=>{if(this.ub(K)){const fe=await this.ab(K.extensionLocation);U.set(fe,K)}})),U}cb(G){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(G))return U;const K=this.P.getActivatedExtension(G);if(!K)return U;try{typeof K.module.deactivate=="function"&&(U=Promise.resolve(K.module.deactivate()).then(void 0,fe=>(this.s.error(fe),Promise.resolve(void 0))))}catch(fe){this.s.error(`An error occurred when deactivating the extension '${G.value}':`),this.s.error(fe)}try{(0,$.$fc)(K.subscriptions)}catch(fe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this.s.error(fe)}return U}async db(G,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(G.identifier):await this.C.$onWillActivateExtension(G.identifier),this.fb(G,U).then(K=>{const fe=K.activationTimes;return this.C.$onDidActivateExtension(G.identifier,fe.codeLoadingTime,fe.activateCallTime,fe.activateResolvedTime,U),this.eb(G,U,"success",fe),K},K=>{throw this.eb(G,U,"failure"),K})}eb(G,U,K,fe){const te=Z(G,U);this.z.$publicLog2("extensionActivationTimes",{...te,...fe||{},outcome:K})}fb(G,U){const K=Z(G,U);this.z.$publicLog2("activatePlugin",K);const fe=this.ub(G);if(!fe)return Promise.resolve(new k.$vbc(k.$sbc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${G.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const te=new k.$tbc(U.startup);return Promise.all([this.vb(G,(0,L.$ig)(G.extensionLocation,fe),te),this.gb(G)]).then(se=>(f.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),H.hb(this.s,G.identifier,se[0],se[1],te))).then(se=>(f.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),se))}gb(G){const U=new h.$Bbc(G,this.M),K=new h.$Abc(G.identifier.value,!1,this.M),fe=new O.$Mbc(G,this.N),te=G.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,se=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([U.whenReady,K.whenReady,this.O.whenReady]).then(()=>{const ne=this;let Ee,oe;const he=(0,o.$XE)(G,"ipc")?this.f.messagePorts?.get(l.$Vl.toKey(G.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:K,secrets:fe,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(ee){return F.$9d(G.extensionLocation.fsPath,ee)},get storagePath(){return ne.O.workspaceValue(G)?.fsPath},get globalStoragePath(){return ne.O.globalValue(G).fsPath},get logPath(){return F.$9d(ne.f.logsLocation.fsPath,G.identifier.value)},get logUri(){return p.URI.joinPath(ne.f.logsLocation,G.identifier.value)},get storageUri(){return ne.O.workspaceValue(G)},get globalStorageUri(){return ne.O.globalValue(G)},get extensionMode(){return te},get extension(){return Ee===void 0&&(Ee=new V(ne,G.identifier,G,se,!1)),Ee},get extensionRuntime(){return(0,o.$YE)(G,"extensionRuntime"),ne.extensionRuntime},get environmentVariableCollection(){return ne.u.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!oe){if(!he)return;const ee=u.Event.buffer(u.Event.fromDOMEventEmitter(he,"message",le=>le.data));he.start(),oe={onDidReceiveMessage:ee,postMessage:he.postMessage.bind(he)}}return oe}})})}static hb(G,U,K,fe,te){return K=K||{activate:void 0,deactivate:void 0},this.ib(G,U,K,fe,te).then(se=>new k.$ubc(!1,null,te.build(),K,se,fe.subscriptions))}static ib(G,U,K,fe,te){if(typeof K.activate=="function")try{te.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${U.value}`);const se=typeof global=="object"?global:self,ne=K.activate.apply(se,[fe]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(ne).then(Ee=>(te.activateResolveStop(),Ee))}catch(se){return Promise.reject(se)}else return Promise.resolve(K)}jb(G,U){this.$(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:U}).then(void 0,K=>{this.s.error(K)})}kb(G,U=0){const fe=Date.now();(0,z.$A)(()=>{for(let te=U;te<G.length;te+=1){const se=G[te];for(const ne of se.activationEvents??[])if(ne==="onStartupFinished")if(Date.now()-fe>50){this.kb(G,te);break}else this.jb(se,ne)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(G=>{const U=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),K=this.J.getAllExtensionDescriptions();if(U)this.kb(K);else for(const fe of K)if(fe.activationEvents)for(const te of fe.activationEvents)te==="onStartupFinished"&&this.jb(fe,te)})}mb(){const G=this.Z("*",!0).then(void 0,se=>{this.s.error(se)});this.B(this.j.onDidChangeWorkspace(se=>this.nb(se.added)));const U=this.j.workspace?this.j.workspace.folders:[],K=this.nb(U),fe=this.pb(),te=Promise.all([fe,G,K]).then(()=>{});return Promise.race([te,(0,R.$Hg)(1e4)]).then(()=>{this.lb()}),te}nb(G){return G.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(G,U))).then(()=>{})}async ob(G,U){if(this.isActivated(U.identifier))return;const K=!this.f.remote.isRemote&&!!this.f.remote.authority,fe={logService:this.s,folders:G.map(se=>se.uri),forceUsingSearch:K||!this.c.fsExists,exists:se=>this.c.fsExists(se.fsPath),checkExists:(se,ne,Ee)=>this.y.$checkExists(se,ne,Ee)},te=await(0,m.$zlb)(fe,U);if(te)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:te.activationEvent}).then(void 0,se=>this.s.error(se))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(G){throw console.error(G),G}}async qb(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:U}=this.f.environment;if(!G||!U)throw new Error(C.localize(0,null));const K=await this.vb(null,U,new k.$tbc(!1));if(!K||typeof K.run!="function")throw new Error(C.localize(1,null,U.toString()));return new Promise((fe,te)=>{const se=(oe,he)=>{oe?(z.$s&&this.s.error("Test runner called back with error",oe),te(oe)):(z.$s&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),fe(typeof he=="number"&&he>0?1:0))},ne=(0,L.$9f)(U),Ee=K.run(ne,se);Ee&&Ee.then&&Ee.then(()=>{z.$s&&this.s.info("Test runner finished successfully."),fe(0)}).catch(oe=>{z.$s&&this.s.error("Test runner finished with error",oe),te(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Hg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,U){return this.R[G]=U,(0,$.$ic)(()=>{delete this.R[G]})}async getRemoteExecServer(G){const{resolver:U}=await this.sb(G);return U?.resolveExecServer?.(G,{resolveAttempt:0})}async sb(G){const U=G.indexOf("+");if(U===-1)throw new t.$9J("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const K=G.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${K}`,!1),{authorityPrefix:K,resolver:this.R[K]}}async $resolveAuthority(G,U){const K=j.$bd.create(!1),fe=()=>`[resolveAuthority(${(0,r.$Nk)(G)},${U})][${K.elapsed()}ms] `,te=re=>this.s.info(`${fe()}${re}`),se=re=>this.s.warn(`${fe()}${re}`),ne=(re,Q=void 0)=>this.s.error(`${fe()}${re}`,Q),Ee=re=>{if(re instanceof t.$9J)return{type:"error",error:{code:re._code,message:re._message,detail:re._detail}};throw re},oe=async re=>{te(`activating resolver for ${re}...`);const{resolver:Q,authorityPrefix:de}=await this.sb(re);if(!Q)throw ne(`no resolver for ${de}`),new t.$9J(`No remote extension installed to resolve ${de}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:de,remoteAuthority:re}},he=G.split(/@|%40/g).reverse();te(`activating remote resolvers ${he.join(" -> ")}`);let ee;try{ee=await Promise.all(he.map(oe)).catch(async re=>{if(!(re instanceof t.$9J)||re._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw re;return se(`resolving nested authorities failed: ${re.message}`),[await oe(G)]})}catch(re){return Ee(re)}const le=new R.$Rg;le.cancelAndSet(()=>te("waiting..."),1e3);let be,Ie;for(const[re,{authorityPrefix:Q,resolver:de,remoteAuthority:ye}]of ee.entries())try{if(re===ee.length-1)te("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${Q}`),be=await de.resolve(ye,{resolveAttempt:U,execServer:Ie}),f.mark(`code/extHost/didResolveAuthorityOK/${Q}`),te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(de,t.$8J.isManagedResolvedAuthority(be)?be:void 0));else{if(te(`invoking resolveExecServer() for ${ye}`),f.mark(`code/extHost/willResolveExecServer/${Q}`),Ie=await de.resolveExecServer?.(ye,{resolveAttempt:U,execServer:Ie}),!Ie)throw new t.$9J(`Exec server was not available for ${ye}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(je){return f.mark(`code/extHost/didResolveAuthorityError/${Q}`),ne("returned an error",je),le.dispose(),Ee(je)}le.dispose();const B={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},Y={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${t.$8J.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let ie;if(t.$8J.isManagedResolvedAuthority(be)){const re=U;this.X.setFactory(re,be.makeConnection),ie={authority:G,connectTo:new r.$Kk(re),connectionToken:be.connectionToken}}else ie={authority:G,connectTo:new r.$Lk(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:ie,options:Y,tunnelInformation:B}}}async $getCanonicalURI(G,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Nk)(G)})`);const{resolver:K}=await this.sb(G);if(!K)return null;const fe=p.URI.revive(U);if(typeof K.getCanonicalURI>"u")return fe;const te=await(0,R.$zg)(()=>K.getCanonicalURI(fe));return te||fe}$startExtensionHost(G){G.toAdd.forEach(fe=>fe.extensionLocation=p.URI.revive(fe.extensionLocation));const{globalRegistry:U,myExtensions:K}=me(this.I,this.L,this.J,G);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(K),z.$s&&(this.s.info(`$startExtensionHost: global extensions: ${X(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${X(this.J)}`)),this.rb()}$activateByEvent(G,U){return U===1?this.D.wait().then(K=>this.Z(G,!1)):this.G.wait().then(K=>this.Z(G,!1))}async $activate(G,U){return await this.G.wait(),this.J.getExtensionDescription(G)?(await this.$(G,U),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(se=>se.extensionLocation=p.URI.revive(se.extensionLocation));const{globalRegistry:U,myExtensions:K}=me(this.I,this.L,this.J,G),fe=await this.bb(K);return(await this.getExtensionPathIndex()).setSearchTree(fe),this.L.set(U.getAllExtensionDescriptions()),this.J.set(K),z.$s&&(this.s.info(`$deltaExtensions: global extensions: ${X(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${X(this.J)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const U=b.$Fd.alloc(G),K=Math.random()%256;for(let fe=0;fe<G;fe++)U.writeUInt8(K,fe);return U}async $updateRemoteConnectionData(G){this.W=G,this.a.fire()}};e.$Sbc=q,e.$Sbc=q=H=Ke([Be(0,a.$Ah),Be(1,e.$Rbc),Be(2,d.$2L),Be(3,v.$lbc),Be(4,w.$obc),Be(5,A.$5i),Be(6,i.$fM),Be(7,c.$Ebc),Be(8,S.$rsb),Be(9,g.$Gbc),Be(10,M.$Obc),Be(11,T.$Pbc)],q);function me(ve,G,U,K){ve.addActivationEvents(K.addActivationEvents);const fe=new s.$A3b(ve,G.getAllExtensionDescriptions());fe.deltaExtensions(K.toAdd,K.toRemove);const te=new l.$Wl(U.getAllExtensionDescriptions().map(ne=>ne.identifier));for(const ne of K.myToRemove)te.delete(ne);for(const ne of K.myToAdd)te.add(ne);const se=x(fe,te);return{globalRegistry:fe,myExtensions:se}}function Z(ve,G){return{id:ve.identifier.value,name:ve.name,extensionVersion:ve.version,publisherDisplayName:ve.publisher,activationEvents:ve.activationEvents?ve.activationEvents.join(","):null,isBuiltin:ve.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function X(ve){return ve.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.$Tbc=(0,a.$Bh)("IExtHostExtensionService");class V{#e;#t;#i;constructor(G,U,K,fe,te){this.#e=G,this.#t=U,this.#i=K.identifier,this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=F.$7d((0,L.$9f)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=fe,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ubc=V;function x(ve,G){return ve.getAllExtensionDescriptions().filter(U=>G.has(U.identifier))}class ge{constructor(G){this.a=G}setSearchTree(G){this.a=G}findSubstr(G){return this.a.findSubstr(G)}forEach(G){return this.a.forEach(G)}}e.$Vbc=ge;class ue{constructor(G){this.a=new l.$Xl,this.addActivationEvents(G)}readActivationEvents(G){return this.a.get(G.identifier)}addActivationEvents(G){for(const U of Object.keys(G))this.a.set(U,G[U])}}}),define(Se[350],De([1,0,53,2,6,40,27,25,20,26,5,45,14,15]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;let v=class{constructor(b,h,t,r,a,i,c){this.c=b,this.d=h,this.e=t,this.f=r,this.g=a,this.h=i,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const b=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new s(this.c,h,this.d,b,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const h of b.nodeModuleName)this.a.set(h,b);else this.a.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this.b.push(h=>b.alternativeModuleName(h))}};e.$gdc=v,e.$gdc=v=Ke([Be(2,A.$Ah),Be(3,L.$obc),Be(4,I.$Tbc),Be(5,p.$fM),Be(6,w.$5i)],v);let o=class{static{D=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(b){if(b.environment.appRoot&&D.a.size){const h=(0,k.$qe)(this.c(b.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${a}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(b){if(!this.b)return;const h=this.b.exec(this.c(b));if(!h)return;const[,t,r,a]=h,i=D.a.get(r);if(i!==void 0)return console.warn(`${r} as been renamed to ${i}, please update your imports`),t+i+a}c(b){return b.replace(/\\/g,"/")}};o=D=Ke([Be(0,p.$fM)],o);class s{constructor(b,h,t,r,a){this.c=b,this.d=h,this.e=t,this.f=r,this.g=a,this.nodeModuleName="vscode",this.a=new $.$Xl}load(b,h){const t=this.d.findSubstr(h);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((a,i)=>r+=`	${i} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${r}`),this.b=this.c(R.$SE,this.e,this.f)}return this.b}}let n=class{constructor(b,h,t){this.e=b,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$1J.MainThreadTelemetry);const r=t.getProxy(f.$1J.MainThreadWindow);this.c=(a,i)=>{const c=F.URI.parse(a);return i?this.g(a,i):c.scheme==="http"||c.scheme==="https"?r.$openUri(c,a,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?r.$openUri(c,a,{}):this.g(a,i)}}load(b,h,t){const r=this.e.findSubstr(h);return r&&(this.a=r.identifier.value,this.h()),this.b=t(b),this.c}g(b,h){return this.i(),this.b(b,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ke([Be(2,E.$2L)],n)}),define(Se[55],De([1,0,59,3,16,47,5,71,72,45,7,39,278,40]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=void 0,e.$pcc=(0,R.$Bh)("IExtHostVariableResolverProvider");class D extends w.$3M{constructor(s,n,l,b,h,t,r){function a(){if(l){const i=l.activeEditor();if(i)return i.document.uri;const c=b.tabGroups.all.find(d=>d.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof A.$IL||c.input instanceof A.$NL)return c.input.modified;if(c.input instanceof A.$HL||c.input instanceof A.$ML||c.input instanceof A.$KL)return c.input.uri}}}super({getFolderUri:i=>{const c=t.folders.filter(d=>d.name===i);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,c)=>h.getConfiguration(void 0,i).get(c),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=a();if(i)return f.$7d(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const i=a();if(i){const c=n.getWorkspaceFolder(i);if(c)return f.$7d(c.uri.fsPath)}}},getSelectedText:()=>{if(l){const i=l.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(l){const i=l.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>s.getExtension(i)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(L.env))}}let v=class extends F.$kc{constructor(s,n,l,b,h){super(),this.b=s,this.c=n,this.g=l,this.h=b,this.j=h,this.a=new C.$T(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async i=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$qcc=v,e.$qcc=v=Ke([Be(0,p.$Tbc),Be(1,I.$lbc),Be(2,$.$aM),Be(3,k.$obc),Be(4,E.$ncc)],v)}),define(Se[95],De([1,0,9,4,2,5,6,72,45,20,7,39,140,271,40,55]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=e.$ucc=e.$tcc=e.$scc=e.$rcc=void 0,e.$rcc=(0,L.$Bh)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,a,i,c,d,y){this.E=a,this.F=i,this.G=c,this.H=d,this.I=y,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$fd,this.n=new F.$fd,this.o=new F.$fd,this.u=new F.$fd,this.k=r.getProxy(R.$1J.MainThreadDebugService),this.y=new F.$fd,this.A=new F.$fd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange(g=>{this.J(S)}),this.J(S)})}asDebugSourceUri(r,a){const i=r;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let c=`debug:${encodeURIComponent(i.path||"")}`,d="?";return a&&(c+=`${d}session=${encodeURIComponent(a.id)}`,d="&"),c+=`${d}ref=${i.sourceReference}`,f.URI.parse(c)}else{if(i.path)return f.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const a=[];for(const i of r.getAllExtensionDescriptions())if(i.contributes){const c=i.contributes.debuggers;if(c&&c.length>0)for(const d of c)(0,k.$eF)(d)&&a.push(d.type)}this.k.$registerDebugTypes(a)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(a=>r.push(a)),r}addBreakpoints(r){const a=r.filter(d=>{const y=d.id;return this.w.has(y)?!1:(this.w.set(y,d),!0)});this.U(a,[],[]);const i=[],c=new Map;for(const d of a)if(d instanceof A.$2K){let y=c.get(d.location.uri.toString());y||(y={type:"sourceMulti",uri:d.location.uri,lines:[]},c.set(d.location.uri.toString(),y),i.push(y)),y.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof A.$3K&&i.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(r){const a=r.filter(y=>this.w.delete(y.id));this.U([],a,[]);const i=a.filter(y=>y instanceof A.$2K).map(y=>y.id),c=a.filter(y=>y instanceof A.$3K).map(y=>y.id),d=a.filter(y=>y instanceof A.$4K).map(y=>y.id);return this.k.$unregisterBreakpoints(i,c,d)}startDebugging(r,a,i){return this.k.$startDebugging(r?r.uri:void 0,a,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,a,i){if(!a)return new A.$3J(()=>{});const c=this.d++;return this.f.push({type:r,handle:c,provider:a}),this.k.$registerDebugConfigurationProvider(r,i,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,c),new A.$3J(()=>{this.f=this.f.filter(d=>d.provider!==a),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(r,a,i){if(!i)return new A.$3J(()=>{});if(!this.Q(r,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.N(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:a,handle:c,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(a,c),new A.$3J(()=>{this.h=this.h.filter(d=>d.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(r,a){if(!a)return new A.$3J(()=>{});const i=this.i++;return this.j.push({type:r,handle:i,factory:a}),new A.$3J(()=>{this.j=this.j.filter(c=>c.factory!==a)})}async $runInTerminal(r,a){return Promise.resolve(void 0)}async $substituteVariables(r,a){let i;const c=await this.W(r);return c&&(i={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(i,a)}K(r,a){if(r.type==="implementation")return new b(r.implementation)}L(){}async $startDASession(r,a){const i=this,c=await this.V(a);return this.S(this.N(c.type),c).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const y=this.M(d),S=this.K(y,c);if(!S)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const g=S;return this.B.set(r,g),this.R(c).then(u=>(u&&this.C.set(r,u),g.onMessage(async m=>{if(m.type==="request"&&m.command==="handshake"){const P=m,O={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const N=await this.D.sign(P.arguments.value);O.body={signature:N},g.sendResponse(O)}else throw new Error("no signer")}catch(N){O.success=!1,O.message=N.message,g.sendResponse(O)}}else u&&u.onDidSendMessage&&u.onDidSendMessage(m),m=(0,k.$jF)(m,!0),i.k.$acceptDAMessage(r,m)}),g.onError(m=>{u&&u.onError&&u.onError(m),this.k.$acceptDAError(r,m.name,m.message,m.stack)}),g.onExit(m=>{u&&u.onExit&&u.onExit(m??void 0,void 0),this.k.$acceptDAExit(r,m??void 0,void 0)}),u&&u.onWillStartSession&&u.onWillStartSession(),g.startSession()))})}$sendDAMessage(r,a){a=(0,k.$iF)(a,!1);const i=this.C.get(r);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(a),this.B.get(r)?.sendMessage(a)}$stopDASession(r){const a=this.C.get(r);this.C.delete(r),a&&a.onWillStopSession&&a.onWillStopSession();const i=this.B.get(r);return this.B.delete(r),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const a=[],i=[],c=[];if(r.added)for(const d of r.added){const y=d.id;if(y&&!this.w.has(y)){let S;if(d.type==="function")S=new A.$3K(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")S=new A.$4K(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const g=f.URI.revive(d.uri);S=new A.$2K(new A.$cK(g,new A.$4J(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,A.$ZK)(S,y),this.w.set(y,S),a.push(S)}}if(r.removed)for(const d of r.removed){const y=this.w.get(d);y&&(this.w.delete(d),i.push(y))}if(r.changed){for(const d of r.changed)if(d.id){const y=this.w.get(d.id);if(y){if(y instanceof A.$3K&&d.type==="function"){const S=y;S.enabled=d.enabled,S.condition=d.condition,S.hitCondition=d.hitCondition,S.logMessage=d.logMessage,S.functionName=d.functionName}else if(y instanceof A.$2K&&d.type==="source"){const S=y;S.enabled=d.enabled,S.condition=d.condition,S.hitCondition=d.hitCondition,S.logMessage=d.logMessage,S.location=new A.$cK(f.URI.revive(d.uri),new A.$4J(d.line,d.character))}c.push(y)}}}this.U(a,i,c)}async $acceptStackFrameFocus(r){let a;const i=r.sessionId?await this.V(r.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?a=new A.$0K(i,r.threadId):a=new A.$9K(i,r.threadId,r.frameId),this.z=a,this.A.fire(this.z)}$provideDebugConfigurations(r,a,i){return(0,C.$zg)(async()=>{const c=this.P(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(a);return c.provideDebugConfigurations(d,i)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(r,a,i,c){return(0,C.$zg)(async()=>{const d=this.P(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.W(a);return d.resolveDebugConfiguration(y,i,c)})}$resolveDebugConfigurationWithSubstitutedVariables(r,a,i,c){return(0,C.$zg)(async()=>{const d=this.P(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.W(a);return d.resolveDebugConfigurationWithSubstitutedVariables(y,i,c)})}async $provideDebugAdapter(r,a){const i=this.O(r);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(a);return this.S(i,c).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(r){const a=await this.V(r);this.m.fire(a)}async $acceptDebugSessionTerminated(r){const a=await this.V(r);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,a){(await this.V(r))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(r,a){const c={session:await this.V(r),event:a.event,body:a.body};this.u.fire(c)}M(r){if(r instanceof A.$5K)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof A.$6K)return{type:"server",port:r.port,host:r.host};if(r instanceof A.$7K)return{type:"pipeServer",path:r.path};if(r instanceof A.$8K)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const a=this.h.filter(i=>i.type===r);if(a.length>0)return a[0].factory}O(r){const a=this.h.filter(i=>i.handle===r);if(a.length>0)return a[0].factory}P(r){const a=this.f.filter(i=>i.handle===r);if(a.length>0)return a[0].provider}Q(r,a){if(r.contributes){const i=r.contributes.debuggers;if(i&&i.length>0){for(const c of i)if(c.label&&c.type&&c.type===a)return!0}}return!1}R(r){const i=r.configuration.type,c=this.j.filter(d=>d.type===i||d.type==="*").map(d=>(0,C.$zg)(()=>d.factory.createDebugAdapterTracker(r)).then(y=>y,y=>null));return Promise.race([Promise.all(c).then(d=>{const y=d.filter(S=>!!S);if(y.length>0)return new l(y)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(r,a){const i=a.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new A.$6K(i));if(r){const d=await this.F.getExtensionRegistry();return(0,C.$zg)(()=>r.createDebugAdapterDescriptor(a,this.T(a,d))).then(y=>{if(y)return y})}const c=await this.F.getExtensionRegistry();return Promise.resolve(this.T(a,c))}T(r,a){}U(r,a,i){(r.length>0||a.length>0||i.length>0)&&this.y.fire(Object.freeze({added:r,removed:a,changed:i}))}async V(r){if(r)if(typeof r=="string"){const a=this.l.get(r);if(a)return a}else{let a=this.l.get(r.id);if(!a){const i=await this.W(r.folderUri),c=r.parent?this.l.get(r.parent):void 0;a=new s(this.k,r.id,r.type,r.name,i,r.configuration,c),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(r){if(r){const a=f.URI.revive(r);return this.E.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.$scc=o,e.$scc=o=Ke([Be(0,p.$2L),Be(1,I.$lbc),Be(2,E.$Tbc),Be(3,D.$obc),Be(4,$.$ncc),Be(5,v.$pcc)],o);class s{constructor(r,a,i,c,d,y,S){this.d=r,this.f=a,this.g=i,this.h=c,this.i=d,this.j=y,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,a){return this.d.$customDebugAdapterRequest(this.f,r,a)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$tcc=s;class n{constructor(r){this.value=Object.freeze({append(a){r.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.$ucc=n;class l{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(a=>a.onError?a.onError(r):void 0)}onExit(r,a){this.d.forEach(i=>i.onExit?i.onExit(r,a):void 0)}}class b extends w.$Ecb{constructor(r){super(),this.h=r,r.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends o{constructor(r,a,i,c,d,y){super(r,a,i,c,d,y)}};e.$vcc=h,e.$vcc=h=Ke([Be(0,p.$2L),Be(1,I.$lbc),Be(2,E.$Tbc),Be(3,D.$obc),Be(4,$.$ncc),Be(5,v.$pcc)],h)}),define(Se[351],De([1,0,8,53,2,6,342,14,104,105,26,238,20,68,45,89]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=e.$hdc=void 0;class o{static async installEarlyHandler(l){Error.stackTraceLimit=100;const b=l.get($.$5i),t=l.get(w.$2L).getProxy(L.$1J.MainThreadErrors);C.setUnexpectedErrorHandler(r=>{b.error(r);const a=C.$1(r);t.$onUnexpectedError(a)})}static async installFullHandler(l){const b=l.get($.$5i),h=l.get(w.$2L),t=l.get(D.$Tbc),r=l.get(v.$jM),a=h.getProxy(L.$1J.MainThreadExtensionService),i=h.getProxy(L.$1J.MainThreadErrors),c=await t.getExtensionPathIndex(),d=new WeakMap;function y(u,m){if(d.has(u))return d.get(u).stack;let P="",O,N;for(const j of m)P+=`
	at ${j.toString()}`,N=j.getFileName(),!O&&N&&(O=c.findSubstr(f.URI.file(N)));const M=`${u.name||"Error"}: ${u.message||""}${P}`;return d.set(u,{extensionIdentifier:O?.identifier,stack:M}),M}const S=Symbol("prepareStackTrace wrapped");let g=y;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(u){if(u===y||!u||u[S]){g=u||y;return}g=function(m,P){return y(m,P),u.call(Error,m,P)},Object.assign(g,{[S]:!0})}}),C.setUnexpectedErrorHandler(u=>{b.error(u);const m=C.$1(u),P=d.get(u);if(!P?.extensionIdentifier){i.$onUnexpectedError(m);return}a.$onExtensionRuntimeError(P.extensionIdentifier,m);const O=r.onExtensionError(P.extensionIdentifier,u);b.trace("forwarded error to extension?",O,P)})}}e.$hdc=o;class s{constructor(l,b,h,t,r){this.a=h,this.b=new R.$J3b(l,null,t),b=s.e(b,this.b);const a=new p.$zh(...(0,E.$nr)());a.set(A.$fM,{_serviceBrand:void 0,...b,messagePorts:r}),a.set(w.$2L,new w.$3L(this.b)),a.set(k.$ibc,new k.$jbc(t)),a.set(D.$Rbc,h);const i=new I.$6p(a,!0);i.invokeFunction(o.installEarlyHandler),this.d=i.invokeFunction(c=>c.get($.$5i)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",b),this.c=i.invokeFunction(c=>c.get(D.$Tbc)),this.c.initialize(),i.invokeFunction(o.installFullHandler)}async asBrowserUri(l){const b=this.b.getProxy(L.$1J.MainThreadExtensionService);return f.URI.revive(await b.$asBrowserUri(l))}terminate(l){this.c.terminate(l)}static e(l,b){l.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(b.transformIncomingURIs(t.extensionLocation))}),l.environment.appRoot=f.URI.revive(b.transformIncomingURIs(l.environment.appRoot));const h=l.environment.extensionDevelopmentLocationURI;return h&&(l.environment.extensionDevelopmentLocationURI=h.map(t=>f.URI.revive(b.transformIncomingURIs(t)))),l.environment.extensionTestsLocationURI=f.URI.revive(b.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=f.URI.revive(b.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=f.URI.revive(b.transformIncomingURIs(l.environment.workspaceStorageHome)),l.environment.extensionTelemetryLogResource=f.URI.revive(b.transformIncomingURIs(l.environment.extensionTelemetryLogResource)),l.nlsBaseUrl=f.URI.revive(b.transformIncomingURIs(l.nlsBaseUrl)),l.logsLocation=f.URI.revive(b.transformIncomingURIs(l.logsLocation)),l.workspace=b.transformIncomingURIs(l.workspace),l}}e.$idc=s}),define(Se[352],De([1,0,9,12,215,232,138,95,72,45,20,44,7,55,39,272,273,40]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;let n=class extends $.$scc{constructor(r,a,i,c,d,y,S){super(r,a,i,c,y,S),this.Z=d,this.X=new h}K(r,a){switch(r.type){case"server":return new v.$ndc(r);case"pipeServer":return new v.$odc(r);case"executable":return new v.$pdc(r,a.type)}return super.K(r,a)}T(r,a){const i=v.$pdc.platformAdapterExecutable(a.getAllExtensionDescriptions(),r.type);if(i)return new w.$5K(i.command,i.args,i.options)}L(){return new R.$m7b}async $runInTerminal(r,a){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const i=await this.G.getConfigProvider(),c=this.Z.getDefaultShell(!0),d=this.Z.getDefaultShellArgs(!0),y=r.title||f.localize(0,null),S=JSON.stringify({shell:c,shellArgs:d});let g=await this.X.checkout(S,y),u,m=!1;if(g)u=r.cwd;else{const M={shellPath:c,shellArgs:d,cwd:r.cwd,name:y,iconPath:new w.$WK("debug")};m=!0,g=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(g,S)}g.show(!0);const P=await g.processId;m?await new Promise(M=>setTimeout(M,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?g.sendText("cls"):c.indexOf("bash")>=0?g.sendText("clear"):F.$i?g.sendText("cls"):g.sendText("clear"));const O=(0,o.$rdc)(c,r.args,!!r.argsCanBeInterpretedByShell,u,r.env);g.sendText(O);const N=this.onDidTerminateDebugSession(M=>{M.id===a&&(this.X.free(g),N.dispose())});return P}else if(r.kind==="external")return b(r,await this.G.getConfigProvider());return super.$runInTerminal(r,a)}};e.$sdc=n,e.$sdc=n=Ke([Be(0,A.$2L),Be(1,D.$lbc),Be(2,p.$Tbc),Be(3,s.$obc),Be(4,I.$Gbc),Be(5,E.$ncc),Be(6,k.$pcc)],n);let l;function b(t,r){if(!l)if(F.$i)l=new L.$85b;else if(F.$j)l=new L.$95b;else if(F.$k)l=new L.$05b;else throw new Error("external terminals not supported on this platform");const a=r.getConfiguration("terminal");return l.runInTerminal(t.title,t.cwd,t.args,t.env||{},a.external||{})}class h{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,a){const c=[...this.b.entries()].map(([d,y])=>(0,C.$ug)(async S=>{if(d.name!==a||y.lastUsedAt!==-1&&await(0,o.$qdc)(await d.processId))return null;const g=Date.now();return y.lastUsedAt+h.a>g||S.isCancellationRequested||y.config!==r?null:(y.lastUsedAt=g,d)}));return await(0,C.$Lg)(c,d=>!!d)}insert(r,a){this.b.set(r,{lastUsedAt:Date.now(),config:a})}free(r){const a=this.b.get(r);a&&(a.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(Se[353],De([1,0,16,2,102,39,71,40,43,44,20,26,94,17,14,90,24,64,55]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;let l=class extends w.$kcc{constructor(h,t,r,a,i,c,d,y,S){super(h,t,r,a,i,c,d,y),this.B=r,this.C=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(h,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const a=w.TaskHandleDTO.from(r,this.B),i=await this.a.$getTaskExecution(a);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(i,t);return this.a.$executeTask(a).catch(()=>{}),c}else{const a=w.TaskDTO.from(t,h);if(a===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(a.execution)&&await this.x(a,t,!1);const i=await this.y(await this.a.$getTaskExecution(a),t);return this.a.$executeTask(a).catch(()=>{}),i}}u(h,t,r,a){const i=[];if(a)for(const c of a){this.z(c,r),(!c.definition||!h[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const d=w.TaskDTO.from(c,r.extension);d&&(i.push(d),w.CustomExecutionDTO.is(d.execution)&&t.push(this.x(d,c,!0)))}return{tasks:i,extension:r.extension}}async v(h){return h}async F(h){let t=h&&h.length>0?h[0]:void 0;if(!t){const r=F.URI.file((0,s.homedir)());t=new E.$Vh({uri:r,name:o.$fg(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(h,t){const r=F.URI.revive(h),a={process:void 0,variables:Object.create(null)},i=await this.b.resolveWorkspaceFolder(r),c=await this.b.getWorkspaceFolders2()??[],d=await this.C.getResolver(),y=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const S of t.variables)a.variables[S]=await d.resolveAsync(y,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(C.$ge);for(let g=0;g<S.length;g++)S[g]=await d.resolveAsync(y,S[g])}a.process=await f.win32.findExecutable(await d.resolveAsync(y,t.process.name),t.process.cwd!==void 0?await d.resolveAsync(y,t.process.cwd):void 0,S)}return a}async $jsonTasksSupported(){return!0}async $findExecutable(h,t,r){return f.win32.findExecutable(h,t,r)}};e.$kdc=l,e.$kdc=l=Ke([Be(0,A.$2L),Be(1,I.$fM),Be(2,L.$lbc),Be(3,R.$aM),Be(4,$.$obc),Be(5,p.$Gbc),Be(6,D.$5i),Be(7,v.$bbc),Be(8,n.$pcc)],l)}),define(Se[354],De([1,0,64,55]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;class f extends F.$qcc{m(){return(0,C.homedir)()}}e.$3dc=f}),define(Se[153],De([1,0,19,9,21,46,17,16,24,2,36]),function($e,e,C,F,f,L,R,$,E,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=e.$ycc=e.$xcc=void 0;class I{constructor(n,l,b,h){this.d=n,this.e=l,this.f=b,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,l){const b=this.d.folderQueries||[],h=new f.$pd(l);return new Promise((t,r)=>{this.a=new k(n);let a=!1;const i=(c,d)=>{if(!a&&!this.b){const y=this.h(c);v(c)&&typeof this.d.maxResults=="number"&&this.c+y>this.d.maxResults&&(this.b=!0,a=!0,h.cancel(),c=this.j(c,this.d.maxResults-this.c));const S=this.h(c);this.c+=S,(S>0||!v(c))&&this.a.add(c,d)}};Promise.all(b.map((c,d)=>this.k(c,y=>i(y,d),h.token))).then(c=>{h.dispose(),this.a.flush();const d=c.some(y=>!!y&&!!y.limitHit);t({limitHit:this.b||d,messages:(0,C.$Pb)(c.map(y=>y?.message?Array.isArray(y.message)?y.message:[y.message]:[])),stats:{type:this.g}})},c=>{h.dispose();const d=(0,L.$mi)(c);r(new Error(d))})})}h(n){return v(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,l){const b=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:b.slice(0,l),preview:{matches:h.slice(0,l),text:n.preview.text},uri:n.uri}}async k(n,l,b){const h=new A.$KI(this.d,n),t=[],r={report:c=>{if(!this.l(c))return;const d=n.folder.scheme===R.Schemas.file?(0,A.$LI)(()=>this.f.readdir(E.$hg(c.uri))):void 0,y=E.$kg(n.folder,c.uri);if(y){const S=h.includedInQuery(y,$.$ae(y),d);(0,F.$tg)(S)?t.push(S.then(g=>{g&&l(c)})):S&&l(c)}}},a=this.n(n),i=await this.e.provideTextSearchResults(w(this.d.contentPattern),a,r,b);return t.length&&await Promise.all(t),i}l(n){if(v(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const l=(0,A.$JI)(this.d.includePattern,n.includePattern),b=(0,A.$JI)(this.d.excludePattern,n.excludePattern),h={folder:p.URI.from(n.folder),excludes:b,includes:l,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$xcc=I;function w(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class k{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,l=>this.g(l))}add(n,l){this.d&&(this.b!==l||!E.$bg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=l,this.d={resource:n.uri,results:[]}),this.d.results.push(D(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$ycc=k;function D(s){return v(s)?{preview:{matches:(0,C.$Zb)(s.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:s.preview.text},ranges:(0,C.$Zb)(s.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function v(s){return!!s.preview}e.$zcc=v;class o{static{this.a=4e3}static{this.b=50}constructor(n,l){this.g=n,this.h=l,this.c=0,this.d=[],this.e=0}addItem(n,l){n&&this.j(n,l)}addItems(n,l){n&&this.k(n,l)}j(n,l){this.d.push(n),this.e+=l,this.l()}k(n,l){this.d=this.d.concat(n),this.e+=l,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Acc=o}),define(Se[96],De([1,0,3,6,5,347,20,68,14,2,153]),function($e,e,C,F,f,L,R,$,E,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=e.$Ccc=e.$Bcc=void 0,e.$Bcc=(0,f.$Bh)("IExtHostSearch");let I=class{constructor(v,o,s){this.k=v,this.l=o,this.n=s,this.c=this.k.getProxy(F.$1J.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$wcc}o(v){return this.l.transformOutgoingScheme(v)}registerTextSearchProvider(v,o){if(this.g.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this.g.add(v);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.o(v)),(0,C.$ic)(()=>{this.g.delete(v),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(v,o){if(this.i.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this.i.add(v);const s=this.d++;return this.h.set(s,o),this.c.$registerFileSearchProvider(s,this.o(v)),(0,C.$ic)(()=>{this.i.delete(v),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(v,o,s,n){const l=w(s),b=this.h.get(v);if(b)return this.j.fileSearch(l,b,h=>{this.c.$handleFileMatch(v,o,h.map(t=>t.resource))},n);throw new Error("unknown provider: "+v)}$clearCache(v){return this.j.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,o,s,n){const l=this.e.get(v);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const b=w(s);return this.q(b,l).search(t=>this.c.$handleTextMatch(v,o,t),n)}$enableExtensionHostSearch(){}q(v,o){return new A.$xcc(v,o,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$Ccc=I,e.$Ccc=I=Ke([Be(0,R.$2L),Be(1,$.$ibc),Be(2,E.$5i)],I);function w(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(k),extraFileResources:D.extraFileResources&&D.extraFileResources.map(v=>p.URI.revive(v))}}e.$Dcc=w;function k(D){return{...D,folder:p.URI.revive(D.folder)}}}),define(Se[355],De([1,0,21,8,4,38,2,130,125,168,185,30,6,111,302,301,33,303,40,305,306,307,280,308,71,45,310,311,316,317,318,152,284,324,325,327,115,44,329,287,13,7,85,332,92,151,39,25,276,315,67,149,94,95,96,14,68,20,26,319,274,74,90,294,330,91,73,335,333,334,295,54,328,331,114,72,89,320,93,321,17,134,283,263,313,3,27,270,112,257,322,323,296,312,282,314,113,326,298,299,300,293,309,297]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b,h,t,r,a,i,c,d,y,S,g,u,m,P,O,N,M,j,z,T,H,q,me,Z,X,V,x,ge,ue,ve,G,U,K,fe,te,se,ne,Ee,oe,he,ee,le,be,Ie,B,Y,ie,re,Q,de,ye,je,We,_e,Qe,it,et,Ae,Oe,Ve,Le,Xe,ce,ae,Ce,qe,Ue,Ze,rt,at,bt,St,Xt,Ht,pt,Ut,Nt,Bt,At,Rt,jt,Wt,Kt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;function qt(ot){const ft=ot.get(oe.$fM),Lt=ot.get(je.$$ac),Mt=ot.get(ie.$Dbc),It=ot.get(i.$Tbc),dt=ot.get(x.$lbc),kt=ot.get(et.$jM),Dt=ot.get(n.$obc),Ft=ot.get(ne.$ibc),Ge=ot.get(Ee.$2L),Me=ot.get(M.$zbc),Fe=ot.get(Y.$Ebc),Pe=ot.get(se.$6i),_=ot.get(se.$5i),Te=ot.get(le.$rsb),He=ot.get(be.$bbc),xe=ot.get(V.$fcc),Je=ot.get(Qe.$Lbc),nt=ot.get(it.$ncc),$t=ot.get(Nt.$Pbc);Ge.set(w.$2J.ExtHostFileSystemInfo,Lt),Ge.set(w.$2J.ExtHostLogLevelServiceShape,Pe),Ge.set(w.$2J.ExtHostWorkspace,dt),Ge.set(w.$2J.ExtHostConfiguration,Dt),Ge.set(w.$2J.ExtHostExtensionService,It),Ge.set(w.$2J.ExtHostStorage,Me),Ge.set(w.$2J.ExtHostTunnelService,Te),Ge.set(w.$2J.ExtHostWindow,xe),Ge.set(w.$2J.ExtHostSecretState,Je),Ge.set(w.$2J.ExtHostTelemetry,kt),Ge.set(w.$2J.ExtHostEditorTabs,nt),Ge.set(w.$2J.ExtHostManagedSockets,$t);const Pt=Ge.set(w.$2J.ExtHostDecorations,ot.get(U.$jcc)),vt=Ge.set(w.$2J.ExtHostDocumentsAndEditors,ot.get(a.$aM)),lt=Ge.set(w.$2J.ExtHostCommands,ot.get(o.$lM)),mt=Ge.set(w.$2J.ExtHostTerminalService,ot.get(j.$Gbc)),yt=Ge.set(w.$2J.ExtHostDebugService,ot.get(fe.$rcc)),gi=Ge.set(w.$2J.ExtHostSearch,ot.get(te.$Bcc)),Jt=Ge.set(w.$2J.ExtHostTask,ot.get(K.$mcc)),Qt=Ge.set(w.$2J.ExtHostOutputService,ot.get(u.$2bc)),si=Ge.set(w.$2J.ExtHostLocalization,ot.get(rt.$Obc)),ki=Ge.set(w.$2J.ExtHostUrls,new Z.$$bc(Ge)),Ct=Ge.set(w.$2J.ExtHostDocuments,new r.$9ac(Ge,vt)),Qi=Ge.set(w.$2J.ExtHostDocumentContentProviders,new h.$qbc(Ge,vt,_)),un=Ge.set(w.$2J.ExtHostDocumentSaveParticipant,new t.$rbc(_,Ct,Ge.getProxy(w.$1J.MainThreadBulkEdits))),wt=Ge.set(w.$2J.ExtHostNotebook,new he.$Hcc(Ge,lt,vt,Ct,Mt)),mi=Ge.set(w.$2J.ExtHostNotebookDocuments,new ae.$Zcc(wt)),$i=Ge.set(w.$2J.ExtHostNotebookEditors,new ce.$Ycc(_,wt)),oi=Ge.set(w.$2J.ExtHostNotebookKernels,new Ae.$Vcc(Ge,ft,wt,lt,_)),Si=Ge.set(w.$2J.ExtHostNotebookRenderers,new Ve.$Xcc(Ge,wt)),Di=Ge.set(w.$2J.ExtHostNotebookDocumentSaveParticipant,new pt.$6cc(_,wt,Ge.getProxy(w.$1J.MainThreadBulkEdits))),Tt=Ge.set(w.$2J.ExtHostEditors,new z.$9bc(Ge,vt)),bi=Ge.set(w.$2J.ExtHostTreeViews,new T.$0bc(Ge.getProxy(w.$1J.MainThreadTreeViews),lt,_)),Ci=Ge.set(w.$2J.ExtHostEditorInsets,new ue.$gcc(Ge.getProxy(w.$1J.MainThreadEditorInsets),Tt,ft.remote)),ai=Ge.set(w.$2J.ExtHostDiagnostics,new l.$abc(Ge,_,Lt,vt)),ci=Ge.set(w.$2J.ExtHostLanguages,new S.$Ybc(Ge,Ct,lt.converter,Ft)),ut=Ge.set(w.$2J.ExtHostLanguageFeatures,new y.$ebc(Ge,Ft,Ct,lt,ai,_,He,kt)),Ii=Ge.set(w.$2J.ExtHostFileSystem,new c.$Wbc(Ge,ut)),Zt=Ge.set(w.$2J.ExtHostFileSystemEventService,new d.$Xbc(Ge,_,vt)),ii=Ge.set(w.$2J.ExtHostQuickOpen,(0,P.$4bc)(Ge,dt,lt)),pi=Ge.set(w.$2J.ExtHostSCM,new O.$6bc(Ge,lt,Ct,_)),Zi=Ge.set(w.$2J.ExtHostQuickDiff,new St.$3cc(Ge,Ft)),Pi=Ge.set(w.$2J.ExtHostShare,new Bt.$8cc(Ge,Ft)),Ai=Ge.set(w.$2J.ExtHostComments,(0,s.$hbc)(Ge,lt,Ct)),Ri=Ge.set(w.$2J.ExtHostProgress,new m.$3bc(Ge.getProxy(w.$1J.MainThreadProgress))),xi=Ge.set(w.$2J.ExtHosLabelService,new ve.$hcc(Ge)),Li=Ge.set(w.$2J.ExtHostTheming,new ee.$Icc(Ge)),ui=Ge.set(w.$2J.ExtHostAuthentication,new Ie.$Jcc(Ge)),_i=Ge.set(w.$2J.ExtHostTimeline,new B.$Lcc(Ge,lt)),Mi=Ge.set(w.$2J.ExtHostWebviews,new X.$bcc(Ge,ft.remote,dt,_,He)),Fi=Ge.set(w.$2J.ExtHostWebviewPanels,new de.$Ncc(Ge,Mi,dt)),Ti=Ge.set(w.$2J.ExtHostCustomEditors,new Q.$Occ(Ge,Ct,Fe,Mi,Fi)),Oi=Ge.set(w.$2J.ExtHostWebviewViews,new re.$Mcc(Ge,Mi)),hi=Ge.set(w.$2J.ExtHostTesting,new We.$Qcc(Ge,lt,vt)),ln=Ge.set(w.$2J.ExtHostUriOpeners,new _e.$Ucc(Ge)),en=Ge.set(w.$2J.ExtHostProfileContentHandlers,new bt.$2cc(Ge));Ge.set(w.$2J.ExtHostInteractive,new Ce.$1cc(Ge,wt,vt,lt,_));const Ni=Ge.set(w.$2J.ExtHostInlineChat,new Ht.$5cc(Ge,lt,Ct,_)),di=Ge.set(w.$2J.ExtHostChatProvider,new At.$9cc(Ge,_)),tn=Ge.set(w.$2J.ExtHostChatSlashCommands,new Rt.$0cc(Ge,di,_)),nn=Ge.set(w.$2J.ExtHostChatAgents,new Vt.$bdc(Ge,di,_)),hn=Ge.set(w.$2J.ExtHostChatVariables,new jt.$$cc(Ge)),ni=Ge.set(w.$2J.ExtHostChat,new Xt.$4cc(Ge,_)),ji=Ge.set(w.$2J.ExtHostAiRelatedInformation,new Wt.$_cc(Ge)),_t=Ge.set(w.$2J.ExtHostAiEmbeddingVector,new Kt.$adc(Ge)),wi=Ge.set(w.$2J.ExtHostIssueReporter,new Ut.$7cc(Ge)),rn=Ge.set(w.$2J.ExtHostStatusBar,new N.$8bc(Ge,lt.converter)),Gt=Object.values(w.$2J);Ge.assertRegistered(Gt);const vi=new ye.$Pcc(Ge,vt),sn=new v.$gbc(Ge),yi=new g.$Zbc(Ge,_),zi=new b.$pbc(Ge);return D.$fbc.register(lt),function(ze,ei,Ui){const gt=function(){let pe=!ze.isUnderDevelopment;function ke(){pe||(_.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")ke();else{const Et=st;typeof Et.scheme>"u"&&ke(),typeof Et.exclusive=="boolean"&&(0,Ue.$YE)(ze,"documentFiltersExclusive")}return st}}(),dn={getSession(pe,ke,Ne){return ui.getSession(ze,pe,ke,Ne)},getSessions(pe,ke){return(0,Ue.$YE)(ze,"authGetSessions"),ui.getSessions(ze,pe,ke)},async hasSession(pe,ke){return(0,Ue.$YE)(ze,"authSession"),!!await ui.getSession(ze,pe,ke,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(pe,ke,Ne,st){return ui.registerAuthenticationProvider(pe,ke,Ne,st)}},fn={registerCommand(pe,ke,Ne){return lt.registerCommand(!0,pe,ke,Ne,void 0,ze)},registerTextEditorCommand(pe,ke,Ne){return lt.registerCommand(!0,pe,(...st)=>{const Et=Tt.getActiveTextEditor();if(!Et){_.warn("Cannot execute "+pe+" because there is no active text editor.");return}return Et.edit(Ot=>{ke.apply(Ne,[Et,Ot,...st])}).then(Ot=>{Ot||_.warn("Edits from command "+pe+" were not applied.")},Ot=>{_.warn("An error occurred while running command "+pe,Ot)})},void 0,void 0,ze)},registerDiffInformationCommand:(pe,ke,Ne)=>((0,Ue.$YE)(ze,"diffCommand"),lt.registerCommand(!0,pe,async(...st)=>{const Et=vt.activeEditor(!0);if(!Et){_.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Ot=await Tt.getDiffInformation(Et.id);ke.apply(Ne,[Ot,...st])},void 0,void 0,ze)),executeCommand(pe,...ke){return lt.executeCommand(pe,...ke)},getCommands(pe=!1){return lt.getCommands(pe)}},Ei={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return mt.getDefaultShell(!1)},get onDidChangeShell(){return mt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ue.$YE)(ze,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ue.$YE)(ze,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$iM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,ke){return et.$hM.validateSender(pe),kt.instantiateLogger(ze,pe,ke)},openExternal(pe,ke){return xe.openUri(pe,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===ft.environment.appUriScheme)return ki.createAppUri(pe);try{return await xe.asExternalUri(pe,{allowTunneling:!!ft.remote.authority})}catch(ke){if((0,Xe.$OT)(pe,Le.Schemas.http)||(0,Xe.$OT)(pe,Le.Schemas.https))return pe;throw ke}},get remoteName(){return(0,G.$Pk)(ft.remote.authority)},get remoteAuthority(){return(0,Ue.$YE)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return _.getLevel()},get onDidChangeLogLevel(){return _.onDidChangeLogLevel},registerIssueUriRequestHandler(pe){return(0,Ue.$YE)(ze,"handleIssueUri"),wi.registerIssueUriRequestHandler(ze,pe)},get appQuality(){return(0,Ue.$YE)(ze,"resolvers"),ft.quality},get appCommit(){return(0,Ue.$YE)(ze,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Ei);const on={createTestController(pe,ke,Ne){return hi.createTestController(ze,pe,ke,Ne)},createTestObserver(){return(0,Ue.$YE)(ze,"testObserver"),hi.createTestObserver()},runTests(pe){return(0,Ue.$YE)(ze,"testObserver"),hi.runTests(pe)},get onDidChangeTestResults(){return(0,Ue.$YE)(ze,"testObserver"),hi.onResultsChanged},get testResults(){return(0,Ue.$YE)(ze,"testObserver"),hi.results}},fi=ft.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,an={getExtension(pe,ke){(0,Ue.$XE)(ze,"extensionsAny")||(ke=!1);const Ne=ei.mine.getExtensionDescription(pe);if(Ne)return new i.$Ubc(It,ze.identifier,Ne,fi,!1);if(ke){const st=ei.all.getExtensionDescription(pe);if(st)return new i.$Ubc(It,ze.identifier,st,fi,!0)}},get all(){const pe=[];for(const ke of ei.mine.getAllExtensionDescriptions())pe.push(new i.$Ubc(It,ze.identifier,ke,fi,!1));return pe},get allAcrossExtensionHosts(){(0,Ue.$YE)(ze,"extensionsAny");const pe=new ge.$Wl(ei.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),ke=[];for(const Ne of ei.all.getAllExtensionDescriptions()){const st=!pe.has(Ne.identifier);ke.push(new i.$Ubc(It,ze.identifier,Ne,fi,st))}return ke},get onDidChange(){return(0,Ue.$XE)(ze,"extensionsAny")?f.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},gn={createDiagnosticCollection(pe){return ai.createDiagnosticCollection(ze.identifier,pe)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:pe=>ai.getDiagnostics(pe),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(pe,ke){return ci.changeLanguage(pe.uri,ke)},match(pe,ke){const Ne=Ct.getDocumentData(ke.uri)?.notebook;return(0,A.$gE)(H.LanguageSelector.from(pe),ke.uri,ke.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(pe,ke,Ne){return ut.registerCodeActionProvider(ze,gt(pe),ke,Ne)},registerDocumentPasteEditProvider(pe,ke,Ne){return(0,Ue.$YE)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,gt(pe),ke,Ne)},registerCodeLensProvider(pe,ke){return ut.registerCodeLensProvider(ze,gt(pe),ke)},registerDefinitionProvider(pe,ke){return ut.registerDefinitionProvider(ze,gt(pe),ke)},registerDeclarationProvider(pe,ke){return ut.registerDeclarationProvider(ze,gt(pe),ke)},registerImplementationProvider(pe,ke){return ut.registerImplementationProvider(ze,gt(pe),ke)},registerTypeDefinitionProvider(pe,ke){return ut.registerTypeDefinitionProvider(ze,gt(pe),ke)},registerHoverProvider(pe,ke){return ut.registerHoverProvider(ze,gt(pe),ke,ze.identifier)},registerEvaluatableExpressionProvider(pe,ke){return ut.registerEvaluatableExpressionProvider(ze,gt(pe),ke,ze.identifier)},registerInlineValuesProvider(pe,ke){return ut.registerInlineValuesProvider(ze,gt(pe),ke,ze.identifier)},registerDocumentHighlightProvider(pe,ke){return ut.registerDocumentHighlightProvider(ze,gt(pe),ke)},registerLinkedEditingRangeProvider(pe,ke){return ut.registerLinkedEditingRangeProvider(ze,gt(pe),ke)},registerReferenceProvider(pe,ke){return ut.registerReferenceProvider(ze,gt(pe),ke)},registerRenameProvider(pe,ke){return ut.registerRenameProvider(ze,gt(pe),ke)},registerDocumentSymbolProvider(pe,ke,Ne){return ut.registerDocumentSymbolProvider(ze,gt(pe),ke,Ne)},registerWorkspaceSymbolProvider(pe){return ut.registerWorkspaceSymbolProvider(ze,pe)},registerDocumentFormattingEditProvider(pe,ke){return ut.registerDocumentFormattingEditProvider(ze,gt(pe),ke)},registerDocumentRangeFormattingEditProvider(pe,ke){return ut.registerDocumentRangeFormattingEditProvider(ze,gt(pe),ke)},registerOnTypeFormattingEditProvider(pe,ke,Ne,...st){return ut.registerOnTypeFormattingEditProvider(ze,gt(pe),ke,[Ne].concat(st))},registerDocumentSemanticTokensProvider(pe,ke,Ne){return ut.registerDocumentSemanticTokensProvider(ze,gt(pe),ke,Ne)},registerDocumentRangeSemanticTokensProvider(pe,ke,Ne){return ut.registerDocumentRangeSemanticTokensProvider(ze,gt(pe),ke,Ne)},registerSignatureHelpProvider(pe,ke,Ne,...st){return typeof Ne=="object"?ut.registerSignatureHelpProvider(ze,gt(pe),ke,Ne):ut.registerSignatureHelpProvider(ze,gt(pe),ke,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(pe,ke,...Ne){return ut.registerCompletionItemProvider(ze,gt(pe),ke,Ne)},registerInlineCompletionItemProvider(pe,ke,Ne){return ke.handleDidShowCompletionItem&&(0,Ue.$YE)(ze,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,Ue.$YE)(ze,"inlineCompletionsAdditions"),Ne&&(0,Ue.$YE)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,gt(pe),ke,Ne)},registerDocumentLinkProvider(pe,ke){return ut.registerDocumentLinkProvider(ze,gt(pe),ke)},registerColorProvider(pe,ke){return ut.registerColorProvider(ze,gt(pe),ke)},registerFoldingRangeProvider(pe,ke){return ut.registerFoldingRangeProvider(ze,gt(pe),ke)},registerSelectionRangeProvider(pe,ke){return ut.registerSelectionRangeProvider(ze,pe,ke)},registerCallHierarchyProvider(pe,ke){return ut.registerCallHierarchyProvider(ze,pe,ke)},registerTypeHierarchyProvider(pe,ke){return ut.registerTypeHierarchyProvider(ze,pe,ke)},setLanguageConfiguration:(pe,ke)=>ut.setLanguageConfiguration(ze,pe,ke),getTokenInformationAtPosition(pe,ke){return(0,Ue.$YE)(ze,"tokenInformation"),ci.tokenAtPosition(pe,ke)},registerInlayHintsProvider(pe,ke){return ut.registerInlayHintsProvider(ze,pe,ke)},createLanguageStatusItem(pe,ke){return ci.createLanguageStatusItem(ze,pe,ke)},registerDocumentDropEditProvider(pe,ke,Ne){return ut.registerDocumentOnDropEditProvider(ze,pe,ke,(0,Ue.$XE)(ze,"dropMetadata")?Ne:void 0)}},mn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(pe,ke,Ne){const st=await(R.URI.isUri(pe)?Promise.resolve(Bi.openTextDocument(pe)):Promise.resolve(pe));return Tt.showTextDocument(st,ke,Ne)},createTextEditorDecorationType(pe){return Tt.createTextEditorDecorationType(ze,pe)},onDidChangeActiveTextEditor(pe,ke,Ne){return Tt.onDidChangeActiveTextEditor(pe,ke,Ne)},onDidChangeVisibleTextEditors(pe,ke,Ne){return Tt.onDidChangeVisibleTextEditors(pe,ke,Ne)},onDidChangeTextEditorSelection(pe,ke,Ne){return Tt.onDidChangeTextEditorSelection(pe,ke,Ne)},onDidChangeTextEditorOptions(pe,ke,Ne){return Tt.onDidChangeTextEditorOptions(pe,ke,Ne)},onDidChangeTextEditorVisibleRanges(pe,ke,Ne){return Tt.onDidChangeTextEditorVisibleRanges(pe,ke,Ne)},onDidChangeTextEditorViewColumn(pe,ke,Ne){return Tt.onDidChangeTextEditorViewColumn(pe,ke,Ne)},onDidCloseTerminal(pe,ke,Ne){return mt.onDidCloseTerminal(pe,ke,Ne)},onDidOpenTerminal(pe,ke,Ne){return mt.onDidOpenTerminal(pe,ke,Ne)},onDidChangeActiveTerminal(pe,ke,Ne){return mt.onDidChangeActiveTerminal(pe,ke,Ne)},onDidChangeTerminalDimensions(pe,ke,Ne){return(0,Ue.$YE)(ze,"terminalDimensions"),mt.onDidChangeTerminalDimensions(pe,ke,Ne)},onDidChangeTerminalState(pe,ke,Ne){return mt.onDidChangeTerminalState(pe,ke,Ne)},onDidWriteTerminalData(pe,ke,Ne){return(0,Ue.$YE)(ze,"terminalDataWriteEvent"),mt.onDidWriteTerminalData(pe,ke,Ne)},onDidExecuteTerminalCommand(pe,ke,Ne){return(0,Ue.$YE)(ze,"terminalExecuteCommandEvent"),mt.onDidExecuteTerminalCommand(pe,ke,Ne)},get state(){return xe.getState(ze)},onDidChangeWindowState(pe,ke,Ne){return xe.onDidChangeWindowState(pe,ke,Ne)},showInformationMessage(pe,...ke){return yi.showMessage(ze,L.default.Info,pe,ke[0],ke.slice(1))},showWarningMessage(pe,...ke){return yi.showMessage(ze,L.default.Warning,pe,ke[0],ke.slice(1))},showErrorMessage(pe,...ke){return yi.showMessage(ze,L.default.Error,pe,ke[0],ke.slice(1))},showQuickPick(pe,ke,Ne){return ii.showQuickPick(ze,pe,ke,Ne)},showWorkspaceFolderPick(pe){return ii.showWorkspaceFolderPick(pe)},showInputBox(pe,ke){return ii.showInput(pe,ke)},showOpenDialog(pe){return zi.showOpenDialog(ze,pe)},showSaveDialog(pe){return zi.showSaveDialog(pe)},createStatusBarItem(pe,ke,Ne){let st,Et,Ot;return typeof pe=="string"?(st=pe,Et=ke,Ot=Ne):(Et=pe,Ot=ke),rn.createStatusBarEntry(ze,st,Et,Ot)},setStatusBarMessage(pe,ke){return rn.setStatusBarMessage(pe,ke)},withScmProgress(pe){return He.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ri.withProgress(ze,{location:q.ProgressLocation.SourceControl},(ke,Ne)=>pe({report(st){}}))},withProgress(pe,ke){return Ri.withProgress(ze,pe,ke)},createOutputChannel(pe,ke){return Qt.createOutputChannel(pe,ke,ze)},createWebviewPanel(pe,ke,Ne,st){return Fi.createWebviewPanel(ze,pe,ke,Ne,st)},createWebviewTextEditorInset(pe,ke,Ne,st){return(0,Ue.$YE)(ze,"editorInsets"),Ci.createWebviewEditorInset(pe,ke,Ne,st,ze)},createTerminal(pe,ke,Ne){return typeof pe=="object"?"pty"in pe?mt.createExtensionTerminal(pe):mt.createTerminalFromOptions(pe):mt.createTerminal(pe,ke,Ne)},registerTerminalLinkProvider(pe){return mt.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,ke){return mt.registerProfileProvider(ze,pe,ke)},registerTerminalQuickFixProvider(pe,ke){return(0,Ue.$YE)(ze,"terminalQuickFixProvider"),mt.registerTerminalQuickFixProvider(pe,ze.identifier.value,ke)},registerTreeDataProvider(pe,ke){return bi.registerTreeDataProvider(pe,ke,ze)},createTreeView(pe,ke){return bi.createTreeView(pe,ke,ze)},registerWebviewPanelSerializer:(pe,ke)=>Fi.registerWebviewPanelSerializer(ze,pe,ke),registerCustomEditorProvider:(pe,ke,Ne={})=>Ti.registerCustomEditorProvider(ze,pe,ke,Ne),registerFileDecorationProvider(pe){return Pt.registerFileDecorationProvider(pe,ze)},registerUriHandler(pe){return ki.registerUriHandler(ze,pe)},createQuickPick(){return ii.createQuickPick(ze)},createInputBox(){return ii.createInputBox(ze)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(pe,ke,Ne){return Li.onDidChangeActiveColorTheme(pe,ke,Ne)},registerWebviewViewProvider(pe,ke,Ne){return Oi.registerWebviewViewProvider(ze,pe,ke,Ne?.webviewOptions)},get activeNotebookEditor(){return wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,ke,Ne){return wt.onDidChangeActiveNotebookEditor(pe,ke,Ne)},get visibleNotebookEditors(){return wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,ke,Ne){return $i.onDidChangeNotebookEditorSelection(pe,ke,Ne)},onDidChangeNotebookEditorVisibleRanges(pe,ke,Ne){return $i.onDidChangeNotebookEditorVisibleRanges(pe,ke,Ne)},showNotebookDocument(pe,ke){return wt.showNotebookDocument(pe,ke)},registerExternalUriOpener(pe,ke,Ne){return(0,Ue.$YE)(ze,"externalUriOpener"),ln.registerExternalUriOpener(ze.identifier,pe,ke,Ne)},registerProfileContentHandler(pe,ke){return(0,Ue.$YE)(ze,"profileContentHandlers"),en.registrProfileContentHandler(ze,pe,ke)},registerQuickDiffProvider(pe,ke,Ne,st){return(0,Ue.$YE)(ze,"quickDiffProvider"),Zi.registerQuickDiffProvider(gt(pe),ke,Ne,st)},get tabGroups(){return nt.tabGroups},registerShareProvider(pe,ke){return(0,Ue.$YE)(ze,"shareProvider"),Pi.registerShareProvider(gt(pe),ke)}},Bi={get rootPath(){return He.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(pe){throw new F.$7("rootPath")},getWorkspaceFolder(pe){return dt.getWorkspaceFolder(pe)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(pe){throw new F.$7("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(pe){throw new F.$7("workspaceFile")},updateWorkspaceFolders:(pe,ke,...Ne)=>dt.updateWorkspaceFolders(ze,pe,ke||0,...Ne),onDidChangeWorkspaceFolders:function(pe,ke,Ne){return dt.onDidChangeWorkspace(pe,ke,Ne)},asRelativePath:(pe,ke)=>dt.getRelativePath(pe,ke),findFiles:(pe,ke,Ne,st)=>dt.findFiles(pe,ke,Ne,ze.identifier,st),findTextInFiles:(pe,ke,Ne,st)=>{(0,Ue.$YE)(ze,"findTextInFiles");let Et,Ot;return typeof ke=="object"?(Et=ke,Ot=Ne):(Et={},Ot=ke,st=Ne),dt.findTextInFiles(pe,Et||{},Ot,ze.identifier,st)},save:pe=>((0,Ue.$YE)(ze,"saveEditor"),dt.save(pe)),saveAs:pe=>((0,Ue.$YE)(ze,"saveEditor"),dt.saveAs(pe)),saveAll:pe=>dt.saveAll(pe),applyEdit(pe,ke){return vi.applyWorkspaceEdit(pe,ze,ke)},createFileSystemWatcher:(pe,ke,Ne,st)=>Zt.createFileSystemWatcher(dt,ze,pe,ke,Ne,st),get textDocuments(){return Ct.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw new F.$7("textDocuments")},openTextDocument(pe){let ke;const Ne=pe;if(typeof pe=="string")ke=Promise.resolve(R.URI.file(pe));else if(R.URI.isUri(pe))ke=Promise.resolve(pe);else if(!Ne||typeof Ne=="object")ke=Ct.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>Ct.ensureDocumentData(st).then(Et=>Et.document))},onDidOpenTextDocument:(pe,ke,Ne)=>Ct.onDidAddDocument(pe,ke,Ne),onDidCloseTextDocument:(pe,ke,Ne)=>Ct.onDidRemoveDocument(pe,ke,Ne),onDidChangeTextDocument:(pe,ke,Ne)=>Ct.onDidChangeDocument(pe,ke,Ne),onDidSaveTextDocument:(pe,ke,Ne)=>Ct.onDidSaveDocument(pe,ke,Ne),onWillSaveTextDocument:(pe,ke,Ne)=>un.getOnWillSaveTextDocumentEvent(ze)(pe,ke,Ne),get notebookDocuments(){return wt.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,ke){let Ne;if(R.URI.isUri(pe))Ne=pe,await wt.openNotebookDocument(pe);else if(typeof pe=="string")Ne=R.URI.revive(await wt.createNotebookDocument({viewType:pe,content:ke}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(pe,ke,Ne){return mi.onDidSaveNotebookDocument(pe,ke,Ne)},onDidChangeNotebookDocument(pe,ke,Ne){return mi.onDidChangeNotebookDocument(pe,ke,Ne)},onWillSaveNotebookDocument(pe,ke,Ne){return Di.getOnWillSaveNotebookDocumentEvent(ze)(pe,ke,Ne)},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(pe,ke,Ne,st){return wt.registerNotebookSerializer(ze,pe,ke,Ne,(0,Ue.$XE)(ze,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(pe,ke,Ne)=>Ui.onDidChangeConfiguration(pe,ke,Ne),getConfiguration(pe,ke){return ke=arguments.length===1?void 0:ke,Ui.getConfiguration(pe,ke,ze)},registerTextDocumentContentProvider(pe,ke){return Qi.registerTextDocumentContentProvider(pe,ke)},registerTaskProvider:(pe,ke)=>(He.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(ze,pe,ke)),registerFileSystemProvider(pe,ke,Ne){return(0,qe.$hc)(Ii.registerFileSystemProvider(ze,pe,ke,Ne),Mt.addFileSystemProvider(pe,ke,Ne))},get fs(){return Mt.value},registerFileSearchProvider:(pe,ke)=>((0,Ue.$YE)(ze,"fileSearchProvider"),gi.registerFileSearchProvider(pe,ke)),registerTextSearchProvider:(pe,ke)=>((0,Ue.$YE)(ze,"textSearchProvider"),gi.registerTextSearchProvider(pe,ke)),registerRemoteAuthorityResolver:(pe,ke)=>((0,Ue.$YE)(ze,"resolvers"),It.registerRemoteAuthorityResolver(pe,ke)),registerResourceLabelFormatter:pe=>((0,Ue.$YE)(ze,"resolvers"),xi.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,Ue.$YE)(ze,"resolvers"),It.getRemoteExecServer(pe)),onDidCreateFiles:(pe,ke,Ne)=>Zt.onDidCreateFile(pe,ke,Ne),onDidDeleteFiles:(pe,ke,Ne)=>Zt.onDidDeleteFile(pe,ke,Ne),onDidRenameFiles:(pe,ke,Ne)=>Zt.onDidRenameFile(pe,ke,Ne),onWillCreateFiles:(pe,ke,Ne)=>Zt.getOnWillCreateFileEvent(ze)(pe,ke,Ne),onWillDeleteFiles:(pe,ke,Ne)=>Zt.getOnWillDeleteFileEvent(ze)(pe,ke,Ne),onWillRenameFiles:(pe,ke,Ne)=>Zt.getOnWillRenameFileEvent(ze)(pe,ke,Ne),openTunnel:pe=>((0,Ue.$YE)(ze,"tunnels"),Te.openTunnel(ze,pe).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,Ue.$YE)(ze,"tunnels"),Te.getTunnels()},onDidChangeTunnels:(pe,ke,Ne)=>((0,Ue.$YE)(ze,"tunnels"),Te.onDidChangeTunnels(pe,ke,Ne)),registerPortAttributesProvider:(pe,ke)=>((0,Ue.$YE)(ze,"portsAttributes"),Te.registerPortsAttributesProvider(pe,ke)),registerTunnelProvider:(pe,ke)=>((0,Ue.$YE)(ze,"tunnelFactory"),Te.registerTunnelProvider(pe,ke)),registerTimelineProvider:(pe,ke)=>((0,Ue.$YE)(ze,"timeline"),_i.registerTimelineProvider(pe,ke,ze.identifier,lt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:pe=>((0,Ue.$YE)(ze,"workspaceTrust"),dt.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,ke,Ne)=>dt.onDidGrantWorkspaceTrust(pe,ke,Ne),registerEditSessionIdentityProvider:(pe,ke)=>((0,Ue.$YE)(ze,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(pe,ke)),onWillCreateEditSessionIdentity:(pe,ke,Ne)=>((0,Ue.$YE)(ze,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(ze)(pe,ke,Ne)),registerCanonicalUriProvider:(pe,ke)=>((0,Ue.$YE)(ze,"canonicalUriProvider"),dt.registerCanonicalUriProvider(pe,ke)),getCanonicalUri:(pe,ke,Ne)=>((0,Ue.$YE)(ze,"canonicalUriProvider"),dt.provideCanonicalUri(pe,ke,Ne))},cn={get inputBox(){return He.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(ze)},createSourceControl(pe,ke,Ne){return pi.createSourceControl(ze,pe,ke,Ne)}},Wi={createCommentController(pe,ke){return Ai.createCommentController(ze,pe,ke)}},Vi={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(pe,ke,Ne){return yt.onDidStartDebugSession(pe,ke,Ne)},onDidTerminateDebugSession(pe,ke,Ne){return yt.onDidTerminateDebugSession(pe,ke,Ne)},onDidChangeActiveDebugSession(pe,ke,Ne){return yt.onDidChangeActiveDebugSession(pe,ke,Ne)},onDidReceiveDebugSessionCustomEvent(pe,ke,Ne){return yt.onDidReceiveDebugSessionCustomEvent(pe,ke,Ne)},onDidChangeBreakpoints(pe,ke,Ne){return yt.onDidChangeBreakpoints(pe,ke,Ne)},onDidChangeStackFrameFocus(pe,ke,Ne){return(0,Ue.$YE)(ze,"debugFocus"),yt.onDidChangeStackFrameFocus(pe,ke,Ne)},registerDebugConfigurationProvider(pe,ke,Ne){return yt.registerDebugConfigurationProvider(pe,ke,Ne||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,ke){return yt.registerDebugAdapterDescriptorFactory(ze,pe,ke)},registerDebugAdapterTrackerFactory(pe,ke){return yt.registerDebugAdapterTrackerFactory(pe,ke)},startDebugging(pe,ke,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?yt.startDebugging(pe,ke,{parentSession:Ne}):yt.startDebugging(pe,ke,Ne||{})},stopDebugging(pe){return yt.stopDebugging(pe)},addBreakpoints(pe){return yt.addBreakpoints(pe)},removeBreakpoints(pe){return yt.removeBreakpoints(pe)},asDebugSourceUri(pe,ke){return yt.asDebugSourceUri(pe,ke)}},qi={registerTaskProvider:(pe,ke)=>Jt.registerTaskProvider(ze,pe,ke),fetchTasks:pe=>Jt.fetchTasks(pe),executeTask:pe=>Jt.executeTask(ze,pe),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(pe,ke,Ne)=>Jt.onDidStartTask(pe,ke,Ne),onDidEndTask:(pe,ke,Ne)=>Jt.onDidEndTask(pe,ke,Ne),onDidStartTaskProcess:(pe,ke,Ne)=>Jt.onDidStartTaskProcess(pe,ke,Ne),onDidEndTaskProcess:(pe,ke,Ne)=>Jt.onDidEndTaskProcess(pe,ke,Ne)},li={createNotebookController(pe,ke,Ne,st,Et){return oi.createNotebookController(ze,pe,ke,Ne,st,(0,Ue.$XE)(ze,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(pe,ke)=>wt.registerNotebookCellStatusBarItemProvider(ze,pe,ke),createRendererMessaging(pe){return Si.createRendererMessaging(ze,pe)},createNotebookControllerDetectionTask(pe){return(0,Ue.$YE)(ze,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(ze,pe)},registerKernelSourceActionProvider(pe,ke){return(0,Ue.$YE)(ze,"notebookKernelSource"),oi.registerKernelSourceActionProvider(ze,pe,ke)},onDidChangeNotebookCellExecutionState(pe,ke,Ne){return(0,Ue.$YE)(ze,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(pe,ke,Ne)}},Hi={t(...pe){if(typeof pe[0]=="string"){const ke=pe.shift(),Ne=!pe||typeof pe[0]!="object"?pe:pe[0];return si.getMessage(ze.identifier.value,{message:ke,args:Ne})}return si.getMessage(ze.identifier.value,pe[0])},get bundle(){return si.getBundle(ze.identifier.value)},get uri(){return si.getBundleUri(ze.identifier.value)}},Ki={_version:1,registerInteractiveEditorSessionProvider(pe,ke){return(0,Ue.$YE)(ze,"interactive"),Ni.registerProvider(ze,pe,ke={label:ke?.label??ze.displayName??ze.name})},registerInteractiveSessionProvider(pe,ke){return(0,Ue.$YE)(ze,"interactive"),ni.registerChatProvider(ze,pe,ke)},addInteractiveRequest(pe){return(0,Ue.$YE)(ze,"interactive"),ni.addChatRequest(pe)},sendInteractiveRequestToProvider(pe,ke){return(0,Ue.$YE)(ze,"interactive"),ni.sendInteractiveRequestToProvider(pe,ke)},get onDidPerformUserAction(){return(0,Ue.$YE)(ze,"interactiveUserActions"),ni.onDidPerformUserAction},transferChatSession(pe,ke){return(0,Ue.$YE)(ze,"interactive"),ni.transferChatSession(pe,ke)}},Ji={getRelatedInformation(pe,ke){return(0,Ue.$YE)(ze,"aiRelatedInformation"),ji.getRelatedInformation(ze,pe,ke)},registerRelatedInformationProvider(pe,ke){return(0,Ue.$YE)(ze,"aiRelatedInformation"),ji.registerRelatedInformationProvider(ze,pe,ke)},registerEmbeddingVectorProvider(pe,ke){return(0,Ue.$YE)(ze,"aiRelatedInformation"),_t.registerEmbeddingVectorProvider(ze,pe,ke)}},Gi={registerChatResponseProvider(pe,ke,Ne){return(0,Ue.$YE)(ze,"chatProvider"),di.registerProvider(ze.identifier,pe,ke,Ne)},registerSlashCommand(pe,ke,Ne){return(0,Ue.$YE)(ze,"chatSlashCommands"),tn.registerCommand(ze.identifier,pe,ke,Ne??{description:""})},requestChatAccess(pe){return(0,Ue.$YE)(ze,"chatRequestAccess"),di.requestChatResponseProvider(ze.identifier,pe)},registerVariable(pe,ke,Ne){return(0,Ue.$YE)(ze,"chatVariables"),hn.registerVariableResolver(ze,pe,ke,Ne)},registerMappedEditsProvider(pe,ke){return(0,Ue.$YE)(ze,"mappedEditsProvider"),ut.registerMappedEditsProvider(ze,pe,ke)},registerAgent(pe,ke,Ne){return(0,Ue.$YE)(ze,"chatAgents"),nn.registerAgent(ze.identifier,pe,ke,Ne)}};return{version:ft.version,ai:Ji,authentication:dn,commands:fn,comments:Wi,chat:Gi,debug:Vi,env:Ei,extensions:an,interactive:Ki,l10n:Hi,languages:gn,notebooks:li,scm:cn,tasks:qi,tests:on,window:mn,workspace:Bi,Breakpoint:q.$1K,TerminalOutputAnchor:q.TerminalOutputAnchor,ChatMessage:q.$QL,ChatMessageRole:q.ChatMessageRole,ChatVariableLevel:q.ChatVariableLevel,CallHierarchyIncomingCall:q.$nK,CallHierarchyItem:q.$mK,CallHierarchyOutgoingCall:q.$oK,CancellationError:F.$3,CancellationTokenSource:C.$pd,CandidatePortSource:w.CandidatePortSource,CodeAction:q.$jK,CodeActionKind:q.$kK,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.$pK,Color:q.$CK,ColorInformation:q.$DK,ColorPresentation:q.$EK,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentState:q.CommentState,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CompletionItem:q.$wK,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.$xK,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.$MK,DebugAdapterExecutable:q.$5K,DebugAdapterInlineImplementation:q.$8K,DebugAdapterNamedPipeServer:q.$7K,DebugAdapterServer:q.$6K,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.$eK,DiagnosticRelatedInformation:q.$dK,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.$3J,DocumentHighlight:q.$gK,DocumentHighlightKind:q.DocumentHighlightKind,DocumentLink:q.$BK,DocumentSymbol:q.$iK,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.$$K,InlineValueText:q.$_K,InlineValueVariableLookup:q.$aL,InlineValueEvaluatableExpression:q.$bL,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:f.$fd,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.$lL,FileDecoration2:q.$lL,FileSystemError:q.$dL,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:q.$eL,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.$3K,InlineCompletionItem:q.$yK,InlineCompletionList:q.$zK,Hover:q.$fK,IndentAction:p.IndentAction,Location:q.$cK,MarkdownString:q.$qK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:q.$rK,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.$4J,ProcessExecution:q.$KK,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.$kL,Range:q.$5J,RelativePattern:q.$YK,Selection:q.$6J,SelectionRange:q.$lK,SemanticTokens:q.$hL,SemanticTokensBuilder:q.$gL,SemanticTokensEdit:q.$iL,SemanticTokensEdits:q.$jL,SemanticTokensLegend:q.$fL,ShellExecution:q.$LK,ShellQuoting:q.ShellQuoting,SignatureHelp:q.$tK,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.$sK,SnippetString:q.$bK,SourceBreakpoint:q.$2K,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.$hK,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.$NK,TaskGroup:q.$JK,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.$FK,TerminalQuickFixExecuteTerminalCommand:q.$HK,TerminalQuickFixOpener:q.$GK,TerminalLocation:q.TerminalLocation,TerminalProfile:q.$IK,TerminalExitReason:q.TerminalExitReason,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.$0J,SnippetTextEdit:q.$_J,TextEditorCursorStyle:$.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,SyntaxTokenType:q.SyntaxTokenType,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.$XK,ThemeIcon:q.$WK,TreeItem:q.$OK,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.$GL,UIKind:k.UIKind,Uri:R.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.$aK,DocumentDropEdit:q.$UK,DocumentPasteEdit:q.$VK,InlayHint:q.$vK,InlayHintLabelPart:q.$uK,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.$9J,ResolvedAuthority:q.$7J,ManagedResolvedAuthority:q.$8J,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.$vL,NotebookRange:q.$nL,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.$oL,NotebookData:q.$pL,NotebookRendererScript:q.$tL,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.$rL,NotebookCellOutputItem:q.$qL,NotebookCellStatusBarItem:q.$sL,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.$$J,NotebookKernelSourceAction:q.$uL,PortAttributes:q.$xL,LinkedEditingRanges:q.$wL,TestResultState:q.TestResultState,TestRunRequest:q.$yL,TestMessage:q.$zL,TestMessage2:q.$zL,TestTag:q.$AL,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:Oe.TextSearchCompleteMessageType,DataTransfer:q.$TK,DataTransferItem:q.$PK,CoveredCount:q.$BL,FileCoverage:q.$CL,StatementCoverage:q.$DL,BranchCoverage:q.$EL,FunctionCoverage:q.$FL,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.$HL,TabInputTextDiff:q.$IL,TabInputTextMerge:q.$JL,TabInputCustom:q.$KL,TabInputNotebook:q.$ML,TabInputNotebookDiff:q.$NL,TabInputWebview:q.$LL,TabInputTerminal:q.$OL,TabInputInteractiveWindow:q.$PL,TelemetryTrustedValue:me.$_n,LogLevel:se.LogLevel,EditSessionIdentityMatch:at.EditSessionIdentityMatch,InteractiveSessionVoteDirection:q.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:q.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:q.InteractiveEditorResponseFeedbackKind,StackFrameFocus:q.$9K,ThreadFocus:q.$0K,RelatedInformationType:q.RelatedInformationType}}}e.$cdc=qt}),define(Se[356],De([1,0,104,152,39,149,40,33,71,44,94,95,96,115,74,90,151,73,54,114,89,72,150,14,55,112,113]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b,h,t,r,a,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$mr)(i.$Obc,i.$Nbc,1),(0,C.$mr)(r.$6i,t.$ddc,1),(0,C.$mr)(v.$bbc,v.$cbc,1),(0,C.$mr)($.$lM,$.$kM,0),(0,C.$mr)(R.$obc,R.$mbc,0),(0,C.$mr)(s.$Dbc,s.$Cbc,0),(0,C.$mr)(I.$rcc,I.$vcc,0),(0,C.$mr)(L.$jcc,L.$icc,0),(0,C.$mr)(E.$aM,E.$_L,0),(0,C.$mr)(c.$Pbc,c.$Qbc,0),(0,C.$mr)(n.$$ac,n.$0ac,0),(0,C.$mr)(F.$2bc,F.$1bc,1),(0,C.$mr)(w.$Bcc,w.$Ccc,0),(0,C.$mr)(k.$zbc,k.$ybc,0),(0,C.$mr)(A.$mcc,A.$lcc,0),(0,C.$mr)(p.$Gbc,p.$Jbc,0),(0,C.$mr)(D.$rsb,D.$ssb,0),(0,C.$mr)(o.$fcc,o.$ecc,0),(0,C.$mr)(f.$lbc,f.$kbc,0),(0,C.$mr)(l.$Lbc,l.$Kbc,0),(0,C.$mr)(b.$jM,b.$gM,0),(0,C.$mr)(h.$ncc,h.$occ,0),(0,C.$mr)(a.$pcc,a.$qcc,0)}),define(Se[116],De([1,0,19,14,36,93]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=e.$tdc=void 0;function R(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$tdc=R;function $(I,w,k,D){const v=(0,C.$Zb)(k,E),o=new f.$wI(w,v,D),s=o.preview.matches;return{ranges:(0,C.$Zb)(v,p),uri:I,preview:{text:o.preview.text,matches:(0,C.$Zb)(s,p)}}}e.$udc=$;function E(I){return new f.$xI(I.start.line,I.start.character,I.end.line,I.end.character)}function p(I){return new L.$lI(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let A=class{constructor(w,k){this.a=w,this.b=k}appendLine(w){this.b.debug(`${this.a}#search`,w)}};e.$vdc=A,e.$vdc=A=Ke([Be(1,F.$5i)],A)}),define(Se[357],De([1,0,48,16,77,32,12,15,116,358]),function($e,e,C,F,f,L,R,$,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=e.$xdc=e.$wdc=void 0;const A=p.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(l,b,h,t){const r=w(l,b,h,t),a=b.folder.fsPath;return{cmd:C.spawn(A,r.args,{cwd:a}),rgDiskPath:A,siblingClauses:r.siblingClauses,rgArgs:r,cwd:a}}e.$wdc=I;function w(l,b,h,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];D([b],h,!1).forEach(i=>{const c=(0,E.$tdc)(i);if(r.push("-g",c),R.$j){const d=(0,f.$il)(c);d!==c&&r.push("-g",d)}});const a=k([b],t,void 0,!1);return a.globArgs.forEach(i=>{const c=`!${(0,E.$tdc)(i)}`;if(r.push("-g",c),R.$j){const d=(0,f.$il)(c);d!==c&&r.push("-g",d)}}),b.disregardIgnoreFiles!==!1?r.push("--no-ignore"):b.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),b.ignoreSymlinks||r.push("--follow"),l.exists&&r.push("--quiet"),r.push("--no-config"),b.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:a.siblingClauses}}function k(l,b,h,t=!0){const r=[];let a={};return l.forEach(i=>{const c=Object.assign({},i.excludePattern||{},b||{}),d=v(c,t?i.folder.fsPath:void 0,h);r.push(...d.globArgs),d.siblingClauses&&(a=Object.assign(a,d.siblingClauses))}),{globArgs:r,siblingClauses:a}}function D(l,b,h=!0){const t=[];return l.forEach(r=>{const a=Object.assign({},b||{},r.includePattern||{}),i=v(a,h?r.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function v(l,b,h){const t=[],r={};return Object.keys(l).forEach(a=>{if(h&&h.has(a)||!a)return;const i=l[a];a=s(b?o(b,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof i=="boolean"&&i?(a.startsWith("\\\\")&&(a+="**"),t.push(n(a))):i&&i.when&&(r[a]=i)}),{globArgs:t,siblingClauses:r}}function o(l,b){return F.$8d(b)?b:F.$9d(l,b)}e.$xdc=o;function s(l){return l=$.$ve(l,"\\"),$.$ve(l,"/")}function n(l){return L.$Ef(l).toLowerCase()==="c:/"?l.replace(/^c:[/\\]/i,"/"):l}e.$ydc=n}),define(Se[359],De([1,0,48,52,16,360,19,46,35,77,32,12,37,15,18,29,36,357,127]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=e.$zdc=void 0;const l=new Set;process.on("exit",()=>{l.forEach(a=>a())});class b{constructor(i){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=i,this.b=i.filePattern||"",this.d=i.includePattern&&E.$rj(i.includePattern),this.f=i.maxResults||null,this.g=!!i.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,n.$oq)(this.b).normalizedLowercase),this.u=i.excludePattern&&E.$rj(i.excludePattern),this.t=new Map,i.folderQueries.forEach(c=>{const d=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),y=c.folder.fsPath;i.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==y).forEach(S=>{(0,A.$If)(S,y)&&(d[f.$$d(y,S)]=!0)}),this.t.set(y,new t(d,y))})}cancel(){this.l=!0,l.forEach(i=>i())}walk(i,c,d,y,S){if(this.m=w.$bd.create(!1),this.l)return S(null,this.j);c.forEach(g=>{const u=f.$ae(g.fsPath);this.u&&this.u(g.fsPath,u)||this.J(d,{relativePath:g.fsPath,searchPath:void 0})}),this.r=w.$bd.create(!1),this.w(i,(g,u)=>{this.x(this.y,this,g,d,y,m=>{if(m){const P=(0,$.$mi)(m);console.error(P),this.q.push(P),u(m,void 0)}else u(null,void 0)})},(g,u)=>{this.m.stop();const m=g?R.$Fb(g)[0]:null;S(m,this.j)})}w(i,c,d){const y=new Array(i.length),S=new Array(i.length);let g=!1,u=0;if(i.length===0)return d(null,[]);i.forEach((m,P)=>{c(m,(O,N)=>{if(O?(g=!0,y[P]=null,S[P]=O):(y[P]=N,S[P]=null),++u===i.length)return d(g?S:null,y)})})}x(i,c,...d){try{i.apply(c,d)}catch(y){d[d.length-1](y)}}y(i,c,d,y){const S=i.folder.fsPath,g=I.$j,u=()=>M&&M.kill();l.add(u);let m=H=>{l.delete(u),m=()=>{},y(H)},P="";const O=this.D(),N=(0,s.$wdc)(this.a,i,this.a.includePattern,this.t.get(i.folder.fsPath).expression),M=N.cmd,j=!Object.keys(N.siblingClauses).length,z=N.rgArgs.args.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");let T=`${N.rgDiskPath} ${z}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),d({message:T}),this.s=0,this.z(M,"utf8",d,(H,q,me)=>{if(H){m(H);return}if(this.j){m();return}const X=(P+(g?p.$hl(q||""):q)).split(`
`);if(me){const V=X.length;X[V-1]=X[V-1].trim(),X[V-1]||X.pop()}else P=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){m(new Error("Splitting up files failed"));return}if(this.s+=X.length,j){for(const V of X)if(this.J(c,{base:S,relativePath:V,searchPath:this.N(i,V)}),this.j){u();break}(me||this.j)&&m();return}this.G(i,O,S,X,c),me&&(this.H(O,S,c),m())})}spawnFindCmd(i){const c=this.t.get(i.folder.fsPath),d=c.getBasenameTerms(),y=c.getPathTerms(),S=["-L","."];if(d.length||y.length){S.push("-not","(","(");for(const g of d)S.push("-name",g),S.push("-o");for(const g of y)S.push("-path",g),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),C.spawn("find",S,{cwd:i.folder.fsPath})}readStdout(i,c,d){let y="";this.z(i,c,()=>{},(S,g,u)=>{if(S){d(S);return}y+=g,u&&d(null,y)})}z(i,c,d,y){let S=(m,P,O)=>{(m||O)&&(S=()=>{},this.r?.stop()),y(m,P,O)},g=!1;i.stdout?(this.A(i.stdout,c,S),i.stdout.once("data",()=>g=!0)):d({message:"stdout is null"});let u;i.stderr?u=this.B(i.stderr):d({message:"stderr is null"}),i.on("error",m=>{S(m)}),i.on("close",m=>{let P;!g&&(P=this.C(u,c))&&r(P)?S(new Error(`command failed with error code ${m}: ${this.C(u,c)}`)):(this.g&&m===0&&(this.j=!0),S(null,"",!0))})}A(i,c,d){const y=new L.StringDecoder(c);return i.on("data",S=>{d(null,y.write(S))}),y}B(i){const c=[];return i.on("data",d=>{c.push(d)}),c}C(i,c){const d=new L.StringDecoder(c);return i.map(y=>d.write(y)).join("")}D(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}G(i,{pathToEntries:c},d,y,S){y.indexOf(this.b)!==-1&&this.J(S,{base:d,relativePath:this.b,searchPath:this.N(i,this.b)});const g=u=>{const m=f.$ae(u),P=f.$_d(u);let O=c[P];O||(O=c[P]=[],g(P)),O.push({base:d,relativePath:u,basename:m,searchPath:this.N(i,u)})};y.forEach(g)}H({rootEntries:i,pathToEntries:c},d,y){const S=this,g=this.t.get(d),u=this.b;function m(P){S.o++;const O=(0,o.$MI)(()=>P.map(N=>N.basename));for(let N=0,M=P.length;N<M;N++){const j=P[N],{relativePath:z,basename:T}=j;if(g.test(z,T,u!==T?O:void 0))continue;const H=c[z];if(H)m(H);else{if(S.p++,z===u)continue;S.J(y,j)}if(S.j)break}}m(i)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(i,c,d,y,S){const g=i.folder,u=(0,o.$MI)(()=>d);this.w(d,(m,P)=>{if(this.l||this.j)return P(null);const O=c?[c,m].join(f.sep):m;if(this.t.get(i.folder.fsPath).test(O,m,this.a.filePattern!==m?u:void 0))return P(null);const N=[g.fsPath,O].join(f.sep);F.lstat(N,(M,j)=>{if(M||this.l||this.j)return P(null);this.L(N,j,(z,T)=>z||this.l||this.j?P(null):T.isDirectory()?(this.o++,this.M(N,j,(H,q)=>H||this.l||this.j||(q=q||"",this.v[q])?P(null):(this.v[q]=!0,v.Promises.readdir(N).then(me=>{if(this.l||this.j)return P(null);this.I(i,O,me,y,Z=>P(Z||null))},me=>{P(null)})))):(this.p++,O===this.b||this.h&&D.$nf(T.size)&&T.size>this.h||this.J(y,{base:g.fsPath,relativePath:O,searchPath:this.N(i,O)}),P(null,void 0)))})},m=>{const P=m&&R.$Fb(m);return S(P&&P.length>0?P[0]:void 0)})}J(i,c){this.K(c)&&(!this.d||this.d(c.relativePath,f.$ae(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||i(c))}K(i){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,o.$HI)(i,this.c)}return!0}L(i,c,d){return c.isSymbolicLink()?F.stat(i,d):d(null,c)}M(i,c,d){return c.isSymbolicLink()?F.realpath(i,(y,S)=>y?d(y):d(null,S)):d(null,i)}N(i,c){return i.folderName?f.$9d(i.folderName,c):c}}e.$zdc=b;class h{constructor(i){this.a=i.folderQueries,this.b=i.extraFileResources||[],this.c=new b(i)}search(i,c,d){this.c.walk(this.a,this.b,i,c,(y,S)=>{d(y,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Adc=h;class t{constructor(i,c){this.expression=i,this.c=c,this.d(i)}d(i){let c,d;Object.keys(i).filter(y=>i[y]).forEach(y=>{f.$8d(y)?(c=c||E.$mj(),c[y]=i[y]):(d=d||E.$mj(),d[y]=i[y])}),this.a=c&&E.$rj(c,{trimForExclusions:!0}),this.b=d&&E.$rj(d,{trimForExclusions:!0})}test(i,c,d){return this.b&&this.b(i,c,d)||this.a&&this.a(f.$9d(this.c,i),c,d)}getBasenameTerms(){const i=[];return this.a&&i.push(...E.$tj(this.a)),this.b&&i.push(...E.$tj(this.b)),i}getPathTerms(){const i=[];return this.a&&i.push(...E.$uj(this.a)),this.b&&i.push(...E.$uj(this.b)),i}}function r(a){const i=a.trim().split(`
`),c=i[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return k.$bf(i[i.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(Se[361],De([1,0,97,22,182,21]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tC=e.$sC=e.$rC=e.$qC=e.$pC=e.$oC=e.$nC=e.$mC=e.$lC=e.DecodeStreamErrorKind=e.$kC=e.$jC=e.$iC=e.$hC=e.$gC=e.$fC=e.$eC=e.$dC=void 0,e.$dC="utf8",e.$eC="utf8bom",e.$fC="utf16be",e.$gC="utf16le";function R(c){return[e.$dC,e.$eC,e.$fC,e.$gC].some(d=>d===c)}e.$hC=R,e.$iC=[254,255],e.$jC=[255,254],e.$kC=[239,187,191];const $=512,E=512,p=512*8,A=512*128;var I;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class w extends Error{constructor(d,y){super(d),this.decodeStreamErrorKind=y}}e.$lC=w;class k{static async create(d){let y;if(d!==e.$dC)y=(await(0,f.$cC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(d));else{const S=new TextDecoder;y={write(g){return S.decode(g,{stream:!0})},end(){return S.decode()}}}return new k(y)}constructor(d){this.a=d}write(d){return this.a.write(d)}end(){return this.a.end()}}function D(c,d){const y=d.minBytesRequiredForDetection??d.guessEncoding?p:E;return new Promise((S,g)=>{const u=(0,C.$td)(j=>j.join("")),m=[];let P=0,O;const N=new L.$pd,M=async()=>{try{const j=await i({buffer:F.$Fd.concat(m),bytesRead:P},d.guessEncoding);if(j.seemsBinary&&d.acceptTextOnly)throw new w("Stream is binary but only text is accepted for decoding",1);j.encoding=await d.overwriteEncoding(j.encoding),O=await k.create(j.encoding);const z=O.write(F.$Fd.concat(m).buffer);u.write(z),m.length=0,P=0,S({stream:u,detected:j})}catch(j){N.cancel(),u.destroy(),g(j)}};(0,C.$xd)(c,{onData:async j=>{O?u.write(O.write(j.buffer)):(m.push(j),P+=j.byteLength,P>=y&&(c.pause(),await M(),setTimeout(()=>c.resume())))},onError:j=>u.error(j),onEnd:async()=>{O||await M(),u.end(O?.end())}},N.token)})}e.$mC=D;async function v(c,d,y){const g=(await(0,f.$cC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(d),y);let u=!1,m=!1;return{read(){if(m)return null;const P=c.read();if(typeof P!="string"){if(m=!0,!u&&y?.addBOM)switch(d){case e.$dC:case e.$eC:return F.$Fd.wrap(Uint8Array.from(e.$kC));case e.$fC:return F.$Fd.wrap(Uint8Array.from(e.$iC));case e.$gC:return F.$Fd.wrap(Uint8Array.from(e.$jC))}const O=g.end();return O&&O.length>0?(u=!0,F.$Fd.wrap(O)):null}return u=!0,F.$Fd.wrap(g.write(P))}}}e.$nC=v;async function o(c){return(await(0,f.$cC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(c))}e.$oC=o;function s(c){return c===e.$eC||c===null?e.$dC:c}e.$pC=s;function n(c,d){if(!c||d<e.$iC.length)return null;const y=c.readUInt8(0),S=c.readUInt8(1);if(y===e.$iC[0]&&S===e.$iC[1])return e.$fC;if(y===e.$jC[0]&&S===e.$jC[1])return e.$gC;if(d<e.$kC.length)return null;const g=c.readUInt8(2);return y===e.$kC[0]&&S===e.$kC[1]&&g===e.$kC[2]?e.$eC:null}e.$qC=n;const l=["ascii","utf-16","utf-32"];async function b(c){const d=await(0,f.$cC)("jschardet","dist/jschardet.min.js"),y=c.slice(0,A),S=r(y.buffer),g=d.detect(S);if(!g||!g.encoding)return null;const u=g.encoding.toLowerCase();return 0<=l.indexOf(u)?null:t(g.encoding)}const h={ibm866:"cp866",big5:"cp950"};function t(c){const d=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return h[d]||d}function r(c){let d="";for(let y=0;y<c.length;y++)d+=String.fromCharCode(c[y]);return d}function a(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=c.match(/windows(\d+)/);return d?"windows-"+d[1]:c}}}e.$rC=a;function i({buffer:c,bytesRead:d},y){let S=n(c,d),g=!1;if(S!==e.$fC&&S!==e.$gC&&c){let u=!0,m=!0,P=!1;for(let O=0;O<d&&O<$;O++){const N=O%2===1,M=c.readUInt8(O)===0;if(M&&(P=!0),u&&(N&&!M||!N&&M)&&(u=!1),m&&(N&&M||!N&&!M)&&(m=!1),M&&!u&&!m)break}P&&(u?S=e.$gC:m?S=e.$fC:g=!0)}return y&&!g&&!S&&c?b(c.slice(0,d)).then(u=>({seemsBinary:!1,encoding:u})):{seemsBinary:g,encoding:S}}e.$sC=i,e.$tC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[154],De([1,0,361,29,153]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class L extends f.$xcc{constructor($,E,p=F,A="searchProcess"){super($,E,{readdir:I=>p.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,C.$rC)(I)},A)}}e.$Idc=L}),define(Se[155],De([1,0,48,377,360,19,56,35,16,15,2,36,93,378,358,116]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=e.$Gdc=e.$Fdc=e.$Edc=e.$Ddc=e.$Cdc=e.$Bdc=void 0;const o=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(m){this.a=m}provideTextSearchResults(m,P,O,N){return this.a.appendLine(`provideTextSearchResults ${m.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((M,j)=>{N.onCancellationRequested(()=>V());const z=r(m,P),T=P.folder.fsPath,H=z.map(G=>G.match(/^-/)?G:`'${G}'`).join(" ");this.a.appendLine(`${o} ${H}
 - cwd: ${T}`);let q=C.spawn(o,z,{cwd:T});q.on("error",G=>{console.error(G),this.a.appendLine("Error: "+(G&&G.message)),j((0,I.$DI)(new I.$BI(G&&G.message,I.SearchErrorCode.rgProcessError)))});let me=!1;const Z=new b(P.maxResults,T,P.previewOptions);Z.on("result",G=>{me=!0,ge="",O.report(G)});let X=!1;const V=()=>{X=!0,q?.kill(),Z?.cancel()};let x=!1;Z.on("hitLimit",()=>{x=!0,V()});let ge="";q.stdout.on("data",G=>{Z.handleData(G),me||(ge+=G)});let ue=!1;q.stdout.once("data",()=>ue=!0);let ve="";q.stderr.on("data",G=>{const U=G.toString();this.a.appendLine(U),ve.length+U.length<1e6&&(ve+=U)}),q.on("close",()=>{if(this.a.appendLine(ue?"Got data from stdout":"No data from stdout"),this.a.appendLine(me?"Got result from parser":"No result from parser"),ge&&this.a.appendLine(`Got data without result: ${ge}`),this.a.appendLine(""),X)M({limitHit:x});else{Z.flush(),q=null;let G;ve&&!ue&&(G=n(ve))?j((0,I.$DI)(new I.$BI(G.message,G.code))):M({limitHit:x})}})})}}e.$Bdc=s;function n(u){const m=u.split(`
`),P=m[0].trim();if(m.some(N=>N.startsWith("regex parse error")))return new I.$BI(l(m),I.SearchErrorCode.regexParseError);const O=P.match(/grep config error: unknown encoding: (.*)/);if(O)return new I.$BI(`Unknown encoding: ${O[1]}`,I.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new I.$BI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new I.$BI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new I.$BI(P,I.SearchErrorCode.regexParseError)}function l(u){const m=["Regex parse error"],P=u.filter(O=>O.startsWith("PCRE2:"));if(P.length>=1){const O=P[0].replace("PCRE2:","");if(O.indexOf(":")!==-1&&O.split(":").length>=2){const N=O.split(":")[1];m.push(":"+N)}}return m.join("")}class b extends F.EventEmitter{constructor(m,P,O){super(),this.g=m,this.h=P,this.j=O,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(m,P){return super.on(m,P),this}handleData(m){if(this.b)return;const P=typeof m=="string"?m:this.d.write(m);this.k(P)}k(m){let P=m.indexOf(`
`);const O=this.a+m;if(P>=0)P+=this.a.length;else{this.a=O;return}let N=0;for(;P>=0;)this.m(O.substring(N,P).trim()),N=P+1,P=O.indexOf(`
`,N);this.a=O.substring(N)}m(m){if(this.b||!m)return;let P;try{P=JSON.parse(m)}catch{throw new Error(`malformed line from rg: ${m}`)}if(P.type==="match"){const O=h(P.data.path),N=A.URI.file(E.$9d(this.h,O)),M=this.n(P.data,N);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const O=h(P.data.path),N=A.URI.file(E.$9d(this.h,O));this.o(P.data,N).forEach(j=>this.p(j))}}n(m,P){const O=m.line_number-1,N=h(m.lines),M=Buffer.from(N);let j=0,z=0,T=O;m.submatches.length===0&&m.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const H=(0,L.$Fb)(m.submatches.map((q,me)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Z=h(q.match),X=M.slice(j,q.start).toString(),V=t(X),x=V.numLines>0?V.lastLineLength:V.lastLineLength+z,ge=t(Z),ue=V.numLines+T,ve=ge.numLines+ue,G=ge.numLines>0?ge.lastLineLength:ge.lastLineLength+x;return j=q.end,z=G,T=ve,new w.$lI(ue,x,ve,G)}));return(0,v.$udc)(P,N,H,this.j)}o(m,P){const O=h(m.lines),N=m.line_number;return O.replace(/\r?\n$/,"").split(`
`).map((M,j)=>({text:M,uri:P,lineNumber:N+j}))}p(m){this.emit("result",m)}}e.$Cdc=b;function h(u){return u.bytes?Buffer.from(u.bytes,"base64").toString():u.text}function t(u){const m=/\n/g;let P=0,O=-1,N;for(;N=m.exec(u);)P++,O=N.index;const M=O>=0?u.length-O-1:u.length;return{numLines:P,lastLineLength:M}}function r(u,m){const P=["--hidden","--no-require-git"];P.push(u.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:O,otherIncludes:N}=(0,R.$I)(m.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const j=new Set;N.forEach(z=>{j.add(z)}),P.push("-g","!*"),j.forEach(z=>{a(z).map(v.$tdc).forEach(T=>{P.push("-g",T)})})}O&&O.length&&O.forEach(j=>{P.push("-g",j)}),m.excludes.map(v.$tdc).forEach(j=>P.push("-g",`!${j}`)),m.maxFileSize&&P.push("--max-filesize",m.maxFileSize+""),m.useIgnoreFiles?m.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),m.followSymlinks&&P.push("--follow"),m.encoding&&m.encoding!=="utf8"&&P.push("--encoding",m.encoding),u.pattern==="--"&&(u.isRegExp=!0,u.pattern="\\-\\-"),u.isMultiline&&!u.isRegExp&&(u.pattern=(0,p.$qe)(u.pattern),u.isRegExp=!0),m.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),u.isRegExp&&(u.pattern=i(u.pattern),P.push("--engine","auto"));let M;if(u.isWordMatch){const z=(0,p.$ye)(u.pattern,!!u.isRegExp,{wholeWord:u.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",z)}else if(u.isRegExp){let j=d(u.pattern);j=y(j),P.push("--regexp",j)}else M=u.pattern,P.push("--fixed-strings");return P.push("--no-config"),m.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),u.isMultiline&&P.push("--multiline"),m.beforeContext&&P.push("--before-context",m.beforeContext+""),m.afterContext&&P.push("--after-context",m.afterContext+""),P.push("--"),M&&P.push(M),P.push("."),P}e.$Ddc=r;function a(u){return g(u).flatMap(P=>{const O=(0,$.$pj)(P,"/");return O.map((N,M)=>O.slice(0,M+1).join("/"))})}function i(u){const m=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;u.match(m);)u=u.replace(m,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;u.match(P);)u=u.replace(P,"$1\\x{$2}");return u}e.$Edc=i;const c=u=>u.type==="Assertion"&&u.kind==="lookbehind";function d(u){let m;try{m=new k.RegExpParser().parsePattern(u)}catch{return u}let P="",O=0;const N=(z,T,H)=>{P+=u.slice(O,z)+H,O=T},M=[];return new k.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const T=M[0];if(!T)N(z.start,z.end,"\\r?\\n");else if(!M.some(c))if(T.type==="CharacterClass")if(T.negate){const H=u.slice(T.start+2,z.start)+u.slice(z.end,T.end-1);T.parent?.type==="Quantifier"?N(T.start,T.end,H?`[^${H}]`:"."):N(T.start,T.end,"(?!\\r?\\n"+(H?`|[${H}]`:"")+")")}else{const H=u.slice(T.start+1,z.start)+u.slice(z.end,T.end-1);N(T.start,T.end,H===""?"\\r?\\n":`(?:[${H}]|\\r?\\n)`)}else T.type==="Quantifier"&&N(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){M.unshift(z)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(z){M.unshift(z)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(z){M.unshift(z)},onCharacterClassLeave(){M.shift()},onAssertionEnter(z){c(z)&&M.push(z)},onAssertionLeave(z){M[0]===z&&M.shift()}}).visit(m),P+=u.slice(O),P}e.$Fdc=d;function y(u){return u.replace(/\n/g,"\\r?\\n")}e.$Gdc=y;function S(u){let m=!1,P=!1,O="",N="";for(let M=0;M<u.length;M++){const j=u[M];switch(j){case"\\":P?(m?N+="\\"+j:O+="\\"+j,P=!1):P=!0;break;case"{":if(P)m?N+=j:O+=j,P=!1;else{if(m)return{strInBraces:O+"{"+N+"{"+u.substring(M+1)};m=!0}break;case"}":if(P)m?N+=j:O+=j,P=!1;else{if(m)return{fixedStart:O,strInBraces:N,fixedEnd:u.substring(M+1)};O+=j}break;default:m?N+=(P?"\\":"")+j:O+=(P?"\\":"")+j,P=!1;break}}return{strInBraces:O+(m?"{"+N:"")}}function g(u){const{fixedStart:m,strInBraces:P,fixedEnd:O}=S(u);if(m===void 0||O===void 0)return[P];let N=(0,$.$pj)(P,",");N.length||(N=[""]);const M=g(O);return N.flatMap(j=>{const z=m+j;return M.map(T=>z+T)})}e.$Hdc=g}),define(Se[362],De([1,0,21,155,65,17]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;class R{constructor(p){this.b=p,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(p,A,I,w){const k=new F.$Bdc(this.b);if(A.folder.scheme===L.Schemas.vscodeUserData){const D={...A,folder:A.folder.with({scheme:L.Schemas.file})},v=new f.$Vu(o=>I.report({...o,uri:o.uri.with({scheme:A.folder.scheme})}));return this.c(w,o=>k.provideTextSearchResults(p,D,v,o))}else return this.c(w,D=>k.provideTextSearchResults(p,A,I,D))}async c(p,A){const I=$(p);this.a.add(I);const w=await A(I.token);return this.a.delete(I),w}d(){this.a.forEach(p=>p.cancel())}}e.$Ldc=R;function $(E){const p=new C.$pd;return E.onCancellationRequested(()=>p.cancel()),p}}),define(Se[363],De([1,0,29,155,154]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class L{constructor(E){this.a=E}search(E,p,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(k){A({message:k})}},w=new f.$Idc(this.a,new F.$Bdc(I),C);return new Promise((k,D)=>w.search(v=>{p(v.map(R))},E).then(v=>k({limitHit:v.limitHit,type:"success",stats:v.stats}),D))}}e.$Jdc=L;function R($){return{path:$.resource&&$.resource.fsPath,results:$.results,numMatches:($.results||[]).reduce((E,p)=>{if(p.ranges){const A=p;return E+(Array.isArray(A.ranges)?A.ranges.length:1)}else return E+1},0)}}}),define(Se[364],De([1,0,19,9,8,4,127,16,37,2,30,36,359,363]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class D{static{this.a=512}constructor(b="searchProcess"){this.d=b,this.b=Object.create(null)}fileSearch(b){let h;const t=s(b),r=new L.$fd({onDidAddFirstListener:()=>{h=(0,F.$ug)(a=>this.doFileSearchWithEngine(w.$Adc,t,i=>r.fire(i),a)),h.then(a=>r.fire(a),a=>r.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{h.cancel()}});return r.event}textSearch(b){let h;const t=s(b),r=new L.$fd({onDidAddFirstListener:()=>{h=(0,F.$ug)(a=>this.f(t,i=>r.fire(i),a)),h.then(a=>r.fire(a),a=>r.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{h.cancel()}});return r.event}f(b,h,t){return b.maxFileSize=this.g().maxFileSize,new k.$Jdc(b).search(t,h,h)}g(){return{maxFileSize:process.arch==="ia32"?300*A.$Ak.MB:16*A.$Ak.GB}}doFileSearch(b,h,t){return this.doFileSearchWithEngine(w.$Adc,b,h,t)}doFileSearchWithEngine(b,h,t,r,a=D.a){let i=0;const c=y=>{Array.isArray(y)?(i+=y.length,t(y.map(S=>this.h(S)))):y.relativePath?(i++,t(this.h(y))):t(y)};if(h.sortByScore){let y=this.l(h,c,r);if(!y){const S=h.maxResults?Object.assign({},h,{maxResults:null}):h,g=new b(S);y=this.j(g,h,t,c,r)}return new Promise((S,g)=>{y.then(([u,m])=>{const P=m.map(O=>this.h(O));this.o(P,t,a),S(u)},g)})}const d=new b(h);return this.r(d,c,a,r).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.d,fromCache:!1,resultCount:i,sortingTime:void 0}}))}h(b){return{path:b.base?(0,$.$9d)(b.base,b.relativePath):b.relativePath}}j(b,h,t,r,a){const i=new L.$fd;let c=(0,F.$ug)(y=>{let S=[];const g=u=>{Array.isArray(u)?S=u:(r(u),i.fire(u))};return this.r(b,g,-1,y).then(u=>[u,S])}),d;if(h.cacheKey){d=this.k(h.cacheKey);const y={promise:c,event:i.event,resolved:!1};d.resultsToSearchCache[h.filePattern||""]=y,c.then(()=>{y.resolved=!0},S=>{delete d.resultsToSearchCache[h.filePattern||""]}),c=this.s(c)}return c.then(([y,S])=>{const g=d?d.scorerCache:Object.create(null),u=(typeof h.maxResults!="number"||h.maxResults>0)&&E.$bd.create(!1);return this.n(h,S,g,a).then(m=>{const P=u?u.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:h.folderQueries.length,resultCount:m.length},messages:y.messages,limitHit:y.limitHit||typeof h.maxResults=="number"&&S.length>h.maxResults},m]})})}k(b){const h=this.b[b];return h||(this.b[b]=new v)}l(b,h,t){const r=b.cacheKey&&this.b[b.cacheKey];if(!r)return;const a=this.q(r,b.filePattern||"",h,t);if(a)return a.then(([i,c,d])=>{const y=E.$bd.create(!1);return this.n(b,c,r.scorerCache,t).then(S=>{const g=y.elapsed(),u={fromCache:!0,detailStats:d,type:this.d,resultCount:c.length,sortingTime:g};return[{type:"success",limitHit:i.limitHit||typeof b.maxResults=="number"&&c.length>b.maxResults,stats:u},S]})})}n(b,h,t,r){const a=(0,R.$oq)(b.filePattern||""),i=(d,y)=>(0,R.$nq)(d,y,a,!0,o,t),c=typeof b.maxResults=="number"?b.maxResults:Number.MAX_VALUE;return C.$Eb(h,i,c,1e4,r)}o(b,h,t){if(t&&t>0)for(let r=0;r<b.length;r+=t)h(b.slice(r,r+t));else h(b)}q(b,h,t,r){const a=E.$bd.create(!1),i=h.indexOf($.sep)>=0;let c;for(const g in b.resultsToSearchCache)if(h.startsWith(g)){if(i&&g.indexOf($.sep)<0&&g!=="")continue;const u=b.resultsToSearchCache[g];c={promise:this.s(u.promise),event:u.event,resolved:u.resolved};break}if(!c)return null;const d=a.elapsed(),y=E.$bd.create(!1),S=c.event(t);return r&&r.onCancellationRequested(()=>{S.dispose()}),c.promise.then(([g,u])=>{if(r&&r.isCancellationRequested)throw(0,f.$4)();const m=[],P=(0,R.$oq)(h).normalizedLowercase;for(const O of u)(0,I.$HI)(O,P)&&m.push(O);return[g,m,{cacheWasResolved:c.resolved,cacheLookupTime:d,cacheFilterTime:y.elapsed(),cacheEntryCount:u.length}]})}r(b,h,t,r){return new Promise((a,i)=>{let c=[];r?.onCancellationRequested(()=>b.cancel()),b.search(d=>{d&&(t?(c.push(d),t>0&&c.length>=t&&(h(c),c=[])):h(d))},d=>{h(d)},(d,y)=>{c.length&&h(c),d?i(d):a(y)})})}clearCache(b){return delete this.b[b],Promise.resolve(void 0)}s(b){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(h,t){return b.then(h,t)}catch(h){return this.then(void 0,h)}finally(h){return b.finally(h)}}}}e.$Kdc=D;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const o=new class{getItemLabel(l){return(0,$.$ae)(l.relativePath)}getItemDescription(l){return(0,$.$_d)(l.relativePath)}getItemPath(l){return l.relativePath}};function s(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(n),extraFileResources:l.extraFileResources&&l.extraFileResources.map(b=>p.URI.revive(b))}}function n(l){return{...l,folder:p.URI.revive(l.folder)}}}),define(Se[365],De([1,0,3,17,2,29,14,26,20,96,68,36,364,362,116,154]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;let o=class extends p.$Ccc{constructor(n,l,b,h){super(n,b,h),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new C.$jc;const t=new D.$vdc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new k.$Ldc(t))),l.remote.isRemote&&l.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const n=new D.$vdc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new k.$Ldc(n))),this.x.add(this.z(F.Schemas.file,new w.$Kdc("fileSearchProvider")))}z(n,l){const b=this.d++;return this.v=l,this.t=b,this.c.$registerFileSearchProvider(b,this.o(n)),(0,C.$ic)(()=>{this.v=null,this.c.$unregisterProvider(b)})}$provideFileSearchResults(n,l,b,h){const t=(0,p.$Dcc)(b);return n===this.t?this.A(n,l,t,h):super.$provideFileSearchResults(n,l,b,h)}A(n,l,b,h){const t=r=>{if((0,I.$GI)(r)&&(r=[r]),Array.isArray(r)){this.c.$handleFileMatch(n,l,r.map(a=>f.URI.file(a.path)));return}r.message&&this.n.debug("ExtHostSearch",r.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(b,t,h)}$clearCache(n){return this.v?.clearCache(n),super.$clearCache(n)}q(n,l){return new v.$Idc(n,l,void 0,"textSearchProvider")}};e.$Mdc=o,e.$Mdc=o=Ke([Be(0,E.$2L),Be(1,$.$fM),Be(2,A.$ibc),Be(3,R.$5i)],o)}),define(Se[117],De([1,0,379,61,64,380,22,8,4,3,16,12,31,81,82]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0;class v{traceSocketEvent(u,m){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,m)}constructor(u,m=""){this.f=!0,this.debugLabel=m,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,$.$Y)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(u){const m=P=>{this.traceSocketEvent("read",P),u(R.$Fd.wrap(P))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(u){const m=P=>{u({type:0,hadError:P,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(u){const m=()=>{u()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(u){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,$.$Y)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,$.$Y)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$qh=v;var o;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize",g[g.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(o||(o={}));var s;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(s||(s={}));class n extends p.$kc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(u,m){this.socket.traceSocketEvent(u,m)}constructor(u,m,P,O){super(),this.f=this.B(new E.$fd),this.g=this.B(new E.$fd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:P?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new l(this,m,P,O,this.f,(N,M)=>this.m(N,M))),this.B(this.a.onError(N=>{console.error(N),(0,$.$Y)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new D.$lh,this.B(this.socket.onData(N=>this.n(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this.f.event(u)}onClose(u){return this.g.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let m=0;for(;m<u.byteLength;)this.a.writeMessage(u.slice(m,Math.min(m+262144,u.byteLength))),m+=262144}m(u,m){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let P=2;u.byteLength<126?P+=0:u.byteLength<2**16?P+=2:P+=8;const O=R.$Fd.alloc(P);if(m?O.writeUInt8(194,0):O.writeUInt8(130,0),u.byteLength<126)O.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){O.writeUInt8(126,1);let N=1;O.writeUInt8(u.byteLength>>>8&255,++N),O.writeUInt8(u.byteLength>>>0&255,++N)}else{O.writeUInt8(127,1);let N=1;O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(u.byteLength>>>24&255,++N),O.writeUInt8(u.byteLength>>>16&255,++N),O.writeUInt8(u.byteLength>>>8&255,++N),O.writeUInt8(u.byteLength>>>0&255,++N)}this.socket.write(R.$Fd.concat([O,u]))}end(){this.h=!0,this.socket.end()}n(u){if(u.byteLength!==0){for(this.b.acceptChunk(u);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const m=this.b.peek(this.j.readLen),P=m.readUInt8(0),O=(P&128)>>>7,N=(P&64)>>>6,M=m.readUInt8(1),j=(M&128)>>>7,z=M&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(z===126?2:0)+(z===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const m=this.b.read(this.j.readLen),P=m.readUInt8(1),O=(P&128)>>>7;let N=P&127,M=1;N===126?N=m.readUInt8(++M)*2**8+m.readUInt8(++M):N===127&&(N=m.readUInt8(++M)*0+m.readUInt8(++M)*0+m.readUInt8(++M)*0+m.readUInt8(++M)*0+m.readUInt8(++M)*2**24+m.readUInt8(++M)*2**16+m.readUInt8(++M)*2**8+m.readUInt8(++M));let j=0;O&&(j=m.readUInt8(++M)*2**24+m.readUInt8(++M)*2**16+m.readUInt8(++M)*2**8+m.readUInt8(++M)),this.j.state=3,this.j.readLen=N,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const m=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),t(m,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(m,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$rh=n;class l extends p.$kc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$Fd.alloc(0)}constructor(u,m,P,O,N,M){super(),this.n=u,this.r=N,this.s=M,this.a=this.B(new E.$fd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$fd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$fd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,m?(this.b=this.B(new b(this.n,O,P,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(u){this.g.push(u),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const u=this.g.shift();if(this.f){const m=await this.w(this.f,u);this.s(m,!0)}else this.s(u,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(u,m){return new Promise((P,O)=>{u.write(m),u.flush(N=>P(N))})}acceptFrame(u,m,P){this.h.push({data:u,isCompressed:m,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const u=this.h.shift();if(this.b&&u.isCompressed){const m=await this.C(this.b,u.data,u.isLastFrameOfMessage);this.r.fire(m)}else this.r.fire(u.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(u,m,P){return new Promise((O,N)=>{u.write(m),P&&u.write(R.$Fd.fromByteArray([0,0,255,255])),u.flush(M=>O(M))})}}class b extends p.$kc{get recordedInflateBytes(){return this.j?R.$Fd.concat(this.f):R.$Fd.alloc(0)}constructor(u,m,P,O){super(),this.h=u,this.j=m,this.a=this.B(new E.$fd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(O),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(R.$Fd.wrap(N))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(u){this.j&&this.f.push(u.clone()),this.h.traceSocketEvent("zlibInflateWrite",u),this.b.write(u.buffer)}flush(u){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const m=R.$Fd.concat(this.g);this.g.length=0,u(m)})}}class h extends p.$kc{constructor(u,m){super(),this.g=u,this.a=this.B(new E.$fd),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(R.$Fd.wrap(P))})}write(u){this.g.traceSocketEvent("zlibDeflateWrite",u.buffer),this.b.write(u.buffer)}flush(u){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let m=R.$Fd.concat(this.f);this.f.length=0,m=m.slice(0,m.byteLength-4),u(m)})}}function t(g,u){if(u===0)return;const m=g.byteLength>>>2;for(let z=0;z<m;z++){const T=g.readUInt32BE(z*4);g.writeUInt32BE(T^u,z*4)}const P=m*4,O=g.byteLength-P,N=u>>>24&255,M=u>>>16&255,j=u>>>8&255;O>=1&&g.writeUInt8(g.readUInt8(P)^N,P),O>=2&&g.writeUInt8(g.readUInt8(P+1)^M,P+1),O>=3&&g.writeUInt8(g.readUInt8(P+2)^j,P+2)}e.$sh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function a(){const g=(0,w.$4f)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;const u=process.platform!=="darwin"&&e.$sh?e.$sh:(0,f.tmpdir)(),m=(0,A.$9d)(u,`vscode-ipc-${g}.sock`);return c(m),m}e.$th=a;function i(g,u,m){const P=(0,C.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${m}-${u}-sock`;const O=m.substr(0,4),N=u.substr(0,6),M=P.substr(0,8);let j;return process.platform!=="darwin"&&e.$sh&&!process.env.VSCODE_PORTABLE?j=(0,A.$9d)(e.$sh,`vscode-${M}-${O}-${N}.sock`):j=(0,A.$9d)(g,`${O}-${N}.sock`),c(j),j}e.$uh=i;function c(g){const u=r[I.$t];typeof u=="number"&&g.length>=u&&console.warn(`WARNING: IPC handle "${g}" is longer than ${u} chars, try a shorter --user-data-dir`)}class d extends k.$fh{static b(u){const m=E.Event.fromNodeEventEmitter(u,"connection");return E.Event.map(m,P=>({protocol:new D.$mh(new v(P,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(P,"close"))}))}constructor(u){super(d.b(u)),this.d=u}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$vh=d;function y(g){return new Promise((u,m)=>{const P=(0,F.createServer)();P.on("error",m),P.listen(g,()=>{P.removeListener("error",m),u(new d(P))})})}e.$wh=y;function S(g,u){return new Promise((m,P)=>{const O=(0,F.createConnection)(g,()=>{O.removeListener("error",P),m(D.$nh.fromSocket(new v(O,`ipc-client${u}`),u))});O.once("error",P)})}e.$xh=S}),define(Se[366],De([1,0,61,64,163,117,9,3,12,49,14,135,247,248,107,86,22]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=e.$j7b=e.$i7b=e.$h7b=void 0;async function s(t,r,a,i,c){let d;for(let y=3;y&&(d?.dispose(),d=await new n(t,r,a,i,c).waitForReady(),!(c&&f.$7f[c]||!f.$7f[d.tunnelLocalPort]));y--);return d}class n extends $.$kc{constructor(r,a,i,c,d){super(),this.m=a,this.n=d,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=C.createServer(),this.c=new R.$Fg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=y=>this.r(y),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(a=>{a()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,a=(0,v.$7u)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,f.$8f)(r,2,1e3,a),c=null;return this.b.listen(i,this.m),await this.c.wait(),c=this.b.address(),c||(i=0,this.b.listen(i,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(r){r.pause();const a=(0,v.$5u)(this.tunnelRemoteHost)||(0,v.$7u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,w.$Zk)(this.a,a,this.tunnelRemotePort),c=i.getSocket(),d=i.readEntireBuffer();i.dispose(),d.byteLength>0&&r.write(d.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),c.end()}),r.on("close",()=>c.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),c instanceof L.$qh?c.socket.destroy():c.end()}),c instanceof L.$qh?this.t(r,c):this.s(r,c),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),c.end()})}s(r,a){a.onClose(()=>r.destroy()),a.onEnd(()=>r.end()),a.onData(i=>r.write(i.buffer)),r.on("data",i=>a.write(o.$Fd.wrap(i))),r.resume()}t(r,a){const i=a.socket;i.on("end",()=>r.end()),i.on("close",()=>r.end()),i.on("error",()=>{r.destroy()}),i.pipe(r),r.pipe(i)}}e.$h7b=n;let l=class extends v.$0u{constructor(r,a,i,c,d){super(a,d),this.u=r,this.v=i,this.w=c}isPortPrivileged(r){return(0,v.$8u)(r,this.l,E.OS,F.release())}s(r,a,i,c,d,y,S,g){const u=this.r(a,i);if(u)return++u.refcount,u.value;if((0,v.$2u)(r))return this.t(r,a,i,d,y,S,g);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${i} on local port ${d}.`);const m={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},P=s(m,c,a,i,d);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(a,i,P),P}}};e.$i7b=l,e.$i7b=l=Ke([Be(0,k.$Tk),Be(1,A.$5i),Be(2,D.$Wk),Be(3,I.$kj),Be(4,p.$8h)],l);let b=class extends l{constructor(r,a,i,c,d){super(r,a,i,c,d)}};e.$j7b=b,e.$j7b=b=Ke([Be(0,k.$Tk),Be(1,A.$5i),Be(2,D.$Wk),Be(3,I.$kj),Be(4,p.$8h)],b);let h=class extends $.$kc{constructor(r,a,i,c,d){super(),this.b=r,this.c=a,this.f=i,this.g=c,this.h=d,this.a=new Map}async openTunnel(r,a,i,c,d,y,S,g,u){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${c} on local port ${y}.`),!this.a.has(r)){const m=new b(this.b,this.c,this.g,this.f,this.h);this.B(m),this.a.set(r,m),m.onTunnelClosed(async()=>{(await m.tunnels).length===0&&(m.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(a,i,c,d,y,S,g,u)}};e.$k7b=h,e.$k7b=h=Ke([Be(0,k.$Tk),Be(1,A.$5i),Be(2,I.$kj),Be(3,D.$Wk),Be(4,p.$8h)],h)}),define(Se[367],De([1,0,117,267,52,33,2,14,43]),function($e,e,C,F,f,L,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=void 0;class p{constructor(w,k,D){this.b=w,this.c=k,this.f=D,this.a=F.createServer((v,o)=>this.h(v,o)),this.g().catch(v=>(k.error(v),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,k){const D=(o,s)=>{k.writeHead(o,{"content-type":"application/json"}),k.end(JSON.stringify(s||null),n=>n&&this.c.error(n))},v=[];w.setEncoding("utf8"),w.on("data",o=>v.push(o)),w.on("end",async()=>{try{const o=JSON.parse(v.join(""));let s;switch(o.type){case"open":s=await this.i(o);break;case"openExternal":s=await this.j(o);break;case"status":s=await this.l(o);break;case"extensionManagement":s=await this.k(o);break;default:D(404,`Unknown message type: ${o.type}`);break}D(200,s)}catch(o){const s=o instanceof Error?o.message:JSON.stringify(o);D(500,s),this.c.error("Error while processing pipe request",o)}})}async i(w){const{fileURIs:k,folderURIs:D,forceNewWindow:v,diffMode:o,mergeMode:s,addMode:n,forceReuseWindow:l,gotoLineMode:b,waitMarkerFilePath:h,remoteAuthority:t}=w,r=[];if(Array.isArray(D))for(const d of D)try{r.push({folderUri:R.URI.parse(d)})}catch{}if(Array.isArray(k))for(const d of k)try{(0,E.$7h)(d)?r.push({workspaceUri:R.URI.parse(d)}):r.push({fileUri:R.URI.parse(d)})}catch{}const a=h?R.URI.file(h):void 0,c={forceNewWindow:v,diffMode:o,mergeMode:s,addMode:n,gotoLineMode:b,forceReuseWindow:l,preferNewWindow:!l&&!a&&!n,waitMarkerFileURI:a,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,c)}async j(w){for(const k of w.uris){const D=R.URI.parse(k),v=D.scheme==="file"?D:k;await this.b.executeCommand("_remoteCLI.openExternal",v)}}async k(w){const k=v=>v?.map(o=>/\.vsix$/i.test(o)?R.URI.parse(o):o),D={list:w.list,install:k(w.install),uninstall:k(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$qM=p;let A=class extends p{constructor(w,k){super(w,k,(0,C.$th)())}};e.$rM=A,e.$rM=A=Ke([Be(0,L.$lM),Be(1,$.$5i)],A)}),define(Se[368],De([1,0,53,355,350,266,45,338,2,17,7,367,101,336,337]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class v extends f.$gdc{j(){const n=this,l=globalThis._VSCODE_NODE_MODULES.module,b=l._load;l._load=function(a,i,c){return a=t(a),n.a.has(a)?n.a.get(a).load(a,E.URI.file((0,w.$Xp)(i.filename)),d=>b.apply(this,[d,i,c])):b.apply(this,arguments)};const h=l._resolveLookupPaths;l._resolveLookupPaths=(r,a)=>h.call(this,t(r),a);const t=r=>{for(const a of n.b){const i=a(r);if(i){r=i;break}}return r}}}class o extends R.$Sbc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(k.$Pdc);const n=this.h.invokeFunction(F.$cdc);if(this.h.createInstance($.$Odc),this.f.remote.isRemote&&this.f.remote.authority){const h=this.h.createInstance(I.$rM);process.env.VSCODE_IPC_HOOK_CLI=h.ipcHandlePath}this.h.createInstance(D.$Qdc),await this.h.createInstance(v,n,{mine:this.J,all:this.L}).install(),C.mark("code/extHost/didInitAPI");const b=await this.m.getConfigProvider();await(0,L.$Ndc)(this.j,b,this,this.s,this.z,this.f),C.mark("code/extHost/didInitProxyResolver")}ub(n){return n.main}async vb(n,l,b){if(l.scheme!==p.Schemas.file)throw new Error(`Cannot load URI: '${l}', must be of file-scheme`);let h=null;b.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${l.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),h=$e.__$__nodeRequire(l.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),b.codeLoadingStop()}return h}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const l in n){const b=n[l];b===null?delete process.env[l]:process.env[l]=b}}}e.$Rdc=o}),define(Se[369],De([1,0,48,22,4,3,120,12,24,2,29,14,246,66,107,86,366,26,20,74,346]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=e.$Ydc=e.$Xdc=e.$Wdc=e.$Vdc=e.$Udc=e.$Tdc=e.$Sdc=void 0;function h(u){const m=u.trim().split(`
`),P=[];return m.forEach(N=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(N);M&&M.length>=3&&P.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),P.reduce((N,M)=>(N[M.socket]=M,N),{})}e.$Sdc=h;function t(...u){const m=[].concat(...u.map(a));return[...new Map(m.filter(P=>P.st==="0A").map(P=>{const O=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:r(O[0]),port:parseInt(O[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$Tdc=t;function r(u){let m="";if(u.length===8)for(let P=u.length-2;P>=0;P-=2)m+=parseInt(u.substr(P,2),16),P!==0&&(m+=".");else for(let P=0;P<u.length;P+=8){const O=u.substring(P,P+8);let N="";for(let M=8;M>=2;M-=2)N+=O.substring(M-2,M),(M===6||M===2)&&(N=parseInt(N,16).toString(16),m+=`${N}`,N="",P+M!==u.length-6&&(m+=":"))}return m}e.$Udc=r;function a(u){const m=u.trim().split(`
`),P=m.shift().trim().split(/\s+/).filter(N=>N!=="rx_queue"&&N!=="tm->when");return m.map(N=>N.trim().split(/\s+/).reduce((M,j,z)=>(M[P[z]||z]=j,M),{}))}e.$Vdc=a;function i(u){return!!u.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||u.indexOf("out/server-main.js")!==-1||u.indexOf("_productName=VSCode")!==-1}function c(u){const m=u.trim().split(`
`),P=[];return m.forEach(O=>{const N=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);N&&N.length>=4&&P.push({pid:parseInt(N[1],10),ppid:parseInt(N[2]),cmd:N[3]})}),P}e.$Wdc=c;async function d(u,m,P){const O=P.reduce((M,j)=>(M[j.pid]=j,M),{}),N=[];return u.forEach(({socket:M,ip:j,port:z})=>{const T=m[M]?m[M].pid:void 0,H=T?O[T]?.cmd:void 0;T&&H&&!i(H)&&N.push({host:j,port:z,detail:H,pid:T})}),N}e.$Xdc=d;function y(u,m,P){const O=new Map,N=c(m);for(const M of u){const j=P.get(M.port);if(j){O.set(M.port,j);continue}const z=N.find(T=>T.cmd.includes(`${M.port}`));if(z){let T=z,H;do H=N.find(q=>q.ppid===T.pid),H&&(T=H);while(H);O.set(M.port,{host:M.ip,port:M.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else O.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return O}e.$Ydc=y;let S=class extends l.$ssb{constructor(m,P,O,N){super(m,P,O),this.D=P,this.F=N,this.y=void 0,this.z=new Map,this.C=!1,$.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(m){if(m&&this.C)return;this.C=m;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new R.$Kl;let N=0;for(;this.C;){const M=new Date().getTime(),j=(await this.I()).filter(H=>(0,v.$5u)(H.host)||(0,v.$7u)(H.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(H=>H.port).join(", ")}`);const z=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${z} ms.`),N++>3&&O.update(z),(!P||JSON.stringify(P)!==JSON.stringify(j))&&(P=j,await this.a.$onFoundNewCandidates(P));const T=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(H=>setTimeout(()=>H(),T))}}G(m){return Math.max(m*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(m=>m.port).join(", ")}`)}async I(){let m="",P="";try{m=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=t(m,P),N=await new Promise(Z=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(X,V,x)=>{Z(V)})}),M=h(N),j=await A.Promises.readdir("/proc"),z=[];for(const Z of j)try{const X=Number(Z),V=E.$ig(p.URI.file("/proc"),Z);if((await A.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(X)){const ge=await A.Promises.readlink(E.$ig(V,"cwd").fsPath),ue=await A.Promises.readFile(E.$ig(V,"cmdline").fsPath,"utf8");z.push({pid:X,cwd:ge,cmd:ue})}}catch{}const T=[],H=O.filter(Z=>{const X=M[Z.socket];return X||T.push(Z),X}),q=d(H,M,z);let me;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const Z=await new Promise(X=>{(0,C.exec)("ps -F -A -l | grep root",(V,x,ge)=>{X(x)})});this.z=y(T,Z,this.z),me=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${me.map(X=>X.port).join(", ")}`)}return q.then(Z=>me?Z.concat(me):Z)}w(m){return async P=>{const O=new o.$h7b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,j,z,T){const H=await m.makeConnection();return g.connect(H,j,z,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new k.$Kk(0),connectionToken:m.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await O.waitForReady();const N=new f.$fd;return{localAddress:(0,b.$oJ)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:N.event,dispose:()=>{O.dispose(),N.fire(),N.dispose()}}}}};e.$Zdc=S,e.$Zdc=S=Ke([Be(0,n.$2L),Be(1,s.$fM),Be(2,I.$5i),Be(3,D.$Wk)],S);class g extends w.$Ckb{static connect(m,P,O,N){const M=new L.$jc,j={onClose:M.add(new f.$fd),onData:M.add(new f.$fd),onEnd:M.add(new f.$fd)};M.add(m.onDidReceiveMessage(T=>j.onData.fire(F.$Fd.wrap(T)))),M.add(m.onDidEnd(()=>j.onEnd.fire())),M.add(m.onDidClose(T=>j.onClose.fire({type:0,error:T,hadError:!!T})));const z=new g(m,N,j);return z.B(M),(0,w.$Bkb)(z,P,O,N,j)}constructor(m,P,O){super(P,O),this.n=m}write(m){this.n.send(m.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[370],De([1,0,104,341,353,352,365,368,369,95,45,96,94,44,74,91,340,339,14,354,55,261,103,107,138]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s,n,l,b,h,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$mr)(A.$Tbc,$.$Rdc,0),(0,C.$mr)(n.$6i,s.$2dc,1),(0,C.$mr)(n.$5i,new t.$yh(h.$fdc,[!1],!0)),(0,C.$mr)(r.$Wk,a.$m7b,1),(0,C.$mr)(v.$Ebc,o.$1dc,0),(0,C.$mr)(p.$rcc,L.$sdc,0),(0,C.$mr)(I.$Bcc,R.$Mdc,0),(0,C.$mr)(w.$mcc,f.$kdc,0),(0,C.$mr)(k.$Gbc,F.$jdc,0),(0,C.$mr)(D.$rsb,E.$Zdc,0),(0,C.$mr)(b.$pcc,l.$3dc,0)}),define(Se[381],De([1,0,61,382,53,8,82,117,244,111,351,22,29,101,9,130,268,285,356,370]),function($e,e,C,F,f,L,R,$,E,p,A,I,w,k,D,v,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const n=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,d=c._load;c._load=function(y){if(y==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return d.apply(this,arguments)}})();const l=process.exit.bind(process);function b(c){process.exit=function(d){if(c)l(d);else{const y=new Error("An extension called process.exit() and this was prevented.");console.warn(y.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let h=function(c){l()};function t(){const c=(0,s.$rm)(process.env);if(c.type===3)return new Promise((d,y)=>{const S=g=>{const u=g[0],m=new R.$oh;u.on("message",P=>m.fire(I.$Fd.wrap(P.data))),u.on("close",()=>{h("renderer closed the MessagePort")}),u.start(),d({onMessage:m.event,send:P=>u.postMessage(P.buffer)})};process.parentPort.on("message",g=>S(g.ports))});if(c.type===2)return new Promise((d,y)=>{let S=null;const g=setTimeout(()=>{h("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),u=108e5,m=3e5,P=new D.$Tg(()=>h("renderer disconnected for too long (1)"),u),O=new D.$Tg(()=>h("renderer disconnected for too long (2)"),m);process.on("message",(M,j)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const z=I.$Fd.wrap(Buffer.from(M.initialDataChunk,"base64"));let T;if(M.skipWebSocketFrames)T=new $.$qh(j,"extHost-socket");else{const H=I.$Fd.wrap(Buffer.from(M.inflateBytes,"base64"));T=new $.$rh(new $.$qh(j,"extHost-socket"),M.permessageDeflate,H,!1)}S?(P.cancel(),O.cancel(),S.beginAcceptReconnection(T,z),S.endAcceptReconnection(),S.sendResume()):(clearTimeout(g),S=new R.$ph({socket:T,initialChunk:z}),S.sendResume(),S.onDidDispose(()=>h("renderer disconnected")),d(S),S.onSocketClose(()=>{P.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;P.isScheduled()&&O.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const d=c.pipeName;return new Promise((y,S)=>{const g=C.createConnection(d,()=>{g.removeListener("error",S);const u=new R.$ph({socket:new $.$qh(g,"extHost-renderer")});u.sendResume(),y(u)});g.once("error",S),g.on("close",()=>{h("renderer closed the socket")})})}}async function r(){const c=await t();return new class{constructor(){this.a=new R.$oh,this.onMessage=this.a.event,this.b=!1,c.onMessage(d=>{(0,p.$5l)(d,2)?(this.b=!0,h("received terminate message from renderer")):this.a.fire(d)})}send(d){this.b||c.send(d)}async drain(){if(c.drain)return c.drain()}}}function a(c){return new Promise(d=>{const y=c.onMessage(S=>{y.dispose();const g=JSON.parse(S.toString()),u=g.commit,m=E.default.commit;if(u&&m&&u!==m&&l(55),g.parentPid){let P=0;setInterval(function(){try{process.kill(g.parentPid,0),P=0}catch(N){N&&N.code==="EPERM"?(P++,P>=3&&h(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):h(`parent process ${g.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start(g.parentPid)}catch(N){(0,L.$Y)(N)}}c.send((0,p.$4l)(0)),d({protocol:c,initData:g})});c.send((0,p.$4l)(1))})}async function i(){const c=[];process.on("unhandledRejection",(P,O)=>{c.push(O),setTimeout(()=>{const N=c.indexOf(O);N>=0&&O.catch(M=>{c.splice(N,1),(0,L.$2)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),P&&(0,L.$Y)(P))})},1e3)}),process.on("rejectionHandled",P=>{const O=c.indexOf(P);O>=0&&c.splice(O,1)}),process.on("uncaughtException",function(P){(0,L.$X)(P)||(0,L.$Y)(P)}),f.mark("code/extHost/willConnectToRenderer");const d=await r();f.mark("code/extHost/didConnectToRenderer");const y=await a(d);f.mark("code/extHost/didWaitForInitData");const{initData:S}=y;b(!!S.environment.extensionTestsLocationURI),S.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,S.environment.skipWorkspaceStorageLock=(0,v.boolean)(n.skipWorkspaceStorageLock,!1);const g=new class{constructor(){this.pid=process.pid}exit(O){l(O)}fsExists(O){return w.Promises.exists(O)}fsRealpath(O){return(0,k.$Wp)(O)}};let u=null;S.remote.authority&&n.transformURIs&&(u=(0,o.$qr)(S.remote.authority));const m=new A.$idc(y.protocol,S,g,u);h=P=>m.terminate(P)}i().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f27dd75c3870a63c84a7976a6568655eca59d612/core/vs/workbench/api/node/extensionHostProcess.js.map
